﻿// Generated by Construct 2, the HTML5 game and app creator :: http://www.scirra.com
//////////////////////////////////////
// COCOONJS.JS                      //
//////////////////////////////////////

(function()
{
	// There should not be a CocoonJS object when this code is executed.
	// if (typeof window.CocoonJS !== 'undefined') throw("This is strange, a CocoonJS object already exists when trying to create it.");

    /**
    * The basic object for all the CocoonJS related specific APIs === extensions.
    * @namespace
    */
    CocoonJS = window.CocoonJS ? window.CocoonJS : {};

	CocoonJS.nativeExtensionObjectAvailable = typeof window.ext !== 'undefined';

	/**
	* This type represents a 2D size structure with horizontal and vertical values.
	* @namespace
	*/
	CocoonJS.Size = {
		/**
		* The horizontal size value.
		*/
		width : 0,

		/**
		* The vertical size value.
		*/
		height : 0
	};

	/**
	* This utility function allows to create an object oriented like hierarchy between two functions using their prototypes.
	* This function adds a "superclass" and a "__super" attributes to the subclass and it's functions to reference the super class.
	* @param {function} subc The subclass function.
	* @param {function} superc The superclass function.
	*/
	CocoonJS.extend = function(subc, superc) {
	    var subcp = subc.prototype;

	    // Class pattern.
	    var CocoonJSExtendHierarchyChainClass = function() {};
	    CocoonJSExtendHierarchyChainClass.prototype = superc.prototype;

	    subc.prototype = new CocoonJSExtendHierarchyChainClass();       // chain prototypes.
	    subc.superclass = superc.prototype;
	    subc.prototype.constructor = subc;

	    // Reset constructor. See Object Oriented Javascript for an in-depth explanation of this.
	    if (superc.prototype.constructor === Object.prototype.constructor) {
	        superc.prototype.constructor = superc;
	    }

	    // Check all the elements in the subclass prototype and add them to the chain object's prototype.
	    for (var method in subcp) {
	        if (subcp.hasOwnProperty(method)) {
	            subc.prototype[method] = subcp[method];

	            // // tenemos en super un metodo con igual nombre.
	            // if ( superc.prototype[method]) 
	            // {
	            //     subc.prototype[method]= (function(fn, fnsuper) 
	            //     {
	            //         return function() 
	            //         {
	            //             var prevMethod= this.__super;

	            //             this.__super= fnsuper;

	            //             var retValue= fn.apply(
	            //                     this,
	            //                     Array.prototype.slice.call(arguments) );

	            //             this.__super= prevMethod;

	            //             return retValue;
	            //         };
	            //     })(subc.prototype[method], superc.prototype[method]);
	            // }
	        }
	    }
	}

	/**
	* IMPORTANT: This function should only be used by Ludei.
	* This function allows a call to the native extension object function reusing the same arguments object.
	* Why is interesting to use this function instead of calling the native object's function directly?
	* As the CocoonJS object functions expicitly receive parameters, if they are not present and the native call is direcly mapped,
	* undefined arguments are passed to the native side. Some native functions do not check the parameters validation
	* correctly (just check the number of parameters passed).
	* Another solution instead of using this function call is to correctly check if the parameters are valid (not undefined) to make the
	* call, but it takes more work than using this approach.
	* @static
	* @param {string} nativeExtensionObjectName The name of the native extension object name. The object that is a member of the 'ext' object.
	* @param {string} nativeFunctionName The name of the function to be called inside the native extension object.
	* @param {object} arguments The arguments object of the CocoonJS extension object function. It contains all the arguments passed to the CocoonJS extension object function and these are the ones that will be passed to the native call too.
	* @param {boolean} [async] A flag to indicate if the makeCall (false or undefined) or the makeCallAsync function should be used to perform the native call.
	* @returns Whatever the native function call returns.
	*/
	CocoonJS.makeNativeExtensionObjectFunctionCall = function(nativeExtensionObjectName, nativeFunctionName, args, async) {
		if (CocoonJS.nativeExtensionObjectAvailable) {
			var argumentsArray = Array.prototype.slice.call(args);
			argumentsArray.unshift(nativeFunctionName);
			var nativeExtensionObject = ext[nativeExtensionObjectName];
			var makeCallFunction = async ? nativeExtensionObject.makeCallAsync : nativeExtensionObject.makeCall;
			var ret = makeCallFunction.apply(nativeExtensionObject, argumentsArray);
			var finalRet = ret;
			if (typeof ret === "string") {
				try	{
					finalRet = JSON.parse(ret);
				}
				catch(error) {
				}
			}
			return finalRet;
		}
	};

	/**
	* Returns an object retrieved from a path specified by a dot specified text path starting from a given base object.
	* It could be useful to find the reference of an object from a defined base object. For example the base object could be window and the
	* path could be "CocoonJS.App" or "document.body".
	* @param {Object} baseObject The object to start from to find the object using the given text path.
	* @param {string} objectPath The path in the form of a text using the dot notation. i.e. "document.body"
	* For example:
	* var body = getObjectFromPath(window, "document.body");
	*/
	CocoonJS.getObjectFromPath = function(baseObject, objectPath) {
    	var parts = objectPath.split('.');
    	var obj = baseObject;
        for (var i = 0, len = parts.length; i < len; ++i) 
        {
            obj[parts[i]] = obj[parts[i]] || undefined;
    		obj = obj[parts[i]];
    	}
    	return obj;
 	};

 	/**
 	* Returns the key for a value in a dictionary. It looks for an specific value inside a dictionary and returns the corresponding key.
 	* @param {Object} dictionary The dictionary to look for the value in and get the corresponding key.
 	* @param {Object} value The value to look for inside the dictionary and return it's corresponding key.
 	* @return The key that corresponds to the given value it is has been found or null.
 	*/
 	CocoonJS.getKeyForValueInDictionary = function(dictionary, value) {
        var finalKey = null;
        for (var key in dictionary) {
            if (dictionary[key] === value)            {
                finalKey = key;
                break;
            }
        }
        return finalKey;
 	}

 	/**
 	* Finds a string inside a given array of strings by looking for a given substring. It can also
 	* specify if the search must be performed taking care or not of the case sensitivity.
 	* @param {Array} stringArray The array of strings in which to to look for the string.
 	* @param {string} subString The substring to look for inside all the strings of the array.
 	* @param {boolean} caseSensitive A flag to indicate if the search must be performed taking case of the 
 	* case sensitiveness (true) or not (false).
 	* @return {string} The string that has been found or null if the substring is not inside any of the string of the array.
 	*/
 	CocoonJS.findStringInStringArrayThatIsIndexOf = function(stringArray, subString, caseSensitive) {
 		var foundString = null;
 		subString = caseSensitive ? subString : subString.toUpperCase();
 		for (var i = 0; foundString == null && i < stringArray.length; i++)	{
 			foundString = caseSensitive ? stringArray[i] : stringArray[i].toUpperCase();
 			foundString = foundString.indexOf(subString) >= 0 ? stringArray[i] : null; 
 		}
 		return foundString;
 	};

	/**
	* A class that represents objects to handle events. Event handlers have always the same structure:
	* Mainly they provide the addEventListener and removeEventListener functions.
	* Both functions receive a callback function that will be added or removed. All the added callback
	* functions will be called when the event takes place.
	* Additionally they also allow the addEventListenerOnce and notifyEventListeners functions.
	* @constructor
	* @param {string} nativeExtensionObjectName The name of the native extension object (inside the ext object) to be used.
	* @param {string} cocoonJSExtensionObjectName The name of the sugarized extension object.
	* @param {string} nativeEventName The name of the native event inside the ext object.
	* @param {number} [chainFunction] An optional function used to preprocess the listener callbacks. This function, if provided,
	* will be called before any of the other listeners.
	*/
	CocoonJS.EventHandler = function(nativeExtensionObjectName, cocoonJSExtensionObjectName, nativeEventName, chainFunction) {
		this.listeners = [];
		this.listenersOnce = [];
		this.chainFunction = chainFunction;

		/**
		* Adds a callback function so it can be called when the event takes place.
		* @param {function} listener The callback function to be added to the event handler object. See the referenced Listener function documentation for more detail in each event handler object's documentation.
		*/
		this.addEventListener = function(listener) {
			if (chainFunction) {
				var f = function() {
					chainFunction.call(this, arguments.callee.sourceListener, Array.prototype.slice.call(arguments)); 
				};
				listener.CocoonJSEventHandlerChainFunction = f;
				f.sourceListener = listener;
				listener = f;
			}

			var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject && cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].addEventListener(nativeEventName, listener);
            }
            else {
                var indexOfListener = this.listeners.indexOf(listener);
                if (indexOfListener < 0) {
                	this.listeners.push(listener);
                }
            }
		};

        this.addEventListenerOnce = function(listener)
		{
			if (chainFunction) {
				var f = function() { chainFunction(arguments.callee.sourceListener,Array.prototype.slice.call(arguments)); };
				f.sourceListener = listener;
				listener = f;
			}

			var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].addEventListenerOnce(nativeEventName, listener);
            }
            else
            {
                var indexOfListener = this.listeners.indexOf(listener);
                if (indexOfListener < 0)
                {
                	this.listenersOnce.push(listener);
                }
            }
		};

        /**
         * Removes a callback function that was added to the event handler so it won't be called when the event takes place.
         * @param {function} listener The callback function to be removed from the event handler object. See the referenced Listener function documentation for more detail in each event handler object's documentation.
         */
        this.removeEventListener = function (listener) {

        	if (chainFunction) {
        		listener = listener.CocoonJSEventHandlerChainFunction;
        		delete listener.CocoonJSEventHandlerChainFunction;
        	}

			var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].removeEventListener(nativeEventName, listener);
            }
            else {
                var indexOfListener = this.listeners.indexOf(listener);
                if (indexOfListener >= 0) {
                    this.listeners.splice(indexOfListener, 1);
                }
            }
        };

		this.notifyEventListeners = function() {
			var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject && cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].notifyEventListeners(nativeEventName);
            } else {

                var argumentsArray= Array.prototype.slice.call(arguments);
                var listeners =     Array.prototype.slice.call(this.listeners);
                var listenersOnce = Array.prototype.slice.call(this.listenersOnce);
                var _this = this;
                // Notify listeners after a while ;) === do not block this thread.
                setTimeout(function() {
                    for (var i = 0; i < listeners.length; i++) {
                        listeners[i].apply(_this, argumentsArray);
                    }
                    for (var i = 0; i < listenersOnce.length; i++) {
                        listenersOnce[i].apply(_this, argumentsArray);
                    }
                }, 0);

                _this.listenersOnce= [];
            }
		};
		return this;
	};

	/**
	* A simple timer class. Update it every loop iteration and get values from accumulated time to elapsed time in seconds or milliseconds.
	*/
	CocoonJS.Timer = function() {
		this.reset();
		return this;
	};

	CocoonJS.Timer.prototype = {
		currentTimeInMillis : 0,
		lastTimeInMillis : 0,
		elapsedTimeInMillis : 0,
		elapsedTimeInSeconds : 0,
		accumTimeInMillis : 0,

		/**
		Resets the timer to 0.
		*/
		reset : function() {
			this.currentTimeInMillis = this.lastTimeInMillis = new Date().getTime();
			this.accumTimeInMillis = this.elapsedTimeInMillis = this.elapsedTimeInSeconds = 0;
		},

		/**
		Updates the timer calculating the elapsed time between update calls.
		*/
		update : function() {
			this.currentTimeInMillis = new Date().getTime();
			this.elapsedTimeInMillis = this.currentTimeInMillis - this.lastTimeInMillis;
			this.elapsedTimeInSeconds = this.elapsedTimeInMillis / 1000.0;
			this.lastTimeInMillis = this.currentTimeInMillis;
			this.accumTimeInMillis += this.elapsedTimeInMillis;
		}
	};

	// CocoonJS.FindAllNativeBindingsInCocoonJSExtensionObject = function(cocoonJSExtensionObject, nativeFunctionBindingCallback, nativeEventBindingCallback)
	// {
	// 	for (var cocoonJSExtensionObjectAttributeName in cocoonJSExtensionObject)
	// 	{
	// 		var cocoonJSExtensionObjectAttribute = cocoonJSExtensionObject[cocoonJSExtensionObjectAttributeName];

	// 		// Function
	// 		if (typeof cocoonJSExtensionObjectAttribute === 'function' && typeof cocoonJSExtensionObjectAttribute.nativeFunctionName !== 'undefined')
	// 		{
	// 			var nativeFunctionName = cocoonJSExtensionObjectAttribute.nativeFunctionName;
	// 			nativeFunctionBindingCallback(cocoonJSExtensionObjectAttributeName, nativeFunctionName);
	// 		}
	// 		// Event object
	// 		else if (typeof cocoonJSExtensionObjectAttribute === 'object' && cocoonJSExtensionObjectAttribute !== null && typeof cocoonJSExtensionObjectAttribute.nativeEventName !== 'undefined')
	// 		{
	// 			var nativeEventName = cocoonJSExtensionObjectAttribute.nativeEventName;
	// 			nativeEventBindingCallback(cocoonJSExtensionObjectAttributeName, nativeEventName);
	// 		}
	// 	}
	// }

	/**
	This function looks for a CocoonJS extension object that is bound to the given native ext object name.
	@returns The CocoonJS extension object that corresponds to the give native extension object name or null if it cannot be found.
	*/
	// CocoonJS.GetCocoonJSExtensionObjectForNativeExtensionObjectName = function(nativeExtensionObjectName)
	// {
	// 	var cocoonJSExtensionObject = null;
	// 	// Look in the CocoonJS object and for every object that is a CocoonJS.Extension check if it's nativeExtensionObjectName matches to the one passed as argument. If so, create an object that will represent it's documentation for the native ext object.
	// 	for (var cocoonJSAttributeName in CocoonJS)
	// 	{
	// 		var cocoonJSAttribute = CocoonJS[cocoonJSAttributeName];
	// 		if (typeof cocoonJSAttribute === 'object' && cocoonJSAttribute instanceof CocoonJS.Extension && cocoonJSAttribute.nativeExtensionObjectName === nativeExtensionObjectName)
	// 		{
	// 			// We have found the CocoonJS object that represents the native ext extension object name. 
	// 			cocoonJSExtensionObject = cocoonJSAttribute;
	// 			break;
	// 		}
	// 	}
	// 	return cocoonJSExtensionObject;
	// };

	/**
	This function adds functions to a CocoonJS extension object in order to bind them to the native makeCall function calls of the ext object.

	@param extensionObject The reference to the CocoonJS extension object where to add the new functions bound to the ext object makeCall functions calls.

	@param nativeFunctionsConfiguration An array of objects with the following structure:

		{ nativeFunctionName : "" [, functionName : "", isAsync : true/false] }

		- nativeFunctionName: Specifies the name of the function inside the ext object makeCall function call that will be bound.
		- functionName: An optional attribute that allows to specify the name of the function to be added to the CocoonJS extension object. If is not present, the name of the function will be the same
		as the nativeFunctionName.
		- isAsync: An optional attribute that allows to specify if the call should be performed using makeCall (false or missing) or makeCallAsync (true).
		- alternativeFunction: An optional attribute that allows to specify an alternative function that will be called internally when this function is called. This attribute
		allows for adding new functionalities like for example adding methods 

	@returns The CocoonJS extension object.
	*/
	// CocoonJS.AddNativeFunctionBindingsToExtensionObject = function(extensionObject, nativeFunctionsConfiguration)
	// {
	// 	if (typeof extensionObject === 'undefined' || extensionObject === null) throw("The passed extension object be a valid object.");
	// 	if (typeof nativeFunctionsConfiguration === 'undefined' || nativeFunctionsConfiguration === null) throw("The passed native functions configuration array must be a valid object.");

	// 	for (var i = 0; i < nativeFunctionsConfiguration.length; i++)
	// 	{
	// 		if (typeof nativeFunctionsConfiguration[i].nativeFunctionName === 'undefined') throw("The 'nativeFunctionName' attribute in the native function configuration object at index '" + i + "' in the native function configuration array cannot be undefined.");
	// 		var nativeFunctionName = nativeFunctionsConfiguration[i].nativeFunctionName;
	// 		var functionName = typeof nativeFunctionsConfiguration[i].functionName !== 'undefined' ? nativeFunctionsConfiguration[i].functionName : nativeFunctionName;
	// 		var makeCallFunction = null;
	// 		makeCallFunction = typeof nativeFunctionsConfiguration[i].isAsync !== 'undefined' && nativeFunctionsConfiguration[i].isAsync ? extensionObject.nativeExtensionObject.makeCallAsync : extensionObject.nativeExtensionObject.makeCall;
	// 		// Add the new function to the CocoonJS extension object
	// 		extensionObject[functionName] = function()
	// 		{
	// 			// Convert the arguments object to an array
	// 			var arguments = Array.prototype.slice.call(arguments);
	// 			// Add the native function name as the first parameter
	// 			arguments.unshift(nativeFunctionName);
	// 			// Make the native ext object call
	// 			var result = makeCallFunction.apply(extensionObject.nativeExtensionObject, arguments);
	// 			return result;
	// 		}
	// 		// Add a property to the newly added function to store the name of the original function.
	// 		extensionObject[functionName].nativeFunctionName = nativeFunctionName;
	// 	}
	// 	return extensionObject;
	// };

	/**
	This function adds objects to a CocoonJS extension object to allow event listener handling (add and remove) bound to the native ext object event listener handling.

	@param extensionObject The reference to the CocoonJS extension object where to add the new objects bound to the ext object event listener handling.

	@param nativeEventsConfiguration An array of objects with the following structure:

		{ nativeEventName : "" [, eventObjectName : ""] }

		- nativeEventName: Specifies the event in the native ext object to be bound.
		- eventObjectName: An optional attribute that allows to specify the name of the object to be added to the CocoonJS extension object. If is not present, the name of the function will be the same
		as the nativeEventName.
		- alternativeAddEventListenerFunction:
		- alternativeRemoveEventListenerFunction:

	@returns The CocoonJS extension object.
	*/
	// CocoonJS.AddNativeEventBindingsToExtensionObject = function(extensionObject, nativeEventsConfiguration)
	// {
	// 	if (typeof extensionObject === 'undefined' || extensionObject === null) throw("The passed extension object be a valid object.");
	// 	if (typeof nativeEventsConfiguration === 'undefined' || nativeEventsConfiguration === null) throw("The passed native events configuration array must be a valid object.");

	// 	for (var i = 0; i < nativeEventsConfiguration.length; i++)
	// 	{
	// 		if (typeof nativeEventsConfiguration[i].nativeEventName === 'undefined') throw("The 'nativeEventName' attribute in the native event configuration object at index '" + i + "' in the native event configuration array cannot be undefined.");
	// 		var nativeEventName = nativeEventsConfiguration[i].nativeEventName;
	// 		var eventObjectName = typeof nativeEventsConfiguration[i].eventObjectName !== 'undefined' ? nativeEventsConfiguration[i].eventObjectName : nativeEventName;
	// 		// Anonymous function call so each variable in the loop is used in the event listener handling function bindings.
	// 		(function(nativeEventName, eventObjectName)
	// 		{
	//     		extensionObject[eventObjectName] =
	//     		{
	//     			// Store the native event name
	//     			nativeEventName : nativeEventName,
	//     			// Create the event listener management functions bound to the native counterparts
	//     			addEventListener : function(callback)
	// 	    		{
	// 	    			extensionObject.nativeExtensionObject.addEventListener(nativeEventName, callback);
	//     			},
	//     			removeEventListener : function(callback)
	//     			{
	// 	    			extensionObject.nativeExtensionObject.removeEventListener(nativeEventName, callback);
	//     			}
	//     			// ,
	//     			// removeAllEventListeners : function()
	//     			// {

	//     			// }
	//     		};
	// 		})(nativeEventName, eventObjectName);
	// 	}
	// 	return extensionObject;
	// };

	/**
	The function object constructor function all the CocoonJS extensions can use to instantiate the CocoonJS extension object and add all the functionality needed bound to the native ext object.

	@param nativeExtensionObject The reference to the ext object extension object.

	@param nativeFunctionsConfiguration See CocoonJS.AddNativeFunctionBindingsToExtensionObject function's documentation for more details.

	@param nativeEventsConfiguration See CocoonJS.AddNativeEventBindingsToExtensionObject function's documentation for more details.

	@returns The new CocoonJS extension object.
	*/
	// CocoonJS.Extension = function(nativeExtensionObjectName, nativeFunctionsConfiguration, nativeEventsConfiguration)
	// {
	// 	if (typeof nativeExtensionObjectName === 'undefined' || nativeExtensionObjectName === null) throw("The native extension object name cannot be null");

	// 	if (window.ext[nativeExtensionObjectName] === 'undefined') throw("The given native extension object name '" + nativeExtensionObjectName + "' is incorrect or the native extension object is undefined.");

	// 	var nativeExtensionObject = window.ext[nativeExtensionObjectName];

	// 	// Store a reference to the native extension object and to it's name
	// 	this.nativeExtensionObject = nativeExtensionObject;
	// 	this.nativeExtensionObjectName = nativeExtensionObjectName;

	// 	// If native function configuration is passed, use it to add some functions to the new extension object.
	// 	if (typeof nativeFunctionsConfiguration !== 'undefined')
	// 	{
	// 		CocoonJS.AddNativeFunctionBindingsToExtensionObject(this, nativeFunctionsConfiguration);
	// 	}

	// 	// If native event configuration is passed, use it to add some event objects to the new extension object.
	// 	if (typeof nativeEventsConfiguration !== 'undefined')
	// 	{
	// 		CocoonJS.AddNativeEventBindingsToExtensionObject(this, nativeEventsConfiguration);
	// 	}

	// 	return this;
	// };   

})();

//////////////////////////////////////
// COCOONJS_APP.JS                  //
//////////////////////////////////////

(function () {
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
     * This namespace represents all the basic functionalities available in the CocoonJS extension API.
     * @namespace
     */
    CocoonJS.App = CocoonJS.App ? CocoonJS.App : {};

    CocoonJS.App.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_APP !== 'undefined';

    /**
     * The predefined possible layouts for the FPS overlay.
     * @namespace
     */
    CocoonJS.App.FPSLayout = {
        TOP_LEFT:'top-left',
        TOP_RIGHT:'top-right',
        BOTTOM_LEFT:'bottom-left',
        BOTTOM_RIGHT:'bottom-right'
    };

    /**
     * Contains all the possible values to specify the input keyboard type to be used when introducing text.
     * @namespace
     */
    CocoonJS.App.KeyboardType = {
        /**
         * Represents a generic text input keyboard.
         */
        TEXT:"text",

        /**
         * Represents a number like input keyboard.
         */
        NUMBER:"num",

        /**
         * Represents a phone like input keyboard.
         */
        PHONE:"phone",

        /**
         * Represents an email like input keyboard.
         */
        EMAIL:"email",

        /**
         * Represents an URL like input keyboard.
         */
        URL:"url"
    };

    /**
     * The storage types to be used with file system related operations.
     * @namespace
     */
    CocoonJS.App.StorageType = {
        /**
         * Represents the application storage. The application storage is the place where all the resources that come with the application are stored.
         */
        APP_STORAGE:"APP_STORAGE",

        /**
         * Represents the internal storage. The internal storage is a different storage space that the application storage and only the data that the application has stored
         * in it will be in this storage. It is internal to the platform/device.
         */
        INTERNAL_STORAGE:"INTERNAL_STORAGE",

        /**
         * Represents an external storage. The external storage is similar to the internal storage in the sense that it only contains information that the application has written
         * in it but it represents an external storage device like a SD-CARD. If there is no exrernal storage, it will represent the same as the internal storage.
         */
        EXTERNAL_STORAGE:"EXTERNAL_STORAGE",

        /**
         * Represents the temporal storage. Same as the internal and external storage spaces in the sense that it only contains information that the application has written
         * in it but the main difference is that the information in this storage may dissapear without notice.
         */
        TEMPORARY_STORAGE:"TEMPORARY_STORAGE"
    };

    /**
     * The capture types to capture screenshots using CocoonJS native capabilities.
     * @namespace
     */
    CocoonJS.App.CaptureType = {
        /**
         Captures everything, both the CocoonJS GL hardware accelerated surface and the system views (like the WebView).
         */
        EVERYTHING:0,

        /**
         * Captures just the CocoonJS GL hardware accelerated surface.
         */
        JUST_COCOONJS_GL_SURFACE:1,

        /**
         * Captures just the sustem views (like the webview)
         */
        JUST_SYSTEM_VIEWS:2
    };

    /**
     * Makes a forward call of some javascript code to be executed in a different environment (i.e. from CocoonJS to the WebView and viceversa).
     * It waits until the code is executed and the result of it is returned === synchronous.
     * @function
     * @param {string} javaScriptCode Some JavaScript code in a string to be forwarded and executed in a different JavaScript environment (i.e. from CocoonJS to the WebView and viceversa).
     * @return {string} The result of the execution of the passed JavaScript code in the different JavaScript environment.
     */
    CocoonJS.App.forward = function (javaScriptCode) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "forward", arguments);
        }
        else if (!navigator.isCocoonJS) {
            if (window.name == 'CocoonJS_App_ForCocoonJS_WebViewIFrame') {
                return window.parent.eval(javaScriptCode);
            }
            else {
                //return window.parent.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
                return window.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
            }
        }
    };

    /**
     * Makes a forward call of some javascript code to be executed in a different environment (i.e. from CocoonJS to the WebView and viceversa).
     * It is asyncrhonous so it does not wait until the code is executed and the result of it is returned. Instead, it calls a callback function when the execution has finished to pass the result.
     * @function
     * @param {string} javaScriptCode Some JavaScript code in a string to be forwarded and executed in a different JavaScript environment (i.e. from CocoonJS to the WebView and viceversa).
     * @param {function} [returnCallback] A function callback that will be called when the passed JavaScript code is executed in a different thread to pass the result of the execution in the different JavaScript environment.
     */
    CocoonJS.App.forwardAsync = function (javaScriptCode, returnCallback) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            if (typeof returnCallback !== 'undefined') {
                return ext.IDTK_APP.makeCallAsync("forward", javaScriptCode, returnCallback);
            }
            else {
                return ext.IDTK_APP.makeCallAsync("forward", javaScriptCode);
            }
        }
        else if (!navigator.isCocoonJS) {
            if (window.name == 'CocoonJS_App_ForCocoonJS_WebViewIFrame') {
                return window.parent.eval(javaScriptCode);
            }
            else {
                return window.parent.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
                // window.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
            }
        }
    };

    /**
     * Pops up a text dialog so the user can introduce some text and the application can get it back. It is the first approach CocoonJS has taken to be able to introduce
     * text input in a easy way. The dialog execution events are passed to the application through the {@link CocoonJS.App.onTextDialogFinished} and the {@link CocoonJS.App.onTextDialogCancelled} event objects.
     * @function
     * @param {string} [title] Default value is "". The title to be displayed in the dialog.
     * @param {string} [message] Default value is "". The message to be displayed in the dialog, next to the text input field.
     * @param {string} [text] Default value is "". The initial text to be introduced in the text input field.
     * @param {CocoonJS.App.KeyboardType} [keyboardType] Default value is {@link CocoonJS.App.KeyboardType.TEXT}. The keyboard type to be used when the text has to be introduced.
     * @param {string} [cancelButtonText] Default value is "". The text to be displayed in the cancel button of the dialog.
     * @param {string} [okButtonText] Default value is "". The text to be displayed in the ok button of the dialog.
     * @see CocoonJS.App.onTextDialogFinished
     * @see CocoonJS.App.onTextDialogCancelled
     */
    CocoonJS.App.showTextDialog = function (title, message, text, keyboardType, cancelButtonText, okButtonText) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "showTextDialog", arguments, true);
        }
        else if (!navigator.isCocoonJS) {
            if (!message) {
                message = "";
            }
            if (!text) {
                text = "";
            }
            var result = prompt(message, text);
            var eventObject = result ? CocoonJS.App.onTextDialogFinished : CocoonJS.App.onTextDialogCancelled;
            eventObject.notifyEventListeners(result);
        }
    };

    /**
     * Pops up a message dialog so the user can decide between a yes or no like confirmation. The message box execution events are passed to the application through the {@link CocoonJS.App.onMessageBoxConfirmed} and the {@link CocoonJS.App.onMessageBoxDenied} event objects.
     * @function
     * @param {string} [title] Default value is "". The title to be displayed in the dialog.
     * @param {string} [message] Default value is "". The message to be displayed in the dialog, next to the text input field.
     * @param {string} [confirmButtonText] Default value is "Yes". The text to be displayed for the confirm button.
     * @param {string} [denyButtonText] Default value is "No". The text to be displayed for the deny button.
     * @see CocoonJS.App.onMessageBoxConfirmed
     * @see CocoonJS.App.onMessageBoxDenied
     */
    CocoonJS.App.showMessageBox = function (title, message, confirmButtonText, denyButtonText) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "showMessageBox", arguments, true);
        }
        else if (!navigator.isCocoonJS) {
            if (!message) {
                message = "";
            }
            var result = confirm(message);
            var eventObject = result ? CocoonJS.App.onMessageBoxConfirmed : CocoonJS.App.onMessageBoxDenied;
            eventObject.notifyEventListeners();
        }
    };

    /**
     * It allows to load a new JavaScript/HTML5 resource that can be loaded either locally (inside the platform/device storage) or using a remote URL.
     * @function
     * @param {string} path A path to a resource stored in the platform or in a URL to a remote resource.
     * @param {CocoonJS.App.StorageType} [storageType] If the path argument represents a locally stored resource, the developer can specify the storage where it is stored. If no value is passes, the {@link CocoonJS.App.StorageType.APP_STORAGE} value is used by default.
     */
    CocoonJS.App.load = function (path, storageType) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "loadPath", arguments);
        }
        else if (!navigator.isCocoonJS) {
            var xhr = new XMLHttpRequest();

            xhr.onreadystatechange = function (event) {
                if (xhr.readyState === 4) {
                    if (xhr.status === 200) {
                        // TODO: As window load event is not being called (WHY???), I have decided to call the listeners directly
                        // var callback= function(event){
                        //     window.removeEventListener("load", callback);
                        var jsCode;
                        // If there is no webview, it means we are in the webview, so notify the CocoonJS environment
                        if (!CocoonJS.App.EmulatedWebViewIFrame) {
                            jsCode = "window.CocoonJS && window.CocoonJS.App.onLoadInTheWebViewSucceed.notifyEventListeners('" + path + "');";
                        }
                        // If there is a webview, it means we are in CocoonJS, so notify the webview environment
                        else {
                            jsCode = "window.CocoonJS && window.CocoonJS.App.onLoadInCocoonJSSucceed.notifyEventListeners('" + path + "');";
                        }
                        CocoonJS.App.forwardAsync(jsCode);
                        // };
                        // window.addEventListener("load", callback);
                        window.location.href = path;
                    }
                    else if (xhr.status === 404) {
                        this.onreadystatechange = null;
                        var jsCode;
                        // If there is no webview, it means we are in the webview, so notify the CocoonJS environment
                        if (!CocoonJS.App.EmulatedWebViewIFrame) {
                            jsCode = "CocoonJS && CocoonJS.App.onLoadInTheWebViewFailed.notifyEventListeners('" + path + "');";
                        }
                        // If there is a webview, it means we are in CocoonJS, so notify the webview environment
                        else {
                            jsCode = "CocoonJS && CocoonJS.App.onLoadInCocoonJSFailed.notifyEventListeners('" + path + "');";
                        }
                        CocoonJS.App.forwardAsync(jsCode);
                    }
                }
            };
            xhr.open("GET", path, true);
            xhr.send();
        }
    };

    /**
     * Reloads the last loaded path in the current context.
     * @function
     */
    CocoonJS.App.reload = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "reload", arguments);
        }
        else if (!navigator.isCocoonJS) {
            if (window.name == 'CocoonJS_App_ForCocoonJS_WebViewIFrame') {
                return window.parent.location.reload();
            }
            else {
                return window.parent.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.location.reload();
            }
        }
    };

    /**
     * Opens a given URL using a system service that is able to open it. For example, open a HTTP URL using the system WebBrowser.+
     * @function
     * @param {string} url The URL to be opened by a system service.
     */
    CocoonJS.App.openURL = function (url) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "openURL", arguments, true);
        }
        else if (!navigator.isCocoonJS) {
            window.open(url, '_blank');
        }
    }

    /**
     * Forces the app to be finished.
     * @function
     */
    CocoonJS.App.forceToFinish = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "forceToFinish", arguments);
        }
        else if (!navigator.isCocoonJS) {
            window.close();
        }
    }

    /**
     * Enables or disables the auto lock to control if the screen keeps on after an inactivity period.
     * When the auto lock is enabled and the application has no user input for a short period, the system puts the device into a "sleepâ€ state where the screen dims or turns off.
     * When the auto lock is disabled the screen keeps on even when there is no user input for long times.
     * @param enabled A boolean value that controls whether to enable or disable the auto lock.
     */
    CocoonJS.App.setAutoLockEnabled = function (enabled) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setAutoLockEnabled", arguments);
        }
    }

    /**
     * Creates a canvas element that is automatically resized to the screen size. When the app is being executed
     * inside CocoonJS. This canvas is optimized for rendering so it is higly recommended to use it if it fits
     * your app needs. If your app uses one canvas as the main canvas where all other canvases and images are displayed, Ludei recommends to
     * call this function in order to create this main canvas. A usual 2x performance gain is achieved by doing so
     * depending on the device and the graphics card driver.
     * @function
     * @return {object} The canvas object that should be used as the main canvas and that is resized to the screen resolution.
     */
    CocoonJS.App.createScreenCanvas = function () {
        var screenCanvas;
        if (navigator.isCocoonJS) {
            screenCanvas = document.createElement("screencanvas");
        }
        else if (!navigator.isCocoonJS) {
            screenCanvas = document.createElement("canvas");
            screenCanvas.width = window.innerWidth;
            screenCanvas.height = window.innerHeight;
        }
        return screenCanvas;
    };

    /**
     * Disables the touch events in the CocoonJS environment.
     * @function
     */
    CocoonJS.App.disableTouchInCocoonJS = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("disableTouchLayer", "CocoonJSView");
        }
    };

    /**
     * Enables the touch events in the CocoonJS environment.
     * @function
     */
    CocoonJS.App.enableTouchInCocoonJS = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("enableTouchLayer", "CocoonJSView");
        }
    };

    /**
     * Disables the touch events in the WebView environment.
     * @function
     */
    CocoonJS.App.disableTouchInTheWebView = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("disableTouchLayer", "WebView");
        }
    };

    /**
     * Enables the touch events in the WebView environment.
     * @function
     */
    CocoonJS.App.enableTouchInTheWebView = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("enableTouchLayer", "WebView");
        }
    };

    /**
     * Setups the update interval in seconds (1 second / X frames) to receive the accelerometer updates.
     * It defines the rate at which the devicemotion events are updated.
     * @function
     * @param {number} updateIntervalInSeconds The update interval in seconds to be set.
     */
    CocoonJS.App.setAccelerometerUpdateIntervalInSeconds = function (updateIntervalInSeconds) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("setAccelerometerUpdateIntervalInSeconds", updateIntervalInSeconds);
        }
    };

    /**
     * Returns the update interval in seconds that is currently set for accelerometer related events.
     * @function
     * @return {number} The update interval in seconds that is currently set for accelerometer related events.
     */
    CocoonJS.App.getAccelerometerUpdateIntervalInSeconds = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getAccelerometerUpdateIntervalInSeconds");
        }
    };

    /**
     * Setups the update interval in seconds (1 second / X frames) to receive the gyroscope updates.
     * It defines the rate at which the devicemotion and deviceorientation events are updated.
     * @function
     * @param {number} updateIntervalInSeconds The update interval in seconds to be set.
     */
    CocoonJS.App.setGyroscopeUpdateIntervalInSeconds = function (updateIntervalInSeconds) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("setGyroscopeUpdateIntervalInSeconds", updateIntervalInSeconds);
        }
    };

    /**
     * Returns the update interval in seconds that is currently set for gyroscope related events.
     * @function
     * @return {number} The update interval in seconds that is currently set for gyroscope related events.
     */
    CocoonJS.App.getGyroscopeUpdateIntervalInSeconds = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("getGyroscopeUpdateIntervalInSeconds");
        }
    };


    /**
     * Setups a origin proxy for a given typeName. What this means is that after calling this function the environment that makes this call will suddenly
     * have a way of creating instances of the given typeName and those instances will act as a transparent proxy to counterpart instances in the destination environment.
     * Manipulating attributes, calling funcitions or handling events will all be performed in the destination environment but the developer will think they will be
     * happening in the origin environment.
     * IMPORTANT NOTE: These proxies only work with types that use attributes and function parameters and return types that are primitive like numbers, strings or arrays.
     * @param {string} typeName The name of the type to be proxified.
     * @param {array} [attributeNames] A list of the names of the attributes to be proxified.
     * @param {array} [functionNames] A list of the names of the functions to be proxified.
     * @param {array} [eventHandlerNames] A list of the names of the event handlers to be proxified (onXXXX like attributes that represent callbacks).
     * A valid typeName and at least one valid array for attribute, function or event handler names is mandatory.
     */
    CocoonJS.App.setupOriginProxyType = function (typeName, attributeNames, functionNames, eventHandlerNames) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            // Control the parameters.
            if (!typeName) throw "The given typeName must be valid.";
            if (!attributeNames && !functionNames && !eventHandlerNames) throw "There is no point on setting up a proxy for no attributes, functions nor eventHandlers.";
            attributeNames = attributeNames ? attributeNames : [];
            functionNames = functionNames ? functionNames : [];
            eventHandlerNames = eventHandlerNames ? eventHandlerNames : [];

            // The parent object will be the window. It could be another object but careful, the destination side should know about this.
            // TODO: Specify the parentObject as a parameter, obtain it's path from the window object and pass it to the destination environment so it knows about it.
            var parentObject = window;

            // Setup the destination side too.
            var jsCode = "CocoonJS.App.setupDestinationProxyType(" + JSON.stringify(typeName) + ", " + JSON.stringify(eventHandlerNames) + ");";
            CocoonJS.App.forward(jsCode);

            var originalType = parentObject[typeName];

            // Constructor. This will be the new proxified type in the origin environment. Instances of this type will be created by the developer without knowing that they are
            // internally calling to their counterparts in the destination environment.
            parentObject[typeName] = function () {
                var _this = this;

                // Each proxy object will have a origin object inside with all the necessary information to be a proxy to the destination.
                this._cocoonjs_proxy_object_data = {};
                // The id is obtained calling to the destination side to create an instance of the type.
                var jsCode = "CocoonJS.App.newDestinationProxyObject(" + JSON.stringify(typeName) + ");";
                this._cocoonjs_proxy_object_data.id = CocoonJS.App.forward(jsCode);
                // The eventHandlers dictionary contains objects of the type { eventHandlerName : string, eventHandler : function } to be able to make the callbacks when the 
                // webview makes the corresponding calls.
                this._cocoonjs_proxy_object_data.eventHandlers = {};
                // Also store the typename inside each instance.
                this._cocoonjs_proxy_object_data.typeName = typeName;
                // A dictionary to store the event handlers
                this._cocoonjs_proxy_object_data.eventListeners = {};

                // TODO: eventHandlers and eventListeners should be in the same list ;)

                // Store all the proxy instances in a list that belongs to the type itself.
                parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[this._cocoonjs_proxy_object_data.id] = this;

                // Create a setter and a getter for all the attribute names that have been specified. When the attributes are accessed (set or get) a call to the destination counterpart will be performed.
                for (var i = 0; i < attributeNames.length; i++) {
                    (function (attributeName) {
                        _this.__defineSetter__(attributeName, function (value) {
                            var jsCode = "CocoonJS.App.setDestinationProxyObjectAttribute(" + JSON.stringify(typeName) + ", " + _this._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(attributeName) + ", " + JSON.stringify(value) + ");";
                            return CocoonJS.App.forwardAsync(jsCode);
                        });
                        _this.__defineGetter__(attributeName, function () {
                            var jsCode = "CocoonJS.App.getDestinationProxyObjectAttribute(" + JSON.stringify(typeName) + ", " + _this._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(attributeName) + ");";
                            return CocoonJS.App.forwardAsync(jsCode);
                        });
                    })(attributeNames[i]);
                }

                // Create a function that performs a call to the destination environment counterpart for all the function names that have been specified.
                for (var i = 0; i < functionNames.length; i++) {
                    (function (functionName) {
                        _this[functionName] = function () {
                            // Get the arguments as an array and add the typeName, the proxy id and the functionName before all the other arguments before making the call to the destination counterpart.
                            var argumentsArray = Array.prototype.slice.call(arguments);
                            argumentsArray.unshift(functionName);
                            argumentsArray.unshift(this._cocoonjs_proxy_object_data.id);
                            argumentsArray.unshift(typeName);
                            // Use the array to create the correct function call.
                            var jsCode = "CocoonJS.App.callDestinationProxyObjectFunction(";
                            for (var i = 0; i < argumentsArray.length; i++) {
                                // The second argument (the id) should not be stringified
                                jsCode += (i !== 1 ? JSON.stringify(argumentsArray[i]) : argumentsArray[i]) + (i < argumentsArray.length - 1 ? ", " : "");
                            }
                            jsCode += ");";
                            // TODO: This next call should be synchronous but it seems that some customers are experiencing some crash issues. Making it async solves these crashes.
                            // Another possible solution could be to be able to specify which calls could be async and which sync in the proxification array.
                            var ret = CocoonJS.App.forwardAsync(jsCode);
                            return ret;
                        };
                    })(functionNames[i]);
                }

                // Create a setter and getter for all the event handler names that have been specified. When the event handlers are accessed, store them inside the corresponding position on the eventHandlers
                // array so they can be called when the destination environment makes the corresponding callback call.
                for (var i = 0; i < eventHandlerNames.length; i++) {
                    (function (eventHandlerName) {
                        _this.__defineSetter__(eventHandlerName, function (value) {
                            _this._cocoonjs_proxy_object_data.eventHandlers[eventHandlerName] = value;
                        });
                        _this.__defineGetter__(eventHandlerName, function () {
                            return _this._cocoonjs_proxy_object_data.eventHandlers[eventHandlerName];
                        });
                    })(eventHandlerNames[i]);
                }

                // Setup the add and remove event listeners in the proxy object
                _this.addEventListener = function (eventTypeName, eventCallback) {
                    var addEventCallback = true;
                    // Check for the eventListeners
                    var eventListeners = _this._cocoonjs_proxy_object_data.eventListeners[eventTypeName];
                    if (eventListeners) {
                        // As the eventListeners were already added, check that the same callback has not been added.
                        addEventCallback = eventListeners.indexOf(eventCallback) < 0;
                    }
                    else {
                        // There are no event listeners, so add the one and add the listeners array for the specific event type name
                        eventListeners = [];
                        _this._cocoonjs_proxy_object_data.eventListeners[eventTypeName] = eventListeners;

                        // Forward the call so the other end registers a event listener (only one is needed).
                        var jsCode = "CocoonJS.App.addDestinationProxyObjectEventListener(" + JSON.stringify(_this._cocoonjs_proxy_object_data.typeName) + ", " + _this._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(eventTypeName) + ");";
                        CocoonJS.App.forwardAsync(jsCode);
                    }
                    // Only if the alforithm above specify so, add the eventcallback and notify the destination environment to do the same
                    if (addEventCallback) {
                        eventListeners.push(eventCallback);
                    }
                };

                _this.removeEventListener = function (eventTypeName, eventCallback) {
                    // Check for the eventListeners
                    var eventListeners = _this._cocoonjs_proxy_object_data.eventListeners[eventTypeName];
                    if (eventListeners) {
                        var eventCallbackIndex = eventListeners.indexOf(eventCallback);
                        if (eventCallbackIndex >= 0) {
                            eventListeners.splice(eventCallbackIndex, 1);
                        }
                    }
                };

                // Return the proxy instance.
                return this;
            };

            // The type will contain a proxy data structure to store all the instances that are created so they are available when the destination environment calls back. 
            parentObject[typeName]._cocoonjs_proxy_type_data =
            {
                originalType:originalType,
                proxyObjects:[]
            };

            /**
             * Deletes a proxy instance from both the CocoonJS environment structures and also deleting it's webview environment counterpart.
             * This function should be manually called whenever a proxy instance won't be accessed anymore.
             * @param {object} object The proxy object to be deleted.
             */
            parentObject[typeName]._cocoonjs_proxy_type_data.deleteProxyObject = function (object) {
                var proxyObjectKey = CocoonJS.getKeyForValueInDictionary(this.proxyObjects, object);
                if (proxyObjectKey) {
                    var jsCode = "CocoonJS.App.deleteDestinationProxyObject(" + JSON.stringify(typeName) + ", " + object._cocoonjs_proxy_object_data.id + ");";
                    CocoonJS.App.forwardAsync(jsCode);
                    object._cocoonjs_proxy_object_data = null;
                    delete this.proxyObjects[proxyObjectKey];
                }
            };

            /**
             * Calls a event handler for the given proxy object id and eventHandlerName.
             * @param {number} id The id to be used to look for the proxy object for which to make the call to it's event handler.
             * @param {string} eventHandlerName The name of the handler to be called.
             * NOTE: Events are a complex thing in the HTML specification. This function just performs a call but at least provides a
             * structure to the event passing the target (the proxy object).
             * TODO: The destination should serialize the event object as far as it can so many parameters can be passed to the origin
             * side. Using JSON.stringify in the destination side and parse in origin side maybe? Still must add the target to the event structure though.
             */
            parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventHandler = function (id, eventHandlerName) {
                var object = this.proxyObjects[id];
                var eventHandler = object._cocoonjs_proxy_object_data.eventHandlers[eventHandlerName];
                if (eventHandler) {
                    eventHandler({ target:object });
                }
            };

            parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventListeners = function (id, eventTypeName) {
                var object = this.proxyObjects[id];
                var eventListeners = object._cocoonjs_proxy_object_data.eventListeners[eventTypeName].slice();
                for (var i = 0; i < eventListeners.length; i++) {
                    eventListeners[i]({ target:object });
                }
            };
        }
    };

    /**
     * Takes down the proxification of a type and restores it to it's original type. Do not worry if you pass a type name that is not proxified yet. The
     * function will handle it correctly for compativility reasons.
     * @param {string} typeName The name of the type to be deproxified (take down the proxification and restore the type to it's original state)
     */
    CocoonJS.App.takedownOriginProxyType = function (typeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            if (parentObject[typeName] && parentObject[typeName]._cocoonjs_proxy_type_data) {
                parentObject[typeName] = parentObject[typeName]._cocoonjs_proxy_type_data.originalType;
            }
        }
    };

    /**
     * Deletes everything related to a proxy object in both environments. Do not worry of you do not pass a proxified object to the
     * function. For compatibility reasons, you can still have calls to this function even when no poxification of a type has been done.
     * @param {object} object The proxified object to be deleted.
     */
    CocoonJS.App.deleteOriginProxyObject = function (object) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            if (object && object._cocoonjs_proxy_object_data) {
                parentObject[object._cocoonjs_proxy_object_data.typeName]._cocoonjs_proxy_type_data.deleteProxyObject(object);
            }
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the destination environment whenever it is needed to work with proxy objects.
     * It calls the origin proxy object when an event handler need to be updated/called from the destination environment.
     * @param {string} typeName The type name of the proxified type.
     * @param {number} id The id of the proxy object.
     * @param {string} eventHandlerName The name of the event handler to be called.
     */
    CocoonJS.App.callOriginProxyObjectEventHandler = function (typeName, id, eventHandlerName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventHandler(id, eventHandlerName);
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the destination environment whenever it is needed to work with proxy objects.
     * It calls the origin proxy object when all the event listeners related to a specific event need to be updated/called from the destination environment.
     * @param {string} typeName The type name of the proxified type.
     * @param {number} id The id of the proxy object.
     * @param {string} eventTypeName The name of the event type to call the listeners related to it.
     */
    CocoonJS.App.callOriginProxyObjectEventListeners = function (typeName, id, eventTypeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventListeners(id, eventTypeName);
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the origin environment whenever it is needed to work with proxy objects.
     * Setups all the structures that are needed to proxify a destination type to an origin type.
     * @param {string} typeName The name of the type to be proxified.
     * @param {array} eventHandlerNames An array with al the event handlers to be proxified. Needed in order to be able to create callbacks for all the event handlers
     * and call to the CocoonJS counterparts accordingly.
     */
    CocoonJS.App.setupDestinationProxyType = function (typeName, eventHandlerNames) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;

            // Add a cocoonjs structure to the destination proxified type to store some useful information like all the proxy instances that are created, plus the id counter 
            // and the names of all the event handlers and some utility functions.
            parentObject[typeName]._cocoonjs_proxy_type_data =
            {
                nextId:0,
                proxyObjects:{},
                eventHandlerNames:eventHandlerNames
            }
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the origin environment whenever it is needed to work with proxy objects.
     * Takes down the proxy type at the destination environment. Just removes the data structure related to proxies that was added to the type when proxification tool place.
     * @param {string} typeName The name of the type to take the proxification down.
     */
    CocoonJS.App.takedownDestinationProxyType = function (typeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            if (parent[typeName] && parentObject[typeName]._cocoonjs_proxy_type_data) {
                delete parentObject[typeName]._cocoonjs_proxy_type_data;
            }
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Creates a new destination object instance and generates a id to reference it from the original environment.
     * @param {string} typeName The name of the type to be proxified and to generate an instance.
     * @return The id to be used from the original environment to identify the corresponding destination object instance.
     */
    CocoonJS.App.newDestinationProxyObject = function (typeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;

            var proxyObject = new parentObject[typeName]();
            // Also store some additional information in the proxy object
            proxyObject._cocoonjs_proxy_object_data = {};
            // Like the type name, that could be useful late ;)
            proxyObject._cocoonjs_proxy_object_data.typeName = typeName;
            // Caculate the id for the object. It will be returned to the origin environment so this object can be referenced later
            var proxyObjectId = parentObject[typeName]._cocoonjs_proxy_type_data.nextId;
            // Store the created object in the structure defined in the setup of proxification with an id associated to it
            parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[proxyObjectId] = proxyObject;
            // Also store the id inside the proxy object itself
            proxyObject._cocoonjs_proxy_object_data.id = proxyObjectId;
            // Calculate a new id for the next object.
            parentObject[typeName]._cocoonjs_proxy_type_data.nextId++;

            // Setup all the event handlers.
            for (var i = 0; i < parentObject[typeName]._cocoonjs_proxy_type_data.eventHandlerNames.length; i++) {
                (function (eventHandlerName) {
                    proxyObject[eventHandlerName] = function (event) {
                        var proxyObject = this; // event.target;
                        // var eventHandlerName = CocoonJS.getKeyForValueInDictionary(proxyObject, this); // Avoid closures ;)
                        var jsCode = "CocoonJS.App.callOriginProxyObjectEventHandler(" + JSON.stringify(proxyObject._cocoonjs_proxy_object_data.typeName) + ", " + proxyObject._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(eventHandlerName) + ");";
                        CocoonJS.App.forwardAsync(jsCode);
                    };
                })(parentObject[typeName]._cocoonjs_proxy_type_data.eventHandlerNames[i]);
            }

            // Add the dictionary where the event listeners (callbacks) will be added.
            proxyObject._cocoonjs_proxy_object_data.eventListeners = {};

            return proxyObjectId;
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the origin environement whenever it is needed to work with proxy objects.
     * Calls a function of a destination object idetified by it's typeName and id.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     * @param {string} functionName The name of the function to be called.
     * @return Whatever the function call returns.
     */
    CocoonJS.App.callDestinationProxyObjectFunction = function (typeName, id, functionName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            var argumentsArray = Array.prototype.slice.call(arguments);
            argumentsArray.splice(0, 3);
            var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
            var result = proxyObject[functionName].apply(proxyObject, argumentsArray);
            return result;
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Sets a value to the corresponding attributeName of a proxy object represented by it's typeName and id.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     * @param {string} attributeName The name of the attribute to be set.
     * @param {unknown} attributeValue The value to be set to the attribute.
     */
    CocoonJS.App.setDestinationProxyObjectAttribute = function (typeName, id, attributeName, attributeValue) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
            proxyObject[attributeName] = attributeValue;
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Retrieves the value of the corresponding attributeName of a proxy object represented by it's typeName and id.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     * @param {string} attributeName The name of the attribute to be retrieved.
     */
    CocoonJS.App.getDestinationProxyObjectAttribute = function (typeName, id, attributeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
            return proxyObject[attributeName];
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Deletes a proxy object identifying it using it's typeName and id. Deleting a proxy object mainly means to remove the instance from the global structure
     * that hold all the instances.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     */
    CocoonJS.App.deleteDestinationProxyObject = function (typeName, id) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            delete parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     */
    CocoonJS.App.addDestinationProxyObjectEventListener = function (typeName, id, eventTypeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            // Look for the proxy object
            var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];

            var callback = function (event) {
                var proxyObject = this; // event.target;
                // var eventTypeName = CocoonJS.getKeyForValueInDictionary(proxyObject._cocoonjs_proxy_object_data.eventListeners, this); // Avoid closures ;)
                // TODO: Is there a way to retrieve the callbackId without a closure?
                var jsCode = "CocoonJS.App.callOriginProxyObjectEventListeners(" + JSON.stringify(proxyObject._cocoonjs_proxy_object_data.typeName) + ", " + proxyObject._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(eventTypeName) + ");";
                CocoonJS.App.forwardAsync(jsCode);
            };

            proxyObject._cocoonjs_proxy_object_data.eventListeners[eventTypeName] = callback;

            // Finally add the event listener callback to the proxy object
            proxyObject.addEventListener(eventTypeName, callback);
        }
    };

    // TODO: We could add a removeDestinationProxyObjectEventListener although it seems that is not completely necessary.

    /**
     * Proxifies the XMLHttpRequest type for the environment where this call is made. After calling this function, all the new objects
     * of XMLHttpRequest that are instantiated, will be proxified objects that will make calls to the counterparts in the other environment (CocoonJS <-> WebView viceversa).
     * IMPORTANT NOTE: Remember to take down the proxification once you are done or to delete proxy objects whenever they are not needed anymore or memory leaks may occur.
     */
    CocoonJS.App.proxifyXHR = function () {
        var ATTRIBUTE_NAMES =
            [
                "timeout",
                "withCredentials",
                "upload",
                "status",
                "statusText",
                "responseType",
                "response",
                "responseText",
                "responseXML",
                "readyState"
            ];
        var FUNCTION_NAMES =
            [
                "open",
                "setRequestHeader",
                "send",
                "abort",
                "getResponseHeader",
                "getAllResponseHeaders",
                "overrideMimeType"
            ];
        var EVENT_HANDLER_NAMES =
            [
                "onloadstart",
                "onprogress",
                "onabort",
                "onerror",
                "onload",
                "ontimeout",
                "onloadend",
                "onreadystatechange"
            ];
        CocoonJS.App.setupOriginProxyType("XMLHttpRequest", ATTRIBUTE_NAMES, FUNCTION_NAMES, EVENT_HANDLER_NAMES);
    };

    /**
     * Proxifies the Audio type for the environment where this call is made. After calling this function, all the new objects
     * of Audio that are instantiated, will be proxified objects that will make calls to the counterparts in the other environment (CocoonJS <-> WebView viceversa).
     * IMPORTANT NOTE: Remember to take down the proxification once you are done or to delete proxy objects whenever they are not needed anymore or memory leaks may occur.
     */
    CocoonJS.App.proxifyAudio = function () {
        var ATTRIBUTE_NAMES =
            [
                "src",
                "loop",
                "volume",
                "preload"
            ];
        var FUNCTION_NAMES =
            [
                "play",
                "pause",
                "load",
                "canPlayType"
            ];
        var EVENT_HANDLER_NAMES =
            [
                "onended",
                "oncanplay",
                "oncanplaythrough",
                "onerror"
            ];
        CocoonJS.App.setupOriginProxyType("Audio", ATTRIBUTE_NAMES, FUNCTION_NAMES, EVENT_HANDLER_NAMES);
    };

    /**
     * Captures a image of the screen synchronously and saves it to a file. Sync mode allows to capture the screen in the middle of a frame rendering.
     * @param {string} fileName Desired file name and format (png or jpg). If no value is passed, "capture.png" value is used by default
     * @param {CocoonJS.App.StorageType} storageType The developer can specify the storage where it is stored. If no value is passed, the {@link CocoonJS.App.StorageType.TMP_STORAGE} value is used by default.
     * @param {CocoonJS.App.CaptureType} captureType. Optional value to choose capture type. [0: captures everything, 1: only captures cocoonjs surface 2: only captures system views]. @see CocoonJS.App.CaptureType
     * @return The URL of the saved file.
     * @throws exception if the image fails to be stored or there is another error.
     * @see CocoonJS.App.onCaptureScreenSucceeded
     * @see CocoonJS.App.onCaptureScreenFailed
     */
    CocoonJS.App.captureScreen = function (fileName, storageType, captureType) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("captureScreen", fileName, storageType, captureType);
        }
    };

    /**
     * Captures a image of the screen asynchronously and saves it to a file.
     * Async mode captures a final frame as soon as possible.
     * @param {string} Desired file name and format (png or jpg). If no value is passed, "capture.png" value is used by default
     * @param {CocoonJS.App.StorageType} [storageType] The developer can specify the storage where it is stored. If no value is passed, the {@link CocoonJS.App.StorageType.TMP_STORAGE} value is used by default.
     * @param {CocoonJS.App.CaptureType} captureType. Optional value to choose capture type. [0: captures everything, 1: only captures cocoonjs surface, 2: only captures system views]. @see CocoonJS.App.CaptureType
     * @param {function} callback. Response callback, check the error property to monitor errors. Check the 'url' property to get the URL of the saved Image
     */
    CocoonJS.App.captureScreenAsync = function (fileName, storageType, captureType, callback) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCallAsync("captureScreen", fileName, storageType, captureType, callback);
        }
    };

    /**
     * Returns the device UUID
     * @return {string} The device UUID
     */
    CocoonJS.App.getDeviceId = function() {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getDeviceId");
        }
    };

    /**
     * Structure that defines the getDeviceInfo returned information
     */
    CocoonJS.App.DeviceInfo = {

        /**
        * The operating system name (ios, android,...)
        * @type string
        */
        os: null,

        /**
        * The operating system version (4.2.2, 5.0,...)
        * @type string
        */
        version: null,

        /**
        * The operating system screen density in dpi
        * @type string
        */
        dpi: null,

        /**
        * The device manufacturer (apple, samsung, lg,...)
        * @type string
        */
        brand: null,

        /**
        * The device model (iPhone 4S, SAMSUNG-SGH-I997, SAMSUNG-SGH-I997R, etc)
        * @type string
        */
        model: null,

        /**
        * The phone IMEI
        * Android: The phone IMEI is returned or null if the device has not telepohny
        * iOS: null is returned as we cannot get the IMEI in iOS, no public API available for that yet.
        * @type string
        */
        imei: null,

        /**
        * The platform Id
        * Android: The ANDROID_ID is used.
        * iOS: The OpenUDID is used as there is no Android ANDROID_ID equivalent in iOS
        * @type string
        */
        platformId: null,

        /**
        * The Odin generated id https://code.google.com/p/odinmobile/
        * @type string
        */
        odin: null,

        /**
        * The OpenUDID generated Id https://github.com/ylechelle/OpenUDID
        * @type string
        */
        openudid: null
    };

    /**
     * Returns the device Info
     * @return {CocoonJS.App.DeviceInfo} The device Info
     */
    CocoonJS.App.getDeviceInfo = function() {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getDeviceInfo");
        }
    };    

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onTextDialogFinished} event calls.
     * @name OnTextDialogFinishedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} text The text that was introduced in the text dialog when it was finished.
     */
    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by accepting it's content.
     * The callback function's documentation is represented by {@link CocoonJS.App.OnTextDialogFinishedListener}
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onTextDialogFinished = new CocoonJS.EventHandler("IDTK_APP", "App", "ontextdialogfinish");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by dismissing it's content.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onTextDialogCancelled = new CocoonJS.EventHandler("IDTK_APP", "App", "ontextdialogcancel");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by accepting it's content.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onMessageBoxConfirmed = new CocoonJS.EventHandler("IDTK_APP", "App", "onmessageboxconfirmed");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by dismissing it's content.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onMessageBoxDenied = new CocoonJS.EventHandler("IDTK_APP", "App", "onmessageboxdenied");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the application is suspended.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onSuspended = new CocoonJS.EventHandler("IDTK_APP", "App", "onsuspended");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the application is activated.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onActivated = new CocoonJS.EventHandler("IDTK_APP", "App", "onactivated");

})();

//////////////////////////////////////
// COCOONJS_APP_FORCOCOONJS.JS		//
//////////////////////////////////////

(function()
{
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before adding more functionalities to an extension.");
    if (typeof window.CocoonJS.App === 'undefined' || window.CocoonJS.App === null) throw("The CocoonJS.App object must exist and be valid before adding more functionalities to it.");

    /**
    * This namespace represents all the basic functionalities available in the CocoonJS extension API.
    * @namespace
    */
    CocoonJS.App = CocoonJS.App ? CocoonJS.App : {};

    if (!CocoonJS.App.nativeExtensionObjectAvailable)
    {
        (function createWebView() { 
            CocoonJS.App.EmulatedWebView = document.createElement('div'); 
            CocoonJS.App.EmulatedWebView.setAttribute('id', 'CocoonJS_App_ForCocoonJS_WebViewDiv'); 
            CocoonJS.App.EmulatedWebView.style.width = 0; 
            CocoonJS.App.EmulatedWebView.style.height = 0; 
            CocoonJS.App.EmulatedWebView.style.position = "absolute"; 
            CocoonJS.App.EmulatedWebView.style.left = 0; 
            CocoonJS.App.EmulatedWebView.style.top = 0;
            CocoonJS.App.EmulatedWebView.style.backgroundColor = 'transparent';
            CocoonJS.App.EmulatedWebView.style.border = "0px solid #000"; 
            CocoonJS.App.EmulatedWebViewIFrame = document.createElement("IFRAME"); 
            CocoonJS.App.EmulatedWebViewIFrame.setAttribute('id', 'CocoonJS_App_ForCocoonJS_WebViewIFrame');
            CocoonJS.App.EmulatedWebViewIFrame.setAttribute('name', 'CocoonJS_App_ForCocoonJS_WebViewIFrame');
            CocoonJS.App.EmulatedWebViewIFrame.style.width = 0; 
            CocoonJS.App.EmulatedWebViewIFrame.style.height = 0; 
            CocoonJS.App.EmulatedWebViewIFrame.frameBorder = 0;
            CocoonJS.App.EmulatedWebViewIFrame.allowtransparency = true;
            CocoonJS.App.EmulatedWebView.appendChild(CocoonJS.App.EmulatedWebViewIFrame);
            if(!document.body)
            document.body = document.createElement("body");
            document.body.appendChild(CocoonJS.App.EmulatedWebView);
        })(); 
    }

    /**
    * Pauses the CocoonJS JavaScript execution loop.
    * @function
    * @augments CocoonJS.App
    */
    CocoonJS.App.pause = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "pause", arguments);
        }
    };

    /**
    * Resumes the CocoonJS JavaScript execution loop.
    * @static
    * @function
    */
    CocoonJS.App.resume = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "resume", arguments);
        }
    };

    /**
    * Loads a resource in the WebView environment from the CocoonJS environment.
    * @function
    * @param {string} path The path to the resource. It can be a remote URL or a path to a local file.
    * @param {CocoonJS.App.StorageType} [storageType] An optional parameter to specify at which storage in the device the file path is stored. By default, APP_STORAGE is used.
    * @see CocoonJS.App.load
    * @see CocoonJS.App.onLoadInTheWebViewSucceed
    * @see CocoonJS.App.onLoadInTheWebViewFailed
    */
    CocoonJS.App.loadInTheWebView = function(path, storageType)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            // TODO: All this code should be changed to a simple call makeNativeExtensionObjectFunctionCall when the native argument control is improved.
            var javaScriptCodeToForward = "ext.IDTK_APP.makeCall('loadPath'";
            if (typeof path !== 'undefined')
            {
                javaScriptCodeToForward += ", '" + path + "'";
                if (typeof storageType !== 'undefined')
                {
                    javaScriptCodeToForward += ", '" + storageType + "'";
                }
            }
            javaScriptCodeToForward += ");";

            return CocoonJS.App.forwardAsync(javaScriptCodeToForward);
        }
        else if (!navigator.isCocoonJS)
        {
            var xhr = new XMLHttpRequest();

            xhr.onreadystatechange = function(event) {
                if (xhr.readyState === 4)
                {
                    if (xhr.status === 200)
                    {
                        var callback= function(event){
                            CocoonJS.App.onLoadInTheWebViewSucceed.notifyEventListeners(path);
                            CocoonJS.App.EmulatedWebViewIFrame.removeEventListener("load", callback);
                        };

                        CocoonJS.App.EmulatedWebViewIFrame.addEventListener(
                            "load", 
                            callback
                        );
                        CocoonJS.App.EmulatedWebViewIFrame.contentWindow.location.href= path;
                    }
                    else if (xhr.status === 404)
                    {
                        this.onreadystatechange = null;
                        CocoonJS.App.onLoadInTheWebViewFailed.notifyEventListeners(path);
                    }
                }
            };
            xhr.open("GET", path, true);
            xhr.send();
        }
    };

    /**
     * Reloads the last loaded path in the WebView context.
     * @function
     */
    CocoonJS.App.reloadWebView = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.App.forwardAsync("ext.IDTK_APP.makeCall('reload');");
        }
        else if (!navigator.isCocoonJS)
        {
            CocoonJS.App.EmulatedWebViewIFrame.contentWindow.location.reload();
        }
    };

    /**
    * Shows the webview.
    * @function
    * @param {int} x The top lef x coordinate of the rectangle where the webview will be shown.
    * @param {int} y The top lef y coordinate of the rectangle where the webview will be shown.
    * @param {width} y The width of the rectangle where the webview will be shown.
    * @param {height} y The height of the rectangle where the webview will be shown.
    */
    CocoonJS.App.showTheWebView = function(x, y, width, height)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            var javaScriptCodeToForward = "ext.IDTK_APP.makeCall('show'";
            if (typeof x !== 'undefined' && typeof y !== 'undefined' && typeof width !== 'undefined' && typeof height !== 'undefined')
            {
                javaScriptCodeToForward += ", " + x + ", " + y + ", " + width + ", " + height;
            }
            javaScriptCodeToForward += ");";

            return CocoonJS.App.forwardAsync(javaScriptCodeToForward);
        }
        else if (!navigator.isCocoonJS)
        {
            CocoonJS.App.EmulatedWebViewIFrame.style.width = (width ? width : window.innerWidth)+'px';
            CocoonJS.App.EmulatedWebViewIFrame.style.height = (height ? height : window.innerHeight)+'px';
            CocoonJS.App.EmulatedWebView.style.left = (x ? x : 0)+'px';
            CocoonJS.App.EmulatedWebView.style.top = (y ? y : 0)+'px';
            CocoonJS.App.EmulatedWebView.style.width = (width ? width : window.innerWidth)+'px';
            CocoonJS.App.EmulatedWebView.style.height = (height ? height : window.innerHeight)+'px';
            CocoonJS.App.EmulatedWebView.style.display = "block";
        }
    };

    /**
    * Hides the webview.
    * @function
    */
    CocoonJS.App.hideTheWebView = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            var javaScriptCodeToForward = "ext.IDTK_APP.makeCall('hide');";
            return CocoonJS.App.forwardAsync(javaScriptCodeToForward);
        }
        else if (!navigator.isCocoonJS)
        {
            CocoonJS.App.EmulatedWebView.style.display = "none";
        }
    };

    /**
    * Marks a audio file to be used as music by the system. CocoonJS, internally, differentiates among music files and sound files.
    * Music files are usually bigger in size and longer in duration that sound files. There can only be just one music file 
    * playing at a specific given time. The developer can mark as many files as he/she wants to be treated as music. When the corresponding
    * HTML5 audio object is used, the system will automatically know how to treat the audio resource as music or as sound.
    * Note that it is not mandatory to use this function. The system automatically tries to identify if a file is suitable to be treated as music
    * or as sound by checking file size and duration thresholds. It is recommended, though, that the developer specifies him/herself what he/she considers
    * to be music.
    * @function
    * @param {string} audioFilePath The same audio file path that will be used to create HTML5 audio objects.
    */
    CocoonJS.App.markAsMusic = function(audioFilePath)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
           return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "addForceMusic", arguments);
        }
    };

    /**
    * Activates or deactivates the antialas functionality from the CocoonJS rendering.
    * @function
    * @param {boolean} enable A flag that indicates if the antialas should be activated (true) or deactivated (false).
    */
    CocoonJS.App.setAntialias = function(enable)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
           return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setDefaultAntialias", arguments);
        }
    };

    /**
    * Sets a callback function that will be called whenever the system tries to finish the app.
    * The developer can specify how the system will react to the finish of the app by returning a
    * boolean value in the callback function: true means, close the app, false means that the developer
    * will handle the app close.
    * A common example of this is the back button in Android devices. When the back button is pressed, this
    * callback will be called and the system will react depending on the developers choice finishing, or not,
    * the application.
    * @function
    * @param {function} appShouldFinishCallback A function object that will be called when the system
    * determines that the app should be finished. This function must return a true or a false value
    * depending on what the developer wants: true === finish the app, false === do not close the app.
    */
    CocoonJS.App.setAppShouldFinishCallback = function(appShouldFinishCallback)
    {
        if (navigator.isCocoonJS)
        {
            window.onidtkappfinish = appShouldFinishCallback;
        }
    }

    /**
    * Sets the texture reduction options. The texture reduction is a process that allows big images to be reduced/scaled down when they are loaded.
    * Although the quality of the images may decrease, it can be very useful in low end devices or those with limited amount of memory.
    * The function sets the threshold on image size (width or height) that will be used in order to know if an image should be reduced or not.
    * It also allows to specify a list of strings to identify in which images file paths should be applied (when they meet the size threshold requirement) 
    * The developer will still think that the image is of the original size. CocoonJS handles all of the internals to be able to show the image correctly.
    * IMPORTANT NOTE: This function should be called when the application is initialized before any image is set to be loaded for obvious reasons ;).
    * and in which sould be forbid (even if they meet the threshold requirement).
    * @function
    * @param {number} sizeThreshold This parameter specifies the minimun size (either width or height) that an image should have in order to be reduced.
    * @param {string or array} [applyTo] This parameter can either be a string or an array of strings. It's purpose is to specify one (the string) or more (the array) substring(s) 
    * that will be compared against the file path of an image to be loaded in order to know if the reduction should be applied or not. If the image meets the
    * threshold size requirement and it's file path contains this string (or strings), it will be reduced. This parameter can also be null.
    * @param {string or array} [forbidFor] This parameter can either be a string or an array of strings. It's purpose is to specify one (the string) or more (the array) substring(s) 
    * that will be compared against the file path of an image to be loaded in order to know if the reduction should be applied or not. If the image meets the
    * threshold size requirement and it's file path contains this string (or strings), it won't be reduced. This parameter should be used in order to mantain the 
    * quality of some images even they meet the size threshold requirement.
    */
    CocoonJS.App.setTextureReduction = function(sizeThreshold, applyTo, forbidFor)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setDefaultTextureReducerThreshold", arguments);
        }
    };


    /**
    * Prints to the console the memory usage of the currently alive textures
    * @function
    */
    CocoonJS.App.logMemoryInfo = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "logMemoryInfo", arguments);
        }
    };

    /**
    * Enable CocoonJS Webview FPS overlay.
    * @function
    */
    CocoonJS.App.enableFPSInTheWebView = function(fpsLayout, textColor)
    {
        if (!CocoonJS.App.fpsInTheWebViewEnabled)
        {
            fpsLayout = fpsLayout ? fpsLayout : CocoonJS.App.FPSLayout.TOP_RIGHT;
            textColor = textColor ? textColor : "white";
            var jsCode = "" +
                "(function()" +
                "{" +
                    "var COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES = ['js/CocoonJSExtensions/CocoonJS.js', 'js/CocoonJSExtensions/CocoonJS_App.js', 'js/CocoonJSExtensions/CocoonJS_App_ForWebView.js'];" +
                    "var loadedScriptCounter = 0;" + 
                    "var loadedScriptFunction = function() " +
                    "{ " +
                        "loadedScriptCounter++;"+
                        "if (loadedScriptCounter >= COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES.length)"+
                        "{"+
                            "CocoonJS.App.enableFPS(" + JSON.stringify(fpsLayout) + ", " + JSON.stringify(textColor) + ");"+
                        "}"+
                    "};"+
                    "for (var i = 0; i < COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES.length; i++)"+
                    "{"+
                        "var s = document.createElement('script');"+
                        "s.onload = loadedScriptFunction;"+
                        "s.src = COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES[i];"+
                        "document.body.appendChild(s);"+
                    "}" +
                "})();";
            setTimeout(function()
            {
                CocoonJS.App.forward(jsCode);
            }, 3000);
            CocoonJS.App.fpsInTheWebViewEnabled = true;
        }
    };

    /**
    * Disable CocoonJS Webview FPS overlay.
    * @function
    */
    CocoonJS.App.disableFPSInTheWebView = function()
    {
        // TODO: Implement this function.
    };

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onLoadInTheWebViewSucceed} event calls.
     * @name OnLoadInTheWebViewSucceedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} pageURL The URL of the page that had been loaded in the webview.
     */
    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the WebView load has completed successfully.
    * The callback function's documentation is represented by {@link CocoonJS.App.OnLoadInTheWebViewSucceedListener}
    * @event
    * @static
    * @memberOf CocoonJS.App
    * @param {string} pageURL A string that represents the page URL loaded.
    */
    CocoonJS.App.onLoadInTheWebViewSucceed = new CocoonJS.EventHandler("IDTK_APP", "App", "forwardpageload");

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onLoadInTheWebViewFailed} event calls.
     * @name OnLoadInTheWebViewFailedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} pageURL The URL of the page that had been loaded in the webview.
     */
    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the WebView load fails.
    * The callback function's documentation is represented by {@link CocoonJS.App.OnLoadInTheWebViewFailedListener}
    * @event
    * @static
    * @memberOf CocoonJS.App
    */
    CocoonJS.App.onLoadInTheWebViewFailed = new CocoonJS.EventHandler("IDTK_APP", "App", "forwardpagefail");
    
})();

//////////////////////////////////////
// COCOONJS_AD.JS                   //
//////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
    * This namespace represents the CocoonJS Advertisement extension API.
    * @namespace
    */
    CocoonJS.Ad = {};

    CocoonJS.Ad.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_AD !== 'undefined';

    /**
    * The predefined possible layouts for a banner ad.
    * @namespace 
    */
	CocoonJS.Ad.BannerLayout = 
	{
		/**
		* Specifies that the banner must be shown in the top of the screen and vertically centered.
		*/
	    TOP_CENTER      : "TOP_CENTER",

		/**
		* Specifies that the banner must be shown in the bottom of the screen and vertically centered.
		*/
	    BOTTOM_CENTER   : "BOTTOM_CENTER"
	};

	/**
    * A rectangle object that contains the banner dimensions
    * @namespace 
    * @constructor
    * @param {int} x The top lef x coordinate of the rectangle.
    * @param {int} y The top lef y coordinate of the rectangle.
    * @param {width} y The rectangle width.
    * @param {height} y The rectangle height.
    */
	CocoonJS.Ad.Rectangle = function(x, y, width, height) 
	{
		/**
		* The top lef x coordinate of the rectangle 
		* @field 
		* @type {int}
		*/
	    this.x = x;

		/**
		* The top lef y coordinate of the rectangle 
		* @field 
		* @type {int}
		*/
	    this.y = y;

	    /**
		* The rectangle width
		* @field 
		* @type {int}
		*/
	    this.width = width;

	    /**
		* The rectangle height
		* @field 
		* @type {int}
		*/
	    this.height = height;
	};

	CocoonJS.Ad.Banner = function(id)
	{
		if (typeof id !== 'number') throw "The given ad ID is not a number.";

		this.id = id;
		var me = this;

		/**
    	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is shown.
    	* The callback function does not receive any parameter.
    	* @static
    	* @event
    	*/
		this.onBannerShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannershow", function(sourceListener, args)
    	{
    		if (me.id === args[0]) 
    		{
    			sourceListener();
    		}
    	});

    	/**
    	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is hidden.
    	* The callback function does not receive any parameter.
    	* @static
    	* @event
    	*/
		this.onBannerHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerhide", function(sourceListener, args)
    	{
    		if (me.id === args[0]) 
    		{
    			sourceListener();
    		}
    	});

    	/**
    	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is ready (cached).
    	* The callback function does not receive any parameter.
    	* @param {number} width The banner width
    	* @param {number} height The banner height
    	* @static
    	* @event
    	*/
		this.onBannerReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerready", function(sourceListener, args)
    	{
    		if (me.id === args[0]) 
    		{
    			sourceListener(args[1], args[2]);
    		}
    	});
	};

	CocoonJS.Ad.Banner.prototype = {

		/**
		* Shows a banner ad if available.
		* @function
		*/
		showBanner : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showBanner", [this.id], true);
			}
		},

		/**
		* Hides the banner ad if it was being shown.
		* @function
		*/
		hideBanner : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "hideBanner", [this.id], true);
			}
		},

		/**
		* Refreshes the banner.
		* @function
		*/
		refreshBanner : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshBanner", [this.id], true);
			}
		},

		/**
		* Gets the rectangle representing the banner screen position.
		* @function
		* @return {CocoonJS.Ad.Rectangle} rectangle The rectangle representing the banner position and domensions.
		*/
		getRectangle : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "getRectangle", [this.id]);
			}
		},

		/**
		* Sets the rectangle where the banner ad is going to be shown.
		* @function
		* @param {CocoonJS.Ad.Rectangle} rect The rectangle representing the banner position and domensions.
		*/
		setRectangle : function(rect)
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setRectangle", [this.id, rect],true);
			}
		},

		/**
		* Sets the rectangle where the banner ad is going to be shown.
		* You can use this method if you want to have better control of the banner screen positioning.
		* @function
		* @param {CocoonJS.Ad.BannerLayout} bannerLayout The layout where the bannerwill be placed.
		*/
		setBannerLayout : function(bannerLayout)
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setBannerLayout", [this.id, bannerLayout],true);
			}
		}
	};

	CocoonJS.Ad.Fullscreen = function(id)
	{
		if (typeof id !== 'number') throw "The given ad ID is not a number.";

		this.id = id;
		var me = this;

		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is shown.
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    */
		this.onFullScreenShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenshow", function(sourceListener, args)
    	{
    		if (me.id === args[0]) {
    			sourceListener();
    		}
    	});

		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is hidden.
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    */
    	this.onFullScreenHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenhide", function(sourceListener, args)
    	{
    		if (me.id === args[0]) {
    			sourceListener();
    		}
    	});

    	/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is ready (cached).
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    */
    	this.onFullScreenReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenready", function(sourceListener, args)
    	{
    		if (me.id === args[0]) {
    			sourceListener();
    		}
    	});
	};

	CocoonJS.Ad.Fullscreen.prototype = {

		/**
		* Shows a full screen ad if available.
		* @function
		* @see CocoonJS.Ad.onFullScreenShown
		* @see CocoonJS.Ad.onFullScreenHidden
		*/
		showFullScreen : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showFullScreen", [this.id], true);
			}
		},

		/**
		* Refreshes the fullscreen.
		* @function
		*/
		refreshFullScreen : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshFullScreen", [this.id], true);
			}
		}
	};

	/**
	* Initialize the service with service level initialization parameters.
	* @function
	* @param {object} An object with the required initialization parameters for the service.
	*/
	CocoonJS.Ad.requestInitialization = function(parameters)
	{
        if (typeof parameters === "undefined") {
            parameters = {};
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "requestInitialization", arguments, true);
		}
	};

	/**
	* Creates a new banner ad.
	* @function
	* @param {object} An object containing the properties the ad will need for its initialization.
	*/
	CocoonJS.Ad.createBanner = function(parameters)
	{
		if (typeof parameters === "undefined") {
            parameters = {};
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			var adId = CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "createBanner", [parameters]);
			var banner = new CocoonJS.Ad.Banner(adId);

			return banner;
		}
	};

	/**
	* Releases a banner.
	* @function
	* @param {object} The banner ad object to be released.
	*/
	CocoonJS.Ad.releaseBanner = function(banner)
	{
		if (typeof banner === "undefined") {
            throw "The banner ad object to be released is undefined"
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "releaseBanner", [banner.id]);
		}
	};

	/**
	* Creates a new fullscreen ad.
	* @function
	* @param {object} An object containing the properties the ad will need for its initialization.
	*/
	CocoonJS.Ad.createFullscreen = function(parameters)
	{
		if (typeof parameters === "undefined") {
            parameters = {};
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			var adId = CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "createFullscreen", [parameters]);
			var fullscreen = new CocoonJS.Ad.Fullscreen(adId);

			return fullscreen;
		}
	};

	/**
	* Releases a fullscreen ad.
	* @function
	* @param {object} The fullscreen ad object to be released.
	*/
	CocoonJS.Ad.releaseFullscreen = function(fullscreen)
	{
		if (typeof fullscreen === "undefined") {
            throw "The fullscreen ad object to be released is undefined"
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "releaseFullscreen", [fullscreen.id]);
		}
	};

	/**
	* Shows a banner ad if available.
	* @function
	* @see CocoonJS.Ad.setBannerLayout
	* @see CocoonJS.Ad.onBannerShown
	*/
	CocoonJS.Ad.showBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showBanner", arguments, true);
		}
	};

	/**
	* Hides the banner ad if it was being shown.
	* @function
	*/
	CocoonJS.Ad.hideBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "hideBanner", arguments, true);
		}
	};

	/**
	* Refreshes the banner.
	* @function
	*/
	CocoonJS.Ad.refreshBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshBanner", arguments, true);
		}
	};

	/**
	* Shows a full screen ad if available.
	* @function
	* @see CocoonJS.Ad.onFullScreenShown
	* @see CocoonJS.Ad.onFullScreenHidden
	*/
	CocoonJS.Ad.showFullScreen = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showFullScreen", arguments, true);
		}
	};

	/**
	* Refreshes the fullscreen.
	* @function
	*/
	CocoonJS.Ad.refreshFullScreen = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshFullScreen", arguments, true);
		}
	};

	/**
	* Makes a request to preload a banner ad.
	* @function
	*/
	CocoonJS.Ad.preloadBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "preloadBanner", arguments, true);
		}
	};

	/**
	* Makes a request to preload a full screen ad.
	* @function
	*/
	CocoonJS.Ad.preloadFullScreen = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "preloadFullScreen", arguments, true);
		}
	};

	/**
	* Sets the rectangle where the banner ad is going to be shown.
	* @function
	* @param {CocoonJS.Ad.Rectangle} rect The rectangle representing the banner position and domensions.
	*/
	CocoonJS.Ad.setRectangle = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setRectangle", arguments, true);
		}
	};

	/**
	* Gets the rectangle representing the banner screen position.
	* @function
	* @return {CocoonJS.Ad.Rectangle} rectangle The rectangle representing the banner position and domensions.
	*/
	CocoonJS.Ad.getRectangle = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "getRectangle", arguments);
		}
	};

	/**
	* Sets the rectangle where the banner ad is going to be shown.
	* You can use this method if you want to have better control of the banner screen positioning.
	* @function
	* @param {CocoonJS.Ad.BannerLayout} bannerLayout The layout where the bannerwill be placed.
	*/
	CocoonJS.Ad.setBannerLayout = function(bannerLayout)
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setBannerLayout", arguments, true);
		}
	};

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is shown.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onBannerShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannershow");

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is hidden.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onBannerHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerhide"); 

	/**
	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is ready (cached).
	* The callback function does not receive any parameter.
	* @param {number} width The banner width
	* @param {number} height The banner height
	* @static
	* @event
	*/
	CocoonJS.Ad.onBannerReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerready"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is shown.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onFullScreenShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenshow"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is hidden.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onFullScreenHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenhide");

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is ready (cached).
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onFullScreenReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenready"); 

})();

//////////////////////////////////////
// COCOONJS_STORE.JS                //
//////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
    * This namespace represents the CocoonJS In-App Purchase extension.
    * @namespace
    */
    CocoonJS.Store = {};

    CocoonJS.Store.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_STORE !== 'undefined';

	/**
	* The data structure that represents the information of a product in the store.
	* @namespace
	* @constructor
	* @param {string} The id of the product.
	* @param {string} The alias of the product.
	* @param {CocoonJS.Store.ProductType} The product type @see CocoonJS.Store.ProductType.
	* @param {string} The title of the product.
	* @param {string} The description of the product.
	* @param {string} The localized price of the product.
	* @param {string} The URL of the asset to be downloaded for this purchase.
	*/
	CocoonJS.Store.ProductInfo = function(productAlias, productId, productType, title, description, price, localizedPrice, downloadURL)
	{
		/**
		* The id of the product.
		* @field
		* @type string
		*/
		this.productId = productId;

		/**
		* The alias of the product.
		* @field
		* @type string
		*/
		this.productAlias = productAlias;

		/**
		* The product type @see CocoonJS.Store.ProductType
		* @field
		* @type CocoonJS.Store.ProductType
		*/
		this.productType = productType;

		/**
		* The title of the product.
		* @field
		* @type string
		*/
		this.title = title;

		/**
		* The description of the product.
		* @field
		* @type string
		*/
		this.description = description;

		/**
		* The price of the product.
		* @field
		* @type string
		*/
		this.price = price;

		/**
		* The localized price of the product.
		* @field
		* @type string
		*/
		this.localizedPrice = localizedPrice;

		/**
		* The URL of the asset to be downloaded for this purchase.
		* @field
		* @type string
		*/
		this.downloadURL = downloadURL;

		return this;
	};

	/**
    * The predefined possible states of a purchase.
    * @namespace 
    */
	CocoonJS.Store.ProductType = 
	{
		/**
		* A consumable product. See platform documentation for further information.
		*/
	    CONSUMABLE : 0,

		/**
		* A non-cunsumable product. . See platform documentation for further information.
		*/
	    NON_CONSUMABLE : 1,

	    /**
		* An auto-renewable subscription. See platform documentation for further information.
		*/
	    AUTO_RENEWABLE_SUBSCRIPTION : 2,

	    /**
		* A free subscription. See platform documentation for further information.
		*/
	    FREE_SUBSCRIPTION : 3,

	    /**
		* A non-renewable subscription. See platform documentation for further information.
		*/
	    NON_RENEWABLE_SUBSCRIPTION : 4
	};

	/**
    * The predefined possible store types.
    * @namespace 
    */
	CocoonJS.Store.StoreType = 
	{
		/**
		* Apple AppStore
		*/
	    APP_STORE : 0,

	    /**
	    * Android Play Store
	    */
	    PLAY_STORE : 1,

		/**
		* Mock Store
		*/
		MOCK_STORE : 2,

		/**
	    * Amazon AppStore
	    */
	    CHROME_STORE : 3,

	    /**
	    * Amazon AppStore
	    */
	    AMAZON_STORE : 4,

	    /**
	    * Nook Store
	    */
	    NOOK_STORE : 5
	};

	/**
	* The data structure that represents the information of a purchase.
	* @namespace
	* @constructor
	* @param {string} The transaction id of a purchase.
	* @param {string} The time when the purchase was done in seconds since 1970.
	* @param {CocoonJS.Store.PurchaseState} The state of the purchase. @see CocoonJS.Store.PurchaseState
	* @param {string} The product id related to this purchase.
	* @param {number} The number of products of the productId kind purchased in this transaction.
	*/
	CocoonJS.Store.PurchaseInfo = function(transactionId, purchaseTime, purchaseState, productId, quantity)
	{
		/**
		* The transaction id of a purchase.
		* @field
		* @type string
		*/
		this.transactionId = transactionId;

		/**
		* The time when the purchase was done in seconds since 1970.
		* @field
		* @type string
		*/
		this.purchaseTime = purchaseTime;

		/**
		* The state of the purchase. @see CocoonJS.Store.PurchaseState
		* @field
		* @type CocoonJS.Store.PurchaseState
		*/
		this.purchaseState = purchaseState;

		/**
		* The product id related to this purchase.
		* @field
		* @type string
		*/
		this.productId = productId;

		/**
		* The number of products of the productId kind purchased in this transaction.
		* @field
		* @type number
		*/
		this.quantity = quantity;

		return this;
	};

	/**
    * The predefined possible states of a purchase.
    * @namespace 
    */
	CocoonJS.Store.PurchaseState = 
	{
		/**
		* The product has been successfully purchased. The transaction has ended successfully.
		*/
	    PURCHASED : 0,

		/**
		* The purchase has been canceled.
		*/
	    CANCELED : 1,

	    /**
		* The purchase has been refunded.
		*/
	    REFUNDED : 2,

	    /**
		* The purchase (subscriptions only) has expired and is no longer valid.
		*/
	    EXPIRED : 3
	};

	/**
	* Gets the name of the native store implementation. 
	* @return {CocoonJS.Store.StoreType} The store type
	* @function
	*/ 
	CocoonJS.Store.getStoreType = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "getStoreType", arguments);
		}
	};

	/**
	* Initialize the service with service level initialization parameters.
	* @function
	* @param {object} An object with the required initialization parameters for the service.
	*/
	CocoonJS.Store.requestInitialization = function(parameters)
	{
        if (typeof parameters === "undefined") 
        {
            parameters = {};
        }
        else
        {
        	if (parameters['managed'] !== undefined) parameters['remote'] = parameters['managed'];
        	if (parameters['sandbox'] !== undefined) parameters['debug'] = parameters['sandbox'];
        }

		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "requestInitialization", arguments, true);
		}
	};

	/**
	* Starts the Store Service. 
	* This will make the system to initialize the Store Service and probably Store callbacks will start to be received after calling this method so you should have set your event handler before calling this method so don't lose any callback.
	* @function
	*/ 
	CocoonJS.Store.start = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "start", arguments);
		}
	};

	/**
	* This method allows you to check is the  Store service is available in this platform. 
	* Not all iOS and Android devices will have the Store service available so you should check if it is before calling any other method.
	* @function
	* @return {boolean} True if the service is available and false otherwise.
	*/ 
	CocoonJS.Store.canPurchase = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "canPurchase", arguments);
		}
	};

	/**
	* Fetches the products from the CocoonJS Cloud Compiling service store configuration. 
	* The request is monitored using the {@link CocoonJS.Store.onProductsFetchStarted}, {@link CocoonJS.Store.onProductsFetchCompleted} and {@link CocoonJS.Store.onProductsFetchFailed} event handlers.
	* @deprecated You should now use fetchProductsFromStore. We don't support cloud products now.
	* @function
	* @see CocoonJS.Store.onProductsFetchStarted
	* @see CocoonJS.Store.onProductsFetchCompleted
	* @see CocoonJS.Store.onProductsFetchFailed
	*/ 
	CocoonJS.Store.fetchProductsFromServer = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "fetchProductsFromServer", arguments, true);
		}
	};

	/**
	* Fetches the products information from the Store. 
	* The request is monitored using the {@link CocoonJS.Store.onProductsFetchStarted}, {@link CocoonJS.Store.onProductsFetchCompleted} and {@link CocoonJS.Store.onProductsFetchFailed} event handlers.
	* @function
	* @param {array} productIds An array with the ids of the products to retrieve information from.
	* @see CocoonJS.Store.onProductsFetchStarted
	* @see CocoonJS.Store.onProductsFetchCompleted
	* @see CocoonJS.Store.onProductsFetchFailed
	*/ 
	CocoonJS.Store.fetchProductsFromStore = function(productIds)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "fetchProductsFromStore", arguments, true);
		}
	};

	/**
	* Finish a purchase transaction and removes the transaction from the transaction queue. 
	* This method must be called after a purchase finishes successfully and the  {@link CocoonJS.Store.onProductPurchaseCompleted} callback has been received. 
	* If the purchase includes some asset to download from an external server this method must be called after the asset has been successfully downloaded. 
	* If you do not finish the transaction because the asset has not been correctly downloaded the {@link CocoonJS.Store.onProductPurchaseStarted} method will be called again later on.
	* @function
	* @param {string} transactionId The transactionId of the purchase to finish.
	*/ 
	CocoonJS.Store.finishPurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "finishPurchase", arguments, true);
		}
	};

	/**
	* Consumes a purchase. This makes that product to be purchasable again. 
	* @function
	* @param {string} transactionId The transaction Id of the purchase to consume.
	* @param {string} productId The product Id of the product to be consumed.
	*/ 
	CocoonJS.Store.consumePurchase = function(transactionId, productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "consumePurchase", arguments, true);
		}
	};

	/**
	* Request a product purchase given it's product id. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} productId The id or alias of the product to be purchased.
	* @see CocoonJS.Store.onProductPurchaseStarted
	* @see CocoonJS.Store.onProductPurchaseCompleted
	* @see CocoonJS.Store.onProductPurchaseFailed
	*/ 
	CocoonJS.Store.purchaseProduct = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "purchaseFeature", arguments, true);
		}
	};

	/**
	* Request a product purchase given it's product id showing a modal progress dialog. 
	* The request is monitored using the {@link CocoonJS.Store.onProductPurchaseStarted}, {@link CocoonJS.Store.onProductPurchaseCompleted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} productId The id or alias of the product to be purchased.
	* @see CocoonJS.Store.onProductPurchaseStarted
	* @see CocoonJS.Store.onProductPurchaseCompleted
	* @see CocoonJS.Store.onProductPurchaseFailed
	*/ 
	CocoonJS.Store.puchaseProductModal = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "purchaseFeatureModal", arguments, true);
		}
	};

	/**
	* Request the purchase of a product given it's product id showing a dialog with a preview of the product (title and description). 
	* The request is monitored using the {@link CocoonJS.Store.onProductPurchaseStarted}, {@link CocoonJS.Store.onProductPurchaseCompleted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} productId The id or alias of the product to be purchased.
	* @see CocoonJS.Store.onProductPurchaseStarted
	* @see CocoonJS.Store.onProductPurchaseCompleted
	* @see CocoonJS.Store.onProductPurchaseFailed
	*/ 
	CocoonJS.Store.purchaseProductModalWithPreview = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "purchaseFeatureModalWithPreview", arguments, true);
		}
	};

	/**
	* Returns if a product has been already purchased or not. 
	* @function
	* @param {string} productId The product id or alias of the product to be checked.
	* @returns {boolean} A flag that indicates whether the product has been already purchased (true) or not (false).
	*/
	CocoonJS.Store.isProductPurchased = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "isFeaturePurchased", arguments);
		}
	};

	/**
	* Restores all the purchases from the platform's market. 
	* For each already purchased product {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onPurchaseProductCompleted} and {@link CocoonJS.Store.onPurchaseProductFailed} event handlers are called again
	* @function
	* @see CocoonJS.Store.onRestorePurchasesStarted
	* @see CocoonJS.Store.onRestorePurchasesCompleted
	* @see CocoonJS.Store.onRestorePurchasesFailed
	*/
	CocoonJS.Store.restorePurchases = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "restorePurchases", arguments, true);
		}
	};

	/**
	* Restores all the purchases from the platform's market showing a modal progress dialog. 
	* For each already purchased product {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onPurchaseProductCompleted} and {@link CocoonJS.Store.onPurchaseProductFailed} event handlers are called again
	* @function
	* @see CocoonJS.Store.onRestorePurchasesStarted
	* @see CocoonJS.Store.onRestorePurchasesCompleted
	* @see CocoonJS.Store.onRestorePurchasesFailed
	*/
	CocoonJS.Store.restorePurchasesModal = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "restorePurchasesModal", arguments, true);
		}
	};

	/**
	* Returns all the products available to be purchased.
	* @function
	* @returns {array} An array with  all the {@link CocoonJS.Store.ProductInfo} objects available for purchase.
	*/
	CocoonJS.Store.getProducts = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "getProducts", arguments);
		}
	};

	/**
	* Adds a product to the products local DB. 
	* @function
	* @param {CocoonJS.Store.ProductInfo} product The product to be added to the local products DB.
	*/
	CocoonJS.Store.addProduct = function(product)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "addProduct", arguments);
		}
	};

	/**
	* Removes a product from the products local DB given its productId. 
	* @function
	* @param {string} productId The product or alias of the product to be removed from the local products DB.
	*/
	CocoonJS.Store.removeProduct = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "removeProduct", arguments);
		}
	};

	/**
	* Returns all the locally stored purchases.
	* @function
	* @returns {array} An array with all the {@link CocoonJS.Store.PurchaseInfo} completed purchases.
	*/
	CocoonJS.Store.getPurchases = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "getPurchases", arguments);
		}
	};

	/**
	* Adds a purchase to the local purchases DB. 
	* @function
	* @param {CocoonJS.Store.StorePurchase} purchase The purchase to be added.
	*/ 
	CocoonJS.Store.addPurchase = function(purchase)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "addPurchase", arguments);
		}
	};

	/**
	* Removes a purchase from the local purchases DB given it's transaction id. 
	* @function
	* @param {string} transactionId The id of the transaction to be removed.
	*/ 
	CocoonJS.Store.removePurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "removePurchase", arguments);
		}
	};

	/**
	* (TESTING ONLY) Simulate a purchase cancel. 
	* This method is not allowed in production services and will only work in Mocks. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} transactionId The transactionId of the purchase to be canceled.
	*/
	CocoonJS.Store.cancelPurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "cancelPurchase", arguments);
		}
	};

	/**
	* (TESTING ONLY) Simulate a purchase refundment. 
	* This method is not allowed in production services and will only work in Mocks. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} transactionId The transactionId of the purchase to be refunded.
	*/
	CocoonJS.Store.refundPurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "refundPurchase", arguments);
		}
	};

	/**
	* (TESTING ONLY) Simulate a purchase expiration. 
	* This method is not allowed in production services and will only work in Mocks. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} transactionId The transactionId of the purchase to be expired.
	*/
	CocoonJS.Store.expirePurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "expirePurchase", arguments);
		}
	};

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the products fetch has started.
    * The callback function receives no parameters.
    * @static
    * @event
    */
	CocoonJS.Store.onProductsFetchStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductsFetchStarted");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the products fetch has completed.
    * The callback function receives a parameter with an the valid products array.
    * @static
    * @event
    * @param {array} validProducts An array of {@link CocoonJS.Store.ProductInfo} objects representing all the valid fetched products.
    */
	CocoonJS.Store.onProductsFetchCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductsFetchCompleted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the products fetch has failed.
    * The callback function receives an error message as a parameter.
    * @static
    * @event
    * @param {string} errorMessage The error message.
    */
	CocoonJS.Store.onProductsFetchFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductsFetchFailed"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the purchase of a product starts.
    * The callback function receives a parameters with the information of the purchased product @see CocoonJS.Store.ProductInfo.
    * @static
	* @event
    * @param {string} productId The product id of the product being purchased.
    */
	CocoonJS.Store.onProductPurchaseStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseStarted"); 

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a request for purchase verification has been received from the Store.
    * The callback function receives two parameters, one with the productId of the purchased product and another one with a JSON object containing the data to be verified.
    * In Andorid this JSON object will containt two keys: signedData and signature. You will need that information to verify the purchase against the backend server.
    * @static
    * @event
    * @param {string} productId The product id of the product to be verified.
    * @param {string} data The string with the data to be verified.
    */
	CocoonJS.Store.onProductPurchaseVerificationRequestReceived = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseVerificationRequestReceived");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the purchase of a product succeeds.
    * The callback function receives as parameter the information of the purchase {@see CocoonJS.Store.PurchaseInfo}.
    * @static
    * @event
    * @param {CocoonJS.Store.PurchaseInfo} purchaseInfo The purchase info.
    */
	CocoonJS.Store.onProductPurchaseCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseCompleted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the purchase of a product fails.
    * The callback function receives a parameters with the product id and an error message.
    * @static
    * @event
    * @param {string} productId The product id.
    * @param {string} msg The error message.
    */
	CocoonJS.Store.onProductPurchaseFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseFailed"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the restore purchases operation has started.
    * The callback function receives no parameters.
    * @static
    * @event
    */
	CocoonJS.Store.onRestorePurchasesStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onRestorePurchasesStarted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the restore purchases operation has completed.
    * The callback function receives no parameters.
    * @static
    * @event
    */
	CocoonJS.Store.onRestorePurchasesCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onRestorePurchasesCompleted"); 

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the restore purchases operation has failed.
    * The callback function receives an error message as a parameter.
    * @static
    * @event
    * @param {string} errorMessage The error message.
    */
	CocoonJS.Store.onRestorePurchasesFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onRestorePurchasesFailed");

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the consume purchase operation has started.
    * @static
    * @event
    * @param {string} transactionId The transaction id of the purchase being consumed.
    */
	CocoonJS.Store.onConsumePurchaseStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onConsumePurchaseStarted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the consume purchase operation has completed.
    * @static
    * @event
    * @param {string} transactionId The transaction id of the consumed purchase.
    */
	CocoonJS.Store.onConsumePurchaseCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onConsumePurchaseCompleted"); 

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the consume purchase operation has failed.
    * @static
    * @event
    * @param {string} transactionId The transaction id of the purchase that couldn't be consumed.
    * @param {string} errorMessage The error message.
    */
	CocoonJS.Store.onConsumePurchaseFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onConsumePurchaseFailed");

})();

//////////////////////////////////////
// COCOONJS_SOCIAL.JS               //
//////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

	/**
	* This type represents the access to a native Social extension API. As there can be more than
	* one service of this type, more than one instance can be created.
	* @namespace
	* @constructor
	* @param {string} nativeExtensionName The name of the native ext object extension property name.
	* @param {string} extensionName The name of the CocoonJS object extension property name.
	*/
	CocoonJS.Social = function(nativeExtensionName, extensionName)
	{
		if (typeof nativeExtensionName !== 'string') throw "The given native extension name '" + nativeExtensionName + "' is not a string.";
		if (typeof extensionName !== 'string') throw "The given extension name '" + extensionName + "' is not a string.";

		this.nativeExtensionName = nativeExtensionName;
		this.extensionName = extensionName;
	    this.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext[nativeExtensionName] !== 'undefined';

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestInitializationSucceed} event calls.
	     * @name OnRequestInitializationSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {object} initializationData The data structure passed when requestInitialization was called.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user information request suceeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestInitializationSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
	    this.onRequestInitializationSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestInitializationSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestInitializationFailed} event calls.
	     * @name OnRequestInitializationFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {object} initializationData The data structure passed when the requestInitialization function was called.
	     * @param {string} errorMessage The message that describes why the request did fail.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user information request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestInitializationFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
	    this.onRequestInitializationFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestInitializationFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestLoginSucceed} event calls.
	     * @name OnRequestLoginSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {CocoonJS.Social.UserInfo} userInfo The structure that describes the information of the user that logged in.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user login request succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestLoginSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestLoginSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestLoginSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestLoginFailed} event calls.
	     * @name OnRequestLoginFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} errorMessage The message that describes why the request did fail.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user login request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestLoginFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestLoginFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestLoginFailed");

	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user logs out.
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onLogout = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onLogout");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserInfoSucceed} event calls.
	     * @name OnRequestUserInfoSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {CocoonJS.Social.UserInfo} userInfo The structure that describes the information of the request user id.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user information request suceeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnUserInfoRequestSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserInfoSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserInfoSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserInfoFailed} event calls.
	     * @name OnRequestUserInfoFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} userID The id used in the request.
	     * @param {string} errorMessage The message that describes why the request did fail.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user information request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnUserInfoRequestFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserInfoFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserInfoFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserImageURLSucceed} event calls.
	     * @name OnRequestUserImageURLSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} userID The id used in the request.
	     * @param {string} imageURL The URL of the image of the requested user. 
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user image URL request succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestUserImageURLSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserImageURLSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserImageURLSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserImageURLFailed} event calls.
	     * @name OnRequestUserImageURLFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} userID The id of the user the request was placed for.
	     * @param {string} errorMessage The message that describes why the request did fail.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user image URL request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestUserImageURLFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserImageURLFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserImageURLFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserFriendsUserInfosSucceed} event calls.
	     * @name OnRequestUserFriendsUserInfosSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} userID The id of the user for whom the friend user infos where requested.
	     * @param {array} friendsInfo An array of {@link CocoonJS.Social.UserInfo} objects representing the information of the friends of the user.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's friends info is successfully retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestUserFriendsUserInfosSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserFriendsUserInfosSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserFriendsUserInfosSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserFriendsUserInfosFailed} event calls.
	     * @name OnRequestUserFriendsUserInfosFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param 
	     * @param {string} userID The id of the user fro whom the friends infos were requested.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's friends info fails to be retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestUserFriendsUserInfosFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserFriendsUserInfosFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserFriendsUserInfosFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestMessagePublicationSucceed} event calls.
	     * @name OnRequestMessagePublicationSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
 	     * @param {CocoonJS.Social.Message} message The message that has been published.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user message publication request succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestMessagePublicationSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    * @param {CocoonJS.Social.Message} message The message that has been published.
	    */
		this.onRequestMessagePublicationSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestMessagePublicationSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestMessagePublicationFailed} event calls.
	     * @name OnRequestMessagePublicationFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {CocoonJS.Social.Message} message The message that was supposed to be published.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user message publication request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestMessagePublicationFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestMessagePublicationFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestMessagePublicationFailed");

		/**
        * @ignore
        */
        this.on= function(event, callback) {
            event= "on"+event[0].toUpperCase()+event.substr(1);
            var signal= this[event];
            if (signal) {
                signal.addEventListener(callback);
            } else {
                console.error("SocialGaming service: '"+this.extensionName+"' does not understand '"+event+' signal.');
            }

            return this;
        };

	    return this;
	};

	CocoonJS.Social.prototype = {
        userInfo : null,
        userInfoCocoonJS : null,

        /**
        * @ignore
        */
        getUserInfo : function() {
            return this.userInfo;
        },

        /**
        * Returns the information of the currently logged in user.
        * @return {@link CocoonJS.Social.UserInfo}
        */
        getLoggedInUserInfo : function() {
            if (this.nativeExtensionObjectAvailable) {
                return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "getLoggedInUserInfo", arguments);
            }
            else {
                return this.userInfoCocoonJS;
            }
        },

        /**
        * @ignore
        */
        setUserInfo : function( userInfo) {
            this.userInfo= userInfo;
        },

        /**
        * @ignore
        */
        setUserInfoCocoonJS : function( userInfoCocoonJS ) {
            this.userInfoCocoonJS = userInfoCocoonJS;
        },

		/**
        * Request initialization of the underlying social service.
        * @param {object} paramsObject A data structure to initialize the service. It will be dependable of the underlying service.
        * @see CocoonJS.Social.onRequestInitializationSucceed
        * @see CocoonJS.Social.onRequestInitializationFailed
        */
		requestInitialization : function(paramsObject) 
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestInitialization", arguments, true);
			}
		},

		/**
        * Returns a flag to indicate if the underlying service has been initialized or not.
        * @return {boolean} If the underlying service had been initialized using the requestInitialization function call.
        */
		isInitialized : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "isInitialized", arguments);
			}
			else
			{
				return false;
			}
		},

		/**
		* Request to log in the social gaming application.
		* @see CocoonJS.Social.onRequestLoginSucceed
		* @see CocoonJS.Socual.onRequestLoginFailed
		*/
		requestLogin : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestLogin", arguments, true);
			}
		},

		/**
		* Request to log out of the social gaming application.
		* @see CocoonJS.Social.onRequestLoginSucceed
		* @see CocoonJS.Social.onRequestLoginFailed
		* @see CocoonJS.Social.onLogout
		*/
		requestLogout : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestLogout", arguments, true);
			}
		},

		/**
		* Check if the user is logged in.
		* @return {boolean} true if the user is still logged in, false otherwise.
		*/
		isLoggedIn : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "isLoggedIn", arguments);
			}
			else
			{
				return false;
			}
		},

		/**
		* Returns all the granted permissions for the current session.
		* @return {Array} An array containin the user granted permissions.
		*/
		getPermissions : function() 
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "getPermissions", arguments);
			}
			else
			{
				return new Array();
			}
		},

		/**
		* Check if the user has granted the publish permission for the current session.
		* @return {boolean} true if the user has granted the publish permission for the current session, false otherwise.
		*/
		hasPublishPermission : function() 
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "hasPublishPermission", arguments);
			}
			else
			{
				return false;
			}
		},

		/**
		* Request to retrieve the current or a specific user's id. The request can be monitored using the {@link CocoonJS.Social.onUserInfoRequestSucceed} and {@link CocoonJS.Social.onUserInfoRequestFailed} event handlers.
		* @param {string} [userId] The id of the user to retireve the information from. If no userID is specified, the currently logged in user is assumed.
		* @see CocoonJS.Social.onRequestUserInfoSucceed
		* @see CocoonJS.Social.onRequestUserInfoFailed
		*/
		requestUserInfo : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserInfo", arguments, true);
			}
		},

		/**
		* Request to retrieve the Image of a user
		* @param {string} [userID] The id of the user to get the image for. If no userID is specified, the currently logged user is used.
		* @param {CocoonJS.Social.ImageSizeType} [imageSizeType] The size of the image. One of the possible values among the ones in the {@link CocoonJS.Social.ImageSizeType}. If no value is specified, SMALL is used.
		* @see CocoonJS.Social.onRequestUserImageURLSucceed;
		* @see CocoonJS.Social.onRequestUserImageURLFailed;
		*/
		requestUserImageURL : function( imageSizeType, userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserImageURL", arguments, true);
			}
		},

		/**
		* Request for the information of all the friends of the currently logged user.
		* @param {string} [userID] The id of the user to get the friends infos for. If no userID is specified, the currently logged user is used.
		* @see CocoonJS.Social.onRequestUserFriendsUserInfosSucceed;
		* @see CocoonJS.Social.onRequestUserFriendsUserInfosFailed;
		*/
		requestUserFriendsUserInfos : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserFriendsUserInfos", arguments, true);
			}
		},

		/**
		* Request the publication of a message using a dialog.
		* @param {CocoonJS.Social.Message} message A object representing the information to be published.
		* @see CocoonJS.Social.onRequestMessagePublicationSucceed
		* @see CocoonJS.Social.onRequestMessagePublicationFailed
		*/
		requestMessagePublicationWithDialog : function(message)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestMessagePublicationWithDialog", arguments, true);
			}
		}
	};

	/**
	* This structure represents the possible images to be obtained for a user in the social gaming extension.
	* @namespace
	*/
	CocoonJS.Social.ImageSizeType = 
	{
		/**
		* Represent a thumbnail like image size.
		*/
	    THUMB : "thumb",

		/**
		* Represents the small image size.
		*/
	    SMALL : "small",

		/**
		* Represents the medium image size.
		*/
	    MEDIUM : "medium",

		/**
		* Represents the large image size.
		*/
	    LARGE : "large"
	};

	/**
	* The data structure that represents the information of a user inside the social gaming extension.
	* @namespace
	* @constructor
	* @param {string} userID The id of the user.
	* @param {string} userName The user name of the user.
	*/
	CocoonJS.Social.UserInfo = function(userID, userName)
	{
		/**
		* The id of the user.
		* @field
		* @type string
		*/
		this.userID = userID;

		/**
		* The user name of the user.
		* @field
		* @type string
		*/
		this.userName = userName;
	};

	/**
	* This type represents a message to be published.
	* @namespace
	* @constructor
	* @param {string} message The message to be published.
	* @param {string} mediaURL An URL to a media (image, video, ...)
	* @param {string} linkURL An URL to add to the message so the user can click on that link to get more information.
	* @param {string} linkText The text that will appear in the message link.
	* @param {string} linkCaption The text caption that will appear in the message link.
	*/
	CocoonJS.Social.Message = function(message, mediaURL, linkURL, linkText, linkCaption)
	{
		/**
		* The message to be published.
		* @field
		* @type string
		*/
		this.message = message;

		/**
		* An URL to a media (image, video, ...)
		* @field
		* @type string
		*/
		this.mediaURL = mediaURL;

		/**
		* An URL to add to the message so the user can click on that link to get more information.
		* @field
		* @type string
		*/
		this.linkURL = linkURL;

		/**
		* The text that will appear in the message link.
		* @field
		* @type string
		*/
		this.linkText = linkText;

		/**
		* The text caption that will appear in the message link.
		* @field
		* @type string
		*/
		this.linkCaption = linkCaption;

		return this;
	};

})();

//////////////////////////////////////
// COCOONJS_SOCIALGAMING.JS         //
//////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    if (!CocoonJS.Social)
		throw("The CocoonJS.Social object must exist and be valid before creating any extension object.");

	/**
	* This type represents the access to a native Social Gamming extension API. As there can be more than
	* one service of this type, more than one instance can be created.
	* @namespace
	* @constructor
	* @param {string} nativeExtensionName The name of the native ext object extension property name.
	* @param {string} extensionName The name of the CocoonJS object extension property name.
	*/
	CocoonJS.SocialGaming = function(nativeExtensionName, extensionName)
	{
		CocoonJS.SocialGaming.superclass.constructor.call(this, nativeExtensionName, extensionName);

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserAndFriendsScoresSucceed} event calls.
	     * @name OnRequestUserAndFriendsScoresSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {array} userAndFriendsScoreInfos An array of {@link CocoonJS.SocialGaming.UserScoreInfo} objects representing the information of the user's and friends' scores.
	     */
		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user and friends scores request succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserAndFriendsScoresSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserAndFriendsScoresSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserAndFriendsScoresSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserAndFriendsScoresFailed} event calls.
	     * @name OnRequestUserAndFriendsScoresFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the score and friends scores were requested.
	     * @param {string} leadeboardID The id of the leaderboard for whom the score and friends scores were requested.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user and his/her friends scores request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserAndFriendsScoresFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserAndFriendsScoresFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserAndFriendsScoresFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserScoreSucceed} event calls.
	     * @name OnRequestUserScoreSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {CocoonJS.SocialGaming.UserScoreInfo} userScoreInfo The info of the user's score.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's score information request suceeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserScoreSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserScoreSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserScoreSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserScoreFailed} event calls.
	     * @name OnRequestUserScoreFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the score was requested.
	     * @param {string} leaderboardID The id of the leaderboard for whom the score was requested.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's score information request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserScoreFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserScoreFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserScoreFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onSubmitUserScoreSucceed} event calls.
	     * @name OnSubmitUserScoreSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the score has been submitted.
	     * @param {string} leaderboardID The id of the leaderboard for which the score has been submitted.
	     * @param {number} score The score that has been submitted.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's score submit suceeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnSubmitUserScoreSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onSubmitUserScoreSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSubmitUserScoreSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onSubmitUserScoreFailed} event calls.
	     * @name OnSubmitUserScoreFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the score submition was requested.
	     * @param {string} leaderboadID The id of the leaderboard for which the score submition was requested.
	     * @param {number} score The score that was submitted and failed.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's score submit fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnSubmitUserScoreFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onSubmitUserScoreFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSubmitUserScoreFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserAchievementsSucceed} event calls.
	     * @name OnRequestUserAchievementsSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievements where requested.
	     * @param {array} achievementsInfos An array of {@link CocoonJS.SocialGaming.AchievementInfo} objects representing the information of the user's achievements.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's achievements info are successfully retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserAchievementsSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserAchievementsSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserAchievementsSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserAchievementsFailed} event calls.
	     * @name OnRequestUserAchievementsFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievements were requested.
	   	 * @param {string} msg The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's achievmeents info fails to be retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserAchievementsFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserAchievementsFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserAchievementsFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestAllAchievementsSucceed} event calls.
	     * @name OnRequestAllAchievementsSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {array} achievementsInfos An array of {@link CocoonJS.SocialGaming.AchievementInfo} objects representing the information of all the achievements.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's achievements info are successfully retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestAllAchievementsSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestAllAchievementsSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestAllAchievementsSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestAllAchievementsFailed} event calls.
	     * @name OnRequestAllAchievementsFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	   	 * @param {string} msg The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's achievmeents info fails to be retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestAllAchievementsFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestAllAchievementsFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestAllAchievementsFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestAchievementInfoSucceed} event calls.
	     * @name OnRequestAchievementInfoSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {CocoonJS.SocialGaming.AchievementInfo} achievementInfo A {@link CocoonJS.SocialGaming.AchievementInfo} object representing the information of the achievement.
	     */
		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the request to retrieve the information of an achievement succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestAchievementInfoSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestAchievementInfoSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestAchievementInfoSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestAchievementInfoFailed} event calls.
	     * @name OnRequestAchievementInfoFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} achievementID The id of the achievement for which the information retrieval was requested.
	     * @param {string} errorMessage The error message.
	     */
		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the request to retrieve the information of an achievement fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestAchievementInfoFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestAchievementInfoFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestAchievementInfoFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onSubmitUserAchievementSucceed} event calls.
	     * @name OnSubmitUserAchievementSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievement has been submitted.
	     * @param {string} achievementID The id of the achievement that has been submitted.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement submition succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnSubmitUserAchievementSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onSubmitUserAchievementSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSubmitUserAchievementSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onSubmitUserAchievementFailed} event calls.
	     * @name OnSubmitUserAchievementFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievment was submitted.
	     * @param {string} achievementID The id of the achievement that was submitted.
	     * @param {string} msg The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement submition fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnSubmitUserAchievementFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onSubmitUserAchievementFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSubmitUserAchievementFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onResetUserAchievementsSucceed} event calls.
	     * @name OnResetUserAchievementsSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievements were reset.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnResetUserAchievementsSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onResetUserAchievementsSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onResetUserAchievementsSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onResetUserAchievementsFailed} event calls.
	     * @name OnResetUserAchievementsFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievements where tried to be reset.
	     * @param {string} msg The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnResetUserAchievementsFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onResetUserAchievementsFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onResetUserAchievementsFailed");

	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the users closes the achievements view.
	    * The callback function does not receive any parameter.
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onAchievementsViewClosed  = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onAchievementsViewClosed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onAchievementsViewFailed} event calls.
	     * @name OnAchievementsViewFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} errorMessage The message that describes why the call failed.
	     */
		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the achievements view failed to show.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnAchievementsViewFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onAchievementsViewFailed  = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onAchievementsViewFailed");

		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when achievements view shows successfully.
	    * The callback function does not receive any parameter.
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onAchievementsViewSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onAchievementsViewSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onLeaderboardViewClosed} event calls.
	     * @name OnLeaderboardViewClosedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} leaderboardID The id of the leaderboard for which it's vew was requested to be shown.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnLeaderboardViewClosedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
   		this.onLeaderboardViewClosed  = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onLeaderboardViewClosed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onLeaderboardViewFailed} event calls.
	     * @name OnLeaderboardViewFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} leaderboardID The id of the leaderboard for which it's vew was requested to be shown.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnLeaderboardViewFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
   		this.onLeaderboardViewFailed  = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onLeaderboardViewFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onLeaderboardViewSucceed} event calls.
	     * @name OnLeaderboardViewSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} leaderboardID The id of the leaderboard for which it's vew was requested to be shown.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnLeaderboardViewSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
   		this.onLeaderboardViewSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onLeaderboardViewSucceed");

		return this;
	};

	CocoonJS.SocialGaming.prototype = 
	{
        abstractToSocialGamingAchievementMap : null,
        abstractToSocialGamingAchievementMapInverse : null,

        /**
        * @ignore
        */
        setAbstractToSocialGamingAchievementMap : function( map ) {
            this.abstractToSocialGamingAchievementMap= map;

            // build a reciprocal map.
            this.abstractToSocialGamingAchievementMapInverse= {};
            for( var id in map ) {
                if ( map.hasOwnProperty(id) ) {
                    this.abstractToSocialGamingAchievementMapInverse[ map[id] ]= id;
                }
            }
            return this;
        },

        /**
        * @ignore
        */
        getAbstractToSocialGamingAchievementTranslation : function( achievementID ) {
            /**
             * If a translation map for abstract in-game achievements has been set, translate achievementID from
             * abstract to SocialGamingService.
             */
            if (this.abstractToSocialGamingAchievementMap) {
                var socialGamingAchievementID = this.abstractToSocialGamingAchievementMap[achievementID];
                if (socialGamingAchievementID) {
                    console.log("Abstract achieventID='" + achievementID + "' turned to '" + socialGamingAchievementID + "'");
                    achievementID = socialGamingAchievementID;
                } else {
                    console.log("Something may be wrong: abstract achievementID: '" + achievementID + "' w/o translation.")
                }
            }

            return achievementID;
        },

		/**
		* Request to retrieve the scores of all friends of a given user.
		* @param {string} [leaderboardID] The id of the leaderboard to request the scores for.
		* @param {string} [userID] The id of the user. If null or undefined is passed, the currently logged in user id is used.
		* @see CocoonJS.SocialGaming.onRequestUserAndFriendsScoresSucceed
		* @see CocoonJS.SocialGaming.onRequestUserAndFriendsScoresFailed
		*/
		requestUserAndFriendsScores : function(leaderboardID, userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserAndFriendsScores", arguments, true);
			}
		},

		/**
		* Request to retrieve the score of a user.
		* @param {string} [leaderboardID] The id of the scores leaderboard to retireve the score from. If null or underfined is passed, the "leadeboard" id will be used.
		* @param {string} [userID] The id of the user to retireve the score from. If null or undefined is passed, the currently logged in user id is used.
		* @see CocoonJS.SocialGaming.onRequestUserScoreSucceed
		* @see CocoonJS.SocualGaming.onRequestUserScoreFailed
		*/
		requestUserScore : function(leaderboardID, userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserScore", arguments, true);
			}
		},

		/**
		* Request to the server the score of a user.
		* @param {number} [score] the score to submit
		* @param {string} [leaderboardID] The id of the scores leaderboard to submit the score to. If null or underfined is passed, the "leadeboard" id will be used.
		* @param {string} [userID] The id of the user to submit the score for. If null or undefined is passed, the currently logged in user id is used.
		* @see CocoonJS.SocialGaming.onSubmitUserScoreSucceed
		* @see CocoonJS.SocualGaming.onSubmitUserScoreFailed
		*/
		submitUserScore : function(score, leaderboardID, userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "submitUserScore", arguments, true);
			}
		},
		/**
		* Shows the leaderboard using a platform dependant view.
		* @param {string} [leaderboardID] The id of the scores leaderboard to show the view for. If null or underfined is passed, the "leadeboard" id will be used.
		* @see CocoonJS.SocialGaming.onLeaderboardViewClosed
		*/
		showLeaderboardView : function(leaderboardID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "showLeaderboardView", arguments, true);
			}
		},

		/**
		* Request to retrieve the user achievements. The request can be monitored using the {@link CocoonJS.SocialGaming.onRequestUserAchievementsSucceed} and {@link CocoonJS.Social.onRequestUserAchievementsFailed} event handlers.
		* @param {string} [userID] The id of the user to retireve the achievements from. if null/undefined/"" is specified, the currently logged in user is assumed.
		* @see CocoonJS.SocialGaming.onRequestUserAchievementsSucceed
		* @see CocoonJS.SocialGaming.onRequestUserAchievementsFailed
		*/
		requestUserAchievements : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserAchievements", arguments, true);
			}
		},

		/**
		* Request to retrieve all the achievements. The request can be monitored using the {@link CocoonJS.SocialGaming.onRequestAllAchievementsSucceed} and {@link CocoonJS.Social.onRequestAllAchievementsFailed} event handlers.
		* @see CocoonJS.SocialGaming.onRequestAllAchievementsSucceed
		* @see CocoonJS.SocialGaming.onRequestAllAchievementsFailed
		*/
		requestAllAchievements : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestAllAchievements", arguments, true);
			}
		},

		/**
		* Request to retrieve the information about an achievement. 
		* @param {string} achievementID The id of the achievement to get the information for.
		* @param {CocoonJS.Social.ImageSizeType} [imageSizeType] The size of the image. One of the possible values among the ones in the {@link CocoonJS.Social.ImageSizeType}
		*/
		requestAchievementInfo : function(achievementID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestAchievementInfo", arguments, true);
			}
		},

		/**
		* Submits an achievement to the server. If the process fails, the achievement is stored to submit it later.
		* @param {string} [achievementID] the achievement identifier
		* @param {number} [percentComplete] an optional number between 0 and 100 that indicates a completion percentage.
		* @see CocoonJS.SocialGaming.onSubmitAchievementSucceed
		* @see CocoonJS.SocualGaming.onSubmitAchievementFailed
		*/
        submitUserAchievement:function (achievementID, userID) {
            achievementID = this.getAbstractToSocialGamingAchievementTranslation(achievementID);

            if (this.nativeExtensionObjectAvailable) {
                return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "submitUserAchievement", arguments, true);
            }
        },

		/**
		* Shows the achievements using a platform dependant view.
		* @see CocoonJS.SocialGaming.onAchievementsViewClosed
		*/
		showUserAchievementsView : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "showUserAchievementsView", arguments, true);
			}
		},

		/**
		* Resets all the achievements of the current user
		* @param {string} [userID] The id of the user to reset the achievements for. If null/undefined/"", the logged in user is assumed.
		* @see CocoonJS.SocialGaming.onResetAchievementsSucceed
		* @see CocoonJS.SocualGaming.onResetAchievementsFailed
		*/
		resetUserAchievements : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "resetUserAchievements", arguments, true);
			}
		}
	};

	/**
    * @ignore
    */
	CocoonJS.extend(CocoonJS.SocialGaming, CocoonJS.Social);

	/**
	* The data structure that represents the information of the user score in the application.
	* @namespace
	* @constructor
	* @param {string} userID The user id.
	* @param {number} score The score of the user.
	* @param {string} userName The name of the user.
	* @param {string} imageURL The url of the user image.
	* @param {number} leaderboardID The id of the leaderboard the score belongs to.
	*/
	CocoonJS.SocialGaming.UserScoreInfo = function(userID, score, userName, imageURL, leaderboardID)
	{
		/**
		* The user id. 
		* @type string
		*/
		this.userID = userID;

		/**
		* The score of the user.
		* @type number
		*/
		this.score = score ? score : 0;

		/**
		* The name of the user.
		* @type string
		*/
        this.userName = userName;

		/**
		* The url of the user image.
		* @type string
		*/
        this.imageURL = imageURL;

        /**
		* The id of the leaderboard the score belongs to.
		* @type number
		*/
        this.leaderboardID = leaderboardID;
	};

	/**
	* The data structure that represents the information of an achievement in the application.
	* @namespace
	* @constructor
	* @param {string} achievementID The id of the achievement info.
	* @param {string} title The title of the achievement.
	* @param {string} description The description of the achievement.
	* @param {string} imageURL The url to the image representing the achievement.
	* @param {number} points The points value of the achievement
	*/
	CocoonJS.SocialGaming.AchievementInfo = function(achievementID, title, description, imageURL, points)
	{
		/**
		* The id of the achievement info.
		* @type string
		*/
		this.achievementID = achievementID;

		/**
		* The title of the achievement.
		* @type string
		*/
		this.title = title;

		/**
		* The description of the achievement.
		* @type string
		*/
		this.description = description;

		/**
		* The url to the image representing the achievement.
		* @type string
		*/
		this.imageURL = imageURL;

		/**
		* The points value of the achievement
		* @type number
		*/
		this.points = points ? points : 0;
	};

})();

/////////////////////////////////////////
// COCOONJS_SOCIALGAMING_GAMECENTER.JS //
/////////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");
    if (typeof window.CocoonJS.SocialGaming === 'undefined' || window.CocoonJS === null) throw("The CocoonJS.SocialGaming object must exist and be valid before creating a Game Center extension object.");

	/**
	* This instance represents the extension object to access GameCenter related native functionalities.
	* The data structure for initialization: None.
	* @see CocoonJS.Social
	*/
	CocoonJS.SocialGaming.GameCenter = new CocoonJS.SocialGaming("IDTK_SRV_SOCIAL_GAMECENTER", "SocialGaming.GameCenter");
})();

//////////////////////////////
// COCOONJS_GAMEPAD.JS 		//
//////////////////////////////

(function () {
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
     * This namespace represents the functionalities related to OUYA android gaming control.
     * @namespace
     */
    CocoonJS.Gamepad = {};

    CocoonJS.Gamepad.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.Gamepad !== 'undefined';

    CocoonJS.Gamepad.Indices = {
        BUTTON_0                : 0, 
        BUTTON_1                : 1,
        BUTTON_2                : 2,
        BUTTON_3                : 3,
        BUTTON_LEFT_BUMPER      : 4,
        BUTTON_RIGHT_BUMPER     : 5,
        
        BUTTON_LEFT_TRIGGER     : 6,
        BUTTON_RIGHT_TRIGGER    : 7,
        
        BUTTON_LEFT_JOYSTICK    : 10,
        BUTTON_RIGHT_JOYSTICK   : 11,
        BUTTON_DPAD_UP          : 12,
        BUTTON_DPAD_DOWN        : 13,
        BUTTON_DPAD_LEFT        : 14,
        BUTTON_DPAD_RIGHT       : 15,
        BUTTON_MENU             : 16,
        
        AXE_LEFT_JOYSTICK_X     : 0,
        AXE_LEFT_JOYSTICK_Y     : 1,
        AXE_RIGHT_JOYSTICK_X    : 2,
        AXE_RIGHT_JOYSTICK_Y    : 3
    };

    // If the extension is present and the navigator does not provide the gamepad API:
    // 1.- Add the getGamepads function to the navigator object.
    // 2.- Replace the window add and remove event listener functions to call to the extension for the gamepad related events.
    var systemSupportsGamepads = navigator["getGamepads"] || navigator["webkitGetGamepads"];
    if (CocoonJS.Gamepad.nativeExtensionObjectAvailable && !systemSupportsGamepads)
    {
        navigator.getGamepads = function()
        {
            return window.ext.Gamepad.makeCall("getGamepads");
        };

        CocoonJS.Gamepad.originalWindowAddEventListener = window.addEventListener;
        CocoonJS.Gamepad.originalWindowRemoveEventListener = window.removeEventListener;

        window.addEventListener = function(eventName, callback)
        {
            console.log("The new window.addEventListener has been called.");
            if (eventName === "gamepadconnected" || eventName === "gamepaddisconnected")
            {
                window.ext.Gamepad.addEventListener(eventName, callback);
            }
            else
            {
                var argumentsArray = Array.prototype.slice.call(arguments);
                CocoonJS.Gamepad.originalWindowAddEventListener.apply(window, argumentsArray);
            }
        };
        window.removeEventListener = function(eventName, callback)
        {
            console.log("The new window.removeEventListener has been called.");
            if (eventName === "gamepadconnected" || eventName === "gamepaddisconnected")
            {
                window.ext.Gamepad.removeEventListener(eventName, callback);
            }
            else
            {
                var argumentsArray = Array.prototype.slice.call(arguments);
                CocoonJS.Gamepad.originalWindowRemoveEventListener.apply(window, argumentsArray);
            }
        };
    } 
    else if (systemSupportsGamepads) 
    {
        if (!navigator.getGamepads)
        {
            console.log("navigator.getGamepads does not exist.");
            if (navigator.webkitGetGamepads)
            {
                console.log("navigator.webkitGamepads exists, adding navigator.getGamepads to point to it.");
                navigator.getGamepads = navigator.webkitGetGamepads;
            }
            else
            {
                console.log("navigator.webkitGetGamepads does not exist either.");
            }
        }
    }
})();

//////////////////////////////
// COCOONJS_NOTIFICATION.JS //
//////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
    * This namespace represents the CocoonJS Notification extension.
    * @namespace
    */
    CocoonJS.Notification = {};

    CocoonJS.Notification.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_NOTIFICATION !== 'undefined';

	/**
	* The data structure that represents the information of a local notification.
	* @namespace
	* @constructor
	* @param {string} message The notification message.
	* @param {boolean} soundEnabled A flag that indicates if the sound should be enabled for the notification.
	* @param {number} badgeNumber The number that will appear in the badge of the application icon in the home screen.
	* @param {object} userData The JSON data to attached to the notification.
	* @param {string} contentBody The body content to be showed in the expanded notification information.
	* @param {string} contentTitle The title to be showed in the expanded notification information.
	* @param {number} date Time in millisecs from 1970 when the notification will be fired.
	*/
	CocoonJS.Notification.LocalNotification = function(message, soundEnabled, badgeNumber, userData, contentBody, contentTitle, scheduleTime)
	{
		/**
		* The notification message.
		* @field
		* @type string
		*/
		this.message = message;

		/**
		* A flag that indicates if the sound should be enabled for the notification.
		* @field
		* @type boolean
		*/
		this.soundEnabled = soundEnabled;

		/**
		* (iOS only) The number that will appear in the badge of the application icon in the home screen.
		* @field
		* @type number
		*/
		this.badgeNumber = badgeNumber;

		/**
		* The JSON data to attached to the notification.
		* @field
		* @type object
		*/
		this.userData = userData;

		/**
		* (Android only) The body content to be showed in the expanded notification information.
		* @field
		* @type string
		*/
		if (contentBody !== undefined)
			this.contentBody = contentBody;
		else
			this.contentBody = "";

		/**
		* (Android only) The title to be showed in the expanded notification information.
		* @field
		* @type string
		*/
		if (contentTitle !== undefined)
			this.contentTitle = contentTitle;
		else
			this.contentTitle = "";

		/**
		* Time in millisecs from 1970 when the local notification will be fired
		* @field
		* @type number
		*/
		var currentTime = new Date().getTime();
		if (scheduleTime !== undefined){
			this.scheduleTime = scheduleTime;
		}else{
			this.scheduleTime = currentTime;
		}
	};

	/**
	* The data structure that represents the information of a push notification.
	* @namespace
	* @constructor
	* @param {string} message The notification message.
	* @param {boolean} soundEnabled A flag that indicates if the sound should be enabled for the notification.
	* @param {number} badgeNumber The number that will appear in the badge of the application icon in the home screen.
	* @param {object} userData The JSON data to attached to the notification.
	* @param {array} channels An array containing the channels names this notification will be delivered to.
	* @param {number} expirationTime A time in seconds from 1970 when the notification is no longer valid and will not be delivered in case it has not already been delivered.
	* @param {number} expirationTimeInterval An incremental ammount of time in from now when the notification is no longer valid and will not be delivered in case it has not already been delivered.
	*/
	CocoonJS.Notification.PushNotification = function(message, soundEnabled, badgeNumber, userData, channels, expirationTime, expirationTimeInterval)
	{
		/**
		* The notification message.
		* @field
		* @type string
		*/
		this.message = message;

		/**
		* A flag that indicates if the sound should be enabled for the notification.
		* @field
		* @type boolean
		*/
		this.soundEnabled = soundEnabled;

		/**
		* The number that will appear in the badge of the application icon in the home screen.
		* @field
		* @type number
		*/
		this.badgeNumber = badgeNumber;

		/**
		* The JSON data to attached to the notification.
		* @field
		* @type object
		*/
		this.userData = userData

		/**
		* An array containing the channels names this notification will be delivered to.
		* @field
		* @type array
		*/
		this.channels = channels;

		/**
		* A time in seconds from 1970 when the notification is no longer valid and will not be delivered in case it has not already been delivered.
		* @field
		* @type number
		*/
		if (expirationTime !== undefined)
			this.expirationTime = expirationTime;
		else
			this.expirationTime = 0;

		/**
		* An incremental ammount of time in from now when the notification is no longer valid and will not be delivered in case it has not already been delivered.
		* @field
		* @type number
		*/
		if (expirationTimeInterval !== undefined)
			this.expirationTimeInterval = expirationTimeInterval;
		else
			this.expirationTimeInterval = 0;
	};

	/**
	* Start processing received notifications. The user must call this method when the game is ready to process notifications. Notifications received before being prepared are stored and processed later.
	*/
	CocoonJS.Notification.start = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "start", arguments, true);
		}
	};


	/**
	* Register to be able to receive push notifications.
	* The registration process is controlled using the {@link CocoonJS.Notification.onRegisterForPushNotificationsSucceed} and {@link CocoonJS.Notification.onRegisterForPushNotificationsFailed} event handlers.
	* @function
	* @see {CocoonJS.Notification.onRegisterForPushNotificationsSucceed}
	* @see {CocoonJS.Notification.onRegisterForPushNotificationsFailed}
	*/
	CocoonJS.Notification.registerForPushNotifications = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "registerForPushNotifications", arguments, true);
		}
	};

	/**
	* Unregister from receiving push notifications.
	* The unregistration process is controlled using the {@link CocoonJS.Notification.onUnregisterForPushNotificationsSucceed} event handler.
	* @function
	* @see CocoonJS.Notification.onUnregisterForPushNotificationsSucceed
	*/
	CocoonJS.Notification.unregisterForPushNotifications = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "unregisterForPushNotifications", arguments, true);
		}
	};

	/**
	* Cancel the last sent local notification.
	* The last sent local notification will be remove from the notifications bar.
	* @function
	*/
	CocoonJS.Notification.cancelLastSentLocalNotificiation = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "cancelLocalNotification", arguments, true);
		}
	};

	/**
	* Cancel all sent local notifications.
	* All the notifications will ve removed from the notifications bar.
	* @function
	*/
	CocoonJS.Notification.cancelAllLocalNotifications = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "cancelAllLocalNotifications", arguments, true);
		}
	};

	/**
	* Send a local notification.
	* @function
	* @param {CocoonJS.Notification.LocalNotification} localNotification The local notification to be sent.
	*/
	CocoonJS.Notification.sendLocalNotification = function(localNotification)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "sendLocalNotification", arguments, true);
		}
	};

	/**
	* Subscribe to a channel in order to receive notifications targeted to that channel.
	* @function
	* @param {string} channel The channel id to subscribe to.
	*/
	CocoonJS.Notification.subscribeToChannel = function(channel)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "subscribe", arguments, true);
		}
	};

	/**
	* Unsubscribe from a channel in order to stop receiving notifications targeted to it.
	* @function
	* @param {string} channel The channel id to unsubscribe from.
	*/
	CocoonJS.Notification.unsubscribeFromChannel = function(channel)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "unsubscribe", arguments, true);
		}
	};

	/**
	* Send a push notification.
	* @function
	* @param {CocoonJS.Notification.PushNotification} pushNotification The push notification object to be sent.
	* @see CocoonJS.Notification.onPushNotificationDeliverySucceed
	* @see CocoonJS.Notification.onPushNotificationDeliveryFailed
	*/
	CocoonJS.Notification.sendPushNotification = function(pushNotification)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "sendPushNotification", arguments, true);
		}
	};

	/**
	* (iOS only) Set the badge number for this application.
	* This is useful if you want to modify the badge number set by a notification.
	* @function
	* @param {number} badgeNumber The number of the badge.
	*/
	CocoonJS.Notification.setBadgeNumber = function(badgeNumber)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "setBadgeNumber", arguments);
		}
	};

	/**
	* (iOS only) Returns the current badge number.
	* @function
	* @returns {number} The badge number.
	*/
	CocoonJS.Notification.getBadgeNumber = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "getBadgeNumber", arguments);
		}
	};

	/**
	* Returns the last received user data from a Local notification.
	* @function
	* @returns {object} The last received user data from a Local notification.
	*/
	CocoonJS.Notification.getLastReceivedLocalNotificationData = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "getLastReceivedLocalNotificationData", arguments);
		}
	};

	/**
	* Returns the last received user data from a Push notification.
	* @function
	* @returns {object} The last received user data from a Push notification.
	*/
	CocoonJS.Notification.getLastReceivedPushNotificationData = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "getLastReceivedPushNotificationData", arguments);
		}
	};

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the registration for push notification succeeds.
    * The callback function does not receive any parameter.
    * @static
    * @event
    * @param {string} token The token (apid or device token) received at registration time.
    * @memberOf CocoonJS.Notification
    */
	CocoonJS.Notification.onRegisterForPushNotificationsSucceed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationServiceRegistered");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the unregistration for push notifications succeeds.
    * The callback function does not receive any parameter.
    * @static
    * @event
    * @memberOf CocoonJS.Notification
    */
	CocoonJS.Notification.onUnregisterForPushNotificationsSucceed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationServiceUnregistered");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the registration for push notifications fails.
    * The callback function receives a parameter with error information.
    * @static
    * @event
    * @param {string} msg The error message.
    */
	CocoonJS.Notification.onRegisterForPushNotificationsFailed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationServiceFailedToRegister");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a push notification is received.
    * The callback function receives a parameter with the userData of the received notification.
    * @static
    * @event
    * @param {object} userData An object with the notification userData information.
    */
	CocoonJS.Notification.onPushNotificationReceived = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationReceived");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a local notification is received.
    * The callback function receives a parameter with the userData of the received notification.
    * @static
    * @event
    * @param {object} userData An object with the notification userData information.
    */
	CocoonJS.Notification.onLocalNotificationReceived = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "localNotificationReceived");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a notification is successfully delivered.
    * The callback function receives a parameter with the notificationId of the delivered notification.
    * @static
    * @event
    * @param {string} userData A string with the notification userData information.
    */
	CocoonJS.Notification.onPushNotificationDeliverySucceed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationSuccessfullyDelivered");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the delivery of push a notification fails.
    * The callback function receives a parameter with error information.
    * @static
    * @event
    * @param {string} msg The error message.
    */
	CocoonJS.Notification.onPushNotificationDeliveryFailed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationDeliveryError");

})();

/////////////////
// PATHFIND.JS //
/////////////////

// Pathfind.js
// Written by Ashley Gullen
// Copyright (c) 2013 Scirra Ltd.

// A* pathfinding javascript implementation

(function() {
	
	var PF_CLEAR = 0;
	var PF_OBSTACLE = 32767;
	
	function node()
	{
		this.parent = null;
		
		this.x = 0;
		this.y = 0;

		this.f = 0;
		this.g = 0;
		this.h = 0;
	};
	
	var nodeCache = [];			// for recycling nodes
	
	function allocNode()
	{
		var ret;
		
		if (nodeCache.length)
			ret = nodeCache.pop();
		else
			ret = new node();
			
		ret.parent = null;
		ret.x = 0;
		ret.y = 0;
		ret.f = 0;
		ret.g = 0;
		ret.h = 0;
		return ret;
	};
	
	function freeNode(n)
	{
		if (nodeCache.length < 64000)
			nodeCache.push(n);
	};
	
	function resultNode(x_, y_)
	{
		this.x = x_ || 0;
		this.y = y_ || 0;
	};
	
	var resultNodeCache = [];			// for recycling resultNodes
	
	function allocResultNode()
	{
		if (resultNodeCache.length)
			return resultNodeCache.pop();
		else
			return new resultNode(0, 0);
	};
	
	function freeResultNode(n)
	{
		if (resultNodeCache.length < 10000)
			resultNodeCache.push(n);
	};
	
	var workersSupported = (typeof Worker !== "undefined");
	var isInWebWorker = (typeof document === "undefined");		// no DOM in a worker
	var myInstance = null;										// single pathfinder instance for worker
	
	if (isInWebWorker)
	{
		self.addEventListener("message", function (e)
		{
			var d = e.data;
			
			if (!d)
				return;		// could be empty postMessage() to start worker
			
			if (d.cmd === "init")
			{
				if (!myInstance)
					myInstance = new pathfinder();
					
				myInstance.init(d.hcells, d.vcells, d.data, d.diagonals);
			}
			else if (d.cmd === "find")
			{
				// receive a pathfind job, process it them dispatch result
				myInstance.pathEnd.parent = null;
				myInstance.targetX = d.endX;
				myInstance.targetY = d.endY;
				
				if (myInstance.doLongFindPath(d.startX, d.startY))
				{
					self.postMessage({ cmd: "result", pathList: myInstance.pathList });
				}
				else
				{
					self.postMessage({ cmd: "result", pathList: null });
				}
			}
			else if (d.cmd === "setdiag")
			{
				// update diagonalsEnabled flag
				myInstance.diagonalsEnabled = d.diagonals;
			}
			
		}, false);
	}
	
	function pathfinder()
	{
		this.hcells = 0;
		this.vcells = 0;
		
		this.pathEnd = allocNode();
		
		this.cells = null;
		this.openList = [];
		this.closedList = [];
		this.closedCache = {};
		this.pathList = [];
		
		this.currentNode = null;
		this.targetX = 0;
		this.targetY = 0;
		this.diagonalsEnabled = true;
		
		this.worker = null;
		this.workerQueue = [];		// jobs awaiting completion from worker in order of requests made
		this.workerRecycle = [];
		
		var self = this;
		var i, len;
		
		if (workersSupported && !isInWebWorker)
		{
			// Create worker and receive results of pathfind jobs from it
			this.worker = new Worker("pathfind.js");
			
			this.worker.addEventListener("message", function (e) {
			
				if (!e || !e.data)
					return;
				
				if (e.data.cmd === "result")
				{
					if (e.data.pathList)
					{
						for (i = 0, len = self.pathList.length; i < len; i++)
							freeResultNode(self.pathList[i]);
						
						self.pathList = e.data.pathList;
						self.workerQueue[0].success();
					}
					else
						self.workerQueue[0].fail();
						
					self.workerRecycle.push(self.workerQueue.shift());
				}
			}, false);
			
			this.worker.addEventListener("error", function (e) {
				console.error(e);
			}, false);
			
			this.worker.postMessage(null);
		}
	};
	
	pathfinder.prototype.init = function (hcells_, vcells_, data_, diagonals_)
	{
		this.hcells = hcells_;
		this.vcells = vcells_;
		this.cells = data_;
		this.diagonalsEnabled = diagonals_;
		
		if (workersSupported && !isInWebWorker)
		{
			this.worker.postMessage({
				cmd: "init",
				hcells: hcells_,
				vcells: vcells_,
				diagonals: diagonals_,
				data: data_
			});
		}
	};
	
	pathfinder.prototype.isReady = function ()
	{
		return !!this.cells;
	};
	
	pathfinder.prototype.setDiagonals = function (d)
	{
		if (this.diagonalsEnabled === d)
			return;
		
		this.diagonalsEnabled = d;
		
		if (workersSupported && !isInWebWorker)
		{
			this.worker.postMessage({
				cmd: "setdiag",
				diagonals: d,
			});
		}
	};
	
	pathfinder.prototype.at = function (x_, y_)
	{
		if (x_ < 0 || y_ < 0 || x_ >= this.hcells || y_ >= this.vcells)
			return PF_OBSTACLE;
			
		return this.cells[x_][y_];
	};
	
	pathfinder.prototype.findPath = function (startX, startY, endX, endY, successCallback, failCallback)
	{
		if (!this.cells)
		{
			// not yet initialised
			failCallback();
			return;
		}
		
		startX = Math.floor(startX);
		startY = Math.floor(startY);
		endX = Math.floor(endX);
		endY = Math.floor(endY);
		
		this.targetX = endX;
		this.targetY = endY;
		this.pathEnd.parent = null;
		
		// Check the box made by the start and dest cells.
		// If the complete box is empty, allow a direct move to target.
		var minX = Math.min(startX, endX);
		var maxX = Math.max(startX, endX);
		var minY = Math.min(startY, endY);
		var maxY = Math.max(startY, endY);
		
		// Path goes out of bounds: no calculable path
		if (minX < 0 || minY < 0 || maxX >= this.hcells || maxY >= this.vcells)
		{
			failCallback();
			return;
		}
		
		var x, y, i, len, c, h, n;

		if (this.diagonalsEnabled)
		{
			var canMoveDirect = true;
			
			for (x = minX; x <= maxX; x++)
			{
				for (y = minY; y <= maxY; y++)
				{
					if (this.cells[x][y] !== 0)
					{
						canMoveDirect = false;
						
						// Break both loops
						x = maxX + 1;
						break;
					}
				}
			}

			// A "direct" path is available (box is empty)
			if (canMoveDirect)
			{
				for (i = 0, len = this.pathList.length; i < len; i++)
					freeResultNode(this.pathList[i]);
				this.pathList.length = 0;
			
				this.pathEnd.x = endX;
				this.pathEnd.y = endY;
				this.pathEnd.parent = null;
				n = allocResultNode();
				n.x = endX;
				n.y = endY;
				this.pathList.push(n);
				successCallback();
				return;
			}
		}
		
		if (workersSupported)
		{
			// recycle objects in the worker queue
			if (this.workerRecycle.length)
				h = this.workerRecycle.pop();
			else
				h = {};
			
			h.success = successCallback;
			h.fail = failCallback;
			
			// dispatch the heavy lifting to the worker thread
			this.workerQueue.push(h);

			this.worker.postMessage({
				cmd: "find",
				startX: startX,
				startY: startY,
				endX: endX,
				endY: endY
			});
		}
		else
		{
			// no web worker support, just run on main thread
			if (this.doLongFindPath(startX, startY))
				successCallback();
			else
				failCallback();
		}
	};
		
	pathfinder.prototype.doLongFindPath = function (startX, startY)
	{
		var i, len, c, n, p, lastDir = 8, curDir = -1, addNode;
		for (i = 0, len = this.openList.length; i < len; i++)
			freeNode(this.openList[i]);
		for (i = 0, len = this.closedList.length; i < len; i++)
			freeNode(this.closedList[i]);
		for (i = 0, len = this.pathList.length; i < len; i++)
			freeResultNode(this.pathList[i]);
		this.openList.length = 0;
		this.closedList.length = 0;
		this.closedCache = {};
		this.pathList.length = 0;

		// Add the start node to the open list
		var startNode = allocNode();
		startNode.x = startX;
		startNode.y = startY;

		this.openList.push(startNode);
		var obsLeft = false, obsTop = false, obsRight = false, obsBottom = false;
		var diagonals = this.diagonalsEnabled;
		
		// While there are nodes on the open list
		while (this.openList.length)
		{
			// Move the best F value to closed list
			c = this.openList.shift();
			this.closedList.unshift(c);
			this.closedCache[((c.x << 16) + c.y).toString()] = true;

			// Are we there yet?
			if (c.x === this.targetX && c.y === this.targetY)
			{
				this.pathEnd.parent = c.parent;
				this.pathEnd.x = c.x;
				this.pathEnd.y = c.y;
				
				// Link up the whole path to an indexable array
				p = this.pathEnd;
				
				while (p)
				{
					// filter redundant nodes in straight lines
					if (this.pathList.length === 0)
					{
						addNode = true;
						
						if (p.parent)
						{
							lastDir = this.nodeDirection(p, p.parent);
							curDir = lastDir;
						}
					}
					else if (!p.parent)
						addNode = false;
					else 
					{
						curDir = this.nodeDirection(p, p.parent);
						addNode = (curDir !== lastDir);
					}
					
					if (addNode)
					{
						n = allocResultNode();
						n.x = p.x;
						n.y = p.y;
						this.pathList.unshift(n);
						lastDir = curDir;
					}
					
					p = p.parent;
				}
				
				return true;
			}

			// Get current node
			this.currentNode = c;
			var x = c.x;
			var y = c.y;
			
			var obsLeft = (this.at(x - 1, y) === PF_OBSTACLE);
			var obsTop = (this.at(x, y - 1) === PF_OBSTACLE);
			var obsRight = (this.at(x + 1, y) === PF_OBSTACLE);
			var obsBottom = (this.at(x, y + 1) === PF_OBSTACLE);

			// Check adjacent 8 nodes.  No diagonals allowed if either cell being crossed is obstacle.
			if (!obsLeft)
				this.addCellToOpenList(x - 1, y, 10);

			if (diagonals && !obsLeft && !obsTop)
				this.addCellToOpenList(x - 1, y - 1, 14);

			if (!obsTop)
				this.addCellToOpenList(x, y - 1, 10);

			if (diagonals && !obsTop && !obsRight)
				this.addCellToOpenList(x + 1, y - 1, 14);

			if (!obsRight)
				this.addCellToOpenList(x + 1, y, 10);

			if (diagonals && !obsRight && !obsBottom)
				this.addCellToOpenList(x + 1, y + 1, 14);

			if (!obsBottom)
				this.addCellToOpenList(x, y + 1, 10);

			if (diagonals && !obsBottom && !obsLeft)
				this.addCellToOpenList(x - 1, y + 1, 14);
		}
		
		return false;
	};
	
	pathfinder.prototype.insertToOpenList = function (c)
	{
		var i, len;
		
		// Needs to go at end
		if (c.f >= this.openList[this.openList.length - 1].f)
		{
			this.openList.push(c);
		}
		else
		{
			for (i = 0, len = this.openList.length; i < len; i++)
			{
				if (c.f < this.openList[i].f)
				{
					this.openList.splice(i, 0, c);
					break;
				}
			}
		}
	};
	
	pathfinder.prototype.addCellToOpenList = function (x_, y_, g_)
	{
		// Ignore if cell on closed list
		if (this.closedCache.hasOwnProperty(((x_ << 16) + y_).toString()))
			return;
		
		var i, len, c;
		
		// Cell costs can be increased by changing the number in the map
		var curCellCost = this.at(x_, y_);

		// Is this cell already on the open list?
		for (i = 0, len = this.openList.length; i < len; i++)
		{
			c = this.openList[i];
			
			if (x_ === c.x && y_ === c.y)
			{
				// Is this a better path?
				if (this.currentNode.g + g_ + curCellCost < c.g)
				{
					// Update F, G and H and update parent
					c.parent = this.currentNode;
					c.g = this.currentNode.g + g_ + curCellCost;
					c.h = this.estimateH(c.x, c.y);
					c.f = c.g + c.h;

					// This node's F has changed:  Delete it then re-insert it in the right place

					if (this.openList.length === 1)
					{
						// no need to remove then re-insert same node, just leave it there
						return;
					}
					
					this.openList.splice(i, 1);
					this.insertToOpenList(c);
				}

				return;
			}
		}

		// Not on the open list; add it in the right place
		c = allocNode();
		c.x = x_;
		c.y = y_;
		c.h = this.estimateH(x_, y_);
		c.g = this.currentNode.g + g_ + curCellCost;
		c.f = c.h + c.g;
		c.parent = this.currentNode;

		// Insert this node sorted in the open list
		// The loop below won't add new largest F values
		if (!this.openList.length)
		{
			this.openList.push(c);
			return;
		}
		
		this.insertToOpenList(c);
	};
	
	function quickAbs(x)
	{
		return x < 0 ? -x : x;
	};
	
	pathfinder.prototype.estimateH = function (x_, y_)
	{
		var dx = quickAbs(x_ - this.targetX);
		var dy = quickAbs(y_ - this.targetY);

		return dx * 10 + dy * 10;
	};
	
	pathfinder.prototype.nodeDirection = function (a, b)
	{
		var ax = a.x;
		var ay = a.y;
		var bx = b.x;
		var by = b.y;

		if (ax === bx)
		{
			if (by > ay) return 6;
			if (by < ay) return 2;
			if (ay == by) return 8;
		}
		else if (ay === by)
		{
			if (bx > ax) return 4;
			if (by < ax) return 0;
		}
		else
		{
			if (bx < ax && by < ay) return 1;
			if (bx > ax && by < ay) return 3;
			if (bx < ax && by > ay) return 7;
			if (bx > ax && by > ay) return 5;
		}
		return 8;
	};
	
	if (!isInWebWorker)
	{
		window.PF_CLEAR = PF_CLEAR;
		window.PF_OBSTACLE = PF_OBSTACLE;
		window.Pathfinder = pathfinder;
		
		window.ResultNode = resultNode;
		window.allocResultNode = allocResultNode;
		window.freeResultNode = freeResultNode;
	}

})();
(function() {
'use strict';var cr={plugins_:{},behaviors:{}};"function"!==typeof Object.getPrototypeOf&&(Object.getPrototypeOf="object"===typeof"test".__proto__?function(a){return a.__proto__}:function(a){return a.constructor.prototype});
(function(){function a(a,b){this.x=a;this.y=b;cr.seal(this)}function b(a,b,c,d){this.set(a,b,c,d);cr.seal(this)}function c(){this.bly=this.blx=this.bry=this.brx=this.try_=this.trx=this.tly=this.tlx=0;cr.seal(this)}function d(a,b,c,d){a<b?c<d?(n=a<c?a:c,p=b>d?b:d):(n=a<d?a:d,p=b>c?b:c):c<d?(n=b<c?b:c,p=a>d?a:d):(n=b<d?b:d,p=a>c?a:c)}function e(){this.items=this.s=null;this.item_count=0;s?this.s=new Set:this.items={};this.values_cache=[];this.cache_valid=!0;cr.seal(this)}function h(a){r[t++]=a}function g(){this.sum=
this.t=this.y=this.c=0;cr.seal(this)}function l(a){this.pts_cache=[];this.bboxBottom=this.bboxRight=this.bboxTop=this.bboxLeft=0;this.convexpolys=null;this.set_pts(a);cr.seal(this)}function k(a,b){this.cellwidth=a;this.cellheight=b;this.cells={}}function f(a,b,c){var d;k.prototype.totalCellCount++;return w.length?(d=w.pop(),d.grid=a,d.x=b,d.y=c,d):new cr.GridCell(a,b,c)}function m(a,b,c){this.grid=a;this.x=b;this.y=c;this.objects=new cr.ObjectSet}cr.logexport=function(a){window.console&&window.console.log&&
window.console.log(a)};cr.seal=function(a){return a};cr.freeze=function(a){return a};cr.is_undefined=function(a){return"undefined"===typeof a};cr.is_number=function(a){return"number"===typeof a};cr.is_string=function(a){return"string"===typeof a};cr.isPOT=function(a){return 0<a&&0===(a-1&a)};cr.nextHighestPowerOfTwo=function(a){--a;for(var b=1;32>b;b<<=1)a|=a>>b;return a+1};cr.abs=function(a){return 0>a?-a:a};cr.max=function(a,b){return a>b?a:b};cr.min=function(a,b){return a<b?a:b};cr.PI=Math.PI;
cr.round=function(a){return a+0.5|0};cr.floor=function(a){return 0<=a?a|0:(a|0)-1};cr.ceil=function(a){var b=a|0;return b===a?b:b+1};a.prototype.offset=function(a,b){this.x+=a;this.y+=b;return this};a.prototype.mul=function(a,b){this.x*=a;this.y*=b;return this};cr.vector2=a;cr.segments_intersect=function(a,b,c,d,e,r,h,f){var t,g,k,n;a<c?(g=a,t=c):(g=c,t=a);e<h?(n=e,k=h):(n=h,k=e);if(t<n||g>k)return!1;b<d?(g=b,t=d):(g=d,t=b);r<f?(n=r,k=f):(n=f,k=r);if(t<n||g>k)return!1;t=e-a+h-c;g=r-b+f-d;a=c-a;b=
d-b;e=h-e;r=f-r;f=cr.abs(b*e-r*a);return cr.abs(e*g-r*t)>f?!1:cr.abs(a*g-b*t)<=f};b.prototype.set=function(a,b,c,d){this.left=a;this.top=b;this.right=c;this.bottom=d};b.prototype.copy=function(a){this.left=a.left;this.top=a.top;this.right=a.right;this.bottom=a.bottom};b.prototype.width=function(){return this.right-this.left};b.prototype.height=function(){return this.bottom-this.top};b.prototype.offset=function(a,b){this.left+=a;this.top+=b;this.right+=a;this.bottom+=b;return this};b.prototype.normalize=
function(){var a=0;this.left>this.right&&(a=this.left,this.left=this.right,this.right=a);this.top>this.bottom&&(a=this.top,this.top=this.bottom,this.bottom=a)};b.prototype.intersects_rect=function(a){return!(a.right<this.left||a.bottom<this.top||a.left>this.right||a.top>this.bottom)};b.prototype.intersects_rect_off=function(a,b,c){return!(a.right+b<this.left||a.bottom+c<this.top||a.left+b>this.right||a.top+c>this.bottom)};b.prototype.contains_pt=function(a,b){return a>=this.left&&a<=this.right&&b>=
this.top&&b<=this.bottom};b.prototype.equals=function(a){return this.left===a.left&&this.top===a.top&&this.right===a.right&&this.bottom===a.bottom};cr.rect=b;c.prototype.set_from_rect=function(a){this.tlx=a.left;this.tly=a.top;this.trx=a.right;this.try_=a.top;this.brx=a.right;this.bry=a.bottom;this.blx=a.left;this.bly=a.bottom};c.prototype.set_from_rotated_rect=function(a,b){if(0===b)this.set_from_rect(a);else{var c=Math.sin(b),d=Math.cos(b),e=a.left*c,r=a.top*c,h=a.right*c,c=a.bottom*c,f=a.left*
d,t=a.top*d,g=a.right*d,d=a.bottom*d;this.tlx=f-r;this.tly=t+e;this.trx=g-r;this.try_=t+h;this.brx=g-c;this.bry=d+h;this.blx=f-c;this.bly=d+e}};c.prototype.offset=function(a,b){this.tlx+=a;this.tly+=b;this.trx+=a;this.try_+=b;this.brx+=a;this.bry+=b;this.blx+=a;this.bly+=b;return this};var n=0,p=0;c.prototype.bounding_box=function(a){d(this.tlx,this.trx,this.brx,this.blx);a.left=n;a.right=p;d(this.tly,this.try_,this.bry,this.bly);a.top=n;a.bottom=p};c.prototype.contains_pt=function(a,b){var c=this.trx-
this.tlx,d=this.try_-this.tly,e=this.brx-this.tlx,r=this.bry-this.tly,h=a-this.tlx,f=b-this.tly,t=c*c+d*d,g=c*e+d*r,d=c*h+d*f,k=e*e+r*r,n=e*h+r*f,m=1/(t*k-g*g),c=(k*d-g*n)*m,t=(t*n-g*d)*m;if(0<=c&&0<t&&1>c+t)return!0;c=this.blx-this.tlx;d=this.bly-this.tly;t=c*c+d*d;g=c*e+d*r;d=c*h+d*f;m=1/(t*k-g*g);c=(k*d-g*n)*m;t=(t*n-g*d)*m;return 0<=c&&0<t&&1>c+t};c.prototype.at=function(a,b){if(b)switch(a){case 0:return this.tlx;case 1:return this.trx;case 2:return this.brx;case 3:return this.blx;case 4:return this.tlx;
default:return this.tlx}else switch(a){case 0:return this.tly;case 1:return this.try_;case 2:return this.bry;case 3:return this.bly;case 4:return this.tly;default:return this.tly}};c.prototype.midX=function(){return(this.tlx+this.trx+this.brx+this.blx)/4};c.prototype.midY=function(){return(this.tly+this.try_+this.bry+this.bly)/4};c.prototype.intersects_segment=function(a,b,c,d){if(this.contains_pt(a,b)||this.contains_pt(c,d))return!0;var e,r,h,f,t;for(t=0;4>t;t++)if(e=this.at(t,!0),r=this.at(t,!1),
h=this.at(t+1,!0),f=this.at(t+1,!1),cr.segments_intersect(a,b,c,d,e,r,h,f))return!0;return!1};c.prototype.intersects_quad=function(a){var b=a.midX(),c=a.midY();if(this.contains_pt(b,c))return!0;b=this.midX();c=this.midY();if(a.contains_pt(b,c))return!0;var d,e,r,h,f,t,g,k;for(g=0;4>g;g++)for(k=0;4>k;k++)if(b=this.at(g,!0),c=this.at(g,!1),d=this.at(g+1,!0),e=this.at(g+1,!1),r=a.at(k,!0),h=a.at(k,!1),f=a.at(k+1,!0),t=a.at(k+1,!1),cr.segments_intersect(b,c,d,e,r,h,f,t))return!0;return!1};cr.quad=c;cr.RGB=
function(a,b,c){return Math.max(Math.min(a,255),0)|Math.max(Math.min(b,255),0)<<8|Math.max(Math.min(c,255),0)<<16};cr.GetRValue=function(a){return a&255};cr.GetGValue=function(a){return(a&65280)>>8};cr.GetBValue=function(a){return(a&16711680)>>16};cr.shallowCopy=function(a,b,c){for(var d in b)b.hasOwnProperty(d)&&(a[d]=b[d]);return a};cr.arrayRemove=function(a,b){var c,d;b=cr.floor(b);if(!(0>b||b>=a.length))if(0===b)a.shift();else if(b===a.length-1)a.pop();else{c=b;for(d=a.length-1;c<d;c++)a[c]=a[c+
1];a.length=d}};cr.shallowAssignArray=function(a,b){a.length=b.length;var c,d;c=0;for(d=b.length;c<d;c++)a[c]=b[c]};cr.appendArray=function(a,b){a.push.apply(a,b)};cr.arrayFindRemove=function(a,b){var c=a.indexOf(b);-1!==c&&cr.arrayRemove(a,c)};cr.clamp=function(a,b,c){return a<b?b:a>c?c:a};cr.to_radians=function(a){return a/(180/cr.PI)};cr.to_degrees=function(a){return a*(180/cr.PI)};cr.clamp_angle_degrees=function(a){a%=360;0>a&&(a+=360);return a};cr.clamp_angle=function(a){a%=2*cr.PI;0>a&&(a+=
2*cr.PI);return a};cr.to_clamped_degrees=function(a){return cr.clamp_angle_degrees(cr.to_degrees(a))};cr.to_clamped_radians=function(a){return cr.clamp_angle(cr.to_radians(a))};cr.angleTo=function(a,b,c,d){return Math.atan2(d-b,c-a)};cr.angleDiff=function(a,b){if(a===b)return 0;var c=Math.sin(a),d=Math.cos(a),e=Math.sin(b),r=Math.cos(b),c=c*e+d*r;return 1<=c?0:-1>=c?cr.PI:Math.acos(c)};cr.angleRotate=function(a,b,c){var d=Math.sin(a),e=Math.cos(a),r=Math.sin(b),h=Math.cos(b);return Math.acos(d*r+
e*h)>c?0<e*r-d*h?cr.clamp_angle(a+c):cr.clamp_angle(a-c):cr.clamp_angle(b)};cr.angleClockwise=function(a,b){var c=Math.sin(a),d=Math.cos(a),e=Math.sin(b),r=Math.cos(b);return 0>=d*e-c*r};cr.rotatePtAround=function(a,b,c,d,e,r){if(0===c)return r?a:b;var h=Math.sin(c);c=Math.cos(c);a-=d;b-=e;var f=a*h;a=a*c-b*h;b=b*c+f;return r?a+d:b+e};cr.distanceTo=function(a,b,c,d){a=c-a;b=d-b;return Math.sqrt(a*a+b*b)};cr.xor=function(a,b){return!a!==!b};cr.lerp=function(a,b,c){return a+(b-a)*c};cr.hasAnyOwnProperty=
function(a){for(var b in a)if(a.hasOwnProperty(b))return!0;return!1};cr.wipe=function(a){for(var b in a)a.hasOwnProperty(b)&&delete a[b]};var q=+new Date;cr.performance_now=function(){if("undefined"!==typeof window.performance){var a=window.performance;if("undefined"!==typeof a.now)return a.now();if("undefined"!==typeof a.webkitNow)return a.webkitNow();if("undefined"!==typeof a.mozNow)return a.mozNow();if("undefined"!==typeof a.msNow)return a.msNow()}return Date.now()-q};var s="undefined"!==typeof Set&&
"undefined"!==typeof Set.prototype.forEach;e.prototype.contains=function(a){return s?this.s.has(a):this.items.hasOwnProperty(a.toString())};e.prototype.add=function(a){if(s)this.s.has(a)||(this.s.add(a),this.cache_valid=!1);else{var b=a.toString();this.items.hasOwnProperty(b)||(this.items[b]=a,this.item_count++,this.cache_valid=!1)}return this};e.prototype.remove=function(a){s?this.s.has(a)&&(this.s["delete"](a),this.cache_valid=!1):(a=a.toString(),this.items.hasOwnProperty(a)&&(delete this.items[a],
this.item_count--,this.cache_valid=!1));return this};e.prototype.clear=function(){s?this.s.clear():(this.items={},this.item_count=0);this.values_cache.length=0;this.cache_valid=!0;return this};e.prototype.isEmpty=function(){return s?0===this.s.size:0===this.item_count};e.prototype.count=function(){return s?this.s.size:this.item_count};var r=null,t=0;e.prototype.update_cache=function(){if(!this.cache_valid){if(s)this.values_cache.length=this.s.size,r=this.values_cache,t=0,this.s.forEach(h),r=null,
t=0;else{this.values_cache.length=this.item_count;var a,b=0;for(a in this.items)this.items.hasOwnProperty(a)&&(this.values_cache[b++]=this.items[a])}this.cache_valid=!0}};e.prototype.values=function(){this.update_cache();return this.values_cache.slice(0)};e.prototype.valuesRef=function(){this.update_cache();return this.values_cache};cr.ObjectSet=e;g.prototype.add=function(a){this.y=a-this.c;this.t=this.sum+this.y;this.c=this.t-this.sum-this.y;this.sum=this.t};g.prototype.reset=function(){this.sum=
this.t=this.y=this.c=0};cr.KahanAdder=g;cr.regexp_escape=function(a){return a.replace(/[-[\]{}()*+?.,\\^$|#\s]/g,"\\$&")};l.prototype.set_pts=function(a){this.pts_array=a;this.pts_count=a.length/2;this.pts_cache.length=a.length;this.cache_height=this.cache_width=-1;this.cache_angle=0};l.prototype.is_empty=function(){return!this.pts_array.length};l.prototype.update_bbox=function(){for(var a=this.pts_cache,b=a[0],c=b,d=a[1],e=d,r,h,f=1,t=this.pts_count;f<t;++f)h=2*f,r=a[h],h=a[h+1],r<b&&(b=r),r>c&&
(c=r),h<d&&(d=h),h>e&&(e=h);this.bboxLeft=b;this.bboxRight=c;this.bboxTop=d;this.bboxBottom=e};l.prototype.set_from_rect=function(a,b,c){this.pts_cache.length=8;this.pts_count=4;var d=this.pts_cache;d[0]=a.left-b;d[1]=a.top-c;d[2]=a.right-b;d[3]=a.top-c;d[4]=a.right-b;d[5]=a.bottom-c;d[6]=a.left-b;d[7]=a.bottom-c;this.cache_width=a.right-a.left;this.cache_height=a.bottom-a.top;this.update_bbox()};l.prototype.set_from_quad=function(a,b,c,d,e){this.pts_cache.length=8;this.pts_count=4;var r=this.pts_cache;
r[0]=a.tlx-b;r[1]=a.tly-c;r[2]=a.trx-b;r[3]=a.try_-c;r[4]=a.brx-b;r[5]=a.bry-c;r[6]=a.blx-b;r[7]=a.bly-c;this.cache_width=d;this.cache_height=e;this.update_bbox()};l.prototype.set_from_poly=function(a){this.pts_count=a.pts_count;cr.shallowAssignArray(this.pts_cache,a.pts_cache);this.bboxLeft=a.bboxLeft;this.bboxTop-a.bboxTop;this.bboxRight=a.bboxRight;this.bboxBottom=a.bboxBottom};l.prototype.cache_poly=function(a,b,c){if(this.cache_width!==a||this.cache_height!==b||this.cache_angle!==c){this.cache_width=
a;this.cache_height=b;this.cache_angle=c;var d,e,r,h,f,t=0,g=1,k=this.pts_array,n=this.pts_cache;0!==c&&(t=Math.sin(c),g=Math.cos(c));c=0;for(r=this.pts_count;c<r;c++)d=2*c,e=d+1,h=k[d]*a,f=k[e]*b,n[d]=h*g-f*t,n[e]=f*g+h*t;this.update_bbox()}};l.prototype.contains_pt=function(a,b){var c=this.pts_cache;if(a===c[0]&&b===c[1])return!0;var d,e,r,h=this.pts_count,f=this.bboxLeft-110,t=this.bboxTop-101,g=this.bboxRight+131,k=this.bboxBottom+120,n,m,q=0,l=0;for(d=0;d<h;d++)e=2*d,r=2*((d+1)%h),n=c[e],e=c[e+
1],m=c[r],r=c[r+1],cr.segments_intersect(f,t,a,b,n,e,m,r)&&q++,cr.segments_intersect(g,k,a,b,n,e,m,r)&&l++;return 1===q%2||1===l%2};l.prototype.intersects_poly=function(a,b,c){var d=a.pts_cache,e=this.pts_cache;if(this.contains_pt(d[0]+b,d[1]+c)||a.contains_pt(e[0]-b,e[1]-c))return!0;var r,h,f,t,g,k,n,m,q,l,w,A;r=0;for(t=this.pts_count;r<t;r++)for(h=2*r,f=2*((r+1)%t),m=e[h],h=e[h+1],q=e[f],l=e[f+1],f=0,n=a.pts_count;f<n;f++)if(g=2*f,k=2*((f+1)%n),w=d[g]+b,g=d[g+1]+c,A=d[k]+b,k=d[k+1]+c,cr.segments_intersect(m,
h,q,l,w,g,A,k))return!0;return!1};l.prototype.intersects_segment=function(a,b,c,d,e,r){var h=this.pts_cache;if(this.contains_pt(c-a,d-b))return!0;var f,t,g,k,n,m;f=0;for(t=this.pts_count;f<t;f++)if(g=2*f,k=2*((f+1)%t),n=h[g]+a,g=h[g+1]+b,m=h[k]+a,k=h[k+1]+b,cr.segments_intersect(c,d,e,r,n,g,m,k))return!0;return!1};l.prototype.mirror=function(a){var b,c,d;b=0;for(c=this.pts_count;b<c;++b)d=2*b,this.pts_cache[d]=2*a-this.pts_cache[d]};l.prototype.flip=function(a){var b,c,d;b=0;for(c=this.pts_count;b<
c;++b)d=2*b+1,this.pts_cache[d]=2*a-this.pts_cache[d]};l.prototype.diag=function(){var a,b,c,d,e;a=0;for(b=this.pts_count;a<b;++a)c=2*a,d=c+1,e=this.pts_cache[c],this.pts_cache[c]=this.pts_cache[d],this.pts_cache[d]=e};cr.CollisionPoly=l;k.prototype.totalCellCount=0;k.prototype.getCell=function(a,b,c){var d;d=this.cells[a];return d?(d=d[b])?d:c?(d=f(this,a,b),this.cells[a][b]=d):null:c?(d=f(this,a,b),this.cells[a]={},this.cells[a][b]=d):null};k.prototype.XToCell=function(a){return cr.floor(a/this.cellwidth)};
k.prototype.YToCell=function(a){return cr.floor(a/this.cellheight)};k.prototype.update=function(a,b,c){var d,e,r,h,f;if(b)for(d=b.left,e=b.right;d<=e;++d)for(r=b.top,h=b.bottom;r<=h;++r)if(!c||!c.contains_pt(d,r))if(f=this.getCell(d,r,!1))f.remove(a),f.isEmpty()&&(k.prototype.totalCellCount--,f.objects.clear(),1E3>w.length&&w.push(f),this.cells[d][r]=null);if(c)for(d=c.left,e=c.right;d<=e;++d)for(r=c.top,h=c.bottom;r<=h;++r)b&&b.contains_pt(d,r)||this.getCell(d,r,!0).insert(a)};k.prototype.queryRange=
function(a,b){var c,d,e,r,h,f;c=this.XToCell(a.left);e=this.YToCell(a.top);d=this.XToCell(a.right);for(h=this.YToCell(a.bottom);c<=d;++c)for(r=e;r<=h;++r)(f=this.getCell(c,r,!1))&&f.dump(b)};cr.SparseGrid=k;var w=[];m.prototype.isEmpty=function(){return this.objects.isEmpty()};m.prototype.insert=function(a){this.objects.add(a)};m.prototype.remove=function(a){this.objects.remove(a)};m.prototype.dump=function(a){cr.appendArray(a,this.objects.valuesRef())};cr.GridCell=m;var A="lighter xor copy destination-over source-in destination-in source-out destination-out source-atop destination-atop".split(" ");
cr.effectToCompositeOp=function(a){return 0>=a||11<=a?"source-over":A[a-1]};cr.setGLBlend=function(a,b,c){if(c)switch(a.srcBlend=c.ONE,a.destBlend=c.ONE_MINUS_SRC_ALPHA,b){case 1:a.srcBlend=c.ONE;a.destBlend=c.ONE;break;case 3:a.srcBlend=c.ONE;a.destBlend=c.ZERO;break;case 4:a.srcBlend=c.ONE_MINUS_DST_ALPHA;a.destBlend=c.ONE;break;case 5:a.srcBlend=c.DST_ALPHA;a.destBlend=c.ZERO;break;case 6:a.srcBlend=c.ZERO;a.destBlend=c.SRC_ALPHA;break;case 7:a.srcBlend=c.ONE_MINUS_DST_ALPHA;a.destBlend=c.ZERO;
break;case 8:a.srcBlend=c.ZERO;a.destBlend=c.ONE_MINUS_SRC_ALPHA;break;case 9:a.srcBlend=c.DST_ALPHA;a.destBlend=c.ONE_MINUS_SRC_ALPHA;break;case 10:a.srcBlend=c.ONE_MINUS_DST_ALPHA,a.destBlend=c.SRC_ALPHA}};cr.round6dp=function(a){return cr.round(1E6*a)/1E6};cr.equals_nocase=function(a,b){return"string"!==typeof a||"string"!==typeof b||a.length!==b.length?!1:a===b?!0:a.toLowerCase()===b.toLowerCase()}})();
(function(){function a(a){if(a&&(a.getContext||a.dc)&&!a.c2runtime){a.c2runtime=this;var b=this;this.isCrosswalk=/crosswalk/i.test(navigator.userAgent)||/xwalk/i.test(navigator.userAgent)||!("undefined"===typeof window.c2isCrosswalk||!window.c2isCrosswalk);this.isPhoneGap=!this.isCrosswalk&&"undefined"!==typeof window.device&&("undefined"!==typeof window.device.cordova||"undefined"!==typeof window.device.phonegap);this.isDirectCanvas=!!a.dc;this.isAppMobi="undefined"!==typeof window.AppMobi||this.isDirectCanvas;
if(this.isCocoonJs=!!window.c2cocoonjs)CocoonJS.App.onSuspended.addEventListener(function(){b.setSuspended(!0)}),CocoonJS.App.onActivated.addEventListener(function(){b.setSuspended(!1)});this.isDomFree=this.isDirectCanvas||this.isCocoonJs;this.isTizen=/tizen/i.test(navigator.userAgent);this.isAndroid=/android/i.test(navigator.userAgent)&&!this.isTizen;this.isIE=/msie/i.test(navigator.userAgent)||/trident/i.test(navigator.userAgent);this.isiPhone=/iphone/i.test(navigator.userAgent)||/ipod/i.test(navigator.userAgent);
this.isiPad=/ipad/i.test(navigator.userAgent);this.isiOS=this.isiPhone||this.isiPad;this.isChrome=/chrome/i.test(navigator.userAgent)||/chromium/i.test(navigator.userAgent);this.isAmazonWebApp=/amazonwebappplatform/i.test(navigator.userAgent);this.isFirefox=/firefox/i.test(navigator.userAgent);this.isSafari=!this.isChrome&&/safari/i.test(navigator.userAgent);this.isWindows=/windows/i.test(navigator.userAgent);this.isNodeWebkit="undefined"!==typeof window.c2nodewebkit||/nodewebkit/i.test(navigator.userAgent);
this.isArcade="undefined"!==typeof window.is_scirra_arcade;this.isWindows8App=!("undefined"===typeof window.c2isWindows8||!window.c2isWindows8);this.isWindowsPhone8=!("undefined"===typeof window.c2isWindowsPhone8||!window.c2isWindowsPhone8);this.isBlackberry10=!("undefined"===typeof window.c2isBlackberry10||!window.c2isBlackberry10);this.isAndroidStockBrowser=this.isAndroid&&!this.isChrome&&!this.isFirefox&&!this.isAmazonWebApp&&!this.isDomFree;this.devicePixelRatio=1;this.isMobile=this.isPhoneGap||
this.isCrosswalk||this.isAppMobi||this.isCocoonJs||this.isAndroid||this.isiOS||this.isWindowsPhone8||this.isBlackberry10||this.isTizen;this.isMobile||(this.isMobile=/(blackberry|bb10|playbook|palm|symbian|nokia|windows\s+ce|phone|mobile|tablet)/i.test(navigator.userAgent));"undefined"===typeof cr_is_preview||this.isNodeWebkit||"?nw"!==window.location.search&&!/nodewebkit/i.test(navigator.userAgent)||(this.isNodeWebkit=!0);this.isDebug="undefined"!==typeof cr_is_preview&&-1<window.location.search.indexOf("debug");
this.canvas=a;this.canvasdiv=document.getElementById("c2canvasdiv");this.ctx=this.glwrap=this.gl=null;this.fullscreenOldMarginCss="";this.firstInFullscreen=!1;this.oldHeight=this.oldWidth=0;this.canvas.oncontextmenu=function(a){a.preventDefault&&a.preventDefault();return!1};this.canvas.onselectstart=function(a){a.preventDefault&&a.preventDefault();return!1};this.isDirectCanvas&&(window.c2runtime=this);this.isNodeWebkit&&(window.ondragover=function(a){a.preventDefault();return!1},window.ondrop=function(a){a.preventDefault();
return!1},require("nw.gui").App.clearCache());this.width=a.width;this.height=a.height;this.draw_width=this.width;this.draw_height=this.height;this.cssWidth=this.width;this.cssHeight=this.height;this.lastWindowWidth=window.innerWidth;this.lastWindowHeight=window.innerHeight;this.redraw=!0;this.isSuspended=!1;Date.now||(Date.now=function(){return+new Date});this.plugins=[];this.types={};this.types_by_index=[];this.behaviors=[];this.layouts={};this.layouts_by_index=[];this.eventsheets={};this.eventsheets_by_index=
[];this.wait_for_textures=[];this.triggers_to_postinit=[];this.all_global_vars=[];this.all_local_vars=[];this.jumpthruBehavior=this.solidBehavior=null;this.deathRow=new cr.ObjectSet;this.isInClearDeathRow=!1;this.isInOnDestroy=0;this.isRunningEvents=!1;this.createRow=[];this.isLoadingState=!1;this.lastSaveJson=this.loadFromJson=this.loadFromSlot=this.saveToSlot="";this.suspendDrawing=this.signalledContinuousPreview=!1;this.zeroDtCount=this.cpuutilisation=this.logictime=this.dt1=this.dt=0;this.timescale=
1;this.kahanTime=new cr.KahanAdder;this.last_tick_time=0;this.measuring_dt=!0;this.objectcount=this.framecount=this.execcount=this.tickcount=this.last_fps_time=this.fps=0;this.changelayout=null;this.destroycallbacks=[];this.event_stack=[];this.event_stack_index=-1;this.localvar_stack=[[]];this.trigger_depth=this.localvar_stack_index=0;this.pushEventStack(null);this.loop_stack=[];this.loop_stack_index=-1;this.next_puid=this.next_uid=0;this.layout_first_tick=!0;this.family_count=0;this.suspend_events=
[];this.timeout_id=this.raf_id=0;this.isloading=!0;this.loadingprogress=0;this.isNodeFullscreen=!1;this.stackLocalCount=0;this.halfFramerateMode=!1;this.lastRafTime=0;this.isInUserInputEvent=this.had_a_click=this.ranLastRaf=!1;this.objects_to_tick=new cr.ObjectSet;this.objects_to_tick2=new cr.ObjectSet;this.registered_collisions=[];this.temp_poly=new cr.CollisionPoly([]);this.temp_poly2=new cr.CollisionPoly([]);this.allGroups=[];this.activeGroups={};this.cndsBySid={};this.actsBySid={};this.varsBySid=
{};this.blocksBySid={};this.layout_ctx=this.layout_canvas=this.layout_tex=this.layer_tex=this.layer_ctx=this.layer_canvas=this.running_layout=null;this.uses_background_blending=this.is_WebGL_context_lost=!1;this.fx_tex=[null,null];this.fullscreen_scaling=0;this.files_subfolder="";this.objectsByUid={};this.snapshotCanvas=this.loaderlogo=null;this.snapshotData="";this.load();this.devicePixelRatio=(this.isRetina=!this.isDomFree&&this.useHighDpi&&!this.isAndroidStockBrowser)?window.devicePixelRatio||
window.webkitDevicePixelRatio||window.mozDevicePixelRatio||window.msDevicePixelRatio||1:1;this.ClearDeathRow();var c,d=this.alphaBackground&&!(this.isNodeWebkit||this.isWindows8App||this.isWindowsPhone8);0<this.fullscreen_mode&&this.setSize(window.innerWidth,window.innerHeight,!0);try{!this.enableWebGL||!this.isCocoonJs&&this.isDomFree||(c={alpha:d,depth:!1,antialias:!1,failIfMajorPerformanceCaveat:!0},this.gl=a.getContext("webgl",c)||a.getContext("experimental-webgl",c))}catch(e){}if(this.gl){this.isDomFree||
(this.overlay_canvas=document.createElement("canvas"),jQuery(this.overlay_canvas).appendTo(this.canvas.parentNode),this.overlay_canvas.oncontextmenu=function(a){return!1},this.overlay_canvas.onselectstart=function(a){return!1},this.overlay_canvas.width=this.cssWidth,this.overlay_canvas.height=this.cssHeight,jQuery(this.overlay_canvas).css({width:this.cssWidth+"px",height:this.cssHeight+"px"}),this.positionOverlayCanvas(),this.overlay_ctx=this.overlay_canvas.getContext("2d"));this.glwrap=new cr.GLWrap(this.gl,
this.isMobile);this.glwrap.setSize(a.width,a.height);this.ctx=null;this.canvas.addEventListener("webglcontextlost",function(a){a.preventDefault();b.onContextLost();console.log("[Construct 2] WebGL context lost");window.cr_setSuspended(!0)},!1);this.canvas.addEventListener("webglcontextrestored",function(a){b.glwrap.initState();b.glwrap.setSize(b.glwrap.width,b.glwrap.height,!0);b.layer_tex=null;b.layout_tex=null;b.fx_tex[0]=null;b.fx_tex[1]=null;b.onContextRestored();b.redraw=!0;console.log("[Construct 2] WebGL context restored");
window.cr_setSuspended(!1)},!1);var h,f,g,k,n,m;a=0;for(c=this.types_by_index.length;a<c;a++)for(f=this.types_by_index[a],d=0,h=f.effect_types.length;d<h;d++)k=f.effect_types[d],k.shaderindex=this.glwrap.getShaderIndex(k.id),this.uses_background_blending=this.uses_background_blending||this.glwrap.programUsesDest(k.shaderindex);a=0;for(c=this.layouts_by_index.length;a<c;a++){n=this.layouts_by_index[a];d=0;for(h=n.effect_types.length;d<h;d++)k=n.effect_types[d],k.shaderindex=this.glwrap.getShaderIndex(k.id);
d=0;for(h=n.layers.length;d<h;d++)for(m=n.layers[d],f=0,g=m.effect_types.length;f<g;f++)k=m.effect_types[f],k.shaderindex=this.glwrap.getShaderIndex(k.id),this.uses_background_blending=this.uses_background_blending||this.glwrap.programUsesDest(k.shaderindex)}}else{if(0<this.fullscreen_mode&&this.isDirectCanvas){this.canvas=null;document.oncontextmenu=function(a){return!1};document.onselectstart=function(a){return!1};this.ctx=AppMobi.canvas.getContext("2d");try{this.ctx.samplingMode=this.linearSampling?
"smooth":"sharp",this.ctx.globalScale=1,this.ctx.HTML5CompatibilityMode=!0,this.ctx.imageSmoothingEnabled=this.linearSampling}catch(q){}0!==this.width&&0!==this.height&&(this.ctx.width=this.width,this.ctx.height=this.height)}this.ctx||(c=this.isCocoonJs?{antialias:!!this.linearSampling,alpha:d}:{alpha:d},this.ctx=a.getContext("2d",c),this.ctx.webkitImageSmoothingEnabled=this.linearSampling,this.ctx.mozImageSmoothingEnabled=this.linearSampling,this.ctx.msImageSmoothingEnabled=this.linearSampling,this.ctx.imageSmoothingEnabled=
this.linearSampling);this.overlay_ctx=this.overlay_canvas=null}this.tickFunc=function(){b.tick()};window==window.top||this.isDomFree||this.isWindows8App||(document.addEventListener("mousedown",function(){window.focus()},!0),document.addEventListener("touchstart",function(){window.focus()},!0));"undefined"!==typeof cr_is_preview&&(this.isCocoonJs&&console.log("[Construct 2] In preview-over-wifi via CocoonJS mode"),-1<window.location.search.indexOf("continuous")&&(cr.logexport("Reloading for continuous preview"),
this.loadFromSlot="__c2_continuouspreview",this.suspendDrawing=!0),this.pauseOnBlur&&!this.isMobile&&(jQuery(window).focus(function(){b.setSuspended(!1)}),jQuery(window).blur(function(){b.setSuspended(!0)})));0===this.fullscreen_mode&&this.isRetina&&1<this.devicePixelRatio&&this.setSize(this.original_width,this.original_height,!0);this.tryLockOrientation();this.go();this.extra={};cr.seal(this)}}function b(a){a.target.result.createObjectStore("saves",{keyPath:"slot"})}function c(a,c,d,e){var h=indexedDB.open("_C2SaveStates");
h.onupgradeneeded=b;h.onerror=e;h.onsuccess=function(b){b=b.target.result;b.onerror=e;b.transaction(["saves"],"readwrite").objectStore("saves").put({slot:a,data:c}).onsuccess=d}}function d(a,c,d){var e=indexedDB.open("_C2SaveStates");e.onupgradeneeded=b;e.onerror=d;e.onsuccess=function(b){b=b.target.result;b.onerror=d;var e=b.transaction(["saves"]).objectStore("saves").get(a);e.onsuccess=function(a){e.result?c(e.result.data):c(null)}}}function e(){cr.logexport("Reloading for continuous preview");
window.c2cocoonjs?CocoonJS.App.reload():-1<window.location.search.indexOf("continuous")?window.location.reload(!0):window.location+="?continuous"}function h(a){var b,c={};for(b in a)!a.hasOwnProperty(b)||a[b]instanceof cr.ObjectSet||a[b]&&"undefined"!==typeof a[b].c2userdata||(c[b]=a[b]);return c}a.prototype.setSize=function(a,b,c){var d=0,e=0,h=0,f=0,f=0;if(this.lastWindowWidth!==a||this.lastWindowHeight!==b||c){this.lastWindowWidth=a;this.lastWindowHeight=b;var g=this.fullscreen_mode,k=document.mozFullScreen||
document.webkitIsFullScreen||!!document.msFullscreenElement||document.fullScreen||this.isNodeFullscreen;if(k||0!==this.fullscreen_mode||c)k&&0<this.fullscreen_scaling&&(g=this.fullscreen_scaling),4<=g?(c=this.original_width/this.original_height,a/b>c?(h=b*c,5===g?(f=h/this.original_width,1<f?f=Math.floor(f):1>f&&(f=1/Math.ceil(1/f)),h=this.original_width*f,f*=this.original_height,d=(a-h)/2,e=(b-f)/2,a=h,b=f):(d=(a-h)/2,a=h)):(f=a/c,5===g?(f/=this.original_height,1<f?f=Math.floor(f):1>f&&(f=1/Math.ceil(1/
f)),h=this.original_width*f,f*=this.original_height,d=(a-h)/2,e=(b-f)/2,a=h):e=(b-f)/2,b=f),k&&!this.isNodeWebkit&&(e=d=0),d=Math.floor(d),e=Math.floor(e),a=Math.floor(a),b=Math.floor(b)):this.isNodeWebkit&&this.isNodeFullscreen&&0===this.fullscreen_mode_set&&(d=Math.floor((a-this.original_width)/2),e=Math.floor((b-this.original_height)/2),a=this.original_width,b=this.original_height),2>g&&(this.aspect_scale=this.devicePixelRatio),this.isRetina&&this.isiPad&&1<this.devicePixelRatio&&(1024<=a&&(a=
1023),1024<=b&&(b=1023)),k=this.devicePixelRatio,this.cssWidth=a,this.cssHeight=b,this.width=Math.round(a*k),this.height=Math.round(b*k),this.redraw=!0,this.wantFullscreenScalingQuality?(this.draw_width=this.width,this.draw_height=this.height,this.fullscreenScalingQuality=!0):this.width<this.original_width&&this.height<this.original_height||1===g?(this.draw_width=this.width,this.draw_height=this.height,this.fullscreenScalingQuality=!0):(this.draw_width=this.original_width,this.draw_height=this.original_height,
this.fullscreenScalingQuality=!1,2===g?(c=this.original_width/this.original_height,g=this.lastWindowWidth/this.lastWindowHeight,g<c?this.draw_width=this.draw_height*g:g>c&&(this.draw_height=this.draw_width/g)):3===g&&(c=this.original_width/this.original_height,g=this.lastWindowWidth/this.lastWindowHeight,g>c?this.draw_width=this.draw_height*g:g<c&&(this.draw_height=this.draw_width/g))),this.canvasdiv&&!this.isDomFree&&(jQuery(this.canvasdiv).css({width:a+"px",height:b+"px","margin-left":d,"margin-top":e}),
"undefined"!==typeof cr_is_preview&&jQuery("#borderwrap").css({width:a+"px",height:b+"px"})),this.canvas&&(this.canvas.width=Math.round(a*k),this.canvas.height=Math.round(b*k),this.isRetina&&jQuery(this.canvas).css({width:a+"px",height:b+"px"})),this.overlay_canvas&&(this.overlay_canvas.width=a,this.overlay_canvas.height=b,jQuery(this.overlay_canvas).css({width:a+"px",height:b+"px"})),this.glwrap&&this.glwrap.setSize(Math.round(a*k),Math.round(b*k)),this.isDirectCanvas&&this.ctx&&(this.ctx.width=
a,this.ctx.height=b),this.ctx&&(this.ctx.webkitImageSmoothingEnabled=this.linearSampling,this.ctx.mozImageSmoothingEnabled=this.linearSampling,this.ctx.msImageSmoothingEnabled=this.linearSampling,this.ctx.imageSmoothingEnabled=this.linearSampling),this.tryLockOrientation()}};a.prototype.tryLockOrientation=function(){if(this.autoLockOrientation&&0!==this.orientations){var a="portrait";2===this.orientations&&(a="landscape");screen.lockOrientation?screen.lockOrientation(a):screen.webkitLockOrientation?
screen.webkitLockOrientation(a):screen.mozLockOrientation?screen.mozLockOrientation(a):screen.msLockOrientation&&screen.msLockOrientation(a)}};a.prototype.onContextLost=function(){this.is_WebGL_context_lost=!0;var a,b,c;a=0;for(b=this.types_by_index.length;a<b;a++)if(c=this.types_by_index[a],c.onLostWebGLContext)c.onLostWebGLContext()};a.prototype.onContextRestored=function(){this.is_WebGL_context_lost=!1;var a,b,c;a=0;for(b=this.types_by_index.length;a<b;a++)if(c=this.types_by_index[a],c.onRestoreWebGLContext)c.onRestoreWebGLContext()};
a.prototype.positionOverlayCanvas=function(){if(!this.isDomFree){var a=document.mozFullScreen||document.webkitIsFullScreen||document.fullScreen||document.msFullscreenElement||this.isNodeFullscreen?jQuery(this.canvas).offset():jQuery(this.canvas).position();a.position="absolute";jQuery(this.overlay_canvas).css(a)}};var g=window.cancelAnimationFrame||window.mozCancelAnimationFrame||window.webkitCancelAnimationFrame||window.msCancelAnimationFrame||window.oCancelAnimationFrame;a.prototype.setSuspended=
function(a){var b;if(a&&!this.isSuspended)for(cr.logexport("[Construct 2] Suspending"),this.isSuspended=!0,0!==this.raf_id&&g&&g(this.raf_id),0!==this.timeout_id&&clearTimeout(this.timeout_id),a=0,b=this.suspend_events.length;a<b;a++)this.suspend_events[a](!0);else if(!a&&this.isSuspended){cr.logexport("[Construct 2] Resuming");this.isSuspended=!1;this.last_tick_time=cr.performance_now();this.last_fps_time=cr.performance_now();a=this.logictime=this.framecount=0;for(b=this.suspend_events.length;a<
b;a++)this.suspend_events[a](!1);this.tick()}};a.prototype.addSuspendCallback=function(a){this.suspend_events.push(a)};a.prototype.load=function(){var a=cr.getProjectModel();this.name=a[0];this.first_layout=a[1];this.fullscreen_mode=a[11];this.fullscreen_mode_set=a[11];this.original_width=a[9];this.original_height=a[10];this.isDomFree&&(4<=a[11]||0===a[11])&&(cr.logexport("[Construct 2] Letterbox scale fullscreen modes are not supported on this platform - falling back to 'Scale outer'"),this.fullscreen_mode_set=
this.fullscreen_mode=3);this.uses_loader_layout=a[17];this.loaderstyle=a[18];0===this.loaderstyle&&(this.loaderlogo=new Image,this.loaderlogo.src="loading-logo.png");this.next_uid=a[20];this.system=new cr.system_object(this);var b,c,d,e,f,h,g,k,n;b=0;for(c=a[2].length;b<c;b++){g=a[2][b];cr.add_common_aces(g);n=new g[0](this);n.singleglobal=g[1];n.is_world=g[2];n.must_predraw=g[9];if(n.onCreate)n.onCreate();cr.seal(n);this.plugins.push(n)}a=cr.getProjectModel();b=0;for(c=a[3].length;b<c;b++){g=a[3][b];
f=g[1];n=null;d=0;for(e=this.plugins.length;d<e;d++)if(this.plugins[d]instanceof f){n=this.plugins[d];break}var m=new n.Type(n);m.name=g[0];m.is_family=g[2];m.instvar_sids=g[3].slice(0);m.vars_count=g[3].length;m.behs_count=g[4];m.fx_count=g[5];m.sid=g[11];m.is_family?(m.members=[],m.family_index=this.family_count++,m.families=null):(m.members=null,m.family_index=-1,m.families=[]);m.family_var_map=null;m.family_beh_map=null;m.family_fx_map=null;m.is_contained=!1;m.container=null;g[6]?(m.texture_file=
g[6][0],m.texture_filesize=g[6][1],m.texture_pixelformat=g[6][2]):(m.texture_file=null,m.texture_filesize=0,m.texture_pixelformat=0);m.animations=g[7]?g[7]:null;m.index=b;m.instances=[];m.deadCache=[];m.solstack=[new cr.selection(m)];m.cur_sol=0;m.default_instance=null;m.stale_iids=!0;m.updateIIDs=cr.type_updateIIDs;m.getFirstPicked=cr.type_getFirstPicked;m.getPairedInstance=cr.type_getPairedInstance;m.getCurrentSol=cr.type_getCurrentSol;m.pushCleanSol=cr.type_pushCleanSol;m.pushCopySol=cr.type_pushCopySol;
m.popSol=cr.type_popSol;m.getBehaviorByName=cr.type_getBehaviorByName;m.getBehaviorIndexByName=cr.type_getBehaviorIndexByName;m.getEffectIndexByName=cr.type_getEffectIndexByName;m.applySolToContainer=cr.type_applySolToContainer;m.getInstanceByIID=cr.type_getInstanceByIID;m.collision_grid=new cr.SparseGrid(this.original_width,this.original_height);m.any_bbox_changed=!0;m.any_instance_parallaxed=!1;m.extra={};m.toString=cr.type_toString;m.behaviors=[];d=0;for(e=g[8].length;d<e;d++){k=g[8][d];var q=
k[1],l=null;f=0;for(h=this.behaviors.length;f<h;f++)if(this.behaviors[f]instanceof q){l=this.behaviors[f];break}if(!l){l=new q(this);l.my_types=[];l.my_instances=new cr.ObjectSet;if(l.onCreate)l.onCreate();cr.seal(l);this.behaviors.push(l);cr.behaviors.solid&&l instanceof cr.behaviors.solid&&(this.solidBehavior=l);cr.behaviors.jumpthru&&l instanceof cr.behaviors.jumpthru&&(this.jumpthruBehavior=l)}-1===l.my_types.indexOf(m)&&l.my_types.push(m);f=new l.Type(l,m);f.name=k[0];f.sid=k[2];f.onCreate();
cr.seal(f);m.behaviors.push(f)}m.global=g[9];m.isOnLoaderLayout=g[10];m.effect_types=[];d=0;for(e=g[12].length;d<e;d++)m.effect_types.push({id:g[12][d][0],name:g[12][d][1],shaderindex:-1,active:!0,index:d});m.tile_poly_data=g[13];if(!this.uses_loader_layout||m.is_family||m.isOnLoaderLayout||!n.is_world)m.onCreate(),cr.seal(m);m.name&&(this.types[m.name]=m);this.types_by_index.push(m);n.singleglobal&&(d=new n.Instance(m),d.uid=this.next_uid++,d.puid=this.next_puid++,d.iid=0,d.get_iid=cr.inst_get_iid,
d.toString=cr.inst_toString,d.properties=g[14],d.onCreate(),cr.seal(d),m.instances.push(d),this.objectsByUid[d.uid.toString()]=d)}b=0;for(c=a[4].length;b<c;b++)for(f=a[4][b],h=this.types_by_index[f[0]],d=1,e=f.length;d<e;d++)g=this.types_by_index[f[d]],g.families.push(h),h.members.push(g);b=0;for(c=a[23].length;b<c;b++){f=a[23][b];h=[];d=0;for(e=f.length;d<e;d++)h.push(this.types_by_index[f[d]]);d=0;for(e=h.length;d<e;d++)h[d].is_contained=!0,h[d].container=h}if(0<this.family_count)for(b=0,c=this.types_by_index.length;b<
c;b++)if(g=this.types_by_index[b],!g.is_family&&g.families.length){g.family_var_map=Array(this.family_count);g.family_beh_map=Array(this.family_count);g.family_fx_map=Array(this.family_count);m=[];d=l=q=k=0;for(e=g.families.length;d<e;d++)for(n=g.families[d],g.family_var_map[n.family_index]=k,k+=n.vars_count,g.family_beh_map[n.family_index]=q,q+=n.behs_count,g.family_fx_map[n.family_index]=l,l+=n.fx_count,f=0,h=n.effect_types.length;f<h;f++)m.push(cr.shallowCopy({},n.effect_types[f]));g.effect_types=
m.concat(g.effect_types);d=0;for(e=g.effect_types.length;d<e;d++)g.effect_types[d].index=d}b=0;for(c=a[5].length;b<c;b++)g=a[5][b],d=new cr.layout(this,g),cr.seal(d),this.layouts[d.name]=d,this.layouts_by_index.push(d);b=0;for(c=a[6].length;b<c;b++)g=a[6][b],d=new cr.eventsheet(this,g),cr.seal(d),this.eventsheets[d.name]=d,this.eventsheets_by_index.push(d);b=0;for(c=this.eventsheets_by_index.length;b<c;b++)this.eventsheets_by_index[b].postInit();b=0;for(c=this.triggers_to_postinit.length;b<c;b++)this.triggers_to_postinit[b].postInit();
this.triggers_to_postinit.length=0;this.files_subfolder=a[7];this.pixel_rounding=a[8];this.aspect_scale=1;this.enableWebGL=a[12];this.linearSampling=a[13];this.alphaBackground=a[14];this.versionstr=a[15];this.useHighDpi=a[16];this.orientations=a[19];this.autoLockOrientation=0<this.orientations;this.pauseOnBlur=a[21];this.fullscreenScalingQuality=this.wantFullscreenScalingQuality=a[22];this.start_time=Date.now()};a.prototype.findWaitingTexture=function(a){var b,c;b=0;for(c=this.wait_for_textures.length;b<
c;b++)if(this.wait_for_textures[b].cr_src===a)return this.wait_for_textures[b];return null};a.prototype.areAllTexturesLoaded=function(){var a=0,b=0,c=!0,d,e;d=0;for(e=this.wait_for_textures.length;d<e;d++){var f=this.wait_for_textures[d].cr_filesize;if(!f||0>=f)f=5E4;a+=f;this.wait_for_textures[d].complete||this.wait_for_textures[d].loaded?b+=f:c=!1}this.progress=0==a?0:b/a;return c};a.prototype.go=function(){if(this.ctx||this.glwrap){var a=this.ctx||this.overlay_ctx;this.overlay_canvas&&this.positionOverlayCanvas();
this.progress=0;this.last_progress=-1;if(this.areAllTexturesLoaded())this.go_textures_done();else{var b=Date.now()-this.start_time;if(a){var c=this.width,d=this.height,e=this.devicePixelRatio;this.overlay_canvas&&(c=this.cssWidth,d=this.cssHeight,e=1);if(3!==this.loaderstyle&&500<=b&&this.last_progress!=this.progress){a.clearRect(0,0,c,d);var b=c/2,d=d/2,c=0===this.loaderstyle&&this.loaderlogo.complete,f=40*e,h=0,g=80*e,k;c&&(g=this.loaderlogo.width*e,k=this.loaderlogo.height*e,f=g/2,h=k/2,a.drawImage(this.loaderlogo,
cr.floor(b-f),cr.floor(d-h),g,k));1>=this.loaderstyle?(d+=h+(c?12*e:0),b=cr.floor(b-f)+0.5,d=cr.floor(d)+0.5,a.fillStyle="DodgerBlue",a.fillRect(b,d,Math.floor(g*this.progress),6*e),a.strokeStyle="black",a.strokeRect(b,d,g,6*e),a.strokeStyle="white",a.strokeRect(b-1*e,d-1*e,g+2*e,8*e)):2===this.loaderstyle&&(a.font="12pt Arial",a.fillStyle="#999",a.textBaseLine="middle",e=Math.round(100*this.progress)+"%",c=a.measureText?a.measureText(e):null,a.fillText(e,b-(c?c.width:0)/2,d))}this.last_progress=
this.progress}setTimeout(function(a){return function(){a.go()}}(this),100)}}};a.prototype.go_textures_done=function(){this.overlay_canvas&&(this.canvas.parentNode.removeChild(this.overlay_canvas),this.overlay_canvas=this.overlay_ctx=null);this.start_time=Date.now();this.last_fps_time=cr.performance_now();var a,b,c;if(this.uses_loader_layout)for(a=0,b=this.types_by_index.length;a<b;a++)c=this.types_by_index[a],c.is_family||c.isOnLoaderLayout||!c.plugin.is_world||(c.onCreate(),cr.seal(c));else this.isloading=
!1;a=0;for(b=this.layouts_by_index.length;a<b;a++)this.layouts_by_index[a].createGlobalNonWorlds();2<=this.fullscreen_mode&&(a=this.original_width/this.original_height,b=this.width/this.height,this.aspect_scale=2!==this.fullscreen_mode&&b>a||2===this.fullscreen_mode&&b<a?this.height/this.original_height:this.width/this.original_width);this.first_layout?this.layouts[this.first_layout].startRunning():this.layouts_by_index[0].startRunning();this.uses_loader_layout||(this.loadingprogress=1,this.trigger(cr.system_object.prototype.cnds.OnLoadFinished,
null));navigator.splashscreen&&navigator.splashscreen.hide&&navigator.splashscreen.hide();this.tick();this.isDirectCanvas&&AppMobi.webview.execute("onGameReady();")};var l=window.requestAnimationFrame||window.mozRequestAnimationFrame||window.webkitRequestAnimationFrame||window.msRequestAnimationFrame||window.oRequestAnimationFrame;a.prototype.tick=function(){if(this.running_layout){var a=cr.performance_now();if(this.halfFramerateMode&&this.ranLastRaf&&29>a-this.lastRafTime)this.ranLastRaf=!1,this.lastRafTime=
a,l?this.raf_id=l(this.tickFunc,this.canvas):this.timeout_id=setTimeout(this.tickFunc,this.isMobile?1:16);else{this.ranLastRaf=!0;this.lastRafTime=a;var b=this.fullscreen_mode,c=document.mozFullScreen||document.webkitIsFullScreen||document.fullScreen||!!document.msFullscreenElement;(c||this.isNodeFullscreen)&&0<this.fullscreen_scaling&&(b=this.fullscreen_scaling);if(0<b){var b=window.innerWidth,d=window.innerHeight;this.lastWindowWidth===b&&this.lastWindowHeight===d||this.setSize(b,d)}this.isDomFree||
(c?(this.firstInFullscreen||(this.fullscreenOldMarginCss=jQuery(this.canvas).css("margin")||"0",this.firstInFullscreen=!0),this.isChrome||this.isNodeWebkit||jQuery(this.canvas).css({"margin-left":""+Math.floor((screen.width-this.width/this.devicePixelRatio)/2)+"px","margin-top":""+Math.floor((screen.height-this.height/this.devicePixelRatio)/2)+"px"})):this.firstInFullscreen?(this.isChrome||this.isNodeWebkit||jQuery(this.canvas).css("margin",this.fullscreenOldMarginCss),this.fullscreenOldMarginCss=
"",this.firstInFullscreen=!1,0===this.fullscreen_mode&&this.setSize(Math.round(this.oldWidth/this.devicePixelRatio),Math.round(this.oldHeight/this.devicePixelRatio),!0)):(this.oldWidth=this.width,this.oldHeight=this.height));this.isloading&&(c=this.areAllTexturesLoaded(),this.loadingprogress=this.progress,c&&(this.isloading=!1,this.progress=1,this.trigger(cr.system_object.prototype.cnds.OnLoadFinished,null)));this.logic();!this.redraw&&!this.isCocoonJs||this.is_WebGL_context_lost||this.suspendDrawing||
(this.redraw=!1,this.glwrap?this.drawGL():this.draw(),this.snapshotCanvas&&(this.canvas&&this.canvas.toDataURL&&(this.snapshotData=this.canvas.toDataURL(this.snapshotCanvas[0],this.snapshotCanvas[1]),this.trigger(cr.system_object.prototype.cnds.OnCanvasSnapshot,null)),this.snapshotCanvas=null));this.hit_breakpoint||(this.tickcount++,this.execcount++,this.framecount++);this.logictime+=cr.performance_now()-a;this.isSuspended||(l?this.raf_id=l(this.tickFunc,this.canvas):this.timeout_id=setTimeout(this.tickFunc,
this.isMobile?1:16))}}};a.prototype.logic=function(){var a,b,c,d,e,f,h,g,k;a=cr.performance_now();1E3<=a-this.last_fps_time&&(this.last_fps_time+=1E3,this.fps=this.framecount,this.framecount=0,this.cpuutilisation=this.logictime,this.logictime=0);this.measuring_dt&&(0!==this.last_tick_time&&(b=a-this.last_tick_time,0!==b||this.isDebug?(this.dt1=b/1E3,0.5<this.dt1?this.dt1=0:0.1<this.dt1&&(this.dt1=0.1)):(this.zeroDtCount++,10<=this.zeroDtCout&&(this.measuring_dt=!1),this.dt1=1/60)),this.last_tick_time=
a);this.dt=this.dt1*this.timescale;this.kahanTime.add(this.dt);a=document.mozFullScreen||document.webkitIsFullScreen||document.fullScreen||!!document.msFullscreenElement||this.isNodeFullscreen;2<=this.fullscreen_mode||a&&0<this.fullscreen_scaling?(b=this.original_width/this.original_height,c=this.width/this.height,d=this.fullscreen_mode,a&&0<this.fullscreen_scaling&&(d=this.fullscreen_scaling),this.aspect_scale=2!==d&&c>b||2===d&&c<b?this.height/this.original_height:this.width/this.original_width,
this.running_layout&&(this.running_layout.scrollToX(this.running_layout.scrollX),this.running_layout.scrollToY(this.running_layout.scrollY))):this.aspect_scale=this.isRetina?this.devicePixelRatio:1;this.ClearDeathRow();this.isInOnDestroy++;this.system.runWaits();this.isInOnDestroy--;this.ClearDeathRow();this.isInOnDestroy++;a=0;for(b=this.types_by_index.length;a<b;a++)if(h=this.types_by_index[a],!h.is_family&&(h.behaviors.length||h.families.length))for(c=0,d=h.instances.length;c<d;c++)for(g=h.instances[c],
e=0,f=g.behavior_insts.length;e<f;e++)g.behavior_insts[e].tick();a=0;for(b=this.types_by_index.length;a<b;a++)if(h=this.types_by_index[a],!h.is_family&&(h.behaviors.length||h.families.length))for(c=0,d=h.instances.length;c<d;c++)for(g=h.instances[c],e=0,f=g.behavior_insts.length;e<f;e++)k=g.behavior_insts[e],k.posttick&&k.posttick();c=this.objects_to_tick.valuesRef();a=0;for(b=c.length;a<b;a++)c[a].tick();this.isInOnDestroy--;this.handleSaveLoad();for(a=0;this.changelayout&&10>a++;)this.doChangeLayout(this.changelayout);
a=0;for(b=this.eventsheets_by_index.length;a<b;a++)this.eventsheets_by_index[a].hasRun=!1;this.running_layout.event_sheet&&this.running_layout.event_sheet.run();this.registered_collisions.length=0;this.layout_first_tick=!1;this.isInOnDestroy++;a=0;for(b=this.types_by_index.length;a<b;a++)if(h=this.types_by_index[a],!h.is_family&&(h.behaviors.length||h.families.length))for(c=0,d=h.instances.length;c<d;c++)for(g=h.instances[c],e=0,f=g.behavior_insts.length;e<f;e++)k=g.behavior_insts[e],k.tick2&&k.tick2();
c=this.objects_to_tick2.valuesRef();a=0;for(b=c.length;a<b;a++)c[a].tick2();this.isInOnDestroy--};a.prototype.doChangeLayout=function(a){var b=this.running_layout;this.running_layout.stopRunning();var c,d,e,f,h,g,k;if(this.glwrap)for(c=0,d=this.types_by_index.length;c<d;c++)h=this.types_by_index[c],h.is_family||!h.unloadTextures||h.global&&0!==h.instances.length||-1!==a.initial_types.indexOf(h)||h.unloadTextures();b==a&&(this.system.waits.length=0);a.startRunning();c=0;for(d=this.types_by_index.length;c<
d;c++)if(h=this.types_by_index[c],h.global||h.plugin.singleglobal)for(a=0,b=h.instances.length;a<b;a++){g=h.instances[a];if(g.onLayoutChange)g.onLayoutChange();if(g.behavior_insts)for(e=0,f=g.behavior_insts.length;e<f;e++)if(k=g.behavior_insts[e],k.onLayoutChange)k.onLayoutChange()}this.layout_first_tick=this.redraw=!0;this.ClearDeathRow()};a.prototype.tickMe=function(a){this.objects_to_tick.add(a)};a.prototype.untickMe=function(a){this.objects_to_tick.remove(a)};a.prototype.tick2Me=function(a){this.objects_to_tick2.add(a)};
a.prototype.untick2Me=function(a){this.objects_to_tick2.remove(a)};a.prototype.getDt=function(a){return a&&-1!==a.my_timescale?this.dt1*a.my_timescale:this.dt};a.prototype.draw=function(){this.running_layout.draw(this.ctx);this.isDirectCanvas&&this.ctx.present()};a.prototype.drawGL=function(){this.running_layout.drawGL(this.glwrap);this.glwrap.present()};a.prototype.addDestroyCallback=function(a){a&&this.destroycallbacks.push(a)};a.prototype.removeDestroyCallback=function(a){cr.arrayFindRemove(this.destroycallbacks,
a)};a.prototype.getObjectByUID=function(a){return this.objectsByUid[a.toString()]};a.prototype.DestroyInstance=function(a){var b,c;if(!this.deathRow.contains(a)){this.deathRow.add(a);if(a.is_contained)for(b=0,c=a.siblings.length;b<c;b++)this.DestroyInstance(a.siblings[b]);this.isInClearDeathRow&&this.deathRow.values_cache.push(a);this.isInOnDestroy++;this.trigger(Object.getPrototypeOf(a.type.plugin).cnds.OnDestroyed,a);this.isInOnDestroy--}};a.prototype.ClearDeathRow=function(){var a,b,c,d,e,f,h,
g,k,m;this.isInClearDeathRow=!0;d=0;for(f=this.createRow.length;d<f;d++)for(a=this.createRow[d],b=a.type,b.instances.push(a),e=0,h=b.families.length;e<h;e++)b.families[e].instances.push(a),b.families[e].stale_iids=!0;this.createRow.length=0;f=this.deathRow.valuesRef();for(d=0;d<f.length;d++){a=f[d];b=a.type;c=b.instances;e=0;for(h=this.destroycallbacks.length;e<h;e++)this.destroycallbacks[e](a);cr.arrayFindRemove(c,a);0===c.length&&(b.any_instance_parallaxed=!1);a.collcells&&b.collision_grid.update(a,
a.collcells,null);a.layer&&(cr.arrayRemove(a.layer.instances,a.get_zindex()),a.layer.zindices_stale=!0);e=0;for(h=b.families.length;e<h;e++)cr.arrayFindRemove(b.families[e].instances,a),b.families[e].stale_iids=!0;if(a.behavior_insts)for(e=0,h=a.behavior_insts.length;e<h;e++){c=a.behavior_insts[e];if(c.onDestroy)c.onDestroy();c.behavior.my_instances.remove(a)}this.objects_to_tick.remove(a);this.objects_to_tick2.remove(a);e=0;for(h=this.system.waits.length;e<h;e++)if(k=this.system.waits[e],k.sols.hasOwnProperty(b.index)&&
cr.arrayFindRemove(k.sols[b.index].insts,a),!b.is_family)for(c=0,g=b.families.length;c<g;c++)m=b.families[c],k.sols.hasOwnProperty(m.index)&&cr.arrayFindRemove(k.sols[m.index].insts,a);if(a.onDestroy)a.onDestroy();this.objectsByUid.hasOwnProperty(a.uid.toString())&&delete this.objectsByUid[a.uid.toString()];this.objectcount--;64>b.deadCache.length&&b.deadCache.push(a);b.stale_iids=!0}this.deathRow.isEmpty()||(this.redraw=!0);this.deathRow.clear();this.isInClearDeathRow=!1};a.prototype.createInstance=
function(a,b,c,d){if(a.is_family){var e=cr.floor(Math.random()*a.members.length);return this.createInstance(a.members[e],b,c,d)}return a.default_instance?this.createInstanceFromInit(a.default_instance,b,!1,c,d,!1):null};var k=[];a.prototype.createInstanceFromInit=function(a,b,c,d,e,h){var f,g,m,n;if(!a)return null;var l=this.types_by_index[a[1]],q=l.plugin.is_world;if(this.isloading&&q&&!l.isOnLoaderLayout||q&&!this.glwrap&&11===a[0][11])return null;var s=b;q||(b=null);var p;l.deadCache.length?(p=
l.deadCache.pop(),p.recycled=!0,l.plugin.Instance.call(p,l)):(p=new l.plugin.Instance(l),p.recycled=!1);p.uid=c&&!h?a[2]:this.next_uid++;this.objectsByUid[p.uid.toString()]=p;p.puid=this.next_puid++;p.iid=l.instances.length;f=0;for(g=this.createRow.length;f<g;++f)this.createRow[f].type===l&&p.iid++;p.get_iid=cr.inst_get_iid;m=a[3];if(p.recycled)cr.wipe(p.extra);else{p.extra={};if("undefined"!==typeof cr_is_preview)for(p.instance_var_names=[],p.instance_var_names.length=m.length,f=0,g=m.length;f<g;f++)p.instance_var_names[f]=
m[f][1];p.instance_vars=[];p.instance_vars.length=m.length}f=0;for(g=m.length;f<g;f++)p.instance_vars[f]=m[f][0];if(q){var G=a[0];p.x=cr.is_undefined(d)?G[0]:d;p.y=cr.is_undefined(e)?G[1]:e;p.z=G[2];p.width=G[3];p.height=G[4];p.depth=G[5];p.angle=G[6];p.opacity=G[7];p.hotspotX=G[8];p.hotspotY=G[9];p.blend_mode=G[10];f=G[11];!this.glwrap&&l.effect_types.length&&(p.blend_mode=f);p.compositeOp=cr.effectToCompositeOp(p.blend_mode);this.gl&&cr.setGLBlend(p,p.blend_mode,this.gl);if(p.recycled){f=0;for(g=
G[12].length;f<g;f++)for(m=0,n=G[12][f].length;m<n;m++)p.effect_params[f][m]=G[12][f][m];p.bbox.set(0,0,0,0);p.collcells.set(0,0,-1,-1);p.bquad.set_from_rect(p.bbox);p.bbox_changed_callbacks.length=0}else{p.effect_params=G[12].slice(0);f=0;for(g=p.effect_params.length;f<g;f++)p.effect_params[f]=G[12][f].slice(0);p.active_effect_types=[];p.active_effect_flags=[];p.active_effect_flags.length=l.effect_types.length;p.bbox=new cr.rect(0,0,0,0);p.collcells=new cr.rect(0,0,-1,-1);p.bquad=new cr.quad;p.bbox_changed_callbacks=
[];p.set_bbox_changed=cr.set_bbox_changed;p.add_bbox_changed_callback=cr.add_bbox_changed_callback;p.contains_pt=cr.inst_contains_pt;p.update_bbox=cr.update_bbox;p.get_zindex=cr.inst_get_zindex}p.tilemap_exists=!1;p.tilemap_width=0;p.tilemap_height=0;p.tilemap_data=null;14===G.length&&(p.tilemap_exists=!0,p.tilemap_width=G[13][0],p.tilemap_height=G[13][1],p.tilemap_data=G[13][2]);f=0;for(g=l.effect_types.length;f<g;f++)p.active_effect_flags[f]=!0;p.updateActiveEffects=cr.inst_updateActiveEffects;
p.updateActiveEffects();p.uses_shaders=!!p.active_effect_types.length;p.bbox_changed=!0;l.any_bbox_changed=!0;p.visible=!0;p.my_timescale=-1;p.layer=b;p.zindex=b.instances.length;"undefined"===typeof p.collision_poly&&(p.collision_poly=null);this.redraw=p.collisionsEnabled=!0}p.toString=cr.inst_toString;var H;f=k.length=0;for(g=l.families.length;f<g;f++)k.push.apply(k,l.families[f].behaviors);k.push.apply(k,l.behaviors);if(p.recycled)for(f=0,g=k.length;f<g;f++){var J=k[f];H=p.behavior_insts[f];H.recycled=
!0;J.behavior.Instance.call(H,J,p);G=a[4][f];m=0;for(n=G.length;m<n;m++)H.properties[m]=G[m];H.onCreate();J.behavior.my_instances.add(p)}else for(p.behavior_insts=[],f=0,g=k.length;f<g;f++)J=k[f],H=new J.behavior.Instance(J,p),H.recycled=!1,H.properties=a[4][f].slice(0),H.onCreate(),cr.seal(H),p.behavior_insts.push(H),J.behavior.my_instances.add(p);G=a[5];if(p.recycled)for(f=0,g=G.length;f<g;f++)p.properties[f]=G[f];else p.properties=G.slice(0);this.createRow.push(p);b&&(b.instances.push(p),1!==b.parallaxX||
1!==b.parallaxY)&&(l.any_instance_parallaxed=!0);this.objectcount++;if(l.is_contained){if(p.is_contained=!0,p.recycled?p.siblings.length=0:p.siblings=[],!c&&!h){f=0;for(g=l.container.length;f<g;f++)if(l.container[f]!==l){if(!l.container[f].default_instance)return null;p.siblings.push(this.createInstanceFromInit(l.container[f].default_instance,s,!1,q?p.x:d,q?p.y:e,!0))}f=0;for(g=p.siblings.length;f<g;f++)for(p.siblings[f].siblings.push(p),m=0;m<g;m++)f!==m&&p.siblings[f].siblings.push(p.siblings[m])}}else p.is_contained=
!1,p.siblings=null;p.onCreate();p.recycled||cr.seal(p);f=0;for(g=p.behavior_insts.length;f<g;f++)p.behavior_insts[f].postCreate&&p.behavior_insts[f].postCreate();return p};a.prototype.getLayerByName=function(a){var b,c;b=0;for(c=this.running_layout.layers.length;b<c;b++){var d=this.running_layout.layers[b];if(cr.equals_nocase(d.name,a))return d}return null};a.prototype.getLayerByNumber=function(a){a=cr.floor(a);0>a&&(a=0);a>=this.running_layout.layers.length&&(a=this.running_layout.layers.length-
1);return this.running_layout.layers[a]};a.prototype.getLayer=function(a){return cr.is_number(a)?this.getLayerByNumber(a):this.getLayerByName(a.toString())};a.prototype.clearSol=function(a){var b,c;b=0;for(c=a.length;b<c;b++)a[b].getCurrentSol().select_all=!0};a.prototype.pushCleanSol=function(a){var b,c;b=0;for(c=a.length;b<c;b++)a[b].pushCleanSol()};a.prototype.pushCopySol=function(a){var b,c;b=0;for(c=a.length;b<c;b++)a[b].pushCopySol()};a.prototype.popSol=function(a){var b,c;b=0;for(c=a.length;b<
c;b++)a[b].popSol()};a.prototype.updateAllBBoxes=function(a){if(a.any_bbox_changed){var b,c,d=a.instances;b=0;for(c=d.length;b<c;++b)d[b].update_bbox();a.any_bbox_changed=!1}};a.prototype.getCollisionCandidates=function(a,b,c,d){var e,f,h=a?1!==a.parallaxX||1!==a.parallaxY:!1;if(b.is_family)for(a=0,e=b.members.length;a<e;++a)f=b.members[a],h||f.any_instance_parallaxed?cr.appendArray(d,f.instances):(this.updateAllBBoxes(f),f.collision_grid.queryRange(c,d));else h||b.any_instance_parallaxed?cr.appendArray(d,
b.instances):(this.updateAllBBoxes(b),b.collision_grid.queryRange(c,d))};a.prototype.getTypesCollisionCandidates=function(a,b,c,d){var e,f;e=0;for(f=b.length;e<f;++e)this.getCollisionCandidates(a,b[e],c,d)};a.prototype.getSolidCollisionCandidates=function(a,b,c){var d=this.getSolidBehavior();if(!d)return null;this.getTypesCollisionCandidates(a,d.my_types,b,c)};a.prototype.getJumpthruCollisionCandidates=function(a,b,c){var d=this.getJumpthruBehavior();if(!d)return null;this.getTypesCollisionCandidates(a,
d.my_types,b,c)};a.prototype.testAndSelectCanvasPointOverlap=function(a,b,c,d){var e=a.getCurrentSol(),f,h,g,k,m,n;if(e.select_all)for(d||(e.select_all=!1,e.instances.length=0),f=0,k=a.instances.length;f<k;f++){if(g=a.instances[f],g.update_bbox(),m=g.layer.canvasToLayer(b,c,!0),n=g.layer.canvasToLayer(b,c,!1),g.contains_pt(m,n)){if(d)return!1;e.instances.push(g)}}else{f=h=0;for(k=e.instances.length;f<k;f++)if(g=e.instances[f],g.update_bbox(),m=g.layer.canvasToLayer(b,c,!0),n=g.layer.canvasToLayer(b,
c,!1),g.contains_pt(m,n)){if(d)return!1;e.instances[h]=e.instances[f];h++}d||(e.instances.length=h)}a.applySolToContainer();return d?!0:e.hasObjects()};a.prototype.testOverlap=function(a,b){if(!(a&&b&&a!==b&&a.collisionsEnabled&&b.collisionsEnabled))return!1;a.update_bbox();b.update_bbox();var c=a.layer,d=b.layer,e,f,h,g,k,m,n,l;if(c===d||c.parallaxX===d.parallaxX&&d.parallaxY===d.parallaxY&&c.scale===d.scale&&c.angle===d.angle&&c.zoomRate===d.zoomRate){if(!a.bbox.intersects_rect(b.bbox)||!a.bquad.intersects_quad(b.bquad)||
a.tilemap_exists&&b.tilemap_exists)return!1;if(a.tilemap_exists)return this.testTilemapOverlap(a,b);if(b.tilemap_exists)return this.testTilemapOverlap(b,a);n=a.collision_poly&&!a.collision_poly.is_empty();e=b.collision_poly&&!b.collision_poly.is_empty();if(!n&&!e)return!0;n?(a.collision_poly.cache_poly(a.width,a.height,a.angle),n=a.collision_poly):(this.temp_poly.set_from_quad(a.bquad,a.x,a.y,a.width,a.height),n=this.temp_poly);e?(b.collision_poly.cache_poly(b.width,b.height,b.angle),l=b.collision_poly):
(this.temp_poly.set_from_quad(b.bquad,b.x,b.y,b.width,b.height),l=this.temp_poly);return n.intersects_poly(l,b.x-a.x,b.y-a.y)}n=a.collision_poly&&!a.collision_poly.is_empty();e=b.collision_poly&&!b.collision_poly.is_empty();n?(a.collision_poly.cache_poly(a.width,a.height,a.angle),this.temp_poly.set_from_poly(a.collision_poly)):this.temp_poly.set_from_quad(a.bquad,a.x,a.y,a.width,a.height);n=this.temp_poly;e?(b.collision_poly.cache_poly(b.width,b.height,b.angle),this.temp_poly2.set_from_poly(b.collision_poly)):
this.temp_poly2.set_from_quad(b.bquad,b.x,b.y,b.width,b.height);l=this.temp_poly2;e=0;for(f=n.pts_count;e<f;e++)h=2*e,g=h+1,k=n.pts_cache[h],m=n.pts_cache[g],n.pts_cache[h]=c.layerToCanvas(k+a.x,m+a.y,!0),n.pts_cache[g]=c.layerToCanvas(k+a.x,m+a.y,!1);n.update_bbox();e=0;for(f=l.pts_count;e<f;e++)h=2*e,g=h+1,k=l.pts_cache[h],m=l.pts_cache[g],l.pts_cache[h]=d.layerToCanvas(k+b.x,m+b.y,!0),l.pts_cache[g]=d.layerToCanvas(k+b.x,m+b.y,!1);l.update_bbox();return n.intersects_poly(l,0,0)};var f=new cr.quad,
m=new cr.rect(0,0,0,0);a.prototype.testTilemapOverlap=function(a,b){var c=a.collision_rects,d,e,h,g,k=b.bbox,m=a.x,n=a.y,l=b.collision_poly&&!b.collision_poly.is_empty();d=0;for(e=c.length;d<e;++d)if(h=c[d],g=h.rc,k.intersects_rect_off(g,m,n)&&(f.set_from_rect(g),f.offset(m,n),f.intersects_quad(b.bquad)))if(l)if(b.collision_poly.cache_poly(b.width,b.height,b.angle),h.poly){if(h.poly.intersects_poly(b.collision_poly,b.x-(m+g.left),b.y-(n+g.top)))return!0}else{if(this.temp_poly.set_from_quad(f,0,0,
g.right-g.left,g.bottom-g.top),this.temp_poly.intersects_poly(b.collision_poly,b.x,b.y))return!0}else if(h.poly){if(this.temp_poly.set_from_quad(b.bquad,0,0,b.width,b.height),h.poly.intersects_poly(this.temp_poly,-(m+g.left),-(n+g.top)))return!0}else return!0;return!1};a.prototype.testRectOverlap=function(a,b){if(!b||!b.collisionsEnabled)return!1;b.update_bbox();if(!b.bbox.intersects_rect(a))return!1;if(b.tilemap_exists){var c=b.collision_rects,d,e,h,g,k=b.x,m=b.y;d=0;for(e=c.length;d<e;++d)if(h=
c[d],g=h.rc,a.intersects_rect_off(g,k,m))if(h.poly){if(this.temp_poly.set_from_rect(a,0,0),h.poly.intersects_poly(this.temp_poly,-(k+g.left),-(m+g.top)))return!0}else return!0;return!1}f.set_from_rect(a);if(!b.bquad.intersects_quad(f))return!1;if(!b.collision_poly||b.collision_poly.is_empty())return!0;b.collision_poly.cache_poly(b.width,b.height,b.angle);f.offset(-a.left,-a.top);this.temp_poly.set_from_quad(f,0,0,1,1);return b.collision_poly.intersects_poly(this.temp_poly,a.left-b.x,a.top-b.y)};a.prototype.testSegmentOverlap=
function(a,b,c,d,e){if(!e||!e.collisionsEnabled)return!1;e.update_bbox();m.set(cr.min(a,c),cr.min(b,d),cr.max(a,c),cr.max(b,d));if(!e.bbox.intersects_rect(m))return!1;if(e.tilemap_exists){var h=e.collision_rects,g,k,n,l=e.x,q=e.y;e=0;for(g=h.length;e<g;++e)if(k=h[e],n=k.rc,m.intersects_rect_off(n,l,q)&&(f.set_from_rect(n),f.offset(l,q),f.intersects_segment(a,b,c,d)))if(k.poly){if(k.poly.intersects_segment(l+n.left,q+n.top,a,b,c,d))return!0}else return!0;return!1}if(!e.bquad.intersects_segment(a,b,
c,d))return!1;if(!e.collision_poly||e.collision_poly.is_empty())return!0;e.collision_poly.cache_poly(e.width,e.height,e.angle);return e.collision_poly.intersects_segment(e.x,e.y,a,b,c,d)};a.prototype.typeHasBehavior=function(a,b){if(!b)return!1;var c,d,e,f,h;c=0;for(d=a.behaviors.length;c<d;c++)if(a.behaviors[c].behavior instanceof b)return!0;if(!a.is_family)for(c=0,d=a.families.length;c<d;c++)for(h=a.families[c],e=0,f=h.behaviors.length;e<f;e++)if(h.behaviors[e].behavior instanceof b)return!0;return!1};
a.prototype.typeHasNoSaveBehavior=function(a){return this.typeHasBehavior(a,cr.behaviors.NoSave)};a.prototype.typeHasPersistBehavior=function(a){return this.typeHasBehavior(a,cr.behaviors.Persist)};a.prototype.getSolidBehavior=function(){return this.solidBehavior};a.prototype.getJumpthruBehavior=function(){return this.jumpthruBehavior};var n=[];a.prototype.testOverlapSolid=function(a){var b,c,d;a.update_bbox();this.getSolidCollisionCandidates(a.layer,a.bbox,n);b=0;for(c=n.length;b<c;++b)if(d=n[b],
d.extra.solidEnabled&&this.testOverlap(a,d))return n.length=0,d;n.length=0;return null};a.prototype.testRectOverlapSolid=function(a){var b,c,d;this.getSolidCollisionCandidates(null,a,n);b=0;for(c=n.length;b<c;++b)if(d=n[b],d.extra.solidEnabled&&this.testRectOverlap(a,d))return n.length=0,d;n.length=0;return null};var p=[];a.prototype.testOverlapJumpThru=function(a,b){var c=null;b&&(c=p,c.length=0);a.update_bbox();this.getJumpthruCollisionCandidates(a.layer,a.bbox,n);var d,e,f;d=0;for(e=n.length;d<
e;++d)if(f=n[d],f.extra.jumpthruEnabled&&this.testOverlap(a,f))if(b)c.push(f);else return n.length=0,f;n.length=0;return c};a.prototype.pushOutSolid=function(a,b,c,d,e,f){d=d||50;var h=a.x,g=a.y,k,m=null,n=null;for(k=0;k<d;k++)if(a.x=h+b*k,a.y=g+c*k,a.set_bbox_changed(),!this.testOverlap(a,m)&&((m=this.testOverlapSolid(a))&&(n=m),!m&&(e&&(m=f?this.testOverlap(a,f)?f:null:this.testOverlapJumpThru(a))&&(n=m),!m)))return n&&this.pushInFractional(a,b,c,n,16),!0;a.x=h;a.y=g;a.set_bbox_changed();return!1};
a.prototype.pushOut=function(a,b,c,d,e){d=d||50;var f=a.x,h=a.y,g;for(g=0;g<d;g++)if(a.x=f+b*g,a.y=h+c*g,a.set_bbox_changed(),!this.testOverlap(a,e))return!0;a.x=f;a.y=h;a.set_bbox_changed();return!1};a.prototype.pushInFractional=function(a,b,c,d,e){var f=2,h,g=!1;h=!1;for(var k=a.x,m=a.y;f<=e;)h=1/f,f*=2,a.x+=b*h*(g?1:-1),a.y+=c*h*(g?1:-1),a.set_bbox_changed(),this.testOverlap(a,d)?h=g=!0:(h=g=!1,k=a.x,m=a.y);h&&(a.x=k,a.y=m,a.set_bbox_changed())};a.prototype.pushOutSolidNearest=function(a,b){var c=
cr.is_undefined(b)?100:b,d=0,e=a.x,f=a.y,h=0,g=0,k=0,m=this.testOverlapSolid(a);if(!m)return!0;for(;d<=c;){switch(h){case 0:g=0;k=-1;d++;break;case 1:g=1;k=-1;break;case 2:g=1;k=0;break;case 3:k=g=1;break;case 4:g=0;k=1;break;case 5:g=-1;k=1;break;case 6:g=-1;k=0;break;case 7:k=g=-1}h=(h+1)%8;a.x=cr.floor(e+g*d);a.y=cr.floor(f+k*d);a.set_bbox_changed();if(!this.testOverlap(a,m)&&(m=this.testOverlapSolid(a),!m))return!0}a.x=e;a.y=f;a.set_bbox_changed();return!1};a.prototype.registerCollision=function(a,
b){a.collisionsEnabled&&b.collisionsEnabled&&this.registered_collisions.push([a,b])};a.prototype.checkRegisteredCollision=function(a,b){var c,d,e;c=0;for(d=this.registered_collisions.length;c<d;c++)if(e=this.registered_collisions[c],e[0]==a&&e[1]==b||e[0]==b&&e[1]==a)return!0;return!1};a.prototype.calculateSolidBounceAngle=function(a,b,c,d){var e=a.x,f=a.y,h=cr.max(10,cr.distanceTo(b,c,e,f)),g=cr.angleTo(b,c,e,f),k=d||this.testOverlapSolid(a);if(!k)return cr.clamp_angle(g+cr.PI);var m=k,n,l,q,p,s=
cr.to_radians(5);for(n=1;36>n;n++)if(l=g-n*s,a.x=b+Math.cos(l)*h,a.y=c+Math.sin(l)*h,a.set_bbox_changed(),!this.testOverlap(a,m)&&(m=d?null:this.testOverlapSolid(a),!m)){q=l;break}36===n&&(q=cr.clamp_angle(g+cr.PI));m=k;for(n=1;36>n;n++)if(l=g+n*s,a.x=b+Math.cos(l)*h,a.y=c+Math.sin(l)*h,a.set_bbox_changed(),!this.testOverlap(a,m)&&(m=d?null:this.testOverlapSolid(a),!m)){p=l;break}36===n&&(p=cr.clamp_angle(g+cr.PI));a.x=e;a.y=f;a.set_bbox_changed();if(p===q)return p;a=cr.angleDiff(p,q)/2;a=cr.angleClockwise(p,
q)?cr.clamp_angle(q+a+cr.PI):cr.clamp_angle(p+a);q=Math.cos(g);g=Math.sin(g);p=Math.cos(a);a=Math.sin(a);b=q*p+g*a;return cr.angleTo(0,0,q-2*b*p,g-2*b*a)};var q=[],s=-1;a.prototype.trigger=function(a,b,c){if(!this.running_layout)return!1;var d=this.running_layout.event_sheet;if(!d)return!1;s++;s===q.length?q.push(new cr.ObjectSet):q[s].clear();a=this.triggerOnSheet(a,b,d,c);s--;return a};a.prototype.triggerOnSheet=function(a,b,c,d){var e=q[s];if(e.contains(c))return!1;e.add(c);var e=c.includes.valuesRef(),
f=!1,h,g,k;h=0;for(g=e.length;h<g;h++)e[h].isActive()&&(k=this.triggerOnSheet(a,b,e[h].include_sheet,d),f=f||k);if(b)for(k=this.triggerOnSheetForTypeName(a,b,b.type.name,c,d),f=f||k,h=0,g=b.type.families.length;h<g;h++)k=this.triggerOnSheetForTypeName(a,b,b.type.families[h].name,c,d),f=f||k;else k=this.triggerOnSheetForTypeName(a,b,"system",c,d),f=f||k;return f};a.prototype.triggerOnSheetForTypeName=function(a,b,c,d,e){var f,h=!1,g=!1,g="undefined"!==typeof e,k=(g?d.fasttriggers:d.triggers)[c];if(!k)return h;
var m=null;d=0;for(f=k.length;d<f;d++)if(k[d].method==a){m=k[d].evs;break}if(!m)return h;a=g?m[e]:m;if(!a)return null;d=0;for(f=a.length;d<f;d++)e=a[d][0],g=a[d][1],g=this.executeSingleTrigger(b,c,e,g),h=h||g;return h};a.prototype.executeSingleTrigger=function(a,b,c,d){var e,f,h=!1;this.trigger_depth++;var g=this.getCurrentEventStack().current_event;g&&this.pushCleanSol(g.solModifiersIncludingParents);var k=1<this.trigger_depth;this.pushCleanSol(c.solModifiersIncludingParents);k&&this.pushLocalVarStack();
var m=this.pushEventStack(c);m.current_event=c;a&&(e=this.types[b].getCurrentSol(),e.select_all=!1,e.instances.length=1,e.instances[0]=a,this.types[b].applySolToContainer());a=!0;if(c.parent){b=m.temp_parents_arr;for(e=c.parent;e;)b.push(e),e=e.parent;b.reverse();e=0;for(f=b.length;e<f;e++)if(!b[e].run_pretrigger()){a=!1;break}}a&&(this.execcount++,c.orblock?c.run_orblocktrigger(d):c.run(),h=h||m.last_event_true);this.popEventStack();k&&this.popLocalVarStack();this.popSol(c.solModifiersIncludingParents);
g&&this.popSol(g.solModifiersIncludingParents);0!==this.isInOnDestroy||0!==s||this.isRunningEvents||this.deathRow.isEmpty()&&!this.createRow.length||this.ClearDeathRow();this.trigger_depth--;return h};a.prototype.getCurrentCondition=function(){var a=this.getCurrentEventStack();return a.current_event.conditions[a.cndindex]};a.prototype.getCurrentAction=function(){var a=this.getCurrentEventStack();return a.current_event.actions[a.actindex]};a.prototype.pushLocalVarStack=function(){this.localvar_stack_index++;
this.localvar_stack_index>=this.localvar_stack.length&&this.localvar_stack.push([])};a.prototype.popLocalVarStack=function(){this.localvar_stack_index--};a.prototype.getCurrentLocalVarStack=function(){return this.localvar_stack[this.localvar_stack_index]};a.prototype.pushEventStack=function(a){this.event_stack_index++;this.event_stack_index>=this.event_stack.length&&this.event_stack.push(new cr.eventStackFrame);var b=this.getCurrentEventStack();b.reset(a);return b};a.prototype.popEventStack=function(){this.event_stack_index--};
a.prototype.getCurrentEventStack=function(){return this.event_stack[this.event_stack_index]};a.prototype.pushLoopStack=function(a){this.loop_stack_index++;this.loop_stack_index>=this.loop_stack.length&&this.loop_stack.push(cr.seal({name:a,index:0,stopped:!1}));var b=this.getCurrentLoop();b.name=a;b.index=0;b.stopped=!1;return b};a.prototype.popLoopStack=function(){this.loop_stack_index--};a.prototype.getCurrentLoop=function(){return this.loop_stack[this.loop_stack_index]};a.prototype.getEventVariableByName=
function(a,b){for(var c,d,e,f,h,g;b;){c=0;for(d=b.subevents.length;c<d;c++)if(g=b.subevents[c],g instanceof cr.eventvariable&&cr.equals_nocase(a,g.name))return g;b=b.parent}c=0;for(d=this.eventsheets_by_index.length;c<d;c++)for(h=this.eventsheets_by_index[c],e=0,f=h.events.length;e<f;e++)if(g=h.events[e],g instanceof cr.eventvariable&&cr.equals_nocase(a,g.name))return g;return null};a.prototype.getLayoutBySid=function(a){var b,c;b=0;for(c=this.layouts_by_index.length;b<c;b++)if(this.layouts_by_index[b].sid===
a)return this.layouts_by_index[b];return null};a.prototype.getObjectTypeBySid=function(a){var b,c;b=0;for(c=this.types_by_index.length;b<c;b++)if(this.types_by_index[b].sid===a)return this.types_by_index[b];return null};a.prototype.getGroupBySid=function(a){var b,c;b=0;for(c=this.allGroups.length;b<c;b++)if(this.allGroups[b].sid===a)return this.allGroups[b];return null};a.prototype.signalContinuousPreview=function(){this.signalledContinuousPreview=!0};a.prototype.handleSaveLoad=function(){var a=this,
b=this.saveToSlot,f=this.lastSaveJson,h=this.loadFromSlot,g=!1;this.signalledContinuousPreview&&(g=!0,b="__c2_continuouspreview",this.signalledContinuousPreview=!1);if(b.length){this.ClearDeathRow();f=this.saveToJSONString();if(window.indexedDB&&!this.isCocoonJs)c(b,f,function(){cr.logexport("Saved state to IndexedDB storage ("+f.length+" bytes)");a.lastSaveJson=f;a.trigger(cr.system_object.prototype.cnds.OnSaveComplete,null);a.lastSaveJson="";g&&e()},function(c){try{localStorage.setItem("__c2save_"+
b,f),cr.logexport("Saved state to WebStorage ("+f.length+" bytes)"),a.lastSaveJson=f,a.trigger(cr.system_object.prototype.cnds.OnSaveComplete,null),a.lastSaveJson="",g&&e()}catch(d){cr.logexport("Failed to save game state: "+c+"; "+d)}});else try{localStorage.setItem("__c2save_"+b,f),cr.logexport("Saved state to WebStorage ("+f.length+" bytes)"),a.lastSaveJson=f,this.trigger(cr.system_object.prototype.cnds.OnSaveComplete,null),a.lastSaveJson="",g&&e()}catch(k){cr.logexport("Error saving to WebStorage: "+
k)}this.loadFromJson=this.loadFromSlot=this.saveToSlot=""}h.length&&(window.indexedDB&&!this.isCocoonJs?d(h,function(b){b?(a.loadFromJson=b,cr.logexport("Loaded state from IndexedDB storage ("+a.loadFromJson.length+" bytes)")):(a.loadFromJson=localStorage.getItem("__c2save_"+h)||"",cr.logexport("Loaded state from WebStorage ("+a.loadFromJson.length+" bytes)"));a.suspendDrawing=!1;a.loadFromJson.length||a.trigger(cr.system_object.prototype.cnds.OnLoadFailed,null)},function(b){a.loadFromJson=localStorage.getItem("__c2save_"+
h)||"";cr.logexport("Loaded state from WebStorage ("+a.loadFromJson.length+" bytes)");a.suspendDrawing=!1;a.loadFromJson.length||a.trigger(cr.system_object.prototype.cnds.OnLoadFailed,null)}):(this.loadFromJson=localStorage.getItem("__c2save_"+h)||"",cr.logexport("Loaded state from WebStorage ("+this.loadFromJson.length+" bytes)"),this.suspendDrawing=!1,a.loadFromJson.length||a.trigger(cr.system_object.prototype.cnds.OnLoadFailed,null)),this.saveToSlot=this.loadFromSlot="");this.loadFromJson.length&&
(this.ClearDeathRow(),this.loadFromJSONString(this.loadFromJson),this.lastSaveJson=this.loadFromJson,this.trigger(cr.system_object.prototype.cnds.OnLoadComplete,null),this.loadFromJson=this.lastSaveJson="")};a.prototype.saveToJSONString=function(){var a,b,c,d,e,f,g,k={c2save:!0,version:1,rt:{time:this.kahanTime.sum,timescale:this.timescale,tickcount:this.tickcount,execcount:this.execcount,next_uid:this.next_uid,running_layout:this.running_layout.sid,start_time_offset:Date.now()-this.start_time},types:{},
layouts:{},events:{groups:{},cnds:{},acts:{},vars:{}}};a=0;for(b=this.types_by_index.length;a<b;a++)if(e=this.types_by_index[a],!e.is_family&&!this.typeHasNoSaveBehavior(e)){f={instances:[]};cr.hasAnyOwnProperty(e.extra)&&(f.ex=h(e.extra));c=0;for(d=e.instances.length;c<d;c++)f.instances.push(this.saveInstanceToJSON(e.instances[c]));k.types[e.sid.toString()]=f}a=0;for(b=this.layouts_by_index.length;a<b;a++)c=this.layouts_by_index[a],k.layouts[c.sid.toString()]=c.saveToJSON();d=k.events.groups;a=0;
for(b=this.allGroups.length;a<b;a++)c=this.allGroups[a],d[c.sid.toString()]=!!this.activeGroups[c.group_name];b=k.events.cnds;for(g in this.cndsBySid)this.cndsBySid.hasOwnProperty(g)&&(a=this.cndsBySid[g],cr.hasAnyOwnProperty(a.extra)&&(b[g]={ex:h(a.extra)}));b=k.events.acts;for(g in this.actsBySid)this.actsBySid.hasOwnProperty(g)&&(a=this.actsBySid[g],cr.hasAnyOwnProperty(a.extra)&&(b[g]={ex:a.extra}));b=k.events.vars;for(g in this.varsBySid)this.varsBySid.hasOwnProperty(g)&&(a=this.varsBySid[g],
a.is_constant||a.parent&&!a.is_static||(b[g]=a.data));k.system=this.system.saveToJSON();return JSON.stringify(k)};a.prototype.refreshUidMap=function(){var a,b,c,d,e,f;this.objectsByUid={};a=0;for(b=this.types_by_index.length;a<b;a++)if(c=this.types_by_index[a],!c.is_family)for(d=0,e=c.instances.length;d<e;d++)f=c.instances[d],this.objectsByUid[f.uid.toString()]=f};a.prototype.loadFromJSONString=function(a){a=JSON.parse(a);if(a.c2save&&!(1<a.version)){var b=a.rt;this.kahanTime.reset();this.kahanTime.sum=
b.time;this.timescale=b.timescale;this.tickcount=b.tickcount;this.execcount=b.execcount;this.start_time=Date.now()-b.start_time_offset;var c=b.running_layout;if(c!==this.running_layout.sid)if(c=this.getLayoutBySid(c))this.doChangeLayout(c);else return;this.isLoadingState=!0;var d,e,f,h,g,k,m;k=a.types;for(e in k)if(k.hasOwnProperty(e)&&(h=this.getObjectTypeBySid(parseInt(e,10)))&&!h.is_family&&!this.typeHasNoSaveBehavior(h)){k[e].ex?h.extra=k[e].ex:cr.wipe(h.extra);g=h.instances;f=k[e].instances;
c=0;for(d=cr.min(g.length,f.length);c<d;c++)this.loadInstanceFromJSON(g[c],f[c]);c=f.length;for(d=g.length;c<d;c++)this.DestroyInstance(g[c]);c=g.length;for(d=f.length;c<d;c++){g=null;if(h.plugin.is_world&&(g=this.running_layout.getLayerBySid(f[c].w.l),!g))continue;g=this.createInstanceFromInit(h.default_instance,g,!1,0,0,!0);this.loadInstanceFromJSON(g,f[c])}h.stale_iids=!0}this.ClearDeathRow();this.refreshUidMap();d=a.layouts;for(e in d)d.hasOwnProperty(e)&&(c=this.getLayoutBySid(parseInt(e,10)))&&
c.loadFromJSON(d[e]);d=a.events.groups;for(e in d)d.hasOwnProperty(e)&&(c=this.getGroupBySid(parseInt(e,10)))&&(this.activeGroups[c.group_name]=d[e]);c=a.events.cnds;for(e in c)c.hasOwnProperty(e)&&this.cndsBySid.hasOwnProperty(e)&&(this.cndsBySid[e].extra=c[e].ex);c=a.events.acts;for(e in c)c.hasOwnProperty(e)&&this.actsBySid.hasOwnProperty(e)&&(this.actsBySid[e].extra=c[e].ex);c=a.events.vars;for(e in c)c.hasOwnProperty(e)&&this.varsBySid.hasOwnProperty(e)&&(this.varsBySid[e].data=c[e]);this.next_uid=
b.next_uid;this.isLoadingState=!1;this.system.loadFromJSON(a.system);c=0;for(d=this.types_by_index.length;c<d;c++)if(h=this.types_by_index[c],!h.is_family)for(e=0,a=h.instances.length;e<a;e++){g=h.instances[e];if(h.is_contained)for(k=g.get_iid(),b=g.siblings.length=0,f=h.container.length;b<f;b++)m=h.container[b],h!==m&&g.siblings.push(m.instances[k]);g.afterLoad&&g.afterLoad();if(g.behavior_insts)for(b=0,f=g.behavior_insts.length;b<f;b++)k=g.behavior_insts[b],k.afterLoad&&k.afterLoad()}this.redraw=
!0}};a.prototype.saveInstanceToJSON=function(a,b){var c,d,e,f,g;f=a.type;e=f.plugin;var k={};b?k.c2=!0:k.uid=a.uid;cr.hasAnyOwnProperty(a.extra)&&(k.ex=h(a.extra));if(a.instance_vars&&a.instance_vars.length)for(k.ivs={},c=0,d=a.instance_vars.length;c<d;c++)k.ivs[a.type.instvar_sids[c].toString()]=a.instance_vars[c];if(e.is_world){e={x:a.x,y:a.y,w:a.width,h:a.height,l:a.layer.sid,zi:a.get_zindex()};0!==a.angle&&(e.a=a.angle);1!==a.opacity&&(e.o=a.opacity);0.5!==a.hotspotX&&(e.hX=a.hotspotX);0.5!==
a.hotspotY&&(e.hY=a.hotspotY);0!==a.blend_mode&&(e.bm=a.blend_mode);a.visible||(e.v=a.visible);a.collisionsEnabled||(e.ce=a.collisionsEnabled);-1!==a.my_timescale&&(e.mts=a.my_timescale);if(f.effect_types.length)for(e.fx=[],c=0,d=f.effect_types.length;c<d;c++)g=f.effect_types[c],e.fx.push({name:g.name,active:a.active_effect_flags[g.index],params:a.effect_params[g.index]});k.w=e}if(a.behavior_insts&&a.behavior_insts.length)for(k.behs={},c=0,d=a.behavior_insts.length;c<d;c++)f=a.behavior_insts[c],f.saveToJSON&&
(k.behs[f.type.sid.toString()]=f.saveToJSON());a.saveToJSON&&(k.data=a.saveToJSON());return k};a.prototype.getInstanceVarIndexBySid=function(a,b){var c,d;c=0;for(d=a.instvar_sids.length;c<d;c++)if(a.instvar_sids[c]===b)return c;return-1};a.prototype.getBehaviorIndexBySid=function(a,b){var c,d;c=0;for(d=a.behavior_insts.length;c<d;c++)if(a.behavior_insts[c].type.sid===b)return c;return-1};a.prototype.loadInstanceFromJSON=function(a,b,c){var d,e,f,h,g;g=a.type;f=g.plugin;if(c){if(!b.c2)return}else a.uid=
b.uid;b.ex?a.extra=b.ex:cr.wipe(a.extra);if(e=b.ivs)for(d in e)e.hasOwnProperty(d)&&(c=this.getInstanceVarIndexBySid(g,parseInt(d,10)),0>c||c>=a.instance_vars.length||(a.instance_vars[c]=e[d]));if(f.is_world){f=b.w;a.layer.sid!==f.l&&(c=a.layer,a.layer=this.running_layout.getLayerBySid(f.l),a.layer?(a.layer.instances.push(a),a.layer.zindices_stale=!0,cr.arrayFindRemove(c.instances,a),c.zindices_stale=!0):(a.layer=c,this.DestroyInstance(a)));a.x=f.x;a.y=f.y;a.width=f.w;a.height=f.h;a.zindex=f.zi;a.angle=
f.hasOwnProperty("a")?f.a:0;a.opacity=f.hasOwnProperty("o")?f.o:1;a.hotspotX=f.hasOwnProperty("hX")?f.hX:0.5;a.hotspotY=f.hasOwnProperty("hY")?f.hY:0.5;a.visible=f.hasOwnProperty("v")?f.v:!0;a.collisionsEnabled=f.hasOwnProperty("ce")?f.ce:!0;a.my_timescale=f.hasOwnProperty("mts")?f.mts:-1;a.blend_mode=f.hasOwnProperty("bm")?f.bm:0;a.compositeOp=cr.effectToCompositeOp(a.blend_mode);this.gl&&cr.setGLBlend(a,a.blend_mode,this.gl);a.set_bbox_changed();if(f.hasOwnProperty("fx"))for(c=0,e=f.fx.length;c<
e;c++)h=g.getEffectIndexByName(f.fx[c].name),0>h||(a.active_effect_flags[h]=f.fx[c].active,a.effect_params[h]=f.fx[c].params);a.updateActiveEffects()}if(g=b.behs)for(d in g)g.hasOwnProperty(d)&&(f=this.getBehaviorIndexBySid(a,parseInt(d,10)),0>f||a.behavior_insts[f].loadFromJSON(g[d]));b.data&&a.loadFromJSON(b.data)};cr.runtime=a;cr.createRuntime=function(b){return new a(document.getElementById(b))};cr.createDCRuntime=function(b,c){return new a({dc:!0,width:b,height:c})};window.cr_createRuntime=cr.createRuntime;
window.cr_createDCRuntime=cr.createDCRuntime;window.createCocoonJSRuntime=function(){window.c2cocoonjs=!0;var b=document.createElement("screencanvas")||document.createElement("canvas");document.body.appendChild(b);b=new a(b);window.c2runtime=b;window.addEventListener("orientationchange",function(){window.c2runtime.setSize(window.innerWidth,window.innerHeight)});window.c2runtime.setSize(window.innerWidth,window.innerHeight);return b}})();
window.cr_getC2Runtime=function(){var a=document.getElementById("c2canvas");return a?a.c2runtime:window.c2runtime?window.c2runtime:null};window.cr_sizeCanvas=function(a,b){if(0!==a&&0!==b){var c=window.cr_getC2Runtime();c&&c.setSize(a,b)}};window.cr_setSuspended=function(a){var b=window.cr_getC2Runtime();b&&b.setSuspended(a)};
(function(){function a(a,b){this.runtime=a;this.event_sheet=null;this.scrollX=this.runtime.original_width/2;this.scrollY=this.runtime.original_height/2;this.scale=1;this.angle=0;this.first_visit=!0;this.name=b[0];this.width=b[1];this.height=b[2];this.unbounded_scrolling=b[3];this.sheetname=b[4];this.sid=b[5];var c=b[6],d,k;this.layers=[];this.initial_types=[];d=0;for(k=c.length;d<k;d++){var f=new cr.layer(this,c[d]);f.number=d;cr.seal(f);this.layers.push(f)}c=b[7];this.initial_nonworld=[];d=0;for(k=
c.length;d<k;d++){var f=c[d],m=this.runtime.types_by_index[f[1]];m.default_instance||(m.default_instance=f);this.initial_nonworld.push(f);-1===this.initial_types.indexOf(m)&&this.initial_types.push(m)}this.effect_types=[];this.active_effect_types=[];this.effect_params=[];d=0;for(k=b[8].length;d<k;d++)this.effect_types.push({id:b[8][d][0],name:b[8][d][1],shaderindex:-1,active:!0,index:d}),this.effect_params.push(b[8][d][2].slice(0));this.updateActiveEffects();this.rcTex=new cr.rect(0,0,1,1);this.rcTex2=
new cr.rect(0,0,1,1);this.persist_data={}}function b(a,b){this.layout=a;this.runtime=a.runtime;this.instances=[];this.scale=1;this.angle=0;this.disableAngle=!1;this.tmprect=new cr.rect(0,0,0,0);this.tmpquad=new cr.quad;this.viewBottom=this.viewTop=this.viewRight=this.viewLeft=0;this.zindices_stale=!1;this.name=b[0];this.index=b[1];this.sid=b[2];this.visible=b[3];this.background_color=b[4];this.transparent=b[5];this.parallaxX=b[6];this.parallaxY=b[7];this.opacity=b[8];this.forceOwnTexture=b[9];this.zoomRate=
b[10];this.blend_mode=b[11];this.effect_fallback=b[12];this.compositeOp="source-over";this.destBlend=this.srcBlend=0;this.render_offscreen=!1;var c=b[13],d,k;this.initial_instances=[];d=0;for(k=c.length;d<k;d++){var f=c[d],m=this.runtime.types_by_index[f[1]];m.default_instance||(m.default_instance=f);this.initial_instances.push(f);-1===this.layout.initial_types.indexOf(m)&&this.layout.initial_types.push(m)}this.effect_types=[];this.active_effect_types=[];this.effect_params=[];d=0;for(k=b[14].length;d<
k;d++)this.effect_types.push({id:b[14][d][0],name:b[14][d][1],shaderindex:-1,active:!0,index:d}),this.effect_params.push(b[14][d][2].slice(0));this.updateActiveEffects();this.rcTex=new cr.rect(0,0,1,1);this.rcTex2=new cr.rect(0,0,1,1)}function c(a,b){return a.zindex-b.zindex}a.prototype.saveObjectToPersist=function(a){var b=a.type.sid.toString();this.persist_data.hasOwnProperty(b)||(this.persist_data[b]=[]);this.persist_data[b].push(this.runtime.saveInstanceToJSON(a))};a.prototype.hasOpaqueBottomLayer=
function(){var a=this.layers[0];return!a.transparent&&1===a.opacity&&!a.forceOwnTexture&&a.visible};a.prototype.updateActiveEffects=function(){this.active_effect_types.length=0;var a,b,c;a=0;for(b=this.effect_types.length;a<b;a++)c=this.effect_types[a],c.active&&this.active_effect_types.push(c)};a.prototype.getEffectByName=function(a){var b,c,d;b=0;for(c=this.effect_types.length;b<c;b++)if(d=this.effect_types[b],d.name===a)return d;return null};var d=[];a.prototype.startRunning=function(){this.sheetname&&
(this.event_sheet=this.runtime.eventsheets[this.sheetname]);this.runtime.running_layout=this;this.scrollX=this.runtime.original_width/2;this.scrollY=this.runtime.original_height/2;var a,b,g,l,k,f,m;a=0;for(g=this.runtime.types_by_index.length;a<g;a++)if(b=this.runtime.types_by_index[a],!b.is_family)for(k=b.instances,b=0,l=k.length;b<l;b++)if(f=k[b],f.layer){var n=f.layer.number;n>=this.layers.length&&(n=this.layers.length-1);f.layer=this.layers[n];f.layer.instances.push(f);f.layer.zindices_stale=
!0}d.length=0;this.boundScrolling();a=0;for(g=this.layers.length;a<g;a++)f=this.layers[a],f.createInitialInstances(),f.disableAngle=!0,b=f.canvasToLayer(0,0,!0,!0),l=f.canvasToLayer(0,0,!1,!0),f.disableAngle=!1,this.runtime.pixel_rounding&&(b=b+0.5|0,l=l+0.5|0),f.rotateViewport(b,l,null);k=!1;if(!this.first_visit){for(m in this.persist_data)if(this.persist_data.hasOwnProperty(m)&&(b=this.runtime.getObjectTypeBySid(parseInt(m,10)))&&!b.is_family&&this.runtime.typeHasPersistBehavior(b)){l=this.persist_data[m];
a=0;for(g=l.length;a<g;a++){f=null;if(b.plugin.is_world&&(f=this.getLayerBySid(l[a].w.l),!f))continue;f=this.runtime.createInstanceFromInit(b.default_instance,f,!1,0,0,!0);this.runtime.loadInstanceFromJSON(f,l[a]);k=!0;d.push(f)}l.length=0}a=0;for(g=this.layers.length;a<g;a++)this.layers[a].instances.sort(c),this.layers[a].zindices_stale=!0}k&&(this.runtime.ClearDeathRow(),this.runtime.refreshUidMap());for(a=0;a<d.length;a++)if(f=d[a],f.type.is_contained)for(g=f.get_iid(),b=0,l=f.type.container.length;b<
l;b++)m=f.type.container[b],f.type!==m&&(m.instances.length>g?f.siblings.push(m.instances[g]):m.default_instance&&(k=this.runtime.createInstanceFromInit(m.default_instance,f.layer,!0,f.x,f.y,!0),this.runtime.ClearDeathRow(),m.updateIIDs(),f.siblings.push(k),d.push(k)));a=0;for(g=this.initial_nonworld.length;a<g;a++)this.runtime.createInstanceFromInit(this.initial_nonworld[a],null,!0);this.runtime.changelayout=null;this.runtime.ClearDeathRow();if(this.runtime.ctx&&!this.runtime.isDomFree)for(a=0,g=
this.runtime.types_by_index.length;a<g;a++)m=this.runtime.types_by_index[a],!m.is_family&&m.instances.length&&m.preloadCanvas2D&&m.preloadCanvas2D(this.runtime.ctx);a=0;for(g=d.length;a<g;a++)f=d[a],this.runtime.trigger(Object.getPrototypeOf(f.type.plugin).cnds.OnCreated,f);d.length=0;this.runtime.trigger(cr.system_object.prototype.cnds.OnLayoutStart,null);this.first_visit=!1};a.prototype.createGlobalNonWorlds=function(){var a,b,c,d,k;b=a=0;for(c=this.initial_nonworld.length;a<c;a++)d=this.initial_nonworld[a],
k=this.runtime.types_by_index[d[1]],k.global?this.runtime.createInstanceFromInit(d,null,!0):(this.initial_nonworld[b]=d,b++);this.initial_nonworld.length=b};a.prototype.stopRunning=function(){this.runtime.trigger(cr.system_object.prototype.cnds.OnLayoutEnd,null);this.runtime.system.waits.length=0;var a,b,c,d,k,f;a=0;for(b=this.layers.length;a<b;a++){k=this.layers[a].instances;c=0;for(d=k.length;c<d;c++)f=k[c],f.type.global||(this.runtime.typeHasPersistBehavior(f.type)&&this.saveObjectToPersist(f),
this.runtime.DestroyInstance(f));this.runtime.ClearDeathRow();k.length=0;this.layers[a].zindices_stale=!0}a=0;for(b=this.runtime.types_by_index.length;a<b;a++)if(k=this.runtime.types_by_index[a],!(k.global||k.plugin.is_world||k.plugin.singleglobal||k.is_family)){c=0;for(d=k.instances.length;c<d;c++)this.runtime.DestroyInstance(k.instances[c]);this.runtime.ClearDeathRow()}};a.prototype.draw=function(a){var b,c=a,d=!1,k=!this.runtime.fullscreenScalingQuality;k&&(this.runtime.layout_canvas||(this.runtime.layout_canvas=
document.createElement("canvas"),b=this.runtime.layout_canvas,b.width=this.runtime.draw_width,b.height=this.runtime.draw_height,this.runtime.layout_ctx=b.getContext("2d"),d=!0),b=this.runtime.layout_canvas,c=this.runtime.layout_ctx,b.width!==this.runtime.draw_width&&(b.width=this.runtime.draw_width,d=!0),b.height!==this.runtime.draw_height&&(b.height=this.runtime.draw_height,d=!0),d&&(c.webkitImageSmoothingEnabled=this.runtime.linearSampling,c.mozImageSmoothingEnabled=this.runtime.linearSampling,
c.msImageSmoothingEnabled=this.runtime.linearSampling,c.imageSmoothingEnabled=this.runtime.linearSampling));c.globalAlpha=1;c.globalCompositeOperation="source-over";this.runtime.alphaBackground&&!this.hasOpaqueBottomLayer()&&c.clearRect(0,0,this.runtime.draw_width,this.runtime.draw_height);var f,m,d=0;for(f=this.layers.length;d<f;d++)m=this.layers[d],m.visible&&0<m.opacity&&11!==m.blend_mode&&m.draw(c);k&&a.drawImage(b,0,0,this.runtime.width,this.runtime.height)};a.prototype.drawGL=function(a){var b=
0<this.active_effect_types.length||this.runtime.uses_background_blending||!this.runtime.fullscreenScalingQuality;if(b){this.runtime.layout_tex||(this.runtime.layout_tex=a.createEmptyTexture(this.runtime.draw_width,this.runtime.draw_height,this.runtime.linearSampling));if(this.runtime.layout_tex.c2width!==this.runtime.draw_width||this.runtime.layout_tex.c2height!==this.runtime.draw_height)a.deleteTexture(this.runtime.layout_tex),this.runtime.layout_tex=a.createEmptyTexture(this.runtime.draw_width,
this.runtime.draw_height,this.runtime.linearSampling);a.setRenderingToTexture(this.runtime.layout_tex);this.runtime.fullscreenScalingQuality||a.setSize(this.runtime.draw_width,this.runtime.draw_height)}else this.runtime.layout_tex&&(a.setRenderingToTexture(null),a.deleteTexture(this.runtime.layout_tex),this.runtime.layout_tex=null);this.runtime.alphaBackground&&!this.hasOpaqueBottomLayer()&&a.clear(0,0,0,0);var c,d;c=0;for(d=this.layers.length;c<d;c++)this.layers[c].visible&&0<this.layers[c].opacity&&
this.layers[c].drawGL(a);b&&(0===this.active_effect_types.length||1===this.active_effect_types.length&&this.runtime.fullscreenScalingQuality?(1===this.active_effect_types.length?(b=this.active_effect_types[0].index,a.switchProgram(this.active_effect_types[0].shaderindex),a.setProgramParameters(null,1/this.runtime.draw_width,1/this.runtime.draw_height,0,0,1,1,this.scale,this.effect_params[b]),a.programIsAnimated(this.active_effect_types[0].shaderindex)&&(this.runtime.redraw=!0)):a.switchProgram(0),
this.runtime.fullscreenScalingQuality||a.setSize(this.runtime.width,this.runtime.height),a.setRenderingToTexture(null),a.setOpacity(1),a.setTexture(this.runtime.layout_tex),a.setAlphaBlend(),a.resetModelView(),a.updateModelView(),b=this.runtime.width/2,c=this.runtime.height/2,a.quad(-b,c,b,c,b,-c,-b,-c),a.setTexture(null)):this.renderEffectChain(a,null,null,null))};a.prototype.getRenderTarget=function(){return 0<this.active_effect_types.length||this.runtime.uses_background_blending||!this.runtime.fullscreenScalingQuality?
this.runtime.layout_tex:null};a.prototype.getMinLayerScale=function(){var a=this.layers[0].getScale(),b,c,d;b=1;for(c=this.layers.length;b<c;b++)d=this.layers[b],(0!==d.parallaxX||0!==d.parallaxY)&&d.getScale()<a&&(a=d.getScale());return a};a.prototype.scrollToX=function(a){if(!this.unbounded_scrolling){var b=this.runtime.draw_width*(1/this.getMinLayerScale())/2;a>this.width-b&&(a=this.width-b);a<b&&(a=b)}this.scrollX!==a&&(this.scrollX=a,this.runtime.redraw=!0)};a.prototype.scrollToY=function(a){if(!this.unbounded_scrolling){var b=
this.runtime.draw_height*(1/this.getMinLayerScale())/2;a>this.height-b&&(a=this.height-b);a<b&&(a=b)}this.scrollY!==a&&(this.scrollY=a,this.runtime.redraw=!0)};a.prototype.boundScrolling=function(){this.scrollToX(this.scrollX);this.scrollToY(this.scrollY)};a.prototype.renderEffectChain=function(a,b,c,d){var k=c?c.active_effect_types:b?b.active_effect_types:this.active_effect_types,f=c?c.layer.getScale():b?b.getScale():1,m=this.runtime.fx_tex,n,p,q,s,r=0,t=1,w,A=this.runtime.draw_width,D=this.runtime.draw_height,
O=A/2,B=D/2,y=b?b.rcTex:this.rcTex,v=b?b.rcTex2:this.rcTex2,u=0,z=0,E=0,x=0,F=A,G=A,H=D,J=D,S=q=0,W=c?c.layer.getAngle():0;if(c){n=0;for(p=k.length;n<p;n++)q+=a.getProgramBoxExtendHorizontal(k[n].shaderindex),S+=a.getProgramBoxExtendVertical(k[n].shaderindex);s=c.bbox;u=b.layerToCanvas(s.left,s.top,!0,!0);E=b.layerToCanvas(s.left,s.top,!1,!0);F=b.layerToCanvas(s.right,s.bottom,!0,!0);H=b.layerToCanvas(s.right,s.bottom,!1,!0);0!==W&&(n=b.layerToCanvas(s.right,s.top,!0,!0),p=b.layerToCanvas(s.right,
s.top,!1,!0),z=b.layerToCanvas(s.left,s.bottom,!0,!0),x=b.layerToCanvas(s.left,s.bottom,!1,!0),s=cr.min(u,F,n,z),F=cr.max(u,F,n,z),u=s,s=cr.min(E,H,p,x),H=cr.max(E,H,p,x),E=s);u-=q;E-=S;F+=q;H+=S;v.left=u/A;v.top=1-E/D;v.right=F/A;v.bottom=1-H/D;z=u=cr.floor(u);x=E=cr.floor(E);G=F=cr.ceil(F);J=H=cr.ceil(H);z-=q;x-=S;G+=q;J+=S;0>u&&(u=0);0>E&&(E=0);F>A&&(F=A);H>D&&(H=D);0>z&&(z=0);0>x&&(x=0);G>A&&(G=A);J>D&&(J=D);y.left=u/A;y.top=1-E/D;y.right=F/A;y.bottom=1-H/D}else y.left=v.left=0,y.top=v.top=0,
y.right=v.right=1,y.bottom=v.bottom=1;S=c&&((c.angle||W)&&a.programUsesDest(k[0].shaderindex)||0!==q||0!==S||1!==c.opacity||c.type.plugin.must_predraw)||b&&!c&&1!==b.opacity;a.setAlphaBlend();if(S){m[r]||(m[r]=a.createEmptyTexture(A,D,this.runtime.linearSampling));if(m[r].c2width!==A||m[r].c2height!==D)a.deleteTexture(m[r]),m[r]=a.createEmptyTexture(A,D,this.runtime.linearSampling);a.switchProgram(0);a.setRenderingToTexture(m[r]);w=J-x;a.clearRect(z,D-x-w,G-z,w);c?c.drawGL(a):(a.setTexture(this.runtime.layer_tex),
a.setOpacity(b.opacity),a.resetModelView(),a.translate(-O,-B),a.updateModelView(),a.quadTex(u,H,F,H,F,E,u,E,y));v.left=v.top=0;v.right=v.bottom=1;c&&(s=y.top,y.top=y.bottom,y.bottom=s);r=1;t=0}a.setOpacity(1);q=k.length-1;var W=a.programUsesCrossSampling(k[q].shaderindex)||!b&&!c&&!this.runtime.fullscreenScalingQuality,T=0;n=0;for(p=k.length;n<p;n++){m[r]||(m[r]=a.createEmptyTexture(A,D,this.runtime.linearSampling));if(m[r].c2width!==A||m[r].c2height!==D)a.deleteTexture(m[r]),m[r]=a.createEmptyTexture(A,
D,this.runtime.linearSampling);a.switchProgram(k[n].shaderindex);T=k[n].index;a.programIsAnimated(k[n].shaderindex)&&(this.runtime.redraw=!0);0!=n||S?(a.setProgramParameters(d,1/A,1/D,v.left,v.top,v.right,v.bottom,f,c?c.effect_params[T]:b?b.effect_params[T]:this.effect_params[T]),a.setTexture(null),n!==q||W?(a.setRenderingToTexture(m[r]),w=J-x,s=D-x-w,a.clearRect(z,s,G-z,w)):(c?a.setBlend(c.srcBlend,c.destBlend):b&&a.setBlend(b.srcBlend,b.destBlend),a.setRenderingToTexture(d)),a.setTexture(m[t]),
a.resetModelView(),a.translate(-O,-B),a.updateModelView(),a.quadTex(u,H,F,H,F,E,u,E,y),n!==q||W||a.setTexture(null)):(a.setRenderingToTexture(m[r]),w=J-x,s=D-x-w,a.clearRect(z,s,G-z,w),c?(a.setProgramParameters(d,1/c.width,1/c.height,v.left,v.top,v.right,v.bottom,f,c.effect_params[T]),c.drawGL(a)):(a.setProgramParameters(d,1/A,1/D,0,0,1,1,f,b?b.effect_params[T]:this.effect_params[T]),a.setTexture(b?this.runtime.layer_tex:this.runtime.layout_tex),a.resetModelView(),a.translate(-O,-B),a.updateModelView(),
a.quadTex(u,H,F,H,F,E,u,E,y)),v.left=v.top=0,v.right=v.bottom=1,c&&!W&&(s=H,H=E,E=s));r=0===r?1:0;t=0===r?1:0}W&&(a.switchProgram(0),c?a.setBlend(c.srcBlend,c.destBlend):b?a.setBlend(b.srcBlend,b.destBlend):this.runtime.fullscreenScalingQuality||(a.setSize(this.runtime.width,this.runtime.height),O=this.runtime.width/2,B=this.runtime.height/2,E=u=0,F=this.runtime.width,H=this.runtime.height),a.setRenderingToTexture(d),a.setTexture(m[t]),a.resetModelView(),a.translate(-O,-B),a.updateModelView(),c&&
1===k.length&&!S?a.quadTex(u,E,F,E,F,H,u,H,y):a.quadTex(u,H,F,H,F,E,u,E,y),a.setTexture(null))};a.prototype.getLayerBySid=function(a){var b,c;b=0;for(c=this.layers.length;b<c;b++)if(this.layers[b].sid===a)return this.layers[b];return null};a.prototype.saveToJSON=function(){var a,b,c,d={sx:this.scrollX,sy:this.scrollY,s:this.scale,a:this.angle,w:this.width,h:this.height,fv:this.first_visit,persist:this.persist_data,fx:[],layers:{}};a=0;for(b=this.effect_types.length;a<b;a++)c=this.effect_types[a],
d.fx.push({name:c.name,active:c.active,params:this.effect_params[c.index]});a=0;for(b=this.layers.length;a<b;a++)c=this.layers[a],d.layers[c.sid.toString()]=c.saveToJSON();return d};a.prototype.loadFromJSON=function(a){var b,c,d,k;this.scrollX=a.sx;this.scrollY=a.sy;this.scale=a.s;this.angle=a.a;this.width=a.w;this.height=a.h;this.persist_data=a.persist;"undefined"!==typeof a.fv&&(this.first_visit=a.fv);var f=a.fx;b=0;for(c=f.length;b<c;b++)if(d=this.getEffectByName(f[b].name))d.active=f[b].active,
this.effect_params[d.index]=f[b].params;this.updateActiveEffects();b=a.layers;for(k in b)b.hasOwnProperty(k)&&(a=this.getLayerBySid(parseInt(k,10)))&&a.loadFromJSON(b[k])};cr.layout=a;b.prototype.updateActiveEffects=function(){this.active_effect_types.length=0;var a,b,c;a=0;for(b=this.effect_types.length;a<b;a++)c=this.effect_types[a],c.active&&this.active_effect_types.push(c)};b.prototype.getEffectByName=function(a){var b,c,d;b=0;for(c=this.effect_types.length;b<c;b++)if(d=this.effect_types[b],d.name===
a)return d;return null};b.prototype.createInitialInstances=function(){var a,b,c,l,k,f;b=a=0;for(c=this.initial_instances.length;a<c;a++){l=this.initial_instances[a];k=this.runtime.types_by_index[l[1]];f=this.runtime.typeHasPersistBehavior(k);k=!0;if(!f||this.layout.first_visit)l=this.runtime.createInstanceFromInit(l,this,!0),d.push(l),l.type.global&&(k=!1);k&&(this.initial_instances[b]=this.initial_instances[a],b++)}this.initial_instances.length=b;this.runtime.ClearDeathRow();!this.runtime.glwrap&&
this.effect_types.length&&(this.blend_mode=this.effect_fallback);this.compositeOp=cr.effectToCompositeOp(this.blend_mode);this.runtime.gl&&cr.setGLBlend(this,this.blend_mode,this.runtime.gl)};b.prototype.updateZIndices=function(){if(this.zindices_stale){var a,b;a=0;for(b=this.instances.length;a<b;a++)this.instances[a].zindex=a;this.zindices_stale=!1}};b.prototype.getScale=function(a){return this.getNormalScale()*(this.runtime.fullscreenScalingQuality||a?this.runtime.aspect_scale:1)};b.prototype.getNormalScale=
function(){return(this.scale*this.layout.scale-1)*this.zoomRate+1};b.prototype.getAngle=function(){return this.disableAngle?0:cr.clamp_angle(this.layout.angle+this.angle)};b.prototype.draw=function(a){this.render_offscreen=this.forceOwnTexture||1!==this.opacity||0!==this.blend_mode;var b=this.runtime.canvas,c=a,d=!1;a.globalAlpha=1;a.globalCompositeOperation="source-over";this.render_offscreen&&(this.runtime.layer_canvas||(this.runtime.layer_canvas=document.createElement("canvas"),b=this.runtime.layer_canvas,
b.width=this.runtime.draw_width,b.height=this.runtime.draw_height,this.runtime.layer_ctx=b.getContext("2d"),d=!0),b=this.runtime.layer_canvas,c=this.runtime.layer_ctx,b.width!==this.runtime.draw_width&&(b.width=this.runtime.draw_width,d=!0),b.height!==this.runtime.draw_height&&(b.height=this.runtime.draw_height,d=!0),d&&(c.webkitImageSmoothingEnabled=this.runtime.linearSampling,c.mozImageSmoothingEnabled=this.runtime.linearSampling,c.msImageSmoothingEnabled=this.runtime.linearSampling,c.imageSmoothingEnabled=
this.runtime.linearSampling),this.transparent&&c.clearRect(0,0,this.runtime.draw_width,this.runtime.draw_height));this.transparent||(c.fillStyle="rgb("+this.background_color[0]+","+this.background_color[1]+","+this.background_color[2]+")",c.fillRect(0,0,this.runtime.draw_width,this.runtime.draw_height));c.save();this.disableAngle=!0;var d=this.canvasToLayer(0,0,!0,!0),k=this.canvasToLayer(0,0,!1,!0);this.disableAngle=!1;this.runtime.pixel_rounding&&(d=d+0.5|0,k=k+0.5|0);this.rotateViewport(d,k,c);
var f=this.getScale();c.scale(f,f);c.translate(-d,-k);for(var m,d=0,k=this.instances.length;d<k;d++)f=this.instances[d],f.visible&&0!==f.width&&0!==f.height&&(f.update_bbox(),m=f.bbox,m.right<this.viewLeft||m.bottom<this.viewTop||m.left>this.viewRight||m.top>this.viewBottom||(c.globalCompositeOperation=f.compositeOp,f.draw(c)));c.restore();this.render_offscreen&&(a.globalCompositeOperation=this.compositeOp,a.globalAlpha=this.opacity,a.drawImage(b,0,0))};b.prototype.rotateViewport=function(a,b,c){var d=
this.getScale();this.viewLeft=a;this.viewTop=b;this.viewRight=a+this.runtime.draw_width*(1/d);this.viewBottom=b+this.runtime.draw_height*(1/d);a=this.getAngle();0!==a&&(c&&(c.translate(this.runtime.draw_width/2,this.runtime.draw_height/2),c.rotate(-a),c.translate(this.runtime.draw_width/-2,this.runtime.draw_height/-2)),this.tmprect.set(this.viewLeft,this.viewTop,this.viewRight,this.viewBottom),this.tmprect.offset((this.viewLeft+this.viewRight)/-2,(this.viewTop+this.viewBottom)/-2),this.tmpquad.set_from_rotated_rect(this.tmprect,
a),this.tmpquad.bounding_box(this.tmprect),this.tmprect.offset((this.viewLeft+this.viewRight)/2,(this.viewTop+this.viewBottom)/2),this.viewLeft=this.tmprect.left,this.viewTop=this.tmprect.top,this.viewRight=this.tmprect.right,this.viewBottom=this.tmprect.bottom)};b.prototype.drawGL=function(a){var b=this.runtime.draw_width,c=this.runtime.draw_height,d=0,k=0;if(this.render_offscreen=this.forceOwnTexture||1!==this.opacity||0<this.active_effect_types.length||0!==this.blend_mode){this.runtime.layer_tex||
(this.runtime.layer_tex=a.createEmptyTexture(this.runtime.draw_width,this.runtime.draw_height,this.runtime.linearSampling));if(this.runtime.layer_tex.c2width!==this.runtime.draw_width||this.runtime.layer_tex.c2height!==this.runtime.draw_height)a.deleteTexture(this.runtime.layer_tex),this.runtime.layer_tex=a.createEmptyTexture(this.runtime.draw_width,this.runtime.draw_height,this.runtime.linearSampling);a.setRenderingToTexture(this.runtime.layer_tex);this.transparent&&a.clear(0,0,0,0)}this.transparent||
a.clear(this.background_color[0]/255,this.background_color[1]/255,this.background_color[2]/255,1);this.disableAngle=!0;var k=this.canvasToLayer(0,0,!0,!0),f=this.canvasToLayer(0,0,!1,!0);this.disableAngle=!1;this.runtime.pixel_rounding&&(k=k+0.5|0,f=f+0.5|0);this.rotateViewport(k,f,null);f=this.getScale();a.resetModelView();a.scale(f,f);a.rotateZ(-this.getAngle());a.translate((this.viewLeft+this.viewRight)/-2,(this.viewTop+this.viewBottom)/-2);a.updateModelView();var m,n,p;m=0;for(n=this.instances.length;m<
n;m++)if(p=this.instances[m],p.visible&&0!==p.width&&0!==p.height&&(p.update_bbox(),d=p.bbox,!(d.right<this.viewLeft||d.bottom<this.viewTop||d.left>this.viewRight||d.top>this.viewBottom)))if(p.uses_shaders)if(d=p.active_effect_types[0].shaderindex,k=p.active_effect_types[0].index,1!==p.active_effect_types.length||a.programUsesCrossSampling(d)||a.programExtendsBox(d)||(p.angle||p.layer.getAngle())&&a.programUsesDest(d)||1!==p.opacity||p.type.plugin.must_predraw)this.layout.renderEffectChain(a,this,
p,this.render_offscreen?this.runtime.layer_tex:this.layout.getRenderTarget()),a.resetModelView(),a.scale(f,f),a.rotateZ(-this.getAngle()),a.translate((this.viewLeft+this.viewRight)/-2,(this.viewTop+this.viewBottom)/-2),a.updateModelView();else{a.switchProgram(d);a.setBlend(p.srcBlend,p.destBlend);a.programIsAnimated(d)&&(this.runtime.redraw=!0);var q=0,s=0,r=0,t=0;a.programUsesDest(d)&&(d=p.bbox,q=this.layerToCanvas(d.left,d.top,!0,!0),s=this.layerToCanvas(d.left,d.top,!1,!0),r=this.layerToCanvas(d.right,
d.bottom,!0,!0),d=this.layerToCanvas(d.right,d.bottom,!1,!0),q/=b,s=1-s/c,r/=b,t=1-d/c);a.setProgramParameters(this.render_offscreen?this.runtime.layer_tex:this.layout.getRenderTarget(),1/p.width,1/p.height,q,s,r,t,this.getScale(),p.effect_params[k]);p.drawGL(a)}else a.switchProgram(0),a.setBlend(p.srcBlend,p.destBlend),p.drawGL(a);this.render_offscreen&&(d=this.active_effect_types.length?this.active_effect_types[0].shaderindex:0,k=this.active_effect_types.length?this.active_effect_types[0].index:
0,0===this.active_effect_types.length||1===this.active_effect_types.length&&!a.programUsesCrossSampling(d)&&1===this.opacity?(1===this.active_effect_types.length?(a.switchProgram(d),a.setProgramParameters(this.layout.getRenderTarget(),1/this.runtime.draw_width,1/this.runtime.draw_height,0,0,1,1,this.getScale(),this.effect_params[k]),a.programIsAnimated(d)&&(this.runtime.redraw=!0)):a.switchProgram(0),a.setRenderingToTexture(this.layout.getRenderTarget()),a.setOpacity(this.opacity),a.setTexture(this.runtime.layer_tex),
a.setBlend(this.srcBlend,this.destBlend),a.resetModelView(),a.updateModelView(),b=this.runtime.draw_width/2,c=this.runtime.draw_height/2,a.quad(-b,c,b,c,b,-c,-b,-c),a.setTexture(null)):this.layout.renderEffectChain(a,this,null,this.layout.getRenderTarget()))};b.prototype.canvasToLayer=function(a,b,c,d){var k=this.runtime.devicePixelRatio;this.runtime.isRetina&&(a*=k,b*=k);var k=this.runtime.original_width/2,f=this.runtime.original_height/2,k=(this.layout.scrollX-k)*this.parallaxX+k,f=(this.layout.scrollY-
f)*this.parallaxY+f,m=1/this.getScale(!d);d?(k-=this.runtime.draw_width*m/2,f-=this.runtime.draw_height*m/2):(k-=this.runtime.width*m/2,f-=this.runtime.height*m/2);k+=a*m;f+=b*m;b=this.getAngle();0!==b&&(k-=this.layout.scrollX,f-=this.layout.scrollY,a=Math.cos(b),b=Math.sin(b),d=k*a-f*b,f=f*a+k*b,k=d+this.layout.scrollX,f+=this.layout.scrollY);return c?k:f};b.prototype.layerToCanvas=function(a,b,c,d){var k=this.getAngle();if(0!==k){a-=this.layout.scrollX;b-=this.layout.scrollY;var f=Math.cos(-k),
k=Math.sin(-k),m=a*f-b*k;b=b*f+a*k;a=m+this.layout.scrollX;b+=this.layout.scrollY}f=this.runtime.original_width/2;k=this.runtime.original_height/2;f=(this.layout.scrollX-f)*this.parallaxX+f;k=(this.layout.scrollY-k)*this.parallaxY+k;m=1/this.getScale(!d);d?(f-=this.runtime.draw_width*m/2,k-=this.runtime.draw_height*m/2):(f-=this.runtime.width*m/2,k-=this.runtime.height*m/2);f=(a-f)/m;k=(b-k)/m;a=this.runtime.devicePixelRatio;this.runtime.isRetina&&(f/=a,k/=a);return c?f:k};b.prototype.rotatePt=function(a,
b,c){if(0===this.getAngle())return c?a:b;var d=this.layerToCanvas(a,b,!0);b=this.layerToCanvas(a,b,!1);this.disableAngle=!0;a=this.canvasToLayer(d,b,!0);d=this.canvasToLayer(d,b,!0);this.disableAngle=!1;return c?a:d};b.prototype.saveToJSON=function(){var a,b,c,d={s:this.scale,a:this.angle,vl:this.viewLeft,vt:this.viewTop,vr:this.viewRight,vb:this.viewBottom,v:this.visible,bc:this.background_color,t:this.transparent,px:this.parallaxX,py:this.parallaxY,o:this.opacity,zr:this.zoomRate,fx:[],instances:[]};
a=0;for(b=this.effect_types.length;a<b;a++)c=this.effect_types[a],d.fx.push({name:c.name,active:c.active,params:this.effect_params[c.index]});return d};b.prototype.loadFromJSON=function(a){var b,d;this.scale=a.s;this.angle=a.a;this.viewLeft=a.vl;this.viewTop=a.vt;this.viewRight=a.vr;this.viewBottom=a.vb;this.visible=a.v;this.background_color=a.bc;this.transparent=a.t;this.parallaxX=a.px;this.parallaxY=a.py;this.opacity=a.o;this.zoomRate=a.zr;var l=a.fx;a=0;for(b=l.length;a<b;a++)if(d=this.getEffectByName(l[a].name))d.active=
l[a].active,this.effect_params[d.index]=l[a].params;this.updateActiveEffects();this.instances.sort(c);this.zindices_stale=!0};cr.layer=b})();
(function(){function a(a,b){var c,d=a.length;switch(d){case 0:return!0;case 1:return a[0]===b[0];case 2:return a[0]===b[0]&&a[1]===b[1];default:for(c=0;c<d;c++)if(a[c]!==b[c])return!1;return!0}}function b(a,b){return a.index-b.index}function c(c){var d,e,f,g;2===c.length?c[0].index>c[1].index&&(d=c[0],c[0]=c[1],c[1]=d):2<c.length&&c.sort(b);c.length>=q.length&&(q.length=c.length+1);q[c.length]||(q[c.length]=[]);g=q[c.length];d=0;for(e=g.length;d<e;d++)if(f=g[d],a(c,f))return f;g.push(c);return c}
function d(a,b){this.runtime=a;this.triggers={};this.fasttriggers={};this.hasRun=!1;this.includes=new cr.ObjectSet;this.name=b[0];var c=b[1];this.events=[];var d,e;d=0;for(e=c.length;d<e;d++)this.init_event(c[d],null,this.events)}function e(a){this.type=a;this.instances=[];this.else_instances=[];this.select_all=!0}function h(a,b,c){this.sheet=a;this.parent=b;this.runtime=a.runtime;this.solModifiers=[];this.solModifiersIncludingParents=[];this.has_else_block=this.toplevelgroup=this.toplevelevent=this.initially_activated=
this.group=this.solWriterAfterCnds=!1;this.conditions=[];this.actions=[];this.subevents=[];c[1]?(this.group_name=c[1][1].toLowerCase(),this.group=!0,this.initially_activated=!!c[1][0],this.runtime.allGroups.push(this),this.runtime.activeGroups[this.group_name.toLowerCase()]=this.initially_activated):(this.group_name="",this.initially_activated=this.group=!1);this.orblock=c[2];this.sid=c[4];this.group||(this.runtime.blocksBySid[this.sid.toString()]=this);var d=c[5];a=0;for(b=d.length;a<b;a++){var e=
new cr.condition(this,d[a]);e.index=a;cr.seal(e);this.conditions.push(e);this.addSolModifier(e.type)}d=c[6];a=0;for(b=d.length;a<b;a++)e=new cr.action(this,d[a]),e.index=a,cr.seal(e),this.actions.push(e);if(8===c.length)for(c=c[7],a=0,b=c.length;a<b;a++)this.sheet.init_event(c[a],this,this.subevents);this.is_else_block=!1;this.conditions.length&&(this.is_else_block=null==this.conditions[0].type&&this.conditions[0].func==cr.system_object.prototype.cnds.Else)}function g(a,b){var c,d,e;if(a&&(-1===b.indexOf(a)&&
b.push(a),a.is_contained))for(c=0,d=a.container.length;c<d;c++)e=a.container[c],a!==e&&-1===b.indexOf(e)&&b.push(e)}function l(a,b){this.block=a;this.sheet=a.sheet;this.runtime=a.runtime;this.parameters=[];this.results=[];this.extra={};this.index=-1;this.func=b[1];this.trigger=0<b[3];this.fasttrigger=2===b[3];this.looping=b[4];this.inverted=b[5];this.isstatic=b[6];this.sid=b[7];this.runtime.cndsBySid[this.sid.toString()]=this;-1===b[0]?(this.type=null,this.run=this.run_system,this.behaviortype=null,
this.beh_index=-1):(this.type=this.runtime.types_by_index[b[0]],this.run=this.isstatic?this.run_static:this.run_object,b[2]?(this.behaviortype=this.type.getBehaviorByName(b[2]),this.beh_index=this.type.getBehaviorIndexByName(b[2])):(this.behaviortype=null,this.beh_index=-1),this.block.parent&&this.block.parent.setSolWriterAfterCnds());this.fasttrigger&&(this.run=this.run_true);if(10===b.length){var c,d,e=b[9];c=0;for(d=e.length;c<d;c++){var f=new cr.parameter(this,e[c]);cr.seal(f);this.parameters.push(f)}this.results.length=
e.length}}function k(a,b){this.block=a;this.sheet=a.sheet;this.runtime=a.runtime;this.parameters=[];this.results=[];this.extra={};this.index=-1;this.func=b[1];-1===b[0]?(this.type=null,this.run=this.run_system,this.behaviortype=null,this.beh_index=-1):(this.type=this.runtime.types_by_index[b[0]],this.run=this.run_object,b[2]?(this.behaviortype=this.type.getBehaviorByName(b[2]),this.beh_index=this.type.getBehaviorIndexByName(b[2])):(this.behaviortype=null,this.beh_index=-1));this.sid=b[3];this.runtime.actsBySid[this.sid.toString()]=
this;if(6===b.length){var c,d,e=b[5];c=0;for(d=e.length;c<d;c++){var f=new cr.parameter(this,e[c]);cr.seal(f);this.parameters.push(f)}this.results.length=e.length}}function f(a,b){this.owner=a;this.block=a.block;this.sheet=a.sheet;this.runtime=a.runtime;this.type=b[0];this.expression=null;this.combosel=this.solindex=0;this.layout=null;this.key=0;this.object=null;this.index=0;this.variadicret=this.subparams=this.fileinfo=this.eventvar=this.varname=null;var c,d,e;switch(b[0]){case 0:case 7:this.expression=
new cr.expNode(this,b[1]);this.solindex=0;this.get=this.get_exp;break;case 1:this.expression=new cr.expNode(this,b[1]);this.solindex=0;this.get=this.get_exp_str;break;case 5:this.expression=new cr.expNode(this,b[1]);this.solindex=0;this.get=this.get_layer;break;case 3:case 8:this.combosel=b[1];this.get=this.get_combosel;break;case 6:this.layout=this.runtime.layouts[b[1]];this.get=this.get_layout;break;case 9:this.key=b[1];this.get=this.get_key;break;case 4:this.object=this.runtime.types_by_index[b[1]];
this.get=this.get_object;this.block.addSolModifier(this.object);this.owner instanceof cr.action?this.block.setSolWriterAfterCnds():this.block.parent&&this.block.parent.setSolWriterAfterCnds();break;case 10:this.index=b[1];this.get=a.type.is_family?this.get_familyvar:this.get_instvar;break;case 11:this.varname=b[1];this.eventvar=null;this.get=this.get_eventvar;break;case 2:case 12:this.fileinfo=b[1];this.get=this.get_audiofile;break;case 13:for(this.get=this.get_variadic,this.subparams=[],this.variadicret=
[],c=1,d=b.length;c<d;c++)e=new cr.parameter(this.owner,b[c]),cr.seal(e),this.subparams.push(e),this.variadicret.push(0)}}function m(a,b,c){this.sheet=a;this.parent=b;this.runtime=a.runtime;this.solModifiers=[];this.name=c[1];this.vartype=c[2];this.initial=c[3];this.is_static=!!c[4];this.is_constant=!!c[5];this.sid=c[6];this.runtime.varsBySid[this.sid.toString()]=this;this.data=this.initial;this.parent?(this.localIndex=this.is_static||this.is_constant?-1:this.runtime.stackLocalCount++,this.runtime.all_local_vars.push(this)):
(this.localIndex=-1,this.runtime.all_global_vars.push(this))}function n(a,b,c){this.sheet=a;this.parent=b;this.runtime=a.runtime;this.solModifiers=[];this.include_sheet=null;this.include_sheet_name=c[1]}function p(){this.temp_parents_arr=[];this.reset(null);cr.seal(this)}var q=[];d.prototype.toString=function(){return this.name};d.prototype.init_event=function(a,b,c){switch(a[0]){case 0:a=new cr.eventblock(this,b,a);cr.seal(a);if(a.orblock)for(c.push(a),c=0,b=a.conditions.length;c<b;c++)a.conditions[c].trigger&&
this.init_trigger(a,c);else a.is_trigger()?this.init_trigger(a,0):c.push(a);break;case 1:a=new cr.eventvariable(this,b,a);cr.seal(a);c.push(a);break;case 2:a=new cr.eventinclude(this,b,a),cr.seal(a),c.push(a)}};d.prototype.postInit=function(){var a,b;a=0;for(b=this.events.length;a<b;a++)this.events[a].postInit(a<b-1&&this.events[a+1].is_else_block)};d.prototype.run=function(a){this.runtime.resuming_breakpoint||(this.hasRun=!0,a||(this.runtime.isRunningEvents=!0));var b,c;b=0;for(c=this.events.length;b<
c;b++){var d=this.events[b];d.run();this.runtime.clearSol(d.solModifiers);this.runtime.deathRow.isEmpty()&&!this.runtime.createRow.length||this.runtime.ClearDeathRow()}a||(this.runtime.isRunningEvents=!1)};d.prototype.init_trigger=function(a,b){a.orblock||this.runtime.triggers_to_postinit.push(a);var c,d,e=a.conditions[b],f;f=e.type?e.type.name:"system";var g=(c=e.fasttrigger)?this.fasttriggers:this.triggers;g[f]||(g[f]=[]);f=g[f];g=e.func;if(c){if(e.parameters.length&&(e=e.parameters[0],1===e.type&&
2===e.expression.type)){e=e.expression.value.toLowerCase();c=0;for(d=f.length;c<d;c++)if(f[c].method==g){c=f[c].evs;c[e]?c[e].push([a,b]):c[e]=[[a,b]];return}c={};c[e]=[[a,b]];f.push({method:g,evs:c})}}else{c=0;for(d=f.length;c<d;c++)if(f[c].method==g){f[c].evs.push([a,b]);return}f.push({method:g,evs:[[a,b]]})}};cr.eventsheet=d;e.prototype.hasObjects=function(){return this.select_all?this.type.instances.length:this.instances.length};e.prototype.getObjects=function(){return this.select_all?this.type.instances:
this.instances};e.prototype.pick_one=function(a){a&&(a.runtime.getCurrentEventStack().current_event.orblock?(this.select_all&&(this.instances.length=0,cr.shallowAssignArray(this.else_instances,a.type.instances),this.select_all=!1),a=this.else_instances.indexOf(a),-1!==a&&(this.instances.push(this.else_instances[a]),this.else_instances.splice(a,1))):(this.select_all=!1,this.instances.length=1,this.instances[0]=a))};cr.selection=e;h.prototype.postInit=function(a){var b,d=this.parent;if(this.group)for(this.toplevelgroup=
!0;d;){if(!d.group){this.toplevelgroup=!1;break}d=d.parent}this.toplevelevent=!this.is_trigger()&&(!this.parent||this.parent.group&&this.parent.toplevelgroup);this.has_else_block=!!a;this.solModifiersIncludingParents=this.solModifiers.slice(0);for(d=this.parent;d;){a=0;for(b=d.solModifiers.length;a<b;a++)this.addParentSolModifier(d.solModifiers[a]);d=d.parent}this.solModifiers=c(this.solModifiers);this.solModifiersIncludingParents=c(this.solModifiersIncludingParents);a=0;for(b=this.conditions.length;a<
b;a++)this.conditions[a].postInit();a=0;for(b=this.actions.length;a<b;a++)this.actions[a].postInit();a=0;for(b=this.subevents.length;a<b;a++)this.subevents[a].postInit(a<b-1&&this.subevents[a+1].is_else_block)};h.prototype.addSolModifier=function(a){g(a,this.solModifiers)};h.prototype.addParentSolModifier=function(a){g(a,this.solModifiersIncludingParents)};h.prototype.setSolWriterAfterCnds=function(){this.solWriterAfterCnds=!0;this.parent&&this.parent.setSolWriterAfterCnds()};h.prototype.is_trigger=
function(){return this.conditions.length?this.conditions[0].trigger:!1};h.prototype.run=function(){var a,b=!1,c,d=this.runtime.getCurrentEventStack();d.current_event=this;this.is_else_block||(d.else_branch_ran=!1);if(this.orblock){0===this.conditions.length&&(b=!0);d.cndindex=0;for(a=this.conditions.length;d.cndindex<a;d.cndindex++)this.conditions[d.cndindex].trigger||(c=this.conditions[d.cndindex].run())&&(b=!0);(d.last_event_true=b)&&this.run_actions_and_subevents()}else{d.cndindex=0;for(a=this.conditions.length;d.cndindex<
a;d.cndindex++)if(c=this.conditions[d.cndindex].run(),!c){d.last_event_true=!1;!this.toplevelevent||this.runtime.deathRow.isEmpty()&&!this.runtime.createRow.length||this.runtime.ClearDeathRow();return}d.last_event_true=!0;this.run_actions_and_subevents()}this.end_run(d)};h.prototype.end_run=function(a){a.last_event_true&&this.has_else_block&&(a.else_branch_ran=!0);!this.toplevelevent||this.runtime.deathRow.isEmpty()&&!this.runtime.createRow.length||this.runtime.ClearDeathRow()};h.prototype.run_orblocktrigger=
function(a){this.runtime.getCurrentEventStack().current_event=this;this.conditions[a].run()&&(this.run_actions_and_subevents(),this.runtime.getCurrentEventStack().last_event_true=!0)};h.prototype.run_actions_and_subevents=function(){var a=this.runtime.getCurrentEventStack(),b;a.actindex=0;for(b=this.actions.length;a.actindex<b;a.actindex++)if(this.actions[a.actindex].run())return;this.run_subevents()};h.prototype.resume_actions_and_subevents=function(){var a=this.runtime.getCurrentEventStack(),b;
for(b=this.actions.length;a.actindex<b;a.actindex++)if(this.actions[a.actindex].run())return;this.run_subevents()};h.prototype.run_subevents=function(){if(this.subevents.length){var a,b,c,d,e=this.subevents.length-1;this.runtime.pushEventStack(this);if(this.solWriterAfterCnds)for(a=0,b=this.subevents.length;a<b;a++)c=this.subevents[a],(d=!this.toplevelgroup||!this.group&&a<e)&&this.runtime.pushCopySol(c.solModifiers),c.run(),d?this.runtime.popSol(c.solModifiers):this.runtime.clearSol(c.solModifiers);
else for(a=0,b=this.subevents.length;a<b;a++)this.subevents[a].run();this.runtime.popEventStack()}};h.prototype.run_pretrigger=function(){var a=this.runtime.getCurrentEventStack();a.current_event=this;var b=!1,c;a.cndindex=0;for(c=this.conditions.length;a.cndindex<c;a.cndindex++)if(this.conditions[a.cndindex].run())b=!0;else if(!this.orblock)return!1;return this.orblock?b:!0};h.prototype.retrigger=function(){this.runtime.execcount++;var a=this.runtime.getCurrentEventStack().cndindex,b=this.runtime.pushEventStack(this);
if(!this.orblock)for(b.cndindex=a+1,a=this.conditions.length;b.cndindex<a;b.cndindex++)if(!this.conditions[b.cndindex].run())return this.runtime.popEventStack(),!1;this.run_actions_and_subevents();this.runtime.popEventStack();return!0};h.prototype.isFirstConditionOfType=function(a){var b=a.index;if(0===b)return!0;for(--b;0<=b;--b)if(this.conditions[b].type===a.type)return!1;return!0};cr.eventblock=h;l.prototype.postInit=function(){var a,b;a=0;for(b=this.parameters.length;a<b;a++)this.parameters[a].postInit()};
l.prototype.run_true=function(){return!0};l.prototype.run_system=function(){var a,b;a=0;for(b=this.parameters.length;a<b;a++)this.results[a]=this.parameters[a].get();return cr.xor(this.func.apply(this.runtime.system,this.results),this.inverted)};l.prototype.run_static=function(){var a,b;a=0;for(b=this.parameters.length;a<b;a++)this.results[a]=this.parameters[a].get(a);a=this.func.apply(this.behaviortype?this.behaviortype:this.type,this.results);this.type.applySolToContainer();return a};l.prototype.run_object=
function(){var a,b,c,d,e,f,g,k=this.type.getCurrentSol(),h=this.block.orblock&&!this.trigger,m=0,n=this.type.is_contained;if(k.select_all){k.instances.length=0;a=k.else_instances.length=0;for(c=this.type.instances.length;a<c;a++){f=this.type.instances[a];b=0;for(d=this.parameters.length;b<d;b++)this.results[b]=this.parameters[b].get(a);-1<this.beh_index?(this.type.is_family&&(m=f.type.family_beh_map[this.type.family_index]),b=this.func.apply(f.behavior_insts[this.beh_index+m],this.results)):b=this.func.apply(f,
this.results);(e=cr.xor(b,this.inverted))?k.instances.push(f):h&&k.else_instances.push(f)}this.type.finish&&this.type.finish(!0);k.select_all=!1;this.type.applySolToContainer();return k.hasObjects()}var q=0,l=(e=h&&!this.block.isFirstConditionOfType(this))?k.else_instances:k.instances,r=!1;a=0;for(c=l.length;a<c;a++){f=l[a];b=0;for(d=this.parameters.length;b<d;b++)this.results[b]=this.parameters[b].get(a);-1<this.beh_index?(this.type.is_family&&(m=f.type.family_beh_map[this.type.family_index]),b=
this.func.apply(f.behavior_insts[this.beh_index+m],this.results)):b=this.func.apply(f,this.results);if(cr.xor(b,this.inverted))if(r=!0,e){if(k.instances.push(f),n)for(b=0,d=f.siblings.length;b<d;b++)g=f.siblings[b],g.type.getCurrentSol().instances.push(g)}else{l[q]=f;if(n)for(b=0,d=f.siblings.length;b<d;b++)g=f.siblings[b],g.type.getCurrentSol().instances[q]=g;q++}else if(e){l[q]=f;if(n)for(b=0,d=f.siblings.length;b<d;b++)g=f.siblings[b],g.type.getCurrentSol().else_instances[q]=g;q++}else if(h&&(k.else_instances.push(f),
n))for(b=0,d=f.siblings.length;b<d;b++)g=f.siblings[b],g.type.getCurrentSol().else_instances.push(g)}l.length=q;if(n)for(a=0,c=this.type.container.length;a<c;a++)f=this.type.container[a].getCurrentSol(),e?f.else_instances.length=q:f.instances.length=q;m=r;if(e&&!r)for(a=0,c=k.instances.length;a<c;a++){f=k.instances[a];b=0;for(d=this.parameters.length;b<d;b++)this.results[b]=this.parameters[b].get(a);b=-1<this.beh_index?this.func.apply(f.behavior_insts[this.beh_index],this.results):this.func.apply(f,
this.results);if(cr.xor(b,this.inverted)){r=!0;break}}this.type.finish&&this.type.finish(m||h);return h?r:k.hasObjects()};cr.condition=l;k.prototype.postInit=function(){var a,b;a=0;for(b=this.parameters.length;a<b;a++)this.parameters[a].postInit()};k.prototype.run_system=function(){var a,b;a=0;for(b=this.parameters.length;a<b;a++)this.results[a]=this.parameters[a].get();return this.func.apply(this.runtime.system,this.results)};k.prototype.run_object=function(){var a=this.type.getCurrentSol().getObjects(),
b,c,d,e,f;b=0;for(d=a.length;b<d;b++){f=a[b];c=0;for(e=this.parameters.length;c<e;c++)this.results[c]=this.parameters[c].get(b);-1<this.beh_index?(c=0,this.type.is_family&&(c=f.type.family_beh_map[this.type.family_index]),this.func.apply(f.behavior_insts[this.beh_index+c],this.results)):this.func.apply(f,this.results)}return!1};cr.action=k;var s=[],r=-1;f.prototype.postInit=function(){var a,b;if(11===this.type)this.eventvar=this.runtime.getEventVariableByName(this.varname,this.block.parent);else if(13===
this.type)for(a=0,b=this.subparams.length;a<b;a++)this.subparams[a].postInit();this.expression&&this.expression.postInit()};f.prototype.pushTempValue=function(){r++;s.length===r&&s.push(new cr.expvalue);return s[r]};f.prototype.popTempValue=function(){r--};f.prototype.get_exp=function(a){this.solindex=a||0;a=this.pushTempValue();this.expression.get(a);this.popTempValue();return a.data};f.prototype.get_exp_str=function(a){this.solindex=a||0;a=this.pushTempValue();this.expression.get(a);this.popTempValue();
return cr.is_string(a.data)?a.data:""};f.prototype.get_object=function(){return this.object};f.prototype.get_combosel=function(){return this.combosel};f.prototype.get_layer=function(a){this.solindex=a||0;a=this.pushTempValue();this.expression.get(a);this.popTempValue();return a.is_number()?this.runtime.getLayerByNumber(a.data):this.runtime.getLayerByName(a.data)};f.prototype.get_layout=function(){return this.layout};f.prototype.get_key=function(){return this.key};f.prototype.get_instvar=function(){return this.index};
f.prototype.get_familyvar=function(a){var b=this.owner.type,c=null,c=b.getCurrentSol(),d=c.getObjects(),c=d.length?d[a%d.length].type:c.else_instances[a%c.else_instances.length].type;return this.index+c.family_var_map[b.family_index]};f.prototype.get_eventvar=function(){return this.eventvar};f.prototype.get_audiofile=function(){return this.fileinfo};f.prototype.get_variadic=function(){var a,b;a=0;for(b=this.subparams.length;a<b;a++)this.variadicret[a]=this.subparams[a].get();return this.variadicret};
cr.parameter=f;m.prototype.postInit=function(){this.solModifiers=c(this.solModifiers)};m.prototype.setValue=function(a){var b=this.runtime.getCurrentLocalVarStack();this.parent&&!this.is_static&&b?(this.localIndex>=b.length&&(b.length=this.localIndex+1),b[this.localIndex]=a):this.data=a};m.prototype.getValue=function(){var a=this.runtime.getCurrentLocalVarStack();return!this.parent||this.is_static||!a||this.is_constant?this.data:this.localIndex>=a.length||"undefined"===typeof a[this.localIndex]?this.initial:
a[this.localIndex]};m.prototype.run=function(){!this.parent||this.is_static||this.is_constant||this.setValue(this.initial)};cr.eventvariable=m;n.prototype.toString=function(){return"include:"+this.include_sheet.toString()};n.prototype.postInit=function(){this.include_sheet=this.runtime.eventsheets[this.include_sheet_name];this.sheet.includes.add(this);this.solModifiers=c(this.solModifiers)};n.prototype.run=function(){this.parent&&this.runtime.pushCleanSol(this.runtime.types_by_index);this.include_sheet.hasRun||
this.include_sheet.run(!0);this.parent&&this.runtime.popSol(this.runtime.types_by_index)};n.prototype.isActive=function(){for(var a=this.parent;a;){if(a.group&&!this.runtime.activeGroups[a.group_name.toLowerCase()])return!1;a=a.parent}return!0};cr.eventinclude=n;p.prototype.reset=function(a){this.current_event=a;this.actindex=this.cndindex=0;this.temp_parents_arr.length=0;this.any_true_state=this.else_branch_ran=this.last_event_true=!1};p.prototype.isModifierAfterCnds=function(){return this.current_event.solWriterAfterCnds?
!0:this.cndindex<this.current_event.conditions.length-1?!!this.current_event.solModifiers.length:!1};cr.eventStackFrame=p})();
(function(){function a(a,b){this.owner=a;this.runtime=a.runtime;this.type=b[0];this.get=[this.eval_int,this.eval_float,this.eval_string,this.eval_unaryminus,this.eval_add,this.eval_subtract,this.eval_multiply,this.eval_divide,this.eval_mod,this.eval_power,this.eval_and,this.eval_or,this.eval_equal,this.eval_notequal,this.eval_less,this.eval_lessequal,this.eval_greater,this.eval_greaterequal,this.eval_conditional,this.eval_system_exp,this.eval_object_behavior_exp,this.eval_instvar_exp,this.eval_object_behavior_exp,
this.eval_eventvar_exp][this.type];var e=null;this.object_type=this.parameters=this.results=this.func=this.third=this.second=this.first=this.value=null;this.beh_index=-1;this.instance_expr=null;this.varindex=-1;this.eventvar=this.varname=this.behavior_type=null;this.return_string=!1;switch(this.type){case 0:case 1:case 2:this.value=b[1];break;case 3:this.first=new cr.expNode(a,b[1]);break;case 18:this.first=new cr.expNode(a,b[1]);this.second=new cr.expNode(a,b[2]);this.third=new cr.expNode(a,b[3]);
break;case 19:this.func=b[1];this.results=[];this.parameters=[];3===b.length?(e=b[2],this.results.length=e.length+1):this.results.length=1;break;case 20:this.object_type=this.runtime.types_by_index[b[1]];this.beh_index=-1;this.func=b[2];this.return_string=b[3];this.instance_expr=b[4]?new cr.expNode(a,b[4]):null;this.results=[];this.parameters=[];6===b.length?(e=b[5],this.results.length=e.length+1):this.results.length=1;break;case 21:this.object_type=this.runtime.types_by_index[b[1]];this.return_string=
b[2];this.instance_expr=b[3]?new cr.expNode(a,b[3]):null;this.varindex=b[4];break;case 22:this.object_type=this.runtime.types_by_index[b[1]];this.behavior_type=this.object_type.getBehaviorByName(b[2]);this.beh_index=this.object_type.getBehaviorIndexByName(b[2]);this.func=b[3];this.return_string=b[4];this.instance_expr=b[5]?new cr.expNode(a,b[5]):null;this.results=[];this.parameters=[];7===b.length?(e=b[6],this.results.length=e.length+1):this.results.length=1;break;case 23:this.varname=b[1],this.eventvar=
null}4<=this.type&&17>=this.type&&(this.first=new cr.expNode(a,b[1]),this.second=new cr.expNode(a,b[2]));if(e){var h,g;h=0;for(g=e.length;h<g;h++)this.parameters.push(new cr.expNode(a,e[h]))}cr.seal(this)}function b(a,b){this.type=a||cr.exptype.Integer;this.data=b||0;this.object_class=null;this.type==cr.exptype.Integer&&(this.data=Math.floor(this.data));cr.seal(this)}a.prototype.postInit=function(){23===this.type&&(this.eventvar=this.owner.runtime.getEventVariableByName(this.varname,this.owner.block.parent));
this.first&&this.first.postInit();this.second&&this.second.postInit();this.third&&this.third.postInit();this.instance_expr&&this.instance_expr.postInit();if(this.parameters){var a,b;a=0;for(b=this.parameters.length;a<b;a++)this.parameters[a].postInit()}};a.prototype.eval_system_exp=function(a){this.results[0]=a;a=this.owner.pushTempValue();var b,e;b=0;for(e=this.parameters.length;b<e;b++)this.parameters[b].get(a),this.results[b+1]=a.data;this.owner.popTempValue();this.func.apply(this.runtime.system,
this.results)};a.prototype.eval_object_behavior_exp=function(a){var b=this.object_type.getCurrentSol(),e=b.getObjects();if(!e.length)if(b.else_instances.length)e=b.else_instances;else{this.return_string?a.set_string(""):a.set_int(0);return}this.results[0]=a;a.object_class=this.object_type;a=this.owner.pushTempValue();var h,b=0;for(h=this.parameters.length;b<h;b++)this.parameters[b].get(a),this.results[b+1]=a.data;b=this.owner.solindex;this.instance_expr&&(this.instance_expr.get(a),a.is_number()&&
(b=a.data,e=this.object_type.instances));this.owner.popTempValue();b%=e.length;0>b&&(b+=e.length);e=e[b];-1<this.beh_index?(a=0,this.object_type.is_family&&(a=e.type.family_beh_map[this.object_type.family_index]),this.func.apply(e.behavior_insts[this.beh_index+a],this.results)):this.func.apply(e,this.results)};a.prototype.eval_instvar_exp=function(a){var b=this.object_type.getCurrentSol(),e=b.getObjects();if(!e.length)if(b.else_instances.length)e=b.else_instances;else{this.return_string?a.set_string(""):
a.set_int(0);return}b=this.owner.solindex;if(this.instance_expr){var h=this.owner.pushTempValue();this.instance_expr.get(h);if(h.is_number()){b=h.data;e=this.object_type.instances;b%=e.length;0>b&&(b+=e.length);e=e[b].instance_vars[this.varindex];cr.is_string(e)?a.set_string(e):a.set_float(e);this.owner.popTempValue();return}this.owner.popTempValue()}b%=e.length;0>b&&(b+=e.length);e=e[b];b=0;this.object_type.is_family&&(b=e.type.family_var_map[this.object_type.family_index]);e=e.instance_vars[this.varindex+
b];cr.is_string(e)?a.set_string(e):a.set_float(e)};a.prototype.eval_int=function(a){a.type=cr.exptype.Integer;a.data=this.value};a.prototype.eval_float=function(a){a.type=cr.exptype.Float;a.data=this.value};a.prototype.eval_string=function(a){a.type=cr.exptype.String;a.data=this.value};a.prototype.eval_unaryminus=function(a){this.first.get(a);a.is_number()&&(a.data=-a.data)};a.prototype.eval_add=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()&&b.is_number()&&
(a.data+=b.data,b.is_float()&&a.make_float());this.owner.popTempValue()};a.prototype.eval_subtract=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()&&b.is_number()&&(a.data-=b.data,b.is_float()&&a.make_float());this.owner.popTempValue()};a.prototype.eval_multiply=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()&&b.is_number()&&(a.data*=b.data,b.is_float()&&a.make_float());this.owner.popTempValue()};a.prototype.eval_divide=
function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()&&b.is_number()&&(a.data/=b.data,a.make_float());this.owner.popTempValue()};a.prototype.eval_mod=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()&&b.is_number()&&(a.data%=b.data,b.is_float()&&a.make_float());this.owner.popTempValue()};a.prototype.eval_power=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()&&b.is_number()&&
(a.data=Math.pow(a.data,b.data),b.is_float()&&a.make_float());this.owner.popTempValue()};a.prototype.eval_and=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()?b.is_string()?a.set_string(a.data.toString()+b.data):a.data&&b.data?a.set_int(1):a.set_int(0):a.is_string()&&(b.is_string()?a.data+=b.data:a.data+=(Math.round(1E10*b.data)/1E10).toString());this.owner.popTempValue()};a.prototype.eval_or=function(a){this.first.get(a);var b=this.owner.pushTempValue();
this.second.get(b);a.is_number()&&b.is_number()&&(a.data||b.data?a.set_int(1):a.set_int(0));this.owner.popTempValue()};a.prototype.eval_conditional=function(a){this.first.get(a);a.data?this.second.get(a):this.third.get(a)};a.prototype.eval_equal=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.set_int(a.data===b.data?1:0);this.owner.popTempValue()};a.prototype.eval_notequal=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.set_int(a.data!==
b.data?1:0);this.owner.popTempValue()};a.prototype.eval_less=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.set_int(a.data<b.data?1:0);this.owner.popTempValue()};a.prototype.eval_lessequal=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.set_int(a.data<=b.data?1:0);this.owner.popTempValue()};a.prototype.eval_greater=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.set_int(a.data>b.data?1:0);
this.owner.popTempValue()};a.prototype.eval_greaterequal=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.set_int(a.data>=b.data?1:0);this.owner.popTempValue()};a.prototype.eval_eventvar_exp=function(a){var b=this.eventvar.getValue();cr.is_number(b)?a.set_float(b):a.set_string(b)};cr.expNode=a;b.prototype.is_int=function(){return this.type===cr.exptype.Integer};b.prototype.is_float=function(){return this.type===cr.exptype.Float};b.prototype.is_number=function(){return this.type===
cr.exptype.Integer||this.type===cr.exptype.Float};b.prototype.is_string=function(){return this.type===cr.exptype.String};b.prototype.make_int=function(){this.is_int()||(this.is_float()?this.data=Math.floor(this.data):this.is_string()&&(this.data=parseInt(this.data,10)),this.type=cr.exptype.Integer)};b.prototype.make_float=function(){this.is_float()||(this.is_string()&&(this.data=parseFloat(this.data)),this.type=cr.exptype.Float)};b.prototype.make_string=function(){this.is_string()||(this.data=this.data.toString(),
this.type=cr.exptype.String)};b.prototype.set_int=function(a){this.type=cr.exptype.Integer;this.data=Math.floor(a)};b.prototype.set_float=function(a){this.type=cr.exptype.Float;this.data=a};b.prototype.set_string=function(a){this.type=cr.exptype.String;this.data=a};b.prototype.set_any=function(a){cr.is_number(a)?(this.type=cr.exptype.Float,this.data=a):cr.is_string(a)?(this.type=cr.exptype.String,this.data=a.toString()):(this.type=cr.exptype.Integer,this.data=0)};cr.expvalue=b;cr.exptype={Integer:0,
Float:1,String:2}})();cr.system_object=function(a){this.runtime=a;this.waits=[]};
cr.system_object.prototype.saveToJSON=function(){var a={},b,c,d,e,h,g,l,k;a.waits=[];var f=a.waits,m;b=0;for(c=this.waits.length;b<c;b++){g=this.waits[b];m={t:g.time,ev:g.ev.sid,sm:[],sols:{}};g.ev.actions[g.actindex]&&(m.act=g.ev.actions[g.actindex].sid);d=0;for(e=g.solModifiers.length;d<e;d++)m.sm.push(g.solModifiers[d].sid);for(h in g.sols)if(g.sols.hasOwnProperty(h)){l=this.runtime.types_by_index[parseInt(h,10)];k={sa:g.sols[h].sa,insts:[]};d=0;for(e=g.sols[h].insts.length;d<e;d++)k.insts.push(g.sols[h].insts[d].uid);
m.sols[l.sid.toString()]=k}f.push(m)}return a};
cr.system_object.prototype.loadFromJSON=function(a){a=a.waits;var b,c,d,e,h,g,l,k,f,m,n;b=this.waits.length=0;for(c=a.length;b<c;b++)if(g=a[b],k=this.runtime.blocksBySid[g.ev.toString()]){f=-1;d=0;for(e=k.actions.length;d<e;d++)if(k.actions[d].sid===g.act){f=d;break}if(-1!==f){l={sols:{},solModifiers:[],deleteme:!1};l.time=g.t;l.ev=k;l.actindex=f;d=0;for(e=g.sm.length;d<e;d++)(k=this.runtime.getObjectTypeBySid(g.sm[d]))&&l.solModifiers.push(k);for(h in g.sols)if(g.sols.hasOwnProperty(h)&&(k=this.runtime.getObjectTypeBySid(parseInt(h,
10)))){f=g.sols[h];m={sa:f.sa,insts:[]};d=0;for(e=f.insts.length;d<e;d++)(n=this.runtime.getObjectByUID(f.insts[d]))&&m.insts.push(n);l.sols[k.index.toString()]=m}this.waits.push(l)}}};
(function(){function a(){}function b(a,b){var c=a.extra.c2_foreachordered_val,d=b.extra.c2_foreachordered_val;if(cr.is_number(c)&&cr.is_number(d))return c-d;c=""+c;d=""+d;return c<d?-1:c>d?1:0}function c(a,b){f&&a===m&&b===n||(f=RegExp(a,b),m=a,n=b);f.lastIndex=0;return f}function d(){}function e(){}function h(a,b,d){if(a!==t||b!==w||d!==A){var e=c(b,d);r=a.match(e);t=a;w=b;A=d}}var g=cr.system_object.prototype;a.prototype.EveryTick=function(){return!0};a.prototype.OnLayoutStart=function(){return!0};
a.prototype.OnLayoutEnd=function(){return!0};a.prototype.Compare=function(a,b,c){return cr.do_cmp(a,b,c)};a.prototype.CompareTime=function(a,b){var c=this.runtime.kahanTime.sum;if(0===a){var d=this.runtime.getCurrentCondition();return!d.extra.CompareTime_executed&&c>=b?d.extra.CompareTime_executed=!0:!1}return cr.do_cmp(c,a,b)};a.prototype.LayerVisible=function(a){return a?a.visible:!1};a.prototype.LayerCmpOpacity=function(a,b,c){return a?cr.do_cmp(100*a.opacity,b,c):!1};a.prototype.Repeat=function(a){var b=
this.runtime.getCurrentEventStack(),c=b.current_event,d=b.isModifierAfterCnds(),b=this.runtime.pushLoopStack();if(d)for(d=0;d<a&&!b.stopped;d++)this.runtime.pushCopySol(c.solModifiers),b.index=d,c.retrigger(),this.runtime.popSol(c.solModifiers);else for(d=0;d<a&&!b.stopped;d++)b.index=d,c.retrigger();this.runtime.popLoopStack();return!1};a.prototype.While=function(a){var b=this.runtime.getCurrentEventStack();a=b.current_event;var c=b.isModifierAfterCnds(),b=this.runtime.pushLoopStack();if(c)for(c=
0;!b.stopped;c++)this.runtime.pushCopySol(a.solModifiers),b.index=c,a.retrigger()||(b.stopped=!0),this.runtime.popSol(a.solModifiers);else for(c=0;!b.stopped;c++)b.index=c,a.retrigger()||(b.stopped=!0);this.runtime.popLoopStack();return!1};a.prototype.For=function(a,b,c){var d=this.runtime.getCurrentEventStack(),e=d.current_event,d=d.isModifierAfterCnds();a=this.runtime.pushLoopStack(a);if(c<b)if(d)for(;b>=c&&!a.stopped;--b)this.runtime.pushCopySol(e.solModifiers),a.index=b,e.retrigger(),this.runtime.popSol(e.solModifiers);
else for(;b>=c&&!a.stopped;--b)a.index=b,e.retrigger();else if(d)for(;b<=c&&!a.stopped;++b)this.runtime.pushCopySol(e.solModifiers),a.index=b,e.retrigger(),this.runtime.popSol(e.solModifiers);else for(;b<=c&&!a.stopped;++b)a.index=b,e.retrigger();this.runtime.popLoopStack();return!1};var l=[],k=-1;a.prototype.ForEach=function(a){var b=a.getCurrentSol();k++;l.length===k&&l.push([]);var c=l[k];cr.shallowAssignArray(c,b.getObjects());var d=this.runtime.getCurrentEventStack(),e=d.current_event,f=d.isModifierAfterCnds(),
d=this.runtime.pushLoopStack(),g,h,m,n,q,r,p=a.is_contained;if(f)for(f=0,g=c.length;f<g&&!d.stopped;f++){this.runtime.pushCopySol(e.solModifiers);n=c[f];b=a.getCurrentSol();b.select_all=!1;b.instances.length=1;b.instances[0]=n;if(p)for(h=0,m=n.siblings.length;h<m;h++)q=n.siblings[h],r=q.type.getCurrentSol(),r.select_all=!1,r.instances.length=1,r.instances[0]=q;d.index=f;e.retrigger();this.runtime.popSol(e.solModifiers)}else for(b.select_all=!1,b.instances.length=1,f=0,g=c.length;f<g&&!d.stopped;f++){n=
c[f];b.instances[0]=n;if(p)for(h=0,m=n.siblings.length;h<m;h++)q=n.siblings[h],r=q.type.getCurrentSol(),r.select_all=!1,r.instances.length=1,r.instances[0]=q;d.index=f;e.retrigger()}c.length=0;this.runtime.popLoopStack();k--;return!1};a.prototype.ForEachOrdered=function(a,c,d){c=a.getCurrentSol();k++;l.length===k&&l.push([]);var e=l[k];cr.shallowAssignArray(e,c.getObjects());var f=this.runtime.getCurrentEventStack(),g=f.current_event,h=this.runtime.getCurrentCondition(),m=f.isModifierAfterCnds(),
f=this.runtime.pushLoopStack(),n,q,r,p,s;n=0;for(q=e.length;n<q;n++)e[n].extra.c2_foreachordered_val=h.parameters[1].get(n);e.sort(b);1===d&&e.reverse();d=a.is_contained;if(m)for(n=0,q=e.length;n<q&&!f.stopped;n++){this.runtime.pushCopySol(g.solModifiers);r=e[n];c=a.getCurrentSol();c.select_all=!1;c.instances.length=1;c.instances[0]=r;if(d)for(h=0,m=r.siblings.length;h<m;h++)p=r.siblings[h],s=p.type.getCurrentSol(),s.select_all=!1,s.instances.length=1,s.instances[0]=p;f.index=n;g.retrigger();this.runtime.popSol(g.solModifiers)}else for(c.select_all=
!1,c.instances.length=1,n=0,q=e.length;n<q&&!f.stopped;n++){r=e[n];c.instances[0]=r;if(d)for(h=0,m=r.siblings.length;h<m;h++)p=r.siblings[h],s=p.type.getCurrentSol(),s.select_all=!1,s.instances.length=1,s.instances[0]=p;f.index=n;g.retrigger()}e.length=0;this.runtime.popLoopStack();k--;return!1};a.prototype.PickByComparison=function(a,b,c,d){var e,f,g,h;if(a){k++;l.length===k&&l.push([]);var m=l[k],n=a.getCurrentSol();cr.shallowAssignArray(m,n.getObjects());n.select_all&&(n.else_instances.length=
0);var q=this.runtime.getCurrentCondition();g=e=0;for(f=m.length;e<f;e++)h=m[e],m[g]=h,b=q.parameters[1].get(e),d=q.parameters[3].get(e),cr.do_cmp(b,c,d)?g++:n.else_instances.push(h);m.length=g;n.select_all=!1;cr.shallowAssignArray(n.instances,m);m.length=0;k--;a.applySolToContainer();return!!n.instances.length}};a.prototype.PickByEvaluate=function(a,b){var c,d,e,f;if(a){k++;l.length===k&&l.push([]);var g=l[k],h=a.getCurrentSol();cr.shallowAssignArray(g,h.getObjects());h.select_all&&(h.else_instances.length=
0);var m=this.runtime.getCurrentCondition();e=c=0;for(d=g.length;c<d;c++)f=g[c],g[e]=f,(b=m.parameters[1].get(c))?e++:h.else_instances.push(f);g.length=e;h.select_all=!1;cr.shallowAssignArray(h.instances,g);g.length=0;k--;a.applySolToContainer();return!!h.instances.length}};a.prototype.TriggerOnce=function(){var a=this.runtime.getCurrentCondition().extra;"undefined"===typeof a.TriggerOnce_lastTick&&(a.TriggerOnce_lastTick=-1);var b=a.TriggerOnce_lastTick,c=this.runtime.tickcount;a.TriggerOnce_lastTick=
c;return this.runtime.layout_first_tick||b!==c-1};a.prototype.Every=function(a){var b=this.runtime.getCurrentCondition(),c=b.extra.Every_lastTime||0,d=this.runtime.kahanTime.sum;"undefined"===typeof b.extra.Every_seconds&&(b.extra.Every_seconds=a);var e=b.extra.Every_seconds;return d>=c+e?(b.extra.Every_lastTime=c+e,d>=b.extra.Every_lastTime+e&&(b.extra.Every_lastTime=d),b.extra.Every_seconds=a,!0):!1};a.prototype.PickNth=function(a,b){if(!a)return!1;var c=a.getCurrentSol(),d=c.getObjects();b=cr.floor(b);
if(0>b||b>=d.length)return!1;c.pick_one(d[b]);a.applySolToContainer();return!0};a.prototype.PickRandom=function(a){if(!a)return!1;var b=a.getCurrentSol(),c=b.getObjects(),d=cr.floor(Math.random()*c.length);if(d>=c.length)return!1;b.pick_one(c[d]);a.applySolToContainer();return!0};a.prototype.CompareVar=function(a,b,c){return cr.do_cmp(a.getValue(),b,c)};a.prototype.IsGroupActive=function(a){return this.runtime.activeGroups[a.toLowerCase()]};a.prototype.IsPreview=function(){return"undefined"!==typeof cr_is_preview};
a.prototype.PickAll=function(a){if(!a||!a.instances.length)return!1;a.getCurrentSol().select_all=!0;a.applySolToContainer();return!0};a.prototype.IsMobile=function(){return this.runtime.isMobile};a.prototype.CompareBetween=function(a,b,c){return a>=b&&a<=c};a.prototype.Else=function(){var a=this.runtime.getCurrentEventStack();return a.else_branch_ran?!1:!a.last_event_true};a.prototype.OnLoadFinished=function(){return!0};a.prototype.OnCanvasSnapshot=function(){return!0};a.prototype.EffectsSupported=
function(){return!!this.runtime.glwrap};a.prototype.OnSaveComplete=function(){return!0};a.prototype.OnLoadComplete=function(){return!0};a.prototype.OnLoadFailed=function(){return!0};a.prototype.ObjectUIDExists=function(a){return!!this.runtime.getObjectByUID(a)};a.prototype.IsOnPlatform=function(a){var b=this.runtime;switch(a){case 0:return!b.isDomFree&&!b.isNodeWebkit&&!b.isPhoneGap&&!b.isCrosswalk&&!b.isWindows8App&&!b.isWindowsPhone8&&!b.isBlackberry10&&!b.isAmazonWebApp;case 1:return b.isiOS;case 2:return b.isAndroid;
case 3:return b.isWindows8App;case 4:return b.isWindowsPhone8;case 5:return b.isBlackberry10;case 6:return b.isTizen;case 7:return b.isCocoonJs;case 8:return b.isPhoneGap;case 9:return b.isArcade;case 10:return b.isNodeWebkit;case 11:return b.isCrosswalk;case 12:return b.isAmazonWebApp;default:return!1}};var f=null,m="",n="";a.prototype.RegexTest=function(a,b,d){return c(b,d).test(a)};var p=[];a.prototype.PickOverlappingPoint=function(a,b,c){if(!a)return!1;var d=a.getCurrentSol(),e=d.getObjects(),
f=this.runtime.getCurrentEventStack().current_event.orblock,g=this.runtime.getCurrentCondition(),h,k;d.select_all?(cr.shallowAssignArray(p,e),d.else_instances.length=0,d.select_all=!1,d.instances.length=0):f?(cr.shallowAssignArray(p,d.else_instances),d.else_instances.length=0):(cr.shallowAssignArray(p,e),d.instances.length=0);e=0;for(f=p.length;e<f;++e)h=p[e],(k=cr.xor(h.contains_pt(b,c),g.inverted))?d.instances.push(h):d.else_instances.push(h);a.applySolToContainer();return cr.xor(!!d.instances.length,
g.inverted)};g.cnds=new a;d.prototype.GoToLayout=function(a){this.runtime.isloading||this.runtime.changelayout||(this.runtime.changelayout=a)};d.prototype.CreateObject=function(a,b,c,d){if(b&&a&&(b=this.runtime.createInstance(a,b,c,d))){this.runtime.isInOnDestroy++;var e;this.runtime.trigger(Object.getPrototypeOf(a.plugin).cnds.OnCreated,b);if(b.is_contained)for(c=0,d=b.siblings.length;c<d;c++)e=b.siblings[c],this.runtime.trigger(Object.getPrototypeOf(e.type.plugin).cnds.OnCreated,e);this.runtime.isInOnDestroy--;
a=a.getCurrentSol();a.select_all=!1;a.instances.length=1;a.instances[0]=b;if(b.is_contained)for(c=0,d=b.siblings.length;c<d;c++)e=b.siblings[c],a=e.type.getCurrentSol(),a.select_all=!1,a.instances.length=1,a.instances[0]=e}};d.prototype.SetLayerVisible=function(a,b){a&&a.visible!==b&&(a.visible=b,this.runtime.redraw=!0)};d.prototype.SetLayerOpacity=function(a,b){a&&(b=cr.clamp(b/100,0,1),a.opacity!==b&&(a.opacity=b,this.runtime.redraw=!0))};d.prototype.SetLayerScaleRate=function(a,b){a&&a.zoomRate!==
b&&(a.zoomRate=b,this.runtime.redraw=!0)};d.prototype.SetLayoutScale=function(a){this.runtime.running_layout&&this.runtime.running_layout.scale!==a&&(this.runtime.running_layout.scale=a,this.runtime.running_layout.boundScrolling(),this.runtime.redraw=!0)};d.prototype.ScrollX=function(a){this.runtime.running_layout.scrollToX(a)};d.prototype.ScrollY=function(a){this.runtime.running_layout.scrollToY(a)};d.prototype.Scroll=function(a,b){this.runtime.running_layout.scrollToX(a);this.runtime.running_layout.scrollToY(b)};
d.prototype.ScrollToObject=function(a){if(a=a.getFirstPicked())this.runtime.running_layout.scrollToX(a.x),this.runtime.running_layout.scrollToY(a.y)};d.prototype.SetVar=function(a,b){0===a.vartype?cr.is_number(b)?a.setValue(b):a.setValue(parseFloat(b)):1===a.vartype&&a.setValue(b.toString())};d.prototype.AddVar=function(a,b){0===a.vartype?cr.is_number(b)?a.setValue(a.getValue()+b):a.setValue(a.getValue()+parseFloat(b)):1===a.vartype&&a.setValue(a.getValue()+b.toString())};d.prototype.SubVar=function(a,
b){0===a.vartype&&(cr.is_number(b)?a.setValue(a.getValue()-b):a.setValue(a.getValue()-parseFloat(b)))};d.prototype.SetGroupActive=function(a,b){var c=this.runtime.activeGroups,d=a.toLowerCase();switch(b){case 0:c[d]=!1;break;case 1:c[d]=!0;break;case 2:c[d]=!c[d]}};d.prototype.SetTimescale=function(a){0>a&&(a=0);this.runtime.timescale=a};d.prototype.SetObjectTimescale=function(a,b){var c=b;0>c&&(c=0);if(a){var d=a.getCurrentSol().getObjects(),e,f;e=0;for(f=d.length;e<f;e++)d[e].my_timescale=c}};d.prototype.RestoreObjectTimescale=
function(a){if(!a)return!1;a=a.getCurrentSol().getObjects();var b,c;b=0;for(c=a.length;b<c;b++)a[b].my_timescale=-1};var q=[],s=[];d.prototype.Wait=function(a){if(!(0>a)){var b,c,d,e=this.runtime.getCurrentEventStack(),f;f=q.length?q.pop():{sols:{},solModifiers:[]};f.deleteme=!1;f.time=this.runtime.kahanTime.sum+a;f.ev=e.current_event;f.actindex=e.actindex+1;a=0;for(b=this.runtime.types_by_index.length;a<b;a++)d=this.runtime.types_by_index[a],c=d.getCurrentSol(),c.select_all&&-1===e.current_event.solModifiers.indexOf(d)||
(f.solModifiers.push(d),d=void 0,d=s.length?s.pop():{insts:[]},d.sa=!1,d.sa=c.select_all,cr.shallowAssignArray(d.insts,c.instances),f.sols[a.toString()]=d);this.waits.push(f);return!0}};d.prototype.SetLayerScale=function(a,b){a&&a.scale!==b&&(a.scale=b,this.runtime.redraw=!0)};d.prototype.ResetGlobals=function(){var a,b,c;a=0;for(b=this.runtime.all_global_vars.length;a<b;a++)c=this.runtime.all_global_vars[a],c.data=c.initial};d.prototype.SetLayoutAngle=function(a){a=cr.to_radians(a);a=cr.clamp_angle(a);
this.runtime.running_layout&&this.runtime.running_layout.angle!==a&&(this.runtime.running_layout.angle=a,this.runtime.redraw=!0)};d.prototype.SetLayerAngle=function(a,b){a&&(b=cr.to_radians(b),b=cr.clamp_angle(b),a.angle!==b&&(a.angle=b,this.runtime.redraw=!0))};d.prototype.SetLayerParallax=function(a,b,c){if(a&&(a.parallaxX!==b/100||a.parallaxY!==c/100)){a.parallaxX=b/100;a.parallaxY=c/100;if(1!==a.parallaxX||1!==a.parallaxY)for(c=a.instances,a=0,b=c.length;a<b;++a)c[a].type.any_instance_parallaxed=
!0;this.runtime.redraw=!0}};d.prototype.SetLayerBackground=function(a,b){if(a){var c=cr.GetRValue(b),d=cr.GetGValue(b),e=cr.GetBValue(b);if(a.background_color[0]!==c||a.background_color[1]!==d||a.background_color[2]!==e)a.background_color[0]=c,a.background_color[1]=d,a.background_color[2]=e,this.runtime.redraw=!0}};d.prototype.SetLayerTransparent=function(a,b){a&&!!b!==!!a.transparent&&(a.transparent=!!b,this.runtime.redraw=!0)};d.prototype.StopLoop=function(){0>this.runtime.loop_stack_index||(this.runtime.getCurrentLoop().stopped=
!0)};d.prototype.GoToLayoutByName=function(a){if(!this.runtime.isloading&&!this.runtime.changelayout)for(var b in this.runtime.layouts)if(this.runtime.layouts.hasOwnProperty(b)&&cr.equals_nocase(b,a)){this.runtime.changelayout=this.runtime.layouts[b];break}};d.prototype.RestartLayout=function(a){if(!this.runtime.isloading&&!this.runtime.changelayout&&this.runtime.running_layout){this.runtime.changelayout=this.runtime.running_layout;var b,c;a=0;for(b=this.runtime.allGroups.length;a<b;a++)c=this.runtime.allGroups[a],
this.runtime.activeGroups[c.group_name.toLowerCase()]=c.initially_activated}};d.prototype.SnapshotCanvas=function(a,b){this.runtime.snapshotCanvas=[0===a?"image/png":"image/jpeg",b/100];this.runtime.redraw=!0};d.prototype.SetCanvasSize=function(a,b){if(!(0>=a||0>=b)){var c=this.runtime.fullscreen_mode;(document.mozFullScreen||document.webkitIsFullScreen||document.msFullscreenElement||document.fullScreen||this.runtime.isNodeFullscreen)&&0<this.runtime.fullscreen_scaling&&(c=this.runtime.fullscreen_scaling);
0===c?this.runtime.setSize(a,b,!0):(this.runtime.original_width=a,this.runtime.original_height=b,this.runtime.setSize(this.runtime.lastWindowWidth,this.runtime.lastWindowHeight,!0))}};d.prototype.SetLayoutEffectEnabled=function(a,b){if(this.runtime.running_layout&&this.runtime.glwrap){var c=this.runtime.running_layout.getEffectByName(b);if(c){var d=1===a;c.active!=d&&(c.active=d,this.runtime.running_layout.updateActiveEffects(),this.runtime.redraw=!0)}}};d.prototype.SetLayerEffectEnabled=function(a,
b,c){a&&this.runtime.glwrap&&(c=a.getEffectByName(c))&&(b=1===b,c.active!=b&&(c.active=b,a.updateActiveEffects(),this.runtime.redraw=!0))};d.prototype.SetLayoutEffectParam=function(a,b,c){if(this.runtime.running_layout&&this.runtime.glwrap&&(a=this.runtime.running_layout.getEffectByName(a))){var d=this.runtime.running_layout.effect_params[a.index];b=Math.floor(b);0>b||b>=d.length||(1===this.runtime.glwrap.getProgramParameterType(a.shaderindex,b)&&(c/=100),d[b]!==c&&(d[b]=c,a.active&&(this.runtime.redraw=
!0)))}};d.prototype.SetLayerEffectParam=function(a,b,c,d){a&&this.runtime.glwrap&&(b=a.getEffectByName(b))&&(a=a.effect_params[b.index],c=Math.floor(c),0>c||c>=a.length||(1===this.runtime.glwrap.getProgramParameterType(b.shaderindex,c)&&(d/=100),a[c]!==d&&(a[c]=d,b.active&&(this.runtime.redraw=!0))))};d.prototype.SaveState=function(a){this.runtime.saveToSlot=a};d.prototype.LoadState=function(a){this.runtime.loadFromSlot=a};d.prototype.LoadStateJSON=function(a){this.runtime.loadFromJson=a};d.prototype.SetHalfFramerateMode=
function(a){this.runtime.halfFramerateMode=0!==a};d.prototype.SetFullscreenQuality=function(a){if(document.mozFullScreen||document.webkitIsFullScreen||document.msFullscreenElement||document.fullScreen||this.isNodeFullscreen||0!==this.runtime.fullscreen_mode)this.runtime.wantFullscreenScalingQuality=0!==a,this.runtime.setSize(this.runtime.lastWindowWidth,this.runtime.lastWindowHeight,!0)};g.acts=new d;e.prototype["int"]=function(a,b){cr.is_string(b)?(a.set_int(parseInt(b,10)),isNaN(a.data)&&(a.data=
0)):a.set_int(b)};e.prototype["float"]=function(a,b){cr.is_string(b)?(a.set_float(parseFloat(b)),isNaN(a.data)&&(a.data=0)):a.set_float(b)};e.prototype.str=function(a,b){cr.is_string(b)?a.set_string(b):a.set_string(b.toString())};e.prototype.len=function(a,b){a.set_int(b.length||0)};e.prototype.random=function(a,b,c){void 0===c?a.set_float(Math.random()*b):a.set_float(Math.random()*(c-b)+b)};e.prototype.sqrt=function(a,b){a.set_float(Math.sqrt(b))};e.prototype.abs=function(a,b){a.set_float(Math.abs(b))};
e.prototype.round=function(a,b){a.set_int(Math.round(b))};e.prototype.floor=function(a,b){a.set_int(Math.floor(b))};e.prototype.ceil=function(a,b){a.set_int(Math.ceil(b))};e.prototype.sin=function(a,b){a.set_float(Math.sin(cr.to_radians(b)))};e.prototype.cos=function(a,b){a.set_float(Math.cos(cr.to_radians(b)))};e.prototype.tan=function(a,b){a.set_float(Math.tan(cr.to_radians(b)))};e.prototype.asin=function(a,b){a.set_float(cr.to_degrees(Math.asin(b)))};e.prototype.acos=function(a,b){a.set_float(cr.to_degrees(Math.acos(b)))};
e.prototype.atan=function(a,b){a.set_float(cr.to_degrees(Math.atan(b)))};e.prototype.exp=function(a,b){a.set_float(Math.exp(b))};e.prototype.ln=function(a,b){a.set_float(Math.log(b))};e.prototype.log10=function(a,b){a.set_float(Math.log(b)/Math.LN10)};e.prototype.max=function(a){var b=arguments[1],c,d;c=2;for(d=arguments.length;c<d;c++)b<arguments[c]&&(b=arguments[c]);a.set_float(b)};e.prototype.min=function(a){var b=arguments[1],c,d;c=2;for(d=arguments.length;c<d;c++)b>arguments[c]&&(b=arguments[c]);
a.set_float(b)};e.prototype.dt=function(a){a.set_float(this.runtime.dt)};e.prototype.timescale=function(a){a.set_float(this.runtime.timescale)};e.prototype.wallclocktime=function(a){a.set_float((Date.now()-this.runtime.start_time)/1E3)};e.prototype.time=function(a){a.set_float(this.runtime.kahanTime.sum)};e.prototype.tickcount=function(a){a.set_int(this.runtime.tickcount)};e.prototype.objectcount=function(a){a.set_int(this.runtime.objectcount)};e.prototype.fps=function(a){a.set_int(this.runtime.fps)};
e.prototype.loopindex=function(a,b){var c,d,e;if(this.runtime.loop_stack.length)if(b){d=0;for(e=this.runtime.loop_stack.length;d<e;d++)if(c=this.runtime.loop_stack[d],c.name===b){a.set_int(c.index);return}a.set_int(0)}else c=this.runtime.getCurrentLoop(),a.set_int(c?c.index:-1);else a.set_int(0)};e.prototype.distance=function(a,b,c,d,e){a.set_float(cr.distanceTo(b,c,d,e))};e.prototype.angle=function(a,b,c,d,e){a.set_float(cr.to_degrees(cr.angleTo(b,c,d,e)))};e.prototype.scrollx=function(a){a.set_float(this.runtime.running_layout.scrollX)};
e.prototype.scrolly=function(a){a.set_float(this.runtime.running_layout.scrollY)};e.prototype.newline=function(a){a.set_string("\n")};e.prototype.lerp=function(a,b,c,d){a.set_float(cr.lerp(b,c,d))};e.prototype.windowwidth=function(a){a.set_int(this.runtime.width)};e.prototype.windowheight=function(a){a.set_int(this.runtime.height)};e.prototype.uppercase=function(a,b){a.set_string(cr.is_string(b)?b.toUpperCase():"")};e.prototype.lowercase=function(a,b){a.set_string(cr.is_string(b)?b.toLowerCase():
"")};e.prototype.clamp=function(a,b,c,d){b<c?a.set_float(c):b>d?a.set_float(d):a.set_float(b)};e.prototype.layerscale=function(a,b){var c=this.runtime.getLayer(b);c?a.set_float(c.scale):a.set_float(0)};e.prototype.layeropacity=function(a,b){var c=this.runtime.getLayer(b);c?a.set_float(100*c.opacity):a.set_float(0)};e.prototype.layerscalerate=function(a,b){var c=this.runtime.getLayer(b);c?a.set_float(c.zoomRate):a.set_float(0)};e.prototype.layerparallaxx=function(a,b){var c=this.runtime.getLayer(b);
c?a.set_float(100*c.parallaxX):a.set_float(0)};e.prototype.layerparallaxy=function(a,b){var c=this.runtime.getLayer(b);c?a.set_float(100*c.parallaxY):a.set_float(0)};e.prototype.layoutscale=function(a){this.runtime.running_layout?a.set_float(this.runtime.running_layout.scale):a.set_float(0)};e.prototype.layoutangle=function(a){a.set_float(cr.to_degrees(this.runtime.running_layout.angle))};e.prototype.layerangle=function(a,b){var c=this.runtime.getLayer(b);c?a.set_float(cr.to_degrees(c.angle)):a.set_float(0)};
e.prototype.layoutwidth=function(a){a.set_int(this.runtime.running_layout.width)};e.prototype.layoutheight=function(a){a.set_int(this.runtime.running_layout.height)};e.prototype.find=function(a,b,c){cr.is_string(b)&&cr.is_string(c)?a.set_int(b.search(RegExp(cr.regexp_escape(c),"i"))):a.set_int(-1)};e.prototype.left=function(a,b,c){a.set_string(cr.is_string(b)?b.substr(0,c):"")};e.prototype.right=function(a,b,c){a.set_string(cr.is_string(b)?b.substr(b.length-c):"")};e.prototype.mid=function(a,b,c,
d){a.set_string(cr.is_string(b)?b.substr(c,d):"")};e.prototype.tokenat=function(a,b,c,d){cr.is_string(b)&&cr.is_string(d)?(b=b.split(d),c=cr.floor(c),0>c||c>=b.length?a.set_string(""):a.set_string(b[c])):a.set_string("")};e.prototype.tokencount=function(a,b,c){cr.is_string(b)&&b.length?a.set_int(b.split(c).length):a.set_int(0)};e.prototype.replace=function(a,b,c,d){cr.is_string(b)&&cr.is_string(c)&&cr.is_string(d)?a.set_string(b.replace(RegExp(cr.regexp_escape(c),"gi"),d)):a.set_string(cr.is_string(b)?
b:"")};e.prototype.trim=function(a,b){a.set_string(cr.is_string(b)?b.trim():"")};e.prototype.pi=function(a){a.set_float(cr.PI)};e.prototype.layoutname=function(a){this.runtime.running_layout?a.set_string(this.runtime.running_layout.name):a.set_string("")};e.prototype.renderer=function(a){a.set_string(this.runtime.gl?"webgl":"canvas2d")};e.prototype.anglediff=function(a,b,c){a.set_float(cr.to_degrees(cr.angleDiff(cr.to_radians(b),cr.to_radians(c))))};e.prototype.choose=function(a){var b=cr.floor(Math.random()*
(arguments.length-1));a.set_any(arguments[b+1])};e.prototype.rgb=function(a,b,c,d){a.set_int(cr.RGB(b,c,d))};e.prototype.projectversion=function(a){a.set_string(this.runtime.versionstr)};e.prototype.anglelerp=function(a,b,c,d){b=cr.to_radians(b);c=cr.to_radians(c);var e=cr.angleDiff(b,c);cr.angleClockwise(c,b)?a.set_float(cr.to_clamped_degrees(b+e*d)):a.set_float(cr.to_clamped_degrees(b-e*d))};e.prototype.anglerotate=function(a,b,c,d){b=cr.to_radians(b);c=cr.to_radians(c);d=cr.to_radians(d);a.set_float(cr.to_clamped_degrees(cr.angleRotate(b,
c,d)))};e.prototype.zeropad=function(a,b,c){var d=0>b?"-":"";0>b&&(b=-b);c-=b.toString().length;for(var e=0;e<c;e++)d+="0";a.set_string(d+b.toString())};e.prototype.cpuutilisation=function(a){a.set_float(this.runtime.cpuutilisation/1E3)};e.prototype.viewportleft=function(a,b){var c=this.runtime.getLayer(b);a.set_float(c?c.viewLeft:0)};e.prototype.viewporttop=function(a,b){var c=this.runtime.getLayer(b);a.set_float(c?c.viewTop:0)};e.prototype.viewportright=function(a,b){var c=this.runtime.getLayer(b);
a.set_float(c?c.viewRight:0)};e.prototype.viewportbottom=function(a,b){var c=this.runtime.getLayer(b);a.set_float(c?c.viewBottom:0)};e.prototype.loadingprogress=function(a){a.set_float(this.runtime.loadingprogress)};e.prototype.unlerp=function(a,b,c,d){a.set_float((d-b)/(c-b))};e.prototype.canvassnapshot=function(a){a.set_string(this.runtime.snapshotData)};e.prototype.urlencode=function(a,b){a.set_string(encodeURIComponent(b))};e.prototype.urldecode=function(a,b){a.set_string(decodeURIComponent(b))};
e.prototype.canvastolayerx=function(a,b,c,d){b=this.runtime.getLayer(b);a.set_float(b?b.canvasToLayer(c,d,!0):0)};e.prototype.canvastolayery=function(a,b,c,d){b=this.runtime.getLayer(b);a.set_float(b?b.canvasToLayer(c,d,!1):0)};e.prototype.layertocanvasx=function(a,b,c,d){b=this.runtime.getLayer(b);a.set_float(b?b.layerToCanvas(c,d,!0):0)};e.prototype.layertocanvasy=function(a,b,c,d){b=this.runtime.getLayer(b);a.set_float(b?b.layerToCanvas(c,d,!1):0)};e.prototype.savestatejson=function(a){a.set_string(this.runtime.lastSaveJson)};
e.prototype.imagememoryusage=function(a){this.runtime.glwrap?a.set_float(Math.round(100*this.runtime.glwrap.estimateVRAM()/1048576)/100):a.set_float(0)};e.prototype.regexsearch=function(a,b,d,e){d=c(d,e);a.set_int(b?b.search(d):-1)};e.prototype.regexreplace=function(a,b,d,e,f){d=c(d,e);a.set_string(b?b.replace(d,f):"")};var r=[],t="",w="",A="";e.prototype.regexmatchcount=function(a,b,d,e){c(d,e);h(b,d,e);a.set_int(r?r.length:0)};e.prototype.regexmatchat=function(a,b,d,e,f){f=Math.floor(f);c(d,e);
h(b,d,e);!r||0>f||f>=r.length?a.set_string(""):a.set_string(r[f])};e.prototype.infinity=function(a){a.set_float(Infinity)};g.exps=new e;g.runWaits=function(){var a,b,c,d,e,f,g=this.runtime.getCurrentEventStack();a=0;for(c=this.waits.length;a<c;a++)if(d=this.waits[a],!(d.time>this.runtime.kahanTime.sum)){g.current_event=d.ev;g.actindex=d.actindex;g.cndindex=0;for(b in d.sols)d.sols.hasOwnProperty(b)&&(e=this.runtime.types_by_index[parseInt(b,10)].getCurrentSol(),f=d.sols[b],e.select_all=f.sa,cr.shallowAssignArray(e.instances,
f.insts),e=f,e.insts.length=0,s.push(e));d.ev.resume_actions_and_subevents();this.runtime.clearSol(d.solModifiers);d.deleteme=!0}b=a=0;for(c=this.waits.length;a<c;a++)d=this.waits[a],this.waits[b]=d,d.deleteme?(cr.wipe(d.sols),d.solModifiers.length=0,q.push(d)):b++;this.waits.length=b}})();
(function(){cr.add_common_aces=function(a){var c=a[0].prototype,d=a[1],e=a[3],h=a[4],g=a[5],l=a[6],k=a[7];a=a[8];c.cnds||(c.cnds={});c.acts||(c.acts={});c.exps||(c.exps={});var f=c.cnds,m=c.acts,c=c.exps;e&&(f.CompareX=function(a,b){return cr.do_cmp(this.x,a,b)},f.CompareY=function(a,b){return cr.do_cmp(this.y,a,b)},f.IsOnScreen=function(){var a=this.layer;this.update_bbox();var b=this.bbox;return!(b.right<a.viewLeft||b.bottom<a.viewTop||b.left>a.viewRight||b.top>a.viewBottom)},f.IsOutsideLayout=
function(){this.update_bbox();var a=this.bbox,b=this.runtime.running_layout;return 0>a.right||0>a.bottom||a.left>b.width||a.top>b.height},f.PickDistance=function(a,b,c){var d=this.getCurrentSol(),e=d.getObjects();if(!e.length)return!1;var f=e[0],g=f,h=cr.distanceTo(f.x,f.y,b,c),k,m,l;k=1;for(m=e.length;k<m;k++)if(f=e[k],l=cr.distanceTo(f.x,f.y,b,c),0===a&&l<h||1===a&&l>h)h=l,g=f;d.pick_one(g);return!0},m.SetX=function(a){this.x!==a&&(this.x=a,this.set_bbox_changed())},m.SetY=function(a){this.y!==
a&&(this.y=a,this.set_bbox_changed())},m.SetPos=function(a,b){if(this.x!==a||this.y!==b)this.x=a,this.y=b,this.set_bbox_changed()},m.SetPosToObject=function(a,b){var c=a.getPairedInstance(this);if(c){var d;c.getImagePoint?(d=c.getImagePoint(b,!0),c=c.getImagePoint(b,!1)):(d=c.x,c=c.y);if(this.x!==d||this.y!==c)this.x=d,this.y=c,this.set_bbox_changed()}},m.MoveForward=function(a){0!==a&&(this.x+=Math.cos(this.angle)*a,this.y+=Math.sin(this.angle)*a,this.set_bbox_changed())},m.MoveAtAngle=function(a,
b){0!==b&&(this.x+=Math.cos(cr.to_radians(a))*b,this.y+=Math.sin(cr.to_radians(a))*b,this.set_bbox_changed())},c.X=function(a){a.set_float(this.x)},c.Y=function(a){a.set_float(this.y)},c.dt=function(a){a.set_float(this.runtime.getDt(this))});h&&(f.CompareWidth=function(a,b){return cr.do_cmp(this.width,a,b)},f.CompareHeight=function(a,b){return cr.do_cmp(this.height,a,b)},m.SetWidth=function(a){this.width!==a&&(this.width=a,this.set_bbox_changed())},m.SetHeight=function(a){this.height!==a&&(this.height=
a,this.set_bbox_changed())},m.SetSize=function(a,b){if(this.width!==a||this.height!==b)this.width=a,this.height=b,this.set_bbox_changed()},c.Width=function(a){a.set_float(this.width)},c.Height=function(a){a.set_float(this.height)},c.BBoxLeft=function(a){this.update_bbox();a.set_float(this.bbox.left)},c.BBoxTop=function(a){this.update_bbox();a.set_float(this.bbox.top)},c.BBoxRight=function(a){this.update_bbox();a.set_float(this.bbox.right)},c.BBoxBottom=function(a){this.update_bbox();a.set_float(this.bbox.bottom)});
g&&(f.AngleWithin=function(a,b){return cr.angleDiff(this.angle,cr.to_radians(b))<=cr.to_radians(a)},f.IsClockwiseFrom=function(a){return cr.angleClockwise(this.angle,cr.to_radians(a))},f.IsBetweenAngles=function(a,b){var c=cr.to_clamped_radians(a),d=cr.to_clamped_radians(b),e=cr.clamp_angle(this.angle);return cr.angleClockwise(d,c)?cr.angleClockwise(e,c)&&!cr.angleClockwise(e,d):!(!cr.angleClockwise(e,c)&&cr.angleClockwise(e,d))},m.SetAngle=function(a){a=cr.to_radians(cr.clamp_angle_degrees(a));isNaN(a)||
this.angle===a||(this.angle=a,this.set_bbox_changed())},m.RotateClockwise=function(a){0===a||isNaN(a)||(this.angle+=cr.to_radians(a),this.angle=cr.clamp_angle(this.angle),this.set_bbox_changed())},m.RotateCounterclockwise=function(a){0===a||isNaN(a)||(this.angle-=cr.to_radians(a),this.angle=cr.clamp_angle(this.angle),this.set_bbox_changed())},m.RotateTowardAngle=function(a,b){var c=cr.angleRotate(this.angle,cr.to_radians(b),cr.to_radians(a));isNaN(c)||this.angle===c||(this.angle=c,this.set_bbox_changed())},
m.RotateTowardPosition=function(a,b,c){b=Math.atan2(c-this.y,b-this.x);a=cr.angleRotate(this.angle,b,cr.to_radians(a));isNaN(a)||this.angle===a||(this.angle=a,this.set_bbox_changed())},m.SetTowardPosition=function(a,b){var c=Math.atan2(b-this.y,a-this.x);isNaN(c)||this.angle===c||(this.angle=c,this.set_bbox_changed())},c.Angle=function(a){a.set_float(cr.to_clamped_degrees(this.angle))});d||(f.CompareInstanceVar=function(a,b,c){return cr.do_cmp(this.instance_vars[a],b,c)},f.IsBoolInstanceVarSet=function(a){return this.instance_vars[a]},
f.PickInstVarHiLow=function(a,b){var c=this.getCurrentSol(),d=c.getObjects();if(!d.length)return!1;var e=d[0],f=e,g=e.instance_vars[b],h,k,m;h=1;for(k=d.length;h<k;h++)if(e=d[h],m=e.instance_vars[b],0===a&&m<g||1===a&&m>g)g=m,f=e;c.pick_one(f);return!0},f.PickByUID=function(a){var b,c,d,e,f;if(this.runtime.getCurrentCondition().inverted){f=this.getCurrentSol();if(f.select_all)for(f.select_all=!1,f.instances.length=0,f.else_instances.length=0,d=this.instances,b=0,c=d.length;b<c;b++)e=d[b],e.uid===
a?f.else_instances.push(e):f.instances.push(e);else{d=b=0;for(c=f.instances.length;b<c;b++)e=f.instances[b],f.instances[d]=e,e.uid===a?f.else_instances.push(e):d++;f.instances.length=d}this.applySolToContainer();return!!f.instances.length}e=this.runtime.getObjectByUID(a);if(!e)return!1;f=this.getCurrentSol();if(!f.select_all&&-1===f.instances.indexOf(e))return!1;if(this.is_family)for(a=e.type.families,b=0,c=a.length;b<c;b++){if(a[b]===this)return f.pick_one(e),this.applySolToContainer(),!0}else if(e.type===
this)return f.pick_one(e),this.applySolToContainer(),!0;return!1},f.OnCreated=function(){return!0},f.OnDestroyed=function(){return!0},m.SetInstanceVar=function(a,b){var c=this.instance_vars;cr.is_number(c[a])?cr.is_number(b)?c[a]=b:c[a]=parseFloat(b):cr.is_string(c[a])&&(cr.is_string(b)?c[a]=b:c[a]=b.toString())},m.AddInstanceVar=function(a,b){var c=this.instance_vars;cr.is_number(c[a])?cr.is_number(b)?c[a]+=b:c[a]+=parseFloat(b):cr.is_string(c[a])&&(cr.is_string(b)?c[a]+=b:c[a]+=b.toString())},m.SubInstanceVar=
function(a,b){var c=this.instance_vars;cr.is_number(c[a])&&(cr.is_number(b)?c[a]-=b:c[a]-=parseFloat(b))},m.SetBoolInstanceVar=function(a,b){this.instance_vars[a]=b?1:0},m.ToggleBoolInstanceVar=function(a){this.instance_vars[a]=1-this.instance_vars[a]},m.Destroy=function(){this.runtime.DestroyInstance(this)},m.LoadFromJsonString||(m.LoadFromJsonString=function(a){var b,c;try{b=JSON.parse(a)}catch(d){return}this.runtime.loadInstanceFromJSON(this,b,!0);this.afterLoad&&this.afterLoad();if(this.behavior_insts)for(a=
0,b=this.behavior_insts.length;a<b;++a)c=this.behavior_insts[a],c.afterLoad&&c.afterLoad()}),c.Count=function(a){var b=a.object_class.instances.length,c,d,e;c=0;for(d=this.runtime.createRow.length;c<d;c++)e=this.runtime.createRow[c],a.object_class.is_family?0<=e.type.families.indexOf(a.object_class)&&b++:e.type===a.object_class&&b++;a.set_int(b)},c.PickedCount=function(a){a.set_int(a.object_class.getCurrentSol().getObjects().length)},c.UID=function(a){a.set_int(this.uid)},c.IID=function(a){a.set_int(this.get_iid())},
c.AsJSON||(c.AsJSON=function(a){a.set_string(JSON.stringify(this.runtime.saveInstanceToJSON(this,!0)))}));l&&(f.IsVisible=function(){return this.visible},m.SetVisible=function(a){!a!==!this.visible&&(this.visible=a,this.runtime.redraw=!0)},f.CompareOpacity=function(a,b){return cr.do_cmp(cr.round6dp(100*this.opacity),a,b)},m.SetOpacity=function(a){a/=100;0>a?a=0:1<a&&(a=1);a!==this.opacity&&(this.opacity=a,this.runtime.redraw=!0)},c.Opacity=function(a){a.set_float(cr.round6dp(100*this.opacity))});
k&&(f.IsOnLayer=function(a){return a?this.layer===a:!1},f.PickTopBottom=function(a){var b=this.getCurrentSol(),c=b.getObjects();if(!c.length)return!1;var d=c[0],e=d,f,g;f=1;for(g=c.length;f<g;f++)if(d=c[f],0===a){if(d.layer.index>e.layer.index||d.layer.index===e.layer.index&&d.get_zindex()>e.get_zindex())e=d}else if(d.layer.index<e.layer.index||d.layer.index===e.layer.index&&d.get_zindex()<e.get_zindex())e=d;b.pick_one(e);return!0},m.MoveToTop=function(){var a=this.get_zindex();a!==this.layer.instances.length-
1&&(cr.arrayRemove(this.layer.instances,a),this.layer.instances.push(this),this.runtime.redraw=!0,this.layer.zindices_stale=!0)},m.MoveToBottom=function(){var a=this.get_zindex();0!==a&&(cr.arrayRemove(this.layer.instances,a),this.layer.instances.unshift(this),this.runtime.redraw=!0,this.layer.zindices_stale=!0)},m.MoveToLayer=function(a){a&&a!=this.layer&&(cr.arrayRemove(this.layer.instances,this.get_zindex()),this.layer.zindices_stale=!0,this.layer=a,this.zindex=a.instances.length,a.instances.push(this),
this.runtime.redraw=!0)},m.ZMoveToObject=function(a,b){var c=0===a;if(b){var d=b.getFirstPicked(this);if(d&&d.uid!==this.uid){this.layer.index!==d.layer.index&&(cr.arrayRemove(this.layer.instances,this.get_zindex()),this.layer.zindices_stale=!0,this.layer=d.layer,this.zindex=d.layer.instances.length,d.layer.instances.push(this));var e=this.get_zindex(),d=d.get_zindex();cr.arrayRemove(this.layer.instances,e);e<d&&d--;c&&d++;d===this.layer.instances.length?this.layer.instances.push(this):this.layer.instances.splice(d,
0,this);this.layer.zindices_stale=!0;this.runtime.redraw=!0}}},c.LayerNumber=function(a){a.set_int(this.layer.number)},c.LayerName=function(a){a.set_string(this.layer.name)},c.ZIndex=function(a){a.set_int(this.get_zindex())});a&&(m.SetEffectEnabled=function(a,b){if(this.runtime.glwrap){var c=this.type.getEffectIndexByName(b);if(!(0>c)){var d=1===a;this.active_effect_flags[c]!==d&&(this.active_effect_flags[c]=d,this.updateActiveEffects(),this.runtime.redraw=!0)}}},m.SetEffectParam=function(a,b,c){if(this.runtime.glwrap){var d=
this.type.getEffectIndexByName(a);0>d||(a=this.type.effect_types[d],d=this.effect_params[d],b=Math.floor(b),0>b||b>=d.length||(1===this.runtime.glwrap.getProgramParameterType(a.shaderindex,b)&&(c/=100),d[b]!==c&&(d[b]=c,a.active&&(this.runtime.redraw=!0))))}})};cr.set_bbox_changed=function(){this.bbox_changed=!0;this.type.any_bbox_changed=!0;this.runtime.redraw=!0;var a,c,d=this.bbox_changed_callbacks;a=0;for(c=d.length;a<c;++a)d[a](this)};cr.add_bbox_changed_callback=function(a){a&&this.bbox_changed_callbacks.push(a)};
var a=new cr.rect(0,0,0,0);cr.update_bbox=function(){if(this.bbox_changed){var b=this.bbox,c=this.bquad;b.set(this.x,this.y,this.x+this.width,this.y+this.height);b.offset(-this.hotspotX*this.width,-this.hotspotY*this.height);this.angle?(b.offset(-this.x,-this.y),c.set_from_rotated_rect(b,this.angle),c.offset(this.x,this.y),c.bounding_box(b)):c.set_from_rect(b);b.normalize();this.bbox_changed=!1;if(this.collisionsEnabled){var c=this.type.collision_grid,d=this.collcells;a.set(c.XToCell(b.left),c.YToCell(b.top),
c.XToCell(b.right),c.YToCell(b.bottom));d.equals(a)||(d.right<d.left?c.update(this,null,a):c.update(this,d,a),d.copy(a))}}};cr.inst_contains_pt=function(a,c){return this.bbox.contains_pt(a,c)&&this.bquad.contains_pt(a,c)?this.collision_poly&&!this.collision_poly.is_empty()?(this.collision_poly.cache_poly(this.width,this.height,this.angle),this.collision_poly.contains_pt(a-this.x,c-this.y)):!0:!1};cr.inst_get_iid=function(){this.type.updateIIDs();return this.iid};cr.inst_get_zindex=function(){this.layer.updateZIndices();
return this.zindex};cr.inst_updateActiveEffects=function(){this.active_effect_types.length=0;var a,c;a=0;for(c=this.active_effect_flags.length;a<c;a++)this.active_effect_flags[a]&&this.active_effect_types.push(this.type.effect_types[a]);this.uses_shaders=!!this.active_effect_types.length};cr.inst_toString=function(){return"Inst"+this.puid};cr.type_getFirstPicked=function(a){if(a&&a.is_contained&&a.type!=this){var c,d,e;c=0;for(d=a.siblings.length;c<d;c++)if(e=a.siblings[c],e.type==this)return e}a=
this.getCurrentSol().getObjects();return a.length?a[0]:null};cr.type_getPairedInstance=function(a){var c=this.getCurrentSol().getObjects();return c.length?c[a.get_iid()%c.length]:null};cr.type_updateIIDs=function(){if(this.stale_iids&&!this.is_family){var a,c;a=0;for(c=this.instances.length;a<c;a++)this.instances[a].iid=a;var d=a,e=this.runtime.createRow;a=0;for(c=e.length;a<c;++a)e[a].type===this&&(e[a].iid=d++);this.stale_iids=!1}};cr.type_getInstanceByIID=function(a){if(a<this.instances.length)return this.instances[a];
a-=this.instances.length;var c=this.runtime.createRow,d,e;d=0;for(e=c.length;d<e;++d)if(c[d].type===this){if(0===a)return c[d];--a}return null};cr.type_getCurrentSol=function(){return this.solstack[this.cur_sol]};cr.type_pushCleanSol=function(){this.cur_sol++;this.cur_sol===this.solstack.length?this.solstack.push(new cr.selection(this)):this.solstack[this.cur_sol].select_all=!0};cr.type_pushCopySol=function(){this.cur_sol++;this.cur_sol===this.solstack.length&&this.solstack.push(new cr.selection(this));
var a=this.solstack[this.cur_sol],c=this.solstack[this.cur_sol-1];c.select_all?a.select_all=!0:(a.select_all=!1,cr.shallowAssignArray(a.instances,c.instances),cr.shallowAssignArray(a.else_instances,c.else_instances))};cr.type_popSol=function(){this.cur_sol--};cr.type_getBehaviorByName=function(a){var c,d,e,h,g,l=0;if(!this.is_family)for(c=0,d=this.families.length;c<d;c++)for(g=this.families[c],e=0,h=g.behaviors.length;e<h;e++){if(a===g.behaviors[e].name)return this.extra.lastBehIndex=l,g.behaviors[e];
l++}c=0;for(d=this.behaviors.length;c<d;c++){if(a===this.behaviors[c].name)return this.extra.lastBehIndex=l,this.behaviors[c];l++}return null};cr.type_getBehaviorIndexByName=function(a){return this.getBehaviorByName(a)?this.extra.lastBehIndex:-1};cr.type_getEffectIndexByName=function(a){var c,d;c=0;for(d=this.effect_types.length;c<d;c++)if(this.effect_types[c].name===a)return c;return-1};cr.type_applySolToContainer=function(){if(this.is_contained&&!this.is_family){var a,c,d,e,h,g,l;this.updateIIDs();
g=this.getCurrentSol();var k=g.select_all,f=(a=this.runtime.getCurrentEventStack())&&a.current_event&&a.current_event.orblock;a=0;for(c=this.container.length;a<c;a++)if(h=this.container[a],h!==this&&(h.updateIIDs(),l=h.getCurrentSol(),l.select_all=k,!k)){l.instances.length=g.instances.length;d=0;for(e=g.instances.length;d<e;d++)l.instances[d]=h.getInstanceByIID(g.instances[d].iid);if(f)for(l.else_instances.length=g.else_instances.length,d=0,e=g.else_instances.length;d<e;d++)l.else_instances[d]=h.getInstanceByIID(g.else_instances[d].iid)}}};
cr.type_toString=function(){return"Type"+this.sid};cr.do_cmp=function(a,c,d){if("undefined"===typeof a||"undefined"===typeof d)return!1;switch(c){case 0:return a===d;case 1:return a!==d;case 2:return a<d;case 3:return a<=d;case 4:return a>d;case 5:return a>=d;default:return!1}}})();cr.shaders={};cr.plugins_.Audio=function(a){this.runtime=a};
(function(){function a(a){a=Math.pow(10,a/20);0>a&&(a=0);1<a&&(a=1);return a}function b(a){0>a&&(a=0);1<a&&(a=1);return 20*(Math.log(a)/Math.log(10))}function c(a){a=a.toLowerCase();return M.hasOwnProperty(a)&&M[a].length?M[a][0].getInputNode():I.destination}function d(){return I.createGain?I.createGain():I.createGainNode()}function e(a){return I.createDelay?I.createDelay(a):I.createDelayNode(a)}function h(a){a.start?a.start(0):a.noteOn(0)}function g(a,b,c){a.start?a.start(0,b):a.noteGrainOn(0,b,
c-b)}function l(a){try{a.stop?a.stop(0):a.noteOff(0)}catch(b){}}function k(a,b,c,d){if(a)if(a.cancelScheduledValues(0),0===d)a.value=b;else{var e=I.currentTime;d+=e;switch(c){case 0:a.setValueAtTime(b,d);break;case 1:a.setValueAtTime(a.value,e);a.linearRampToValueAtTime(b,d);break;case 2:a.setValueAtTime(a.value,e),a.exponentialRampToValueAtTime(b,d)}}}function f(a,b,c,e,f,g){this.type="filter";this.params=[a,b,c,e,f,g];this.inputNode=d();this.wetNode=d();this.wetNode.gain.value=g;this.dryNode=d();
this.dryNode.gain.value=1-g;this.filterNode=I.createBiquadFilter();this.filterNode.type="number"===typeof this.filterNode.type?a:la[a];this.filterNode.frequency.value=b;this.filterNode.detune&&(this.filterNode.detune.value=c);this.filterNode.Q.value=e;this.filterNode.gain.value=f;this.inputNode.connect(this.filterNode);this.inputNode.connect(this.dryNode);this.filterNode.connect(this.wetNode)}function m(a,b,c){this.type="delay";this.params=[a,b,c];this.inputNode=d();this.wetNode=d();this.wetNode.gain.value=
c;this.dryNode=d();this.dryNode.gain.value=1-c;this.mainNode=d();this.delayNode=e(a);this.delayNode.delayTime.value=a;this.delayGainNode=d();this.delayGainNode.gain.value=b;this.inputNode.connect(this.mainNode);this.inputNode.connect(this.dryNode);this.mainNode.connect(this.wetNode);this.mainNode.connect(this.delayNode);this.delayNode.connect(this.delayGainNode);this.delayGainNode.connect(this.mainNode)}function n(a,b,c,e){this.type="convolve";this.params=[b,c,e];this.inputNode=d();this.wetNode=d();
this.wetNode.gain.value=c;this.dryNode=d();this.dryNode.gain.value=1-c;this.convolveNode=I.createConvolver();a&&(this.convolveNode.normalize=b,this.convolveNode.buffer=a);this.inputNode.connect(this.convolveNode);this.inputNode.connect(this.dryNode);this.convolveNode.connect(this.wetNode)}function p(a,b,c,f,g){this.type="flanger";this.params=[a,b,c,f,g];this.inputNode=d();this.dryNode=d();this.dryNode.gain.value=1-g/2;this.wetNode=d();this.wetNode.gain.value=g/2;this.feedbackNode=d();this.feedbackNode.gain.value=
f;this.delayNode=e(a+b);this.delayNode.delayTime.value=a;this.oscNode=I.createOscillator();this.oscNode.frequency.value=c;this.oscGainNode=d();this.oscGainNode.gain.value=b;this.inputNode.connect(this.delayNode);this.inputNode.connect(this.dryNode);this.delayNode.connect(this.wetNode);this.delayNode.connect(this.feedbackNode);this.feedbackNode.connect(this.delayNode);this.oscNode.connect(this.oscGainNode);this.oscGainNode.connect(this.delayNode.delayTime);h(this.oscNode)}function q(a,b,c,e,f,g){this.type=
"phaser";this.params=[a,b,c,e,f,g];this.inputNode=d();this.dryNode=d();this.dryNode.gain.value=1-g/2;this.wetNode=d();this.wetNode.gain.value=g/2;this.filterNode=I.createBiquadFilter();this.filterNode.type="number"===typeof this.filterNode.type?7:"allpass";this.filterNode.frequency.value=a;this.filterNode.detune&&(this.filterNode.detune.value=b);this.filterNode.Q.value=c;this.oscNode=I.createOscillator();this.oscNode.frequency.value=f;this.oscGainNode=d();this.oscGainNode.gain.value=e;this.inputNode.connect(this.filterNode);
this.inputNode.connect(this.dryNode);this.filterNode.connect(this.wetNode);this.oscNode.connect(this.oscGainNode);this.oscGainNode.connect(this.filterNode.frequency);h(this.oscNode)}function s(a){this.type="gain";this.params=[a];this.node=d();this.node.gain.value=a}function r(a,b){this.type="tremolo";this.params=[a,b];this.node=d();this.node.gain.value=1-b/2;this.oscNode=I.createOscillator();this.oscNode.frequency.value=a;this.oscGainNode=d();this.oscGainNode.gain.value=b/2;this.oscNode.connect(this.oscGainNode);
this.oscGainNode.connect(this.node.gain);h(this.oscNode)}function t(a,b){this.type="ringmod";this.params=[a,b];this.inputNode=d();this.wetNode=d();this.wetNode.gain.value=b;this.dryNode=d();this.dryNode.gain.value=1-b;this.ringNode=d();this.ringNode.gain.value=0;this.oscNode=I.createOscillator();this.oscNode.frequency.value=a;this.oscNode.connect(this.ringNode.gain);h(this.oscNode);this.inputNode.connect(this.ringNode);this.inputNode.connect(this.dryNode);this.ringNode.connect(this.wetNode)}function w(a,
b,c,e,f){this.type="distortion";this.params=[a,b,c,e,f];this.inputNode=d();this.preGain=d();this.postGain=d();this.setDrive(c,Math.pow(10,e/20));this.wetNode=d();this.wetNode.gain.value=f;this.dryNode=d();this.dryNode.gain.value=1-f;this.waveShaper=I.createWaveShaper();this.curve=new Float32Array(65536);this.generateColortouchCurve(a,b);this.waveShaper.curve=this.curve;this.inputNode.connect(this.preGain);this.inputNode.connect(this.dryNode);this.preGain.connect(this.waveShaper);this.waveShaper.connect(this.postGain);
this.postGain.connect(this.wetNode)}function A(a,b,c,d,e){this.type="compressor";this.params=[a,b,c,d,e];this.node=I.createDynamicsCompressor();this.node.threshold.value=a;this.node.knee.value=b;this.node.ratio.value=c;this.node.attack.value=d;this.node.release.value=e}function D(a,b){this.type="analyser";this.params=[a,b];this.node=I.createAnalyser();this.node.fftSize=a;this.node.smoothingTimeConstant=b;this.freqBins=new Float32Array(this.node.frequencyBinCount);this.signal=new Uint8Array(a);this.rms=
this.peak=0}function O(){this.obj=null;this.loadUid=0;this.speeds=[];this.moveAngle=this.lastY=this.lastX=0}function B(a,b){this.src=a;this.myapi=K;this.is_music=b;this.added_end_listener=!1;var c=this;this.mediaSourceNode=this.outNode=null;this.panWhenReady=[];this.seekWhenReady=0;this.supportWebAudioAPI=this.pauseWhenReady=!1;K===C&&b&&(this.myapi=Q,this.outNode=d());this.audioData=this.bufferObject=null;var e;switch(this.myapi){case Q:this.bufferObject=new Audio;K===C&&I.createMediaElementSource&&
!J.isFirefox&&(this.supportWebAudioAPI=!0,this.bufferObject.addEventListener("canplay",function(){c.mediaSourceNode||(c.mediaSourceNode=I.createMediaElementSource(c.bufferObject),c.mediaSourceNode.connect(c.outNode))}));this.bufferObject.autoplay=!1;this.bufferObject.preload="auto";this.bufferObject.src=a;break;case C:e=new XMLHttpRequest;e.open("GET",a,!0);e.responseType="arraybuffer";e.onload=function(){c.audioData=e.response;c.decodeAudioBuffer()};e.send();break;case V:this.bufferObject=!0;break;
case U:this.bufferObject=!0}}function y(a,b){var e=this;this.tag=b;this.stopped=this.fresh=!0;this.src=a.src;this.buffer=a;this.myapi=K;this.is_music=a.is_music;this.playbackRate=1;this.pgended=!0;this.is_paused=this.resume_me=!1;this.resume_position=0;this.is_silent=this.is_muted=this.looping=!1;this.mutevol=this.volume=1;this.startTime=J.kahanTime.sum;this.pannerNode=this.gainNode=null;this.pannerEnabled=!1;this.objectTracker=null;this.panConeOuterGain=this.panConeOuter=this.panConeInner=this.panAngle=
this.panY=this.panX=0;this.instanceObject=null;var f=!1;this.myapi!==C||this.buffer.myapi!==Q||this.buffer.supportWebAudioAPI||(this.myapi=Q);switch(this.myapi){case Q:this.is_music?(this.instanceObject=a.bufferObject,f=!a.added_end_listener,a.added_end_listener=!0):(this.instanceObject=new Audio,this.instanceObject.autoplay=!1,this.instanceObject.src=a.bufferObject.src,f=!0);f&&this.instanceObject.addEventListener("ended",function(){W=e.tag;e.stopped=!0;J.trigger(cr.plugins_.Audio.prototype.cnds.OnEnded,
S)});break;case C:this.gainNode=d();this.gainNode.connect(c(b));this.buffer.myapi===C?a.bufferObject&&(this.instanceObject=I.createBufferSource(),this.instanceObject.buffer=a.bufferObject,this.instanceObject.connect(this.gainNode)):(this.instanceObject=this.buffer.bufferObject,this.buffer.outNode.connect(this.gainNode));break;case V:this.instanceObject=new window.Media(T+this.src,null,null,function(a){a===window.Media.MEDIA_STOPPED&&(e.pgended=!0,e.stopped=!0,W=e.tag,J.trigger(cr.plugins_.Audio.prototype.cnds.OnEnded,
S))});break;case U:this.instanceObject=!0}}function v(a){N.length=0;if(a.length){var b,c,d;b=0;for(c=L.length;b<c;b++)d=L[b],cr.equals_nocase(a,d.tag)&&N.push(d)}else P&&!P.hasEnded()&&(N.length=1,N[0]=P)}function u(a){var b,c,d,e,f=I.destination;if(M.hasOwnProperty(a)&&(d=M[a],d.length))for(f=d[0].getInputNode(),b=0,c=d.length;b<c;b++)e=d[b],b+1===c?e.connectTo(I.destination):e.connectTo(d[b+1].getInputNode());v(a);b=0;for(c=N.length;b<c;b++)N[b].reconnect(f);ca&&ia===a&&(ca.disconnect(),ca.connect(f))}
function z(a,b){M.hasOwnProperty(a)?M[a].push(b):M[a]=[b];u(a)}function E(){}function x(){}function F(){}function G(a,b){var c=null;M.hasOwnProperty(a)&&(c=M[a]);return c&&0<=b&&b<c.length&&c[b].freqBins?c[b]:null}var H=cr.plugins_.Audio.prototype;H.Type=function(a){this.plugin=a;this.runtime=a.runtime};H.Type.prototype.onCreate=function(){};var J=null,S=null,W="",T="",Q=0,C=1,V=2,U=3,K=Q,I=null,da=[],L=[],P=null,X=!1,ha=0,R=!1,Y=1,Z=0,aa=0,ja=1,ka=1,ma=10,na=1E4,oa=1,ca=null,ia="",ea=!1,fa=[],M=
{},la="lowpass highpass bandpass lowshelf highshelf peaking notch allpass".split(" ");f.prototype.connectTo=function(a){this.wetNode.disconnect();this.wetNode.connect(a);this.dryNode.disconnect();this.dryNode.connect(a)};f.prototype.remove=function(){this.inputNode.disconnect();this.filterNode.disconnect();this.wetNode.disconnect();this.dryNode.disconnect()};f.prototype.getInputNode=function(){return this.inputNode};f.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100;0>b&&(b=0);1<b&&(b=
1);this.params[5]=b;k(this.wetNode.gain,b,c,d);k(this.dryNode.gain,1-b,c,d);break;case 1:this.params[1]=b;k(this.filterNode.frequency,b,c,d);break;case 2:this.params[2]=b;k(this.filterNode.detune,b,c,d);break;case 3:this.params[3]=b;k(this.filterNode.Q,b,c,d);break;case 4:this.params[4]=b,k(this.filterNode.gain,b,c,d)}};m.prototype.connectTo=function(a){this.wetNode.disconnect();this.wetNode.connect(a);this.dryNode.disconnect();this.dryNode.connect(a)};m.prototype.remove=function(){this.inputNode.disconnect();
this.mainNode.disconnect();this.delayNode.disconnect();this.delayGainNode.disconnect();this.wetNode.disconnect();this.dryNode.disconnect()};m.prototype.getInputNode=function(){return this.inputNode};m.prototype.setParam=function(b,c,d,e){switch(b){case 0:c/=100;0>c&&(c=0);1<c&&(c=1);this.params[2]=c;k(this.wetNode.gain,c,d,e);k(this.dryNode.gain,1-c,d,e);break;case 4:this.params[1]=a(c);k(this.delayGainNode.gain,a(c),d,e);break;case 5:this.params[0]=c,k(this.delayNode.delayTime,c,d,e)}};n.prototype.connectTo=
function(a){this.wetNode.disconnect();this.wetNode.connect(a);this.dryNode.disconnect();this.dryNode.connect(a)};n.prototype.remove=function(){this.inputNode.disconnect();this.convolveNode.disconnect();this.wetNode.disconnect();this.dryNode.disconnect()};n.prototype.getInputNode=function(){return this.inputNode};n.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100,0>b&&(b=0),1<b&&(b=1),this.params[1]=b,k(this.wetNode.gain,b,c,d),k(this.dryNode.gain,1-b,c,d)}};p.prototype.connectTo=function(a){this.dryNode.disconnect();
this.dryNode.connect(a);this.wetNode.disconnect();this.wetNode.connect(a)};p.prototype.remove=function(){this.inputNode.disconnect();this.delayNode.disconnect();this.oscNode.disconnect();this.oscGainNode.disconnect();this.dryNode.disconnect();this.wetNode.disconnect();this.feedbackNode.disconnect()};p.prototype.getInputNode=function(){return this.inputNode};p.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100;0>b&&(b=0);1<b&&(b=1);this.params[4]=b;k(this.wetNode.gain,b/2,c,d);k(this.dryNode.gain,
1-b/2,c,d);break;case 6:this.params[1]=b/1E3;k(this.oscGainNode.gain,b/1E3,c,d);break;case 7:this.params[2]=b;k(this.oscNode.frequency,b,c,d);break;case 8:this.params[3]=b/100,k(this.feedbackNode.gain,b/100,c,d)}};q.prototype.connectTo=function(a){this.dryNode.disconnect();this.dryNode.connect(a);this.wetNode.disconnect();this.wetNode.connect(a)};q.prototype.remove=function(){this.inputNode.disconnect();this.filterNode.disconnect();this.oscNode.disconnect();this.oscGainNode.disconnect();this.dryNode.disconnect();
this.wetNode.disconnect()};q.prototype.getInputNode=function(){return this.inputNode};q.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100;0>b&&(b=0);1<b&&(b=1);this.params[5]=b;k(this.wetNode.gain,b/2,c,d);k(this.dryNode.gain,1-b/2,c,d);break;case 1:this.params[0]=b;k(this.filterNode.frequency,b,c,d);break;case 2:this.params[1]=b;k(this.filterNode.detune,b,c,d);break;case 3:this.params[2]=b;k(this.filterNode.Q,b,c,d);break;case 6:this.params[3]=b;k(this.oscGainNode.gain,b,c,d);break;case 7:this.params[4]=
b,k(this.oscNode.frequency,b,c,d)}};s.prototype.connectTo=function(a){this.node.disconnect();this.node.connect(a)};s.prototype.remove=function(){this.node.disconnect()};s.prototype.getInputNode=function(){return this.node};s.prototype.setParam=function(b,c,d,e){switch(b){case 4:this.params[0]=a(c),k(this.node.gain,a(c),d,e)}};r.prototype.connectTo=function(a){this.node.disconnect();this.node.connect(a)};r.prototype.remove=function(){this.oscNode.disconnect();this.oscGainNode.disconnect();this.node.disconnect()};
r.prototype.getInputNode=function(){return this.node};r.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100;0>b&&(b=0);1<b&&(b=1);this.params[1]=b;k(this.node.gain.value,1-b/2,c,d);k(this.oscGainNode.gain.value,b/2,c,d);break;case 7:this.params[0]=b,k(this.oscNode.frequency,b,c,d)}};t.prototype.connectTo=function(a){this.wetNode.disconnect();this.wetNode.connect(a);this.dryNode.disconnect();this.dryNode.connect(a)};t.prototype.remove=function(){this.oscNode.disconnect();this.ringNode.disconnect();
this.inputNode.disconnect();this.wetNode.disconnect();this.dryNode.disconnect()};t.prototype.getInputNode=function(){return this.inputNode};t.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100;0>b&&(b=0);1<b&&(b=1);this.params[1]=b;k(this.wetNode.gain,b,c,d);k(this.dryNode.gain,1-b,c,d);break;case 7:this.params[0]=b,k(this.oscNode.frequency,b,c,d)}};w.prototype.setDrive=function(a,b){0.01>a&&(a=0.01);this.preGain.gain.value=a;this.postGain.gain.value=Math.pow(1/a,0.6)*b};w.prototype.shape=
function(a,b,c){var d=1.05*c*b-b;c=0>a?-1:1;a=0>a?-a:a;b=a<b?a:b+d*(1-Math.exp(-(1/d)*(a-b)));return b*c};w.prototype.generateColortouchCurve=function(a,b){for(var c=Math.pow(10,a/20),d=Math.pow(10,b/20),e=0,f=0;32768>f;++f)e=f/32768,e=this.shape(e,c,d),this.curve[32768+f]=e,this.curve[32768-f-1]=-e};w.prototype.connectTo=function(a){this.wetNode.disconnect();this.wetNode.connect(a);this.dryNode.disconnect();this.dryNode.connect(a)};w.prototype.remove=function(){this.inputNode.disconnect();this.preGain.disconnect();
this.waveShaper.disconnect();this.postGain.disconnect();this.wetNode.disconnect();this.dryNode.disconnect()};w.prototype.getInputNode=function(){return this.inputNode};w.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100,0>b&&(b=0),1<b&&(b=1),this.params[4]=b,k(this.wetNode.gain,b,c,d),k(this.dryNode.gain,1-b,c,d)}};A.prototype.connectTo=function(a){this.node.disconnect();this.node.connect(a)};A.prototype.remove=function(){this.node.disconnect()};A.prototype.getInputNode=function(){return this.node};
A.prototype.setParam=function(a,b,c,d){};D.prototype.tick=function(){this.node.getFloatFrequencyData(this.freqBins);this.node.getByteTimeDomainData(this.signal);for(var a=this.node.fftSize,c=0,d=this.peak=0,e=0;c<a;c++)e=(this.signal[c]-128)/128,0>e&&(e=-e),this.peak<e&&(this.peak=e),d+=e*e;this.peak=b(this.peak);this.rms=b(Math.sqrt(d/a))};D.prototype.connectTo=function(a){this.node.disconnect();this.node.connect(a)};D.prototype.remove=function(){this.node.disconnect()};D.prototype.getInputNode=
function(){return this.node};D.prototype.setParam=function(a,b,c,d){};O.prototype.setObject=function(a){if(this.obj=a)this.lastX=this.obj.x,this.lastY=this.obj.y;this.speeds.length=0};O.prototype.hasObject=function(){return!!this.obj};O.prototype.tick=function(a){this.obj&&0!==a&&(this.moveAngle=cr.angleTo(this.lastX,this.lastY,this.obj.x,this.obj.y),a=cr.distanceTo(this.lastX,this.lastY,this.obj.x,this.obj.y)/a,4>this.speeds.length||this.speeds.shift(),this.speeds.push(a),this.lastX=this.obj.x,this.lastY=
this.obj.y)};O.prototype.getSpeed=function(){if(!this.speeds.length)return 0;var a,b,c=0;a=0;for(b=this.speeds.length;a<b;a++)c+=this.speeds[a];return c/this.speeds.length};O.prototype.getVelocityX=function(){return Math.cos(this.moveAngle)*this.getSpeed()};O.prototype.getVelocityY=function(){return Math.sin(this.moveAngle)*this.getSpeed()};var pa=!1;B.prototype.decodeAudioBuffer=function(){if(!this.bufferObject&&this.audioData){var a=this;if(I.decodeAudioData)I.decodeAudioData(this.audioData,function(b){a.bufferObject=
b;var c,d,e;if(cr.is_undefined(a.playTagWhenReady)||R)cr.is_undefined(a.convolveWhenReady)||(c=a.convolveWhenReady.convolveNode,c.normalize=a.normalizeWhenReady,c.buffer=b);else if(a.panWhenReady.length){c=0;for(d=a.panWhenReady.length;c<d;c++){b=a.panWhenReady[c];e=new y(a,b.thistag);e.setPannerEnabled(!0);if("undefined"!==typeof b.objUid&&(b.obj=J.getObjectByUID(b.objUid),!b.obj))continue;if(b.obj){var f=cr.rotatePtAround(b.obj.x,b.obj.y,-b.obj.layer.getAngle(),Z,aa,!0),g=cr.rotatePtAround(b.obj.x,
b.obj.y,-b.obj.layer.getAngle(),Z,aa,!1);e.setPan(f,g,cr.to_degrees(b.obj.angle-b.obj.layer.getAngle()),b.ia,b.oa,b.og);e.setObject(b.obj)}else e.setPan(b.x,b.y,b.a,b.ia,b.oa,b.og);e.play(a.loopWhenReady,a.volumeWhenReady,a.seekWhenReady);a.pauseWhenReady&&e.pause();L.push(e)}a.panWhenReady.length=0}else e=new y(a,a.playTagWhenReady),e.play(a.loopWhenReady,a.volumeWhenReady,a.seekWhenReady),a.pauseWhenReady&&e.pause(),L.push(e)});else if(this.bufferObject=I.createBuffer(this.audioData,!1),cr.is_undefined(this.playTagWhenReady)||
R)cr.is_undefined(this.convolveWhenReady)||(b=this.convolveWhenReady.convolveNode,b.normalize=this.normalizeWhenReady,b.buffer=this.bufferObject);else{var b=new y(this,this.playTagWhenReady);b.play(this.loopWhenReady,this.volumeWhenReady,this.seekWhenReady);this.pauseWhenReady&&b.pause();L.push(b)}}};B.prototype.isLoaded=function(){switch(this.myapi){case Q:return 4===this.bufferObject.readyState;case C:return!!this.audioData;case V:return!0;case U:return!0}return!1};y.prototype.hasEnded=function(){switch(this.myapi){case Q:return this.instanceObject.ended;
case C:return this.buffer.myapi===C?!this.fresh&&!this.stopped&&this.instanceObject.loop||this.is_paused?!1:J.kahanTime.sum-this.startTime>this.buffer.bufferObject.duration:this.instanceObject.ended;case V:return this.pgended;case U:!0}return!0};y.prototype.canBeRecycled=function(){return this.fresh||this.stopped?!0:this.hasEnded()};y.prototype.setPannerEnabled=function(a){K===C&&(!this.pannerEnabled&&a?this.gainNode&&(this.pannerNode||(this.pannerNode=I.createPanner(),this.pannerNode.panningModel=
"number"===typeof this.pannerNode.panningModel?ja:["equalpower","HRTF","soundfield"][ja],this.pannerNode.distanceModel="number"===typeof this.pannerNode.distanceModel?ka:["linear","inverse","exponential"][ka],this.pannerNode.refDistance=ma,this.pannerNode.maxDistance=na,this.pannerNode.rolloffFactor=oa),this.gainNode.disconnect(),this.gainNode.connect(this.pannerNode),this.pannerNode.connect(c(this.tag)),this.pannerEnabled=!0):this.pannerEnabled&&!a&&this.gainNode&&(this.pannerNode.disconnect(),this.gainNode.disconnect(),
this.gainNode.connect(c(this.tag)),this.pannerEnabled=!1))};y.prototype.setPan=function(a,b,c,d,e,f){this.pannerEnabled&&K===C&&(this.pannerNode.setPosition(a,b,0),this.pannerNode.setOrientation(Math.cos(cr.to_radians(c)),Math.sin(cr.to_radians(c)),0),this.pannerNode.coneInnerAngle=d,this.pannerNode.coneOuterAngle=e,this.pannerNode.coneOuterGain=f,this.panX=a,this.panY=b,this.panAngle=c,this.panConeInner=d,this.panConeOuter=e,this.panConeOuterGain=f)};y.prototype.setObject=function(a){this.pannerEnabled&&
K===C&&(this.objectTracker||(this.objectTracker=new O),this.objectTracker.setObject(a))};y.prototype.tick=function(a){if(this.pannerEnabled&&K===C&&this.objectTracker&&this.objectTracker.hasObject()&&this.isPlaying()){this.objectTracker.tick(a);a=this.objectTracker.obj;var b=cr.rotatePtAround(a.x,a.y,-a.layer.getAngle(),Z,aa,!0),c=cr.rotatePtAround(a.x,a.y,-a.layer.getAngle(),Z,aa,!1);this.pannerNode.setPosition(b,c,0);b=0;"undefined"!==typeof this.objectTracker.obj.angle&&(b=a.angle-a.layer.getAngle(),
this.pannerNode.setOrientation(Math.cos(b),Math.sin(b),0));this.pannerNode.setVelocity(this.objectTracker.getVelocityX(),this.objectTracker.getVelocityY(),0)}};y.prototype.play=function(a,b,c){var d=this.instanceObject;this.looping=a;this.volume=b;c=c||0;switch(this.myapi){case Q:1!==d.playbackRate&&(d.playbackRate=1);d.volume!==b*Y&&(d.volume=b*Y);d.loop!==a&&(d.loop=a);d.muted&&(d.muted=!1);if(d.currentTime!==c)try{d.currentTime=c}catch(e){}this.is_music&&ea&&!J.isInUserInputEvent?fa.push(this):
this.instanceObject.play();break;case C:this.muted=!1;this.mutevol=1;if(this.buffer.myapi===C)this.fresh||(this.instanceObject=I.createBufferSource(),this.instanceObject.buffer=this.buffer.bufferObject,this.instanceObject.connect(this.gainNode)),this.instanceObject.loop=a,this.gainNode.gain.value=b*Y,0===c?h(this.instanceObject):g(this.instanceObject,c,this.getDuration());else{1!==d.playbackRate&&(d.playbackRate=1);d.loop!==a&&(d.loop=a);this.gainNode.gain.value=b*Y;if(d.currentTime!==c)try{d.currentTime=
c}catch(f){}this.is_music&&ea&&!J.isInUserInputEvent?fa.push(this):d.play()}break;case V:(!this.fresh&&this.stopped||0!==c)&&d.seekTo(c);d.play();this.pgended=!1;break;case U:J.isDirectCanvas?AppMobi.context.playSound(this.src,a):AppMobi.player.playSound(this.src,a)}this.playbackRate=1;this.startTime=J.kahanTime.sum-c;this.is_paused=this.stopped=this.fresh=!1};y.prototype.stop=function(){switch(this.myapi){case Q:this.instanceObject.paused||this.instanceObject.pause();break;case C:this.buffer.myapi===
C?l(this.instanceObject):this.instanceObject.paused||this.instanceObject.pause();break;case V:this.instanceObject.stop();break;case U:J.isDirectCanvas&&AppMobi.context.stopSound(this.src)}this.stopped=!0;this.is_paused=!1};y.prototype.pause=function(){if(!(this.fresh||this.stopped||this.hasEnded()||this.is_paused)){switch(this.myapi){case Q:this.instanceObject.paused||this.instanceObject.pause();break;case C:this.buffer.myapi===C?(this.resume_position=this.getPlaybackTime(),this.looping&&(this.resume_position%=
this.getDuration()),l(this.instanceObject)):this.instanceObject.paused||this.instanceObject.pause();break;case V:this.instanceObject.pause();break;case U:J.isDirectCanvas&&AppMobi.context.stopSound(this.src)}this.is_paused=!0}};y.prototype.resume=function(){if(!this.fresh&&!this.stopped&&!this.hasEnded()&&this.is_paused){switch(this.myapi){case Q:this.instanceObject.play();break;case C:this.buffer.myapi===C?(this.instanceObject=I.createBufferSource(),this.instanceObject.buffer=this.buffer.bufferObject,
this.instanceObject.connect(this.gainNode),this.instanceObject.loop=this.looping,this.gainNode.gain.value=Y*this.volume*this.mutevol,this.startTime=J.kahanTime.sum-this.resume_position,g(this.instanceObject,this.resume_position,this.getDuration())):this.instanceObject.play();break;case V:this.instanceObject.play();break;case U:J.isDirectCanvas&&AppMobi.context.resumeSound(this.src)}this.is_paused=!1}};y.prototype.seek=function(a){if(!(this.fresh||this.stopped||this.hasEnded()))switch(this.myapi){case Q:try{this.instanceObject.currentTime=
a}catch(b){}break;case C:if(this.buffer.myapi===C)this.is_paused?this.resume_position=a:(this.pause(),this.resume_position=a,this.resume());else try{this.instanceObject.currentTime=a}catch(c){}break;case U:J.isDirectCanvas&&AppMobi.context.seekSound(this.src,a)}};y.prototype.reconnect=function(a){this.myapi===C&&(this.pannerEnabled?(this.pannerNode.disconnect(),this.pannerNode.connect(a)):(this.gainNode.disconnect(),this.gainNode.connect(a)))};y.prototype.getDuration=function(){switch(this.myapi){case Q:if("undefined"!==
typeof this.instanceObject.duration)return this.instanceObject.duration;break;case C:return this.buffer.bufferObject.duration;case V:return this.instanceObject.getDuration();case U:if(J.isDirectCanvas)return AppMobi.context.getDurationSound(this.src)}return 0};y.prototype.getPlaybackTime=function(){var a=this.getDuration(),b=0;switch(this.myapi){case Q:"undefined"!==typeof this.instanceObject.currentTime&&(b=this.instanceObject.currentTime);break;case C:if(this.buffer.myapi===C){if(this.is_paused)return this.resume_position;
b=J.kahanTime.sum-this.startTime}else"undefined"!==typeof this.instanceObject.currentTime&&(b=this.instanceObject.currentTime);break;case U:J.isDirectCanvas&&(b=AppMobi.context.getPlaybackTimeSound(this.src))}!this.looping&&b>a&&(b=a);return b};y.prototype.isPlaying=function(){return!this.is_paused&&!this.fresh&&!this.stopped&&!this.hasEnded()};y.prototype.setVolume=function(a){this.volume=a;this.updateVolume()};y.prototype.updateVolume=function(){var a=this.volume*Y;switch(this.myapi){case Q:this.instanceObject.volume&&
this.instanceObject.volume!==a&&(this.instanceObject.volume=a);break;case C:this.gainNode.gain.value=a*this.mutevol}};y.prototype.getVolume=function(){return this.volume};y.prototype.doSetMuted=function(a){switch(this.myapi){case Q:this.instanceObject.muted!==!!a&&(this.instanceObject.muted=!!a);break;case C:this.mutevol=a?0:1,this.gainNode.gain.value=Y*this.volume*this.mutevol}};y.prototype.setMuted=function(a){this.is_muted=!!a;this.doSetMuted(this.is_muted||this.is_silent)};y.prototype.setSilent=
function(a){this.is_silent=!!a;this.doSetMuted(this.is_muted||this.is_silent)};y.prototype.setLooping=function(a){this.looping=a;switch(this.myapi){case Q:this.instanceObject.loop!==!!a&&(this.instanceObject.loop=!!a);break;case C:this.instanceObject.loop!==!!a&&(this.instanceObject.loop=!!a);break;case U:J.isDirectCanvas&&AppMobi.context.setLoopingSound(this.src,a)}};y.prototype.setPlaybackRate=function(a){this.playbackRate=a;this.updatePlaybackRate()};y.prototype.updatePlaybackRate=function(){var a=
this.playbackRate;if(1===ha&&!this.is_music||2===ha)a*=J.timescale;switch(this.myapi){case Q:this.instanceObject.playbackRate!==a&&(this.instanceObject.playbackRate=a);break;case C:this.buffer.myapi===C?this.instanceObject.playbackRate.value!==a&&(this.instanceObject.playbackRate.value=a):this.instanceObject.playbackRate!==a&&(this.instanceObject.playbackRate=a)}};y.prototype.setSuspended=function(a){switch(this.myapi){case Q:a?this.isPlaying()?(this.instanceObject.pause(),this.resume_me=!0):this.resume_me=
!1:this.resume_me&&this.instanceObject.play();break;case C:a?this.isPlaying()?(this.buffer.myapi===C?(this.resume_position=this.getPlaybackTime(),this.looping&&(this.resume_position%=this.getDuration()),l(this.instanceObject)):this.instanceObject.pause(),this.resume_me=!0):this.resume_me=!1:this.resume_me&&(this.buffer.myapi===C?(this.instanceObject=I.createBufferSource(),this.instanceObject.buffer=this.buffer.bufferObject,this.instanceObject.connect(this.gainNode),this.instanceObject.loop=this.looping,
this.gainNode.gain.value=Y*this.volume*this.mutevol,this.startTime=J.kahanTime.sum-this.resume_position,g(this.instanceObject,this.resume_position,this.getDuration())):this.instanceObject.play());break;case V:a?this.isPlaying()?(this.instanceObject.pause(),this.resume_me=!0):this.resume_me=!1:this.resume_me&&this.instanceObject.play()}};H.Instance=function(a){this.type=a;J=this.runtime=a.runtime;S=this;this.listenerTracker=null;this.listenerZ=-600;!(this.runtime.isiOS||this.runtime.isAndroid&&(this.runtime.isChrome||
this.runtime.isAndroidStockBrowser))||this.runtime.isCrosswalk||this.runtime.isDomFree||(ea=!0);I=null;"undefined"!==typeof AudioContext?(K=C,I=new AudioContext):"undefined"!==typeof webkitAudioContext&&(K=C,I=new webkitAudioContext);(this.runtime.isiOS&&K===C||ea)&&document.addEventListener("touchstart",function(){var a,b,c;!pa&&I&&(a=I.createBuffer(1,1,22050),b=I.createBufferSource(),b.buffer=a,b.connect(I.destination),h(b),pa=!0);if(ea){if(!R)for(a=0,b=fa.length;a<b;++a)c=fa[a],c.stopped||c.is_paused||
c.instanceObject.play();fa.length=0}},!0);K!==C&&(this.runtime.isPhoneGap?K=V:this.runtime.isAppMobi&&(K=U));K===V&&(T=location.href,a=T.lastIndexOf("/"),-1<a&&(T=T.substr(0,a+1)),T=T.replace("file://",""));if(this.runtime.isSafari&&this.runtime.isWindows&&"undefined"===typeof Audio)alert("It looks like you're using Safari for Windows without Quicktime.  Audio cannot be played until Quicktime is installed."),this.runtime.DestroyInstance(this);else{if(this.runtime.isDirectCanvas)X=this.runtime.isAndroid;
else try{X=!!(new Audio).canPlayType('audio/ogg; codecs="vorbis"')}catch(b){X=!1}this.runtime.tickMe(this)}};var ba=H.Instance.prototype;ba.onCreate=function(){ha=this.properties[0];this.saveload=this.properties[1];ja=this.properties[2];ka=this.properties[3];this.listenerZ=-this.properties[4];ma=this.properties[5];na=this.properties[6];oa=this.properties[7];this.listenerTracker=new O;K===C&&(I.listener.speedOfSound=this.properties[8],I.listener.dopplerFactor=this.properties[9],I.listener.setPosition(this.runtime.draw_width/
2,this.runtime.draw_height/2,this.listenerZ),I.listener.setOrientation(0,0,1,0,-1,0),window.c2OnAudioMicStream=function(a,b){ca&&ca.disconnect();ia=b.toLowerCase();ca=I.createMediaStreamSource(a);ca.connect(c(ia))});this.runtime.addSuspendCallback(function(a){S.onSuspend(a)});var a=this;this.runtime.addDestroyCallback(function(b){a.onInstanceDestroyed(b)})};ba.onInstanceDestroyed=function(a){var b,c,d;b=0;for(c=L.length;b<c;b++)d=L[b],d.objectTracker&&d.objectTracker.obj===a&&(d.objectTracker.obj=
null,d.pannerEnabled&&d.isPlaying()&&d.looping&&d.stop());this.listenerTracker.obj===a&&(this.listenerTracker.obj=null)};ba.saveToJSON=function(){var a={silent:R,masterVolume:Y,listenerZ:this.listenerZ,listenerUid:this.listenerTracker.hasObject()?this.listenerTracker.obj.uid:-1,playing:[],effects:{}},b=a.playing,c,d,e,f,g,h;c=0;for(d=L.length;c<d;c++)e=L[c],!e.isPlaying()||3===this.saveload||e.is_music&&1===this.saveload||!e.is_music&&2===this.saveload||(f=e.getPlaybackTime(),e.looping&&(f%=e.getDuration()),
f={tag:e.tag,buffersrc:e.buffer.src,is_music:e.is_music,playbackTime:f,volume:e.volume,looping:e.looping,muted:e.is_muted,playbackRate:e.playbackRate,paused:e.is_paused,resume_position:e.resume_position},e.pannerEnabled&&(f.pan={},h=f.pan,e.objectTracker&&e.objectTracker.hasObject()?h.objUid=e.objectTracker.obj.uid:(h.x=e.panX,h.y=e.panY,h.a=e.panAngle),h.ia=e.panConeInner,h.oa=e.panConeOuter,h.og=e.panConeOuterGain),b.push(f));b=a.effects;for(g in M)if(M.hasOwnProperty(g)){e=[];c=0;for(d=M[g].length;c<
d;c++)e.push({type:M[g][c].type,params:M[g][c].params});b[g]=e}return a};var ga=[];ba.loadFromJSON=function(a){var b=a.silent;Y=a.masterVolume;this.listenerZ=a.listenerZ;this.listenerTracker.setObject(null);var c=a.listenerUid;-1!==c&&(this.listenerTracker.loadUid=c,ga.push(this.listenerTracker));var c=a.playing,d,e,g,h,k,l,B,y,v,u,x;if(3!==this.saveload)for(d=0,e=L.length;d<e;d++)v=L[d],v.is_music&&1===this.saveload||(v.is_music||2!==this.saveload)&&v.stop();for(k in M)if(M.hasOwnProperty(k))for(d=
0,e=M[k].length;d<e;d++)M[k][d].remove();cr.wipe(M);for(k in a.effects)if(a.effects.hasOwnProperty(k))for(l=a.effects[k],d=0,e=l.length;d<e;d++)switch(g=l[d].type,u=l[d].params,g){case "filter":z(k,new f(u[0],u[1],u[2],u[3],u[4],u[5]));break;case "delay":z(k,new m(u[0],u[1],u[2]));break;case "convolve":g=u[2];v=this.getAudioBuffer(g,!1);v.bufferObject?g=new n(v.bufferObject,u[0],u[1],g):(g=new n(null,u[0],u[1],g),v.normalizeWhenReady=u[0],v.convolveWhenReady=g);z(k,g);break;case "flanger":z(k,new p(u[0],
u[1],u[2],u[3],u[4]));break;case "phaser":z(k,new q(u[0],u[1],u[2],u[3],u[4],u[5]));break;case "gain":z(k,new s(u[0]));break;case "tremolo":z(k,new r(u[0],u[1]));break;case "ringmod":z(k,new t(u[0],u[1]));break;case "distortion":z(k,new w(u[0],u[1],u[2],u[3],u[4]));break;case "compressor":z(k,new A(u[0],u[1],u[2],u[3],u[4]));break;case "analyser":z(k,new D(u[0],u[1]))}d=0;for(e=c.length;d<e;d++)3===this.saveload||(a=c[d],g=a.buffersrc,h=a.is_music,k=a.tag,l=a.playbackTime,B=a.looping,y=a.volume,x=
(u=a.pan)&&u.hasOwnProperty("objUid")?u.objUid:-1,h&&1===this.saveload)||!h&&2===this.saveload||((v=this.getAudioInstance(g,k,h,B,y))?(v.resume_position=a.resume_position,v.setPannerEnabled(!!u),v.play(B,y,l),v.updatePlaybackRate(),v.updateVolume(),v.doSetMuted(v.is_muted||v.is_silent),a.paused&&v.pause(),a.muted&&v.setMuted(!0),v.doSetMuted(v.is_muted||v.is_silent),u&&(-1!==x?(v.objectTracker=v.objectTracker||new O,v.objectTracker.loadUid=x,ga.push(v.objectTracker)):v.setPan(u.x,u.y,u.a,u.ia,u.oa,
u.og))):(v=this.getAudioBuffer(g,h),v.seekWhenReady=l,v.pauseWhenReady=a.paused,u&&(-1!==x?v.panWhenReady.push({objUid:x,ia:u.ia,oa:u.oa,og:u.og,thistag:k}):v.panWhenReady.push({x:u.x,y:u.y,a:u.a,ia:u.ia,oa:u.oa,og:u.og,thistag:k}))));if(b&&!R){d=0;for(e=L.length;d<e;d++)L[d].setSilent(!0);R=!0}else if(!b&&R){d=0;for(e=L.length;d<e;d++)L[d].setSilent(!1);R=!1}};ba.afterLoad=function(){var a,b,c,d;a=0;for(b=ga.length;a<b;a++)c=ga[a],d=this.runtime.getObjectByUID(c.loadUid),c.setObject(d),c.loadUid=
-1,d&&(Z=d.x,aa=d.y);ga.length=0};ba.onSuspend=function(a){var b,c;b=0;for(c=L.length;b<c;b++)L[b].setSuspended(a)};ba.tick=function(){var a=this.runtime.dt,b,c,d;b=0;for(c=L.length;b<c;b++)d=L[b],d.tick(a),d.myapi===Q||d.myapi===U||d.fresh||d.stopped||!d.hasEnded()||(d.stopped=!0,W=d.tag,J.trigger(cr.plugins_.Audio.prototype.cnds.OnEnded,S)),0!==ha&&d.updatePlaybackRate();var e,f;for(e in M)if(M.hasOwnProperty(e))for(d=M[e],b=0,c=d.length;b<c;b++)f=d[b],f.tick&&f.tick();K===C&&this.listenerTracker.hasObject()&&
(this.listenerTracker.tick(a),Z=this.listenerTracker.obj.x,aa=this.listenerTracker.obj.y,I.listener.setPosition(this.listenerTracker.obj.x,this.listenerTracker.obj.y,this.listenerZ),I.listener.setVelocity(this.listenerTracker.getVelocityX(),this.listenerTracker.getVelocityY(),0))};ba.getAudioBuffer=function(a,b){var c,d,e,f=null;c=0;for(d=da.length;c<d;c++)if(e=da[c],e.src===a){f=e;break}f||(f=new B(a,b),da.push(f));return f};ba.getAudioInstance=function(a,b,c,d,e){var f,g,h;f=0;for(g=L.length;f<
g;f++)if(h=L[f],h.src===a&&(h.canBeRecycled()||c))return h.tag=b,h;a=this.getAudioBuffer(a,c);if(!a.bufferObject)return"<preload>"!==b&&(a.playTagWhenReady=b,a.loopWhenReady=d,a.volumeWhenReady=e),null;h=new y(a,b);L.push(h);return h};var N=[];E.prototype.OnEnded=function(a){return cr.equals_nocase(W,a)};E.prototype.PreloadsComplete=function(){var a,b;a=0;for(b=da.length;a<b;a++)if(!da[a].isLoaded())return!1;return!0};E.prototype.AdvancedAudioSupported=function(){return K===C};E.prototype.IsSilent=
function(){return R};E.prototype.IsAnyPlaying=function(){var a,b;a=0;for(b=L.length;a<b;a++)if(L[a].isPlaying())return!0;return!1};E.prototype.IsTagPlaying=function(a){v(a);var b;a=0;for(b=N.length;a<b;a++)if(N[a].isPlaying())return!0;return!1};H.cnds=new E;x.prototype.Play=function(b,c,d,e){!R&&(d=a(d),P=this.getAudioInstance(this.runtime.files_subfolder+b[0]+(X?".ogg":".m4a"),e,b[1],0!==c,d))&&(P.setPannerEnabled(!1),P.play(0!==c,d))};x.prototype.PlayAtPosition=function(b,c,d,e,f,g,h,k,m,n){if(!R){d=
a(d);var q=b[1];b=this.runtime.files_subfolder+b[0]+(X?".ogg":".m4a");(P=this.getAudioInstance(b,n,q,0!==c,d))?(P.setPannerEnabled(!0),P.setPan(e,f,g,h,k,a(m)),P.play(0!==c,d)):this.getAudioBuffer(b,q).panWhenReady.push({x:e,y:f,a:g,ia:h,oa:k,og:a(m),thistag:n})}};x.prototype.PlayAtObject=function(b,c,d,e,f,g,h,k){if(!R&&e&&(e=e.getFirstPicked())){d=a(d);var m=b[1];b=this.runtime.files_subfolder+b[0]+(X?".ogg":".m4a");(P=this.getAudioInstance(b,k,m,0!==c,d))?(P.setPannerEnabled(!0),k=cr.rotatePtAround(e.x,
e.y,-e.layer.getAngle(),Z,aa,!0),b=cr.rotatePtAround(e.x,e.y,-e.layer.getAngle(),Z,aa,!1),P.setPan(k,b,cr.to_degrees(e.angle-e.layer.getAngle()),f,g,a(h)),P.setObject(e),P.play(0!==c,d)):this.getAudioBuffer(b,m).panWhenReady.push({obj:e,ia:f,oa:g,og:a(h),thistag:k})}};x.prototype.PlayByName=function(b,c,d,e,f){!R&&(e=a(e),b=1===b,c=this.runtime.files_subfolder+c.toLowerCase()+(X?".ogg":".m4a"),P=this.getAudioInstance(c,f,b,0!==d,e))&&(P.setPannerEnabled(!1),P.play(0!==d,e))};x.prototype.PlayAtPositionByName=
function(b,c,d,e,f,g,h,k,m,n,q){R||(e=a(e),b=1===b,c=this.runtime.files_subfolder+c.toLowerCase()+(X?".ogg":".m4a"),(P=this.getAudioInstance(c,q,b,0!==d,e))?(P.setPannerEnabled(!0),P.setPan(f,g,h,k,m,a(n)),P.play(0!==d,e)):this.getAudioBuffer(c,b).panWhenReady.push({x:f,y:g,a:h,ia:k,oa:m,og:a(n),thistag:q}))};x.prototype.PlayAtObjectByName=function(b,c,d,e,f,g,h,k,m){!R&&f&&(f=f.getFirstPicked())&&(e=a(e),b=1===b,c=this.runtime.files_subfolder+c.toLowerCase()+(X?".ogg":".m4a"),(P=this.getAudioInstance(c,
m,b,0!==d,e))?(P.setPannerEnabled(!0),m=cr.rotatePtAround(f.x,f.y,-f.layer.getAngle(),Z,aa,!0),c=cr.rotatePtAround(f.x,f.y,-f.layer.getAngle(),Z,aa,!1),P.setPan(m,c,cr.to_degrees(f.angle-f.layer.getAngle()),g,h,a(k)),P.setObject(f),P.play(0!==d,e)):this.getAudioBuffer(c,b).panWhenReady.push({obj:f,ia:g,oa:h,og:a(k),thistag:m}))};x.prototype.SetLooping=function(a,b){v(a);var c,d;c=0;for(d=N.length;c<d;c++)N[c].setLooping(0===b)};x.prototype.SetMuted=function(a,b){v(a);var c,d;c=0;for(d=N.length;c<
d;c++)N[c].setMuted(0===b)};x.prototype.SetVolume=function(b,c){v(b);var d=a(c),e,f;e=0;for(f=N.length;e<f;e++)N[e].setVolume(d)};x.prototype.Preload=function(a){if(!R){var b=a[1];a=this.runtime.files_subfolder+a[0]+(X?".ogg":".m4a");K===U?this.runtime.isDirectCanvas?AppMobi.context.loadSound(a):AppMobi.player.loadSound(a):K!==V&&this.getAudioInstance(a,"<preload>",b,!1)}};x.prototype.PreloadByName=function(a,b){if(!R){var c=1===a,d=this.runtime.files_subfolder+b.toLowerCase()+(X?".ogg":".m4a");K===
U?this.runtime.isDirectCanvas?AppMobi.context.loadSound(d):AppMobi.player.loadSound(d):K!==V&&this.getAudioInstance(d,"<preload>",c,!1)}};x.prototype.SetPlaybackRate=function(a,b){v(a);0>b&&(b=0);var c,d;c=0;for(d=N.length;c<d;c++)N[c].setPlaybackRate(b)};x.prototype.Stop=function(a){v(a);var b;a=0;for(b=N.length;a<b;a++)N[a].stop()};x.prototype.StopAll=function(){var a,b;a=0;for(b=L.length;a<b;a++)L[a].stop()};x.prototype.SetPaused=function(a,b){v(a);var c,d;c=0;for(d=N.length;c<d;c++)0===b?N[c].pause():
N[c].resume()};x.prototype.Seek=function(a,b){v(a);var c,d;c=0;for(d=N.length;c<d;c++)N[c].seek(b)};x.prototype.SetSilent=function(a){var b;2===a&&(a=R?1:0);if(0===a&&!R){a=0;for(b=L.length;a<b;a++)L[a].setSilent(!0);R=!0}else if(1===a&&R){a=0;for(b=L.length;a<b;a++)L[a].setSilent(!1);R=!1}};x.prototype.SetMasterVolume=function(b){Y=a(b);var c;b=0;for(c=L.length;b<c;b++)L[b].updateVolume()};x.prototype.AddFilterEffect=function(a,b,c,d,e,g,h){K!==C||0>b||b>=la.length||(a=a.toLowerCase(),h/=100,0>h&&
(h=0),1<h&&(h=1),z(a,new f(b,c,d,e,g,h)))};x.prototype.AddDelayEffect=function(b,c,d,e){K===C&&(b=b.toLowerCase(),e/=100,0>e&&(e=0),1<e&&(e=1),z(b,new m(c,a(d),e)))};x.prototype.AddFlangerEffect=function(a,b,c,d,e,f){K===C&&(a=a.toLowerCase(),f/=100,0>f&&(f=0),1<f&&(f=1),z(a,new p(b/1E3,c/1E3,d,e/100,f)))};x.prototype.AddPhaserEffect=function(a,b,c,d,e,f,g){K===C&&(a=a.toLowerCase(),g/=100,0>g&&(g=0),1<g&&(g=1),z(a,new q(b,c,d,e,f,g)))};x.prototype.AddConvolutionEffect=function(a,b,c,d){if(K===C){c=
0===c;var e=this.runtime.files_subfolder+b[0]+(X?".ogg":".m4a");b=this.getAudioBuffer(e,!1);a=a.toLowerCase();d/=100;0>d&&(d=0);1<d&&(d=1);b.bufferObject?d=new n(b.bufferObject,c,d,e):(d=new n(null,c,d,e),b.normalizeWhenReady=c,b.convolveWhenReady=d);z(a,d)}};x.prototype.AddGainEffect=function(b,c){K===C&&(b=b.toLowerCase(),z(b,new s(a(c))))};x.prototype.AddMuteEffect=function(a){K===C&&(a=a.toLowerCase(),z(a,new s(0)))};x.prototype.AddTremoloEffect=function(a,b,c){K===C&&(a=a.toLowerCase(),c/=100,
0>c&&(c=0),1<c&&(c=1),z(a,new r(b,c)))};x.prototype.AddRingModEffect=function(a,b,c){K===C&&(a=a.toLowerCase(),c/=100,0>c&&(c=0),1<c&&(c=1),z(a,new t(b,c)))};x.prototype.AddDistortionEffect=function(a,b,c,d,e,f){K===C&&(a=a.toLowerCase(),f/=100,0>f&&(f=0),1<f&&(f=1),z(a,new w(b,c,d,e,f)))};x.prototype.AddCompressorEffect=function(a,b,c,d,e,f){K===C&&(a=a.toLowerCase(),z(a,new A(b,c,d,e/1E3,f/1E3)))};x.prototype.AddAnalyserEffect=function(a,b,c){K===C&&(a=a.toLowerCase(),z(a,new D(b,c)))};x.prototype.RemoveEffects=
function(a){if(K===C){a=a.toLowerCase();var b,c,d;if(M.hasOwnProperty(a)&&(d=M[a],d.length)){b=0;for(c=d.length;b<c;b++)d[b].remove();d.length=0;u(a)}}};x.prototype.SetEffectParameter=function(a,b,c,d,e,f){K===C&&(a=a.toLowerCase(),b=Math.floor(b),M.hasOwnProperty(a)&&(a=M[a],0>b||b>=a.length||a[b].setParam(c,d,e,f)))};x.prototype.SetListenerObject=function(a){a&&K===C&&(a=a.getFirstPicked())&&(this.listenerTracker.setObject(a),Z=a.x,aa=a.y)};x.prototype.SetListenerZ=function(a){this.listenerZ=a};
H.acts=new x;F.prototype.Duration=function(a,b){v(b);N.length?a.set_float(N[0].getDuration()):a.set_float(0)};F.prototype.PlaybackTime=function(a,b){v(b);N.length?a.set_float(N[0].getPlaybackTime()):a.set_float(0)};F.prototype.Volume=function(a,c){v(c);if(N.length){var d=N[0].getVolume();a.set_float(b(d))}else a.set_float(0)};F.prototype.MasterVolume=function(a){a.set_float(Y)};F.prototype.EffectCount=function(a,b){b=b.toLowerCase();var c=null;M.hasOwnProperty(b)&&(c=M[b]);a.set_int(c?c.length:0)};
F.prototype.AnalyserFreqBinCount=function(a,b,c){b=b.toLowerCase();c=Math.floor(c);b=G(b,c);a.set_int(b?b.node.frequencyBinCount:0)};F.prototype.AnalyserFreqBinAt=function(a,b,c,d){b=b.toLowerCase();c=Math.floor(c);d=Math.floor(d);(b=G(b,c))?0>d||d>=b.node.frequencyBinCount?a.set_float(0):a.set_float(b.freqBins[d]):a.set_float(0)};F.prototype.AnalyserPeakLevel=function(a,b,c){b=b.toLowerCase();c=Math.floor(c);(b=G(b,c))?a.set_float(b.peak):a.set_float(0)};F.prototype.AnalyserRMSLevel=function(a,b,
c){b=b.toLowerCase();c=Math.floor(c);(b=G(b,c))?a.set_float(b.rms):a.set_float(0)};H.exps=new F})();cr.plugins_.Browser=function(a){this.runtime=a};
(function(){function a(){}function b(){}function c(){"undefined"!==typeof jQuery&&g.setSize(jQuery(window).width(),jQuery(window).height())}function d(){}var e=cr.plugins_.Browser.prototype;e.Type=function(a){this.plugin=a;this.runtime=a.runtime};e.Type.prototype.onCreate=function(){};e.Instance=function(a){this.type=a;this.runtime=a.runtime};e.Instance.prototype.onCreate=function(){var a=this;window.addEventListener("resize",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnResize,
a)});"undefined"!==typeof navigator.onLine&&(window.addEventListener("online",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnOnline,a)}),window.addEventListener("offline",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnOffline,a)}));"undefined"!==typeof window.applicationCache&&(window.applicationCache.addEventListener("updateready",function(){a.runtime.loadingprogress=1;a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnUpdateReady,a)}),window.applicationCache.addEventListener("progress",
function(b){a.runtime.loadingprogress=b.loaded/b.total}));this.runtime.isDirectCanvas||(document.addEventListener("appMobi.device.update.available",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnUpdateReady,a)}),document.addEventListener("backbutton",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnBackButton,a)}),document.addEventListener("menubutton",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnMenuButton,a)}),document.addEventListener("searchbutton",
function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnSearchButton,a)}),document.addEventListener("tizenhwkey",function(b){var c;switch(b.keyName){case "back":c=a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnBackButton,a);!c&&window.tizen&&window.tizen.application.getCurrentApplication().exit();break;case "menu":(c=a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnMenuButton,a))||b.preventDefault()}}));this.runtime.addSuspendCallback(function(b){b?a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnPageHidden,
a):a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnPageVisible,a)});this.is_arcade="undefined"!==typeof window.is_scirra_arcade};a.prototype.CookiesEnabled=function(){return navigator?navigator.cookieEnabled:!1};a.prototype.IsOnline=function(){return navigator?navigator.onLine:!1};a.prototype.HasJava=function(){return navigator?navigator.javaEnabled():!1};a.prototype.OnOnline=function(){return!0};a.prototype.OnOffline=function(){return!0};a.prototype.IsDownloadingUpdate=function(){return"undefined"===
typeof window.applicationCache?!1:window.applicationCache.status===window.applicationCache.DOWNLOADING};a.prototype.OnUpdateReady=function(){return!0};a.prototype.PageVisible=function(){return!this.runtime.isSuspended};a.prototype.OnPageVisible=function(){return!0};a.prototype.OnPageHidden=function(){return!0};a.prototype.OnResize=function(){return!0};a.prototype.IsFullscreen=function(){return!!(document.mozFullScreen||document.webkitIsFullScreen||document.fullScreen||this.runtime.isNodeFullscreen)};
a.prototype.OnBackButton=function(){return!0};a.prototype.OnMenuButton=function(){return!0};a.prototype.OnSearchButton=function(){return!0};a.prototype.IsMetered=function(){var a=navigator.connection||navigator.mozConnection||navigator.webkitConnection;return a?a.metered:!1};a.prototype.IsCharging=function(){var a=navigator.battery||navigator.mozBattery||navigator.webkitBattery;return a?a.charging:!0};a.prototype.IsPortraitLandscape=function(a){return(window.innerWidth<=window.innerHeight?0:1)===
a};e.cnds=new a;b.prototype.Alert=function(a){this.runtime.isDomFree||alert(a.toString())};b.prototype.Close=function(){this.runtime.isCocoonJs?CocoonJS.App.forceToFinish():window.tizen?window.tizen.application.getCurrentApplication().exit():navigator.app&&navigator.app.exitApp?navigator.app.exitApp():navigator.device&&navigator.device.exitApp?navigator.device.exitApp():this.is_arcade||this.runtime.isDomFree||window.close()};b.prototype.Focus=function(){this.runtime.isNodeWebkit?window.nwgui.Window.get().focus():
this.is_arcade||this.runtime.isDomFree||window.focus()};b.prototype.Blur=function(){this.runtime.isNodeWebkit?window.nwgui.Window.get().blur():this.is_arcade||this.runtime.isDomFree||window.blur()};b.prototype.GoBack=function(){this.is_arcade||this.runtime.isDomFree||!window.back||window.back()};b.prototype.GoForward=function(){this.is_arcade||this.runtime.isDomFree||!window.forward||window.forward()};b.prototype.GoHome=function(){this.is_arcade||this.runtime.isDomFree||!window.home||window.home()};
b.prototype.GoToURL=function(a){this.runtime.isCocoonJs?CocoonJS.App.openURL(a):this.is_arcade||this.runtime.isDomFree||(window.location=a)};b.prototype.GoToURLWindow=function(a,b){this.runtime.isCocoonJs?CocoonJS.App.openURL(a):this.is_arcade||this.runtime.isDomFree||window.open(a,b)};b.prototype.Reload=function(){this.is_arcade||this.runtime.isDomFree||window.location.reload()};var h=!0,g=null;b.prototype.RequestFullScreen=function(a){this.runtime.isDomFree?cr.logexport("[Construct 2] Requesting fullscreen is not supported on this platform - the request has been ignored"):
(2<=a&&(a+=1),6===a&&(a=2),this.runtime.isNodeWebkit?this.runtime.isNodeFullscreen||(window.nwgui.Window.get().enterFullscreen(),this.runtime.isNodeFullscreen=!0):document.mozFullScreen||document.webkitIsFullScreen||document.msFullscreenElement||document.fullScreen||(this.runtime.fullscreen_scaling=2<=a?a:0,a=this.runtime.canvasdiv||this.runtime.canvas,h&&(h=!1,g=this.runtime,a.addEventListener("mozfullscreenerror",c),a.addEventListener("webkitfullscreenerror",c),a.addEventListener("msfullscreenerror",
c),a.addEventListener("fullscreenerror",c)),cr.is_undefined(a.requestFullscreen)?cr.is_undefined(a.webkitRequestFullScreen)?cr.is_undefined(a.mozRequestFullScreen)?cr.is_undefined(a.msRequestFullscreen)||a.msRequestFullscreen():a.mozRequestFullScreen():"undefined"!==typeof Element&&"undefined"!==typeof Element.ALLOW_KEYBOARD_INPUT?a.webkitRequestFullScreen(Element.ALLOW_KEYBOARD_INPUT):a.webkitRequestFullScreen():a.requestFullscreen()))};b.prototype.CancelFullScreen=function(){this.runtime.isDomFree?
cr.logexport("[Construct 2] Exiting fullscreen is not supported on this platform - the request has been ignored"):this.runtime.isNodeWebkit?this.runtime.isNodeFullscreen&&(window.nwgui.Window.get().leaveFullscreen(),this.runtime.isNodeFullscreen=!1):cr.is_undefined(document.exitFullscreen)?cr.is_undefined(document.webkitCancelFullScreen)?cr.is_undefined(document.mozCancelFullScreen)?cr.is_undefined(document.msExitFullscreen)||document.msExitFullscreen():document.mozCancelFullScreen():document.webkitCancelFullScreen():
document.exitFullscreen()};b.prototype.Vibrate=function(a){try{var b=a.split(","),c,d;c=0;for(d=b.length;c<d;c++)b[c]=parseInt(b[c],10);navigator.vibrate?navigator.vibrate(b):navigator.mozVibrate?navigator.mozVibrate(b):navigator.webkitVibrate?navigator.webkitVibrate(b):navigator.msVibrate&&navigator.msVibrate(b)}catch(e){}};b.prototype.InvokeDownload=function(a,b){var c=document.createElement("a");if("undefined"===typeof c.download)window.open(a);else{var d=document.getElementsByTagName("body")[0];
c.textContent=b;c.href=a;c.download=b;d.appendChild(c);var e=document.createEvent("MouseEvent");e.initMouseEvent("click",!0,!0,window,0,0,0,0,0,!1,!1,!1,!1,0,null);c.dispatchEvent(e);d.removeChild(c)}};b.prototype.InvokeDownloadString=function(a,b,c){var d="data:"+b+","+encodeURIComponent(a);a=document.createElement("a");"undefined"===typeof a.download?window.open(d):(b=document.getElementsByTagName("body")[0],a.textContent=c,a.href=d,a.download=c,b.appendChild(a),c=document.createEvent("MouseEvent"),
c.initMouseEvent("click",!0,!0,window,0,0,0,0,0,!1,!1,!1,!1,0,null),a.dispatchEvent(c),b.removeChild(a))};b.prototype.ConsoleLog=function(a,b){"undefined"!==typeof console&&(0===a&&console.log&&console.log(b.toString()),1===a&&console.warn&&console.warn(b.toString()),2===a&&console.error&&console.error(b.toString()))};b.prototype.ConsoleGroup=function(a){console&&console.group&&console.group(a)};b.prototype.ConsoleGroupEnd=function(){console&&console.groupEnd&&console.groupEnd()};b.prototype.ExecJs=
function(a){eval&&eval(a)};var l="portrait landscape portrait-primary portrait-secondary landscape-primary landscape-secondary".split(" ");b.prototype.LockOrientation=function(a){a=Math.floor(a);0>a||a>=l.length||(this.runtime.autoLockOrientation=!1,a=l[a],screen.lockOrientation?screen.lockOrientation(a):screen.webkitLockOrientation?screen.webkitLockOrientation(a):screen.mozLockOrientation?screen.mozLockOrientation(a):screen.msLockOrientation&&screen.msLockOrientation(a))};b.prototype.UnlockOrientation=
function(){this.runtime.autoLockOrientation=!1;screen.unlockOrientation?screen.unlockOrientation():screen.webkitUnlockOrientation?screen.webkitUnlockOrientation():screen.mozUnlockOrientation?screen.mozUnlockOrientation():screen.msUnlockOrientation&&screen.msUnlockOrientation()};e.acts=new b;d.prototype.URL=function(a){a.set_string(this.runtime.isDomFree?"":window.location.toString())};d.prototype.Protocol=function(a){a.set_string(this.runtime.isDomFree?"":window.location.protocol)};d.prototype.Domain=
function(a){a.set_string(this.runtime.isDomFree?"":window.location.hostname)};d.prototype.PathName=function(a){a.set_string(this.runtime.isDomFree?"":window.location.pathname)};d.prototype.Hash=function(a){a.set_string(this.runtime.isDomFree?"":window.location.hash)};d.prototype.Referrer=function(a){a.set_string(this.runtime.isDomFree?"":document.referrer)};d.prototype.Title=function(a){a.set_string(this.runtime.isDomFree?"":document.title)};d.prototype.Name=function(a){a.set_string(this.runtime.isDomFree?
"":navigator.appName)};d.prototype.Version=function(a){a.set_string(this.runtime.isDomFree?"":navigator.appVersion)};d.prototype.Language=function(a){navigator&&navigator.language?a.set_string(navigator.language):a.set_string("")};d.prototype.Platform=function(a){a.set_string(this.runtime.isDomFree?"":navigator.platform)};d.prototype.Product=function(a){navigator&&navigator.product?a.set_string(navigator.product):a.set_string("")};d.prototype.Vendor=function(a){navigator&&navigator.vendor?a.set_string(navigator.vendor):
a.set_string("")};d.prototype.UserAgent=function(a){a.set_string(this.runtime.isDomFree?"":navigator.userAgent)};d.prototype.QueryString=function(a){a.set_string(this.runtime.isDomFree?"":window.location.search)};d.prototype.QueryParam=function(a,b){if(this.runtime.isDomFree)a.set_string("");else{var c=RegExp("[?&]"+b+"=([^&]*)").exec(window.location.search);c?a.set_string(decodeURIComponent(c[1].replace(/\+/g," "))):a.set_string("")}};d.prototype.Bandwidth=function(a){var b=navigator.connection||
navigator.mozConnection||navigator.webkitConnection;b?a.set_float(b.bandwidth):a.set_float(Number.POSITIVE_INFINITY)};d.prototype.BatteryLevel=function(a){var b=navigator.battery||navigator.mozBattery||navigator.webkitBattery;b?a.set_float(b.level):a.set_float(1)};d.prototype.BatteryTimeLeft=function(a){var b=navigator.battery||navigator.mozBattery||navigator.webkitBattery;b?a.set_float(b.dischargingTime):a.set_float(Number.POSITIVE_INFINITY)};d.prototype.ExecJS=function(a,b){if(eval){var c=eval(b);
"number"===typeof c?a.set_any(c):"string"===typeof c?a.set_any(c):"boolean"===typeof c?a.set_any(c?1:0):a.set_any(0)}else a.set_any(0)};d.prototype.ScreenWidth=function(a){a.set_int(screen.width)};d.prototype.ScreenHeight=function(a){a.set_int(screen.height)};d.prototype.DevicePixelRatio=function(a){a.set_float(this.runtime.devicePixelRatio)};e.exps=new d})();cr.plugins_.CJSAds=function(a){this.runtime=a};
(function(){function a(){}function b(){}function c(){}var d="",e=[],h=0,g=0,l=!1,k=!1,f=!1,m=cr.plugins_.CJSAds.prototype;m.Type=function(a){this.plugin=a;this.runtime=a.runtime};m.Type.prototype.onCreate=function(){};m.Instance=function(a){this.type=a;this.runtime=a.runtime};m.Instance.prototype.onCreate=function(){this.isShowingFullscreen=this.isShowingBanner=!1;this.triggerProduct="";this.socialService=null;this.socialServiceAvailable=!1;this.storeServiceAvailable=this.runtime.isCocoonJs&&"undefined"!==
typeof CocoonJS.Store.nativeExtensionObjectAvailable;this.storeManaged=1!==this.properties[0];this.storeSandboxed=0!==this.properties[1];this.onConsumePurchaseCompleted=this.onConsumePurchaseFailedTransactionId="";var a=this;this.runtime.isCocoonJs&&(CocoonJS.App.onTextDialogFinished.addEventListener(function(b){d=b;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnKeyboardOK,a)}),CocoonJS.App.onTextDialogCancelled.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnKeyboardCancelled,
a)}),CocoonJS.Ad.onBannerShown.addEventListener(function(){a.isShowingBanner=!0;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnBannerShown,a)}),CocoonJS.Ad.onBannerReady.addEventListener(function(){k=!0;l||(CocoonJS.Ad.setBannerLayout(g),CocoonJS.Ad.showBanner())}),CocoonJS.Ad.onFullScreenShown.addEventListener(function(){a.isShowingFullscreen=!0;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnFullscreenShown,a)}),CocoonJS.Ad.onFullScreenHidden.addEventListener(function(){a.isShowingFullscreen=
!1;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnFullscreenHidden,a)}),CocoonJS.Ad.onFullScreenReady.addEventListener(function(){f=!0;preloadFullScreen||CocoonJS.Ad.showFullScreen()}),this.storeServiceAvailable&&(CocoonJS.Store.onProductPurchaseCompleted.addEventListener(function(b){a.triggerProduct=b.productId;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnPurchaseComplete,a);CocoonJS.Store.addPurchase(b);CocoonJS.Store.consumePurchase(b.transactionId,b.productId);CocoonJS.Store.finishPurchase(b.transactionId)}),
CocoonJS.Store.onConsumePurchaseFailed.addEventListener(function(b,c){this.onConsumePurchaseFailedTransactionId=b;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onConsumePurchaseFailed,a)}),CocoonJS.Store.onConsumePurchaseCompleted.addEventListener(function(b){this.onConsumePurchaseCompleted=b;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onConsumePurchaseCompleted,a)}),CocoonJS.Store.onProductPurchaseFailed.addEventListener(function(b,c){a.triggerProduct=b;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnPurchaseFail,
a)}),CocoonJS.Store.onProductPurchaseStarted.addEventListener(function(b){a.triggerProduct=b.productId;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnPurchaseStart,a)}),CocoonJS.Store.onProductsFetchStarted.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onProductsFetchStarted,a)}),CocoonJS.Store.onProductsFetchFailed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onProductsFetchFailed,a)}),CocoonJS.Store.onProductsFetchCompleted.addEventListener(function(b){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onProductsFetchCompleted,
a)}),CocoonJS.Store.requestInitialization({managed:this.storeManaged,sandbox:this.storeSandboxed}),CocoonJS.Store.start()),this.socialService=CocoonJS.SocialGaming.GameCenter,this.socialServiceAvailable=!!this.socialService.nativeExtensionObjectAvailable,this.socialService.onRequestLoginSucceed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLoginSuccess,a)}),this.socialService.onRequestLoginFailed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLoginFail,
a)}),this.socialService.onLogout.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLogout,a)}),this.socialService.onRequestUserScoreSucceed.addEventListener(function(b){h=b.score||0;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCScoreReceived,a)}),this.socialService.onRequestUserScoreFailed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCScoreUnavailable,a)}),this.socialService.onSubmitUserScoreSucceed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCScoreSubmitSuccess,
a)}),this.socialService.onSubmitUserScoreFailed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCScoreSubmitFail,a)}),this.socialService.onLeaderboardViewSucceed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLeaderboardOpen,a)}),this.socialService.onLeaderboardViewClosed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLeaderboardClose,a)}))};a.prototype.IsShowingBanner=function(){return this.isShowingBanner};
a.prototype.IsCocoonJS=function(){return this.runtime.isCocoonJs};a.prototype.OnBannerShown=function(){return!0};a.prototype.OnFullscreenShown=function(){return!0};a.prototype.OnFullscreenHidden=function(){return!0};a.prototype.IsShowingFullscreen=function(){return this.isShowingFullscreen};a.prototype.IsStoreAvailable=function(){return this.runtime.isCocoonJs?this.storeServiceAvailable&&CocoonJS.Store.canPurchase():!1};a.prototype.OnPurchaseStart=function(a){return this.triggerProduct===a};a.prototype.OnPurchaseComplete=
function(a){return this.triggerProduct===a};a.prototype.OnPurchaseFail=function(a){return this.triggerProduct===a};a.prototype.onProductsFetchStarted=function(){return!0};a.prototype.onConsumePurchaseFailed=function(){return!0};a.prototype.onProductsFetchCompleted=function(){return!0};a.prototype.onProductsFetchFailed=function(){return!0};a.prototype.IsProductPurchased=function(a){return this.runtime.isCocoonJs?CocoonJS.Store.isProductPurchased(a):!1};a.prototype.OnKeyboardCancelled=function(){return!0};
a.prototype.OnKeyboardOK=function(){return!0};a.prototype.IsGCAvailable=function(){return this.socialServiceAvailable};a.prototype.IsGCLoggedIn=function(){return this.socialServiceAvailable?this.socialService.isLoggedIn():!1};a.prototype.OnGCLoginSuccess=function(){return!0};a.prototype.OnGCLoginFail=function(){return!0};a.prototype.OnGCLogout=function(){return!0};a.prototype.OnGCScoreReceived=function(){return!0};a.prototype.OnGCScoreUnavailable=function(){return!0};a.prototype.OnGCScoreSubmitSuccess=
function(){return!0};a.prototype.OnGCScoreSubmitFail=function(){return!0};a.prototype.OnGCLeaderboardOpen=function(){return!0};a.prototype.OnGCLeaderboardClose=function(){return!0};m.cnds=new a;b.prototype.ShowBanner=function(a){this.runtime.isCocoonJs&&(g=0===a?CocoonJS.Ad.BannerLayout.TOP_CENTER:CocoonJS.Ad.BannerLayout.BOTTOM_CENTER,l=!1,k?(CocoonJS.Ad.setBannerLayout(g),CocoonJS.Ad.showBanner()):CocoonJS.Ad.preloadBanner())};b.prototype.ShowFullscreen=function(){this.runtime.isCocoonJs&&(f?CocoonJS.Ad.showFullScreen():
CocoonJS.Ad.preloadFullScreen())};b.prototype.HideBanner=function(){this.runtime.isCocoonJs&&(CocoonJS.Ad.hideBanner(),this.isShowingBanner=!1)};b.prototype.PreloadBanner=function(){this.runtime.isCocoonJs&&(l=!0,CocoonJS.Ad.preloadBanner())};b.prototype.PreloadFullscreen=function(){this.runtime.isCocoonJs&&CocoonJS.Ad.preloadFullScreen()};b.prototype.RefreshBanner=function(){this.runtime.isCocoonJs&&CocoonJS.Ad.refreshBanner()};b.prototype.RefreshFullscreen=function(){this.runtime.isCocoonJs&&CocoonJS.Ad.refreshFullScreen()};
b.prototype.Purchase=function(a){this.runtime.isCocoonJs&&CocoonJS.Store.purchaseProduct(a)};b.prototype.fetchProductsFromStore=function(a){this.runtime.isCocoonJs&&CocoonJS.Store.fetchProductsFromStore(a.split(","))};b.prototype.restorePurchases=function(){if(this.runtime.isCocoonJs)return CocoonJS.Store.restorePurchases()};b.prototype.PurchasePreview=function(a){this.runtime.isCocoonJs&&CocoonJS.Store.purchaseProductModalWithPreview(a)};b.prototype.RestorePurchases=function(){this.runtime.isCocoonJs&&
CocoonJS.Store.restorePurchases()};b.prototype.PromptKeyboard=function(a,b,c,d,e,f){this.runtime.isCocoonJs&&CocoonJS.App.showTextDialog(a,b,c,["text","num","phone","email","url"][d],e,f)};b.prototype.UpdateProductsList=function(){this.runtime.isCocoonJs&&CocoonJS.Store.canPurchase()&&(e=CocoonJS.Store.getProducts())};b.prototype.GCLogin=function(){this.socialServiceAvailable&&!this.socialService.isLoggedIn()&&this.socialService.requestLogin()};b.prototype.GCLogout=function(){this.socialServiceAvailable&&
this.socialService.isLoggedIn()&&this.socialService.requestLogout()};b.prototype.GCSubmitScore=function(a,b){this.socialServiceAvailable&&this.socialService.isLoggedIn()&&this.socialService.submitUserScore(a,b)};b.prototype.GCRequestScore=function(a){this.socialServiceAvailable&&this.socialService.isLoggedIn()&&this.socialService.requestUserScore(a)};b.prototype.GCOpenLeaderboard=function(a){this.socialServiceAvailable&&this.socialService.isLoggedIn()&&this.socialService.showLeaderboardView(a)};m.acts=
new b;c.prototype.InputText=function(a){a.set_string(d)};c.prototype.ProductCount=function(a){a.set_int(e.length)};c.prototype.ProductDescription=function(a,b){b=Math.floor(b);0>b||b>=e.length?a.set_string(""):a.set_string(e[b].description)};c.prototype.ProductLocalizedPrice=function(a,b){b=Math.floor(b);0>b||b>=e.length?a.set_string(""):a.set_string(e[b].localizedPrice)};c.prototype.ProductPrice=function(a,b){b=Math.floor(b);0>b||b>=e.length?a.set_string(""):a.set_string(e[b].price)};c.prototype.ProductAlias=
function(a,b){b=Math.floor(b);0>b||b>=e.length?a.set_string(""):a.set_string(e[b].productAlias)};c.prototype.ProductID=function(a,b){b=Math.floor(b);0>b||b>=e.length?a.set_string(""):a.set_string(e[b].productId)};c.prototype.ProductTitle=function(a,b){b=Math.floor(b);0>b||b>=e.length?a.set_string(""):a.set_string(e[b].title)};c.prototype.GameCenterScore=function(a){a.set_float(h)};m.exps=new c})();cr.plugins_.Sprite=function(a){this.runtime=a};
(function(){function a(){if(0===this.datauri.length){var a=document.createElement("canvas");a.width=this.width;a.height=this.height;var b=a.getContext("2d");this.spritesheeted?b.drawImage(this.texture_img,this.offx,this.offy,this.width,this.height,0,0,this.width,this.height):b.drawImage(this.texture_img,0,0,this.width,this.height);this.datauri=a.toDataURL("image/png")}return this.datauri}function b(){}function c(a){a[0]=0;a[1]=0;a[2]=0;s.push(a)}function d(a,b){return a<b?""+a+","+b:""+b+","+a}function e(a,
b,c,e){b=b.uid;c=c.uid;var f=d(b,c);if(a.hasOwnProperty(f))a[f][2]=e;else{var g;g=s.length?s.pop():[0,0,0];g[0]=b;g[1]=c;g[2]=e;a[f]=g}}function h(a,b,e){b=d(b.uid,e.uid);a.hasOwnProperty(b)&&(c(a[b]),delete a[b])}function g(a,b,c){b=d(b.uid,c.uid);if(a.hasOwnProperty(b))return r=a[b][2],!0;r=-2;return!1}function l(a,b,c){if(!a)return!1;var d=0!==b||0!==c,e,f,g=!1,h,k=this.runtime.getCurrentCondition(),m=k.type,k=k.inverted,q=a.getCurrentSol();h=this.runtime.getCurrentEventStack().current_event.orblock;
q.select_all?(this.update_bbox(),this.runtime.getCollisionCandidates(this.layer,a,this.bbox,t),q=t):q=h?q.else_instances:q.instances;w=a;D=m!==a&&!k;d&&(e=this.x,f=this.y,this.x+=b,this.y+=c,this.set_bbox_changed());b=0;for(c=q.length;b<c;b++)if(h=q[b],this.runtime.testOverlap(this,h)){g=!0;if(k)break;m!==a&&A.add(h)}d&&(this.x=e,this.y=f,this.set_bbox_changed());t.length=0;return g}function k(){}function f(){}var m=cr.plugins_.Sprite.prototype;m.Type=function(a){this.plugin=a;this.runtime=a.runtime};
var n=m.Type.prototype;n.onCreate=function(){if(!this.is_family){var b,c,d,e,f,g,h,k,m;this.all_frames=[];this.has_loaded_textures=!1;b=0;for(c=this.animations.length;b<c;b++){f=this.animations[b];h={};h.name=f[0];h.speed=f[1];h.loop=f[2];h.repeatcount=f[3];h.repeatto=f[4];h.pingpong=f[5];h.sid=f[6];h.frames=[];d=0;for(e=f[7].length;d<e;d++)g=f[7][d],k={},k.texture_file=g[0],k.texture_filesize=g[1],k.offx=g[2],k.offy=g[3],k.width=g[4],k.height=g[5],k.duration=g[6],k.hotspotX=g[7],k.hotspotY=g[8],
k.image_points=g[9],k.poly_pts=g[10],k.pixelformat=g[11],k.spritesheeted=0!==k.width,k.datauri="",k.getDataUri=a,m={left:0,top:0,right:1,bottom:1},k.sheetTex=m,k.webGL_texture=null,(m=this.runtime.findWaitingTexture(g[0]))?k.texture_img=m:(k.texture_img=new Image,k.texture_img.idtkLoadDisposed=!0,k.texture_img.src=g[0],k.texture_img.cr_src=g[0],k.texture_img.cr_filesize=g[1],k.texture_img.c2webGL_texture=null,this.runtime.wait_for_textures.push(k.texture_img)),cr.seal(k),h.frames.push(k),this.all_frames.push(k);
cr.seal(h);this.animations[b]=h}}};n.updateAllCurrentTexture=function(){var a,b,c;a=0;for(b=this.instances.length;a<b;a++)c=this.instances[a],c.curWebGLTexture=c.curFrame.webGL_texture};n.onLostWebGLContext=function(){if(!this.is_family){var a,b,c;a=0;for(b=this.all_frames.length;a<b;++a)c=this.all_frames[a],c.texture_img.c2webGL_texture=null,c.webGL_texture=null}};n.onRestoreWebGLContext=function(){if(!this.is_family&&this.instances.length){var a,b,c;a=0;for(b=this.all_frames.length;a<b;++a)c=this.all_frames[a],
c.webGL_texture=this.runtime.glwrap.loadTexture(c.texture_img,!1,this.runtime.linearSampling,c.pixelformat);this.updateAllCurrentTexture()}};n.loadTextures=function(){if(!this.is_family&&!this.has_loaded_textures&&this.runtime.glwrap){var a,b,c;a=0;for(b=this.all_frames.length;a<b;++a)c=this.all_frames[a],c.webGL_texture=this.runtime.glwrap.loadTexture(c.texture_img,!1,this.runtime.linearSampling,c.pixelformat);this.has_loaded_textures=!0}};n.unloadTextures=function(){if(!this.is_family&&!this.instances.length&&
this.has_loaded_textures){var a,b,c;a=0;for(b=this.all_frames.length;a<b;++a)c=this.all_frames[a],this.runtime.glwrap.deleteTexture(c.webGL_texture);this.has_loaded_textures=!1}};var p=[];n.preloadCanvas2D=function(a){var b,c,d;b=p.length=0;for(c=this.all_frames.length;b<c;++b)d=this.all_frames[b].texture_img,-1===p.indexOf(d)&&(a.drawImage(d,0,0),p.push(d))};m.Instance=function(a){this.type=a;this.runtime=a.runtime;a=this.type.animations[0].frames[0].poly_pts;this.recycled?this.collision_poly.set_pts(a):
this.collision_poly=new cr.CollisionPoly(a)};var q=m.Instance.prototype;q.onCreate=function(){this.visible=0===this.properties[0];this.inAnimTrigger=this.isTicking=!1;this.collisionsEnabled=0!==this.properties[3];1===this.type.animations.length&&1===this.type.animations[0].frames.length||0===this.type.animations[0].speed||(this.runtime.tickMe(this),this.isTicking=!0);this.cur_animation=this.getAnimationByName(this.properties[1])||this.type.animations[0];this.cur_frame=this.properties[2];0>this.cur_frame&&
(this.cur_frame=0);this.cur_frame>=this.cur_animation.frames.length&&(this.cur_frame=this.cur_animation.frames.length-1);var a=this.cur_animation.frames[this.cur_frame];this.collision_poly.set_pts(a.poly_pts);this.hotspotX=a.hotspotX;this.hotspotY=a.hotspotY;this.cur_anim_speed=this.cur_animation.speed;this.recycled?this.animTimer.reset():this.animTimer=new cr.KahanAdder;this.frameStart=this.getNowTime();this.animPlaying=!0;this.animRepeats=0;this.animForwards=!0;this.changeAnimName=this.animTriggerName=
"";this.changeAnimFrom=0;this.changeAnimFrame=-1;this.type.loadTextures();var b,c,d,e,f,g,h,a=0;for(b=this.type.animations.length;a<b;a++)for(e=this.type.animations[a],c=0,d=e.frames.length;c<d;c++)f=e.frames[c],0===f.width&&(f.width=f.texture_img.width,f.height=f.texture_img.height),f.spritesheeted&&(h=f.texture_img,g=f.sheetTex,g.left=f.offx/h.width,g.top=f.offy/h.height,g.right=(f.offx+f.width)/h.width,g.bottom=(f.offy+f.height)/h.height,0===f.offx&&0===f.offy&&f.width===h.width&&f.height===h.height&&
(f.spritesheeted=!1));this.curFrame=this.cur_animation.frames[this.cur_frame];this.curWebGLTexture=this.curFrame.webGL_texture};q.saveToJSON=function(){var a={a:this.cur_animation.sid,f:this.cur_frame,cas:this.cur_anim_speed,fs:this.frameStart,ar:this.animRepeats,at:this.animTimer.sum};this.animPlaying||(a.ap=this.animPlaying);this.animForwards||(a.af=this.animForwards);return a};q.loadFromJSON=function(a){var b=this.getAnimationBySid(a.a);b&&(this.cur_animation=b);this.cur_frame=a.f;0>this.cur_frame&&
(this.cur_frame=0);this.cur_frame>=this.cur_animation.frames.length&&(this.cur_frame=this.cur_animation.frames.length-1);this.cur_anim_speed=a.cas;this.frameStart=a.fs;this.animRepeats=a.ar;this.animTimer.reset();this.animTimer.sum=a.at;this.animPlaying=a.hasOwnProperty("ap")?a.ap:!0;this.animForwards=a.hasOwnProperty("af")?a.af:!0;this.curFrame=this.cur_animation.frames[this.cur_frame];this.curWebGLTexture=this.curFrame.webGL_texture;this.collision_poly.set_pts(this.curFrame.poly_pts);this.hotspotX=
this.curFrame.hotspotX;this.hotspotY=this.curFrame.hotspotY};q.animationFinish=function(a){this.cur_frame=a?0:this.cur_animation.frames.length-1;this.animPlaying=!1;this.animTriggerName=this.cur_animation.name;this.inAnimTrigger=!0;this.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,this);this.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnAnimFinished,this);this.inAnimTrigger=!1;this.animRepeats=0};q.getNowTime=function(){return this.animTimer.sum};q.tick=function(){this.animTimer.add(this.runtime.getDt(this));
this.changeAnimName.length&&this.doChangeAnim();0<=this.changeAnimFrame&&this.doChangeAnimFrame();var a=this.getNowTime(),b=this.cur_animation,c=b.frames[this.cur_frame],d=c.duration/this.cur_anim_speed;this.animPlaying&&a>=this.frameStart+d&&(this.animForwards?this.cur_frame++:this.cur_frame--,this.frameStart+=d,this.cur_frame>=b.frames.length&&(b.pingpong?(this.animForwards=!1,this.cur_frame=b.frames.length-2):b.loop?this.cur_frame=b.repeatto:(this.animRepeats++,this.animRepeats>=b.repeatcount?
this.animationFinish(!1):this.cur_frame=b.repeatto)),0>this.cur_frame&&(b.pingpong?(this.cur_frame=1,this.animForwards=!0,b.loop||(this.animRepeats++,this.animRepeats>=b.repeatcount&&this.animationFinish(!0))):b.loop?this.cur_frame=b.repeatto:(this.animRepeats++,this.animRepeats>=b.repeatcount?this.animationFinish(!0):this.cur_frame=b.repeatto)),0>this.cur_frame?this.cur_frame=0:this.cur_frame>=b.frames.length&&(this.cur_frame=b.frames.length-1),a>this.frameStart+b.frames[this.cur_frame].duration/
this.cur_anim_speed&&(this.frameStart=a),a=b.frames[this.cur_frame],this.OnFrameChanged(c,a),this.runtime.redraw=!0)};q.getAnimationByName=function(a){var b,c,d;b=0;for(c=this.type.animations.length;b<c;b++)if(d=this.type.animations[b],cr.equals_nocase(d.name,a))return d;return null};q.getAnimationBySid=function(a){var b,c,d;b=0;for(c=this.type.animations.length;b<c;b++)if(d=this.type.animations[b],d.sid===a)return d;return null};q.doChangeAnim=function(){var a=this.cur_animation.frames[this.cur_frame],
b=this.getAnimationByName(this.changeAnimName);this.changeAnimName="";!b||cr.equals_nocase(b.name,this.cur_animation.name)&&this.animPlaying||(this.cur_animation=b,this.cur_anim_speed=b.speed,0>this.cur_frame&&(this.cur_frame=0),this.cur_frame>=this.cur_animation.frames.length&&(this.cur_frame=this.cur_animation.frames.length-1),1===this.changeAnimFrom&&(this.cur_frame=0),this.animPlaying=!0,this.frameStart=this.getNowTime(),this.animForwards=!0,this.OnFrameChanged(a,this.cur_animation.frames[this.cur_frame]),
this.runtime.redraw=!0)};q.doChangeAnimFrame=function(){var a=this.cur_animation.frames[this.cur_frame],b=this.cur_frame;this.cur_frame=cr.floor(this.changeAnimFrame);0>this.cur_frame&&(this.cur_frame=0);this.cur_frame>=this.cur_animation.frames.length&&(this.cur_frame=this.cur_animation.frames.length-1);b!==this.cur_frame&&(this.OnFrameChanged(a,this.cur_animation.frames[this.cur_frame]),this.frameStart=this.getNowTime(),this.runtime.redraw=!0);this.changeAnimFrame=-1};q.OnFrameChanged=function(a,
b){var c=a.width,d=a.height,e=b.width,f=b.height;c!=e&&(this.width*=e/c);d!=f&&(this.height*=f/d);this.hotspotX=b.hotspotX;this.hotspotY=b.hotspotY;this.collision_poly.set_pts(b.poly_pts);this.set_bbox_changed();this.curFrame=b;this.curWebGLTexture=b.webGL_texture;c=0;for(d=this.behavior_insts.length;c<d;c++)if(e=this.behavior_insts[c],e.onSpriteFrameChanged)e.onSpriteFrameChanged(a,b);this.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnFrameChanged,this)};q.draw=function(a){a.globalAlpha=this.opacity;
var b=this.curFrame,c=b.spritesheeted,d=b.texture_img,e=this.x,f=this.y,g=this.width,h=this.height;if(0===this.angle&&0<=g&&0<=h)e-=this.hotspotX*g,f-=this.hotspotY*h,this.runtime.pixel_rounding&&(e=e+0.5|0,f=f+0.5|0),c?a.drawImage(d,b.offx,b.offy,b.width,b.height,e,f,g,h):a.drawImage(d,e,f,g,h);else{this.runtime.pixel_rounding&&(e=e+0.5|0,f=f+0.5|0);a.save();var k=0<g?1:-1,m=0<h?1:-1;a.translate(e,f);1===k&&1===m||a.scale(k,m);a.rotate(this.angle*k*m);e=0-this.hotspotX*cr.abs(g);f=0-this.hotspotY*
cr.abs(h);c?a.drawImage(d,b.offx,b.offy,b.width,b.height,e,f,cr.abs(g),cr.abs(h)):a.drawImage(d,e,f,cr.abs(g),cr.abs(h));a.restore()}};q.drawGL=function(a){a.setTexture(this.curWebGLTexture);a.setOpacity(this.opacity);var b=this.curFrame,c=this.bquad;if(this.runtime.pixel_rounding){var d=(this.x+0.5|0)-this.x,e=(this.y+0.5|0)-this.y;b.spritesheeted?a.quadTex(c.tlx+d,c.tly+e,c.trx+d,c.try_+e,c.brx+d,c.bry+e,c.blx+d,c.bly+e,b.sheetTex):a.quad(c.tlx+d,c.tly+e,c.trx+d,c.try_+e,c.brx+d,c.bry+e,c.blx+d,
c.bly+e)}else b.spritesheeted?a.quadTex(c.tlx,c.tly,c.trx,c.try_,c.brx,c.bry,c.blx,c.bly,b.sheetTex):a.quad(c.tlx,c.tly,c.trx,c.try_,c.brx,c.bry,c.blx,c.bly)};q.getImagePointIndexByName=function(a){var b=this.curFrame,c,d;c=0;for(d=b.image_points.length;c<d;c++)if(cr.equals_nocase(a,b.image_points[c][0]))return c;return-1};q.getImagePoint=function(a,b){var c=this.curFrame,d=c.image_points,e;e=cr.is_string(a)?this.getImagePointIndexByName(a):a-1;e=cr.floor(e);if(0>e||e>=d.length)return b?this.x:this.y;
var f=(d[e][1]-c.hotspotX)*this.width,d=d[e][2],d=(d-c.hotspotY)*this.height,c=Math.cos(this.angle);e=Math.sin(this.angle);var g=f*c-d*e,d=d*c+f*e,f=g+this.x,d=d+this.y;return b?f:d};var s=[],r=-2,t=[];b.prototype.OnCollision=function(a){if(!a)return!1;var b=this.runtime,d=b.getCurrentCondition(),f=d.type;d.extra.collmemory||(d.extra.collmemory={},b.addDestroyCallback(function(a){return function(b){b=b.uid;var d,e;for(d in a)a.hasOwnProperty(d)&&(e=a[d],e[0]===b||e[1]===b)&&(c(a[d]),delete a[d])}}(d.extra.collmemory)));
var d=d.extra.collmemory,k=f.getCurrentSol(),m=a.getCurrentSol(),k=k.getObjects(),q,l,n,s,p,w,A,D=this.runtime.tickcount,T=D-1,Q=b.getCurrentEventStack().current_event;for(l=0;l<k.length;l++){n=k[l];m.select_all?(n.update_bbox(),this.runtime.getCollisionCandidates(n.layer,a,n.bbox,t),q=t):q=m.getObjects();for(s=0;s<q.length;s++)p=q[s],b.testOverlap(n,p)||b.checkRegisteredCollision(n,p)?(w=g(d,n,p),w=!w||r<T,e(d,n,p,D),w&&(b.pushCopySol(Q.solModifiers),w=f.getCurrentSol(),A=a.getCurrentSol(),w.select_all=
!1,A.select_all=!1,f===a?(w.instances.length=2,w.instances[0]=n,w.instances[1]=p,f.applySolToContainer()):(w.instances.length=1,A.instances.length=1,w.instances[0]=n,A.instances[0]=p,f.applySolToContainer(),a.applySolToContainer()),Q.retrigger(),b.popSol(Q.solModifiers))):h(d,n,p);t.length=0}return!1};var w=null,A=new cr.ObjectSet,D=!1;n.finish=function(a){if(D){if(a){var b=this.runtime.getCurrentEventStack().current_event.orblock;a=w.getCurrentSol();var c=A.valuesRef(),d,e;if(a.select_all){a.select_all=
!1;a.instances.length=c.length;d=0;for(e=c.length;d<e;d++)a.instances[d]=c[d];if(b)for(d=a.else_instances.length=0,e=w.instances.length;d<e;d++)c=w.instances[d],A.contains(c)||a.else_instances.push(c)}else if(b)for(b=a.instances.length,a.instances.length=b+c.length,d=0,e=c.length;d<e;d++)a.instances[b+d]=c[d],cr.arrayFindRemove(a.else_instances,c[d]);else cr.shallowAssignArray(a.instances,c);w.applySolToContainer()}A.clear();D=!1}};b.prototype.IsOverlapping=function(a){return l.call(this,a,0,0)};
b.prototype.IsOverlappingOffset=function(a,b,c){return l.call(this,a,b,c)};b.prototype.IsAnimPlaying=function(a){return this.changeAnimName.length?cr.equals_nocase(this.changeAnimName,a):cr.equals_nocase(this.cur_animation.name,a)};b.prototype.CompareFrame=function(a,b){return cr.do_cmp(this.cur_frame,a,b)};b.prototype.CompareAnimSpeed=function(a,b){return cr.do_cmp(this.animForwards?this.cur_anim_speed:-this.cur_anim_speed,a,b)};b.prototype.OnAnimFinished=function(a){return cr.equals_nocase(this.animTriggerName,
a)};b.prototype.OnAnyAnimFinished=function(){return!0};b.prototype.OnFrameChanged=function(){return!0};b.prototype.IsMirrored=function(){return 0>this.width};b.prototype.IsFlipped=function(){return 0>this.height};b.prototype.OnURLLoaded=function(){return!0};b.prototype.IsCollisionEnabled=function(){return this.collisionsEnabled};m.cnds=new b;k.prototype.Spawn=function(a,b,c){if(a&&b&&(b=this.runtime.createInstance(a,b,this.getImagePoint(c,!0),this.getImagePoint(c,!1)))){"undefined"!==typeof b.angle&&
(b.angle=this.angle,b.set_bbox_changed());this.runtime.isInOnDestroy++;var d,e,f;this.runtime.trigger(Object.getPrototypeOf(a.plugin).cnds.OnCreated,b);if(b.is_contained)for(d=0,e=b.siblings.length;d<e;d++)f=b.siblings[d],this.runtime.trigger(Object.getPrototypeOf(f.type.plugin).cnds.OnCreated,f);this.runtime.isInOnDestroy--;d=this.runtime.getCurrentAction();c=!1;if(cr.is_undefined(d.extra.Spawn_LastExec)||d.extra.Spawn_LastExec<this.runtime.execcount)c=!0,d.extra.Spawn_LastExec=this.runtime.execcount;
if(a!=this.type&&(a=a.getCurrentSol(),a.select_all=!1,c?(a.instances.length=1,a.instances[0]=b):a.instances.push(b),b.is_contained))for(d=0,e=b.siblings.length;d<e;d++)f=b.siblings[d],a=f.type.getCurrentSol(),a.select_all=!1,c?(a.instances.length=1,a.instances[0]=f):a.instances.push(f)}};k.prototype.SetEffect=function(a){this.compositeOp=cr.effectToCompositeOp(a);cr.setGLBlend(this,a,this.runtime.gl);this.runtime.redraw=!0};k.prototype.StopAnim=function(){this.animPlaying=!1};k.prototype.StartAnim=
function(a){this.animPlaying=!0;this.frameStart=this.getNowTime();1===a&&0!==this.cur_frame&&(this.changeAnimFrame=0,this.inAnimTrigger||this.doChangeAnimFrame());this.isTicking||(this.runtime.tickMe(this),this.isTicking=!0)};k.prototype.SetAnim=function(a,b){this.changeAnimName=a;this.changeAnimFrom=b;this.isTicking||(this.runtime.tickMe(this),this.isTicking=!0);this.inAnimTrigger||this.doChangeAnim()};k.prototype.SetAnimFrame=function(a){this.changeAnimFrame=a;this.isTicking||(this.runtime.tickMe(this),
this.isTicking=!0);this.inAnimTrigger||this.doChangeAnimFrame()};k.prototype.SetAnimSpeed=function(a){this.cur_anim_speed=cr.abs(a);this.animForwards=0<=a;this.isTicking||(this.runtime.tickMe(this),this.isTicking=!0)};k.prototype.SetMirrored=function(a){a=cr.abs(this.width)*(0===a?-1:1);this.width!==a&&(this.width=a,this.set_bbox_changed())};k.prototype.SetFlipped=function(a){a=cr.abs(this.height)*(0===a?-1:1);this.height!==a&&(this.height=a,this.set_bbox_changed())};k.prototype.SetScale=function(a){var b=
this.curFrame,c=b.width*a*(0>this.width?-1:1);a=b.height*a*(0>this.height?-1:1);if(this.width!==c||this.height!==a)this.width=c,this.height=a,this.set_bbox_changed()};k.prototype.LoadURL=function(a,b){var c=new Image,d=this,e=this.curFrame;c.onload=function(){e.texture_img.src===c.src?d.runtime.glwrap&&d.curFrame===e&&(d.curWebGLTexture=e.webGL_texture):(e.texture_img=c,e.offx=0,e.offy=0,e.width=c.width,e.height=c.height,e.spritesheeted=!1,e.datauri="",d.runtime.glwrap&&(e.webGL_texture&&d.runtime.glwrap.deleteTexture(e.webGL_texture),
e.webGL_texture=d.runtime.glwrap.loadTexture(c,!1,d.runtime.linearSampling),d.curFrame===e&&(d.curWebGLTexture=e.webGL_texture),d.type.updateAllCurrentTexture()),0===b&&(d.width=c.width,d.height=c.height,d.set_bbox_changed()));d.runtime.redraw=!0;d.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnURLLoaded,d)};"data:"!==a.substr(0,5)&&(c.crossOrigin="anonymous");c.src=a};k.prototype.SetCollisions=function(a){this.collisionsEnabled!==(0!==a)&&((this.collisionsEnabled=0!==a)?this.set_bbox_changed():
(this.collcells.right>=this.collcells.left&&this.type.collision_grid.update(this,this.collcells,null),this.collcells.set(0,0,-1,-1)))};m.acts=new k;f.prototype.AnimationFrame=function(a){a.set_int(this.cur_frame)};f.prototype.AnimationFrameCount=function(a){a.set_int(this.cur_animation.frames.length)};f.prototype.AnimationName=function(a){a.set_string(this.cur_animation.name)};f.prototype.AnimationSpeed=function(a){a.set_float(this.animForwards?this.cur_anim_speed:-this.cur_anim_speed)};f.prototype.ImagePointX=
function(a,b){a.set_float(this.getImagePoint(b,!0))};f.prototype.ImagePointY=function(a,b){a.set_float(this.getImagePoint(b,!1))};f.prototype.ImagePointCount=function(a){a.set_int(this.curFrame.image_points.length)};f.prototype.ImageWidth=function(a){a.set_float(this.curFrame.width)};f.prototype.ImageHeight=function(a){a.set_float(this.curFrame.height)};m.exps=new f})();cr.plugins_.Text=function(a){this.runtime=a};
(function(){function a(){return f.length?f.pop():{}}function b(a){var b,c;b=0;for(c=a.length;b<c;b++)f.push(a[b]);a.length=0}function c(){}function d(){}function e(){}var h=cr.plugins_.Text.prototype;h.onCreate=function(){h.acts.SetWidth=function(a){this.width!==a&&(this.width=a,this.text_changed=!0,this.set_bbox_changed())}};h.Type=function(a){this.plugin=a;this.runtime=a.runtime};var g=h.Type.prototype;g.onCreate=function(){};g.onLostWebGLContext=function(){if(!this.is_family){var a,b,c;a=0;for(b=
this.instances.length;a<b;a++)c=this.instances[a],c.mycanvas=null,c.myctx=null,c.mytex=null}};h.Instance=function(a){this.type=a;this.runtime=a.runtime;this.recycled?this.lines.length=0:this.lines=[];this.text_changed=!0};var g=h.Instance.prototype,l={};g.onCreate=function(){this.text=this.properties[0];this.visible=0===this.properties[1];this.font=this.properties[2];this.color=this.properties[3];this.halign=this.properties[4];this.valign=this.properties[5];this.wrapbyword=0===this.properties[7];
this.lastwrapwidth=this.lastwidth=this.width;this.lastheight=this.height;this.line_height_offset=this.properties[8];this.fontstyle=this.facename="";this.textHeight=this.textWidth=this.ptSize=0;this.parseFont();this.mytex=this.myctx=this.mycanvas=null;this.need_text_redraw=!1;this.last_render_tick=this.runtime.tickcount;this.recycled?this.rcTex.set(0,0,1,1):this.rcTex=new cr.rect(0,0,1,1);this.runtime.glwrap&&this.runtime.tickMe(this)};g.parseFont=function(){var a=this.font.split(" "),b;for(b=0;b<
a.length;b++)if("pt"===a[b].substr(a[b].length-2,2)){this.ptSize=parseInt(a[b].substr(0,a[b].length-2));this.pxHeight=Math.ceil(96*(this.ptSize/72))+4;0<b&&(this.fontstyle=a[b-1]);this.facename=a[b+1];for(b+=2;b<a.length;b++)this.facename+=" "+a[b];break}};g.saveToJSON=function(){return{t:this.text,f:this.font,c:this.color,ha:this.halign,va:this.valign,wr:this.wrapbyword,lho:this.line_height_offset,fn:this.facename,fs:this.fontstyle,ps:this.ptSize,pxh:this.pxHeight,tw:this.textWidth,th:this.textHeight,
lrt:this.last_render_tick}};g.loadFromJSON=function(a){this.text=a.t;this.font=a.f;this.color=a.c;this.halign=a.ha;this.valign=a.va;this.wrapbyword=a.wr;this.line_height_offset=a.lho;this.facename=a.fn;this.fontstyle=a.fs;this.ptSize=a.ps;this.pxHeight=a.pxh;this.textWidth=a.tw;this.textHeight=a.th;this.last_render_tick=a.lrt;this.text_changed=!0;this.lastwrapwidth=this.lastwidth=this.width;this.lastheight=this.height};g.tick=function(){if(this.runtime.glwrap&&this.mytex&&300<=this.runtime.tickcount-
this.last_render_tick){var a=this.layer;this.update_bbox();var b=this.bbox;if(b.right<a.viewLeft||b.bottom<a.viewTop||b.left>a.viewRight||b.top>a.viewBottom)this.runtime.glwrap.deleteTexture(this.mytex),this.mycanvas=this.myctx=this.mytex=null}};g.onDestroy=function(){this.mycanvas=this.myctx=null;this.runtime.glwrap&&this.mytex&&this.runtime.glwrap.deleteTexture(this.mytex);this.mytex=null};g.updateFont=function(){this.font=this.fontstyle+" "+this.ptSize.toString()+"pt "+this.facename;this.text_changed=
!0;this.runtime.redraw=!0};g.draw=function(a,b){a.font=this.font;a.textBaseline="top";a.fillStyle=this.color;a.globalAlpha=b?1:this.opacity;var c=1;b&&(c=this.layer.getScale(),a.save(),a.scale(c,c));if(this.text_changed||this.width!==this.lastwrapwidth)this.type.plugin.WordWrap(this.text,this.lines,a,this.width,this.wrapbyword),this.text_changed=!1,this.lastwrapwidth=this.width;this.update_bbox();var c=b?0:this.bquad.tlx,d=b?0:this.bquad.tly;this.runtime.pixel_rounding&&(c=c+0.5|0,d=d+0.5|0);0===
this.angle||b||(a.save(),a.translate(c,d),a.rotate(this.angle),d=c=0);var e=d+this.height,f=this.pxHeight,f=f+this.line_height_offset,g,h;1===this.valign?d+=Math.max(this.height/2-this.lines.length*f/2,0):2===this.valign&&(d+=Math.max(this.height-this.lines.length*f-2,0));for(h=0;h<this.lines.length&&!(g=c,1===this.halign?g=c+(this.width-this.lines[h].width)/2:2===this.halign&&(g=c+(this.width-this.lines[h].width)),a.fillText(this.lines[h].text,g,d),d+=f,d>=e-f);h++);(0!==this.angle||b)&&a.restore();
this.last_render_tick=this.runtime.tickcount};g.drawGL=function(a){if(!(1>this.width||1>this.height)){var b=this.text_changed||this.need_text_redraw;this.need_text_redraw=!1;var c=this.layer.getScale(),d=this.layer.getAngle(),e=this.rcTex,f=c*this.width,g=c*this.height,h=Math.ceil(f),k=Math.ceil(g),l=this.runtime.draw_width/2,O=this.runtime.draw_height/2;this.myctx||(this.mycanvas=document.createElement("canvas"),this.mycanvas.width=h,this.mycanvas.height=k,this.lastwidth=h,this.lastheight=k,b=!0,
this.myctx=this.mycanvas.getContext("2d"));if(h!==this.lastwidth||k!==this.lastheight)this.mycanvas.width=h,this.mycanvas.height=k,this.mytex&&(a.deleteTexture(this.mytex),this.mytex=null),b=!0;b&&(this.myctx.clearRect(0,0,h,k),this.draw(this.myctx,!0),this.mytex||(this.mytex=a.createEmptyTexture(h,k,this.runtime.linearSampling,this.runtime.isMobile)),a.videoToTexture(this.mycanvas,this.mytex,this.runtime.isMobile));this.lastwidth=h;this.lastheight=k;a.setTexture(this.mytex);a.setOpacity(this.opacity);
a.resetModelView();a.translate(-l,-O);a.updateModelView();var B=this.bquad,y=this.runtime.devicePixelRatio;this.runtime.devicePixelRatio=1;var b=this.layer.layerToCanvas(B.tlx,B.tly,!0,!0),l=this.layer.layerToCanvas(B.tlx,B.tly,!1,!0),O=this.layer.layerToCanvas(B.trx,B.try_,!0,!0),v=this.layer.layerToCanvas(B.trx,B.try_,!1,!0),u=this.layer.layerToCanvas(B.brx,B.bry,!0,!0),z=this.layer.layerToCanvas(B.brx,B.bry,!1,!0),E=this.layer.layerToCanvas(B.blx,B.bly,!0,!0),B=this.layer.layerToCanvas(B.blx,B.bly,
!1,!0);this.runtime.devicePixelRatio=y;if(this.runtime.pixel_rounding||0===this.angle&&0===d)var y=(b+0.5|0)-b,x=(l+0.5|0)-l,b=b+y,l=l+x,O=O+y,v=v+x,u=u+y,z=z+x,E=E+y,B=B+x;0===this.angle&&0===d?(O=b+h,v=l,u=O,z=l+k,E=b,B=z,e.right=1,e.bottom=1):(e.right=f/h,e.bottom=g/k);a.quadTex(b,l,O,v,u,z,E,B,e);a.resetModelView();a.scale(c,c);a.rotateZ(-this.layer.getAngle());a.translate((this.layer.viewLeft+this.layer.viewRight)/-2,(this.layer.viewTop+this.layer.viewBottom)/-2);a.updateModelView();this.last_render_tick=
this.runtime.tickcount}};var k=[];h.TokeniseWords=function(a){k.length=0;for(var b="",c,d=0;d<a.length;)if(c=a.charAt(d),"\n"===c)b.length&&(k.push(b),b=""),k.push("\n"),++d;else if(" "===c||"\t"===c||"-"===c){do b+=a.charAt(d),d++;while(d<a.length&&(" "===a.charAt(d)||"\t"===a.charAt(d)));k.push(b);b=""}else d<a.length&&(b+=c,d++);b.length&&k.push(b)};var f=[];h.WordWrap=function(c,d,e,f,g){if(c&&c.length)if(2>=f)b(d);else{if(100>=c.length&&-1===c.indexOf("\n")){var h=e.measureText(c).width;if(h<=
f){b(d);d.push(a());d[0].text=c;d[0].width=h;return}}this.WrapText(c,d,e,f,g)}else b(d)};h.WrapText=function(b,c,d,e,g){g&&(this.TokeniseWords(b),b=k);var h="",l,w,A,D=0;for(A=0;A<b.length;A++)"\n"===b[A]?(D>=c.length&&c.push(a()),w=c[D],w.text=h,w.width=d.measureText(h).width,D++,h=""):(l=h,h+=b[A],w=d.measureText(h).width,w>=e&&(D>=c.length&&c.push(a()),w=c[D],w.text=l,w.width=d.measureText(l).width,D++,h=b[A],g||" "!==h||(h="")));h.length&&(D>=c.length&&c.push(a()),w=c[D],w.text=h,w.width=d.measureText(h).width,
D++);for(A=D;A<c.length;A++)f.push(c[A]);c.length=D};c.prototype.CompareText=function(a,b){return b?this.text==a:cr.equals_nocase(this.text,a)};h.cnds=new c;d.prototype.SetText=function(a){cr.is_number(a)&&1E9>a&&(a=Math.round(1E10*a)/1E10);a=a.toString();this.text!==a&&(this.text=a,this.text_changed=!0,this.runtime.redraw=!0)};d.prototype.AppendText=function(a){cr.is_number(a)&&(a=Math.round(1E10*a)/1E10);if(a=a.toString())this.text+=a,this.text_changed=!0,this.runtime.redraw=!0};d.prototype.SetFontFace=
function(a,b){var c="";switch(b){case 1:c="bold";break;case 2:c="italic";break;case 3:c="bold italic"}if(a!==this.facename||c!==this.fontstyle)this.facename=a,this.fontstyle=c,this.updateFont()};d.prototype.SetFontSize=function(a){this.ptSize!==a&&(this.ptSize=a,this.pxHeight=Math.ceil(96*(this.ptSize/72))+4,this.updateFont())};d.prototype.SetFontColor=function(a){a="rgb("+cr.GetRValue(a).toString()+","+cr.GetGValue(a).toString()+","+cr.GetBValue(a).toString()+")";a!==this.color&&(this.color=a,this.need_text_redraw=
!0,this.runtime.redraw=!0)};d.prototype.SetWebFont=function(a,b){if(this.runtime.isDomFree)cr.logexport("[Construct 2] Text plugin: 'Set web font' not supported on this platform - the action has been ignored");else{var c=this,d=function(){c.runtime.redraw=!0;c.text_changed=!0};if(l.hasOwnProperty(b)){var e="'"+a+"'";if(this.facename!==e)for(this.facename=e,this.updateFont(),e=1;10>e;e++)setTimeout(d,100*e),setTimeout(d,1E3*e)}else for(e=document.createElement("link"),e.href=b,e.rel="stylesheet",e.type=
"text/css",e.onload=d,document.getElementsByTagName("head")[0].appendChild(e),l[b]=!0,this.facename="'"+a+"'",this.updateFont(),e=1;10>e;e++)setTimeout(d,100*e),setTimeout(d,1E3*e)}};d.prototype.SetEffect=function(a){this.compositeOp=cr.effectToCompositeOp(a);cr.setGLBlend(this,a,this.runtime.gl);this.runtime.redraw=!0};h.acts=new d;e.prototype.Text=function(a){a.set_string(this.text)};e.prototype.FaceName=function(a){a.set_string(this.facename)};e.prototype.FaceSize=function(a){a.set_int(this.ptSize)};
e.prototype.TextWidth=function(a){var b=0,c,d,e;c=0;for(d=this.lines.length;c<d;c++)e=this.lines[c].width,b<e&&(b=e);a.set_int(b)};e.prototype.TextHeight=function(a){a.set_int(this.lines.length*(this.pxHeight+this.line_height_offset)-this.line_height_offset)};h.exps=new e})();cr.plugins_.Touch=function(a){this.runtime=a};
(function(){function a(a){l=a.x;k=a.y;f=a.z}function b(a){m=a.x;n=a.y;p=a.z}function c(){}function d(){}var e=cr.plugins_.Touch.prototype;e.Type=function(a){this.plugin=a;this.runtime=a.runtime};e.Type.prototype.onCreate=function(){};e.Instance=function(a){this.type=a;this.runtime=a.runtime;this.touches=[];this.mouseDown=!1};var h=e.Instance.prototype,g={left:0,top:0};h.findTouch=function(a){var b,c;b=0;for(c=this.touches.length;b<c;b++)if(this.touches[b].id===a)return b;return-1};var l=0,k=0,f=0,
m=0,n=0,p=0;h.onCreate=function(){this.isWindows8=!("undefined"===typeof window.c2isWindows8||!window.c2isWindows8);this.trigger_id=this.trigger_index=this.curTouchY=this.curTouchX=this.acc_z=this.acc_y=this.acc_x=this.acc_g_z=this.acc_g_y=this.acc_g_x=this.orient_gamma=this.orient_beta=this.orient_alpha=0;this.useMouseInput=0!==this.properties[0];var c=0<this.runtime.fullscreen_mode?document:this.runtime.canvas,d=document;this.runtime.isDirectCanvas?d=c=window.Canvas:this.runtime.isCocoonJs&&(d=
c=window);var e=this;window.navigator.pointerEnabled?(c.addEventListener("pointerdown",function(a){e.onPointerStart(a)},!1),c.addEventListener("pointermove",function(a){e.onPointerMove(a)},!1),d.addEventListener("pointerup",function(a){e.onPointerEnd(a)},!1),d.addEventListener("pointercancel",function(a){e.onPointerEnd(a)},!1),this.runtime.canvas&&(this.runtime.canvas.addEventListener("MSGestureHold",function(a){a.preventDefault()},!1),document.addEventListener("MSGestureHold",function(a){a.preventDefault()},
!1),this.runtime.canvas.addEventListener("gesturehold",function(a){a.preventDefault()},!1),document.addEventListener("gesturehold",function(a){a.preventDefault()},!1))):window.navigator.msPointerEnabled?(c.addEventListener("MSPointerDown",function(a){e.onPointerStart(a)},!1),c.addEventListener("MSPointerMove",function(a){e.onPointerMove(a)},!1),d.addEventListener("MSPointerUp",function(a){e.onPointerEnd(a)},!1),d.addEventListener("MSPointerCancel",function(a){e.onPointerEnd(a)},!1),this.runtime.canvas&&
(this.runtime.canvas.addEventListener("MSGestureHold",function(a){a.preventDefault()},!1),document.addEventListener("MSGestureHold",function(a){a.preventDefault()},!1))):(c.addEventListener("touchstart",function(a){e.onTouchStart(a)},!1),c.addEventListener("touchmove",function(a){e.onTouchMove(a)},!1),d.addEventListener("touchend",function(a){e.onTouchEnd(a)},!1),d.addEventListener("touchcancel",function(a){e.onTouchEnd(a)},!1));if(this.isWindows8){var f=function(a){a=a.reading;e.acc_x=a.accelerationX;
e.acc_y=a.accelerationY;e.acc_z=a.accelerationZ},g=function(a){a=a.reading;e.orient_alpha=a.yawDegrees;e.orient_beta=a.pitchDegrees;e.orient_gamma=a.rollDegrees},h=Windows.Devices.Sensors.Accelerometer.getDefault();h&&(h.reportInterval=Math.max(h.minimumReportInterval,16),h.addEventListener("readingchanged",f));var k=Windows.Devices.Sensors.Inclinometer.getDefault();k&&(k.reportInterval=Math.max(k.minimumReportInterval,16),k.addEventListener("readingchanged",g));document.addEventListener("visibilitychange",
function(a){document.hidden||document.msHidden?(h&&h.removeEventListener("readingchanged",f),k&&k.removeEventListener("readingchanged",g)):(h&&h.addEventListener("readingchanged",f),k&&k.addEventListener("readingchanged",g))},!1)}else window.addEventListener("deviceorientation",function(a){e.orient_alpha=a.alpha||0;e.orient_beta=a.beta||0;e.orient_gamma=a.gamma||0},!1),window.addEventListener("devicemotion",function(a){a.accelerationIncludingGravity&&(e.acc_g_x=a.accelerationIncludingGravity.x,e.acc_g_y=
a.accelerationIncludingGravity.y,e.acc_g_z=a.accelerationIncludingGravity.z);a.acceleration&&(e.acc_x=a.acceleration.x,e.acc_y=a.acceleration.y,e.acc_z=a.acceleration.z)},!1);this.useMouseInput&&!this.runtime.isDomFree&&(jQuery(document).mousemove(function(a){e.onMouseMove(a)}),jQuery(document).mousedown(function(a){e.onMouseDown(a)}),jQuery(document).mouseup(function(a){e.onMouseUp(a)}));this.runtime.isAppMobi&&!this.runtime.isDirectCanvas&&AppMobi.accelerometer.watchAcceleration(a,{frequency:40,
adjustForRotation:!0});this.runtime.isPhoneGap&&navigator.accelerometer.watchAcceleration(b,null,{frequency:40});this.runtime.tick2Me(this)};h.onPointerMove=function(a){if(a.pointerType!==a.MSPOINTER_TYPE_MOUSE&&"mouse"!==a.pointerType){a.preventDefault&&a.preventDefault();var b=this.findTouch(a.pointerId),c=cr.performance_now();if(0<=b){var d=this.runtime.isDomFree?g:jQuery(this.runtime.canvas).offset(),b=this.touches[b];2>c-b.time||(b.lasttime=b.time,b.lastx=b.x,b.lasty=b.y,b.time=c,b.x=a.pageX-
d.left,b.y=a.pageY-d.top)}}};h.onPointerStart=function(a){if(a.pointerType!==a.MSPOINTER_TYPE_MOUSE&&"mouse"!==a.pointerType){a.preventDefault&&a.preventDefault();var b=this.runtime.isDomFree?g:jQuery(this.runtime.canvas).offset(),c=a.pageX-b.left,b=a.pageY-b.top,d=cr.performance_now();this.trigger_index=this.touches.length;this.trigger_id=a.pointerId;this.touches.push({time:d,x:c,y:b,lasttime:d,lastx:c,lasty:b,id:a.pointerId,startindex:this.trigger_index});this.runtime.isInUserInputEvent=!0;this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchStart,
this);this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchStart,this);this.curTouchX=c;this.curTouchY=b;this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchObject,this);this.runtime.isInUserInputEvent=!1}};h.onPointerEnd=function(a){a.pointerType!==a.MSPOINTER_TYPE_MOUSE&&"mouse"!==a.pointerType&&(a.preventDefault&&a.preventDefault(),a=this.findTouch(a.pointerId),this.trigger_index=0<=a?this.touches[a].startindex:-1,this.trigger_id=0<=a?this.touches[a].id:-1,this.runtime.isInUserInputEvent=
!0,this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchEnd,this),this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchEnd,this),this.runtime.isInUserInputEvent=!1,0<=a&&this.touches.splice(a,1))};h.onTouchMove=function(a){a.preventDefault&&a.preventDefault();var b=cr.performance_now(),c,d,e,f;c=0;for(d=a.changedTouches.length;c<d;c++)if(e=a.changedTouches[c],f=this.findTouch(e.identifier),0<=f){var h=this.runtime.isDomFree?g:jQuery(this.runtime.canvas).offset();f=this.touches[f];
2>b-f.time||(f.lasttime=f.time,f.lastx=f.x,f.lasty=f.y,f.time=b,f.x=e.pageX-h.left,f.y=e.pageY-h.top)}};h.onTouchStart=function(a){a.preventDefault&&a.preventDefault();var b=this.runtime.isDomFree?g:jQuery(this.runtime.canvas).offset(),c=cr.performance_now();this.runtime.isInUserInputEvent=!0;var d,e,f,h;d=0;for(e=a.changedTouches.length;d<e;d++)if(f=a.changedTouches[d],h=this.findTouch(f.identifier),-1===h){h=f.pageX-b.left;var k=f.pageY-b.top;this.trigger_index=this.touches.length;this.trigger_id=
f.identifier;this.touches.push({time:c,x:h,y:k,lasttime:c,lastx:h,lasty:k,id:f.identifier,startindex:this.trigger_index});this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchStart,this);this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchStart,this);this.curTouchX=h;this.curTouchY=k;this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchObject,this)}this.runtime.isInUserInputEvent=!1};h.onTouchEnd=function(a){a.preventDefault&&a.preventDefault();this.runtime.isInUserInputEvent=
!0;var b,c,d;b=0;for(c=a.changedTouches.length;b<c;b++)d=a.changedTouches[b],d=this.findTouch(d.identifier),0<=d&&(this.trigger_index=this.touches[d].startindex,this.trigger_id=this.touches[d].id,this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchEnd,this),this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchEnd,this),this.touches.splice(d,1));this.runtime.isInUserInputEvent=!1};h.getAlpha=function(){return this.runtime.isAppMobi&&0===this.orient_alpha&&0!==f?90*f:this.runtime.isPhoneGap&&
0===this.orient_alpha&&0!==p?90*p:this.orient_alpha};h.getBeta=function(){return this.runtime.isAppMobi&&0===this.orient_beta&&0!==k?-90*k:this.runtime.isPhoneGap&&0===this.orient_beta&&0!==n?-90*n:this.orient_beta};h.getGamma=function(){return this.runtime.isAppMobi&&0===this.orient_gamma&&0!==l?90*l:this.runtime.isPhoneGap&&0===this.orient_gamma&&0!==m?90*m:this.orient_gamma};h.onMouseDown=function(a){a.preventDefault&&this.runtime.had_a_click&&a.preventDefault();this.onTouchStart({changedTouches:[{pageX:a.pageX,
pageY:a.pageY,identifier:0}]});this.mouseDown=!0};h.onMouseMove=function(a){a.preventDefault&&this.runtime.had_a_click&&a.preventDefault();if(this.mouseDown)this.onTouchMove({changedTouches:[{pageX:a.pageX,pageY:a.pageY,identifier:0}]})};h.onMouseUp=function(a){a.preventDefault&&this.runtime.had_a_click&&a.preventDefault();this.runtime.had_a_click=!0;this.onTouchEnd({changedTouches:[{pageX:a.pageX,pageY:a.pageY,identifier:0}]});this.mouseDown=!1};h.tick2=function(){var a,b,c,d=cr.performance_now();
a=0;for(b=this.touches.length;a<b;a++)c=this.touches[a],c.time<=d-50&&(c.lasttime=d)};c.prototype.OnTouchStart=function(){return!0};c.prototype.OnTouchEnd=function(){return!0};c.prototype.IsInTouch=function(){return this.touches.length};c.prototype.OnTouchObject=function(a){return a?this.runtime.testAndSelectCanvasPointOverlap(a,this.curTouchX,this.curTouchY,!1):!1};c.prototype.IsTouchingObject=function(a){if(!a)return!1;var b=a.getCurrentSol(),c=b.getObjects(),d,e,f=[],g,h,k,m;g=0;for(h=c.length;g<
h;g++){var l=c[g];l.update_bbox();k=0;for(m=this.touches.length;k<m;k++)if(e=this.touches[k],d=l.layer.canvasToLayer(e.x,e.y,!0),e=l.layer.canvasToLayer(e.x,e.y,!1),l.contains_pt(d,e)){f.push(l);break}}return f.length?(b.select_all=!1,b.instances=f,a.applySolToContainer(),!0):!1};c.prototype.CompareTouchSpeed=function(a,b,c){a=Math.floor(a);if(0>a||a>=this.touches.length)return!1;var d=this.touches[a];a=cr.distanceTo(d.x,d.y,d.lastx,d.lasty);var d=(d.time-d.lasttime)/1E3,e=0;0<d&&(e=a/d);return cr.do_cmp(e,
b,c)};c.prototype.OrientationSupported=function(){return"undefined"!==typeof window.DeviceOrientationEvent};c.prototype.MotionSupported=function(){return"undefined"!==typeof window.DeviceMotionEvent};c.prototype.CompareOrientation=function(a,b,c){var d=0,d=0===a?this.getAlpha():1===a?this.getBeta():this.getGamma();return cr.do_cmp(d,b,c)};c.prototype.CompareAcceleration=function(a,b,c){var d=0;0===a?d=this.acc_g_x:1===a?d=this.acc_g_y:2===a?d=this.acc_g_z:3===a?d=this.acc_x:4===a?d=this.acc_y:5===
a&&(d=this.acc_z);return cr.do_cmp(d,b,c)};c.prototype.OnNthTouchStart=function(a){a=Math.floor(a);return a===this.trigger_index};c.prototype.OnNthTouchEnd=function(a){a=Math.floor(a);return a===this.trigger_index};c.prototype.HasNthTouch=function(a){a=Math.floor(a);return this.touches.length>=a+1};e.cnds=new c;d.prototype.TouchCount=function(a){a.set_int(this.touches.length)};d.prototype.X=function(a,b){if(this.touches.length){var c,d,e,f,g;cr.is_undefined(b)?(c=this.runtime.getLayerByNumber(0),
d=c.scale,e=c.zoomRate,f=c.parallaxX,g=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=1,c.parallaxX=1,c.angle=this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(this.touches[0].x,this.touches[0].y,!0)),c.scale=d,c.zoomRate=e,c.parallaxX=f,c.angle=g):(c=cr.is_number(b)?this.runtime.getLayerByNumber(b):this.runtime.getLayerByName(b))?a.set_float(c.canvasToLayer(this.touches[0].x,this.touches[0].y,!0)):a.set_float(0)}else a.set_float(0)};d.prototype.XAt=function(a,b,c){b=Math.floor(b);
if(0>b||b>=this.touches.length)a.set_float(0);else{var d,e,f,g;cr.is_undefined(c)?(c=this.runtime.getLayerByNumber(0),d=c.scale,e=c.zoomRate,f=c.parallaxX,g=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=1,c.parallaxX=1,c.angle=this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(this.touches[b].x,this.touches[b].y,!0)),c.scale=d,c.zoomRate=e,c.parallaxX=f,c.angle=g):(c=cr.is_number(c)?this.runtime.getLayerByNumber(c):this.runtime.getLayerByName(c))?a.set_float(c.canvasToLayer(this.touches[b].x,
this.touches[b].y,!0)):a.set_float(0)}};d.prototype.XForID=function(a,b,c){b=this.findTouch(b);if(0>b)a.set_float(0);else{b=this.touches[b];var d,e,f,g;cr.is_undefined(c)?(c=this.runtime.getLayerByNumber(0),d=c.scale,e=c.zoomRate,f=c.parallaxX,g=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=1,c.parallaxX=1,c.angle=this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(b.x,b.y,!0)),c.scale=d,c.zoomRate=e,c.parallaxX=f,c.angle=g):(c=cr.is_number(c)?this.runtime.getLayerByNumber(c):
this.runtime.getLayerByName(c))?a.set_float(c.canvasToLayer(b.x,b.y,!0)):a.set_float(0)}};d.prototype.Y=function(a,b){if(this.touches.length){var c,d,e,f,g;cr.is_undefined(b)?(c=this.runtime.getLayerByNumber(0),d=c.scale,e=c.zoomRate,f=c.parallaxY,g=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=1,c.parallaxY=1,c.angle=this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(this.touches[0].x,this.touches[0].y,!1)),c.scale=d,c.zoomRate=e,c.parallaxY=f,c.angle=g):(c=cr.is_number(b)?
this.runtime.getLayerByNumber(b):this.runtime.getLayerByName(b))?a.set_float(c.canvasToLayer(this.touches[0].x,this.touches[0].y,!1)):a.set_float(0)}else a.set_float(0)};d.prototype.YAt=function(a,b,c){b=Math.floor(b);if(0>b||b>=this.touches.length)a.set_float(0);else{var d,e,f,g;cr.is_undefined(c)?(c=this.runtime.getLayerByNumber(0),d=c.scale,e=c.zoomRate,f=c.parallaxY,g=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=1,c.parallaxY=1,c.angle=this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(this.touches[b].x,
this.touches[b].y,!1)),c.scale=d,c.zoomRate=e,c.parallaxY=f,c.angle=g):(c=cr.is_number(c)?this.runtime.getLayerByNumber(c):this.runtime.getLayerByName(c))?a.set_float(c.canvasToLayer(this.touches[b].x,this.touches[b].y,!1)):a.set_float(0)}};d.prototype.YForID=function(a,b,c){b=this.findTouch(b);if(0>b)a.set_float(0);else{b=this.touches[b];var d,e,f,g;cr.is_undefined(c)?(c=this.runtime.getLayerByNumber(0),d=c.scale,e=c.zoomRate,f=c.parallaxY,g=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=
1,c.parallaxY=1,c.angle=this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(b.x,b.y,!1)),c.scale=d,c.zoomRate=e,c.parallaxY=f,c.angle=g):(c=cr.is_number(c)?this.runtime.getLayerByNumber(c):this.runtime.getLayerByName(c))?a.set_float(c.canvasToLayer(b.x,b.y,!1)):a.set_float(0)}};d.prototype.AbsoluteX=function(a){this.touches.length?a.set_float(this.touches[0].x):a.set_float(0)};d.prototype.AbsoluteXAt=function(a,b){b=Math.floor(b);0>b||b>=this.touches.length?a.set_float(0):a.set_float(this.touches[b].x)};
d.prototype.AbsoluteXForID=function(a,b){var c=this.findTouch(b);0>c?a.set_float(0):a.set_float(this.touches[c].x)};d.prototype.AbsoluteY=function(a){this.touches.length?a.set_float(this.touches[0].y):a.set_float(0)};d.prototype.AbsoluteYAt=function(a,b){b=Math.floor(b);0>b||b>=this.touches.length?a.set_float(0):a.set_float(this.touches[b].y)};d.prototype.AbsoluteYForID=function(a,b){var c=this.findTouch(b);0>c?a.set_float(0):a.set_float(this.touches[c].y)};d.prototype.SpeedAt=function(a,b){b=Math.floor(b);
if(0>b||b>=this.touches.length)a.set_float(0);else{var c=this.touches[b],d=cr.distanceTo(c.x,c.y,c.lastx,c.lasty),c=(c.time-c.lasttime)/1E3;0===c?a.set_float(0):a.set_float(d/c)}};d.prototype.SpeedForID=function(a,b){var c=this.findTouch(b);if(0>c)a.set_float(0);else{var d=this.touches[c],c=cr.distanceTo(d.x,d.y,d.lastx,d.lasty),d=(d.time-d.lasttime)/1E3;0===d?a.set_float(0):a.set_float(c/d)}};d.prototype.AngleAt=function(a,b){b=Math.floor(b);if(0>b||b>=this.touches.length)a.set_float(0);else{var c=
this.touches[b];a.set_float(cr.to_degrees(cr.angleTo(c.lastx,c.lasty,c.x,c.y)))}};d.prototype.AngleForID=function(a,b){var c=this.findTouch(b);0>c?a.set_float(0):(c=this.touches[c],a.set_float(cr.to_degrees(cr.angleTo(c.lastx,c.lasty,c.x,c.y))))};d.prototype.Alpha=function(a){a.set_float(this.getAlpha())};d.prototype.Beta=function(a){a.set_float(this.getBeta())};d.prototype.Gamma=function(a){a.set_float(this.getGamma())};d.prototype.AccelerationXWithG=function(a){a.set_float(this.acc_g_x)};d.prototype.AccelerationYWithG=
function(a){a.set_float(this.acc_g_y)};d.prototype.AccelerationZWithG=function(a){a.set_float(this.acc_g_z)};d.prototype.AccelerationX=function(a){a.set_float(this.acc_x)};d.prototype.AccelerationY=function(a){a.set_float(this.acc_y)};d.prototype.AccelerationZ=function(a){a.set_float(this.acc_z)};d.prototype.TouchIndex=function(a){a.set_int(this.trigger_index)};d.prototype.TouchID=function(a){a.set_float(this.trigger_id)};e.exps=new d})();cr.plugins_.WebStorage=function(a){this.runtime=a};
(function(){function a(){k||(cr.logexport("[Construct 2] Webstorage plugin: session storage is not supported on this platform. Try using local storage or global variables instead."),k=!0)}function b(){}function c(){}function d(){}var e=cr.plugins_.WebStorage.prototype;e.Type=function(a){this.plugin=a;this.runtime=a.runtime};e.Type.prototype.onCreate=function(){};e.Instance=function(a){this.type=a;this.runtime=a.runtime};var h=e.Instance.prototype,g="",l="undefined"!==typeof window.is_scirra_arcade;
l&&(g="arcade"+window.scirra_arcade_id);var k=!1;h.onCreate=function(){};b.prototype.LocalStorageEnabled=function(){return!0};b.prototype.SessionStorageEnabled=function(){return!0};b.prototype.LocalStorageExists=function(a){return null!=localStorage.getItem(g+a)};b.prototype.SessionStorageExists=function(b){return this.runtime.isCocoonJs||!sessionStorage?(a(),!1):null!=sessionStorage.getItem(g+b)};b.prototype.OnQuotaExceeded=function(){return!0};b.prototype.CompareKeyText=function(a,b,c){a=localStorage.getItem(g+
a)||"";return c?a==b:cr.equals_nocase(a,b)};b.prototype.CompareKeyNumber=function(a,b,c){a=localStorage.getItem(g+a)||"";return cr.do_cmp(parseFloat(a),b,c)};e.cnds=new b;c.prototype.StoreLocal=function(a,b){try{localStorage.setItem(g+a,b)}catch(c){this.runtime.trigger(cr.plugins_.WebStorage.prototype.cnds.OnQuotaExceeded,this)}};c.prototype.StoreSession=function(b,c){if(this.runtime.isCocoonJs||!sessionStorage)a();else try{sessionStorage.setItem(g+b,c)}catch(d){this.runtime.trigger(cr.plugins_.WebStorage.prototype.cnds.OnQuotaExceeded,
this)}};c.prototype.RemoveLocal=function(a){localStorage.removeItem(g+a)};c.prototype.RemoveSession=function(b){this.runtime.isCocoonJs||!sessionStorage?a():sessionStorage.removeItem(g+b)};c.prototype.ClearLocal=function(){l||localStorage.clear()};c.prototype.ClearSession=function(){this.runtime.isCocoonJs||!sessionStorage?a():l||sessionStorage.clear()};c.prototype.JSONLoad=function(a,b){var c;try{c=JSON.parse(a)}catch(d){return}if(c.c2dictionary){c=c.data;0!==b||l||localStorage.clear();for(var e in c)if(c.hasOwnProperty(e))try{localStorage.setItem(g+
e,c[e])}catch(h){this.runtime.trigger(cr.plugins_.WebStorage.prototype.cnds.OnQuotaExceeded,this);break}}};e.acts=new c;d.prototype.LocalValue=function(a,b){a.set_string(localStorage.getItem(g+b)||"")};d.prototype.SessionValue=function(b,c){this.runtime.isCocoonJs||!sessionStorage?(a(),b.set_string("")):b.set_string(sessionStorage.getItem(g+c)||"")};d.prototype.LocalCount=function(a){a.set_int(l?0:localStorage.length)};d.prototype.SessionCount=function(b){this.runtime.isCocoonJs||!sessionStorage?
(a(),b.set_int(0)):b.set_int(l?0:sessionStorage.length)};d.prototype.LocalAt=function(a,b){l?a.set_string(""):a.set_string(localStorage.getItem(localStorage.key(b))||"")};d.prototype.SessionAt=function(b,c){this.runtime.isCocoonJs||!sessionStorage?(a(),b.set_string("")):l?b.set_string(""):b.set_string(sessionStorage.getItem(sessionStorage.key(c))||"")};d.prototype.LocalKeyAt=function(a,b){l?a.set_string(""):a.set_string(localStorage.key(b)||"")};d.prototype.SessionKeyAt=function(b,c){this.runtime.isCocoonJs||
!sessionStorage?(a(),b.set_string("")):l?b.set_string(""):b.set_string(sessionStorage.key(c)||"")};d.prototype.AsJSON=function(a){var b={},c,d,e;c=0;for(d=localStorage.length;c<d;c++)e=localStorage.key(c),l?e.substr(0,g.length)===g&&(b[e.substr(g.length)]=localStorage.getItem(e)):b[e]=localStorage.getItem(e);a.set_string(JSON.stringify({c2dictionary:!0,data:b}))};e.exps=new d})();cr.behaviors.Bullet=function(a){this.runtime=a};
(function(){function a(){}function b(){}function c(){}var d=cr.behaviors.Bullet.prototype;d.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};d.Type.prototype.onCreate=function(){};d.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var e=d.Instance.prototype;e.onCreate=function(){var a=this.properties[0];this.acc=this.properties[1];this.g=this.properties[2];this.bounceOffSolid=0!==this.properties[3];this.setAngle=0!==this.properties[4];
this.dx=Math.cos(this.inst.angle)*a;this.dy=Math.sin(this.inst.angle)*a;this.lastx=this.inst.x;this.lasty=this.inst.y;this.lastKnownAngle=this.inst.angle;this.travelled=0;this.enabled=0!==this.properties[5]};e.saveToJSON=function(){return{acc:this.acc,g:this.g,dx:this.dx,dy:this.dy,lx:this.lastx,ly:this.lasty,lka:this.lastKnownAngle,t:this.travelled,e:this.enabled}};e.loadFromJSON=function(a){this.acc=a.acc;this.g=a.g;this.dx=a.dx;this.dy=a.dy;this.lastx=a.lx;this.lasty=a.ly;this.lastKnownAngle=a.lka;
this.travelled=a.t;this.enabled=a.e};e.tick=function(){if(this.enabled){var a=this.runtime.getDt(this.inst),b,c;this.inst.angle!==this.lastKnownAngle&&(this.setAngle&&(b=cr.distanceTo(0,0,this.dx,this.dy),this.dx=Math.cos(this.inst.angle)*b,this.dy=Math.sin(this.inst.angle)*b),this.lastKnownAngle=this.inst.angle);0!==this.acc&&(b=cr.distanceTo(0,0,this.dx,this.dy),c=0===this.dx&&0===this.dy?this.inst.angle:cr.angleTo(0,0,this.dx,this.dy),b+=this.acc*a,0>b&&(b=0),this.dx=Math.cos(c)*b,this.dy=Math.sin(c)*
b);0!==this.g&&(this.dy+=this.g*a);this.lastx=this.inst.x;this.lasty=this.inst.y;if(0!==this.dx||0!==this.dy)if(this.inst.x+=this.dx*a,this.inst.y+=this.dy*a,this.travelled+=cr.distanceTo(0,0,this.dx*a,this.dy*a),this.setAngle&&(this.inst.angle=cr.angleTo(0,0,this.dx,this.dy),this.inst.set_bbox_changed(),this.lastKnownAngle=this.inst.angle),this.inst.set_bbox_changed(),this.bounceOffSolid&&(b=this.runtime.testOverlapSolid(this.inst)))this.runtime.registerCollision(this.inst,b),b=cr.distanceTo(0,0,
this.dx,this.dy),c=this.runtime.calculateSolidBounceAngle(this.inst,this.lastx,this.lasty),this.dx=Math.cos(c)*b,this.dy=Math.sin(c)*b,this.inst.x+=this.dx*a,this.inst.y+=this.dy*a,this.inst.set_bbox_changed(),this.setAngle&&(this.lastKnownAngle=this.inst.angle=c,this.inst.set_bbox_changed()),this.runtime.pushOutSolid(this.inst,this.dx/b,this.dy/b,Math.max(2.5*b*a,30))||this.runtime.pushOutSolidNearest(this.inst,100)}};a.prototype.CompareSpeed=function(a,b){return cr.do_cmp(cr.distanceTo(0,0,this.dx,
this.dy),a,b)};a.prototype.CompareTravelled=function(a,b){return cr.do_cmp(this.travelled,a,b)};d.cnds=new a;b.prototype.SetSpeed=function(a){var b=cr.angleTo(0,0,this.dx,this.dy);this.dx=Math.cos(b)*a;this.dy=Math.sin(b)*a};b.prototype.SetAcceleration=function(a){this.acc=a};b.prototype.SetGravity=function(a){this.g=a};b.prototype.SetAngleOfMotion=function(a){a=cr.to_radians(a);var b=cr.distanceTo(0,0,this.dx,this.dy);this.dx=Math.cos(a)*b;this.dy=Math.sin(a)*b};b.prototype.Bounce=function(a){if(a&&
(a=a.getFirstPicked(this.inst))){var b=this.runtime.getDt(this.inst),c=cr.distanceTo(0,0,this.dx,this.dy),d=this.runtime.calculateSolidBounceAngle(this.inst,this.lastx,this.lasty,a);this.dx=Math.cos(d)*c;this.dy=Math.sin(d)*c;this.inst.x+=this.dx*b;this.inst.y+=this.dy*b;this.inst.set_bbox_changed();this.setAngle&&(this.lastKnownAngle=this.inst.angle=d,this.inst.set_bbox_changed());this.bounceOffSolid?this.runtime.pushOutSolid(this.inst,this.dx/c,this.dy/c,Math.max(2.5*c*b,30))||this.runtime.pushOutSolidNearest(this.inst,
100):this.runtime.pushOut(this.inst,this.dx/c,this.dy/c,Math.max(2.5*c*b,30),a)}};b.prototype.SetEnabled=function(a){this.enabled=1===a};d.acts=new b;c.prototype.Speed=function(a){var b=cr.distanceTo(0,0,this.dx,this.dy),b=cr.round6dp(b);a.set_float(b)};c.prototype.Acceleration=function(a){a.set_float(this.acc)};c.prototype.AngleOfMotion=function(a){a.set_float(cr.to_degrees(cr.angleTo(0,0,this.dx,this.dy)))};c.prototype.DistanceTravelled=function(a){a.set_float(this.travelled)};d.exps=new c})();
var Box2D={Dynamics:{}};Box2D.Dynamics.Joints={};Box2D.Common={};Box2D.Common.Math={};Box2D.Collision={};Box2D.Collision.Shapes={};function c2inherit(a,b){for(var c in b.prototype)b.prototype.hasOwnProperty(c)&&(a.prototype[c]=b.prototype[c])}
if(navigator.isCocoonJS&&"undefined"!==typeof window.cr_cjs_accelerated_physics)cr.logexport("Using CocoonJS native physics"),window.ext&&"undefined"!==typeof window.ext.IDTK_SRV_BOX2D?function(){var a=function(a,b){void 0===a&&(a=0);void 0===b&&(b=0);this.x=a;this.y=b};Box2D.Common.Math.b2Vec2=a;a._freeCache=[];a.Get=function(a,b){if(0<Box2D.Common.Math.b2Vec2._freeCache.length){var c=Box2D.Common.Math.b2Vec2._freeCache.pop();c.Set(a,b);return c}return new Box2D.Common.Math.b2Vec2(a,b)};a.Free=function(a){1E4>
Box2D.Common.Math.b2Vec2._freeCache.length&&Box2D.Common.Math.b2Vec2._freeCache.push(a)};a.prototype.SetZero=function(){this.y=this.x=0};a.prototype.Set=function(a,b){void 0===a&&(a=0);void 0===b&&(b=0);this.x=a;this.y=b};a.prototype.SetV=function(a){this.x=a.x;this.y=a.y};a.Make=function(b,c){void 0===b&&(b=0);void 0===c&&(c=0);return a.Get(b,c)};a.prototype.Copy=function(){return a.Get(this.x,this.y)};a.prototype.Add=function(a){this.x+=a.x;this.y+=a.y};a.prototype.Subtract=function(a){this.x-=
a.x;this.y-=a.y};a.prototype.Multiply=function(a){void 0===a&&(a=0);this.x*=a;this.y*=a};a.prototype.Length=function(){return Math.sqrt(this.x*this.x+this.y*this.y)};a.prototype.LengthSquared=function(){return this.x*this.x+this.y*this.y};a.prototype.Normalize=function(){var a=Math.sqrt(this.x*this.x+this.y*this.y);if(a<Number.MIN_VALUE)return 0;var b=1/a;this.x*=b;this.y*=b;return a};a.prototype.NegativeSelf=function(){this.x=-this.x;this.y=-this.y};var b=function(){this.col1=a.Get(0,0);this.col2=
a.Get(0,0);this.SetIdentity()};Box2D.Common.Math.b2Mat22=b;b.FromAngle=function(a){void 0===a&&(a=0);var c=new b;c.Set(a);return c};b.FromVV=function(a,c){var d=new b;d.SetVV(a,c);return d};b.prototype.Set=function(a){void 0===a&&(a=0);var b=Math.cos(a);a=Math.sin(a);this.col1.x=b;this.col2.x=-a;this.col1.y=a;this.col2.y=b};b.prototype.SetVV=function(a,b){this.col1.SetV(a);this.col2.SetV(b)};b.prototype.Copy=function(){var a=new b;a.SetM(this);return a};b.prototype.SetM=function(a){this.col1.SetV(a.col1);
this.col2.SetV(a.col2)};b.prototype.AddM=function(a){this.col1.x+=a.col1.x;this.col1.y+=a.col1.y;this.col2.x+=a.col2.x;this.col2.y+=a.col2.y};b.prototype.SetIdentity=function(){this.col1.x=1;this.col2.x=0;this.col1.y=0;this.col2.y=1};b.prototype.SetZero=function(){this.col1.x=0;this.col2.x=0;this.col1.y=0;this.col2.y=0};b.prototype.GetAngle=function(){return Math.atan2(this.col1.y,this.col1.x)};b.prototype.GetInverse=function(a){var b=this.col1.x,c=this.col2.x,d=this.col1.y,e=this.col2.y,g=b*e-c*
d;0!==g&&(g=1/g);a.col1.x=g*e;a.col2.x=-g*c;a.col1.y=-g*d;a.col2.y=g*b;return a};b.prototype.Solve=function(a,b,c){void 0===b&&(b=0);void 0===c&&(c=0);var d=this.col1.x,e=this.col2.x,g=this.col1.y,h=this.col2.y,k=d*h-e*g;0!==k&&(k=1/k);a.x=k*(h*b-e*c);a.y=k*(d*c-g*b);return a};b.prototype.Abs=function(){this.col1.Abs();this.col2.Abs()};var c=function(c,d){this.position=a.Get(0,0);this.R=new b;void 0===c&&(c=null);void 0===d&&(d=null);c&&(this.position.SetV(c),this.R.SetM(d))};Box2D.Common.Math.b2Transform=
c;c.prototype.Initialize=function(a,b){this.position.SetV(a);this.R.SetM(b)};c.prototype.SetIdentity=function(){this.position.SetZero();this.R.SetIdentity()};c.prototype.Set=function(a){this.position.SetV(a.position);this.R.SetM(a.R)};c.prototype.SetAngle=function(){return Math.atan2(this.R.col1.y,this.R.col1.x)};var d=function(){};Box2D.Common.Math.b2Math=d;d.IsValid=function(a){void 0===a&&(a=0);return isFinite(a)};d.Dot=function(a,b){return a.x*b.x+a.y*b.y};d.CrossVV=function(a,b){return a.x*b.y-
a.y*b.x};d.CrossVF=function(b,c){void 0===c&&(c=0);return a.Get(c*b.y,-c*b.x)};d.CrossFV=function(b,c){void 0===b&&(b=0);return a.Get(-b*c.y,b*c.x)};d.MulMV=function(b,c){return a.Get(b.col1.x*c.x+b.col2.x*c.y,b.col1.y*c.x+b.col2.y*c.y)};d.MulTMV=function(b,c){return a.Get(d.Dot(c,b.col1),d.Dot(c,b.col2))};d.MulX=function(a,b){var c=d.MulMV(a.R,b);c.x+=a.position.x;c.y+=a.position.y;return c};d.MulXT=function(a,b){var c=d.SubtractVV(b,a.position),e=c.x*a.R.col1.x+c.y*a.R.col1.y;c.y=c.x*a.R.col2.x+
c.y*a.R.col2.y;c.x=e;return c};d.AddVV=function(b,c){return a.Get(b.x+c.x,b.y+c.y)};d.SubtractVV=function(b,c){return a.Get(b.x-c.x,b.y-c.y)};d.Distance=function(a,b){var c=a.x-b.x,d=a.y-b.y;return Math.sqrt(c*c+d*d)};d.DistanceSquared=function(a,b){var c=a.x-b.x,d=a.y-b.y;return c*c+d*d};d.MulFV=function(b,c){void 0===b&&(b=0);return a.Get(b*c.x,b*c.y)};d.AddMM=function(a,c){return b.FromVV(d.AddVV(a.col1,c.col1),d.AddVV(a.col2,c.col2))};d.MulMM=function(a,c){return b.FromVV(d.MulMV(a,c.col1),d.MulMV(a,
c.col2))};d.MulTMM=function(c,e){var g=a.Get(d.Dot(c.col1,e.col1),d.Dot(c.col2,e.col1)),h=a.Get(d.Dot(c.col1,e.col2),d.Dot(c.col2,e.col2));return b.FromVV(g,h)};d.Abs=function(a){void 0===a&&(a=0);return 0<a?a:-a};d.AbsV=function(b){return a.Get(d.Abs(b.x),d.Abs(b.y))};d.AbsM=function(a){return b.FromVV(d.AbsV(a.col1),d.AbsV(a.col2))};d.Min=function(a,b){void 0===a&&(a=0);void 0===b&&(b=0);return a<b?a:b};d.MinV=function(b,c){return a.Get(d.Min(b.x,c.x),d.Min(b.y,c.y))};d.Max=function(a,b){void 0===
a&&(a=0);void 0===b&&(b=0);return a>b?a:b};d.MaxV=function(b,c){return a.Get(d.Max(b.x,c.x),d.Max(b.y,c.y))};d.Clamp=function(a,b,c){void 0===a&&(a=0);void 0===b&&(b=0);void 0===c&&(c=0);return a<b?b:a>c?c:a};d.ClampV=function(a,b,c){return d.MaxV(b,d.MinV(a,c))};d.Swap=function(a,b){var c=a[0];a[0]=b[0];b[0]=c};d.Random=function(){return 2*Math.random()-1};d.RandomRange=function(a,b){void 0===a&&(a=0);void 0===b&&(b=0);var c=Math.random();return(b-a)*c+a};d.NextPowerOfTwo=function(a){void 0===a&&
(a=0);a|=a>>1&2147483647;a|=a>>2&1073741823;a|=a>>4&268435455;a|=a>>8&16777215;return(a|a>>16&65535)+1};d.IsPowerOfTwo=function(a){void 0===a&&(a=0);return 0<a&&0===(a&a-1)};d.b2Vec2_zero=new a(0,0);d.b2Mat22_identity=b.FromVV(new a(1,0),new a(0,1));d.b2Transform_identity=new c(d.b2Vec2_zero,d.b2Mat22_identity);var e=function(){this.e_aabbBit=4;this.e_centerOfMassBit=16;this.e_controllerBit=32;this.e_jointBit=2;this.e_pairBit=8;this.e_shapeBit=0};Box2D.Dynamics.b2DebugDraw=e;e.prototype.AppendFlags=
function(){};e.prototype.ClearFlags=function(){};e.prototype.DrawCircle=function(){};e.prototype.DrawPolygon=function(){};e.prototype.DrawSegment=function(){};e.prototype.DrawSolidCircle=function(){};e.prototype.DrawSolidPolygon=function(){};e.prototype.DrawTransform=function(){};e.prototype.GetAlpha=function(){};e.prototype.GetDrawScale=function(){};e.prototype.GetFillAlpha=function(){};e.prototype.GetFlags=function(){};e.prototype.GetLineThickness=function(){};e.prototype.GetSprite=function(){};
e.prototype.GetXFormScale=function(){};e.prototype.SetAlpha=function(){};e.prototype.SetDrawScale=function(){};e.prototype.SetFillAlpha=function(){};e.prototype.SetFlags=function(){};e.prototype.SetLineThickness=function(){};e.prototype.SetSprite=function(){};e.prototype.SetXFormScale=function(){};Box2D.Dynamics.b2BodyDef=function(){this.position=a.Get(0,0);this.linearVelocity=a.Get(0,0);this.userData=null;this.angle=0;this.linearVelocity.Set(0,0);this.angularDamping=this.linearDamping=this.angularVelocity=
0;this.awake=this.allowSleep=!0;this.bullet=this.fixedRotation=!1;this.type=g.b2_staticBody;this.active=!0;this.inertiaScale=1};var h=function(b,c,d,e){this.m_body=b;this.m_userData=c;this.m_fixtureID=d;this.m_shape={};this.m_shape.m_centroid=a.Get(0,0);this.m_isSensor=!1;this.m_density=e.density;this.m_friction=e.friction;this.m_restitution=e.restitution;this.m_isSensor=e.isSensor};Box2D.Dynamics.b2Fixture=h;h.prototype.GetBody=function(){return this.m_body};h.prototype.GetShape=function(){console.log("fixture.GetShape not yet supported in CocoonJS Box2D binding");
return null};h.prototype.GetUserData=function(){return this.m_userData};h.prototype.SetSensor=function(a){this.m_isSensor=a;window.ext.IDTK_SRV_BOX2D.makeCall("setSensor",this.m_body.m_world.m_worldID,this.m_fixtureID,this.m_isSensor)};h.prototype.IsSensor=function(){return this.m_isSensor};h.prototype.SetDensity=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setDensity",this.m_body.m_world.m_worldID,this.m_fixtureID,a);this.m_density=a};h.prototype.SetFriction=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setFriction",
this.m_body.m_world.m_worldID,this.m_fixtureID,a);this.m_friction=a};h.prototype.SetRestitution=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setRestitution",this.m_body.m_world.m_worldID,this.m_fixtureID,a);this.m_restitution=a};h.prototype.GetDensity=function(){return this.m_density};h.prototype.GetFriction=function(){return this.m_friction};h.prototype.GetRestitution=function(){return this.m_restitution};var g=function(a,d){var e=a.userData;a.userData=null;this.m_world=d;this.m_xf=new c(a.position,
b.FromAngle(a.angle));this.m_fixtures=[];this.m_active=a.active;a.type===g.b2_staticBody&&(a.density=0);this.m_bodyID=window.ext.IDTK_SRV_BOX2D.makeCall("createBody",d.m_worldID,a);this.m_userData=e;a.userData=e};Box2D.Dynamics.b2Body=g;g.prototype.CreateFixture=function(a){var b=a.userData;a.userData=null;var c=window.ext.IDTK_SRV_BOX2D.makeCall("createFixture",this.m_world.m_worldID,this.m_bodyID,a);a.userData=b;a=new h(this,b,c,a);this.m_world.m_fixturesList[c]=a;this.m_fixtures.push(a);return a};
g.prototype.GetFixtureList=function(){return 0===this.m_fixtures.length?null:this.m_fixtures[0]};g.prototype.DestroyFixture=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("deleteFixture",this.m_world.m_worldID,a.m_fixtureID);delete this.m_world.m_fixturesList[a.m_fixtureID]};g.prototype.SetPositionAndAngle=function(a,b){window.ext.IDTK_SRV_BOX2D.makeCall("setBodyTransform",this.m_world.m_worldID,this.m_bodyID,a.x,a.y,b);this.m_xf.R.Set(b);this.m_xf.position.SetV(a)};g.prototype.GetPosition=function(){return this.m_xf.position};
g.prototype.SetPosition=function(a){this.SetPositionAndAngle(a,this.GetAngle())};g.prototype.GetLinearVelocity=function(){var b=window.ext.IDTK_SRV_BOX2D.makeCall("getLinearVelocity",this.m_world.m_worldID,this.m_bodyID);return a.Get(b[0],b[1])};g.prototype.GetWorldCenter=function(){var b=window.ext.IDTK_SRV_BOX2D.makeCall("getWorldCenter",this.m_world.m_worldID,this.m_bodyID);return a.Get(b[0],b[1])};g.prototype.GetLocalCenter=function(){var b=window.ext.IDTK_SRV_BOX2D.makeCall("getLocalCenter",
this.m_world.m_worldID,this.m_bodyID);return a.Get(b[0],b[1])};g.prototype.GetLocalPoint=function(a){return d.MulXT(this.m_xf,a)};g.prototype.ApplyImpulse=function(a,b,c){window.ext.IDTK_SRV_BOX2D.makeCall("applyImpulse",this.m_world.m_worldID,this.m_bodyID,a.x,a.y,b.x,b.y,c)};g.prototype.GetMass=function(){return window.ext.IDTK_SRV_BOX2D.makeCall("getMass",this.m_world.m_worldID,this.m_bodyID)};g.prototype.IsAwake=function(){return window.ext.IDTK_SRV_BOX2D.makeCall("isAwake",this.m_world.m_worldID,
this.m_bodyID)};g.prototype.GetAngularVelocity=function(){return window.ext.IDTK_SRV_BOX2D.makeCall("getAngularVelocity",this.m_world.m_worldID,this.m_bodyID)};g.prototype.SetFixedRotation=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setFixedRotation",this.m_world.m_worldID,this.m_bodyID,a)};g.prototype.SetAwake=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setAwake",this.m_world.m_worldID,this.m_bodyID,a)};g.prototype.SetLinearVelocity=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setLinearVelocity",
this.m_world.m_worldID,this.m_bodyID,a.x,a.y)};g.prototype.ApplyForceToCenter=function(a,b){window.ext.IDTK_SRV_BOX2D.makeCall("applyForceToCenter",this.m_world.m_worldID,this.m_bodyID,a.x,a.y,b)};g.prototype.ApplyForce=function(a,b,c){window.ext.IDTK_SRV_BOX2D.makeCall("applyForce",this.m_world.m_worldID,this.m_bodyID,a.x,a.y,b.x,b.y,c)};g.prototype.ApplyTorque=function(a,b){window.ext.IDTK_SRV_BOX2D.makeCall("applyTorque",this.m_world.m_worldID,this.m_bodyID,a,b)};g.prototype.SetLinearDamping=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setLinearDamping",
this.m_world.m_worldID,this.m_bodyID,a)};g.prototype.SetAngularVelocity=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setAngularVelocity",this.m_world.m_worldID,this.m_bodyID,a)};g.prototype.SetType=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setType",this.m_world.m_worldID,this.m_bodyID,a)};g.prototype.SetActive=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setActive",this.m_world.m_worldID,this.m_bodyID,a);this.m_active=a};g.prototype.IsActive=function(){return this.m_active};g.prototype.GetAngle=
function(){return this.m_xf.R.GetAngle()};g.prototype.SetAngle=function(a){void 0===a&&(a=0);this.SetPositionAndAngle(this.GetPosition(),a)};g.prototype.GetContactList=function(){for(var a=window.ext.IDTK_SRV_BOX2D.makeCall("getObjectContacts",this.m_world.m_worldID,this.m_bodyID),b=[],c=0;c<a.length;c++)b.push(this.m_world.m_bodyList[a[c]]);return b};g.prototype.SetUserData=function(a){this.m_userData=a};g.prototype.GetUserData=function(){return this.m_userData};g.prototype.GetWorld=function(){return this.m_world};
Box2D.Dynamics.b2Body.b2_staticBody=0;Box2D.Dynamics.b2Body.b2_kinematicBody=1;Box2D.Dynamics.b2Body.b2_dynamicBody=2;var l=function(a,b,c){this.m_fixtureA=a;this.m_fixtureB=b;this.m_touching=c};Box2D.Dynamics.b2Contact=l;l.prototype.GetFixtureA=function(){return this.m_fixtureA};l.prototype.GetFixtureB=function(){return this.m_fixtureB};l.prototype.IsTouching=function(){return this.m_touching};e=function(){};Box2D.Dynamics.b2ContactListener=e;e.prototype.BeginContact=function(){};e.prototype.EndContact=
function(){};e.prototype.PreSolve=function(){};e.prototype.PostSolve=function(){};Box2D.Dynamics.b2ContactListener.b2_defaultListener=new e;Box2D.Dynamics.b2ContactFilter=function(){};e=function(a,b){this.m_bodyList=[];this.m_jointList=[];this.m_fixturesList=[];this.m_contactListener=null;this.m_jointsList=[];this.m_worldID=window.ext.IDTK_SRV_BOX2D.makeCall("createWorld",a.x,a.y,b)};Box2D.Dynamics.b2World=e;e.prototype.SetContactListener=function(a){this.m_contactListener=a};e.prototype.SetContactFilter=
function(a){var b=this;window.ext.IDTK_SRV_BOX2D.makeCall("setContactFilter",this.m_worldID,function(c,d){return a.ShouldCollide(b.m_fixturesList[c],b.m_fixturesList[d])})};e.prototype.CreateBody=function(a){a=new g(a,this);return this.m_bodyList[a.m_bodyID]=a};e.prototype.DestroyBody=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("deleteBody",this.m_worldID,a.m_bodyID);delete this.m_bodyList[a.m_bodyID];for(var b=0;b<a.m_fixtures.length;++b)delete this.m_fixturesList[a.m_fixtures[b].m_fixtureID]};
e.prototype.CreateJoint=function(a){if(a.bodyA.m_bodyID!==a.bodyB.m_bodyID){var b=a.bodyA,c=a.bodyB;a.bodyA=b.m_bodyID;a.bodyB=c.m_bodyID;var d="createDistanceJoint";a.type===k.e_revoluteJoint&&(d="createRevoluteJoint");var e=new k(a);e.m_jointID=window.ext.IDTK_SRV_BOX2D.makeCall(d,this.m_worldID,a);a.bodyA=b;a.bodyB=c;this.m_jointsList.push(e);return e}};e.prototype.DestroyJoint=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("destroyJoint",this.m_worldID,a.m_jointID)};e.prototype.GetJointList=function(){if(0===
this.m_jointsList.length)return null;for(var a=0;a<this.m_jointsList.length-1;++a)this.m_jointsList[a].next=this.m_jointsList[a+1];this.m_jointsList[this.m_jointsList.length-1].next=null;return this.m_jointsList[0]};e.prototype.SetContinuousPhysics=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setContinuous",this.m_worldID,a)};e.prototype.SetGravity=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setGravity",this.m_worldID,a.x,a.y)};e.prototype.Step=function(a,b,c){c=window.ext.IDTK_SRV_BOX2D.makeCall("step",
this.m_worldID,a,b,c);b=c[0];for(a=1;a<=4*b;a+=4){var d=this.m_bodyList[c[a+0]];if(null===d)break;d.m_xf.position.Set(c[a+1],c[a+2]);d.m_xf.R.Set(c[a+3])}if(null!==this.m_contactListener)for(c=window.ext.IDTK_SRV_BOX2D.makeCall("getLastContacts",this.m_worldID),b=c[0],a=1;a<=3*b;a+=3){var d=c[a+2],e=this.m_fixturesList[c[a+0]],g=this.m_fixturesList[c[a+1]];"undefined"===typeof e||"undefined"===typeof g?console.log("One of the fixtures in a contact DOESN'T EXIST!!"):this.m_contactListener.BeginContact(new l(e,
g,d))}};e.prototype.ClearForces=function(){window.ext.IDTK_SRV_BOX2D.makeCall("clearForces",this.m_worldID)};e.prototype.SetDebugDraw=function(){};e.prototype.DrawDebugData=function(){};Box2D.Collision.Shapes.b2CircleShape=function(a){this.radius=a;this.type="circle"};Box2D.Collision.Shapes.b2PolygonShape=function(){};Box2D.Collision.Shapes.b2PolygonShape.prototype.SetAsBox=function(a,b){this.type="box";this.width=a;this.height=b};Box2D.Collision.Shapes.b2PolygonShape.prototype.SetAsEdge=function(a,
b){this.type="edge";this.p1x=a.x;this.p1y=a.y;this.p2x=b.x;this.p2y=b.y};Box2D.Collision.Shapes.b2PolygonShape.prototype.SetAsArray=function(a,b){this.type="polygon";this.vertices=[];for(var c=0;c<b;c++)this.vertices.push(a[c].x),this.vertices.push(a[c].y)};Box2D.Dynamics.b2FixtureDef=function(){this.userData=this.shape=null;this.friction=0.2;this.density=this.restitution=0;this.isSensor=!1;this.filter={categoryBits:1,maskBits:65535,groupIndex:0}};var k=function(a){this.bodyA=a.bodyA;this.bodyB=a.bodyB;
this.userData=a.userData;this.type=a.type;this.next=null};Box2D.Dynamics.Joints.b2Joint=k;k.prototype.GetBodyA=function(){return this.bodyA};k.prototype.GetBodyB=function(){return this.bodyB};k.prototype.GetUserData=function(){return this.userData};k.prototype.GetType=function(){return this.type};k.prototype.GetNext=function(){return this.next};k.e_distanceJoint=0;k.e_revoluteJoint=1;Box2D.Dynamics.Joints.b2DistanceJointDef=function(b,c,d,e){this.type=k.e_distanceJoint;this.localAnchorA=a.Get(0,0);
this.localAnchorB=a.Get(0,0);this.userData=null;void 0!==b&&(this.bodyA=b);void 0!==c&&(this.bodyB=c);void 0!==d&&this.localAnchorA.SetV(d);void 0!==e&&this.localAnchorB.SetV(e);void 0!==d&&void 0!==e&&(b=e.x-d.x,d=e.y-d.y,this.length=Math.sqrt(b*b+d*d));this.dampingRatio=this.frequencyHz=0};e=function(b,c,d,e){this.type=k.e_revoluteJoint;this.localAnchorA=new a;this.localAnchorB=new a;this.userData=null;void 0!==b&&(this.bodyA=b);void 0!==c&&(this.bodyB=c);void 0!==d&&this.localAnchorA.SetV(d);void 0!==
e&&this.localAnchorB.SetV(e);this.motorSpeed=this.maxMotorTorque=this.upperAngle=this.lowerAngle=this.referenceAngle=0;this.enableMotor=this.enableLimit=!1};e.prototype.Initialize=function(a,b,c){this.bodyA=a;this.bodyB=b;this.localAnchorA=this.bodyA.GetLocalPoint(c);this.localAnchorB=this.bodyB.GetLocalPoint(c);this.referenceAngle=this.bodyB.GetAngle()-this.bodyA.GetAngle()};Box2D.Dynamics.Joints.b2RevoluteJointDef=e}():console.log("The CocoonJS binding for Box2D has been ignored because ext.IDTK_SRV_BOX2D is not available");
else{Box2D.Collision.b2Collision={};Box2D.Collision.b2Distance={};Box2D.Common.b2Settings={};Box2D.Common.Math.b2Math={};Box2D.Consts={};Box2D.Dynamics.Contacts={};Box2D.Dynamics.Controllers={};Box2D.generateCallback=function(a,b){return function(){b.apply(a,arguments)}};Box2D.Consts.MIN_VALUE_SQUARED=Number.MIN_VALUE*Number.MIN_VALUE;Box2D.Common.b2Settings.b2MixFriction=function(a,b){return Math.sqrt(a*b)};Box2D.Common.b2Settings.b2MixRestitution=function(a,b){return a>b?a:b};Box2D.Common.b2Settings.VERSION=
"2.1alpha-illandril";Box2D.Common.b2Settings.USHRT_MAX=65535;Box2D.Common.b2Settings.b2_maxManifoldPoints=2;Box2D.Common.b2Settings.b2_aabbExtension=0.1;Box2D.Common.b2Settings.b2_aabbMultiplier=2;Box2D.Common.b2Settings.b2_polygonRadius=2*Box2D.Common.b2Settings.b2_linearSlop;Box2D.Common.b2Settings.b2_linearSlop=0.005;Box2D.Common.b2Settings.b2_angularSlop=2/180*Math.PI;Box2D.Common.b2Settings.b2_toiSlop=8*Box2D.Common.b2Settings.b2_linearSlop;Box2D.Common.b2Settings.b2_maxTOIContactsPerIsland=
32;Box2D.Common.b2Settings.b2_maxTOIJointsPerIsland=32;Box2D.Common.b2Settings.b2_velocityThreshold=1;Box2D.Common.b2Settings.b2_maxLinearCorrection=0.2;Box2D.Common.b2Settings.b2_maxAngularCorrection=8/180*Math.PI;Box2D.Common.b2Settings.b2_maxTranslation=2;Box2D.Common.b2Settings.b2_maxTranslationSquared=Box2D.Common.b2Settings.b2_maxTranslation*Box2D.Common.b2Settings.b2_maxTranslation;Box2D.Common.b2Settings.b2_maxRotation=0.5*Math.PI;Box2D.Common.b2Settings.b2_maxRotationSquared=Box2D.Common.b2Settings.b2_maxRotation*
Box2D.Common.b2Settings.b2_maxRotation;Box2D.Common.b2Settings.b2_contactBaumgarte=0.2;Box2D.Common.b2Settings.b2_timeToSleep=0.5;Box2D.Common.b2Settings.b2_linearSleepTolerance=0.01;Box2D.Common.b2Settings.b2_linearSleepToleranceSquared=Box2D.Common.b2Settings.b2_linearSleepTolerance*Box2D.Common.b2Settings.b2_linearSleepTolerance;Box2D.Common.b2Settings.b2_angularSleepTolerance=2/180*Math.PI;Box2D.Common.b2Settings.b2_angularSleepToleranceSquared=Box2D.Common.b2Settings.b2_angularSleepTolerance*
Box2D.Common.b2Settings.b2_angularSleepTolerance;Box2D.Common.b2Settings.MIN_VALUE_SQUARED=Number.MIN_VALUE*Number.MIN_VALUE;Box2D.Common.Math.b2Math.Dot=function(a,b){return a.x*b.x+a.y*b.y};Box2D.Common.Math.b2Math.CrossVV=function(a,b){return a.x*b.y-a.y*b.x};Box2D.Common.Math.b2Math.CrossVF=function(a,b){return Box2D.Common.Math.b2Vec2.Get(b*a.y,-b*a.x)};Box2D.Common.Math.b2Math.CrossFV=function(a,b){return Box2D.Common.Math.b2Vec2.Get(-a*b.y,a*b.x)};Box2D.Common.Math.b2Math.MulMV=function(a,
b){return Box2D.Common.Math.b2Vec2.Get(a.col1.x*b.x+a.col2.x*b.y,a.col1.y*b.x+a.col2.y*b.y)};Box2D.Common.Math.b2Math.MulTMV=function(a,b){return Box2D.Common.Math.b2Vec2.Get(Box2D.Common.Math.b2Math.Dot(b,a.col1),Box2D.Common.Math.b2Math.Dot(b,a.col2))};Box2D.Common.Math.b2Math.MulX=function(a,b){var c=Box2D.Common.Math.b2Math.MulMV(a.R,b);c.x+=a.position.x;c.y+=a.position.y;return c};Box2D.Common.Math.b2Math.MulXT=function(a,b){var c=Box2D.Common.Math.b2Math.SubtractVV(b,a.position),d=c.x*a.R.col1.x+
c.y*a.R.col1.y;c.y=c.x*a.R.col2.x+c.y*a.R.col2.y;c.x=d;return c};Box2D.Common.Math.b2Math.AddVV=function(a,b){return Box2D.Common.Math.b2Vec2.Get(a.x+b.x,a.y+b.y)};Box2D.Common.Math.b2Math.SubtractVV=function(a,b){return Box2D.Common.Math.b2Vec2.Get(a.x-b.x,a.y-b.y)};Box2D.Common.Math.b2Math.Distance=function(a,b){return Math.sqrt(Box2D.Common.Math.b2Math.DistanceSquared(a,b))};Box2D.Common.Math.b2Math.DistanceSquared=function(a,b){var c=a.x-b.x,d=a.y-b.y;return c*c+d*d};Box2D.Common.Math.b2Math.MulFV=
function(a,b){return Box2D.Common.Math.b2Vec2.Get(a*b.x,a*b.y)};Box2D.Common.Math.b2Math.AddMM=function(a,b){return Box2D.Common.Math.b2Mat22.FromVV(Box2D.Common.Math.b2Math.AddVV(a.col1,b.col1),Box2D.Common.Math.b2Math.AddVV(a.col2,b.col2))};Box2D.Common.Math.b2Math.MulMM=function(a,b){return Box2D.Common.Math.b2Mat22.FromVV(Box2D.Common.Math.b2Math.MulMV(a,b.col1),Box2D.Common.Math.b2Math.MulMV(a,b.col2))};Box2D.Common.Math.b2Math.MulTMM=function(a,b){var c=Box2D.Common.Math.b2Vec2.Get(Box2D.Common.Math.b2Math.Dot(a.col1,
b.col1),Box2D.Common.Math.b2Math.Dot(a.col2,b.col1)),d=Box2D.Common.Math.b2Vec2.Get(Box2D.Common.Math.b2Math.Dot(a.col1,b.col2),Box2D.Common.Math.b2Math.Dot(a.col2,b.col2));return Box2D.Common.Math.b2Mat22.FromVV(c,d)};Box2D.Common.Math.b2Math.AbsV=function(a){return Box2D.Common.Math.b2Vec2.Get(Math.abs(a.x),Math.abs(a.y))};Box2D.Common.Math.b2Math.AbsM=function(a){return Box2D.Common.Math.b2Mat22.FromVV(Box2D.Common.Math.b2Math.AbsV(a.col1),Box2D.Common.Math.b2Math.AbsV(a.col2))};Box2D.Common.Math.b2Math.Clamp=
function(a,b,c){return a<b?b:a>c?c:a};Box2D.Common.Math.b2Math.ClampV=function(a,b,c){var d=Box2D.Common.Math.b2Math.Clamp(a.x,b.x,c.x);a=Box2D.Common.Math.b2Math.Clamp(a.y,b.y,c.y);return Box2D.Common.Math.b2Vec2.Get(d,a)};Box2D.Common.Math.b2Mat22=function(){this.col1=Box2D.Common.Math.b2Vec2.Get(0,0);this.col2=Box2D.Common.Math.b2Vec2.Get(0,0);this.SetIdentity()};Box2D.Common.Math.b2Mat22.FromAngle=function(a){var b=new Box2D.Common.Math.b2Mat22;b.Set(a);return b};Box2D.Common.Math.b2Mat22.FromVV=
function(a,b){var c=new Box2D.Common.Math.b2Mat22;c.SetVV(a,b);return c};Box2D.Common.Math.b2Mat22.prototype.Set=function(a){var b=Math.cos(a);a=Math.sin(a);this.col1.Set(b,a);this.col2.Set(-a,b)};Box2D.Common.Math.b2Mat22.prototype.SetVV=function(a,b){this.col1.SetV(a);this.col2.SetV(b)};Box2D.Common.Math.b2Mat22.prototype.Copy=function(){var a=new Box2D.Common.Math.b2Mat22;a.SetM(this);return a};Box2D.Common.Math.b2Mat22.prototype.SetM=function(a){this.col1.SetV(a.col1);this.col2.SetV(a.col2)};
Box2D.Common.Math.b2Mat22.prototype.AddM=function(a){this.col1.Add(a.col1);this.col2.Add(a.col2)};Box2D.Common.Math.b2Mat22.prototype.SetIdentity=function(){this.col1.Set(1,0);this.col2.Set(0,1)};Box2D.Common.Math.b2Mat22.prototype.SetZero=function(){this.col1.Set(0,0);this.col2.Set(0,0)};Box2D.Common.Math.b2Mat22.prototype.GetAngle=function(){return Math.atan2(this.col1.y,this.col1.x)};Box2D.Common.Math.b2Mat22.prototype.GetInverse=function(a){var b=this.col1.x*this.col2.y-this.col2.x*this.col1.y;
0!==b&&(b=1/b);a.col1.x=b*this.col2.y;a.col2.x=-b*this.col2.x;a.col1.y=-b*this.col1.y;a.col2.y=b*this.col1.x;return a};Box2D.Common.Math.b2Mat22.prototype.Solve=function(a,b,c){var d=this.col1.x*this.col2.y-this.col2.x*this.col1.y;0!==d&&(d=1/d);a.x=d*(this.col2.y*b-this.col2.x*c);a.y=d*(this.col1.x*c-this.col1.y*b);return a};Box2D.Common.Math.b2Mat22.prototype.Abs=function(){this.col1.Abs();this.col2.Abs()};Box2D.Common.Math.b2Mat33=function(a,b,c){this.col1=new Box2D.Common.Math.b2Vec3(0,0,0);this.col2=
new Box2D.Common.Math.b2Vec3(0,0,0);this.col3=new Box2D.Common.Math.b2Vec3(0,0,0);a&&this.col1.SetV(a);b&&this.col2.SetV(b);c&&this.col3.SetV(c)};Box2D.Common.Math.b2Mat33.prototype.SetVVV=function(a,b,c){this.col1.SetV(a);this.col2.SetV(b);this.col3.SetV(c)};Box2D.Common.Math.b2Mat33.prototype.Copy=function(){return new Box2D.Common.Math.b2Mat33(this.col1,this.col2,this.col3)};Box2D.Common.Math.b2Mat33.prototype.SetM=function(a){this.col1.SetV(a.col1);this.col2.SetV(a.col2);this.col3.SetV(a.col3)};
Box2D.Common.Math.b2Mat33.prototype.AddM=function(a){this.col1.x+=a.col1.x;this.col1.y+=a.col1.y;this.col1.z+=a.col1.z;this.col2.x+=a.col2.x;this.col2.y+=a.col2.y;this.col2.z+=a.col2.z;this.col3.x+=a.col3.x;this.col3.y+=a.col3.y;this.col3.z+=a.col3.z};Box2D.Common.Math.b2Mat33.prototype.SetIdentity=function(){this.col1.Set(1,0,0);this.col2.Set(0,1,0);this.col3.Set(0,0,1)};Box2D.Common.Math.b2Mat33.prototype.SetZero=function(){this.col1.Set(0,0,0);this.col2.Set(0,0,0);this.col3.Set(0,0,0)};Box2D.Common.Math.b2Mat33.prototype.Solve22=
function(a,b,c){var d=this.col1.x,e=this.col2.x,h=this.col1.y,g=this.col2.y,l=d*g-e*h;0!=l&&(l=1/l);a.x=l*(g*b-e*c);a.y=l*(d*c-h*b);return a};Box2D.Common.Math.b2Mat33.prototype.Solve33=function(a,b,c,d){var e=this.col1.x,h=this.col1.y,g=this.col1.z,l=this.col2.x,k=this.col2.y,f=this.col2.z,m=this.col3.x,n=this.col3.y,p=this.col3.z,q=e*(k*p-f*n)+h*(f*m-l*p)+g*(l*n-k*m);0!=q&&(q=1/q);a.x=q*(b*(k*p-f*n)+c*(f*m-l*p)+d*(l*n-k*m));a.y=q*(e*(c*p-d*n)+h*(d*m-b*p)+g*(b*n-c*m));a.z=q*(e*(k*d-f*c)+h*(f*b-l*
d)+g*(l*c-k*b));return a};Box2D.Common.Math.b2Sweep=function(){this.localCenter=Box2D.Common.Math.b2Vec2.Get(0,0);this.c0=Box2D.Common.Math.b2Vec2.Get(0,0);this.c=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Common.Math.b2Sweep.prototype.Set=function(a){this.localCenter.SetV(a.localCenter);this.c0.SetV(a.c0);this.c.SetV(a.c);this.a0=a.a0;this.a=a.a;this.t0=a.t0};Box2D.Common.Math.b2Sweep.prototype.Copy=function(){var a=new Box2D.Common.Math.b2Sweep;a.localCenter.SetV(this.localCenter);a.c0.SetV(this.c0);
a.c.SetV(this.c);a.a0=this.a0;a.a=this.a;a.t0=this.t0;return a};Box2D.Common.Math.b2Sweep.prototype.GetTransform=function(a,b){void 0===b&&(b=0);a.position.x=(1-b)*this.c0.x+b*this.c.x;a.position.y=(1-b)*this.c0.y+b*this.c.y;a.R.Set((1-b)*this.a0+b*this.a);var c=a.R;a.position.x-=c.col1.x*this.localCenter.x+c.col2.x*this.localCenter.y;a.position.y-=c.col1.y*this.localCenter.x+c.col2.y*this.localCenter.y};Box2D.Common.Math.b2Sweep.prototype.Advance=function(a){void 0===a&&(a=0);if(this.t0<a&&1-this.t0>
Number.MIN_VALUE){var b=(a-this.t0)/(1-this.t0);this.c0.x=(1-b)*this.c0.x+b*this.c.x;this.c0.y=(1-b)*this.c0.y+b*this.c.y;this.a0=(1-b)*this.a0+b*this.a;this.t0=a}};Box2D.Common.Math.b2Transform=function(a,b){this.position=Box2D.Common.Math.b2Vec2.Get(0,0);this.R=new Box2D.Common.Math.b2Mat22;a&&this.position.SetV(a);b&&this.R.SetM(b)};Box2D.Common.Math.b2Transform.prototype.Initialize=function(a,b){this.position.SetV(a);this.R.SetM(b)};Box2D.Common.Math.b2Transform.prototype.SetIdentity=function(){this.position.SetZero();
this.R.SetIdentity()};Box2D.Common.Math.b2Transform.prototype.Set=function(a){this.position.SetV(a.position);this.R.SetM(a.R)};Box2D.Common.Math.b2Transform.prototype.GetAngle=function(){return Math.atan2(this.R.col1.y,this.R.col1.x)};Box2D.Common.Math.b2Vec2=function(a,b){this.x=a;this.y=b};Box2D.Common.Math.b2Vec2._freeCache=[];Box2D.Common.Math.b2Vec2.Get=function(a,b){if(0<Box2D.Common.Math.b2Vec2._freeCache.length){var c=Box2D.Common.Math.b2Vec2._freeCache.pop();c.Set(a,b);return c}return new Box2D.Common.Math.b2Vec2(a,
b)};Box2D.Common.Math.b2Vec2.Free=function(a){Box2D.Common.Math.b2Vec2._freeCache.push(a)};Box2D.Common.Math.b2Vec2.prototype.SetZero=function(){this.y=this.x=0};Box2D.Common.Math.b2Vec2.prototype.Set=function(a,b){this.x=a;this.y=b};Box2D.Common.Math.b2Vec2.prototype.SetV=function(a){this.x=a.x;this.y=a.y};Box2D.Common.Math.b2Vec2.prototype.GetNegative=function(){return Box2D.Common.Math.b2Vec2.Get(-this.x,-this.y)};Box2D.Common.Math.b2Vec2.prototype.NegativeSelf=function(){this.x=-this.x;this.y=
-this.y};Box2D.Common.Math.b2Vec2.prototype.Copy=function(){return Box2D.Common.Math.b2Vec2.Get(this.x,this.y)};Box2D.Common.Math.b2Vec2.prototype.Add=function(a){this.x+=a.x;this.y+=a.y};Box2D.Common.Math.b2Vec2.prototype.Subtract=function(a){this.x-=a.x;this.y-=a.y};Box2D.Common.Math.b2Vec2.prototype.Multiply=function(a){this.x*=a;this.y*=a};Box2D.Common.Math.b2Vec2.prototype.MulM=function(a){var b=this.x;this.x=a.col1.x*b+a.col2.x*this.y;this.y=a.col1.y*b+a.col2.y*this.y};Box2D.Common.Math.b2Vec2.prototype.MulTM=
function(a){var b=this.x*a.col1.x+this.y*a.col1.y;this.y=this.x*a.col2.x+this.y*a.col2.y;this.x=b};Box2D.Common.Math.b2Vec2.prototype.CrossVF=function(a){var b=this.x;this.x=a*this.y;this.y=-a*b};Box2D.Common.Math.b2Vec2.prototype.CrossFV=function(a){var b=this.x;this.x=-a*this.y;this.y=a*b};Box2D.Common.Math.b2Vec2.prototype.MinV=function(a){this.x=Math.min(this.x,a.x);this.y=Math.min(this.y,a.y)};Box2D.Common.Math.b2Vec2.prototype.MaxV=function(a){this.x=Math.max(this.x,a.x);this.y=Math.max(this.y,
a.y)};Box2D.Common.Math.b2Vec2.prototype.Abs=function(){this.x=Math.abs(this.x);this.y=Math.abs(this.y)};Box2D.Common.Math.b2Vec2.prototype.Length=function(){return Math.sqrt(this.LengthSquared())};Box2D.Common.Math.b2Vec2.prototype.LengthSquared=function(){return this.x*this.x+this.y*this.y};Box2D.Common.Math.b2Vec2.prototype.Normalize=function(){var a=this.Length();if(a<Number.MIN_VALUE)return 0;var b=1/a;this.x*=b;this.y*=b;return a};Box2D.Common.Math.b2Vec2.prototype.IsValid=function(){return isFinite(this.x)&&
isFinite(this.y)};Box2D.Common.Math.b2Vec3=function(a,b,c){this.x=a;this.y=b;this.z=c};Box2D.Common.Math.b2Vec3.prototype.SetZero=function(){this.z=this.y=this.x=0};Box2D.Common.Math.b2Vec3.prototype.Set=function(a,b,c){this.x=a;this.y=b;this.z=c};Box2D.Common.Math.b2Vec3.prototype.SetV=function(a){this.x=a.x;this.y=a.y;this.z=a.z};Box2D.Common.Math.b2Vec3.prototype.GetNegative=function(){return new Box2D.Common.Math.b2Vec3(-this.x,-this.y,-this.z)};Box2D.Common.Math.b2Vec3.prototype.NegativeSelf=
function(){this.x=-this.x;this.y=-this.y;this.z=-this.z};Box2D.Common.Math.b2Vec3.prototype.Copy=function(){return new Box2D.Common.Math.b2Vec3(this.x,this.y,this.z)};Box2D.Common.Math.b2Vec3.prototype.Add=function(a){this.x+=a.x;this.y+=a.y;this.z+=a.z};Box2D.Common.Math.b2Vec3.prototype.Subtract=function(a){this.x-=a.x;this.y-=a.y;this.z-=a.z};Box2D.Common.Math.b2Vec3.prototype.Multiply=function(a){this.x*=a;this.y*=a;this.z*=a};Box2D.Collision.Shapes.b2Shape=function(){this.m_radius=Box2D.Common.b2Settings.b2_linearSlop};
Box2D.Collision.Shapes.b2Shape.prototype.GetTypeName=function(){};Box2D.Collision.Shapes.b2Shape.prototype.Copy=function(){};Box2D.Collision.Shapes.b2Shape.prototype.Set=function(a){this.m_radius=a.m_radius};Box2D.Collision.Shapes.b2Shape.prototype.TestPoint=function(){};Box2D.Collision.Shapes.b2Shape.prototype.RayCast=function(){};Box2D.Collision.Shapes.b2Shape.prototype.ComputeAABB=function(){};Box2D.Collision.Shapes.b2Shape.prototype.ComputeMass=function(){};Box2D.Collision.Shapes.b2Shape.prototype.ComputeSubmergedArea=
function(){};Box2D.Collision.Shapes.b2Shape.prototype.SetDistanceProxy=function(){};Box2D.Collision.Shapes.b2Shape.TestOverlap=function(a,b,c,d){var e=new Box2D.Collision.b2DistanceInput;e.proxyA=new Box2D.Collision.b2DistanceProxy;e.proxyA.Set(a);e.proxyB=new Box2D.Collision.b2DistanceProxy;e.proxyB.Set(c);e.transformA=b;e.transformB=d;e.useRadii=!0;a=new Box2D.Collision.b2SimplexCache;a.count=0;b=new Box2D.Collision.b2DistanceOutput;Box2D.Collision.b2Distance.Distance(b,a,e);return b.distance<10*
Number.MIN_VALUE};Box2D.Collision.Shapes.b2Shape.e_startsInsideCollide=-1;Box2D.Collision.Shapes.b2Shape.e_missCollide=0;Box2D.Collision.Shapes.b2Shape.e_hitCollide=1;Box2D.Collision.Shapes.b2CircleShape=function(a){Box2D.Collision.Shapes.b2Shape.call(this);this.m_radius=a;this.m_radiusSquared=a*a;this.m_p=Box2D.Common.Math.b2Vec2.Get(0,0)};c2inherit(Box2D.Collision.Shapes.b2CircleShape,Box2D.Collision.Shapes.b2Shape);Box2D.Collision.Shapes.b2CircleShape.prototype.GetTypeName=function(){return Box2D.Collision.Shapes.b2CircleShape.NAME};
Box2D.Collision.Shapes.b2CircleShape.prototype.Copy=function(){var a=new Box2D.Collision.Shapes.b2CircleShape(this.m_radius);a.Set(this);return a};Box2D.Collision.Shapes.b2CircleShape.prototype.Set=function(a){Box2D.Collision.Shapes.b2Shape.prototype.Set.call(this,a);a instanceof Box2D.Collision.Shapes.b2CircleShape&&this.m_p.SetV(a.m_p)};Box2D.Collision.Shapes.b2CircleShape.prototype.TestPoint=function(a,b){var c=b.x-(a.position.x+(a.R.col1.x*this.m_p.x+a.R.col2.x*this.m_p.y)),d=b.y-(a.position.y+
(a.R.col1.y*this.m_p.x+a.R.col2.y*this.m_p.y));return c*c+d*d<=this.m_radiusSquared};Box2D.Collision.Shapes.b2CircleShape.prototype.RayCast=function(a,b,c){var d=c.R,e=b.p1.x-(c.position.x+(d.col1.x*this.m_p.x+d.col2.x*this.m_p.y));c=b.p1.y-(c.position.y+(d.col1.y*this.m_p.x+d.col2.y*this.m_p.y));var d=b.p2.x-b.p1.x,h=b.p2.y-b.p1.y,g=e*d+c*h,l=d*d+h*h,k=g*g-l*(e*e+c*c-this.m_radiusSquared);if(0>k||l<Number.MIN_VALUE)return!1;g=-(g+Math.sqrt(k));return 0<=g&&g<=b.maxFraction*l?(g/=l,a.fraction=g,a.normal.x=
e+g*d,a.normal.y=c+g*h,a.normal.Normalize(),!0):!1};Box2D.Collision.Shapes.b2CircleShape.prototype.ComputeAABB=function(a,b){var c=b.R,d=b.position.x+(c.col1.x*this.m_p.x+c.col2.x*this.m_p.y),c=b.position.y+(c.col1.y*this.m_p.x+c.col2.y*this.m_p.y);a.lowerBound_.Set(d-this.m_radius,c-this.m_radius);a.upperBound_.Set(d+this.m_radius,c+this.m_radius)};Box2D.Collision.Shapes.b2CircleShape.prototype.ComputeMass=function(a,b){a.mass=b*Math.PI*this.m_radiusSquared;a.center.SetV(this.m_p);a.I=a.mass*(0.5*
this.m_radiusSquared+(this.m_p.x*this.m_p.x+this.m_p.y*this.m_p.y))};Box2D.Collision.Shapes.b2CircleShape.prototype.ComputeSubmergedArea=function(a,b,c,d){c=Box2D.Common.Math.b2Math.MulX(c,this.m_p);var e=-(Box2D.Common.Math.b2Math.Dot(a,c)-b);if(e<-this.m_radius+Number.MIN_VALUE)return 0;if(e>this.m_radius)return d.SetV(c),Math.PI*this.m_radiusSquared;b=e*e;e=this.m_radiusSquared*(Math.asin(e/this.m_radius)+Math.PI/2)+e*Math.sqrt(this.m_radiusSquared-b);b=-2/3*Math.pow(this.m_radiusSquared-b,1.5)/
e;d.x=c.x+a.x*b;d.y=c.y+a.y*b;return e};Box2D.Collision.Shapes.b2CircleShape.prototype.SetDistanceProxy=function(a){a.m_vertices=[this.m_p];a.m_count=1;a.m_radius=this.m_radius};Box2D.Collision.Shapes.b2CircleShape.prototype.GetLocalPosition=function(){return this.m_p};Box2D.Collision.Shapes.b2CircleShape.prototype.SetLocalPosition=function(a){this.m_p.SetV(a)};Box2D.Collision.Shapes.b2CircleShape.prototype.GetRadius=function(){return this.m_radius};Box2D.Collision.Shapes.b2CircleShape.prototype.SetRadius=
function(a){this.m_radius=a;this.m_radiusSquared=a*a};Box2D.Collision.Shapes.b2CircleShape.NAME="b2CircleShape";Box2D.Collision.Shapes.b2EdgeChainDef=function(){this.vertexCount=0;this.isALoop=!0;this.vertices=[]};Box2D.Collision.Shapes.b2EdgeShape=function(a,b){Box2D.Collision.Shapes.b2Shape.call(this);this.m_nextEdge=this.m_prevEdge=null;this.m_v1=a;this.m_v2=b;this.m_direction=Box2D.Common.Math.b2Vec2.Get(this.m_v2.x-this.m_v1.x,this.m_v2.y-this.m_v1.y);this.m_length=this.m_direction.Normalize();
this.m_normal=Box2D.Common.Math.b2Vec2.Get(this.m_direction.y,-this.m_direction.x);this.m_coreV1=Box2D.Common.Math.b2Vec2.Get(-Box2D.Common.b2Settings.b2_toiSlop*(this.m_normal.x-this.m_direction.x)+this.m_v1.x,-Box2D.Common.b2Settings.b2_toiSlop*(this.m_normal.y-this.m_direction.y)+this.m_v1.y);this.m_coreV2=Box2D.Common.Math.b2Vec2.Get(-Box2D.Common.b2Settings.b2_toiSlop*(this.m_normal.x+this.m_direction.x)+this.m_v2.x,-Box2D.Common.b2Settings.b2_toiSlop*(this.m_normal.y+this.m_direction.y)+this.m_v2.y);
this.m_cornerDir1=this.m_normal;this.m_cornerDir2=Box2D.Common.Math.b2Vec2.Get(-this.m_normal.x,-this.m_normal.y);this.m_cornerConvex2=this.m_cornerConvex1=!1};c2inherit(Box2D.Collision.Shapes.b2EdgeShape,Box2D.Collision.Shapes.b2Shape);Box2D.Collision.Shapes.b2EdgeShape.prototype.GetTypeName=function(){return Box2D.Collision.Shapes.b2EdgeShape.NAME};Box2D.Collision.Shapes.b2EdgeShape.prototype.TestPoint=function(a,b){return!1};Box2D.Collision.Shapes.b2EdgeShape.prototype.RayCast=function(a,b,c){var d=
b.p2.x-b.p1.x,e=b.p2.y-b.p1.y,h=c.R,g=c.position.x+(h.col1.x*this.m_v1.x+h.col2.x*this.m_v1.y),l=c.position.y+(h.col1.y*this.m_v1.x+h.col2.y*this.m_v1.y),k=c.position.y+(h.col1.y*this.m_v2.x+h.col2.y*this.m_v2.y)-l;c=-(c.position.x+(h.col1.x*this.m_v2.x+h.col2.x*this.m_v2.y)-g);var h=100*Number.MIN_VALUE,f=-(d*k+e*c);if(f>h){var g=b.p1.x-g,m=b.p1.y-l,l=g*k+m*c;if(0<=l&&l<=b.maxFraction*f&&(b=-d*m+e*g,-h*f<=b&&b<=f*(1+h)))return a.fraction=l/f,b=Math.sqrt(k*k+c*c),a.normal.x=k/b,a.normal.y=c/b,!0}return!1};
Box2D.Collision.Shapes.b2EdgeShape.prototype.ComputeAABB=function(a,b){var c=b.R,d=b.position.x+(c.col1.x*this.m_v1.x+c.col2.x*this.m_v1.y),e=b.position.y+(c.col1.y*this.m_v1.x+c.col2.y*this.m_v1.y),h=b.position.x+(c.col1.x*this.m_v2.x+c.col2.x*this.m_v2.y),c=b.position.y+(c.col1.y*this.m_v2.x+c.col2.y*this.m_v2.y);d<h?(a.lowerBound_.x=d,a.upperBound_.x=h):(a.lowerBound_.x=h,a.upperBound_.x=d);e<c?(a.lowerBound_.y=e,a.upperBound_.y=c):(a.lowerBound_.y=c,a.upperBound_.y=e)};Box2D.Collision.Shapes.b2EdgeShape.prototype.ComputeMass=
function(a,b){a.mass=0;a.center.SetV(this.m_v1);a.I=0};Box2D.Collision.Shapes.b2EdgeShape.prototype.ComputeSubmergedArea=function(a,b,c,d){void 0===b&&(b=0);var e=Box2D.Common.Math.b2Vec2.Get(a.x*b,a.y*b),h=Box2D.Common.Math.b2Math.MulX(c,this.m_v1);c=Box2D.Common.Math.b2Math.MulX(c,this.m_v2);var g=Box2D.Common.Math.b2Math.Dot(a,h)-b;a=Box2D.Common.Math.b2Math.Dot(a,c)-b;if(0<g){if(0<a)return 0;h.x=-a/(g-a)*h.x+g/(g-a)*c.x;h.y=-a/(g-a)*h.y+g/(g-a)*c.y}else 0<a&&(c.x=-a/(g-a)*h.x+g/(g-a)*c.x,c.y=
-a/(g-a)*h.y+g/(g-a)*c.y);d.x=(e.x+h.x+c.x)/3;d.y=(e.y+h.y+c.y)/3;return 0.5*((h.x-e.x)*(c.y-e.y)-(h.y-e.y)*(c.x-e.x))};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetLength=function(){return this.m_length};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetVertex1=function(){return this.m_v1};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetVertex2=function(){return this.m_v2};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetCoreVertex1=function(){return this.m_coreV1};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetCoreVertex2=
function(){return this.m_coreV2};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetNormalVector=function(){return this.m_normal};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetDirectionVector=function(){return this.m_direction};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetCorner1Vector=function(){return this.m_cornerDir1};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetCorner2Vector=function(){return this.m_cornerDir2};Box2D.Collision.Shapes.b2EdgeShape.prototype.Corner1IsConvex=function(){return this.m_cornerConvex1};
Box2D.Collision.Shapes.b2EdgeShape.prototype.Corner2IsConvex=function(){return this.m_cornerConvex2};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetFirstVertex=function(a){var b=a.R;return Box2D.Common.Math.b2Vec2.Get(a.position.x+(b.col1.x*this.m_coreV1.x+b.col2.x*this.m_coreV1.y),a.position.y+(b.col1.y*this.m_coreV1.x+b.col2.y*this.m_coreV1.y))};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetNextEdge=function(){return this.m_nextEdge};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetPrevEdge=function(){return this.m_prevEdge};
Box2D.Collision.Shapes.b2EdgeShape.prototype.Support=function(a,b,c){var d=a.R,e=a.position.x+(d.col1.x*this.m_coreV1.x+d.col2.x*this.m_coreV1.y),h=a.position.y+(d.col1.y*this.m_coreV1.x+d.col2.y*this.m_coreV1.y),g=a.position.x+(d.col1.x*this.m_coreV2.x+d.col2.x*this.m_coreV2.y);a=a.position.y+(d.col1.y*this.m_coreV2.x+d.col2.y*this.m_coreV2.y);return e*b+h*c>g*b+a*c?Box2D.Common.Math.b2Vec2.Get(e,h):Box2D.Common.Math.b2Vec2.Get(g,a)};Box2D.Collision.Shapes.b2EdgeShape.prototype.SetPrevEdge=function(a,
b,c,d){this.m_prevEdge=a;this.m_coreV1=b;this.m_cornerDir1=c;this.m_cornerConvex1=d};Box2D.Collision.Shapes.b2EdgeShape.prototype.SetNextEdge=function(a,b,c,d){this.m_nextEdge=a;this.m_coreV2=b;this.m_cornerDir2=c;this.m_cornerConvex2=d};Box2D.Collision.Shapes.b2EdgeShape.NAME="b2EdgeShape";Box2D.Collision.Shapes.b2MassData=function(){this.mass=0;this.center=Box2D.Common.Math.b2Vec2.Get(0,0);this.I=0};Box2D.Collision.Shapes.b2PolygonShape=function(){Box2D.Collision.Shapes.b2Shape.call(this);this.m_centroid=
Box2D.Common.Math.b2Vec2.Get(0,0);this.m_vertices=[];this.m_normals=[]};c2inherit(Box2D.Collision.Shapes.b2PolygonShape,Box2D.Collision.Shapes.b2Shape);Box2D.Collision.Shapes.b2PolygonShape.prototype.GetTypeName=function(){return Box2D.Collision.Shapes.b2PolygonShape.NAME};Box2D.Collision.Shapes.b2PolygonShape.prototype.Copy=function(){var a=new Box2D.Collision.Shapes.b2PolygonShape;a.Set(this);return a};Box2D.Collision.Shapes.b2PolygonShape.prototype.Set=function(a){Box2D.Collision.Shapes.b2Shape.prototype.Set.call(this,
a);if(a instanceof Box2D.Collision.Shapes.b2PolygonShape){this.m_centroid.SetV(a.m_centroid);this.m_vertexCount=a.m_vertexCount;this.Reserve(this.m_vertexCount);for(var b=0;b<this.m_vertexCount;b++)this.m_vertices[b].SetV(a.m_vertices[b]),this.m_normals[b].SetV(a.m_normals[b])}};Box2D.Collision.Shapes.b2PolygonShape.prototype.SetAsArray=function(a){this.SetAsVector(a)};Box2D.Collision.Shapes.b2PolygonShape.AsArray=function(a){var b=new Box2D.Collision.Shapes.b2PolygonShape;b.SetAsArray(a);return b};
Box2D.Collision.Shapes.b2PolygonShape.prototype.SetAsVector=function(a){var b=a.length;this.m_vertexCount=b;this.Reserve(b);for(b=b=0;b<this.m_vertexCount;b++)this.m_vertices[b].SetV(a[b]);for(b=0;b<this.m_vertexCount;++b)a=Box2D.Common.Math.b2Math.SubtractVV(this.m_vertices[b+1<this.m_vertexCount?b+1:0],this.m_vertices[b]),this.m_normals[b].SetV(Box2D.Common.Math.b2Math.CrossVF(a,1)),this.m_normals[b].Normalize();this.m_centroid=Box2D.Collision.Shapes.b2PolygonShape.ComputeCentroid(this.m_vertices,
this.m_vertexCount)};Box2D.Collision.Shapes.b2PolygonShape.AsVector=function(a){var b=new Box2D.Collision.Shapes.b2PolygonShape;b.SetAsVector(a);return b};Box2D.Collision.Shapes.b2PolygonShape.prototype.SetAsBox=function(a,b){this.m_vertexCount=4;this.Reserve(4);this.m_vertices[0].Set(-a,-b);this.m_vertices[1].Set(a,-b);this.m_vertices[2].Set(a,b);this.m_vertices[3].Set(-a,b);this.m_normals[0].Set(0,-1);this.m_normals[1].Set(1,0);this.m_normals[2].Set(0,1);this.m_normals[3].Set(-1,0);this.m_centroid.SetZero()};
Box2D.Collision.Shapes.b2PolygonShape.AsBox=function(a,b){var c=new Box2D.Collision.Shapes.b2PolygonShape;c.SetAsBox(a,b);return c};Box2D.Collision.Shapes.b2PolygonShape.prototype.SetAsOrientedBox=function(a,b,c,d){this.m_vertexCount=4;this.Reserve(4);this.m_vertices[0].Set(-a,-b);this.m_vertices[1].Set(a,-b);this.m_vertices[2].Set(a,b);this.m_vertices[3].Set(-a,b);this.m_normals[0].Set(0,-1);this.m_normals[1].Set(1,0);this.m_normals[2].Set(0,1);this.m_normals[3].Set(-1,0);this.m_centroid=c;a=new Box2D.Common.Math.b2Mat22;
a.Set(d);c=new Box2D.Common.Math.b2Transform(c,a);for(d=0;d<this.m_vertexCount;++d)this.m_vertices[d]=Box2D.Common.Math.b2Math.MulX(c,this.m_vertices[d]),this.m_normals[d]=Box2D.Common.Math.b2Math.MulMV(c.R,this.m_normals[d])};Box2D.Collision.Shapes.b2PolygonShape.AsOrientedBox=function(a,b,c,d){var e=new Box2D.Collision.Shapes.b2PolygonShape;e.SetAsOrientedBox(a,b,c,d);return e};Box2D.Collision.Shapes.b2PolygonShape.prototype.SetAsEdge=function(a,b){this.m_vertexCount=2;this.Reserve(2);this.m_vertices[0].SetV(a);
this.m_vertices[1].SetV(b);this.m_centroid.x=0.5*(a.x+b.x);this.m_centroid.y=0.5*(a.y+b.y);this.m_normals[0]=Box2D.Common.Math.b2Math.CrossVF(Box2D.Common.Math.b2Math.SubtractVV(b,a),1);this.m_normals[0].Normalize();this.m_normals[1].x=-this.m_normals[0].x;this.m_normals[1].y=-this.m_normals[0].y};Box2D.Collision.Shapes.b2PolygonShape.AsEdge=function(a,b){var c=new Box2D.Collision.Shapes.b2PolygonShape;c.SetAsEdge(a,b);return c};Box2D.Collision.Shapes.b2PolygonShape.prototype.TestPoint=function(a,
b){var c;c=a.R;for(var d=b.x-a.position.x,e=b.y-a.position.y,h=d*c.col1.x+e*c.col1.y,g=d*c.col2.x+e*c.col2.y,l=0;l<this.m_vertexCount;++l)if(c=this.m_vertices[l],d=h-c.x,e=g-c.y,c=this.m_normals[l],0<c.x*d+c.y*e)return!1;return!0};Box2D.Collision.Shapes.b2PolygonShape.prototype.RayCast=function(a,b,c){var d=0,e=b.maxFraction,h=0,g=0,l,k,h=b.p1.x-c.position.x,g=b.p1.y-c.position.y;l=c.R;var f=h*l.col1.x+g*l.col1.y,m=h*l.col2.x+g*l.col2.y,h=b.p2.x-c.position.x,g=b.p2.y-c.position.y;l=c.R;b=h*l.col1.x+
g*l.col1.y-f;l=h*l.col2.x+g*l.col2.y-m;for(var n=-1,p=0;p<this.m_vertexCount;++p){k=this.m_vertices[p];h=k.x-f;g=k.y-m;k=this.m_normals[p];h=k.x*h+k.y*g;g=k.x*b+k.y*l;if(0==g){if(0>h)return!1}else 0>g&&h<d*g?(d=h/g,n=p):0<g&&h<e*g&&(e=h/g);if(e<d-Number.MIN_VALUE)return!1}return 0<=n?(a.fraction=d,l=c.R,k=this.m_normals[n],a.normal.x=l.col1.x*k.x+l.col2.x*k.y,a.normal.y=l.col1.y*k.x+l.col2.y*k.y,!0):!1};Box2D.Collision.Shapes.b2PolygonShape.prototype.ComputeAABB=function(a,b){for(var c=b.R,d=this.m_vertices[0],
e=b.position.x+(c.col1.x*d.x+c.col2.x*d.y),h=b.position.y+(c.col1.y*d.x+c.col2.y*d.y),g=e,l=h,k=1;k<this.m_vertexCount;++k)var d=this.m_vertices[k],f=b.position.x+(c.col1.x*d.x+c.col2.x*d.y),d=b.position.y+(c.col1.y*d.x+c.col2.y*d.y),e=e<f?e:f,h=h<d?h:d,g=g>f?g:f,l=l>d?l:d;a.lowerBound_.x=e-this.m_radius;a.lowerBound_.y=h-this.m_radius;a.upperBound_.x=g+this.m_radius;a.upperBound_.y=l+this.m_radius};Box2D.Collision.Shapes.b2PolygonShape.prototype.ComputeMass=function(a,b){if(2==this.m_vertexCount)a.center.x=
0.5*(this.m_vertices[0].x+this.m_vertices[1].x),a.center.y=0.5*(this.m_vertices[0].y+this.m_vertices[1].y),a.mass=0,a.I=0;else{for(var c=0,d=0,e=0,h=0,g=1/3,l=0;l<this.m_vertexCount;++l)var k=this.m_vertices[l],f=l+1<this.m_vertexCount?this.m_vertices[l+1]:this.m_vertices[0],m=k.x-0,n=k.y-0,p=f.x-0,q=f.y-0,s=m*q-n*p,r=0.5*s,e=e+r,c=c+r*g*(0+k.x+f.x),d=d+r*g*(0+k.y+f.y),k=m,h=h+s*(g*(0.25*(k*k+p*k+p*p)+(0*k+0*p))+0+(g*(0.25*(n*n+q*n+q*q)+(0*n+0*q))+0));a.mass=b*e;a.center.Set(c*(1/e),d*(1/e));a.I=
b*h}};Box2D.Collision.Shapes.b2PolygonShape.prototype.ComputeSubmergedArea=function(a,b,c,d){var e=Box2D.Common.Math.b2Math.MulTMV(c.R,a),h=b-Box2D.Common.Math.b2Math.Dot(a,c.position),g=[],l=0,k=-1;b=-1;var f=!1;for(a=a=0;a<this.m_vertexCount;++a){g[a]=Box2D.Common.Math.b2Math.Dot(e,this.m_vertices[a])-h;var m=g[a]<-Number.MIN_VALUE;0<a&&(m?f||(k=a-1,l++):f&&(b=a-1,l++));f=m}switch(l){case 0:return f?(a=new Box2D.Collision.Shapes.b2MassData,this.ComputeMass(a,1),d.SetV(Box2D.Common.Math.b2Math.MulX(c,
a.center)),a.mass):0;case 1:-1==k?k=this.m_vertexCount-1:b=this.m_vertexCount-1}a=(k+1)%this.m_vertexCount;e=(b+1)%this.m_vertexCount;h=(0-g[k])/(g[a]-g[k]);g=(0-g[b])/(g[e]-g[b]);k=Box2D.Common.Math.b2Vec2.Get(this.m_vertices[k].x*(1-h)+this.m_vertices[a].x*h,this.m_vertices[k].y*(1-h)+this.m_vertices[a].y*h);b=Box2D.Common.Math.b2Vec2.Get(this.m_vertices[b].x*(1-g)+this.m_vertices[e].x*g,this.m_vertices[b].y*(1-g)+this.m_vertices[e].y*g);g=0;h=Box2D.Common.Math.b2Vec2.Get(0,0);for(l=this.m_vertices[a];a!=
e;)a=(a+1)%this.m_vertexCount,f=a==e?b:this.m_vertices[a],m=0.5*((l.x-k.x)*(f.y-k.y)-(l.y-k.y)*(f.x-k.x)),g+=m,h.x+=m*(k.x+l.x+f.x)/3,h.y+=m*(k.y+l.y+f.y)/3,l=f;h.Multiply(1/g);d.SetV(Box2D.Common.Math.b2Math.MulX(c,h));return g};Box2D.Collision.Shapes.b2PolygonShape.prototype.SetDistanceProxy=function(a){a.m_vertices=this.m_vertices;a.m_count=this.m_vertexCount;a.m_radius=this.m_radius};Box2D.Collision.Shapes.b2PolygonShape.prototype.GetVertexCount=function(){return this.m_vertexCount};Box2D.Collision.Shapes.b2PolygonShape.prototype.GetVertices=
function(){return this.m_vertices};Box2D.Collision.Shapes.b2PolygonShape.prototype.GetNormals=function(){return this.m_normals};Box2D.Collision.Shapes.b2PolygonShape.prototype.GetSupport=function(a){for(var b=0,c=this.m_vertices[0].x*a.x+this.m_vertices[0].y*a.y,d=1;d<this.m_vertexCount;++d){var e=this.m_vertices[d].x*a.x+this.m_vertices[d].y*a.y;e>c&&(b=d,c=e)}return b};Box2D.Collision.Shapes.b2PolygonShape.prototype.GetSupportVertex=function(a){for(var b=0,c=this.m_vertices[0].x*a.x+this.m_vertices[0].y*
a.y,d=1;d<this.m_vertexCount;++d){var e=this.m_vertices[d].x*a.x+this.m_vertices[d].y*a.y;e>c&&(b=d,c=e)}return this.m_vertices[b]};Box2D.Collision.Shapes.b2PolygonShape.prototype.Reserve=function(a){this.m_vertices=[];this.m_normals=[];for(var b=this.m_vertices.length;b<a;b++)this.m_vertices[b]=Box2D.Common.Math.b2Vec2.Get(0,0),this.m_normals[b]=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Collision.Shapes.b2PolygonShape.ComputeCentroid=function(a,b){for(var c=Box2D.Common.Math.b2Vec2.Get(0,0),d=0,e=
1/3,h=0;h<b;++h){var g=a[h],l=h+1<b?a[h+1]:a[0],k=0.5*((g.x-0)*(l.y-0)-(g.y-0)*(l.x-0)),d=d+k;c.x+=k*e*(0+g.x+l.x);c.y+=k*e*(0+g.y+l.y)}c.x*=1/d;c.y*=1/d;return c};Box2D.Collision.Shapes.b2PolygonShape.s_mat=new Box2D.Common.Math.b2Mat22;Box2D.Collision.Shapes.b2PolygonShape.NAME="b2PolygonShape";Box2D.Collision.b2ContactID=function(){this._incidentVertex=this._incidentEdge=this._referenceEdge=this._key=0};Box2D.Collision.b2ContactID.prototype.GetKey=function(){return this._key};Box2D.Collision.b2ContactID.prototype.SetKey=
function(a){this._key=a;this._referenceEdge=this._key&255;this._incidentEdge=(this._key&65280)>>8&255;this._incidentVertex=(this._key&16711680)>>16&255;this._flip=(this._key&4278190080)>>24&255};Box2D.Collision.b2ContactID.prototype.Set=function(a){this.SetKey(a._key)};Box2D.Collision.b2ContactID.prototype.SetReferenceEdge=function(a){this._referenceEdge=a;this._key=this._key&4294967040|this._referenceEdge&255};Box2D.Collision.b2ContactID.prototype.SetIncidentEdge=function(a){this._incidentEdge=a;
this._key=this._key&4294902015|this._incidentEdge<<8&65280};Box2D.Collision.b2ContactID.prototype.SetIncidentVertex=function(a){this._incidentVertex=a;this._key=this._key&4278255615|this._incidentVertex<<16&16711680};Box2D.Collision.b2ContactID.prototype.SetFlip=function(a){this._flip=a;this._key=this._key&16777215|this._flip<<24&4278190080};Box2D.Collision.b2ContactID.prototype.Copy=function(){var a=new Box2D.Collision.b2ContactID;a.Set(this);return a};Box2D.Collision.ClipVertex=function(){this.v=
Box2D.Common.Math.b2Vec2.Get(0,0);this.id=new Box2D.Collision.b2ContactID};Box2D.Collision.ClipVertex.prototype.Set=function(a){this.v.SetV(a.v);this.id.Set(a.id)};Box2D.Collision.IBroadPhase="Box2D.Collision.IBroadPhase";Box2D.Collision.b2AABB=function(){this.lowerBound_=Box2D.Common.Math.b2Vec2.Get(0,0);this.upperBound_=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Collision.b2AABB._freeCache=[];Box2D.Collision.b2AABB.Get=function(){if(0<Box2D.Collision.b2AABB._freeCache.length){var a=Box2D.Collision.b2AABB._freeCache.pop();
a.SetZero();return a}return new Box2D.Collision.b2AABB};Box2D.Collision.b2AABB.Free=function(a){Box2D.Collision.b2AABB._freeCache.push(a)};Box2D.Collision.b2AABB.prototype.SetZero=function(){this.lowerBound_.Set(0,0);this.upperBound_.Set(0,0)};Box2D.Collision.b2AABB.prototype.IsValid=function(){return 0>this.upperBound_.x-this.lowerBound_.x||0>this.upperBound_.y-this.lowerBound_.y?!1:this.lowerBound_.IsValid()&&this.upperBound_.IsValid()};Box2D.Collision.b2AABB.prototype.GetCenter=function(){return Box2D.Common.Math.b2Vec2.Get((this.lowerBound_.x+
this.upperBound_.x)/2,(this.lowerBound_.y+this.upperBound_.y)/2)};Box2D.Collision.b2AABB.prototype.SetCenter=function(a){var b=this.GetCenter();this.lowerBound_.Subtract(b);this.upperBound_.Subtract(b);this.lowerBound_.Add(a);this.upperBound_.Add(a);Box2D.Common.Math.b2Vec2.Free(b)};Box2D.Collision.b2AABB.prototype.GetExtents=function(){return Box2D.Common.Math.b2Vec2.Get((this.upperBound_.x-this.lowerBound_.x)/2,(this.upperBound_.y-this.lowerBound_.y)/2)};Box2D.Collision.b2AABB.prototype.Contains=
function(a){var b;return b=(b=(b=(b=this.lowerBound_.x<=a.lowerBound_.x)&&this.lowerBound_.y<=a.lowerBound_.y)&&a.upperBound_.x<=this.upperBound_.x)&&a.upperBound_.y<=this.upperBound_.y};Box2D.Collision.b2AABB.prototype.RayCast=function(a,b){var c=-Number.MAX_VALUE,d=Number.MAX_VALUE,e=b.p2.x-b.p1.x;if(Math.abs(e)<Number.MIN_VALUE){if(b.p1.x<this.lowerBound_.x||this.upperBound_.x<b.p1.x)return!1}else{var h=1/e,e=(this.lowerBound_.x-b.p1.x)*h,h=(this.upperBound_.x-b.p1.x)*h,g=-1;e>h&&(g=e,e=h,h=g,
g=1);e>c&&(a.normal.x=g,a.normal.y=0,c=e);d=Math.min(d,h);if(c>d)return!1}e=b.p2.y-b.p1.y;if(Math.abs(e)<Number.MIN_VALUE){if(b.p1.y<this.lowerBound_.y||this.upperBound_.y<b.p1.y)return!1}else if(h=1/e,e=(this.lowerBound_.y-b.p1.y)*h,h*=this.upperBound_.y-b.p1.y,g=-1,e>h&&(g=e,e=h,h=g,g=1),e>c&&(a.normal.y=g,a.normal.x=0,c=e),d=Math.min(d,h),c>d)return!1;a.fraction=c;return!0};Box2D.Collision.b2AABB.prototype.TestOverlap=function(a){return 0<a.lowerBound_.x-this.upperBound_.x||0<a.lowerBound_.y-this.upperBound_.y||
0<this.lowerBound_.x-a.upperBound_.x||0<this.lowerBound_.y-a.upperBound_.y?!1:!0};Box2D.Collision.b2AABB.Combine=function(a,b){var c=Box2D.Collision.b2AABB.Get();c.Combine(a,b);return c};Box2D.Collision.b2AABB.prototype.Combine=function(a,b){this.lowerBound_.x=Math.min(a.lowerBound_.x,b.lowerBound_.x);this.lowerBound_.y=Math.min(a.lowerBound_.y,b.lowerBound_.y);this.upperBound_.x=Math.max(a.upperBound_.x,b.upperBound_.x);this.upperBound_.y=Math.max(a.upperBound_.y,b.upperBound_.y)};Box2D.Collision.b2Collision.ClipSegmentToLine=
function(a,b,c,d){var e=0,h=b[0].v,g=b[1].v,l=c.x*h.x+c.y*h.y-d;c=c.x*g.x+c.y*g.y-d;0>=l&&a[e++].Set(b[0]);0>=c&&a[e++].Set(b[1]);0>l*c&&(c=l/(l-c),d=a[e].v,d.x=h.x+c*(g.x-h.x),d.y=h.y+c*(g.y-h.y),a[e].id=0<l?b[0].id:b[1].id,e++);return e};Box2D.Collision.b2Collision.EdgeSeparation=function(a,b,c,d,e){for(var h=b.R.col1.x*a.m_normals[c].x+b.R.col2.x*a.m_normals[c].y,g=b.R.col1.y*a.m_normals[c].x+b.R.col2.y*a.m_normals[c].y,l=e.R.col1.x*h+e.R.col1.y*g,k=e.R.col2.x*h+e.R.col2.y*g,f=0,m=Number.MAX_VALUE,
n=0;n<d.m_vertexCount;n++){var p=d.m_vertices[n].x*l+d.m_vertices[n].y*k;p<m&&(m=p,f=n)}return(e.position.x+(e.R.col1.x*d.m_vertices[f].x+e.R.col2.x*d.m_vertices[f].y)-(b.position.x+(b.R.col1.x*a.m_vertices[c].x+b.R.col2.x*a.m_vertices[c].y)))*h+(e.position.y+(e.R.col1.y*d.m_vertices[f].x+e.R.col2.y*d.m_vertices[f].y)-(b.position.y+(b.R.col1.y*a.m_vertices[c].x+b.R.col2.y*a.m_vertices[c].y)))*g};Box2D.Collision.b2Collision.FindMaxSeparation=function(a,b,c,d){for(var e=d.position.x+(d.R.col1.x*c.m_centroid.x+
d.R.col2.x*c.m_centroid.y),h=d.position.y+(d.R.col1.y*c.m_centroid.x+d.R.col2.y*c.m_centroid.y),e=e-(b.position.x+(b.R.col1.x*a.m_centroid.x+b.R.col2.x*a.m_centroid.y)),h=h-(b.position.y+(b.R.col1.y*a.m_centroid.x+b.R.col2.y*a.m_centroid.y)),g=e*b.R.col1.x+h*b.R.col1.y,h=e*b.R.col2.x+h*b.R.col2.y,e=0,l=-Number.MAX_VALUE,k=0;k<a.m_vertexCount;++k){var f=a.m_normals[k].x*g+a.m_normals[k].y*h;f>l&&(l=f,e=k)}g=Box2D.Collision.b2Collision.EdgeSeparation(a,b,e,c,d);h=e-1;0>h&&(h=a.m_vertexCount-1);l=Box2D.Collision.b2Collision.EdgeSeparation(a,
b,h,c,d);k=e+1;k>=a.m_vertexCount&&(k=0);var f=Box2D.Collision.b2Collision.EdgeSeparation(a,b,k,c,d),m=0,n=0;if(l>g&&l>f)for(m=h,n=l;;)if(e=m-1,0>e&&(e=a.m_vertexCount-1),g=Box2D.Collision.b2Collision.EdgeSeparation(a,b,e,c,d),g>n)m=e,n=g;else break;else if(f>g)for(m=k,n=f;;)if(e=m+1,e>=a.m_vertexCount&&(e=0),g=Box2D.Collision.b2Collision.EdgeSeparation(a,b,e,c,d),g>n)m=e,n=g;else break;else m=e,n=g;return{bestEdge:m,separation:n}};Box2D.Collision.b2Collision.FindIncidentEdge=function(a,b,c,d,e,h){void 0===
d&&(d=0);var g=c.R.col1.x*b.m_normals[d].x+c.R.col2.x*b.m_normals[d].y;b=c.R.col1.y*b.m_normals[d].x+c.R.col2.y*b.m_normals[d].y;c=h.R.col1.x*g+h.R.col1.y*b;b=h.R.col2.x*g+h.R.col2.y*b;g=c;c=0;for(var l=Number.MAX_VALUE,k=0;k<e.m_vertexCount;k++){var f=g*e.m_normals[k].x+b*e.m_normals[k].y;f<l&&(l=f,c=k)}g=c+1;g>=e.m_vertexCount&&(g=0);a[0].v.x=h.position.x+(h.R.col1.x*e.m_vertices[c].x+h.R.col2.x*e.m_vertices[c].y);a[0].v.y=h.position.y+(h.R.col1.y*e.m_vertices[c].x+h.R.col2.y*e.m_vertices[c].y);
a[0].id.SetReferenceEdge(d);a[0].id.SetIncidentEdge(c);a[0].id.SetIncidentVertex(0);a[1].v.x=h.position.x+(h.R.col1.x*e.m_vertices[g].x+h.R.col2.x*e.m_vertices[g].y);a[1].v.y=h.position.y+(h.R.col1.y*e.m_vertices[g].x+h.R.col2.y*e.m_vertices[g].y);a[1].id.SetReferenceEdge(d);a[1].id.SetIncidentEdge(g);a[1].id.SetIncidentVertex(1)};Box2D.Collision.b2Collision.MakeClipPointVector=function(){return[new Box2D.Collision.ClipVertex,new Box2D.Collision.ClipVertex]};Box2D.Collision.b2Collision.CollidePolygons=
function(a,b,c,d,e){a.m_pointCount=0;var h=b.m_radius+d.m_radius,g=Box2D.Collision.b2Collision.FindMaxSeparation(b,c,d,e),l=g.bestEdge;if(!(g.separation>h)){var k=Box2D.Collision.b2Collision.FindMaxSeparation(d,e,b,c);if(!(k.separation>h)){var f=b,m=d,n=c,p=e,q=0;a.m_type=Box2D.Collision.b2Manifold.e_faceA;k.separation>0.98*g.separation+0.001&&(f=d,m=b,n=e,p=c,l=k.bestEdge,a.m_type=Box2D.Collision.b2Manifold.e_faceB,q=1);b=Box2D.Collision.b2Collision.s_incidentEdge;Box2D.Collision.b2Collision.FindIncidentEdge(b,
f,n,l,m,p);m=f.m_vertices[l];l=l+1<f.m_vertexCount?f.m_vertices[l+1]:f.m_vertices[0];Box2D.Collision.b2Collision.s_localTangent.Set(l.x-m.x,l.y-m.y);Box2D.Collision.b2Collision.s_localTangent.Normalize();Box2D.Collision.b2Collision.s_localNormal.x=Box2D.Collision.b2Collision.s_localTangent.y;Box2D.Collision.b2Collision.s_localNormal.y=-Box2D.Collision.b2Collision.s_localTangent.x;Box2D.Collision.b2Collision.s_planePoint.Set(0.5*(m.x+l.x),0.5*(m.y+l.y));Box2D.Collision.b2Collision.s_tangent.x=n.R.col1.x*
Box2D.Collision.b2Collision.s_localTangent.x+n.R.col2.x*Box2D.Collision.b2Collision.s_localTangent.y;Box2D.Collision.b2Collision.s_tangent.y=n.R.col1.y*Box2D.Collision.b2Collision.s_localTangent.x+n.R.col2.y*Box2D.Collision.b2Collision.s_localTangent.y;Box2D.Collision.b2Collision.s_tangent2.x=-Box2D.Collision.b2Collision.s_tangent.x;Box2D.Collision.b2Collision.s_tangent2.y=-Box2D.Collision.b2Collision.s_tangent.y;Box2D.Collision.b2Collision.s_normal.x=Box2D.Collision.b2Collision.s_tangent.y;Box2D.Collision.b2Collision.s_normal.y=
-Box2D.Collision.b2Collision.s_tangent.x;Box2D.Collision.b2Collision.s_v11.x=n.position.x+(n.R.col1.x*m.x+n.R.col2.x*m.y);Box2D.Collision.b2Collision.s_v11.y=n.position.y+(n.R.col1.y*m.x+n.R.col2.y*m.y);Box2D.Collision.b2Collision.s_v12.x=n.position.x+(n.R.col1.x*l.x+n.R.col2.x*l.y);Box2D.Collision.b2Collision.s_v12.y=n.position.y+(n.R.col1.y*l.x+n.R.col2.y*l.y);if(!(2>Box2D.Collision.b2Collision.ClipSegmentToLine(Box2D.Collision.b2Collision.s_clipPoints1,b,Box2D.Collision.b2Collision.s_tangent2,
-Box2D.Collision.b2Collision.s_tangent.x*Box2D.Collision.b2Collision.s_v11.x-Box2D.Collision.b2Collision.s_tangent.y*Box2D.Collision.b2Collision.s_v11.y+h)||2>Box2D.Collision.b2Collision.ClipSegmentToLine(Box2D.Collision.b2Collision.s_clipPoints2,Box2D.Collision.b2Collision.s_clipPoints1,Box2D.Collision.b2Collision.s_tangent,Box2D.Collision.b2Collision.s_tangent.x*Box2D.Collision.b2Collision.s_v12.x+Box2D.Collision.b2Collision.s_tangent.y*Box2D.Collision.b2Collision.s_v12.y+h))){a.m_localPlaneNormal.SetV(Box2D.Collision.b2Collision.s_localNormal);
a.m_localPoint.SetV(Box2D.Collision.b2Collision.s_planePoint);n=Box2D.Collision.b2Collision.s_normal.x*Box2D.Collision.b2Collision.s_v11.x+Box2D.Collision.b2Collision.s_normal.y*Box2D.Collision.b2Collision.s_v11.y;for(f=l=0;f<Box2D.Common.b2Settings.b2_maxManifoldPoints;++f)Box2D.Collision.b2Collision.s_normal.x*Box2D.Collision.b2Collision.s_clipPoints2[f].v.x+Box2D.Collision.b2Collision.s_normal.y*Box2D.Collision.b2Collision.s_clipPoints2[f].v.y-n<=h&&(m=Box2D.Collision.b2Collision.s_clipPoints2[f].v.x-
p.position.x,b=Box2D.Collision.b2Collision.s_clipPoints2[f].v.y-p.position.y,a.m_points[l].m_localPoint.x=m*p.R.col1.x+b*p.R.col1.y,a.m_points[l].m_localPoint.y=m*p.R.col2.x+b*p.R.col2.y,a.m_points[l].m_id.Set(Box2D.Collision.b2Collision.s_clipPoints2[f].id),a.m_points[l].m_id.SetFlip(q),l++);a.m_pointCount=l}}}};Box2D.Collision.b2Collision.CollideCircles=function(a,b,c,d,e){a.m_pointCount=0;var h=e.position.x+(e.R.col1.x*d.m_p.x+e.R.col2.x*d.m_p.y)-(c.position.x+(c.R.col1.x*b.m_p.x+c.R.col2.x*b.m_p.y));
c=e.position.y+(e.R.col1.y*d.m_p.x+e.R.col2.y*d.m_p.y)-(c.position.y+(c.R.col1.y*b.m_p.x+c.R.col2.y*b.m_p.y));e=b.m_radius+d.m_radius;h*h+c*c>e*e||(a.m_type=Box2D.Collision.b2Manifold.e_circles,a.m_localPoint.SetV(b.m_p),a.m_localPlaneNormal.SetZero(),a.m_pointCount=1,a.m_points[0].m_localPoint.SetV(d.m_p),a.m_points[0].m_id.SetKey(0))};Box2D.Collision.b2Collision.CollidePolygonAndCircle=function(a,b,c,d,e){a.m_pointCount=0;var h=e.position.x+(e.R.col1.x*d.m_p.x+e.R.col2.x*d.m_p.y)-c.position.x,g=
e.position.y+(e.R.col1.y*d.m_p.x+e.R.col2.y*d.m_p.y)-c.position.y;e=h*c.R.col1.x+g*c.R.col1.y;c=h*c.R.col2.x+g*c.R.col2.y;for(var h=0,g=-Number.MAX_VALUE,l=b.m_radius+d.m_radius,k=0;k<b.m_vertexCount;++k){var f=b.m_normals[k].x*(e-b.m_vertices[k].x)+b.m_normals[k].y*(c-b.m_vertices[k].y);if(f>l)return;f>g&&(g=f,h=k)}f=h+1;f>=b.m_vertexCount&&(f=0);var k=b.m_vertices[h],m=b.m_vertices[f];g<Number.MIN_VALUE?(a.m_pointCount=1,a.m_type=Box2D.Collision.b2Manifold.e_faceA,a.m_localPlaneNormal.SetV(b.m_normals[h]),
a.m_localPoint.x=0.5*(k.x+m.x),a.m_localPoint.y=0.5*(k.y+m.y),a.m_points[0].m_localPoint.SetV(d.m_p),a.m_points[0].m_id.SetKey(0)):0>=(e-k.x)*(m.x-k.x)+(c-k.y)*(m.y-k.y)?(e-k.x)*(e-k.x)+(c-k.y)*(c-k.y)>l*l||(a.m_pointCount=1,a.m_type=Box2D.Collision.b2Manifold.e_faceA,a.m_localPlaneNormal.x=e-k.x,a.m_localPlaneNormal.y=c-k.y,a.m_localPlaneNormal.Normalize(),a.m_localPoint.SetV(k),a.m_points[0].m_localPoint.SetV(d.m_p),a.m_points[0].m_id.SetKey(0)):0>=(e-m.x)*(k.x-m.x)+(c-m.y)*(k.y-m.y)?(e-m.x)*(e-
m.x)+(c-m.y)*(c-m.y)>l*l||(a.m_pointCount=1,a.m_type=Box2D.Collision.b2Manifold.e_faceA,a.m_localPlaneNormal.x=e-m.x,a.m_localPlaneNormal.y=c-m.y,a.m_localPlaneNormal.Normalize(),a.m_localPoint.SetV(m),a.m_points[0].m_localPoint.SetV(d.m_p),a.m_points[0].m_id.SetKey(0)):(f=0.5*(k.x+m.x),k=0.5*(k.y+m.y),g=(e-f)*b.m_normals[h].x+(c-k)*b.m_normals[h].y,g>l||(a.m_pointCount=1,a.m_type=Box2D.Collision.b2Manifold.e_faceA,a.m_localPlaneNormal.x=b.m_normals[h].x,a.m_localPlaneNormal.y=b.m_normals[h].y,a.m_localPlaneNormal.Normalize(),
a.m_localPoint.Set(f,k),a.m_points[0].m_localPoint.SetV(d.m_p),a.m_points[0].m_id.SetKey(0)))};Box2D.Collision.b2Collision.TestOverlap=function(a,b){return 0<b.lowerBound_.x-a.upperBound_.x||0<b.lowerBound_.y-a.upperBound_.y||0<a.lowerBound_.x-b.upperBound_.x||0<a.lowerBound_.y-b.upperBound_.y?!1:!0};Box2D.Collision.b2ContactPoint=function(){this.position=Box2D.Common.Math.b2Vec2.Get(0,0);this.velocity=Box2D.Common.Math.b2Vec2.Get(0,0);this.normal=Box2D.Common.Math.b2Vec2.Get(0,0);this.id=new Box2D.Collision.b2ContactID};
Box2D.Collision.b2Distance.Distance=function(a,b,c){var d=new Box2D.Collision.b2Simplex;d.ReadCache(b,c.proxyA,c.transformA,c.proxyB,c.transformB);for(var e=0;20>e;){for(var h=[],g=0;g<d.m_count;g++)h[g]={},h[g].indexA=d.m_vertices[g].indexA,h[g].indexB=d.m_vertices[g].indexB;2==d.m_count?d.Solve2():3==d.m_count&&d.Solve3();if(3==d.m_count)break;g=d.GetSearchDirection();if(g.LengthSquared()<Box2D.Common.b2Settings.MIN_VALUE_SQUARED)break;var l=g.GetNegative();d.m_vertices[d.m_count].indexA=c.proxyA.GetSupport(Box2D.Common.Math.b2Math.MulTMV(c.transformA.R,
l));d.m_vertices[d.m_count].wA=Box2D.Common.Math.b2Math.MulX(c.transformA,c.proxyA.GetVertex(d.m_vertices[d.m_count].indexA));d.m_vertices[d.m_count].indexB=c.proxyB.GetSupport(Box2D.Common.Math.b2Math.MulTMV(c.transformB.R,g));d.m_vertices[d.m_count].wB=Box2D.Common.Math.b2Math.MulX(c.transformB,c.proxyB.GetVertex(d.m_vertices[d.m_count].indexB));d.m_vertices[d.m_count].w=Box2D.Common.Math.b2Math.SubtractVV(d.m_vertices[d.m_count].wB,d.m_vertices[d.m_count].wA);Box2D.Common.Math.b2Vec2.Free(g);Box2D.Common.Math.b2Vec2.Free(l);
e++;l=!1;for(g=0;g<h.length;g++)if(d.m_vertices[d.m_count].indexA==h[g].indexA&&d.m_vertices[d.m_count].indexB==h[g].indexB){l=!0;break}if(l)break;d.m_count++}d.GetWitnessPoints(a.pointA,a.pointB);a.distance=Box2D.Common.Math.b2Math.SubtractVV(a.pointA,a.pointB).Length();d.WriteCache(b);c.useRadii&&(b=c.proxyA.m_radius,c=c.proxyB.m_radius,a.distance>b+c&&a.distance>Number.MIN_VALUE?(a.distance-=b+c,d=Box2D.Common.Math.b2Math.SubtractVV(a.pointB,a.pointA),d.Normalize(),a.pointA.x+=b*d.x,a.pointA.y+=
b*d.y,a.pointB.x-=c*d.x,a.pointB.y-=c*d.y,Box2D.Common.Math.b2Vec2.Free(d)):(c=Box2D.Common.Math.b2Vec2.Get(0,0),c.x=0.5*(a.pointA.x+a.pointB.x),c.y=0.5*(a.pointA.y+a.pointB.y),a.pointA.x=a.pointB.x=c.x,a.pointA.y=a.pointB.y=c.y,a.distance=0,Box2D.Common.Math.b2Vec2.Free(c)))};Box2D.Collision.b2DistanceInput=function(){};Box2D.Collision.b2DistanceOutput=function(){this.pointA=Box2D.Common.Math.b2Vec2.Get(0,0);this.pointB=Box2D.Common.Math.b2Vec2.Get(0,0);this.distance=0};Box2D.Collision.b2DistanceProxy=
function(){};Box2D.Collision.b2DistanceProxy.prototype.Set=function(a){a.SetDistanceProxy(this)};Box2D.Collision.b2DistanceProxy.prototype.GetSupport=function(a){for(var b=0,c=this.m_vertices[0].x*a.x+this.m_vertices[0].y*a.y,d=1;d<this.m_count;d++){var e=this.m_vertices[d].x*a.x+this.m_vertices[d].y*a.y;e>c&&(b=d,c=e)}return b};Box2D.Collision.b2DistanceProxy.prototype.GetSupportVertex=function(a){return this.m_vertices[this.GetSupport(a)]};Box2D.Collision.b2DistanceProxy.prototype.GetVertexCount=
function(){return this.m_count};Box2D.Collision.b2DistanceProxy.prototype.GetVertex=function(a){void 0===a&&(a=0);return this.m_vertices[a]};Box2D.Collision.b2DynamicTree=function(){this.m_root=null;this.m_insertionCount=this.m_path=0};Box2D.Collision.b2DynamicTree.prototype.CreateProxy=function(a,b){var c=Box2D.Collision.b2DynamicTreeNode.Get(b),d=Box2D.Common.b2Settings.b2_aabbExtension,e=Box2D.Common.b2Settings.b2_aabbExtension;c.aabb.lowerBound_.x=a.lowerBound_.x-d;c.aabb.lowerBound_.y=a.lowerBound_.y-
e;c.aabb.upperBound_.x=a.upperBound_.x+d;c.aabb.upperBound_.y=a.upperBound_.y+e;this.InsertLeaf(c);return c};Box2D.Collision.b2DynamicTree.prototype.DestroyProxy=function(a){this.RemoveLeaf(a);a.Destroy()};Box2D.Collision.b2DynamicTree.prototype.MoveProxy=function(a,b,c){if(a.aabb.Contains(b))return!1;this.RemoveLeaf(a);var d=Box2D.Common.b2Settings.b2_aabbExtension+Box2D.Common.b2Settings.b2_aabbMultiplier*Math.abs(c.x);c=Box2D.Common.b2Settings.b2_aabbExtension+Box2D.Common.b2Settings.b2_aabbMultiplier*
Math.abs(c.y);a.aabb.lowerBound_.x=b.lowerBound_.x-d;a.aabb.lowerBound_.y=b.lowerBound_.y-c;a.aabb.upperBound_.x=b.upperBound_.x+d;a.aabb.upperBound_.y=b.upperBound_.y+c;this.InsertLeaf(a);return!0};Box2D.Collision.b2DynamicTree.prototype.Rebalance=function(a){if(null!==this.m_root)for(var b=0;b<a;b++){for(var c=this.m_root,d=0;!c.IsLeaf();)c=this.m_path>>d&1?c.child2:c.child1,d=d+1&31;this.m_path++;this.RemoveLeaf(c);this.InsertLeaf(c)}};Box2D.Collision.b2DynamicTree.prototype.GetFatAABB=function(a){return a.aabb};
Box2D.Collision.b2DynamicTree.prototype.Query=function(a,b){if(null!==this.m_root){var c=[];for(c.push(this.m_root);0<c.length;){var d=c.pop();if(d.aabb.TestOverlap(b))if(d.IsLeaf()){if(!a(d.fixture))break}else c.push(d.child1),c.push(d.child2)}}};Box2D.Collision.b2DynamicTree.prototype.RayCast=function(a,b){if(null!==this.m_root){var c=Box2D.Common.Math.b2Math.SubtractVV(b.p1,b.p2);c.Normalize();var c=Box2D.Common.Math.b2Math.CrossFV(1,c),d=Box2D.Common.Math.b2Math.AbsV(c),e=b.maxFraction,h=b.p1.x+
e*(b.p2.x-b.p1.x),e=b.p1.y+e*(b.p2.y-b.p1.y),g=Box2D.Collision.b2AABB.Get();g.lowerBound_.x=Math.min(b.p1.x,h);g.lowerBound_.y=Math.min(b.p1.y,e);g.upperBound_.x=Math.max(b.p1.x,h);g.upperBound_.y=Math.max(b.p1.y,e);var l=[];for(l.push(this.m_root);0<l.length;)if(h=l.pop(),h.aabb.TestOverlap(g)){var e=h.aabb.GetCenter(),k=h.aabb.GetExtents();if(!(0<Math.abs(c.x*(b.p1.x-e.x)+c.y*(b.p1.y-e.y))-d.x*k.x-d.y*k.y))if(h.IsLeaf()){new Box2D.Collision.b2RayCastInput(b.p1,b.p2,b.maxFraction);e=a(b,h.fixture);
if(0==e)break;0<e&&(h=b.p1.x+e*(b.p2.x-b.p1.x),e=b.p1.y+e*(b.p2.y-b.p1.y),g.lowerBound_.x=Math.min(b.p1.x,h),g.lowerBound_.y=Math.min(b.p1.y,e),g.upperBound_.x=Math.max(b.p1.x,h),g.upperBound_.y=Math.max(b.p1.y,e))}else l.push(h.child1),l.push(h.child2)}Box2D.Collision.b2AABB.Free(g)}};Box2D.Collision.b2DynamicTree.prototype.InsertLeaf=function(a){this.m_insertionCount++;if(null===this.m_root)this.m_root=a,this.m_root.parent=null;else{var b=this.GetBestSibling(a),c=b.parent,d=Box2D.Collision.b2DynamicTreeNode.Get();
d.parent=c;d.aabb.Combine(a.aabb,b.aabb);if(c)for(b.parent.child1==b?c.child1=d:c.child2=d,d.child1=b,d.child2=a,b.parent=d,a.parent=d;c&&!c.aabb.Contains(d.aabb);)c.aabb.Combine(c.child1.aabb,c.child2.aabb),d=c,c=c.parent;else d.child1=b,d.child2=a,b.parent=d,this.m_root=a.parent=d}};Box2D.Collision.b2DynamicTree.prototype.GetBestSibling=function(a){a=a.aabb.GetCenter();for(var b=this.m_root;!b.IsLeaf();)var c=b.child1,b=b.child2,d=Math.abs((c.aabb.lowerBound_.x+c.aabb.upperBound_.x)/2-a.x)+Math.abs((c.aabb.lowerBound_.y+
c.aabb.upperBound_.y)/2-a.y),e=Math.abs((b.aabb.lowerBound_.x+b.aabb.upperBound_.x)/2-a.x)+Math.abs((b.aabb.lowerBound_.y+b.aabb.upperBound_.y)/2-a.y),b=d<e?c:b;Box2D.Common.Math.b2Vec2.Free(a);return b};Box2D.Collision.b2DynamicTree.prototype.RemoveLeaf=function(a){if(a==this.m_root)this.m_root=null;else{var b=a.parent,c=b.parent;a=b.child1==a?b.child2:b.child1;if(c)for(c.child1==b?c.child1=a:c.child2=a,a.parent=c;c;){a=c.aabb;c.aabb.Combine(c.child1.aabb,c.child2.aabb);if(a.Contains(c.aabb))break;
c=c.parent}else this.m_root=a,a.parent=null;b.Destroy()}};Box2D.Collision.b2DynamicTreeBroadPhase=function(){this.m_tree=new Box2D.Collision.b2DynamicTree;this.m_moveBuffer=[]};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.CreateProxy=function(a,b){var c=this.m_tree.CreateProxy(a,b);this.BufferMove(c);return c};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.DestroyProxy=function(a){this.UnBufferMove(a);this.m_tree.DestroyProxy(a)};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.MoveProxy=
function(a,b,c){this.m_tree.MoveProxy(a,b,c)&&this.BufferMove(a)};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.TestOverlap=function(a,b){var c=this.m_tree.GetFatAABB(a),d=this.m_tree.GetFatAABB(b);return c.TestOverlap(d)};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.GetFatAABB=function(a){return this.m_tree.GetFatAABB(a)};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.GetProxyCount=function(){return this.m_tree.length};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.UpdatePairs=function(a){for(var b=
[];0<this.m_moveBuffer.length;){var c=this.m_moveBuffer.pop(),d=this.m_tree.GetFatAABB(c);this.m_tree.Query(function(a){a!=c.fixture&&b.push(new Box2D.Collision.b2DynamicTreePair(c.fixture,a));return!0},d)}for(d=0;d<b.length;){var e=b[d];a(e.fixtureA,e.fixtureB);for(d++;d<b.length;){var h=b[d];if(!(h.fixtureA==e.fixtureA&&h.fixtureB==e.fixtureB||h.fixtureA==e.fixtureB&&h.fixtureB==e.fixtureA))break;d++}}};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.Query=function(a,b){this.m_tree.Query(a,b)};
Box2D.Collision.b2DynamicTreeBroadPhase.prototype.RayCast=function(a,b){this.m_tree.RayCast(a,b)};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.Rebalance=function(a){this.m_tree.Rebalance(a)};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.BufferMove=function(a){this.m_moveBuffer.push(a)};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.UnBufferMove=function(a){cr.arrayFindRemove(this.m_moveBuffer,a)};Box2D.Collision.b2DynamicTreeBroadPhase.__implements={};Box2D.Collision.b2DynamicTreeBroadPhase.__implements[Box2D.Collision.IBroadPhase]=
!0;Box2D.Collision.b2DynamicTreeNode=function(a){this.aabb=Box2D.Collision.b2AABB.Get();this.fixture=this.parent=this.child2=this.child1=null;"undefined"!=typeof a&&(this.fixture=a)};Box2D.Collision.b2DynamicTreeNode._freeCache=[];Box2D.Collision.b2DynamicTreeNode.Get=function(a){if(0<Box2D.Collision.b2DynamicTreeNode._freeCache.length){var b=Box2D.Collision.b2DynamicTreeNode._freeCache.pop();"undefined"!=typeof a&&(b.fixture=a);b.aabb.SetZero();return b}return new Box2D.Collision.b2DynamicTreeNode(a)};
Box2D.Collision.b2DynamicTreeNode.prototype.Destroy=function(){this.fixture=this.parent=this.child2=this.child1=null;Box2D.Collision.b2DynamicTreeNode._freeCache.push(this)};Box2D.Collision.b2DynamicTreeNode.prototype.IsLeaf=function(){return null===this.child1};Box2D.Collision.b2DynamicTreePair=function(a,b){this.fixtureA=a;this.fixtureB=b};Box2D.Collision.b2Manifold=function(){this.m_type=this.m_pointCount=0;this.m_points=[];for(var a=0;a<Box2D.Common.b2Settings.b2_maxManifoldPoints;a++)this.m_points[a]=
new Box2D.Collision.b2ManifoldPoint;this.m_localPlaneNormal=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localPoint=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Collision.b2Manifold.prototype.Reset=function(){for(var a=0;a<Box2D.Common.b2Settings.b2_maxManifoldPoints;a++)this.m_points[a].Reset();this.m_localPlaneNormal.SetZero();this.m_localPoint.SetZero();this.m_pointCount=this.m_type=0};Box2D.Collision.b2Manifold.prototype.Set=function(a){this.m_pointCount=a.m_pointCount;for(var b=0;b<Box2D.Common.b2Settings.b2_maxManifoldPoints;b++)this.m_points[b].Set(a.m_points[b]);
this.m_localPlaneNormal.SetV(a.m_localPlaneNormal);this.m_localPoint.SetV(a.m_localPoint);this.m_type=a.m_type};Box2D.Collision.b2Manifold.prototype.Copy=function(){var a=new Box2D.Collision.b2Manifold;a.Set(this);return a};Box2D.Collision.b2Manifold.e_circles=1;Box2D.Collision.b2Manifold.e_faceA=2;Box2D.Collision.b2Manifold.e_faceB=4;Box2D.Collision.b2ManifoldPoint=function(){this.m_localPoint=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_id=new Box2D.Collision.b2ContactID;this.Reset()};Box2D.Collision.b2ManifoldPoint.prototype.Reset=
function(){this.m_localPoint.SetZero();this.m_tangentImpulse=this.m_normalImpulse=0;this.m_id.SetKey(0)};Box2D.Collision.b2ManifoldPoint.prototype.Set=function(a){this.m_localPoint.SetV(a.m_localPoint);this.m_normalImpulse=a.m_normalImpulse;this.m_tangentImpulse=a.m_tangentImpulse;this.m_id.Set(a.m_id)};Box2D.Collision.b2RayCastInput=function(a,b,c){this.p1=Box2D.Common.Math.b2Vec2.Get(0,0);this.p2=Box2D.Common.Math.b2Vec2.Get(0,0);void 0===c&&(c=1);a&&this.p1.SetV(a);b&&this.p2.SetV(b);this.maxFraction=
c};Box2D.Collision.b2RayCastOutput=function(){this.normal=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Collision.b2Segment=function(){this.p1=Box2D.Common.Math.b2Vec2.Get(0,0);this.p2=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Collision.b2Segment.prototype.TestSegment=function(a,b,c,d){void 0===d&&(d=0);var e=c.p1,h=c.p2.x-e.x,g=c.p2.y-e.y;c=this.p2.y-this.p1.y;var l=-(this.p2.x-this.p1.x),k=100*Number.MIN_VALUE,f=-(h*c+g*l);if(f>k){var m=e.x-this.p1.x,n=e.y-this.p1.y,e=m*c+n*l;if(0<=e&&e<=d*f&&(d=-h*n+
g*m,-k*f<=d&&d<=f*(1+k)))return e/=f,d=Math.sqrt(c*c+l*l),a[0]=e,b.Set(c/d,l/d),!0}return!1};Box2D.Collision.b2Segment.prototype.Extend=function(a){this.ExtendForward(a);this.ExtendBackward(a)};Box2D.Collision.b2Segment.prototype.ExtendForward=function(a){var b=this.p2.x-this.p1.x,c=this.p2.y-this.p1.y;a=Math.min(0<b?(a.upperBound_.x-this.p1.x)/b:0>b?(a.lowerBound_.x-this.p1.x)/b:Number.POSITIVE_INFINITY,0<c?(a.upperBound_.y-this.p1.y)/c:0>c?(a.lowerBound_.y-this.p1.y)/c:Number.POSITIVE_INFINITY);
this.p2.x=this.p1.x+b*a;this.p2.y=this.p1.y+c*a};Box2D.Collision.b2Segment.prototype.ExtendBackward=function(a){var b=-this.p2.x+this.p1.x,c=-this.p2.y+this.p1.y;a=Math.min(0<b?(a.upperBound_.x-this.p2.x)/b:0>b?(a.lowerBound_.x-this.p2.x)/b:Number.POSITIVE_INFINITY,0<c?(a.upperBound_.y-this.p2.y)/c:0>c?(a.lowerBound_.y-this.p2.y)/c:Number.POSITIVE_INFINITY);this.p1.x=this.p2.x+b*a;this.p1.y=this.p2.y+c*a};Box2D.Collision.b2SeparationFunction=function(){this.m_localPoint=Box2D.Common.Math.b2Vec2.Get(0,
0);this.m_axis=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Collision.b2SeparationFunction.prototype.Initialize=function(a,b,c,d,e){this.m_proxyA=b;this.m_proxyB=d;var h,g,l,k=l=g=0,f=0;d=b=0;var m,n,k=0;1==a.count?(this.m_type=Box2D.Collision.b2SeparationFunction.e_points,h=this.m_proxyA.GetVertex(a.indexA[0]),a=this.m_proxyB.GetVertex(a.indexB[0]),n=h,m=c.R,g=c.position.x+(m.col1.x*n.x+m.col2.x*n.y),l=c.position.y+(m.col1.y*n.x+m.col2.y*n.y),n=a,m=e.R,k=e.position.x+(m.col1.x*n.x+m.col2.x*n.y),f=e.position.y+
(m.col1.y*n.x+m.col2.y*n.y),this.m_axis.x=k-g,this.m_axis.y=f-l,this.m_axis.Normalize()):(a.indexB[0]==a.indexB[1]?(this.m_type=Box2D.Collision.b2SeparationFunction.e_faceA,b=this.m_proxyA.GetVertex(a.indexA[0]),d=this.m_proxyA.GetVertex(a.indexA[1]),a=this.m_proxyB.GetVertex(a.indexB[0]),this.m_localPoint.x=0.5*(b.x+d.x),this.m_localPoint.y=0.5*(b.y+d.y),this.m_axis=Box2D.Common.Math.b2Math.CrossVF(Box2D.Common.Math.b2Math.SubtractVV(d,b),1),this.m_axis.Normalize(),n=this.m_axis,m=c.R,b=m.col1.x*
n.x+m.col2.x*n.y,d=m.col1.y*n.x+m.col2.y*n.y,n=this.m_localPoint,m=c.R,g=c.position.x+(m.col1.x*n.x+m.col2.x*n.y),l=c.position.y+(m.col1.y*n.x+m.col2.y*n.y),n=a,m=e.R,k=e.position.x+(m.col1.x*n.x+m.col2.x*n.y),f=e.position.y+(m.col1.y*n.x+m.col2.y*n.y),k=(k-g)*b+(f-l)*d):a.indexA[0]==a.indexA[0]?(this.m_type=Box2D.Collision.b2SeparationFunction.e_faceB,g=this.m_proxyB.GetVertex(a.indexB[0]),l=this.m_proxyB.GetVertex(a.indexB[1]),h=this.m_proxyA.GetVertex(a.indexA[0]),this.m_localPoint.x=0.5*(g.x+
l.x),this.m_localPoint.y=0.5*(g.y+l.y),this.m_axis=Box2D.Common.Math.b2Math.CrossVF(Box2D.Common.Math.b2Math.SubtractVV(l,g),1),this.m_axis.Normalize(),n=this.m_axis,m=e.R,b=m.col1.x*n.x+m.col2.x*n.y,d=m.col1.y*n.x+m.col2.y*n.y,n=this.m_localPoint,m=e.R,k=e.position.x+(m.col1.x*n.x+m.col2.x*n.y),f=e.position.y+(m.col1.y*n.x+m.col2.y*n.y),n=h,m=c.R,g=c.position.x+(m.col1.x*n.x+m.col2.x*n.y),l=c.position.y+(m.col1.y*n.x+m.col2.y*n.y),k=(g-k)*b+(l-f)*d):(b=this.m_proxyA.GetVertex(a.indexA[0]),d=this.m_proxyA.GetVertex(a.indexA[1]),
g=this.m_proxyB.GetVertex(a.indexB[0]),l=this.m_proxyB.GetVertex(a.indexB[1]),k=Box2D.Common.Math.b2Math.MulMV(c.R,Box2D.Common.Math.b2Math.SubtractVV(d,b)),f=Box2D.Common.Math.b2Math.MulMV(e.R,Box2D.Common.Math.b2Math.SubtractVV(l,g)),e=k.x*k.x+k.y*k.y,c=f.x*f.x+f.y*f.y,h=Box2D.Common.Math.b2Math.SubtractVV(f,k),a=k.x*h.x+k.y*h.y,h=f.x*h.x+f.y*h.y,f=k.x*f.x+k.y*f.y,m=e*c-f*f,k=0,0!=m&&(k=Box2D.Common.Math.b2Math.Clamp((f*h-a*c)/m,0,1)),0>(f*k+h)/c&&(k=Box2D.Common.Math.b2Math.Clamp((f-a)/e,0,1)),
h=Box2D.Common.Math.b2Vec2.Get(0,0),h.x=b.x+k*(d.x-b.x),h.y=b.y+k*(d.y-b.y),a=Box2D.Common.Math.b2Vec2.Get(0,0),a.x=g.x+k*(l.x-g.x),a.y=g.y+k*(l.y-g.y),0==k||1==k?(this.m_type=Box2D.Collision.b2SeparationFunction.e_faceB,this.m_axis=Box2D.Common.Math.b2Math.CrossVF(Box2D.Common.Math.b2Math.SubtractVV(l,g),1),this.m_axis.Normalize(),this.m_localPoint=a):(this.m_type=Box2D.Collision.b2SeparationFunction.e_faceA,this.m_axis=Box2D.Common.Math.b2Math.CrossVF(Box2D.Common.Math.b2Math.SubtractVV(d,b),1),
this.m_localPoint=h)),0>k&&this.m_axis.NegativeSelf())};Box2D.Collision.b2SeparationFunction.prototype.Evaluate=function(a,b){var c,d,e=0;switch(this.m_type){case Box2D.Collision.b2SeparationFunction.e_points:c=Box2D.Common.Math.b2Math.MulTMV(a.R,this.m_axis);d=Box2D.Common.Math.b2Math.MulTMV(b.R,this.m_axis.GetNegative());c=this.m_proxyA.GetSupportVertex(c);d=this.m_proxyB.GetSupportVertex(d);c=Box2D.Common.Math.b2Math.MulX(a,c);d=Box2D.Common.Math.b2Math.MulX(b,d);e=(d.x-c.x)*this.m_axis.x+(d.y-
c.y)*this.m_axis.y;break;case Box2D.Collision.b2SeparationFunction.e_faceA:e=Box2D.Common.Math.b2Math.MulMV(a.R,this.m_axis);c=Box2D.Common.Math.b2Math.MulX(a,this.m_localPoint);d=Box2D.Common.Math.b2Math.MulTMV(b.R,e.GetNegative());d=this.m_proxyB.GetSupportVertex(d);d=Box2D.Common.Math.b2Math.MulX(b,d);e=(d.x-c.x)*e.x+(d.y-c.y)*e.y;break;case Box2D.Collision.b2SeparationFunction.e_faceB:e=Box2D.Common.Math.b2Math.MulMV(b.R,this.m_axis),d=Box2D.Common.Math.b2Math.MulX(b,this.m_localPoint),c=Box2D.Common.Math.b2Math.MulTMV(a.R,
e.GetNegative()),c=this.m_proxyA.GetSupportVertex(c),c=Box2D.Common.Math.b2Math.MulX(a,c),e=(c.x-d.x)*e.x+(c.y-d.y)*e.y}return e};Box2D.Collision.b2SeparationFunction.e_points=1;Box2D.Collision.b2SeparationFunction.e_faceA=2;Box2D.Collision.b2SeparationFunction.e_faceB=4;Box2D.Collision.b2Simplex=function(){this.m_v1=new Box2D.Collision.b2SimplexVertex;this.m_v2=new Box2D.Collision.b2SimplexVertex;this.m_v3=new Box2D.Collision.b2SimplexVertex;this.m_vertices=[this.m_v1,this.m_v2,this.m_v3]};Box2D.Collision.b2Simplex.prototype.ReadCache=
function(a,b,c,d,e){var h,g;this.m_count=a.count;for(var l=this.m_vertices,k=0;k<this.m_count;k++){var f=l[k];f.indexA=a.indexA[k];f.indexB=a.indexB[k];h=b.GetVertex(f.indexA);g=d.GetVertex(f.indexB);f.wA=Box2D.Common.Math.b2Math.MulX(c,h);f.wB=Box2D.Common.Math.b2Math.MulX(e,g);f.w=Box2D.Common.Math.b2Math.SubtractVV(f.wB,f.wA);f.a=0}1<this.m_count&&(a=a.metric,h=this.GetMetric(),h<0.5*a||2*a<h||h<Number.MIN_VALUE)&&(this.m_count=0);0==this.m_count&&(f=l[0],f.indexA=0,f.indexB=0,h=b.GetVertex(0),
g=d.GetVertex(0),f.wA=Box2D.Common.Math.b2Math.MulX(c,h),f.wB=Box2D.Common.Math.b2Math.MulX(e,g),f.w=Box2D.Common.Math.b2Math.SubtractVV(f.wB,f.wA),this.m_count=1)};Box2D.Collision.b2Simplex.prototype.WriteCache=function(a){a.metric=this.GetMetric();a.count=this.m_count;for(var b=this.m_vertices,c=0;c<this.m_count;c++)a.indexA[c]=b[c].indexA,a.indexB[c]=b[c].indexB};Box2D.Collision.b2Simplex.prototype.GetSearchDirection=function(){if(1==this.m_count)return this.m_v1.w.GetNegative();if(2==this.m_count){var a=
Box2D.Common.Math.b2Math.SubtractVV(this.m_v2.w,this.m_v1.w);return 0<Box2D.Common.Math.b2Math.CrossVV(a,this.m_v1.w.GetNegative())?Box2D.Common.Math.b2Math.CrossFV(1,a):Box2D.Common.Math.b2Math.CrossVF(a,1)}return Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Collision.b2Simplex.prototype.GetClosestPoint=function(){return 1==this.m_count?this.m_v1.w:2==this.m_count?Box2D.Common.Math.b2Vec2.Get(this.m_v1.a*this.m_v1.w.x+this.m_v2.a*this.m_v2.w.x,this.m_v1.a*this.m_v1.w.y+this.m_v2.a*this.m_v2.w.y):Box2D.Common.Math.b2Vec2.Get(0,
0)};Box2D.Collision.b2Simplex.prototype.GetWitnessPoints=function(a,b){1==this.m_count?(a.SetV(this.m_v1.wA),b.SetV(this.m_v1.wB)):2==this.m_count?(a.x=this.m_v1.a*this.m_v1.wA.x+this.m_v2.a*this.m_v2.wA.x,a.y=this.m_v1.a*this.m_v1.wA.y+this.m_v2.a*this.m_v2.wA.y,b.x=this.m_v1.a*this.m_v1.wB.x+this.m_v2.a*this.m_v2.wB.x,b.y=this.m_v1.a*this.m_v1.wB.y+this.m_v2.a*this.m_v2.wB.y):3==this.m_count&&(b.x=a.x=this.m_v1.a*this.m_v1.wA.x+this.m_v2.a*this.m_v2.wA.x+this.m_v3.a*this.m_v3.wA.x,b.y=a.y=this.m_v1.a*
this.m_v1.wA.y+this.m_v2.a*this.m_v2.wA.y+this.m_v3.a*this.m_v3.wA.y)};Box2D.Collision.b2Simplex.prototype.GetMetric=function(){return 1==this.m_count?0:2==this.m_count?Box2D.Common.Math.b2Math.SubtractVV(this.m_v1.w,this.m_v2.w).Length():3==this.m_count?Box2D.Common.Math.b2Math.CrossVV(Box2D.Common.Math.b2Math.SubtractVV(this.m_v2.w,this.m_v1.w),Box2D.Common.Math.b2Math.SubtractVV(this.m_v3.w,this.m_v1.w)):0};Box2D.Collision.b2Simplex.prototype.Solve2=function(){var a=this.m_v1.w,b=this.m_v2.w,c=
Box2D.Common.Math.b2Math.SubtractVV(b,a),a=-(a.x*c.x+a.y*c.y);0>=a?this.m_count=this.m_v1.a=1:(b=b.x*c.x+b.y*c.y,0>=b?(this.m_count=this.m_v2.a=1,this.m_v1.Set(this.m_v2)):(c=1/(b+a),this.m_v1.a=b*c,this.m_v2.a=a*c,this.m_count=2))};Box2D.Collision.b2Simplex.prototype.Solve3=function(){var a=this.m_v1.w,b=this.m_v2.w,c=this.m_v3.w,d=Box2D.Common.Math.b2Math.SubtractVV(b,a),e=Box2D.Common.Math.b2Math.Dot(a,d),h=Box2D.Common.Math.b2Math.Dot(b,d),e=-e,g=Box2D.Common.Math.b2Math.SubtractVV(c,a),l=Box2D.Common.Math.b2Math.Dot(a,
g),k=Box2D.Common.Math.b2Math.Dot(c,g),l=-l,f=Box2D.Common.Math.b2Math.SubtractVV(c,b),m=Box2D.Common.Math.b2Math.Dot(b,f),f=Box2D.Common.Math.b2Math.Dot(c,f),m=-m,g=Box2D.Common.Math.b2Math.CrossVV(d,g),d=g*Box2D.Common.Math.b2Math.CrossVV(b,c),c=g*Box2D.Common.Math.b2Math.CrossVV(c,a),a=g*Box2D.Common.Math.b2Math.CrossVV(a,b);0>=e&&0>=l?this.m_count=this.m_v1.a=1:0<h&&0<e&&0>=a?(k=1/(h+e),this.m_v1.a=h*k,this.m_v2.a=e*k,this.m_count=2):0<k&&0<l&&0>=c?(h=1/(k+l),this.m_v1.a=k*h,this.m_v3.a=l*h,this.m_count=
2,this.m_v2.Set(this.m_v3)):0>=h&&0>=m?(this.m_count=this.m_v2.a=1,this.m_v1.Set(this.m_v2)):0>=k&&0>=f?(this.m_count=this.m_v3.a=1,this.m_v1.Set(this.m_v3)):0<f&&0<m&&0>=d?(h=1/(f+m),this.m_v2.a=f*h,this.m_v3.a=m*h,this.m_count=2,this.m_v1.Set(this.m_v3)):(h=1/(d+c+a),this.m_v1.a=d*h,this.m_v2.a=c*h,this.m_v3.a=a*h,this.m_count=3)};Box2D.Collision.b2SimplexCache=function(){this.indexA=[0,0,0];this.indexB=[0,0,0]};Box2D.Collision.b2SimplexVertex=function(){};Box2D.Collision.b2SimplexVertex.prototype.Set=
function(a){this.wA.SetV(a.wA);this.wB.SetV(a.wB);this.w.SetV(a.w);this.a=a.a;this.indexA=a.indexA;this.indexB=a.indexB};Box2D.Collision.b2TOIInput=function(){this.proxyA=new Box2D.Collision.b2DistanceProxy;this.proxyB=new Box2D.Collision.b2DistanceProxy;this.sweepA=new Box2D.Common.Math.b2Sweep;this.sweepB=new Box2D.Common.Math.b2Sweep};Box2D.Collision.b2TimeOfImpact={};Box2D.Collision.b2TimeOfImpact.TimeOfImpact=function(a){Box2D.Collision.b2TimeOfImpact.b2_toiCalls++;var b=a.proxyA,c=a.proxyB,
d=a.sweepA,e=a.sweepB,h=b.m_radius+c.m_radius;a=a.tolerance;var g=0,l=0,k=0;Box2D.Collision.b2TimeOfImpact.s_cache.count=0;for(Box2D.Collision.b2TimeOfImpact.s_distanceInput.useRadii=!1;;){d.GetTransform(Box2D.Collision.b2TimeOfImpact.s_xfA,g);e.GetTransform(Box2D.Collision.b2TimeOfImpact.s_xfB,g);Box2D.Collision.b2TimeOfImpact.s_distanceInput.proxyA=b;Box2D.Collision.b2TimeOfImpact.s_distanceInput.proxyB=c;Box2D.Collision.b2TimeOfImpact.s_distanceInput.transformA=Box2D.Collision.b2TimeOfImpact.s_xfA;
Box2D.Collision.b2TimeOfImpact.s_distanceInput.transformB=Box2D.Collision.b2TimeOfImpact.s_xfB;Box2D.Collision.b2Distance.Distance(Box2D.Collision.b2TimeOfImpact.s_distanceOutput,Box2D.Collision.b2TimeOfImpact.s_cache,Box2D.Collision.b2TimeOfImpact.s_distanceInput);if(0>=Box2D.Collision.b2TimeOfImpact.s_distanceOutput.distance){g=1;break}Box2D.Collision.b2TimeOfImpact.s_fcn.Initialize(Box2D.Collision.b2TimeOfImpact.s_cache,b,Box2D.Collision.b2TimeOfImpact.s_xfA,c,Box2D.Collision.b2TimeOfImpact.s_xfB);
var f=Box2D.Collision.b2TimeOfImpact.s_fcn.Evaluate(Box2D.Collision.b2TimeOfImpact.s_xfA,Box2D.Collision.b2TimeOfImpact.s_xfB);if(0>=f){g=1;break}0==l&&(k=f>h?Math.max(h-a,0.75*h):Math.max(f-a,0.02*h));if(f-k<0.5*a){if(0==l){g=1;break}break}var m=g,n=g,p=1;d.GetTransform(Box2D.Collision.b2TimeOfImpact.s_xfA,p);e.GetTransform(Box2D.Collision.b2TimeOfImpact.s_xfB,p);var q=Box2D.Collision.b2TimeOfImpact.s_fcn.Evaluate(Box2D.Collision.b2TimeOfImpact.s_xfA,Box2D.Collision.b2TimeOfImpact.s_xfB);if(q>=k){g=
1;break}for(var s=0;;){var r=0,r=s&1?n+(k-f)*(p-n)/(q-f):0.5*(n+p);d.GetTransform(Box2D.Collision.b2TimeOfImpact.s_xfA,r);e.GetTransform(Box2D.Collision.b2TimeOfImpact.s_xfB,r);var t=Box2D.Collision.b2TimeOfImpact.s_fcn.Evaluate(Box2D.Collision.b2TimeOfImpact.s_xfA,Box2D.Collision.b2TimeOfImpact.s_xfB);if(Math.abs(t-k)<0.025*a){m=r;break}t>k?(n=r,f=t):(p=r,q=t);s++;Box2D.Collision.b2TimeOfImpact.b2_toiRootIters++;if(50==s)break}Box2D.Collision.b2TimeOfImpact.b2_toiMaxRootIters=Math.max(Box2D.Collision.b2TimeOfImpact.b2_toiMaxRootIters,
s);if(m<(1+100*Number.MIN_VALUE)*g)break;g=m;l++;Box2D.Collision.b2TimeOfImpact.b2_toiIters++;if(1E3==l)break}Box2D.Collision.b2TimeOfImpact.b2_toiMaxIters=Math.max(Box2D.Collision.b2TimeOfImpact.b2_toiMaxIters,l);return g};Box2D.Collision.b2WorldManifold=function(){this.m_normal=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_points=[];for(var a=this.m_pointCount=0;a<Box2D.Common.b2Settings.b2_maxManifoldPoints;a++)this.m_points[a]=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Collision.b2WorldManifold.prototype.Initialize=
function(a,b,c,d,e){if(0!=a.m_pointCount){var h=0,g,l,k=0,f=0,m=0,n=0,p=0;g=0;switch(a.m_type){case Box2D.Collision.b2Manifold.e_circles:l=b.R;g=a.m_localPoint;h=b.position.x+l.col1.x*g.x+l.col2.x*g.y;b=b.position.y+l.col1.y*g.x+l.col2.y*g.y;l=d.R;g=a.m_points[0].m_localPoint;a=d.position.x+l.col1.x*g.x+l.col2.x*g.y;d=d.position.y+l.col1.y*g.x+l.col2.y*g.y;g=a-h;l=d-b;k=g*g+l*l;k>Box2D.Common.b2Settings.MIN_VALUE_SQUARED?(k=Math.sqrt(k),this.m_normal.x=g/k,this.m_normal.y=l/k):(this.m_normal.x=1,
this.m_normal.y=0);g=b+c*this.m_normal.y;d-=e*this.m_normal.y;this.m_points[0].x=0.5*(h+c*this.m_normal.x+(a-e*this.m_normal.x));this.m_points[0].y=0.5*(g+d);break;case Box2D.Collision.b2Manifold.e_faceA:l=b.R;g=a.m_localPlaneNormal;k=l.col1.x*g.x+l.col2.x*g.y;f=l.col1.y*g.x+l.col2.y*g.y;l=b.R;g=a.m_localPoint;m=b.position.x+l.col1.x*g.x+l.col2.x*g.y;n=b.position.y+l.col1.y*g.x+l.col2.y*g.y;this.m_normal.x=k;this.m_normal.y=f;for(h=0;h<a.m_pointCount;h++)l=d.R,g=a.m_points[h].m_localPoint,p=d.position.x+
l.col1.x*g.x+l.col2.x*g.y,g=d.position.y+l.col1.y*g.x+l.col2.y*g.y,this.m_points[h].x=p+0.5*(c-(p-m)*k-(g-n)*f-e)*k,this.m_points[h].y=g+0.5*(c-(p-m)*k-(g-n)*f-e)*f;break;case Box2D.Collision.b2Manifold.e_faceB:for(l=d.R,g=a.m_localPlaneNormal,k=l.col1.x*g.x+l.col2.x*g.y,f=l.col1.y*g.x+l.col2.y*g.y,l=d.R,g=a.m_localPoint,m=d.position.x+l.col1.x*g.x+l.col2.x*g.y,n=d.position.y+l.col1.y*g.x+l.col2.y*g.y,this.m_normal.x=-k,this.m_normal.y=-f,h=0;h<a.m_pointCount;h++)l=b.R,g=a.m_points[h].m_localPoint,
p=b.position.x+l.col1.x*g.x+l.col2.x*g.y,g=b.position.y+l.col1.y*g.x+l.col2.y*g.y,this.m_points[h].x=p+0.5*(e-(p-m)*k-(g-n)*f-c)*k,this.m_points[h].y=g+0.5*(e-(p-m)*k-(g-n)*f-c)*f}}};Box2D.Dynamics.b2Body=function(a,b){this.ID="Body"+Box2D.Dynamics.b2Body.NEXT_ID++;this.m_xf=new Box2D.Common.Math.b2Transform;this.m_xf.position.SetV(a.position);this.m_xf.R.Set(a.angle);this.m_sweep=new Box2D.Common.Math.b2Sweep;this.m_sweep.localCenter.SetZero();this.m_sweep.t0=1;this.m_sweep.a0=this.m_sweep.a=a.angle;
this.m_sweep.c.x=this.m_xf.R.col1.x*this.m_sweep.localCenter.x+this.m_xf.R.col2.x*this.m_sweep.localCenter.y;this.m_sweep.c.y=this.m_xf.R.col1.y*this.m_sweep.localCenter.x+this.m_xf.R.col2.y*this.m_sweep.localCenter.y;this.m_sweep.c.x+=this.m_xf.position.x;this.m_sweep.c.y+=this.m_xf.position.y;this.m_sweep.c0.SetV(this.m_sweep.c);this.m_linearVelocity=a.linearVelocity.Copy();this.m_force=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_bullet=a.bullet;this.m_fixedRotation=a.fixedRotation;this.m_allowSleep=
a.allowSleep;this.m_awake=a.awake;this.m_active=a.active;this.m_world=b;this.m_jointList=null;this.contactList=new Box2D.Dynamics.Contacts.b2ContactList;this.controllerList=new Box2D.Dynamics.Controllers.b2ControllerList;this.m_controllerCount=0;this.m_angularVelocity=a.angularVelocity;this.m_linearDamping=a.linearDamping;this.m_angularDamping=a.angularDamping;this.m_sleepTime=this.m_torque=0;this.m_type=a.type;this.m_mass=this.m_type==Box2D.Dynamics.b2BodyDef.b2_dynamicBody?1:0;this.m_invMass=this.m_type==
Box2D.Dynamics.b2BodyDef.b2_dynamicBody?1:0;this.m_invI=this.m_I=0;this.m_inertiaScale=a.inertiaScale;this.fixtureList=new Box2D.Dynamics.b2FixtureList;this.m_lists=[]};Box2D.Dynamics.b2Body.prototype.CreateFixture=function(a){a=new Box2D.Dynamics.b2Fixture(this,this.m_xf,a);this.m_active&&a.CreateProxy(this.m_world.m_contactManager.m_broadPhase,this.m_xf);this.fixtureList.AddFixture(a);a.m_body=this;0<a.m_density&&this.ResetMassData();this.m_world.m_newFixture=!0;return a};Box2D.Dynamics.b2Body.prototype.CreateFixture2=
function(a,b){void 0===b&&(b=0);var c=new Box2D.Dynamics.b2FixtureDef;c.shape=a;c.density=b;return this.CreateFixture(c)};Box2D.Dynamics.b2Body.prototype.Destroy=function(){Box2D.Common.Math.b2Vec2.Free(this.m_linearVelocity);Box2D.Common.Math.b2Vec2.Free(this.m_force)};Box2D.Dynamics.b2Body.prototype.DestroyFixture=function(a){this.fixtureList.RemoveFixture(a);for(var b=this.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);b;b=b.GetNextNode())a!=b.contact.m_fixtureA&&
a!=b.contact.m_fixtureB||this.m_world.m_contactManager.Destroy(b.contact);this.m_active&&a.DestroyProxy(this.m_world.m_contactManager.m_broadPhase);a.Destroy();a.m_body=null;this.ResetMassData()};Box2D.Dynamics.b2Body.prototype.SetPositionAndAngle=function(a,b){this.m_xf.R.Set(b);this.m_xf.position.SetV(a);var c=this.m_xf.R,d=this.m_sweep.localCenter;this.m_sweep.c.x=c.col1.x*d.x+c.col2.x*d.y;this.m_sweep.c.y=c.col1.y*d.x+c.col2.y*d.y;this.m_sweep.c.x+=this.m_xf.position.x;this.m_sweep.c.y+=this.m_xf.position.y;
this.m_sweep.c0.SetV(this.m_sweep.c);this.m_sweep.a0=this.m_sweep.a=b;c=this.m_world.m_contactManager.m_broadPhase;for(d=this.fixtureList.GetFirstNode();d;d=d.GetNextNode())d.fixture.Synchronize(c,this.m_xf,this.m_xf);this.m_world.m_contactManager.FindNewContacts()};Box2D.Dynamics.b2Body.prototype.SetTransform=function(a){this.SetPositionAndAngle(a.position,a.GetAngle())};Box2D.Dynamics.b2Body.prototype.GetTransform=function(){return this.m_xf};Box2D.Dynamics.b2Body.prototype.GetPosition=function(){return this.m_xf.position};
Box2D.Dynamics.b2Body.prototype.SetPosition=function(a){this.SetPositionAndAngle(a,this.GetAngle())};Box2D.Dynamics.b2Body.prototype.GetAngle=function(){return this.m_sweep.a};Box2D.Dynamics.b2Body.prototype.SetAngle=function(a){this.SetPositionAndAngle(this.GetPosition(),a)};Box2D.Dynamics.b2Body.prototype.GetWorldCenter=function(){return this.m_sweep.c};Box2D.Dynamics.b2Body.prototype.GetLocalCenter=function(){return this.m_sweep.localCenter};Box2D.Dynamics.b2Body.prototype.SetLinearVelocity=function(a){this.m_type!=
Box2D.Dynamics.b2BodyDef.b2_staticBody&&this.m_linearVelocity.SetV(a)};Box2D.Dynamics.b2Body.prototype.GetLinearVelocity=function(){return this.m_linearVelocity};Box2D.Dynamics.b2Body.prototype.SetAngularVelocity=function(a){void 0===a&&(a=0);this.m_type!=Box2D.Dynamics.b2BodyDef.b2_staticBody&&(this.m_angularVelocity=a)};Box2D.Dynamics.b2Body.prototype.GetAngularVelocity=function(){return this.m_angularVelocity};Box2D.Dynamics.b2Body.prototype.GetDefinition=function(){var a=new Box2D.Dynamics.b2BodyDef;
a.type=this.GetType();a.allowSleep=this.m_allowSleep;a.angle=this.GetAngle();a.angularDamping=this.m_angularDamping;a.angularVelocity=this.m_angularVelocity;a.fixedRotation=this.m_fixedRotation;a.bullet=this.m_bullet;a.active=this.m_active;a.awake=this.m_awake;a.linearDamping=this.m_linearDamping;a.linearVelocity.SetV(this.GetLinearVelocity());a.position=this.GetPosition();return a};Box2D.Dynamics.b2Body.prototype.ApplyForce=function(a,b){this.m_type==Box2D.Dynamics.b2BodyDef.b2_dynamicBody&&(this.SetAwake(!0),
this.m_force.x+=a.x,this.m_force.y+=a.y,this.m_torque+=(b.x-this.m_sweep.c.x)*a.y-(b.y-this.m_sweep.c.y)*a.x)};Box2D.Dynamics.b2Body.prototype.ApplyTorque=function(a){void 0===a&&(a=0);this.m_type==Box2D.Dynamics.b2BodyDef.b2_dynamicBody&&(this.SetAwake(!0),this.m_torque+=a)};Box2D.Dynamics.b2Body.prototype.ApplyImpulse=function(a,b){this.m_type==Box2D.Dynamics.b2BodyDef.b2_dynamicBody&&(this.SetAwake(!0),this.m_linearVelocity.x+=this.m_invMass*a.x,this.m_linearVelocity.y+=this.m_invMass*a.y,this.m_angularVelocity+=
this.m_invI*((b.x-this.m_sweep.c.x)*a.y-(b.y-this.m_sweep.c.y)*a.x))};Box2D.Dynamics.b2Body.prototype.Split=function(a){for(var b=this.GetLinearVelocity().Copy(),c=this.GetAngularVelocity(),d=this.GetWorldCenter(),e=this.m_world.CreateBody(this.GetDefinition()),h=this.fixtureList.GetFirstNode();h;h=h.GetNextNode()){var g=h.fixture;a(g)&&(this.fixtureList.RemoveFixture(g),e.fixtureList.AddFixture(g))}this.ResetMassData();e.ResetMassData();h=this.GetWorldCenter();a=e.GetWorldCenter();h=Box2D.Common.Math.b2Math.AddVV(b,
Box2D.Common.Math.b2Math.CrossFV(c,Box2D.Common.Math.b2Math.SubtractVV(h,d)));b=Box2D.Common.Math.b2Math.AddVV(b,Box2D.Common.Math.b2Math.CrossFV(c,Box2D.Common.Math.b2Math.SubtractVV(a,d)));this.SetLinearVelocity(h);e.SetLinearVelocity(b);this.SetAngularVelocity(c);e.SetAngularVelocity(c);this.SynchronizeFixtures();e.SynchronizeFixtures();return e};Box2D.Dynamics.b2Body.prototype.Merge=function(a){for(var b=a.fixtureList.GetFirstNode();b;b=b.GetNextNode())this.fixtureList.AddFixture(b.fixture),a.fixtureList.RemoveFixture(b.fixture);
a.ResetMassData();this.ResetMassData();this.SynchronizeFixtures()};Box2D.Dynamics.b2Body.prototype.GetMass=function(){return this.m_mass};Box2D.Dynamics.b2Body.prototype.GetInertia=function(){return this.m_I};Box2D.Dynamics.b2Body.prototype.GetMassData=function(a){a||(a=new Box2D.Collision.Shapes.b2MassData);a.mass=this.m_mass;a.I=this.m_I;a.center.SetV(this.m_sweep.localCenter);return a};Box2D.Dynamics.b2Body.prototype.SetMassData=function(a){if(this.m_type==Box2D.Dynamics.b2BodyDef.b2_dynamicBody){this.m_invI=
this.m_I=this.m_invMass=0;this.m_mass=a.mass;0>=this.m_mass&&(this.m_mass=1);this.m_invMass=1/this.m_mass;0<a.I&&!this.m_fixedRotation&&(this.m_I=a.I-this.m_mass*(a.center.x*a.center.x+a.center.y*a.center.y),this.m_invI=1/this.m_I);var b=this.m_sweep.c.Copy();this.m_sweep.localCenter.SetV(a.center);this.m_sweep.c0.SetV(Box2D.Common.Math.b2Math.MulX(this.m_xf,this.m_sweep.localCenter));this.m_sweep.c.SetV(this.m_sweep.c0);this.m_linearVelocity.x+=this.m_angularVelocity*-(this.m_sweep.c.y-b.y);this.m_linearVelocity.y+=
this.m_angularVelocity*+(this.m_sweep.c.x-b.x)}};Box2D.Dynamics.b2Body.prototype.ResetMassData=function(){this.m_invI=this.m_I=this.m_invMass=this.m_mass=0;this.m_sweep.localCenter.SetZero();if(this.m_type!=Box2D.Dynamics.b2BodyDef.b2_staticBody&&this.m_type!=Box2D.Dynamics.b2BodyDef.b2_kinematicBody){for(var a=Box2D.Common.Math.b2Vec2.Get(0,0),b=this.fixtureList.GetFirstNode();b;b=b.GetNextNode()){var c=b.fixture;0!=c.m_density&&(c=c.GetMassData(),this.m_mass+=c.mass,a.x+=c.center.x*c.mass,a.y+=
c.center.y*c.mass,this.m_I+=c.I)}0<this.m_mass?(this.m_invMass=1/this.m_mass,a.x*=this.m_invMass,a.y*=this.m_invMass):this.m_invMass=this.m_mass=1;0<this.m_I&&!this.m_fixedRotation?(this.m_I-=this.m_mass*(a.x*a.x+a.y*a.y),this.m_I*=this.m_inertiaScale,this.m_invI=1/this.m_I):this.m_invI=this.m_I=0;b=this.m_sweep.c.Copy();this.m_sweep.localCenter.SetV(a);this.m_sweep.c0.SetV(Box2D.Common.Math.b2Math.MulX(this.m_xf,this.m_sweep.localCenter));this.m_sweep.c.SetV(this.m_sweep.c0);this.m_linearVelocity.x+=
this.m_angularVelocity*-(this.m_sweep.c.y-b.y);this.m_linearVelocity.y+=this.m_angularVelocity*+(this.m_sweep.c.x-b.x);Box2D.Common.Math.b2Vec2.Free(a);Box2D.Common.Math.b2Vec2.Free(b)}};Box2D.Dynamics.b2Body.prototype.GetWorldPoint=function(a){var b=this.m_xf.R;a=Box2D.Common.Math.b2Vec2.Get(b.col1.x*a.x+b.col2.x*a.y,b.col1.y*a.x+b.col2.y*a.y);a.x+=this.m_xf.position.x;a.y+=this.m_xf.position.y;return a};Box2D.Dynamics.b2Body.prototype.GetWorldVector=function(a){return Box2D.Common.Math.b2Math.MulMV(this.m_xf.R,
a)};Box2D.Dynamics.b2Body.prototype.GetLocalPoint=function(a){return Box2D.Common.Math.b2Math.MulXT(this.m_xf,a)};Box2D.Dynamics.b2Body.prototype.GetLocalVector=function(a){return Box2D.Common.Math.b2Math.MulTMV(this.m_xf.R,a)};Box2D.Dynamics.b2Body.prototype.GetLinearVelocityFromWorldPoint=function(a){return Box2D.Common.Math.b2Vec2.Get(this.m_linearVelocity.x-this.m_angularVelocity*(a.y-this.m_sweep.c.y),this.m_linearVelocity.y+this.m_angularVelocity*(a.x-this.m_sweep.c.x))};Box2D.Dynamics.b2Body.prototype.GetLinearVelocityFromLocalPoint=
function(a){var b=this.m_xf.R;a=Box2D.Common.Math.b2Vec2.Get(b.col1.x*a.x+b.col2.x*a.y,b.col1.y*a.x+b.col2.y*a.y);a.x+=this.m_xf.position.x;a.y+=this.m_xf.position.y;b=Box2D.Common.Math.b2Vec2.Get(this.m_linearVelocity.x-this.m_angularVelocity*(a.y-this.m_sweep.c.y),this.m_linearVelocity.y+this.m_angularVelocity*(a.x-this.m_sweep.c.x));Box2D.Common.Math.b2Vec2.Free(a);return b};Box2D.Dynamics.b2Body.prototype.GetLinearDamping=function(){return this.m_linearDamping};Box2D.Dynamics.b2Body.prototype.SetLinearDamping=
function(a){this.m_linearDamping=a};Box2D.Dynamics.b2Body.prototype.GetAngularDamping=function(){return this.m_angularDamping};Box2D.Dynamics.b2Body.prototype.SetAngularDamping=function(a){this.m_angularDamping=a};Box2D.Dynamics.b2Body.prototype.SetType=function(a){if(this.m_type!=a){this.m_type=a;this.ResetMassData();this.m_type==Box2D.Dynamics.b2BodyDef.b2_staticBody&&(this.m_linearVelocity.SetZero(),this.m_angularVelocity=0);this.SetAwake(!0);this.m_force.SetZero();this.m_torque=0;for(a=this.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);a;a=
a.GetNextNode())a.contact.FlagForFiltering();for(a=0;a<this.m_lists.length;a++)this.m_lists[a].UpdateBody(this)}};Box2D.Dynamics.b2Body.prototype.GetType=function(){return this.m_type};Box2D.Dynamics.b2Body.prototype.SetBullet=function(a){this.m_bullet=a};Box2D.Dynamics.b2Body.prototype.IsBullet=function(){return this.m_bullet};Box2D.Dynamics.b2Body.prototype.SetSleepingAllowed=function(a){(this.m_allowSleep=a)||this.SetAwake(!0)};Box2D.Dynamics.b2Body.prototype.SetAwake=function(a){if(this.m_awake!=
a)for(this.m_awake=a,this.m_sleepTime=0,a||(this.m_linearVelocity.SetZero(),this.m_angularVelocity=0,this.m_force.SetZero(),this.m_torque=0),a=0;a<this.m_lists.length;a++)this.m_lists[a].UpdateBody(this)};Box2D.Dynamics.b2Body.prototype.IsAwake=function(){return this.m_awake};Box2D.Dynamics.b2Body.prototype.SetFixedRotation=function(a){this.m_fixedRotation=a;this.ResetMassData()};Box2D.Dynamics.b2Body.prototype.IsFixedRotation=function(){return this.m_fixedRotation};Box2D.Dynamics.b2Body.prototype.SetActive=
function(a){if(a!=this.m_active){if(a){this.m_active=!0;a=this.m_world.m_contactManager.m_broadPhase;for(var b=this.fixtureList.GetFirstNode();b;b=b.GetNextNode())b.fixture.CreateProxy(a,this.m_xf)}else{this.m_active=!1;a=this.m_world.m_contactManager.m_broadPhase;for(b=this.fixtureList.GetFirstNode();b;b=b.GetNextNode())b.fixture.DestroyProxy(a);for(a=this.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);a;a=a.GetNextNode())this.m_world.m_contactManager.Destroy(a.contact)}for(a=
0;a<this.m_lists.length;a++)this.m_lists[a].UpdateBody(this)}};Box2D.Dynamics.b2Body.prototype.IsActive=function(){return this.m_active};Box2D.Dynamics.b2Body.prototype.IsSleepingAllowed=function(){return this.m_allowSleep};Box2D.Dynamics.b2Body.prototype.GetFixtureList=function(){return this.fixtureList};Box2D.Dynamics.b2Body.prototype.GetJointList=function(){return this.m_jointList};Box2D.Dynamics.b2Body.prototype.GetControllerList=function(){return this.controllerList};Box2D.Dynamics.b2Body.prototype.AddController=
function(a){this.controllerList.AddController(a)};Box2D.Dynamics.b2Body.prototype.RemoveController=function(a){this.controllerList.RemoveController(a)};Box2D.Dynamics.b2Body.prototype.GetContactList=function(){return this.contactList};Box2D.Dynamics.b2Body.prototype.GetWorld=function(){return this.m_world};Box2D.Dynamics.b2Body.prototype.SynchronizeFixtures=function(){var a=Box2D.Dynamics.b2Body.s_xf1;a.R.Set(this.m_sweep.a0);var b=a.R,c=this.m_sweep.localCenter;a.position.x=this.m_sweep.c0.x-(b.col1.x*
c.x+b.col2.x*c.y);a.position.y=this.m_sweep.c0.y-(b.col1.y*c.x+b.col2.y*c.y);b=this.m_world.m_contactManager.m_broadPhase;for(c=this.fixtureList.GetFirstNode();c;c=c.GetNextNode())c.fixture.Synchronize(b,a,this.m_xf)};Box2D.Dynamics.b2Body.prototype.SynchronizeTransform=function(){this.m_xf.R.Set(this.m_sweep.a);var a=this.m_xf.R,b=this.m_sweep.localCenter;this.m_xf.position.x=this.m_sweep.c.x-(a.col1.x*b.x+a.col2.x*b.y);this.m_xf.position.y=this.m_sweep.c.y-(a.col1.y*b.x+a.col2.y*b.y)};Box2D.Dynamics.b2Body.prototype.ShouldCollide=
function(a){if(this.m_type!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody&&a.m_type!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody)return!1;for(var b=this.m_jointList;b;b=b.next)if(b.other==a&&!1==b.joint.m_collideConnected)return!1;return!0};Box2D.Dynamics.b2Body.prototype.Advance=function(a){this.m_sweep.Advance(a);this.m_sweep.c.SetV(this.m_sweep.c0);this.m_sweep.a=this.m_sweep.a0;this.SynchronizeTransform()};Box2D.Dynamics.b2Body.NEXT_ID=0;Box2D.Dynamics.b2BodyDef=function(){this.position=Box2D.Common.Math.b2Vec2.Get(0,
0);this.linearVelocity=Box2D.Common.Math.b2Vec2.Get(0,0);this.angularDamping=this.linearDamping=this.angularVelocity=this.angle=0;this.awake=this.allowSleep=!0;this.bullet=this.fixedRotation=!1;this.type=Box2D.Dynamics.b2BodyDef.b2_staticBody;this.active=!0;this.inertiaScale=1};Box2D.Dynamics.b2BodyDef.b2_staticBody=0;Box2D.Dynamics.b2BodyDef.b2_kinematicBody=1;Box2D.Dynamics.b2BodyDef.b2_dynamicBody=2;Box2D.Dynamics.b2BodyList=function(){this.bodyFirstNodes=[];for(var a=0;a<=Box2D.Dynamics.b2BodyList.TYPES.allBodies;a++)this.bodyFirstNodes[a]=
null;this.bodyLastNodes=[];for(a=0;a<=Box2D.Dynamics.b2BodyList.TYPES.allBodies;a++)this.bodyLastNodes[a]=null;this.bodyNodeLookup={};this.bodyCount=0};Box2D.Dynamics.b2BodyList.prototype.GetFirstNode=function(a){return this.bodyFirstNodes[a]};Box2D.Dynamics.b2BodyList.prototype.AddBody=function(a){var b=a.ID;null==this.bodyNodeLookup[b]&&(this.CreateNode(a,b,Box2D.Dynamics.b2BodyList.TYPES.allBodies),this.UpdateBody(a),a.m_lists.push(this),this.bodyCount++)};Box2D.Dynamics.b2BodyList.prototype.UpdateBody=
function(a){var b=a.GetType(),c=a.ID,d=a.IsAwake(),e=a.IsActive();b==Box2D.Dynamics.b2BodyDef.b2_dynamicBody?this.CreateNode(a,c,Box2D.Dynamics.b2BodyList.TYPES.dynamicBodies):this.RemoveNode(c,Box2D.Dynamics.b2BodyList.TYPES.dynamicBodies);b!=Box2D.Dynamics.b2BodyDef.b2_staticBody?this.CreateNode(a,c,Box2D.Dynamics.b2BodyList.TYPES.nonStaticBodies):this.RemoveNode(c,Box2D.Dynamics.b2BodyList.TYPES.nonStaticBodies);b!=Box2D.Dynamics.b2BodyDef.b2_staticBody&&e&&d?this.CreateNode(a,c,Box2D.Dynamics.b2BodyList.TYPES.nonStaticActiveAwakeBodies):
this.RemoveNode(c,Box2D.Dynamics.b2BodyList.TYPES.nonStaticActiveAwakeBodies);d?this.CreateNode(a,c,Box2D.Dynamics.b2BodyList.TYPES.awakeBodies):this.RemoveNode(c,Box2D.Dynamics.b2BodyList.TYPES.awakeBodies);e?this.CreateNode(a,c,Box2D.Dynamics.b2BodyList.TYPES.activeBodies):this.RemoveNode(c,Box2D.Dynamics.b2BodyList.TYPES.activeBodies)};Box2D.Dynamics.b2BodyList.prototype.RemoveBody=function(a){var b=a.ID;if(null!=this.bodyNodeLookup[b]){cr.arrayFindRemove(a.m_lists,this);for(a=0;a<=Box2D.Dynamics.b2BodyList.TYPES.allBodies;a++)this.RemoveNode(b,
a);delete this.bodyNodeLookup[b];this.bodyCount--}};Box2D.Dynamics.b2BodyList.prototype.RemoveNode=function(a,b){var c=this.bodyNodeLookup[a];if(null!=c){var d=c[b];null!=d&&(c[b]=null,c=d.GetPreviousNode(),d=d.GetNextNode(),null==c?this.bodyFirstNodes[b]=d:c.SetNextNode(d),null==d?this.bodyLastNodes[b]=c:d.SetPreviousNode(c))}};Box2D.Dynamics.b2BodyList.prototype.CreateNode=function(a,b,c){var d=this.bodyNodeLookup[b];if(null==d){for(var d=[],e=0;e<=Box2D.Dynamics.b2BodyList.TYPES.allBodies;e++)d[e]=
null;this.bodyNodeLookup[b]=d}null==d[c]&&(d[c]=new Box2D.Dynamics.b2BodyListNode(a),a=this.bodyLastNodes[c],null!=a?a.SetNextNode(d[c]):this.bodyFirstNodes[c]=d[c],d[c].SetPreviousNode(a),this.bodyLastNodes[c]=d[c])};Box2D.Dynamics.b2BodyList.prototype.GetBodyCount=function(){return this.bodyCount};Box2D.Dynamics.b2BodyList.TYPES={dynamicBodies:0,nonStaticBodies:1,activeBodies:2,nonStaticActiveAwakeBodies:3,awakeBodies:4,allBodies:5};Box2D.Dynamics.b2BodyListNode=function(a){this.body=a;this.previous=
this.next=null};Box2D.Dynamics.b2BodyListNode.prototype.SetNextNode=function(a){this.next=a};Box2D.Dynamics.b2BodyListNode.prototype.SetPreviousNode=function(a){this.previous=a};Box2D.Dynamics.b2BodyListNode.prototype.GetBody=function(){return this.body};Box2D.Dynamics.b2BodyListNode.prototype.GetNextNode=function(){return this.next};Box2D.Dynamics.b2BodyListNode.prototype.GetPreviousNode=function(){return this.previous};Box2D.Dynamics.b2ContactFilter=function(){};Box2D.Dynamics.b2ContactFilter.prototype.ShouldCollide=
function(a,b){var c=a.GetFilterData(),d=b.GetFilterData();return c.groupIndex==d.groupIndex&&0!=c.groupIndex?0<c.groupIndex:0!=(c.maskBits&d.categoryBits)&&0!=(c.categoryBits&d.maskBits)};Box2D.Dynamics.b2ContactFilter.b2_defaultFilter=new Box2D.Dynamics.b2ContactFilter;Box2D.Dynamics.b2ContactImpulse=function(){this.normalImpulses=[];this.tangentImpulses=[]};Box2D.Dynamics.b2ContactListener=function(){};Box2D.Dynamics.b2ContactListener.prototype.BeginContact=function(a){};Box2D.Dynamics.b2ContactListener.prototype.EndContact=
function(a){};Box2D.Dynamics.b2ContactListener.prototype.PreSolve=function(a,b){};Box2D.Dynamics.b2ContactListener.prototype.PostSolve=function(a,b){};Box2D.Dynamics.b2ContactManager=function(a){this.m_world=a;this.m_contactFilter=Box2D.Dynamics.b2ContactFilter.b2_defaultFilter;this.m_contactListener=Box2D.Dynamics.b2ContactListener.b2_defaultListener;this.m_contactFactory=new Box2D.Dynamics.Contacts.b2ContactFactory;this.m_broadPhase=new Box2D.Collision.b2DynamicTreeBroadPhase};Box2D.Dynamics.b2ContactManager.prototype.AddPair=
function(a,b){var c=a.GetBody(),d=b.GetBody();if(c!=d&&d.ShouldCollide(c)&&this.m_contactFilter.ShouldCollide(a,b)){for(c=d.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);c;c=c.GetNextNode())if(d=c.contact.m_fixtureA,d==a){if(d=c.contact.m_fixtureB,d==b)return}else if(d==b&&(d=c.contact.m_fixtureB,d==a))return;this.m_contactFactory.Create(a,b)}};Box2D.Dynamics.b2ContactManager.prototype.FindNewContacts=function(){var a=this;this.m_broadPhase.UpdatePairs(function(b,
c){a.AddPair(b,c)})};Box2D.Dynamics.b2ContactManager.prototype.Destroy=function(a){var b=a.m_fixtureB;a.m_fixtureA.GetBody();b.GetBody();a.touching&&this.m_contactListener.EndContact(a);0<a.m_manifold.m_pointCount&&(a.m_fixtureA.GetBody().SetAwake(!0),a.m_fixtureB.GetBody().SetAwake(!0));a.RemoveFromLists();this.m_contactFactory.Destroy(a)};Box2D.Dynamics.b2ContactManager.prototype.Collide=function(){for(var a=this.m_world.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);a;a=
a.GetNextNode()){var b=a.contact,c=b.m_fixtureA,d=b.m_fixtureB,e=c.GetBody(),h=d.GetBody();if(!1!=e.IsAwake()||!1!=h.IsAwake()){if(b.IsFiltering()){if(!1==h.ShouldCollide(e)){this.Destroy(b);continue}if(!1==this.m_contactFilter.ShouldCollide(c,d)){this.Destroy(b);continue}b.ClearFiltering()}!1==this.m_broadPhase.TestOverlap(c.m_proxy,d.m_proxy)?this.Destroy(b):b.Update(this.m_contactListener)}}};Box2D.Dynamics.b2DestructionListener=function(){};Box2D.Dynamics.b2DestructionListener.prototype.SayGoodbyeJoint=
function(a){};Box2D.Dynamics.b2DestructionListener.prototype.SayGoodbyeFixture=function(a){};Box2D.Dynamics.b2FilterData=function(){this.categoryBits=1;this.maskBits=65535;this.groupIndex=0};Box2D.Dynamics.b2FilterData.prototype.Copy=function(){var a=new Box2D.Dynamics.b2FilterData;a.categoryBits=this.categoryBits;a.maskBits=this.maskBits;a.groupIndex=this.groupIndex;return a};Box2D.Dynamics.b2Fixture=function(a,b,c){this.ID="Fixture"+Box2D.Dynamics.b2Fixture.NEXT_ID++;this.m_filter=c.filter.Copy();
this.m_aabb=Box2D.Collision.b2AABB.Get();this.m_body=a;this.m_shape=c.shape.Copy();this.m_density=c.density;this.m_friction=c.friction;this.m_restitution=c.restitution;this.m_isSensor=c.isSensor};Box2D.Dynamics.b2Fixture.prototype.GetShape=function(){return this.m_shape};Box2D.Dynamics.b2Fixture.prototype.SetSensor=function(a){if(this.m_isSensor!=a&&(this.m_isSensor=a,null!=this.m_body))for(a=this.m_body.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);a;a=a.GetNextNode()){var b=
a.contact.m_fixtureA,c=a.contact.m_fixtureB;b!=this&&c!=this||a.contact.SetSensor(b.sensor||c.sensor)}};Box2D.Dynamics.b2Fixture.prototype.IsSensor=function(){return this.m_isSensor};Box2D.Dynamics.b2Fixture.prototype.SetFilterData=function(a){this.m_filter=a.Copy();if(null!=this.m_body)for(a=this.m_body.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);a;a=a.GetNextNode())a.contact.m_fixtureA!=this&&a.contact.m_fixtureB!=this||a.contact.FlagForFiltering()};Box2D.Dynamics.b2Fixture.prototype.GetFilterData=
function(){return this.m_filter.Copy()};Box2D.Dynamics.b2Fixture.prototype.GetBody=function(){return this.m_body};Box2D.Dynamics.b2Fixture.prototype.TestPoint=function(a){return this.m_shape.TestPoint(this.m_body.GetTransform(),a)};Box2D.Dynamics.b2Fixture.prototype.RayCast=function(a,b){return this.m_shape.RayCast(a,b,this.m_body.GetTransform())};Box2D.Dynamics.b2Fixture.prototype.GetMassData=function(a){a||(a=new Box2D.Collision.Shapes.b2MassData);this.m_shape.ComputeMass(a,this.m_density);return a};
Box2D.Dynamics.b2Fixture.prototype.SetDensity=function(a){this.m_density=a};Box2D.Dynamics.b2Fixture.prototype.GetDensity=function(){return this.m_density};Box2D.Dynamics.b2Fixture.prototype.GetFriction=function(){return this.m_friction};Box2D.Dynamics.b2Fixture.prototype.SetFriction=function(a){this.m_friction=a};Box2D.Dynamics.b2Fixture.prototype.GetRestitution=function(){return this.m_restitution};Box2D.Dynamics.b2Fixture.prototype.SetRestitution=function(a){this.m_restitution=a};Box2D.Dynamics.b2Fixture.prototype.GetAABB=
function(){return this.m_aabb};Box2D.Dynamics.b2Fixture.prototype.Destroy=function(){Box2D.Collision.b2AABB.Free(this.m_aabb)};Box2D.Dynamics.b2Fixture.prototype.CreateProxy=function(a,b){this.m_shape.ComputeAABB(this.m_aabb,b);this.m_proxy=a.CreateProxy(this.m_aabb,this)};Box2D.Dynamics.b2Fixture.prototype.DestroyProxy=function(a){null!=this.m_proxy&&(a.DestroyProxy(this.m_proxy),this.m_proxy=null)};Box2D.Dynamics.b2Fixture.prototype.Synchronize=function(a,b,c){if(this.m_proxy){var d=Box2D.Collision.b2AABB.Get(),
e=Box2D.Collision.b2AABB.Get();this.m_shape.ComputeAABB(d,b);this.m_shape.ComputeAABB(e,c);this.m_aabb.Combine(d,e);Box2D.Collision.b2AABB.Free(d);Box2D.Collision.b2AABB.Free(e);b=Box2D.Common.Math.b2Math.SubtractVV(c.position,b.position);a.MoveProxy(this.m_proxy,this.m_aabb,b);Box2D.Common.Math.b2Vec2.Free(b)}};Box2D.Dynamics.b2Fixture.NEXT_ID=0;Box2D.Dynamics.b2FixtureDef=function(){this.filter=new Box2D.Dynamics.b2FilterData;this.filter.categoryBits=1;this.filter.maskBits=65535;this.filter.groupIndex=
0;this.shape=null;this.friction=0.2;this.density=this.restitution=0;this.isSensor=!1};Box2D.Dynamics.b2FixtureList=function(){this.fixtureLastNode=this.fixtureFirstNode=null;this.fixtureNodeLookup={};this.fixtureCount=0};Box2D.Dynamics.b2FixtureList.prototype.GetFirstNode=function(){return this.fixtureFirstNode};Box2D.Dynamics.b2FixtureList.prototype.AddFixture=function(a){var b=a.ID;if(null==this.fixtureNodeLookup[b]){a=new Box2D.Dynamics.b2FixtureListNode(a);var c=this.fixtureLastNode;null!=c?c.SetNextNode(a):
this.fixtureFirstNode=a;a.SetPreviousNode(c);this.fixtureLastNode=a;this.fixtureNodeLookup[b]=a;this.fixtureCount++}};Box2D.Dynamics.b2FixtureList.prototype.RemoveFixture=function(a){a=a.ID;var b=this.fixtureNodeLookup[a];if(null!=b){var c=b.GetPreviousNode(),b=b.GetNextNode();null==c?this.fixtureFirstNode=b:c.SetNextNode(b);null==b?this.fixtureLastNode=c:b.SetPreviousNode(c);delete this.fixtureNodeLookup[a];this.fixtureCount--}};Box2D.Dynamics.b2FixtureList.prototype.GetFixtureCount=function(){return this.fixtureCount};
Box2D.Dynamics.b2FixtureListNode=function(a){this.fixture=a;this.previous=this.next=null};Box2D.Dynamics.b2FixtureListNode.prototype.SetNextNode=function(a){this.next=a};Box2D.Dynamics.b2FixtureListNode.prototype.SetPreviousNode=function(a){this.previous=a};Box2D.Dynamics.b2FixtureListNode.prototype.GetNextNode=function(){return this.next};Box2D.Dynamics.b2FixtureListNode.prototype.GetPreviousNode=function(){return this.previous};Box2D.Dynamics.b2Island=function(a,b){this.m_listener=a;this.m_contactSolver=
b;this.m_bodies=[];this.m_dynamicBodies=[];this.m_nonStaticBodies=[];this.m_contacts=[];this.m_joints=[]};Box2D.Dynamics.b2Island.prototype.Clear=function(){this.m_bodies=[];this.m_dynamicBodies=[];this.m_nonStaticBodies=[];this.m_contacts=[];this.m_joints=[]};Box2D.Dynamics.b2Island.prototype.Solve=function(a,b,c){this._InitializeVelocities(a,b);this.m_contactSolver.Initialize(a,this.m_contacts,this.m_contacts.length);this._SolveVelocityConstraints(a);this._SolveBodies(a);this._SolvePositionConstraints(a);
this.Report(this.m_contactSolver.m_constraints);c&&this._SleepIfTired(a)};Box2D.Dynamics.b2Island.prototype._InitializeVelocities=function(a,b){for(var c=0;c<this.m_dynamicBodies.length;c++){var d=this.m_dynamicBodies[c];d.m_linearVelocity.x+=a.dt*(b.x+d.m_invMass*d.m_force.x);d.m_linearVelocity.y+=a.dt*(b.y+d.m_invMass*d.m_force.y);d.m_angularVelocity+=a.dt*d.m_invI*d.m_torque;d.m_linearVelocity.Multiply(Box2D.Common.Math.b2Math.Clamp(1-a.dt*d.m_linearDamping,0,1));d.m_angularVelocity*=Box2D.Common.Math.b2Math.Clamp(1-
a.dt*d.m_angularDamping,0,1)}};Box2D.Dynamics.b2Island.prototype._SolveVelocityConstraints=function(a){this.m_contactSolver.InitVelocityConstraints(a);for(var b=0;b<this.m_joints.length;b++)this.m_joints[b].InitVelocityConstraints(a);for(b=0;b<a.velocityIterations;b++){for(var c=0;c<this.m_joints.length;c++)this.m_joints[c].SolveVelocityConstraints(a);this.m_contactSolver.SolveVelocityConstraints()}for(a=0;a<this.m_joints.length;a++)this.m_joints[a].FinalizeVelocityConstraints();this.m_contactSolver.FinalizeVelocityConstraints()};
Box2D.Dynamics.b2Island.prototype._SolveBodies=function(a){for(var b=0;b<this.m_nonStaticBodies.length;++b){var c=this.m_nonStaticBodies[b],d=a.dt*c.m_linearVelocity.x,e=a.dt*c.m_linearVelocity.y;d*d+e*e>Box2D.Common.b2Settings.b2_maxTranslationSquared&&(c.m_linearVelocity.Normalize(),c.m_linearVelocity.x=c.m_linearVelocity.x*Box2D.Common.b2Settings.b2_maxTranslation*a.inv_dt,c.m_linearVelocity.y=c.m_linearVelocity.y*Box2D.Common.b2Settings.b2_maxTranslation*a.inv_dt);d=a.dt*c.m_angularVelocity;d*
d>Box2D.Common.b2Settings.b2_maxRotationSquared&&(c.m_angularVelocity=0>c.m_angularVelocity?-Box2D.Common.b2Settings.b2_maxRotation*a.inv_dt:Box2D.Common.b2Settings.b2_maxRotation*a.inv_dt);c.m_sweep.c0.SetV(c.m_sweep.c);c.m_sweep.a0=c.m_sweep.a;c.m_sweep.c.x+=a.dt*c.m_linearVelocity.x;c.m_sweep.c.y+=a.dt*c.m_linearVelocity.y;c.m_sweep.a+=a.dt*c.m_angularVelocity;c.SynchronizeTransform()}};Box2D.Dynamics.b2Island.prototype._SolvePositionConstraints=function(a){for(var b=0;b<a.positionIterations;b++){for(var c=
this.m_contactSolver.SolvePositionConstraints(Box2D.Common.b2Settings.b2_contactBaumgarte),d=!0,e=0;e<this.m_joints.length;e++)var h=this.m_joints[e].SolvePositionConstraints(Box2D.Common.b2Settings.b2_contactBaumgarte),d=d&&h;if(c&&d)break}};Box2D.Dynamics.b2Island.prototype._SleepIfTired=function(a){for(var b=Number.MAX_VALUE,c=0;c<this.m_nonStaticBodies.length;c++){var d=this.m_nonStaticBodies[c];!d.m_allowSleep||Math.abs(d.m_angularVelocity)>Box2D.Common.b2Settings.b2_angularSleepTolerance||Box2D.Common.Math.b2Math.Dot(d.m_linearVelocity,
d.m_linearVelocity)>Box2D.Common.b2Settings.b2_linearSleepToleranceSquared?b=d.m_sleepTime=0:(d.m_sleepTime+=a.dt,b=Math.min(b,d.m_sleepTime))}if(b>=Box2D.Common.b2Settings.b2_timeToSleep)for(a=0;a<this.m_bodies.length;a++)this.m_bodies[a].SetAwake(!1)};Box2D.Dynamics.b2Island.prototype.SolveTOI=function(a){var b=0,c=0;this.m_contactSolver.Initialize(a,this.m_contacts,this.m_contacts.length);for(var d=this.m_contactSolver,b=0;b<this.m_joints.length;++b)this.m_joints[b].InitVelocityConstraints(a);
for(b=0;b<a.velocityIterations;++b)for(d.SolveVelocityConstraints(),c=0;c<this.m_joints.length;++c)this.m_joints[c].SolveVelocityConstraints(a);for(b=0;b<this.m_nonStaticBodies.length;++b){var c=this.m_nonStaticBodies[b],e=a.dt*c.m_linearVelocity.x,h=a.dt*c.m_linearVelocity.y;e*e+h*h>Box2D.Common.b2Settings.b2_maxTranslationSquared&&(c.m_linearVelocity.Normalize(),c.m_linearVelocity.x=c.m_linearVelocity.x*Box2D.Common.b2Settings.b2_maxTranslation*a.inv_dt,c.m_linearVelocity.y=c.m_linearVelocity.y*
Box2D.Common.b2Settings.b2_maxTranslation*a.inv_dt);e=a.dt*c.m_angularVelocity;e*e>Box2D.Common.b2Settings.b2_maxRotationSquared&&(c.m_angularVelocity=0>c.m_angularVelocity?-Box2D.Common.b2Settings.b2_maxRotation*a.inv_dt:Box2D.Common.b2Settings.b2_maxRotation*a.inv_dt);c.m_sweep.c0.SetV(c.m_sweep.c);c.m_sweep.a0=c.m_sweep.a;c.m_sweep.c.x+=a.dt*c.m_linearVelocity.x;c.m_sweep.c.y+=a.dt*c.m_linearVelocity.y;c.m_sweep.a+=a.dt*c.m_angularVelocity;c.SynchronizeTransform()}for(b=0;b<a.positionIterations;++b){e=
d.SolvePositionConstraints(0.75);h=!0;for(c=0;c<this.m_joints.length;++c)var g=this.m_joints[c].SolvePositionConstraints(Box2D.Common.b2Settings.b2_contactBaumgarte),h=h&&g;if(e&&h)break}this.Report(d.m_constraints)};Box2D.Dynamics.b2Island.prototype.Report=function(a){if(null!=this.m_listener)for(var b=0;b<this.m_contacts.length;++b){for(var c=this.m_contacts[b],d=a[b],e=new Box2D.Dynamics.b2ContactImpulse,h=0;h<d.pointCount;++h)e.normalImpulses[h]=d.points[h].normalImpulse,e.tangentImpulses[h]=
d.points[h].tangentImpulse;this.m_listener.PostSolve(c,e)}};Box2D.Dynamics.b2Island.prototype.AddBody=function(a){this.m_bodies.push(a);a.GetType()!=Box2D.Dynamics.b2BodyDef.b2_staticBody&&(this.m_nonStaticBodies.push(a),a.GetType()==Box2D.Dynamics.b2BodyDef.b2_dynamicBody&&this.m_dynamicBodies.push(a))};Box2D.Dynamics.b2Island.prototype.AddContact=function(a){this.m_contacts.push(a)};Box2D.Dynamics.b2Island.prototype.AddJoint=function(a){this.m_joints.push(a)};Box2D.Dynamics.b2TimeStep=function(a,
b,c,d,e){this.dt=a;var h=0;0<a&&(h=1/a);this.inv_dt=h;this.dtRatio=b;this.positionIterations=c;this.velocityIterations=d;this.warmStarting=e};Box2D.Dynamics.b2World=function(a,b){this.m_contactManager=new Box2D.Dynamics.b2ContactManager(this);this.m_contactSolver=new Box2D.Dynamics.Contacts.b2ContactSolver;this.m_newFixture=this.m_isLocked=!1;this.m_destructionListener=null;this.bodyList=new Box2D.Dynamics.b2BodyList;this.contactList=new Box2D.Dynamics.Contacts.b2ContactList;this.m_jointList=null;
this.controllerList=new Box2D.Dynamics.Controllers.b2ControllerList;this.m_jointCount=0;this.m_continuousPhysics=this.m_warmStarting=!0;this.m_allowSleep=b;this.m_gravity=a;this.m_inv_dt0=0;this.m_groundBody=this.CreateBody(new Box2D.Dynamics.b2BodyDef)};Box2D.Dynamics.b2World.MAX_TOI=1-100*Number.MIN_VALUE;Box2D.Dynamics.b2World.prototype.SetDestructionListener=function(a){this.m_destructionListener=a};Box2D.Dynamics.b2World.prototype.SetContactFilter=function(a){this.m_contactManager.m_contactFilter=
a};Box2D.Dynamics.b2World.prototype.SetContactListener=function(a){this.m_contactManager.m_contactListener=a};Box2D.Dynamics.b2World.prototype.SetBroadPhase=function(a){var b=this.m_contactManager.m_broadPhase;this.m_contactManager.m_broadPhase=a;for(var c=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.allBodies);c;c=c.GetNextNode())for(var d=c.body.GetFixtureList().GetFirstNode();d;d=d.GetNextNode()){var e=d.fixture;e.m_proxy=a.CreateProxy(b.GetFatAABB(e.m_proxy),e)}};Box2D.Dynamics.b2World.prototype.GetProxyCount=
function(){return this.m_contactManager.m_broadPhase.GetProxyCount()};Box2D.Dynamics.b2World.prototype.CreateBody=function(a){a=new Box2D.Dynamics.b2Body(a,this);this.bodyList.AddBody(a);return a};Box2D.Dynamics.b2World.prototype.DestroyBody=function(a){for(var b=a.m_jointList;b;){var c=b,b=b.next;this.m_destructionListener&&this.m_destructionListener.SayGoodbyeJoint(c.joint);this.DestroyJoint(c.joint)}for(b=a.GetControllerList().GetFirstNode();b;b=b.GetNextNode())b.controller.RemoveBody(a);for(b=
a.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);b;b=b.GetNextNode())this.m_contactManager.Destroy(b.contact);for(b=a.GetFixtureList().GetFirstNode();b;b=b.GetNextNode())this.m_destructionListener&&this.m_destructionListener.SayGoodbyeFixture(b.fixture),a.DestroyFixture(b.fixture);a.Destroy();this.bodyList.RemoveBody(a)};Box2D.Dynamics.b2World.prototype.CreateJoint=function(a){var b=Box2D.Dynamics.Joints.b2Joint.Create(a);b.m_prev=null;if(b.m_next=this.m_jointList)this.m_jointList.m_prev=
b;this.m_jointList=b;this.m_jointCount++;b.m_edgeA.joint=b;b.m_edgeA.other=b.m_bodyB;b.m_edgeA.prev=null;if(b.m_edgeA.next=b.m_bodyA.m_jointList)b.m_bodyA.m_jointList.prev=b.m_edgeA;b.m_bodyA.m_jointList=b.m_edgeA;b.m_edgeB.joint=b;b.m_edgeB.other=b.m_bodyA;b.m_edgeB.prev=null;if(b.m_edgeB.next=b.m_bodyB.m_jointList)b.m_bodyB.m_jointList.prev=b.m_edgeB;b.m_bodyB.m_jointList=b.m_edgeB;var c=a.bodyA,d=a.bodyB;if(!a.collideConnected)for(a=d.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);a;a=
a.GetNextNode())a.contact.GetOther(d)==c&&a.contact.FlagForFiltering();return b};Box2D.Dynamics.b2World.prototype.DestroyJoint=function(a){var b=a.m_collideConnected;a.m_prev&&(a.m_prev.m_next=a.m_next);a.m_next&&(a.m_next.m_prev=a.m_prev);a==this.m_jointList&&(this.m_jointList=a.m_next);var c=a.m_bodyA,d=a.m_bodyB;c.SetAwake(!0);d.SetAwake(!0);a.m_edgeA.prev&&(a.m_edgeA.prev.next=a.m_edgeA.next);a.m_edgeA.next&&(a.m_edgeA.next.prev=a.m_edgeA.prev);a.m_edgeA==c.m_jointList&&(c.m_jointList=a.m_edgeA.next);
a.m_edgeA.prev=null;a.m_edgeA.next=null;a.m_edgeB.prev&&(a.m_edgeB.prev.next=a.m_edgeB.next);a.m_edgeB.next&&(a.m_edgeB.next.prev=a.m_edgeB.prev);a.m_edgeB==d.m_jointList&&(d.m_jointList=a.m_edgeB.next);a.m_edgeB.prev=null;a.m_edgeB.next=null;this.m_jointCount--;if(!b)for(a=d.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);a;a=a.GetNextNode())a.contact.GetOther(d)==c&&a.contact.FlagForFiltering()};Box2D.Dynamics.b2World.prototype.GetControllerList=function(){return this.controllerList};
Box2D.Dynamics.b2World.prototype.AddController=function(a){if(null!==a.m_world&&a.m_world!=this)throw Error("Controller can only be a member of one world");this.controllerList.AddController(a);a.m_world=this;return a};Box2D.Dynamics.b2World.prototype.RemoveController=function(a){this.controllerList.RemoveController(a);a.m_world=null;a.Clear()};Box2D.Dynamics.b2World.prototype.CreateController=function(a){return this.AddController(a)};Box2D.Dynamics.b2World.prototype.DestroyController=function(a){this.RemoveController(a)};
Box2D.Dynamics.b2World.prototype.SetWarmStarting=function(a){this.m_warmStarting=a};Box2D.Dynamics.b2World.prototype.SetContinuousPhysics=function(a){this.m_continuousPhysics=a};Box2D.Dynamics.b2World.prototype.GetBodyCount=function(){return this.bodyList.GetBodyCount()};Box2D.Dynamics.b2World.prototype.GetJointCount=function(){return this.m_jointCount};Box2D.Dynamics.b2World.prototype.GetContactCount=function(){return this.contactList.GetContactCount()};Box2D.Dynamics.b2World.prototype.SetGravity=
function(a){this.m_gravity=a};Box2D.Dynamics.b2World.prototype.GetGravity=function(){return this.m_gravity};Box2D.Dynamics.b2World.prototype.GetGroundBody=function(){return this.m_groundBody};Box2D.Dynamics.b2World.prototype.Step=function(a,b,c){this.m_newFixture&&(this.m_contactManager.FindNewContacts(),this.m_newFixture=!1);this.m_isLocked=!0;a=new Box2D.Dynamics.b2TimeStep(a,this.m_inv_dt0*a,b,c,this.m_warmStarting);this.m_contactManager.Collide();0<a.dt&&(this.Solve(a),this.m_continuousPhysics&&
this.SolveTOI(a),this.m_inv_dt0=a.inv_dt);this.m_isLocked=!1};Box2D.Dynamics.b2World.prototype.ClearForces=function(){for(var a=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.dynamicBodies);a;a=a.GetNextNode())a.body.m_force.SetZero(),a.body.m_torque=0};Box2D.Dynamics.b2World.prototype.QueryAABB=function(a,b){this.m_contactManager.m_broadPhase.Query(a,b)};Box2D.Dynamics.b2World.prototype.QueryPoint=function(a,b){var c=Box2D.Collision.b2AABB.Get();c.lowerBound_.Set(b.x-Box2D.Common.b2Settings.b2_linearSlop,
b.y-Box2D.Common.b2Settings.b2_linearSlop);c.upperBound_.Set(b.x+Box2D.Common.b2Settings.b2_linearSlop,b.y+Box2D.Common.b2Settings.b2_linearSlop);this.m_contactManager.m_broadPhase.Query(function(c){return c.TestPoint(b)?a(c):!0},c);Box2D.Collision.b2AABB.Free(c)};Box2D.Dynamics.b2World.prototype.RayCast=function(a,b,c){var d=this.m_contactManager.m_broadPhase,e=new Box2D.Collision.b2RayCastOutput,h=new Box2D.Collision.b2RayCastInput(b,c,1);d.RayCast(function(d,h){if(h.RayCast(e,d)){var k=1-e.fraction,
k=Box2D.Common.Math.b2Vec2.Get(k*b.x+e.fraction*c.x,k*b.y+e.fraction*c.y),f=a(h,k,e.normal,e.fraction);Box2D.Common.Math.b2Vec2.Free(k);return f}return d.maxFraction},h)};Box2D.Dynamics.b2World.prototype.RayCastOne=function(a,b){var c=null;this.RayCast(function(a,b,h,g){c=a;return g},a,b);return c};Box2D.Dynamics.b2World.prototype.RayCastAll=function(a,b){var c=[];this.RayCast(function(a,b,h,g){c.push(a);return 1},a,b);return c};Box2D.Dynamics.b2World.prototype.GetBodyList=function(){return this.bodyList};
Box2D.Dynamics.b2World.prototype.GetJointList=function(){return this.m_jointList};Box2D.Dynamics.b2World.prototype.GetContactList=function(){return this.contactList};Box2D.Dynamics.b2World.prototype.IsLocked=function(){return this.m_isLocked};var b2solvearray=[];Box2D.Dynamics.b2World.prototype.Solve=function(a){for(var b=this.controllerList.GetFirstNode();b;b=b.GetNextNode())b.controller.Step(a);for(var b=new Box2D.Dynamics.b2Island(this.m_contactManager.m_contactListener,this.m_contactSolver),c=
this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.allBodies);c;c=c.GetNextNode())c.body.m_islandFlag=!1;for(var d=this.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);d;d=d.GetNextNode())d.contact.m_islandFlag=!1;for(c=this.m_jointList;c;c=c.m_next)c.m_islandFlag=!1;for(c=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.nonStaticActiveAwakeBodies);c;c=c.GetNextNode())if(d=c.body,!d.m_islandFlag){b.Clear();b2solvearray.length=0;var e=b2solvearray;
e.push(d);for(d.m_islandFlag=!0;0<e.length;){var h=e.pop();b.AddBody(h);h.IsAwake()||h.SetAwake(!0);if(h.GetType()!=Box2D.Dynamics.b2BodyDef.b2_staticBody){for(d=h.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.nonSensorEnabledTouchingContacts);d;d=d.GetNextNode()){var g=d.contact;g.m_islandFlag||(b.AddContact(g),g.m_islandFlag=!0,g=g.GetOther(h),g.m_islandFlag||(e.push(g),g.m_islandFlag=!0))}for(d=h.m_jointList;d;d=d.next)!d.joint.m_islandFlag&&d.other.IsActive()&&(b.AddJoint(d.joint),
d.joint.m_islandFlag=!0,d.other.m_islandFlag||(e.push(d.other),d.other.m_islandFlag=!0))}}b.Solve(a,this.m_gravity,this.m_allowSleep)}for(c=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.nonStaticActiveAwakeBodies);c;c=c.GetNextNode())c.body.SynchronizeFixtures();this.m_contactManager.FindNewContacts()};Box2D.Dynamics.b2World.prototype.SolveTOI=function(a){for(var b=new Box2D.Dynamics.b2Island(this.m_contactManager.m_contactListener,this.m_contactSolver),c=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.allBodies);c;c=
c.GetNextNode()){var d=c.body;d.m_islandFlag=!1;d.m_sweep.t0=0}for(var e=this.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);e;e=e.GetNextNode())e.contact.m_islandFlag=!1,e.contact.m_toi=null;for(c=this.m_jointList;c;c=c.m_next)c.m_islandFlag=!1;for(;;){var c=this._SolveTOI2(a),h=c.minContact,c=c.minTOI;if(null===h||Box2D.Dynamics.b2World.MAX_TOI<c)break;e=h.m_fixtureA.GetBody();d=h.m_fixtureB.GetBody();Box2D.Dynamics.b2World.s_backupA.Set(e.m_sweep);Box2D.Dynamics.b2World.s_backupB.Set(d.m_sweep);
e.Advance(c);d.Advance(c);h.Update(this.m_contactManager.m_contactListener);h.m_toi=null;if(h.sensor||!h.enabled)e.m_sweep.Set(Box2D.Dynamics.b2World.s_backupA),d.m_sweep.Set(Box2D.Dynamics.b2World.s_backupB),e.SynchronizeTransform(),d.SynchronizeTransform();else if(h.touching){e.GetType()!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody&&(e=d);b.Clear();b2solvearray.length=0;h=b2solvearray;h.push(e);for(e.m_islandFlag=!0;0<h.length;)if(d=h.pop(),b.AddBody(d),d.IsAwake()||d.SetAwake(!0),d.GetType()==Box2D.Dynamics.b2BodyDef.b2_dynamicBody){for(e=
d.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.nonSensorEnabledTouchingContacts);e&&b.m_contactCount!=Box2D.Common.b2Settings.b2_maxTOIContactsPerIsland;e=e.GetNextNode()){var g=e.contact;g.m_islandFlag||(b.AddContact(g),g.m_islandFlag=!0,g=g.GetOther(d),g.m_islandFlag||(g.GetType()!=Box2D.Dynamics.b2BodyDef.b2_staticBody&&(g.Advance(c),g.SetAwake(!0),h.push(g)),g.m_islandFlag=!0))}for(d=d.m_jointList;d;d=d.next)b.m_jointCount!=Box2D.Common.b2Settings.b2_maxTOIJointsPerIsland&&
!d.joint.m_islandFlag&&d.other.IsActive()&&(b.AddJoint(d.joint),d.joint.m_islandFlag=!0,d.other.m_islandFlag||(d.other.GetType()!=Box2D.Dynamics.b2BodyDef.b2_staticBody&&(d.other.Advance(c),d.other.SetAwake(!0),h.push(d.other)),d.other.m_islandFlag=!0))}b.SolveTOI(new Box2D.Dynamics.b2TimeStep((1-c)*a.dt,0,a.velocityIterations,a.positionIterations,!1));for(c=0;c<b.m_bodies.length;c++)if(b.m_bodies[c].m_islandFlag=!1,b.m_bodies[c].IsAwake()&&b.m_bodies[c].GetType()==Box2D.Dynamics.b2BodyDef.b2_dynamicBody)for(b.m_bodies[c].SynchronizeFixtures(),
e=b.m_bodies[c].contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);e;e=e.GetNextNode())e.contact.m_toi=null;for(c=0;c<b.m_contactCount;c++)b.m_contacts[c].m_islandFlag=!1,b.m_contacts[c].m_toi=null;for(c=0;c<b.m_jointCount;c++)b.m_joints[c].m_islandFlag=!1;this.m_contactManager.FindNewContacts()}}};Box2D.Dynamics.b2World.prototype._SolveTOI2=function(a){for(var b=null,c=1,d=this.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.nonSensorEnabledContinuousContacts);d;d=
d.GetNextNode()){var e=d.contact;if(!this._SolveTOI2SkipContact(a,e)){var h=1;if(null!=e.m_toi)h=e.m_toi;else{if(e.touching)h=1;else{var h=e.m_fixtureA.GetBody(),g=e.m_fixtureB.GetBody(),l=h.m_sweep.t0;h.m_sweep.t0<g.m_sweep.t0?(l=g.m_sweep.t0,h.m_sweep.Advance(l)):g.m_sweep.t0<h.m_sweep.t0&&(l=h.m_sweep.t0,g.m_sweep.Advance(l));h=e.ComputeTOI(h.m_sweep,g.m_sweep);0<h&&1>h&&(h=(1-h)*l+h)}e.m_toi=h}Number.MIN_VALUE<h&&h<c&&(b=e,c=h)}}return{minContact:b,minTOI:c}};Box2D.Dynamics.b2World.prototype._SolveTOI2SkipContact=
function(a,b){var c=b.m_fixtureA.GetBody(),d=b.m_fixtureB.GetBody();return c.GetType()==Box2D.Dynamics.b2BodyDef.b2_dynamicBody&&c.IsAwake()||d.GetType()==Box2D.Dynamics.b2BodyDef.b2_dynamicBody&&d.IsAwake()?!1:!0};Box2D.Dynamics.Contacts.b2Contact=function(a,b){this.ID="Contact"+Box2D.Dynamics.Contacts.b2Contact.NEXT_ID++;this.m_manifold=new Box2D.Collision.b2Manifold;this.m_oldManifold=new Box2D.Collision.b2Manifold;this.touching=!1;var c=a.GetBody(),d=b.GetBody();this.continuous=c.GetType()!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody||
c.IsBullet()||d.GetType()!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody||d.IsBullet();this.sensor=a.IsSensor()||b.IsSensor();this.filtering=!1;this.m_fixtureA=a;this.m_fixtureB=b;this.enabled=!0;this.bodyAList=c.GetContactList();this.bodyBList=d.GetContactList();this.worldList=d.GetWorld().GetContactList();this.AddToLists()};Box2D.Dynamics.Contacts.b2Contact.prototype.Reset=function(a,b){this.m_manifold.Reset();this.m_oldManifold.Reset();this.touching=!1;var c=a.GetBody(),d=b.GetBody();this.continuous=
c.GetType()!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody||c.IsBullet()||d.GetType()!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody||d.IsBullet();this.sensor=a.IsSensor()||b.IsSensor();this.filtering=!1;this.m_fixtureA=a;this.m_fixtureB=b;this.enabled=!0;this.bodyAList=c.GetContactList();this.bodyBList=d.GetContactList();this.worldList=d.GetWorld().GetContactList();this.AddToLists()};Box2D.Dynamics.Contacts.b2Contact.prototype.AddToLists=function(){this.bodyAList.AddContact(this);this.bodyBList.AddContact(this);
this.worldList.AddContact(this);this.UpdateLists()};Box2D.Dynamics.Contacts.b2Contact.prototype.UpdateLists=function(){var a=!1,b=!1;!this.IsSensor()&&this.IsEnabled()&&(this.IsTouching()&&(a=!0),this.IsContinuous()&&(b=!0));this.bodyAList.UpdateContact(this,a,b);this.bodyBList.UpdateContact(this,a,b);this.worldList.UpdateContact(this,a,b)};Box2D.Dynamics.Contacts.b2Contact.prototype.RemoveFromLists=function(){this.bodyAList.RemoveContact(this);this.bodyBList.RemoveContact(this);this.worldList.RemoveContact(this)};
Box2D.Dynamics.Contacts.b2Contact.prototype.GetManifold=function(){return this.m_manifold};Box2D.Dynamics.Contacts.b2Contact.prototype.GetWorldManifold=function(a){var b=this.m_fixtureA.GetBody(),c=this.m_fixtureB.GetBody(),d=this.m_fixtureA.GetShape(),e=this.m_fixtureB.GetShape();a.Initialize(this.m_manifold,b.GetTransform(),d.m_radius,c.GetTransform(),e.m_radius)};Box2D.Dynamics.Contacts.b2Contact.prototype.IsTouching=function(){return this.touching};Box2D.Dynamics.Contacts.b2Contact.prototype.IsContinuous=
function(){return this.continuous};Box2D.Dynamics.Contacts.b2Contact.prototype.SetSensor=function(a){this.sensor=a;this.UpdateLists()};Box2D.Dynamics.Contacts.b2Contact.prototype.IsSensor=function(){return this.sensor};Box2D.Dynamics.Contacts.b2Contact.prototype.SetEnabled=function(a){this.enabled=a;this.UpdateLists()};Box2D.Dynamics.Contacts.b2Contact.prototype.IsEnabled=function(){return this.enabled};Box2D.Dynamics.Contacts.b2Contact.prototype.GetNext=function(){return this.m_next};Box2D.Dynamics.Contacts.b2Contact.prototype.GetFixtureA=
function(){return this.m_fixtureA};Box2D.Dynamics.Contacts.b2Contact.prototype.GetFixtureB=function(){return this.m_fixtureB};Box2D.Dynamics.Contacts.b2Contact.prototype.GetOther=function(a){var b=this.m_fixtureA.GetBody();return b!=a?b:this.m_fixtureB.GetBody()};Box2D.Dynamics.Contacts.b2Contact.prototype.FlagForFiltering=function(){this.filtering=!0};Box2D.Dynamics.Contacts.b2Contact.prototype.ClearFiltering=function(){this.filtering=!1};Box2D.Dynamics.Contacts.b2Contact.prototype.IsFiltering=function(){return this.filtering};
Box2D.Dynamics.Contacts.b2Contact.prototype.Update=function(a){var b=this.m_oldManifold;this.m_oldManifold=this.m_manifold;this.m_manifold=b;this.enabled=!0;var b=!1,c=this.IsTouching(),d=this.m_fixtureA.GetBody(),e=this.m_fixtureB.GetBody(),h=this.m_fixtureA.m_aabb.TestOverlap(this.m_fixtureB.m_aabb);if(this.sensor)h&&(b=Box2D.Collision.Shapes.b2Shape.TestOverlap(this.m_fixtureA.GetShape(),d.GetTransform(),this.m_fixtureB.GetShape(),e.GetTransform())),this.m_manifold.m_pointCount=0;else{d.GetType()!=
Box2D.Dynamics.b2BodyDef.b2_dynamicBody||d.IsBullet()||e.GetType()!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody||e.IsBullet()?this.continuous=!0:this.continuous=!1;if(h)for(this.Evaluate(),b=0<this.m_manifold.m_pointCount,h=0;h<this.m_manifold.m_pointCount;h++){var g=this.m_manifold.m_points[h];g.m_normalImpulse=0;for(var l=g.m_tangentImpulse=0;l<this.m_oldManifold.m_pointCount;l++){var k=this.m_oldManifold.m_points[l];if(k.m_id.GetKey()==g.m_id.GetKey()){g.m_normalImpulse=k.m_normalImpulse;g.m_tangentImpulse=
k.m_tangentImpulse;break}}}else this.m_manifold.m_pointCount=0;b!=c&&(d.SetAwake(!0),e.SetAwake(!0))}this.touching=b;b!=c&&this.UpdateLists();!c&&b&&a.BeginContact(this);c&&!b&&a.EndContact(this);this.sensor||a.PreSolve(this,this.m_oldManifold)};Box2D.Dynamics.Contacts.b2Contact.prototype.Evaluate=function(){};Box2D.Dynamics.Contacts.b2Contact.prototype.ComputeTOI=function(a,b){Box2D.Dynamics.Contacts.b2Contact.s_input.proxyA.Set(this.m_fixtureA.GetShape());Box2D.Dynamics.Contacts.b2Contact.s_input.proxyB.Set(this.m_fixtureB.GetShape());
Box2D.Dynamics.Contacts.b2Contact.s_input.sweepA=a;Box2D.Dynamics.Contacts.b2Contact.s_input.sweepB=b;Box2D.Dynamics.Contacts.b2Contact.s_input.tolerance=Box2D.Common.b2Settings.b2_linearSlop;return Box2D.Collision.b2TimeOfImpact.TimeOfImpact(Box2D.Dynamics.Contacts.b2Contact.s_input)};Box2D.Dynamics.Contacts.b2Contact.s_input=new Box2D.Collision.b2TOIInput;Box2D.Dynamics.Contacts.b2Contact.NEXT_ID=0;Box2D.Dynamics.Contacts.b2CircleContact=function(a,b){Box2D.Dynamics.Contacts.b2Contact.call(this,
a,b)};c2inherit(Box2D.Dynamics.Contacts.b2CircleContact,Box2D.Dynamics.Contacts.b2Contact);Box2D.Dynamics.Contacts.b2CircleContact.prototype.Reset=function(a,b){Box2D.Dynamics.Contacts.b2Contact.prototype.Reset.call(this,a,b)};Box2D.Dynamics.Contacts.b2CircleContact.prototype.Evaluate=function(){Box2D.Collision.b2Collision.CollideCircles(this.m_manifold,this.m_fixtureA.GetShape(),this.m_fixtureA.GetBody().m_xf,this.m_fixtureB.GetShape(),this.m_fixtureB.GetBody().m_xf)};Box2D.Dynamics.Contacts.b2ContactConstraint=
function(){this.localPlaneNormal=Box2D.Common.Math.b2Vec2.Get(0,0);this.localPoint=Box2D.Common.Math.b2Vec2.Get(0,0);this.normal=Box2D.Common.Math.b2Vec2.Get(0,0);this.normalMass=new Box2D.Common.Math.b2Mat22;this.K=new Box2D.Common.Math.b2Mat22;this.points=[];for(var a=0;a<Box2D.Common.b2Settings.b2_maxManifoldPoints;a++)this.points[a]=new Box2D.Dynamics.Contacts.b2ContactConstraintPoint};Box2D.Dynamics.Contacts.b2ContactConstraintPoint=function(){this.localPoint=Box2D.Common.Math.b2Vec2.Get(0,0);
this.rA=Box2D.Common.Math.b2Vec2.Get(0,0);this.rB=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Dynamics.Contacts.b2ContactConstraintPoint.prototype.Reset=function(){this.localPoint.Set(0,0);this.rA.Set(0,0);this.rB.Set(0,0)};Box2D.Dynamics.Contacts.b2ContactFactory=function(){this.m_registers={};this.m_freeContacts={};this.AddType(Box2D.Dynamics.Contacts.b2CircleContact,Box2D.Collision.Shapes.b2CircleShape.NAME,Box2D.Collision.Shapes.b2CircleShape.NAME);this.AddType(Box2D.Dynamics.Contacts.b2PolyAndCircleContact,
Box2D.Collision.Shapes.b2PolygonShape.NAME,Box2D.Collision.Shapes.b2CircleShape.NAME);this.AddType(Box2D.Dynamics.Contacts.b2PolygonContact,Box2D.Collision.Shapes.b2PolygonShape.NAME,Box2D.Collision.Shapes.b2PolygonShape.NAME);this.AddType(Box2D.Dynamics.Contacts.b2EdgeAndCircleContact,Box2D.Collision.Shapes.b2EdgeShape.NAME,Box2D.Collision.Shapes.b2CircleShape.NAME);this.AddType(Box2D.Dynamics.Contacts.b2PolyAndEdgeContact,Box2D.Collision.Shapes.b2PolygonShape.NAME,Box2D.Collision.Shapes.b2EdgeShape.NAME)};
Box2D.Dynamics.Contacts.b2ContactFactory.prototype.AddType=function(a,b,c){this.m_freeContacts[b]=this.m_freeContacts[b]||{};this.m_freeContacts[b][c]=this.m_freeContacts[b][c]||[];this.m_registers[b]=this.m_registers[b]||{};this.m_registers[b][c]=new Box2D.Dynamics.Contacts.b2ContactRegister;this.m_registers[b][c].ctor=a;this.m_registers[b][c].primary=!0;b!=c&&(this.m_registers[c]=this.m_registers[c]||{},this.m_registers[c][b]=new Box2D.Dynamics.Contacts.b2ContactRegister,this.m_registers[c][b].ctor=
a,this.m_registers[c][b].primary=!1)};Box2D.Dynamics.Contacts.b2ContactFactory.prototype.Create=function(a,b){var c=a.GetShape().GetTypeName(),d=b.GetShape().GetTypeName(),e=this.m_registers[c][d],h=e.ctor;return null!=h?e.primary?0<this.m_freeContacts[c][d].length?(c=this.m_freeContacts[c][d].pop(),c.Reset(a,b),c):new h(a,b):0<this.m_freeContacts[d][c].length?(c=this.m_freeContacts[d][c].pop(),c.Reset(b,a),c):new h(b,a):null};Box2D.Dynamics.Contacts.b2ContactFactory.prototype.Destroy=function(a){var b=
a.m_fixtureA.GetShape().GetTypeName(),c=a.m_fixtureB.GetShape().GetTypeName();this.m_freeContacts[b][c].push(a)};Box2D.Dynamics.Contacts.b2ContactList=function(){this.contactFirstNodes=[];for(var a=0;a<=Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts;a++)this.contactFirstNodes[a]=null;this.contactLastNodes=[];for(a=0;a<=Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts;a++)this.contactLastNodes[a]=null;this.contactNodeLookup={};this.contactCount=0};Box2D.Dynamics.Contacts.b2ContactList.prototype.GetFirstNode=
function(a){return this.contactFirstNodes[a]};Box2D.Dynamics.Contacts.b2ContactList.prototype.AddContact=function(a){var b=a.ID;if(null==this.contactNodeLookup[b]){this.contactNodeLookup[b]=[];for(var c=0;c<=Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts;c++)this.contactNodeLookup[b][c]=null;this.CreateNode(a,b,Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);this.contactCount++}};Box2D.Dynamics.Contacts.b2ContactList.prototype.UpdateContact=function(a,b,c){b?this.CreateNode(a,a.ID,
Box2D.Dynamics.Contacts.b2ContactList.TYPES.nonSensorEnabledTouchingContacts):this.RemoveNode(a.ID,Box2D.Dynamics.Contacts.b2ContactList.TYPES.nonSensorEnabledTouchingContacts);c?this.CreateNode(a,a.ID,Box2D.Dynamics.Contacts.b2ContactList.TYPES.nonSensorEnabledContinuousContacts):this.RemoveNode(a.ID,Box2D.Dynamics.Contacts.b2ContactList.TYPES.nonSensorEnabledContinuousContacts)};Box2D.Dynamics.Contacts.b2ContactList.prototype.RemoveContact=function(a){a=a.ID;if(null!=this.contactNodeLookup[a]){for(var b=
0;b<=Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts;b++)this.RemoveNode(a,b);delete this.contactNodeLookup[a];this.contactCount--}};Box2D.Dynamics.Contacts.b2ContactList.prototype.RemoveNode=function(a,b){var c=this.contactNodeLookup[a];if(null!=c){var d=c[b];if(null!=d){c[b]=null;var c=d.GetPreviousNode(),e=d.GetNextNode();null==c?this.contactFirstNodes[b]=e:c.SetNextNode(e);null==e?this.contactLastNodes[b]=c:e.SetPreviousNode(c);Box2D.Dynamics.Contacts.b2ContactListNode.FreeNode(d)}}};
Box2D.Dynamics.Contacts.b2ContactList.prototype.CreateNode=function(a,b,c){b=this.contactNodeLookup[b];null==b[c]&&(b[c]=Box2D.Dynamics.Contacts.b2ContactListNode.GetNode(a),a=this.contactLastNodes[c],null!=a?(a.SetNextNode(b[c]),b[c].SetPreviousNode(a)):this.contactFirstNodes[c]=b[c],this.contactLastNodes[c]=b[c])};Box2D.Dynamics.Contacts.b2ContactList.prototype.GetContactCount=function(){return this.contactCount};Box2D.Dynamics.Contacts.b2ContactList.TYPES={nonSensorEnabledTouchingContacts:0,nonSensorEnabledContinuousContacts:1,
allContacts:2};Box2D.Dynamics.Contacts.b2ContactListNode=function(a){this.contact=a;this.previous=this.next=null};Box2D.Dynamics.Contacts.b2ContactListNode.freeNodes=[];Box2D.Dynamics.Contacts.b2ContactListNode.GetNode=function(a){if(0<Box2D.Dynamics.Contacts.b2ContactListNode.freeNodes.length){var b=Box2D.Dynamics.Contacts.b2ContactListNode.freeNodes.pop();b.next=null;b.previous=null;b.contact=a;return b}return new Box2D.Dynamics.Contacts.b2ContactListNode(a)};Box2D.Dynamics.Contacts.b2ContactListNode.FreeNode=
function(a){Box2D.Dynamics.Contacts.b2ContactListNode.freeNodes.push(a)};Box2D.Dynamics.Contacts.b2ContactListNode.prototype.SetNextNode=function(a){this.next=a};Box2D.Dynamics.Contacts.b2ContactListNode.prototype.SetPreviousNode=function(a){this.previous=a};Box2D.Dynamics.Contacts.b2ContactListNode.prototype.GetContact=function(){return this.contact};Box2D.Dynamics.Contacts.b2ContactListNode.prototype.GetNextNode=function(){return this.next};Box2D.Dynamics.Contacts.b2ContactListNode.prototype.GetPreviousNode=
function(){return this.previous};Box2D.Dynamics.Contacts.b2ContactRegister=function(){this.pool=null;this.poolCount=0};Box2D.Dynamics.Contacts.b2PositionSolverManifold=function(){this.m_normal=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_separations=[];this.m_points=[];for(var a=0;a<Box2D.Common.b2Settings.b2_maxManifoldPoints;a++)this.m_points[a]=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Dynamics.Contacts.b2PositionSolverManifold.prototype.Initialize=function(a){switch(a.type){case Box2D.Collision.b2Manifold.e_circles:this._InitializeCircles(a);
break;case Box2D.Collision.b2Manifold.e_faceA:this._InitializeFaceA(a);break;case Box2D.Collision.b2Manifold.e_faceB:this._InitializeFaceB(a)}};Box2D.Dynamics.Contacts.b2PositionSolverManifold.prototype._InitializeCircles=function(a){var b=a.bodyA.m_xf.R,c=a.localPoint,d=a.bodyA.m_xf.position.x+(b.col1.x*c.x+b.col2.x*c.y),e=a.bodyA.m_xf.position.y+(b.col1.y*c.x+b.col2.y*c.y),b=a.bodyB.m_xf.R,c=a.points[0].localPoint,h=a.bodyB.m_xf.position.x+(b.col1.x*c.x+b.col2.x*c.y),b=a.bodyB.m_xf.position.y+(b.col1.y*
c.x+b.col2.y*c.y),c=h-d,g=b-e,l=c*c+g*g;l>Box2D.Common.b2Settings.MIN_VALUE_SQUARED?(l=Math.sqrt(l),this.m_normal.x=c/l,this.m_normal.y=g/l):(this.m_normal.x=1,this.m_normal.y=0);this.m_points[0].x=0.5*(d+h);this.m_points[0].y=0.5*(e+b);this.m_separations[0]=c*this.m_normal.x+g*this.m_normal.y-a.radius};Box2D.Dynamics.Contacts.b2PositionSolverManifold.prototype._InitializeFaceA=function(a){this.m_normal.x=a.bodyA.m_xf.R.col1.x*a.localPlaneNormal.x+a.bodyA.m_xf.R.col2.x*a.localPlaneNormal.y;this.m_normal.y=
a.bodyA.m_xf.R.col1.y*a.localPlaneNormal.x+a.bodyA.m_xf.R.col2.y*a.localPlaneNormal.y;for(var b=a.bodyA.m_xf.position.x+(a.bodyA.m_xf.R.col1.x*a.localPoint.x+a.bodyA.m_xf.R.col2.x*a.localPoint.y),c=a.bodyA.m_xf.position.y+(a.bodyA.m_xf.R.col1.y*a.localPoint.x+a.bodyA.m_xf.R.col2.y*a.localPoint.y),d=0;d<a.pointCount;d++){var e=a.bodyB.m_xf.position.x+(a.bodyB.m_xf.R.col1.x*a.points[d].localPoint.x+a.bodyB.m_xf.R.col2.x*a.points[d].localPoint.y),h=a.bodyB.m_xf.position.y+(a.bodyB.m_xf.R.col1.y*a.points[d].localPoint.x+
a.bodyB.m_xf.R.col2.y*a.points[d].localPoint.y);this.m_separations[d]=(e-b)*this.m_normal.x+(h-c)*this.m_normal.y-a.radius;this.m_points[d].x=e;this.m_points[d].y=h}};Box2D.Dynamics.Contacts.b2PositionSolverManifold.prototype._InitializeFaceB=function(a){this.m_normal.x=a.bodyB.m_xf.R.col1.x*a.localPlaneNormal.x+a.bodyB.m_xf.R.col2.x*a.localPlaneNormal.y;this.m_normal.y=a.bodyB.m_xf.R.col1.y*a.localPlaneNormal.x+a.bodyB.m_xf.R.col2.y*a.localPlaneNormal.y;for(var b=a.bodyB.m_xf.position.x+(a.bodyB.m_xf.R.col1.x*
a.localPoint.x+a.bodyB.m_xf.R.col2.x*a.localPoint.y),c=a.bodyB.m_xf.position.y+(a.bodyB.m_xf.R.col1.y*a.localPoint.x+a.bodyB.m_xf.R.col2.y*a.localPoint.y),d=0;d<a.pointCount;d++){var e=a.bodyA.m_xf.position.x+(a.bodyA.m_xf.R.col1.x*a.points[d].localPoint.x+a.bodyA.m_xf.R.col2.x*a.points[d].localPoint.y),h=a.bodyA.m_xf.position.y+(a.bodyA.m_xf.R.col1.y*a.points[d].localPoint.x+a.bodyA.m_xf.R.col2.y*a.points[d].localPoint.y);this.m_separations[d]=(e-b)*this.m_normal.x+(h-c)*this.m_normal.y-a.radius;
this.m_points[d].Set(e,h)}this.m_normal.x*=-1;this.m_normal.y*=-1};Box2D.Dynamics.Contacts.b2ContactSolver=function(){this.m_constraints=[]};Box2D.Dynamics.Contacts.b2ContactSolver.prototype.Initialize=function(a,b,c){for(this.m_constraintCount=c;this.m_constraints.length<this.m_constraintCount;)this.m_constraints[this.m_constraints.length]=new Box2D.Dynamics.Contacts.b2ContactConstraint;for(a=0;a<c;a++){var d=b[a],e=d.m_fixtureA,h=d.m_fixtureB,g=e.m_shape.m_radius,l=h.m_shape.m_radius,k=e.GetBody(),
f=h.GetBody(),m=d.GetManifold(),n=Box2D.Common.b2Settings.b2MixFriction(e.GetFriction(),h.GetFriction()),p=Box2D.Common.b2Settings.b2MixRestitution(e.GetRestitution(),h.GetRestitution()),q=k.m_linearVelocity.x,s=k.m_linearVelocity.y,r=f.m_linearVelocity.x,t=f.m_linearVelocity.y,w=k.m_angularVelocity,A=f.m_angularVelocity;Box2D.Dynamics.Contacts.b2ContactSolver.s_worldManifold.Initialize(m,k.m_xf,g,f.m_xf,l);h=Box2D.Dynamics.Contacts.b2ContactSolver.s_worldManifold.m_normal.x;d=Box2D.Dynamics.Contacts.b2ContactSolver.s_worldManifold.m_normal.y;
e=this.m_constraints[a];e.bodyA=k;e.bodyB=f;e.manifold=m;e.normal.x=h;e.normal.y=d;e.pointCount=m.m_pointCount;e.friction=n;e.restitution=p;e.localPlaneNormal.x=m.m_localPlaneNormal.x;e.localPlaneNormal.y=m.m_localPlaneNormal.y;e.localPoint.x=m.m_localPoint.x;e.localPoint.y=m.m_localPoint.y;e.radius=g+l;e.type=m.m_type;for(g=0;g<e.pointCount;++g){n=m.m_points[g];l=e.points[g];l.normalImpulse=n.m_normalImpulse;l.tangentImpulse=n.m_tangentImpulse;l.localPoint.SetV(n.m_localPoint);var n=l.rA.x=Box2D.Dynamics.Contacts.b2ContactSolver.s_worldManifold.m_points[g].x-
k.m_sweep.c.x,p=l.rA.y=Box2D.Dynamics.Contacts.b2ContactSolver.s_worldManifold.m_points[g].y-k.m_sweep.c.y,D=l.rB.x=Box2D.Dynamics.Contacts.b2ContactSolver.s_worldManifold.m_points[g].x-f.m_sweep.c.x,O=l.rB.y=Box2D.Dynamics.Contacts.b2ContactSolver.s_worldManifold.m_points[g].y-f.m_sweep.c.y,B=n*d-p*h,y=D*d-O*h,B=B*B,y=y*y;l.normalMass=1/(k.m_invMass+f.m_invMass+k.m_invI*B+f.m_invI*y);var v=k.m_mass*k.m_invMass+f.m_mass*f.m_invMass,v=v+(k.m_mass*k.m_invI*B+f.m_mass*f.m_invI*y);l.equalizedMass=1/v;
y=d;v=-h;B=n*v-p*y;y=D*v-O*y;B*=B;y*=y;l.tangentMass=1/(k.m_invMass+f.m_invMass+k.m_invI*B+f.m_invI*y);l.velocityBias=0;n=e.normal.x*(r+-A*O-q- -w*p)+e.normal.y*(t+A*D-s-w*n);n<-Box2D.Common.b2Settings.b2_velocityThreshold&&(l.velocityBias+=-e.restitution*n)}2==e.pointCount&&(t=e.points[0],r=e.points[1],m=k.m_invMass,k=k.m_invI,q=f.m_invMass,f=f.m_invI,s=t.rA.x*d-t.rA.y*h,t=t.rB.x*d-t.rB.y*h,w=r.rA.x*d-r.rA.y*h,r=r.rB.x*d-r.rB.y*h,h=m+q+k*s*s+f*t*t,d=m+q+k*w*w+f*r*r,f=m+q+k*s*w+f*t*r,h*h<100*(h*d-
f*f)?(e.K.col1.Set(h,f),e.K.col2.Set(f,d),e.K.GetInverse(e.normalMass)):e.pointCount=1)}};Box2D.Dynamics.Contacts.b2ContactSolver.prototype.InitVelocityConstraints=function(a){for(var b=0;b<this.m_constraintCount;++b){var c=this.m_constraints[b],d=c.bodyA,e=c.bodyB,h=d.m_invMass,g=d.m_invI,l=e.m_invMass,k=e.m_invI,f=c.normal.x,m=c.normal.y,n=m,p=-f,q=0,s=0;if(a.warmStarting)for(s=c.pointCount,q=0;q<s;++q){var r=c.points[q];r.normalImpulse*=a.dtRatio;r.tangentImpulse*=a.dtRatio;var t=r.normalImpulse*
f+r.tangentImpulse*n,w=r.normalImpulse*m+r.tangentImpulse*p;d.m_angularVelocity-=g*(r.rA.x*w-r.rA.y*t);d.m_linearVelocity.x-=h*t;d.m_linearVelocity.y-=h*w;e.m_angularVelocity+=k*(r.rB.x*w-r.rB.y*t);e.m_linearVelocity.x+=l*t;e.m_linearVelocity.y+=l*w}else for(s=c.pointCount,q=0;q<s;++q)d=c.points[q],d.normalImpulse=0,d.tangentImpulse=0}};Box2D.Dynamics.Contacts.b2ContactSolver.prototype.SolveVelocityConstraints=function(){for(var a=0;a<this.m_constraintCount;a++)this.SolveVelocityConstraints_Constraint(this.m_constraints[a])};
Box2D.Dynamics.Contacts.b2ContactSolver.prototype.SolveVelocityConstraints_Constraint=function(a){for(var b=a.normal.x,c=a.normal.y,d=0;d<a.pointCount;d++)Box2D.Dynamics.Contacts.b2ContactSolver.prototype.SolveVelocityConstraints_ConstraintPoint(a,a.points[d]);if(1==a.pointCount){var d=a.points[0],e=d.normalImpulse-d.normalMass*((a.bodyB.m_linearVelocity.x-a.bodyB.m_angularVelocity*d.rB.y-a.bodyA.m_linearVelocity.x+a.bodyA.m_angularVelocity*d.rA.y)*b+(a.bodyB.m_linearVelocity.y+a.bodyB.m_angularVelocity*
d.rB.x-a.bodyA.m_linearVelocity.y-a.bodyA.m_angularVelocity*d.rA.x)*c-d.velocityBias),e=0<e?e:0,h=e-d.normalImpulse,g=h*b,c=h*c;a.bodyA.m_linearVelocity.x-=a.bodyA.m_invMass*g;a.bodyA.m_linearVelocity.y-=a.bodyA.m_invMass*c;a.bodyA.m_angularVelocity-=a.bodyA.m_invI*(d.rA.x*c-d.rA.y*g);a.bodyB.m_linearVelocity.x+=a.bodyB.m_invMass*g;a.bodyB.m_linearVelocity.y+=a.bodyB.m_invMass*c;a.bodyB.m_angularVelocity+=a.bodyB.m_invI*(d.rB.x*c-d.rB.y*g);d.normalImpulse=e}else for(var d=a.points[0],e=a.points[1],
h=d.normalImpulse,g=e.normalImpulse,l=(a.bodyB.m_linearVelocity.x-a.bodyB.m_angularVelocity*d.rB.y-a.bodyA.m_linearVelocity.x+a.bodyA.m_angularVelocity*d.rA.y)*b+(a.bodyB.m_linearVelocity.y+a.bodyB.m_angularVelocity*d.rB.x-a.bodyA.m_linearVelocity.y-a.bodyA.m_angularVelocity*d.rA.x)*c-d.velocityBias,c=(a.bodyB.m_linearVelocity.x-a.bodyB.m_angularVelocity*e.rB.y-a.bodyA.m_linearVelocity.x+a.bodyA.m_angularVelocity*e.rA.y)*b+(a.bodyB.m_linearVelocity.y+a.bodyB.m_angularVelocity*e.rB.x-a.bodyA.m_linearVelocity.y-
a.bodyA.m_angularVelocity*e.rA.x)*c-e.velocityBias,l=l-(a.K.col1.x*h+a.K.col2.x*g),c=c-(a.K.col1.y*h+a.K.col2.y*g);;){b=-(a.normalMass.col1.x*l+a.normalMass.col2.x*c);if(0<=b){var k=-(a.normalMass.col1.y*l+a.normalMass.col2.y*c);if(0<=k){this.SolveVelocityConstraints_ConstraintPointUpdate(a,d,e,b-h,k-g);d.normalImpulse=b;e.normalImpulse=k;break}}b=-d.normalMass*l;if(0<=b&&0<=a.K.col1.y*b+c){this.SolveVelocityConstraints_ConstraintPointUpdate(a,d,e,b-h,-g);d.normalImpulse=b;e.normalImpulse=0;break}b=
-e.normalMass*c;if(0<=b&&0<=a.K.col2.x*b+l){this.SolveVelocityConstraints_ConstraintPointUpdate(a,d,e,-h,b-g);d.normalImpulse=0;e.normalImpulse=b;break}if(0<=l&&0<=c){this.SolveVelocityConstraints_ConstraintPointUpdate(a,d,e,-h,-g);d.normalImpulse=0;e.normalImpulse=0;break}break}};Box2D.Dynamics.Contacts.b2ContactSolver.prototype.SolveVelocityConstraints_ConstraintPoint=function(a,b){var c=a.normal.y,d=-a.normal.x,e=a.friction*b.normalImpulse,e=Box2D.Common.Math.b2Math.Clamp(b.tangentImpulse-b.tangentMass*
((a.bodyB.m_linearVelocity.x-a.bodyB.m_angularVelocity*b.rB.y-a.bodyA.m_linearVelocity.x+a.bodyA.m_angularVelocity*b.rA.y)*c+(a.bodyB.m_linearVelocity.y+a.bodyB.m_angularVelocity*b.rB.x-a.bodyA.m_linearVelocity.y-a.bodyA.m_angularVelocity*b.rA.x)*d),-e,e),h=e-b.tangentImpulse,c=h*c,d=h*d;a.bodyA.m_linearVelocity.x-=a.bodyA.m_invMass*c;a.bodyA.m_linearVelocity.y-=a.bodyA.m_invMass*d;a.bodyA.m_angularVelocity-=a.bodyA.m_invI*(b.rA.x*d-b.rA.y*c);a.bodyB.m_linearVelocity.x+=a.bodyB.m_invMass*c;a.bodyB.m_linearVelocity.y+=
a.bodyB.m_invMass*d;a.bodyB.m_angularVelocity+=a.bodyB.m_invI*(b.rB.x*d-b.rB.y*c);b.tangentImpulse=e};Box2D.Dynamics.Contacts.b2ContactSolver.prototype.SolveVelocityConstraints_ConstraintPointUpdate=function(a,b,c,d,e){var h=d*a.normal.x;d*=a.normal.y;var g=e*a.normal.x;e*=a.normal.y;a.bodyA.m_linearVelocity.x-=a.bodyA.m_invMass*(h+g);a.bodyA.m_linearVelocity.y-=a.bodyA.m_invMass*(d+e);a.bodyA.m_angularVelocity-=a.bodyA.m_invI*(b.rA.x*d-b.rA.y*h+c.rA.x*e-c.rA.y*g);a.bodyB.m_linearVelocity.x+=a.bodyB.m_invMass*
(h+g);a.bodyB.m_linearVelocity.y+=a.bodyB.m_invMass*(d+e);a.bodyB.m_angularVelocity+=a.bodyB.m_invI*(b.rB.x*d-b.rB.y*h+c.rB.x*e-c.rB.y*g);b.normalImpulse=0;c.normalImpulse=0};Box2D.Dynamics.Contacts.b2ContactSolver.prototype.FinalizeVelocityConstraints=function(){for(var a=0;a<this.m_constraintCount;++a)for(var b=this.m_constraints[a],c=b.manifold,d=0;d<b.pointCount;++d){var e=c.m_points[d],h=b.points[d];e.m_normalImpulse=h.normalImpulse;e.m_tangentImpulse=h.tangentImpulse}};Box2D.Dynamics.Contacts.b2ContactSolver.prototype.SolvePositionConstraints=
function(a){void 0===a&&(a=0);for(var b=0,c=0;c<this.m_constraintCount;c++){var d=this.m_constraints[c],e=d.bodyA,h=d.bodyB,g=e.m_mass*e.m_invMass,l=e.m_mass*e.m_invI,k=h.m_mass*h.m_invMass,f=h.m_mass*h.m_invI;Box2D.Dynamics.Contacts.b2ContactSolver.s_psm.Initialize(d);for(var m=Box2D.Dynamics.Contacts.b2ContactSolver.s_psm.m_normal,n=0;n<d.pointCount;n++){var p=d.points[n],q=Box2D.Dynamics.Contacts.b2ContactSolver.s_psm.m_points[n],s=Box2D.Dynamics.Contacts.b2ContactSolver.s_psm.m_separations[n],
r=q.x-e.m_sweep.c.x,t=q.y-e.m_sweep.c.y,w=q.x-h.m_sweep.c.x,q=q.y-h.m_sweep.c.y,b=b<s?b:s,s=Box2D.Common.Math.b2Math.Clamp(a*(s+Box2D.Common.b2Settings.b2_linearSlop),-Box2D.Common.b2Settings.b2_maxLinearCorrection,0),s=-p.equalizedMass*s,p=s*m.x,s=s*m.y;e.m_sweep.c.x-=g*p;e.m_sweep.c.y-=g*s;e.m_sweep.a-=l*(r*s-t*p);e.SynchronizeTransform();h.m_sweep.c.x+=k*p;h.m_sweep.c.y+=k*s;h.m_sweep.a+=f*(w*s-q*p);h.SynchronizeTransform()}}return b>-1.5*Box2D.Common.b2Settings.b2_linearSlop};Box2D.Dynamics.Contacts.b2ContactSolver.prototype.SolvePositionConstraints_NEW=
function(a){void 0===a&&(a=0);for(var b=0,c=0;c<this.m_constraintCount;c++){var d=this.m_constraints[c],e=d.bodyA,h=d.bodyB,g=e.m_mass*e.m_invMass,l=e.m_mass*e.m_invI,k=h.m_mass*h.m_invMass,f=h.m_mass*h.m_invI;Box2D.Dynamics.Contacts.b2ContactSolver.s_psm.Initialize(d);for(var m=Box2D.Dynamics.Contacts.b2ContactSolver.s_psm.m_normal,n=0;n<d.pointCount;n++){var p=d.points[n],q=Box2D.Dynamics.Contacts.b2ContactSolver.s_psm.m_points[n],s=Box2D.Dynamics.Contacts.b2ContactSolver.s_psm.m_separations[n],
r=q.x-e.m_sweep.c.x,t=q.y-e.m_sweep.c.y,w=q.x-h.m_sweep.c.x,q=q.y-h.m_sweep.c.y;s<b&&(b=s);0!=a&&Box2D.Common.Math.b2Math.Clamp(a*(s+Box2D.Common.b2Settings.b2_linearSlop),-Box2D.Common.b2Settings.b2_maxLinearCorrection,0);s=0*-p.equalizedMass;p=s*m.x;s*=m.y;e.m_sweep.c.x-=g*p;e.m_sweep.c.y-=g*s;e.m_sweep.a-=l*(r*s-t*p);e.SynchronizeTransform();h.m_sweep.c.x+=k*p;h.m_sweep.c.y+=k*s;h.m_sweep.a+=f*(w*s-q*p);h.SynchronizeTransform()}}return b>-1.5*Box2D.Common.b2Settings.b2_linearSlop};Box2D.Dynamics.Contacts.b2EdgeAndCircleContact=
function(a,b){Box2D.Dynamics.Contacts.b2Contact.call(this,a,b)};c2inherit(Box2D.Dynamics.Contacts.b2EdgeAndCircleContact,Box2D.Dynamics.Contacts.b2Contact);Box2D.Dynamics.Contacts.b2EdgeAndCircleContact.prototype.Reset=function(a,b){Box2D.Dynamics.Contacts.b2Contact.prototype.Reset.call(this,a,b)};Box2D.Dynamics.Contacts.b2EdgeAndCircleContact.prototype.Evaluate=function(){this.m_fixtureA.GetBody();this.m_fixtureB.GetBody();this.b2CollideEdgeAndCircle(this.m_manifold,this.m_fixtureA.GetShape(),this.m_fixtureA.GetBody().m_xf,
this.m_fixtureB.GetShape(),this.m_fixtureB.GetBody().m_xf)};Box2D.Dynamics.Contacts.b2EdgeAndCircleContact.prototype.b2CollideEdgeAndCircle=function(a,b,c,d,e){};Box2D.Dynamics.Contacts.b2PolyAndCircleContact=function(a,b){Box2D.Dynamics.Contacts.b2Contact.call(this,a,b)};c2inherit(Box2D.Dynamics.Contacts.b2PolyAndCircleContact,Box2D.Dynamics.Contacts.b2Contact);Box2D.Dynamics.Contacts.b2PolyAndCircleContact.prototype.Reset=function(a,b){Box2D.Dynamics.Contacts.b2Contact.prototype.Reset.call(this,
a,b)};Box2D.Dynamics.Contacts.b2PolyAndCircleContact.prototype.Evaluate=function(){Box2D.Collision.b2Collision.CollidePolygonAndCircle(this.m_manifold,this.m_fixtureA.GetShape(),this.m_fixtureA.GetBody().m_xf,this.m_fixtureB.GetShape(),this.m_fixtureB.GetBody().m_xf)};Box2D.Dynamics.Contacts.b2PolyAndEdgeContact=function(a,b){Box2D.Dynamics.Contacts.b2Contact.call(this,a,b)};c2inherit(Box2D.Dynamics.Contacts.b2PolyAndEdgeContact,Box2D.Dynamics.Contacts.b2Contact);Box2D.Dynamics.Contacts.b2PolyAndEdgeContact.prototype.Reset=
function(a,b){Box2D.Dynamics.Contacts.b2Contact.prototype.Reset.call(this,a,b)};Box2D.Dynamics.Contacts.b2PolyAndEdgeContact.prototype.Evaluate=function(){this.b2CollidePolyAndEdge(this.m_manifold,this.m_fixtureA.GetShape(),this.m_fixtureA.GetBody().m_xf,this.m_fixtureB.GetShape(),this.m_fixtureB.GetBody().m_xf)};Box2D.Dynamics.Contacts.b2PolyAndEdgeContact.prototype.b2CollidePolyAndEdge=function(a,b,c,d,e){};Box2D.Dynamics.Contacts.b2PolygonContact=function(a,b){Box2D.Dynamics.Contacts.b2Contact.call(this,
a,b)};c2inherit(Box2D.Dynamics.Contacts.b2PolygonContact,Box2D.Dynamics.Contacts.b2Contact);Box2D.Dynamics.Contacts.b2PolygonContact.prototype.Reset=function(a,b){Box2D.Dynamics.Contacts.b2Contact.prototype.Reset.call(this,a,b)};Box2D.Dynamics.Contacts.b2PolygonContact.prototype.Evaluate=function(){Box2D.Collision.b2Collision.CollidePolygons(this.m_manifold,this.m_fixtureA.GetShape(),this.m_fixtureA.GetBody().m_xf,this.m_fixtureB.GetShape(),this.m_fixtureB.GetBody().m_xf)};Box2D.Dynamics.Controllers.b2Controller=
function(){this.ID="Controller"+Box2D.Dynamics.Controllers.b2Controller.NEXT_ID++;this.m_world=null;this.bodyList=new Box2D.Dynamics.b2BodyList};Box2D.Dynamics.Controllers.b2Controller.prototype.Step=function(a){};Box2D.Dynamics.Controllers.b2Controller.prototype.AddBody=function(a){this.bodyList.AddBody(a);a.AddController(this)};Box2D.Dynamics.Controllers.b2Controller.prototype.RemoveBody=function(a){this.bodyList.RemoveBody(a);a.RemoveController(this)};Box2D.Dynamics.Controllers.b2Controller.prototype.Clear=
function(){for(var a=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.allBodies);a;a=a.GetNextNode())this.RemoveBody(a.body)};Box2D.Dynamics.Controllers.b2Controller.prototype.GetBodyList=function(){return this.bodyList};Box2D.Dynamics.Controllers.b2Controller.NEXT_ID=0;Box2D.Dynamics.Controllers.b2BuoyancyController=function(){Box2D.Dynamics.Controllers.b2Controller.call(this);this.normal=Box2D.Common.Math.b2Vec2.Get(0,-1);this.density=this.offset=0;this.velocity=Box2D.Common.Math.b2Vec2.Get(0,
0);this.linearDrag=2;this.angularDrag=1;this.useDensity=!1;this.useWorldGravity=!0;this.gravity=null};c2inherit(Box2D.Dynamics.Controllers.b2BuoyancyController,Box2D.Dynamics.Controllers.b2Controller);Box2D.Dynamics.Controllers.b2BuoyancyController.prototype.Step=function(a){this.useWorldGravity&&(this.gravity=this.m_world.GetGravity().Copy());for(a=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.awakeBodies);a;a=a.GetNextNode()){for(var b=a.body,c=Box2D.Common.Math.b2Vec2.Get(0,0),d=Box2D.Common.Math.b2Vec2.Get(0,
0),e=0,h=0,g=b.GetFixtureList().GetFirstNode();g;g=g.GetNextNode()){var l=Box2D.Common.Math.b2Vec2.Get(0,0),k=g.fixture.GetShape().ComputeSubmergedArea(this.normal,this.offset,b.GetTransform(),l),e=e+k;c.x+=k*l.x;c.y+=k*l.y;var f=0,f=1,h=h+k*f;d.x+=k*l.x*f;d.y+=k*l.y*f}e<Number.MIN_VALUE||(c.x/=e,c.y/=e,d.x/=h,d.y/=h,h=this.gravity.GetNegative(),h.Multiply(this.density*e),b.ApplyForce(h,d),h=b.GetLinearVelocityFromWorldPoint(c),h.Subtract(this.velocity),h.Multiply(-this.linearDrag*e),b.ApplyForce(h,
c),b.ApplyTorque(-b.GetInertia()/b.GetMass()*e*b.GetAngularVelocity()*this.angularDrag),Box2D.Common.Math.b2Vec2.Free(c),Box2D.Common.Math.b2Vec2.Free(d))}};Box2D.Dynamics.Controllers.b2ConstantAccelController=function(){Box2D.Dynamics.Controllers.b2Controller.call(this);this.A=Box2D.Common.Math.b2Vec2.Get(0,0)};c2inherit(Box2D.Dynamics.Controllers.b2ConstantAccelController,Box2D.Dynamics.Controllers.b2Controller);Box2D.Dynamics.Controllers.b2ConstantAccelController.prototype.Step=function(a){a=Box2D.Common.Math.b2Vec2.Get(this.A.x*
a.dt,this.A.y*a.dt);for(var b=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.awakeBodies);b;b=b.GetNextNode()){var c=b.body,d=c.GetLinearVelocity();c.SetLinearVelocity(Box2D.Common.Math.b2Vec2.Get(d.x+a.x,d.y+a.y))}Box2D.Common.Math.b2Vec2.Free(a)};Box2D.Dynamics.Controllers.b2ConstantForceController=function(){Box2D.Dynamics.Controllers.b2Controller.call(this);this.F=Box2D.Common.Math.b2Vec2.Get(0,0)};c2inherit(Box2D.Dynamics.Controllers.b2ConstantForceController,Box2D.Dynamics.Controllers.b2Controller);
Box2D.Dynamics.Controllers.b2ConstantForceController.prototype.Step=function(a){for(a=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.awakeBodies);a;a=a.GetNextNode()){var b=a.body;b.ApplyForce(this.F,b.GetWorldCenter())}};Box2D.Dynamics.Controllers.b2ControllerList=function(){this.controllerLastNode=this.controllerFirstNode=null;this.controllerNodeLookup={};this.controllerCount=0};Box2D.Dynamics.Controllers.b2ControllerList.prototype.GetFirstNode=function(){return this.controllerFirstNode};
Box2D.Dynamics.Controllers.b2ControllerList.prototype.AddController=function(a){var b=a.ID;if(null==this.controllerNodeLookup[b]){a=new Box2D.Dynamics.Controllers.b2ControllerListNode(a);var c=this.controllerLastNode;null!=c?c.SetNextNode(a):this.controllerFirstNode=a;a.SetPreviousNode(c);this.controllerLastNode=a;this.controllerNodeLookup[b]=a;this.controllerCount++}};Box2D.Dynamics.Controllers.b2ControllerList.prototype.RemoveController=function(a){a=a.ID;var b=this.controllerNodeLookup[a];if(null!=
b){var c=b.GetPreviousNode(),b=b.GetNextNode();null==c?this.controllerFirstNode=b:c.SetNextNode(b);null==b?this.controllerLastNode=c:b.SetPreviousNode(c);delete this.controllerNodeLookup[a];this.controllerCount--}};Box2D.Dynamics.Controllers.b2ControllerList.prototype.GetControllerCount=function(){return this.controllerCount};Box2D.Dynamics.Controllers.b2ControllerListNode=function(a){this.controller=a;this.previous=this.next=null};Box2D.Dynamics.Controllers.b2ControllerListNode.prototype.SetNextNode=
function(a){this.next=a};Box2D.Dynamics.Controllers.b2ControllerListNode.prototype.SetPreviousNode=function(a){this.previous=a};Box2D.Dynamics.Controllers.b2ControllerListNode.prototype.GetNextNode=function(){return this.next};Box2D.Dynamics.Controllers.b2ControllerListNode.prototype.GetPreviousNode=function(){return this.previous};Box2D.Dynamics.Controllers.b2GravityController=function(){Box2D.Dynamics.Controllers.b2Controller.call(this);this.G=1;this.invSqr=!0};c2inherit(Box2D.Dynamics.Controllers.b2GravityController,
Box2D.Dynamics.Controllers.b2Controller);Box2D.Dynamics.Controllers.b2GravityController.prototype.Step=function(a){var b=a=null,c=0,d=null,e=null,h=0,g=0,l=0,h=null;if(this.invSqr)for(var k=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.allBodies);k;k=k.GetNextNode()){a=k.body;for(var b=a.GetWorldCenter(),c=a.GetMass(),f=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.allBodies);f;f=f.GetNextNode())if(d=f.body,a.IsAwake()||d.IsAwake())e=d.GetWorldCenter(),h=e.x-b.x,g=e.y-b.y,
l=h*h+g*g,l<Number.MIN_VALUE||(h=Box2D.Common.Math.b2Vec2.Get(h,g),h.Multiply(this.G/l/Math.sqrt(l)*c*d.GetMass()),a.IsAwake()&&a.ApplyForce(h,b),h.Multiply(-1),d.IsAwake()&&d.ApplyForce(h,e),Box2D.Common.Math.b2Vec2.Free(h))}else for(k=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.allBodies);k;k=k.GetNextNode())for(a=bodyNode.body,b=a.GetWorldCenter(),c=a.GetMass(),f=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.allBodies);f;f=f.GetNextNode())if(d=bodyNode.body,a.IsAwake()||
d.IsAwake())e=d.GetWorldCenter(),h=e.x-b.x,g=e.y-b.y,l=h*h+g*g,l<Number.MIN_VALUE||(h=Box2D.Common.Math.b2Vec2.Get(h,g),h.Multiply(this.G/l*c*d.GetMass()),a.IsAwake()&&a.ApplyForce(h,b),h.Multiply(-1),d.IsAwake()&&d.ApplyForce(h,e),Box2D.Common.Math.b2Vec2.Free(h))};Box2D.Dynamics.Controllers.b2TensorDampingController=function(){Box2D.Dynamics.Controllers.b2Controller.call(this);this.T=new Box2D.Common.Math.b2Mat22;this.maxTimestep=0};c2inherit(Box2D.Dynamics.Controllers.b2TensorDampingController,
Box2D.Dynamics.Controllers.b2Controller);Box2D.Dynamics.Controllers.b2TensorDampingController.prototype.SetAxisAligned=function(a,b){this.T.col1.x=-a;this.T.col1.y=0;this.T.col2.x=0;this.T.col2.y=-b;this.maxTimestep=0<a||0<b?1/Math.max(a,b):0};Box2D.Dynamics.Controllers.b2TensorDampingController.prototype.Step=function(a){a=a.dt;if(!(a<=Number.MIN_VALUE)){a>this.maxTimestep&&0<this.maxTimestep&&(a=this.maxTimestep);for(var b=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.awakeBodies);b;b=
b.GetNextNode()){var c=b.body,d=c.GetWorldVector(Box2D.Common.Math.b2Math.MulMV(this.T,c.GetLocalVector(c.GetLinearVelocity())));c.SetLinearVelocity(Box2D.Common.Math.b2Vec2.Get(c.GetLinearVelocity().x+d.x*a,c.GetLinearVelocity().y+d.y*a))}}};Box2D.Dynamics.Joints.b2Joint=function(a){this.m_edgeA=new Box2D.Dynamics.Joints.b2JointEdge;this.m_edgeB=new Box2D.Dynamics.Joints.b2JointEdge;this.m_localCenterA=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localCenterB=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_type=
a.type;this.m_next=this.m_prev=null;this.m_bodyA=a.bodyA;this.m_bodyB=a.bodyB;this.m_collideConnected=a.collideConnected};Box2D.Dynamics.Joints.b2Joint.prototype.GetType=function(){return this.m_type};Box2D.Dynamics.Joints.b2Joint.prototype.GetAnchorA=function(){return null};Box2D.Dynamics.Joints.b2Joint.prototype.GetAnchorB=function(){return null};Box2D.Dynamics.Joints.b2Joint.prototype.GetReactionForce=function(a){return null};Box2D.Dynamics.Joints.b2Joint.prototype.GetReactionTorque=function(a){return 0};
Box2D.Dynamics.Joints.b2Joint.prototype.GetBodyA=function(){return this.m_bodyA};Box2D.Dynamics.Joints.b2Joint.prototype.GetBodyB=function(){return this.m_bodyB};Box2D.Dynamics.Joints.b2Joint.prototype.GetNext=function(){return this.m_next};Box2D.Dynamics.Joints.b2Joint.prototype.IsActive=function(){return this.m_bodyA.IsActive()&&this.m_bodyB.IsActive()};Box2D.Dynamics.Joints.b2Joint.Create=function(a){return a.Create()};Box2D.Dynamics.Joints.b2Joint.prototype.InitVelocityConstraints=function(a){};
Box2D.Dynamics.Joints.b2Joint.prototype.SolveVelocityConstraints=function(a){};Box2D.Dynamics.Joints.b2Joint.prototype.FinalizeVelocityConstraints=function(){};Box2D.Dynamics.Joints.b2Joint.prototype.SolvePositionConstraints=function(a){return!1};Box2D.Dynamics.Joints.b2Joint.e_unknownJoint=0;Box2D.Dynamics.Joints.b2Joint.e_revoluteJoint=1;Box2D.Dynamics.Joints.b2Joint.e_prismaticJoint=2;Box2D.Dynamics.Joints.b2Joint.e_distanceJoint=3;Box2D.Dynamics.Joints.b2Joint.e_pulleyJoint=4;Box2D.Dynamics.Joints.b2Joint.e_mouseJoint=
5;Box2D.Dynamics.Joints.b2Joint.e_gearJoint=6;Box2D.Dynamics.Joints.b2Joint.e_lineJoint=7;Box2D.Dynamics.Joints.b2Joint.e_weldJoint=8;Box2D.Dynamics.Joints.b2Joint.e_frictionJoint=9;Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit=0;Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit=1;Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit=2;Box2D.Dynamics.Joints.b2Joint.e_equalLimits=3;Box2D.Dynamics.Joints.b2JointDef=function(){this.type=Box2D.Dynamics.Joints.b2Joint.e_unknownJoint;this.bodyB=this.bodyA=null;this.collideConnected=
!1};Box2D.Dynamics.Joints.b2JointEdge=function(){};Box2D.Dynamics.Joints.b2DistanceJoint=function(a){Box2D.Dynamics.Joints.b2Joint.call(this,a);this.m_localAnchor1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor2=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_u=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor1.SetV(a.localAnchorA);this.m_localAnchor2.SetV(a.localAnchorB);this.m_length=a.length;this.m_frequencyHz=a.frequencyHz;this.m_dampingRatio=a.dampingRatio;this.m_bias=this.m_gamma=this.m_impulse=
0};c2inherit(Box2D.Dynamics.Joints.b2DistanceJoint,Box2D.Dynamics.Joints.b2Joint);Box2D.Dynamics.Joints.b2DistanceJoint.prototype.GetAnchorA=function(){return this.m_bodyA.GetWorldPoint(this.m_localAnchor1)};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.GetAnchorB=function(){return this.m_bodyB.GetWorldPoint(this.m_localAnchor2)};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.GetReactionForce=function(a){return Box2D.Common.Math.b2Vec2.Get(a*this.m_impulse*this.m_u.x,a*this.m_impulse*this.m_u.y)};
Box2D.Dynamics.Joints.b2DistanceJoint.prototype.GetReactionTorque=function(a){return 0};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.GetLength=function(){return this.m_length};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.SetLength=function(a){this.m_length=a};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.GetFrequency=function(){return this.m_frequencyHz};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.SetFrequency=function(a){this.m_frequencyHz=a};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.GetDampingRatio=
function(){return this.m_dampingRatio};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.SetDampingRatio=function(a){this.m_dampingRatio=a};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.InitVelocityConstraints=function(a){var b,c=0,d=this.m_bodyA,e=this.m_bodyB;b=d.m_xf.R;var h=this.m_localAnchor1.x-d.m_sweep.localCenter.x,g=this.m_localAnchor1.y-d.m_sweep.localCenter.y,c=b.col1.x*h+b.col2.x*g,g=b.col1.y*h+b.col2.y*g,h=c;b=e.m_xf.R;var l=this.m_localAnchor2.x-e.m_sweep.localCenter.x,k=this.m_localAnchor2.y-
e.m_sweep.localCenter.y,c=b.col1.x*l+b.col2.x*k,k=b.col1.y*l+b.col2.y*k,l=c;this.m_u.x=e.m_sweep.c.x+l-d.m_sweep.c.x-h;this.m_u.y=e.m_sweep.c.y+k-d.m_sweep.c.y-g;c=Math.sqrt(this.m_u.x*this.m_u.x+this.m_u.y*this.m_u.y);c>Box2D.Common.b2Settings.b2_linearSlop?this.m_u.Multiply(1/c):this.m_u.SetZero();b=h*this.m_u.y-g*this.m_u.x;var f=l*this.m_u.y-k*this.m_u.x;b=d.m_invMass+d.m_invI*b*b+e.m_invMass+e.m_invI*f*f;this.m_mass=0!=b?1/b:0;if(0<this.m_frequencyHz){var c=c-this.m_length,f=2*Math.PI*this.m_frequencyHz,
m=this.m_mass*f*f;this.m_gamma=a.dt*(2*this.m_mass*this.m_dampingRatio*f+a.dt*m);this.m_gamma=0!=this.m_gamma?1/this.m_gamma:0;this.m_bias=c*a.dt*m*this.m_gamma;this.m_mass=b+this.m_gamma;this.m_mass=0!=this.m_mass?1/this.m_mass:0}a.warmStarting?(this.m_impulse*=a.dtRatio,a=this.m_impulse*this.m_u.x,b=this.m_impulse*this.m_u.y,d.m_linearVelocity.x-=d.m_invMass*a,d.m_linearVelocity.y-=d.m_invMass*b,d.m_angularVelocity-=d.m_invI*(h*b-g*a),e.m_linearVelocity.x+=e.m_invMass*a,e.m_linearVelocity.y+=e.m_invMass*
b,e.m_angularVelocity+=e.m_invI*(l*b-k*a)):this.m_impulse=0};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.SolveVelocityConstraints=function(a){a=this.m_localAnchor1.x-this.m_bodyA.m_sweep.localCenter.x;var b=this.m_localAnchor1.y-this.m_bodyA.m_sweep.localCenter.y,c=this.m_bodyA.m_xf.R.col1.x*a+this.m_bodyA.m_xf.R.col2.x*b,b=this.m_bodyA.m_xf.R.col1.y*a+this.m_bodyA.m_xf.R.col2.y*b;a=c;var d=this.m_localAnchor2.x-this.m_bodyB.m_sweep.localCenter.x,e=this.m_localAnchor2.y-this.m_bodyB.m_sweep.localCenter.y,
c=this.m_bodyB.m_xf.R.col1.x*d+this.m_bodyB.m_xf.R.col2.x*e,e=this.m_bodyB.m_xf.R.col1.y*d+this.m_bodyB.m_xf.R.col2.y*e,d=c,h=-this.m_mass*(this.m_u.x*(this.m_bodyB.m_linearVelocity.x-this.m_bodyB.m_angularVelocity*e-(this.m_bodyA.m_linearVelocity.x-this.m_bodyA.m_angularVelocity*b))+this.m_u.y*(this.m_bodyB.m_linearVelocity.y+this.m_bodyB.m_angularVelocity*d-(this.m_bodyA.m_linearVelocity.y+this.m_bodyA.m_angularVelocity*a))+this.m_bias+this.m_gamma*this.m_impulse);this.m_impulse+=h;c=h*this.m_u.x;
h*=this.m_u.y;this.m_bodyA.m_linearVelocity.x-=this.m_bodyA.m_invMass*c;this.m_bodyA.m_linearVelocity.y-=this.m_bodyA.m_invMass*h;this.m_bodyA.m_angularVelocity-=this.m_bodyA.m_invI*(a*h-b*c);this.m_bodyB.m_linearVelocity.x+=this.m_bodyB.m_invMass*c;this.m_bodyB.m_linearVelocity.y+=this.m_bodyB.m_invMass*h;this.m_bodyB.m_angularVelocity+=this.m_bodyB.m_invI*(d*h-e*c)};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.SolvePositionConstraints=function(a){if(0<this.m_frequencyHz)return!0;a=this.m_localAnchor1.x-
this.m_bodyA.m_sweep.localCenter.x;var b=this.m_localAnchor1.y-this.m_bodyA.m_sweep.localCenter.y,c=this.m_bodyA.m_xf.R.col1.x*a+this.m_bodyA.m_xf.R.col2.x*b,b=this.m_bodyA.m_xf.R.col1.y*a+this.m_bodyA.m_xf.R.col2.y*b;a=c;var d=this.m_localAnchor2.x-this.m_bodyB.m_sweep.localCenter.x,e=this.m_localAnchor2.y-this.m_bodyB.m_sweep.localCenter.y,c=this.m_bodyB.m_xf.R.col1.x*d+this.m_bodyB.m_xf.R.col2.x*e,e=this.m_bodyB.m_xf.R.col1.y*d+this.m_bodyB.m_xf.R.col2.y*e,d=c,h=this.m_bodyB.m_sweep.c.x+d-this.m_bodyA.m_sweep.c.x-
a,g=this.m_bodyB.m_sweep.c.y+e-this.m_bodyA.m_sweep.c.y-b,c=Math.sqrt(h*h+g*g),h=h/c,g=g/c,c=Box2D.Common.Math.b2Math.Clamp(c-this.m_length,-Box2D.Common.b2Settings.b2_maxLinearCorrection,Box2D.Common.b2Settings.b2_maxLinearCorrection),l=-this.m_mass*c;this.m_u.Set(h,g);h=l*this.m_u.x;g=l*this.m_u.y;this.m_bodyA.m_sweep.c.x-=this.m_bodyA.m_invMass*h;this.m_bodyA.m_sweep.c.y-=this.m_bodyA.m_invMass*g;this.m_bodyA.m_sweep.a-=this.m_bodyA.m_invI*(a*g-b*h);this.m_bodyB.m_sweep.c.x+=this.m_bodyB.m_invMass*
h;this.m_bodyB.m_sweep.c.y+=this.m_bodyB.m_invMass*g;this.m_bodyB.m_sweep.a+=this.m_bodyB.m_invI*(d*g-e*h);this.m_bodyA.SynchronizeTransform();this.m_bodyB.SynchronizeTransform();return Math.abs(c)<Box2D.Common.b2Settings.b2_linearSlop};Box2D.Dynamics.Joints.b2DistanceJointDef=function(){Box2D.Dynamics.Joints.b2JointDef.call(this);this.localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.type=Box2D.Dynamics.Joints.b2Joint.e_distanceJoint;this.length=
1;this.dampingRatio=this.frequencyHz=0};c2inherit(Box2D.Dynamics.Joints.b2DistanceJointDef,Box2D.Dynamics.Joints.b2JointDef);Box2D.Dynamics.Joints.b2DistanceJointDef.prototype.Initialize=function(a,b,c,d){this.bodyA=a;this.bodyB=b;this.localAnchorA.SetV(this.bodyA.GetLocalPoint(c));this.localAnchorB.SetV(this.bodyB.GetLocalPoint(d));a=d.x-c.x;c=d.y-c.y;this.length=Math.sqrt(a*a+c*c);this.dampingRatio=this.frequencyHz=0};Box2D.Dynamics.Joints.b2DistanceJointDef.prototype.Create=function(){return new Box2D.Dynamics.Joints.b2DistanceJoint(this)};
Box2D.Dynamics.Joints.b2FrictionJoint=function(a){Box2D.Dynamics.Joints.b2Joint.call(this,a);this.m_localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_linearMass=new Box2D.Common.Math.b2Mat22;this.m_linearImpulse=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchorA.SetV(a.localAnchorA);this.m_localAnchorB.SetV(a.localAnchorB);this.m_linearMass.SetZero();this.m_angularMass=0;this.m_linearImpulse.SetZero();this.m_angularImpulse=0;this.m_maxForce=
a.maxForce;this.m_maxTorque=a.maxTorque};c2inherit(Box2D.Dynamics.Joints.b2FrictionJoint,Box2D.Dynamics.Joints.b2Joint);Box2D.Dynamics.Joints.b2FrictionJoint.prototype.GetAnchorA=function(){return this.m_bodyA.GetWorldPoint(this.m_localAnchorA)};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.GetAnchorB=function(){return this.m_bodyB.GetWorldPoint(this.m_localAnchorB)};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.GetReactionForce=function(a){void 0===a&&(a=0);return new b2Vec2(a*this.m_linearImpulse.x,
a*this.m_linearImpulse.y)};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.GetReactionTorque=function(a){void 0===a&&(a=0);return a*this.m_angularImpulse};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.SetMaxForce=function(a){void 0===a&&(a=0);this.m_maxForce=a};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.GetMaxForce=function(){return this.m_maxForce};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.SetMaxTorque=function(a){void 0===a&&(a=0);this.m_maxTorque=a};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.GetMaxTorque=
function(){return this.m_maxTorque};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.InitVelocityConstraints=function(a){var b,c=0,d=this.m_bodyA,e=this.m_bodyB;b=d.m_xf.R;var h=this.m_localAnchorA.x-d.m_sweep.localCenter.x,g=this.m_localAnchorA.y-d.m_sweep.localCenter.y,c=b.col1.x*h+b.col2.x*g,g=b.col1.y*h+b.col2.y*g,h=c;b=e.m_xf.R;var l=this.m_localAnchorB.x-e.m_sweep.localCenter.x,k=this.m_localAnchorB.y-e.m_sweep.localCenter.y,c=b.col1.x*l+b.col2.x*k,k=b.col1.y*l+b.col2.y*k,l=c;b=d.m_invMass;var c=
e.m_invMass,f=d.m_invI,m=e.m_invI,n=new Box2D.Common.Math.b2Mat22;n.col1.x=b+c;n.col2.x=0;n.col1.y=0;n.col2.y=b+c;n.col1.x+=f*g*g;n.col2.x+=-f*h*g;n.col1.y+=-f*h*g;n.col2.y+=f*h*h;n.col1.x+=m*k*k;n.col2.x+=-m*l*k;n.col1.y+=-m*l*k;n.col2.y+=m*l*l;n.GetInverse(this.m_linearMass);this.m_angularMass=f+m;0<this.m_angularMass&&(this.m_angularMass=1/this.m_angularMass);a.warmStarting?(this.m_linearImpulse.x*=a.dtRatio,this.m_linearImpulse.y*=a.dtRatio,this.m_angularImpulse*=a.dtRatio,a=this.m_linearImpulse,
d.m_linearVelocity.x-=b*a.x,d.m_linearVelocity.y-=b*a.y,d.m_angularVelocity-=f*(h*a.y-g*a.x+this.m_angularImpulse),e.m_linearVelocity.x+=c*a.x,e.m_linearVelocity.y+=c*a.y,e.m_angularVelocity+=m*(l*a.y-k*a.x+this.m_angularImpulse)):(this.m_linearImpulse.SetZero(),this.m_angularImpulse=0)};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.SolveVelocityConstraints=function(a){var b,c=0,d=this.m_bodyA,e=this.m_bodyB,h=d.m_linearVelocity,g=d.m_angularVelocity,l=e.m_linearVelocity,k=e.m_angularVelocity,f=
d.m_invMass,m=e.m_invMass,n=d.m_invI,p=e.m_invI;b=d.m_xf.R;var q=this.m_localAnchorA.x-d.m_sweep.localCenter.x,s=this.m_localAnchorA.y-d.m_sweep.localCenter.y,c=b.col1.x*q+b.col2.x*s,s=b.col1.y*q+b.col2.y*s,q=c;b=e.m_xf.R;var r=this.m_localAnchorB.x-e.m_sweep.localCenter.x,t=this.m_localAnchorB.y-e.m_sweep.localCenter.y,c=b.col1.x*r+b.col2.x*t,t=b.col1.y*r+b.col2.y*t,r=c;b=0;var c=-this.m_angularMass*(k-g),w=this.m_angularImpulse;b=a.dt*this.m_maxTorque;this.m_angularImpulse=Box2D.Common.Math.b2Math.Clamp(this.m_angularImpulse+
c,-b,b);c=this.m_angularImpulse-w;g-=n*c;k+=p*c;b=Box2D.Common.Math.b2Math.MulMV(this.m_linearMass,Box2D.Common.Math.b2Vec2.Get(-(l.x-k*t-h.x+g*s),-(l.y+k*r-h.y-g*q)));c=this.m_linearImpulse.Copy();this.m_linearImpulse.Add(b);b=a.dt*this.m_maxForce;this.m_linearImpulse.LengthSquared()>b*b&&(this.m_linearImpulse.Normalize(),this.m_linearImpulse.Multiply(b));b=Box2D.Common.Math.b2Math.SubtractVV(this.m_linearImpulse,c);h.x-=f*b.x;h.y-=f*b.y;g-=n*(q*b.y-s*b.x);l.x+=m*b.x;l.y+=m*b.y;k+=p*(r*b.y-t*b.x);
d.m_angularVelocity=g;e.m_angularVelocity=k};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.SolvePositionConstraints=function(a){return!0};Box2D.Dynamics.Joints.b2FrictionJointDef=function(){Box2D.Dynamics.Joints.b2JointDef.call(this);this.localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.type=Box2D.Dynamics.Joints.b2Joint.e_frictionJoint;this.maxTorque=this.maxForce=0};c2inherit(Box2D.Dynamics.Joints.b2FrictionJointDef,Box2D.Dynamics.Joints.b2JointDef);
Box2D.Dynamics.Joints.b2FrictionJointDef.prototype.Initialize=function(a,b,c){this.bodyA=a;this.bodyB=b;this.localAnchorA.SetV(this.bodyA.GetLocalPoint(c));this.localAnchorB.SetV(this.bodyB.GetLocalPoint(c))};Box2D.Dynamics.Joints.b2FrictionJointDef.prototype.Create=function(){return new Box2D.Dynamics.Joints.b2FrictionJoint(this)};Box2D.Dynamics.Joints.b2GearJoint=function(a){Box2D.Dynamics.Joints.b2Joint.call(this,a);this.m_groundAnchor1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_groundAnchor2=Box2D.Common.Math.b2Vec2.Get(0,
0);this.m_localAnchor1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor2=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_J=new Box2D.Dynamics.Joints.b2Jacobian;var b=a.joint1.m_type,c=a.joint2.m_type;this.m_prismatic2=this.m_revolute2=this.m_prismatic1=this.m_revolute1=null;var d=0,e=0;this.m_ground1=a.joint1.GetBodyA();this.m_bodyA=a.joint1.GetBodyB();b==Box2D.Dynamics.Joints.b2Joint.e_revoluteJoint?(this.m_revolute1=a.joint1,this.m_groundAnchor1.SetV(this.m_revolute1.m_localAnchor1),this.m_localAnchor1.SetV(this.m_revolute1.m_localAnchor2),
d=this.m_revolute1.GetJointAngle()):(this.m_prismatic1=a.joint1,this.m_groundAnchor1.SetV(this.m_prismatic1.m_localAnchor1),this.m_localAnchor1.SetV(this.m_prismatic1.m_localAnchor2),d=this.m_prismatic1.GetJointTranslation());this.m_ground2=a.joint2.GetBodyA();this.m_bodyB=a.joint2.GetBodyB();c==Box2D.Dynamics.Joints.b2Joint.e_revoluteJoint?(this.m_revolute2=a.joint2,this.m_groundAnchor2.SetV(this.m_revolute2.m_localAnchor1),this.m_localAnchor2.SetV(this.m_revolute2.m_localAnchor2),e=this.m_revolute2.GetJointAngle()):
(this.m_prismatic2=a.joint2,this.m_groundAnchor2.SetV(this.m_prismatic2.m_localAnchor1),this.m_localAnchor2.SetV(this.m_prismatic2.m_localAnchor2),e=this.m_prismatic2.GetJointTranslation());this.m_ratio=a.ratio;this.m_constant=d+this.m_ratio*e;this.m_impulse=0};c2inherit(Box2D.Dynamics.Joints.b2GearJoint,Box2D.Dynamics.Joints.b2Joint);Box2D.Dynamics.Joints.b2GearJoint.prototype.GetAnchorA=function(){return this.m_bodyA.GetWorldPoint(this.m_localAnchor1)};Box2D.Dynamics.Joints.b2GearJoint.prototype.GetAnchorB=
function(){return this.m_bodyB.GetWorldPoint(this.m_localAnchor2)};Box2D.Dynamics.Joints.b2GearJoint.prototype.GetReactionForce=function(a){void 0===a&&(a=0);return Box2D.Common.Math.b2Vec2.Get(a*this.m_impulse*this.m_J.linearB.x,a*this.m_impulse*this.m_J.linearB.y)};Box2D.Dynamics.Joints.b2GearJoint.prototype.GetReactionTorque=function(a){void 0===a&&(a=0);var b=this.m_bodyB.m_xf.R,c=this.m_localAnchor1.x-this.m_bodyB.m_sweep.localCenter.x,d=this.m_localAnchor1.y-this.m_bodyB.m_sweep.localCenter.y,
e=b.col1.x*c+b.col2.x*d,d=b.col1.y*c+b.col2.y*d;return a*(this.m_impulse*this.m_J.angularB-e*this.m_impulse*this.m_J.linearB.y+d*this.m_impulse*this.m_J.linearB.x)};Box2D.Dynamics.Joints.b2GearJoint.prototype.GetRatio=function(){return this.m_ratio};Box2D.Dynamics.Joints.b2GearJoint.prototype.SetRatio=function(a){void 0===a&&(a=0);this.m_ratio=a};Box2D.Dynamics.Joints.b2GearJoint.prototype.InitVelocityConstraints=function(a){var b=this.m_ground1,c=this.m_ground2,d=this.m_bodyA,e=this.m_bodyB,h=0,
g=0,l=0,k=0,f=l=0,m=0;this.m_J.SetZero();this.m_revolute1?(this.m_J.angularA=-1,m+=d.m_invI):(b=b.m_xf.R,g=this.m_prismatic1.m_localXAxis1,h=b.col1.x*g.x+b.col2.x*g.y,g=b.col1.y*g.x+b.col2.y*g.y,b=d.m_xf.R,l=this.m_localAnchor1.x-d.m_sweep.localCenter.x,k=this.m_localAnchor1.y-d.m_sweep.localCenter.y,f=b.col1.x*l+b.col2.x*k,k=b.col1.y*l+b.col2.y*k,l=f*g-k*h,this.m_J.linearA.Set(-h,-g),this.m_J.angularA=-l,m+=d.m_invMass+d.m_invI*l*l);this.m_revolute2?(this.m_J.angularB=-this.m_ratio,m+=this.m_ratio*
this.m_ratio*e.m_invI):(b=c.m_xf.R,g=this.m_prismatic2.m_localXAxis1,h=b.col1.x*g.x+b.col2.x*g.y,g=b.col1.y*g.x+b.col2.y*g.y,b=e.m_xf.R,l=this.m_localAnchor2.x-e.m_sweep.localCenter.x,k=this.m_localAnchor2.y-e.m_sweep.localCenter.y,f=b.col1.x*l+b.col2.x*k,k=b.col1.y*l+b.col2.y*k,l=f*g-k*h,this.m_J.linearB.Set(-this.m_ratio*h,-this.m_ratio*g),this.m_J.angularB=-this.m_ratio*l,m+=this.m_ratio*this.m_ratio*(e.m_invMass+e.m_invI*l*l));this.m_mass=0<m?1/m:0;a.warmStarting?(d.m_linearVelocity.x+=d.m_invMass*
this.m_impulse*this.m_J.linearA.x,d.m_linearVelocity.y+=d.m_invMass*this.m_impulse*this.m_J.linearA.y,d.m_angularVelocity+=d.m_invI*this.m_impulse*this.m_J.angularA,e.m_linearVelocity.x+=e.m_invMass*this.m_impulse*this.m_J.linearB.x,e.m_linearVelocity.y+=e.m_invMass*this.m_impulse*this.m_J.linearB.y,e.m_angularVelocity+=e.m_invI*this.m_impulse*this.m_J.angularB):this.m_impulse=0};Box2D.Dynamics.Joints.b2GearJoint.prototype.SolveVelocityConstraints=function(a){a=this.m_bodyA;var b=this.m_bodyB,c=this.m_J.Compute(a.m_linearVelocity,
a.m_angularVelocity,b.m_linearVelocity,b.m_angularVelocity),c=-this.m_mass*c;this.m_impulse+=c;a.m_linearVelocity.x+=a.m_invMass*c*this.m_J.linearA.x;a.m_linearVelocity.y+=a.m_invMass*c*this.m_J.linearA.y;a.m_angularVelocity+=a.m_invI*c*this.m_J.angularA;b.m_linearVelocity.x+=b.m_invMass*c*this.m_J.linearB.x;b.m_linearVelocity.y+=b.m_invMass*c*this.m_J.linearB.y;b.m_angularVelocity+=b.m_invI*c*this.m_J.angularB};Box2D.Dynamics.Joints.b2GearJoint.prototype.SolvePositionConstraints=function(a){a=this.m_bodyA;
var b=this.m_bodyB,c=0,d=0,c=this.m_revolute1?this.m_revolute1.GetJointAngle():this.m_prismatic1.GetJointTranslation(),d=this.m_revolute2?this.m_revolute2.GetJointAngle():this.m_prismatic2.GetJointTranslation(),c=-this.m_mass*(this.m_constant-(c+this.m_ratio*d));a.m_sweep.c.x+=a.m_invMass*c*this.m_J.linearA.x;a.m_sweep.c.y+=a.m_invMass*c*this.m_J.linearA.y;a.m_sweep.a+=a.m_invI*c*this.m_J.angularA;b.m_sweep.c.x+=b.m_invMass*c*this.m_J.linearB.x;b.m_sweep.c.y+=b.m_invMass*c*this.m_J.linearB.y;b.m_sweep.a+=
b.m_invI*c*this.m_J.angularB;a.SynchronizeTransform();b.SynchronizeTransform();return 0<Box2D.Common.b2Settings.b2_linearSlop};Box2D.Dynamics.Joints.b2GearJointDef=function(){Box2D.Dynamics.Joints.b2JointDef.call(this);this.type=Box2D.Dynamics.Joints.b2Joint.e_gearJoint;this.joint2=this.joint1=null;this.ratio=1};c2inherit(Box2D.Dynamics.Joints.b2GearJointDef,Box2D.Dynamics.Joints.b2JointDef);Box2D.Dynamics.Joints.b2GearJointDef.prototype.Initialize=function(a,b,c){this.joint1=a;this.bodyA=a.GetBodyA();
this.joint2=b;this.bodyB=b.GetBodyA();this.ratio=c};Box2D.Dynamics.Joints.b2GearJointDef.prototype.Create=function(){return new Box2D.Dynamics.Joints.b2GearJoint(this)};Box2D.Dynamics.Joints.b2Jacobian=function(){this.linearA=Box2D.Common.Math.b2Vec2.Get(0,0);this.linearB=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Dynamics.Joints.b2Jacobian.prototype.SetZero=function(){this.linearA.SetZero();this.angularA=0;this.linearB.SetZero();this.angularB=0};Box2D.Dynamics.Joints.b2Jacobian.prototype.Set=function(a,
b,c,d){void 0===b&&(b=0);void 0===d&&(d=0);this.linearA.SetV(a);this.angularA=b;this.linearB.SetV(c);this.angularB=d};Box2D.Dynamics.Joints.b2Jacobian.prototype.Compute=function(a,b,c,d){void 0===b&&(b=0);void 0===d&&(d=0);return this.linearA.x*a.x+this.linearA.y*a.y+this.angularA*b+(this.linearB.x*c.x+this.linearB.y*c.y)+this.angularB*d};Box2D.Dynamics.Joints.b2LineJoint=function(a){Box2D.Dynamics.Joints.b2Joint.call(this,a);this.m_localAnchor1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor2=
Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localXAxis1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localYAxis1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_axis=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_perp=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_K=new Box2D.Common.Math.b2Mat22;this.m_impulse=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor1.SetV(a.localAnchorA);this.m_localAnchor2.SetV(a.localAnchorB);this.m_localXAxis1.SetV(a.localAxisA);this.m_localYAxis1.x=-this.m_localXAxis1.y;this.m_localYAxis1.y=
this.m_localXAxis1.x;this.m_impulse.SetZero();this.m_motorImpulse=this.m_motorMass=0;this.m_lowerTranslation=a.lowerTranslation;this.m_upperTranslation=a.upperTranslation;this.m_maxMotorForce=a.maxMotorForce;this.m_motorSpeed=a.motorSpeed;this.m_enableLimit=a.enableLimit;this.m_enableMotor=a.enableMotor;this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit;this.m_axis.SetZero();this.m_perp.SetZero()};c2inherit(Box2D.Dynamics.Joints.b2LineJoint,Box2D.Dynamics.Joints.b2Joint);Box2D.Dynamics.Joints.b2LineJoint.prototype.GetAnchorA=
function(){return this.m_bodyA.GetWorldPoint(this.m_localAnchor1)};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetAnchorB=function(){return this.m_bodyB.GetWorldPoint(this.m_localAnchor2)};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetReactionForce=function(a){void 0===a&&(a=0);return Box2D.Common.Math.b2Vec2.Get(a*(this.m_impulse.x*this.m_perp.x+(this.m_motorImpulse+this.m_impulse.y)*this.m_axis.x),a*(this.m_impulse.x*this.m_perp.y+(this.m_motorImpulse+this.m_impulse.y)*this.m_axis.y))};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetReactionTorque=
function(a){void 0===a&&(a=0);return a*this.m_impulse.y};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetJointTranslation=function(){var a=this.m_bodyA,b=this.m_bodyB,c=a.GetWorldPoint(this.m_localAnchor1),d=b.GetWorldPoint(this.m_localAnchor2),b=d.x-c.x,c=d.y-c.y,a=a.GetWorldVector(this.m_localXAxis1);return a.x*b+a.y*c};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetJointSpeed=function(){var a=this.m_bodyA,b=this.m_bodyB,c;c=a.m_xf.R;var d=this.m_localAnchor1.x-a.m_sweep.localCenter.x,e=this.m_localAnchor1.y-
a.m_sweep.localCenter.y,h=c.col1.x*d+c.col2.x*e,e=c.col1.y*d+c.col2.y*e,d=h;c=b.m_xf.R;var g=this.m_localAnchor2.x-b.m_sweep.localCenter.x,l=this.m_localAnchor2.y-b.m_sweep.localCenter.y,h=c.col1.x*g+c.col2.x*l,l=c.col1.y*g+c.col2.y*l,g=h;c=b.m_sweep.c.x+g-(a.m_sweep.c.x+d);var h=b.m_sweep.c.y+l-(a.m_sweep.c.y+e),k=a.GetWorldVector(this.m_localXAxis1),f=a.m_linearVelocity,m=b.m_linearVelocity,a=a.m_angularVelocity,b=b.m_angularVelocity;return c*-a*k.y+h*a*k.x+(k.x*(m.x+-b*l-f.x- -a*e)+k.y*(m.y+b*
g-f.y-a*d))};Box2D.Dynamics.Joints.b2LineJoint.prototype.IsLimitEnabled=function(){return this.m_enableLimit};Box2D.Dynamics.Joints.b2LineJoint.prototype.EnableLimit=function(a){this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_enableLimit=a};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetLowerLimit=function(){return this.m_lowerTranslation};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetUpperLimit=function(){return this.m_upperTranslation};Box2D.Dynamics.Joints.b2LineJoint.prototype.SetLimits=
function(a,b){void 0===a&&(a=0);void 0===b&&(b=0);this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_lowerTranslation=a;this.m_upperTranslation=b};Box2D.Dynamics.Joints.b2LineJoint.prototype.IsMotorEnabled=function(){return this.m_enableMotor};Box2D.Dynamics.Joints.b2LineJoint.prototype.EnableMotor=function(a){this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_enableMotor=a};Box2D.Dynamics.Joints.b2LineJoint.prototype.SetMotorSpeed=function(a){void 0===a&&(a=0);this.m_bodyA.SetAwake(!0);
this.m_bodyB.SetAwake(!0);this.m_motorSpeed=a};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetMotorSpeed=function(){return this.m_motorSpeed};Box2D.Dynamics.Joints.b2LineJoint.prototype.SetMaxMotorForce=function(a){void 0===a&&(a=0);this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_maxMotorForce=a};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetMaxMotorForce=function(){return this.m_maxMotorForce};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetMotorForce=function(){return this.m_motorImpulse};
Box2D.Dynamics.Joints.b2LineJoint.prototype.InitVelocityConstraints=function(a){var b=this.m_bodyA,c=this.m_bodyB,d,e=0;this.m_localCenterA.SetV(b.GetLocalCenter());this.m_localCenterB.SetV(c.GetLocalCenter());var h=b.GetTransform();c.GetTransform();d=b.m_xf.R;var g=this.m_localAnchor1.x-this.m_localCenterA.x,l=this.m_localAnchor1.y-this.m_localCenterA.y,e=d.col1.x*g+d.col2.x*l,l=d.col1.y*g+d.col2.y*l,g=e;d=c.m_xf.R;var k=this.m_localAnchor2.x-this.m_localCenterB.x,f=this.m_localAnchor2.y-this.m_localCenterB.y,
e=d.col1.x*k+d.col2.x*f,f=d.col1.y*k+d.col2.y*f,k=e;d=c.m_sweep.c.x+k-b.m_sweep.c.x-g;e=c.m_sweep.c.y+f-b.m_sweep.c.y-l;this.m_invMassA=b.m_invMass;this.m_invMassB=c.m_invMass;this.m_invIA=b.m_invI;this.m_invIB=c.m_invI;this.m_axis.SetV(Box2D.Common.Math.b2Math.MulMV(h.R,this.m_localXAxis1));this.m_a1=(d+g)*this.m_axis.y-(e+l)*this.m_axis.x;this.m_a2=k*this.m_axis.y-f*this.m_axis.x;this.m_motorMass=this.m_invMassA+this.m_invMassB+this.m_invIA*this.m_a1*this.m_a1+this.m_invIB*this.m_a2*this.m_a2;this.m_motorMass=
this.m_motorMass>Number.MIN_VALUE?1/this.m_motorMass:0;this.m_perp.SetV(Box2D.Common.Math.b2Math.MulMV(h.R,this.m_localYAxis1));this.m_s1=(d+g)*this.m_perp.y-(e+l)*this.m_perp.x;this.m_s2=k*this.m_perp.y-f*this.m_perp.x;h=this.m_invMassA;g=this.m_invMassB;l=this.m_invIA;k=this.m_invIB;this.m_K.col1.x=h+g+l*this.m_s1*this.m_s1+k*this.m_s2*this.m_s2;this.m_K.col1.y=l*this.m_s1*this.m_a1+k*this.m_s2*this.m_a2;this.m_K.col2.x=this.m_K.col1.y;this.m_K.col2.y=h+g+l*this.m_a1*this.m_a1+k*this.m_a2*this.m_a2;
this.m_enableLimit?(d=this.m_axis.x*d+this.m_axis.y*e,Math.abs(this.m_upperTranslation-this.m_lowerTranslation)<2*Box2D.Common.b2Settings.b2_linearSlop?this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_equalLimits:d<=this.m_lowerTranslation?this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit&&(this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit,this.m_impulse.y=0):d>=this.m_upperTranslation?this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(this.m_limitState=
Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit,this.m_impulse.y=0):(this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit,this.m_impulse.y=0)):this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit;!1==this.m_enableMotor&&(this.m_motorImpulse=0);a.warmStarting?(this.m_impulse.x*=a.dtRatio,this.m_impulse.y*=a.dtRatio,this.m_motorImpulse*=a.dtRatio,a=this.m_impulse.x*this.m_perp.x+(this.m_motorImpulse+this.m_impulse.y)*this.m_axis.x,d=this.m_impulse.x*this.m_perp.y+(this.m_motorImpulse+
this.m_impulse.y)*this.m_axis.y,e=this.m_impulse.x*this.m_s1+(this.m_motorImpulse+this.m_impulse.y)*this.m_a1,h=this.m_impulse.x*this.m_s2+(this.m_motorImpulse+this.m_impulse.y)*this.m_a2,b.m_linearVelocity.x-=this.m_invMassA*a,b.m_linearVelocity.y-=this.m_invMassA*d,b.m_angularVelocity-=this.m_invIA*e,c.m_linearVelocity.x+=this.m_invMassB*a,c.m_linearVelocity.y+=this.m_invMassB*d,c.m_angularVelocity+=this.m_invIB*h):(this.m_impulse.SetZero(),this.m_motorImpulse=0)};Box2D.Dynamics.Joints.b2LineJoint.prototype.SolveVelocityConstraints=
function(a){var b=this.m_bodyA,c=this.m_bodyB,d=b.m_linearVelocity,e=b.m_angularVelocity,h=c.m_linearVelocity,g=c.m_angularVelocity,l=0,k=0,f=0,m=0;this.m_enableMotor&&this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_equalLimits&&(m=this.m_motorMass*(this.m_motorSpeed-(this.m_axis.x*(h.x-d.x)+this.m_axis.y*(h.y-d.y)+this.m_a2*g-this.m_a1*e)),l=this.m_motorImpulse,k=a.dt*this.m_maxMotorForce,this.m_motorImpulse=Box2D.Common.Math.b2Math.Clamp(this.m_motorImpulse+m,-k,k),m=this.m_motorImpulse-l,l=
m*this.m_axis.x,k=m*this.m_axis.y,f=m*this.m_a1,m*=this.m_a2,d.x-=this.m_invMassA*l,d.y-=this.m_invMassA*k,e-=this.m_invIA*f,h.x+=this.m_invMassB*l,h.y+=this.m_invMassB*k,g+=this.m_invIB*m);k=this.m_perp.x*(h.x-d.x)+this.m_perp.y*(h.y-d.y)+this.m_s2*g-this.m_s1*e;this.m_enableLimit&&this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit?(f=this.m_axis.x*(h.x-d.x)+this.m_axis.y*(h.y-d.y)+this.m_a2*g-this.m_a1*e,l=this.m_impulse.Copy(),a=this.m_K.Solve(Box2D.Common.Math.b2Vec2.Get(0,0),-k,
-f),this.m_impulse.Add(a),this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit?this.m_impulse.y=Math.max(this.m_impulse.y,0):this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(this.m_impulse.y=Math.min(this.m_impulse.y,0)),k=-k-(this.m_impulse.y-l.y)*this.m_K.col2.x,f=0,f=0!=this.m_K.col1.x?k/this.m_K.col1.x+l.x:l.x,this.m_impulse.x=f,a.x=this.m_impulse.x-l.x,a.y=this.m_impulse.y-l.y,l=a.x*this.m_perp.x+a.y*this.m_axis.x,k=a.x*this.m_perp.y+a.y*this.m_axis.y,f=a.x*this.m_s1+
a.y*this.m_a1,m=a.x*this.m_s2+a.y*this.m_a2):(a=0,a=0!=this.m_K.col1.x?-k/this.m_K.col1.x:0,this.m_impulse.x+=a,l=a*this.m_perp.x,k=a*this.m_perp.y,f=a*this.m_s1,m=a*this.m_s2);d.x-=this.m_invMassA*l;d.y-=this.m_invMassA*k;e-=this.m_invIA*f;h.x+=this.m_invMassB*l;h.y+=this.m_invMassB*k;g+=this.m_invIB*m;b.m_linearVelocity.SetV(d);b.m_angularVelocity=e;c.m_linearVelocity.SetV(h);c.m_angularVelocity=g};Box2D.Dynamics.Joints.b2LineJoint.prototype.SolvePositionConstraints=function(a){a=this.m_bodyA;var b=
this.m_bodyB,c=a.m_sweep.c,d=a.m_sweep.a,e=b.m_sweep.c,h=b.m_sweep.a,g,l=0,k=0,f=0,m=0,n=g=0,p=0,k=!1,q=0,s=Box2D.Common.Math.b2Mat22.FromAngle(d),f=Box2D.Common.Math.b2Mat22.FromAngle(h);g=s;var p=this.m_localAnchor1.x-this.m_localCenterA.x,r=this.m_localAnchor1.y-this.m_localCenterA.y,l=g.col1.x*p+g.col2.x*r,r=g.col1.y*p+g.col2.y*r,p=l;g=f;f=this.m_localAnchor2.x-this.m_localCenterB.x;m=this.m_localAnchor2.y-this.m_localCenterB.y;l=g.col1.x*f+g.col2.x*m;m=g.col1.y*f+g.col2.y*m;f=l;g=e.x+f-c.x-p;
l=e.y+m-c.y-r;if(this.m_enableLimit){this.m_axis=Box2D.Common.Math.b2Math.MulMV(s,this.m_localXAxis1);this.m_a1=(g+p)*this.m_axis.y-(l+r)*this.m_axis.x;this.m_a2=f*this.m_axis.y-m*this.m_axis.x;var t=this.m_axis.x*g+this.m_axis.y*l;Math.abs(this.m_upperTranslation-this.m_lowerTranslation)<2*Box2D.Common.b2Settings.b2_linearSlop?(q=Box2D.Common.Math.b2Math.Clamp(t,-Box2D.Common.b2Settings.b2_maxLinearCorrection,Box2D.Common.b2Settings.b2_maxLinearCorrection),n=Math.abs(t),k=!0):t<=this.m_lowerTranslation?
(q=Box2D.Common.Math.b2Math.Clamp(t-this.m_lowerTranslation+Box2D.Common.b2Settings.b2_linearSlop,-Box2D.Common.b2Settings.b2_maxLinearCorrection,0),n=this.m_lowerTranslation-t,k=!0):t>=this.m_upperTranslation&&(q=Box2D.Common.Math.b2Math.Clamp(t-this.m_upperTranslation+Box2D.Common.b2Settings.b2_linearSlop,0,Box2D.Common.b2Settings.b2_maxLinearCorrection),n=t-this.m_upperTranslation,k=!0)}this.m_perp=Box2D.Common.Math.b2Math.MulMV(s,this.m_localYAxis1);this.m_s1=(g+p)*this.m_perp.y-(l+r)*this.m_perp.x;
this.m_s2=f*this.m_perp.y-m*this.m_perp.x;s=Box2D.Common.Math.b2Vec2.Get(0,0);r=this.m_perp.x*g+this.m_perp.y*l;n=Math.max(n,Math.abs(r));p=0;k?(k=this.m_invMassA,f=this.m_invMassB,m=this.m_invIA,g=this.m_invIB,this.m_K.col1.x=k+f+m*this.m_s1*this.m_s1+g*this.m_s2*this.m_s2,this.m_K.col1.y=m*this.m_s1*this.m_a1+g*this.m_s2*this.m_a2,this.m_K.col2.x=this.m_K.col1.y,this.m_K.col2.y=k+f+m*this.m_a1*this.m_a1+g*this.m_a2*this.m_a2,this.m_K.Solve(s,-r,-q)):(k=this.m_invMassA,f=this.m_invMassB,m=this.m_invIA,
g=this.m_invIB,q=k+f+m*this.m_s1*this.m_s1+g*this.m_s2*this.m_s2,s.x=0!=q?-r/q:0,s.y=0);q=s.x*this.m_perp.x+s.y*this.m_axis.x;k=s.x*this.m_perp.y+s.y*this.m_axis.y;r=s.x*this.m_s1+s.y*this.m_a1;s=s.x*this.m_s2+s.y*this.m_a2;c.x-=this.m_invMassA*q;c.y-=this.m_invMassA*k;d-=this.m_invIA*r;e.x+=this.m_invMassB*q;e.y+=this.m_invMassB*k;h+=this.m_invIB*s;a.m_sweep.a=d;b.m_sweep.a=h;a.SynchronizeTransform();b.SynchronizeTransform();return n<=Box2D.Common.b2Settings.b2_linearSlop&&p<=Box2D.Common.b2Settings.b2_angularSlop};
Box2D.Dynamics.Joints.b2LineJointDef=function(){Box2D.Dynamics.Joints.b2JointDef.call(this);this.localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAxisA=Box2D.Common.Math.b2Vec2.Get(0,0);this.type=Box2D.Dynamics.Joints.b2Joint.e_lineJoint;this.localAxisA.Set(1,0);this.enableLimit=!1;this.upperTranslation=this.lowerTranslation=0;this.enableMotor=!1;this.motorSpeed=this.maxMotorForce=0};c2inherit(Box2D.Dynamics.Joints.b2LineJointDef,Box2D.Dynamics.Joints.b2JointDef);
Box2D.Dynamics.Joints.b2LineJointDef.prototype.Initialize=function(a,b,c,d){this.bodyA=a;this.bodyB=b;this.localAnchorA=this.bodyA.GetLocalPoint(c);this.localAnchorB=this.bodyB.GetLocalPoint(c);this.localAxisA=this.bodyA.GetLocalVector(d)};Box2D.Dynamics.Joints.b2LineJointDef.prototype.Create=function(){return new Box2D.Dynamics.Joints.b2LineJoint(this)};Box2D.Dynamics.Joints.b2PrismaticJoint=function(a){Box2D.Dynamics.Joints.b2Joint.call(this,a);this.m_localAnchor1=Box2D.Common.Math.b2Vec2.Get(0,
0);this.m_localAnchor2=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localXAxis1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localYAxis1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_axis=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_perp=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_K=new Box2D.Common.Math.b2Mat33;this.m_impulse=new Box2D.Common.Math.b2Vec3(0,0,0);this.m_localAnchor1.SetV(a.localAnchorA);this.m_localAnchor2.SetV(a.localAnchorB);this.m_localXAxis1.SetV(a.localAxisA);this.m_localYAxis1.x=-this.m_localXAxis1.y;
this.m_localYAxis1.y=this.m_localXAxis1.x;this.m_refAngle=a.referenceAngle;this.m_impulse.SetZero();this.m_motorImpulse=this.m_motorMass=0;this.m_lowerTranslation=a.lowerTranslation;this.m_upperTranslation=a.upperTranslation;this.m_maxMotorForce=a.maxMotorForce;this.m_motorSpeed=a.motorSpeed;this.m_enableLimit=a.enableLimit;this.m_enableMotor=a.enableMotor;this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit;this.m_axis.SetZero();this.m_perp.SetZero()};c2inherit(Box2D.Dynamics.Joints.b2PrismaticJoint,
Box2D.Dynamics.Joints.b2Joint);Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetAnchorA=function(){return this.m_bodyA.GetWorldPoint(this.m_localAnchor1)};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetAnchorB=function(){return this.m_bodyB.GetWorldPoint(this.m_localAnchor2)};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetReactionForce=function(a){void 0===a&&(a=0);return Box2D.Common.Math.b2Vec2.Get(a*(this.m_impulse.x*this.m_perp.x+(this.m_motorImpulse+this.m_impulse.z)*this.m_axis.x),
a*(this.m_impulse.x*this.m_perp.y+(this.m_motorImpulse+this.m_impulse.z)*this.m_axis.y))};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetReactionTorque=function(a){void 0===a&&(a=0);return a*this.m_impulse.y};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetJointTranslation=function(){var a=this.m_bodyA,b=this.m_bodyB,c=a.GetWorldPoint(this.m_localAnchor1),d=b.GetWorldPoint(this.m_localAnchor2),b=d.x-c.x,c=d.y-c.y,a=a.GetWorldVector(this.m_localXAxis1);return a.x*b+a.y*c};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetJointSpeed=
function(){var a=this.m_bodyA,b=this.m_bodyB,c;c=a.m_xf.R;var d=this.m_localAnchor1.x-a.m_sweep.localCenter.x,e=this.m_localAnchor1.y-a.m_sweep.localCenter.y,h=c.col1.x*d+c.col2.x*e,e=c.col1.y*d+c.col2.y*e,d=h;c=b.m_xf.R;var g=this.m_localAnchor2.x-b.m_sweep.localCenter.x,l=this.m_localAnchor2.y-b.m_sweep.localCenter.y,h=c.col1.x*g+c.col2.x*l,l=c.col1.y*g+c.col2.y*l,g=h;c=b.m_sweep.c.x+g-(a.m_sweep.c.x+d);var h=b.m_sweep.c.y+l-(a.m_sweep.c.y+e),k=a.GetWorldVector(this.m_localXAxis1),f=a.m_linearVelocity,
m=b.m_linearVelocity,a=a.m_angularVelocity,b=b.m_angularVelocity;return c*-a*k.y+h*a*k.x+(k.x*(m.x+-b*l-f.x- -a*e)+k.y*(m.y+b*g-f.y-a*d))};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.IsLimitEnabled=function(){return this.m_enableLimit};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.EnableLimit=function(a){this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_enableLimit=a};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetLowerLimit=function(){return this.m_lowerTranslation};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetUpperLimit=
function(){return this.m_upperTranslation};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.SetLimits=function(a,b){void 0===a&&(a=0);void 0===b&&(b=0);this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_lowerTranslation=a;this.m_upperTranslation=b};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.IsMotorEnabled=function(){return this.m_enableMotor};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.EnableMotor=function(a){this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_enableMotor=
a};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.SetMotorSpeed=function(a){void 0===a&&(a=0);this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_motorSpeed=a};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetMotorSpeed=function(){return this.m_motorSpeed};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.SetMaxMotorForce=function(a){void 0===a&&(a=0);this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_maxMotorForce=a};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetMotorForce=
function(){return this.m_motorImpulse};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.InitVelocityConstraints=function(a){var b=this.m_bodyA,c=this.m_bodyB,d,e=0;this.m_localCenterA.SetV(b.GetLocalCenter());this.m_localCenterB.SetV(c.GetLocalCenter());var h=b.GetTransform();c.GetTransform();d=b.m_xf.R;var g=this.m_localAnchor1.x-this.m_localCenterA.x,l=this.m_localAnchor1.y-this.m_localCenterA.y,e=d.col1.x*g+d.col2.x*l,l=d.col1.y*g+d.col2.y*l,g=e;d=c.m_xf.R;var k=this.m_localAnchor2.x-this.m_localCenterB.x,
f=this.m_localAnchor2.y-this.m_localCenterB.y,e=d.col1.x*k+d.col2.x*f,f=d.col1.y*k+d.col2.y*f,k=e;d=c.m_sweep.c.x+k-b.m_sweep.c.x-g;e=c.m_sweep.c.y+f-b.m_sweep.c.y-l;this.m_invMassA=b.m_invMass;this.m_invMassB=c.m_invMass;this.m_invIA=b.m_invI;this.m_invIB=c.m_invI;this.m_axis.SetV(Box2D.Common.Math.b2Math.MulMV(h.R,this.m_localXAxis1));this.m_a1=(d+g)*this.m_axis.y-(e+l)*this.m_axis.x;this.m_a2=k*this.m_axis.y-f*this.m_axis.x;this.m_motorMass=this.m_invMassA+this.m_invMassB+this.m_invIA*this.m_a1*
this.m_a1+this.m_invIB*this.m_a2*this.m_a2;this.m_motorMass>Number.MIN_VALUE&&(this.m_motorMass=1/this.m_motorMass);this.m_perp.SetV(Box2D.Common.Math.b2Math.MulMV(h.R,this.m_localYAxis1));this.m_s1=(d+g)*this.m_perp.y-(e+l)*this.m_perp.x;this.m_s2=k*this.m_perp.y-f*this.m_perp.x;h=this.m_invMassA;g=this.m_invMassB;l=this.m_invIA;k=this.m_invIB;this.m_K.col1.x=h+g+l*this.m_s1*this.m_s1+k*this.m_s2*this.m_s2;this.m_K.col1.y=l*this.m_s1+k*this.m_s2;this.m_K.col1.z=l*this.m_s1*this.m_a1+k*this.m_s2*
this.m_a2;this.m_K.col2.x=this.m_K.col1.y;this.m_K.col2.y=l+k;this.m_K.col2.z=l*this.m_a1+k*this.m_a2;this.m_K.col3.x=this.m_K.col1.z;this.m_K.col3.y=this.m_K.col2.z;this.m_K.col3.z=h+g+l*this.m_a1*this.m_a1+k*this.m_a2*this.m_a2;this.m_enableLimit?(d=this.m_axis.x*d+this.m_axis.y*e,Math.abs(this.m_upperTranslation-this.m_lowerTranslation)<2*Box2D.Common.b2Settings.b2_linearSlop?this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_equalLimits:d<=this.m_lowerTranslation?this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit&&
(this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit,this.m_impulse.z=0):d>=this.m_upperTranslation?this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit,this.m_impulse.z=0):(this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit,this.m_impulse.z=0)):this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit;!1==this.m_enableMotor&&(this.m_motorImpulse=0);a.warmStarting?(this.m_impulse.x*=a.dtRatio,
this.m_impulse.y*=a.dtRatio,this.m_motorImpulse*=a.dtRatio,a=this.m_impulse.x*this.m_perp.x+(this.m_motorImpulse+this.m_impulse.z)*this.m_axis.x,d=this.m_impulse.x*this.m_perp.y+(this.m_motorImpulse+this.m_impulse.z)*this.m_axis.y,e=this.m_impulse.x*this.m_s1+this.m_impulse.y+(this.m_motorImpulse+this.m_impulse.z)*this.m_a1,h=this.m_impulse.x*this.m_s2+this.m_impulse.y+(this.m_motorImpulse+this.m_impulse.z)*this.m_a2,b.m_linearVelocity.x-=this.m_invMassA*a,b.m_linearVelocity.y-=this.m_invMassA*d,
b.m_angularVelocity-=this.m_invIA*e,c.m_linearVelocity.x+=this.m_invMassB*a,c.m_linearVelocity.y+=this.m_invMassB*d,c.m_angularVelocity+=this.m_invIB*h):(this.m_impulse.SetZero(),this.m_motorImpulse=0)};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.SolveVelocityConstraints=function(a){var b=this.m_bodyA,c=this.m_bodyB,d=b.m_linearVelocity,e=b.m_angularVelocity,h=c.m_linearVelocity,g=c.m_angularVelocity,l=0,k=0,f=0,m=0;this.m_enableMotor&&this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_equalLimits&&
(m=this.m_motorMass*(this.m_motorSpeed-(this.m_axis.x*(h.x-d.x)+this.m_axis.y*(h.y-d.y)+this.m_a2*g-this.m_a1*e)),l=this.m_motorImpulse,a=a.dt*this.m_maxMotorForce,this.m_motorImpulse=Box2D.Common.Math.b2Math.Clamp(this.m_motorImpulse+m,-a,a),m=this.m_motorImpulse-l,l=m*this.m_axis.x,k=m*this.m_axis.y,f=m*this.m_a1,m*=this.m_a2,d.x-=this.m_invMassA*l,d.y-=this.m_invMassA*k,e-=this.m_invIA*f,h.x+=this.m_invMassB*l,h.y+=this.m_invMassB*k,g+=this.m_invIB*m);f=this.m_perp.x*(h.x-d.x)+this.m_perp.y*(h.y-
d.y)+this.m_s2*g-this.m_s1*e;k=g-e;this.m_enableLimit&&this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit?(a=this.m_axis.x*(h.x-d.x)+this.m_axis.y*(h.y-d.y)+this.m_a2*g-this.m_a1*e,l=this.m_impulse.Copy(),a=this.m_K.Solve33(new Box2D.Common.Math.b2Vec3(0,0,0),-f,-k,-a),this.m_impulse.Add(a),this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit?this.m_impulse.z=Math.max(this.m_impulse.z,0):this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(this.m_impulse.z=Math.min(this.m_impulse.z,
0)),f=-f-(this.m_impulse.z-l.z)*this.m_K.col3.x,k=-k-(this.m_impulse.z-l.z)*this.m_K.col3.y,k=this.m_K.Solve22(Box2D.Common.Math.b2Vec2.Get(0,0),f,k),k.x+=l.x,k.y+=l.y,this.m_impulse.x=k.x,this.m_impulse.y=k.y,a.x=this.m_impulse.x-l.x,a.y=this.m_impulse.y-l.y,a.z=this.m_impulse.z-l.z,l=a.x*this.m_perp.x+a.z*this.m_axis.x,k=a.x*this.m_perp.y+a.z*this.m_axis.y,f=a.x*this.m_s1+a.y+a.z*this.m_a1,m=a.x*this.m_s2+a.y+a.z*this.m_a2):(a=this.m_K.Solve22(Box2D.Common.Math.b2Vec2.Get(0,0),-f,-k),this.m_impulse.x+=
a.x,this.m_impulse.y+=a.y,l=a.x*this.m_perp.x,k=a.x*this.m_perp.y,f=a.x*this.m_s1+a.y,m=a.x*this.m_s2+a.y);d.x-=this.m_invMassA*l;d.y-=this.m_invMassA*k;e-=this.m_invIA*f;h.x+=this.m_invMassB*l;h.y+=this.m_invMassB*k;g+=this.m_invIB*m;b.m_linearVelocity.SetV(d);b.m_angularVelocity=e;c.m_linearVelocity.SetV(h);c.m_angularVelocity=g};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.SolvePositionConstraints=function(a){a=this.m_bodyA;var b=this.m_bodyB,c=a.m_sweep.c,d=a.m_sweep.a,e=b.m_sweep.c,h=b.m_sweep.a,
g,l=0,k=0,f=0,m=l=g=0,n=0,k=!1,p=0,q=Box2D.Common.Math.b2Mat22.FromAngle(d),s=Box2D.Common.Math.b2Mat22.FromAngle(h);g=q;var n=this.m_localAnchor1.x-this.m_localCenterA.x,r=this.m_localAnchor1.y-this.m_localCenterA.y,l=g.col1.x*n+g.col2.x*r,r=g.col1.y*n+g.col2.y*r,n=l;g=s;s=this.m_localAnchor2.x-this.m_localCenterB.x;f=this.m_localAnchor2.y-this.m_localCenterB.y;l=g.col1.x*s+g.col2.x*f;f=g.col1.y*s+g.col2.y*f;s=l;g=e.x+s-c.x-n;l=e.y+f-c.y-r;if(this.m_enableLimit){this.m_axis=Box2D.Common.Math.b2Math.MulMV(q,
this.m_localXAxis1);this.m_a1=(g+n)*this.m_axis.y-(l+r)*this.m_axis.x;this.m_a2=s*this.m_axis.y-f*this.m_axis.x;var t=this.m_axis.x*g+this.m_axis.y*l;Math.abs(this.m_upperTranslation-this.m_lowerTranslation)<2*Box2D.Common.b2Settings.b2_linearSlop?(p=Box2D.Common.Math.b2Math.Clamp(t,-Box2D.Common.b2Settings.b2_maxLinearCorrection,Box2D.Common.b2Settings.b2_maxLinearCorrection),m=Math.abs(t),k=!0):t<=this.m_lowerTranslation?(p=Box2D.Common.Math.b2Math.Clamp(t-this.m_lowerTranslation+Box2D.Common.b2Settings.b2_linearSlop,
-Box2D.Common.b2Settings.b2_maxLinearCorrection,0),m=this.m_lowerTranslation-t,k=!0):t>=this.m_upperTranslation&&(p=Box2D.Common.Math.b2Math.Clamp(t-this.m_upperTranslation+Box2D.Common.b2Settings.b2_linearSlop,0,Box2D.Common.b2Settings.b2_maxLinearCorrection),m=t-this.m_upperTranslation,k=!0)}this.m_perp=Box2D.Common.Math.b2Math.MulMV(q,this.m_localYAxis1);this.m_s1=(g+n)*this.m_perp.y-(l+r)*this.m_perp.x;this.m_s2=s*this.m_perp.y-f*this.m_perp.x;q=new Box2D.Common.Math.b2Vec3(0,0,0);r=this.m_perp.x*
g+this.m_perp.y*l;s=h-d-this.m_refAngle;m=Math.max(m,Math.abs(r));n=Math.abs(s);k?(k=this.m_invMassA,f=this.m_invMassB,g=this.m_invIA,l=this.m_invIB,this.m_K.col1.x=k+f+g*this.m_s1*this.m_s1+l*this.m_s2*this.m_s2,this.m_K.col1.y=g*this.m_s1+l*this.m_s2,this.m_K.col1.z=g*this.m_s1*this.m_a1+l*this.m_s2*this.m_a2,this.m_K.col2.x=this.m_K.col1.y,this.m_K.col2.y=g+l,this.m_K.col2.z=g*this.m_a1+l*this.m_a2,this.m_K.col3.x=this.m_K.col1.z,this.m_K.col3.y=this.m_K.col2.z,this.m_K.col3.z=k+f+g*this.m_a1*
this.m_a1+l*this.m_a2*this.m_a2,this.m_K.Solve33(q,-r,-s,-p)):(k=this.m_invMassA,f=this.m_invMassB,g=this.m_invIA,l=this.m_invIB,p=g*this.m_s1+l*this.m_s2,t=g+l,this.m_K.col1.Set(k+f+g*this.m_s1*this.m_s1+l*this.m_s2*this.m_s2,p,0),this.m_K.col2.Set(p,t,0),p=this.m_K.Solve22(Box2D.Common.Math.b2Vec2.Get(0,0),-r,-s),q.x=p.x,q.y=p.y,q.z=0);p=q.x*this.m_perp.x+q.z*this.m_axis.x;k=q.x*this.m_perp.y+q.z*this.m_axis.y;r=q.x*this.m_s1+q.y+q.z*this.m_a1;q=q.x*this.m_s2+q.y+q.z*this.m_a2;c.x-=this.m_invMassA*
p;c.y-=this.m_invMassA*k;d-=this.m_invIA*r;e.x+=this.m_invMassB*p;e.y+=this.m_invMassB*k;h+=this.m_invIB*q;a.m_sweep.a=d;b.m_sweep.a=h;a.SynchronizeTransform();b.SynchronizeTransform();return m<=Box2D.Common.b2Settings.b2_linearSlop&&n<=Box2D.Common.b2Settings.b2_angularSlop};Box2D.Dynamics.Joints.b2PrismaticJointDef=function(){Box2D.Dynamics.Joints.b2JointDef.call(this);this.localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAxisA=Box2D.Common.Math.b2Vec2.Get(0,
0);this.type=Box2D.Dynamics.Joints.b2Joint.e_prismaticJoint;this.localAxisA.Set(1,0);this.referenceAngle=0;this.enableLimit=!1;this.upperTranslation=this.lowerTranslation=0;this.enableMotor=!1;this.motorSpeed=this.maxMotorForce=0};c2inherit(Box2D.Dynamics.Joints.b2PrismaticJointDef,Box2D.Dynamics.Joints.b2JointDef);Box2D.Dynamics.Joints.b2PrismaticJointDef.prototype.Initialize=function(a,b,c,d){this.bodyA=a;this.bodyB=b;this.localAnchorA=this.bodyA.GetLocalPoint(c);this.localAnchorB=this.bodyB.GetLocalPoint(c);
this.localAxisA=this.bodyA.GetLocalVector(d);this.referenceAngle=this.bodyB.GetAngle()-this.bodyA.GetAngle()};Box2D.Dynamics.Joints.b2PrismaticJointDef.prototype.Create=function(){return new Box2D.Dynamics.Joints.b2PrismaticJoint(this)};Box2D.Dynamics.Joints.b2PulleyJoint=function(a){Box2D.Dynamics.Joints.b2Joint.call(this,a);this.m_groundAnchor1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_groundAnchor2=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor2=
Box2D.Common.Math.b2Vec2.Get(0,0);this.m_u1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_u2=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_ground=this.m_bodyA.m_world.m_groundBody;this.m_groundAnchor1.x=a.groundAnchorA.x-this.m_ground.m_xf.position.x;this.m_groundAnchor1.y=a.groundAnchorA.y-this.m_ground.m_xf.position.y;this.m_groundAnchor2.x=a.groundAnchorB.x-this.m_ground.m_xf.position.x;this.m_groundAnchor2.y=a.groundAnchorB.y-this.m_ground.m_xf.position.y;this.m_localAnchor1.SetV(a.localAnchorA);this.m_localAnchor2.SetV(a.localAnchorB);
this.m_ratio=a.ratio;this.m_constant=a.lengthA+this.m_ratio*a.lengthB;this.m_maxLength1=Math.min(a.maxLengthA,this.m_constant-this.m_ratio*Box2D.Dynamics.Joints.b2PulleyJoint.b2_minPulleyLength);this.m_maxLength2=Math.min(a.maxLengthB,(this.m_constant-Box2D.Dynamics.Joints.b2PulleyJoint.b2_minPulleyLength)/this.m_ratio);this.m_limitImpulse2=this.m_limitImpulse1=this.m_impulse=0};c2inherit(Box2D.Dynamics.Joints.b2PulleyJoint,Box2D.Dynamics.Joints.b2Joint);Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetAnchorA=
function(){return this.m_bodyA.GetWorldPoint(this.m_localAnchor1)};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetAnchorB=function(){return this.m_bodyB.GetWorldPoint(this.m_localAnchor2)};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetReactionForce=function(a){void 0===a&&(a=0);return Box2D.Common.Math.b2Vec2.Get(a*this.m_impulse*this.m_u2.x,a*this.m_impulse*this.m_u2.y)};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetReactionTorque=function(a){return 0};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetGroundAnchorA=
function(){var a=this.m_ground.m_xf.position.Copy();a.Add(this.m_groundAnchor1);return a};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetGroundAnchorB=function(){var a=this.m_ground.m_xf.position.Copy();a.Add(this.m_groundAnchor2);return a};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetLength1=function(){var a=this.m_bodyA.GetWorldPoint(this.m_localAnchor1),b=a.x-(this.m_ground.m_xf.position.x+this.m_groundAnchor1.x),a=a.y-(this.m_ground.m_xf.position.y+this.m_groundAnchor1.y);return Math.sqrt(b*
b+a*a)};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetLength2=function(){var a=this.m_bodyB.GetWorldPoint(this.m_localAnchor2),b=a.x-(this.m_ground.m_xf.position.x+this.m_groundAnchor2.x),a=a.y-(this.m_ground.m_xf.position.y+this.m_groundAnchor2.y);return Math.sqrt(b*b+a*a)};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetRatio=function(){return this.m_ratio};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.InitVelocityConstraints=function(a){var b=this.m_bodyA,c=this.m_bodyB,d;d=b.m_xf.R;var e=
this.m_localAnchor1.x-b.m_sweep.localCenter.x,h=this.m_localAnchor1.y-b.m_sweep.localCenter.y,g=d.col1.x*e+d.col2.x*h,h=d.col1.y*e+d.col2.y*h,e=g;d=c.m_xf.R;var l=this.m_localAnchor2.x-c.m_sweep.localCenter.x,k=this.m_localAnchor2.y-c.m_sweep.localCenter.y,g=d.col1.x*l+d.col2.x*k,k=d.col1.y*l+d.col2.y*k,l=g;d=c.m_sweep.c.x+l;var g=c.m_sweep.c.y+k,f=this.m_ground.m_xf.position.x+this.m_groundAnchor2.x,m=this.m_ground.m_xf.position.y+this.m_groundAnchor2.y;this.m_u1.Set(b.m_sweep.c.x+e-(this.m_ground.m_xf.position.x+
this.m_groundAnchor1.x),b.m_sweep.c.y+h-(this.m_ground.m_xf.position.y+this.m_groundAnchor1.y));this.m_u2.Set(d-f,g-m);d=this.m_u1.Length();g=this.m_u2.Length();d>Box2D.Common.b2Settings.b2_linearSlop?this.m_u1.Multiply(1/d):this.m_u1.SetZero();g>Box2D.Common.b2Settings.b2_linearSlop?this.m_u2.Multiply(1/g):this.m_u2.SetZero();0<this.m_constant-d-this.m_ratio*g?(this.m_state=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit,this.m_impulse=0):this.m_state=Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit;d<
this.m_maxLength1?(this.m_limitState1=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit,this.m_limitImpulse1=0):this.m_limitState1=Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit;g<this.m_maxLength2?(this.m_limitState2=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit,this.m_limitImpulse2=0):this.m_limitState2=Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit;d=e*this.m_u1.y-h*this.m_u1.x;g=l*this.m_u2.y-k*this.m_u2.x;this.m_limitMass1=b.m_invMass+b.m_invI*d*d;this.m_limitMass2=c.m_invMass+c.m_invI*g*g;this.m_pulleyMass=
this.m_limitMass1+this.m_ratio*this.m_ratio*this.m_limitMass2;this.m_limitMass1=1/this.m_limitMass1;this.m_limitMass2=1/this.m_limitMass2;this.m_pulleyMass=1/this.m_pulleyMass;a.warmStarting?(this.m_impulse*=a.dtRatio,this.m_limitImpulse1*=a.dtRatio,this.m_limitImpulse2*=a.dtRatio,a=(-this.m_impulse-this.m_limitImpulse1)*this.m_u1.x,d=(-this.m_impulse-this.m_limitImpulse1)*this.m_u1.y,g=(-this.m_ratio*this.m_impulse-this.m_limitImpulse2)*this.m_u2.x,f=(-this.m_ratio*this.m_impulse-this.m_limitImpulse2)*
this.m_u2.y,b.m_linearVelocity.x+=b.m_invMass*a,b.m_linearVelocity.y+=b.m_invMass*d,b.m_angularVelocity+=b.m_invI*(e*d-h*a),c.m_linearVelocity.x+=c.m_invMass*g,c.m_linearVelocity.y+=c.m_invMass*f,c.m_angularVelocity+=c.m_invI*(l*f-k*g)):this.m_limitImpulse2=this.m_limitImpulse1=this.m_impulse=0};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.SolveVelocityConstraints=function(a){a=this.m_bodyA;var b=this.m_bodyB,c;c=a.m_xf.R;var d=this.m_localAnchor1.x-a.m_sweep.localCenter.x,e=this.m_localAnchor1.y-
a.m_sweep.localCenter.y,h=c.col1.x*d+c.col2.x*e,e=c.col1.y*d+c.col2.y*e,d=h;c=b.m_xf.R;var g=this.m_localAnchor2.x-b.m_sweep.localCenter.x,l=this.m_localAnchor2.y-b.m_sweep.localCenter.y,h=c.col1.x*g+c.col2.x*l,l=c.col1.y*g+c.col2.y*l,g=h,k=h=c=0,f=0;c=f=c=f=k=h=c=0;this.m_state==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(c=a.m_linearVelocity.x+-a.m_angularVelocity*e,h=a.m_linearVelocity.y+a.m_angularVelocity*d,k=b.m_linearVelocity.x+-b.m_angularVelocity*l,f=b.m_linearVelocity.y+b.m_angularVelocity*
g,c=-(this.m_u1.x*c+this.m_u1.y*h)-this.m_ratio*(this.m_u2.x*k+this.m_u2.y*f),f=this.m_pulleyMass*-c,c=this.m_impulse,this.m_impulse=Math.max(0,this.m_impulse+f),f=this.m_impulse-c,c=-f*this.m_u1.x,h=-f*this.m_u1.y,k=-this.m_ratio*f*this.m_u2.x,f=-this.m_ratio*f*this.m_u2.y,a.m_linearVelocity.x+=a.m_invMass*c,a.m_linearVelocity.y+=a.m_invMass*h,a.m_angularVelocity+=a.m_invI*(d*h-e*c),b.m_linearVelocity.x+=b.m_invMass*k,b.m_linearVelocity.y+=b.m_invMass*f,b.m_angularVelocity+=b.m_invI*(g*f-l*k));this.m_limitState1==
Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(c=a.m_linearVelocity.x+-a.m_angularVelocity*e,h=a.m_linearVelocity.y+a.m_angularVelocity*d,c=-(this.m_u1.x*c+this.m_u1.y*h),f=-this.m_limitMass1*c,c=this.m_limitImpulse1,this.m_limitImpulse1=Math.max(0,this.m_limitImpulse1+f),f=this.m_limitImpulse1-c,c=-f*this.m_u1.x,h=-f*this.m_u1.y,a.m_linearVelocity.x+=a.m_invMass*c,a.m_linearVelocity.y+=a.m_invMass*h,a.m_angularVelocity+=a.m_invI*(d*h-e*c));this.m_limitState2==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&
(k=b.m_linearVelocity.x+-b.m_angularVelocity*l,f=b.m_linearVelocity.y+b.m_angularVelocity*g,c=-(this.m_u2.x*k+this.m_u2.y*f),f=-this.m_limitMass2*c,c=this.m_limitImpulse2,this.m_limitImpulse2=Math.max(0,this.m_limitImpulse2+f),f=this.m_limitImpulse2-c,k=-f*this.m_u2.x,f=-f*this.m_u2.y,b.m_linearVelocity.x+=b.m_invMass*k,b.m_linearVelocity.y+=b.m_invMass*f,b.m_angularVelocity+=b.m_invI*(g*f-l*k))};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.SolvePositionConstraints=function(a){a=this.m_bodyA;var b=
this.m_bodyB,c,d=this.m_ground.m_xf.position.x+this.m_groundAnchor1.x,e=this.m_ground.m_xf.position.y+this.m_groundAnchor1.y,h=this.m_ground.m_xf.position.x+this.m_groundAnchor2.x,g=this.m_ground.m_xf.position.y+this.m_groundAnchor2.y,l=0,k=0,f=0,m=0,n=c=0,p=0,q=0,s=n=q=c=n=c=0;this.m_state==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(c=a.m_xf.R,l=this.m_localAnchor1.x-a.m_sweep.localCenter.x,k=this.m_localAnchor1.y-a.m_sweep.localCenter.y,n=c.col1.x*l+c.col2.x*k,k=c.col1.y*l+c.col2.y*k,l=n,c=
b.m_xf.R,f=this.m_localAnchor2.x-b.m_sweep.localCenter.x,m=this.m_localAnchor2.y-b.m_sweep.localCenter.y,n=c.col1.x*f+c.col2.x*m,m=c.col1.y*f+c.col2.y*m,f=n,c=a.m_sweep.c.x+l,n=a.m_sweep.c.y+k,p=b.m_sweep.c.x+f,q=b.m_sweep.c.y+m,this.m_u1.Set(c-d,n-e),this.m_u2.Set(p-h,q-g),c=this.m_u1.Length(),n=this.m_u2.Length(),c>Box2D.Common.b2Settings.b2_linearSlop?this.m_u1.Multiply(1/c):this.m_u1.SetZero(),n>Box2D.Common.b2Settings.b2_linearSlop?this.m_u2.Multiply(1/n):this.m_u2.SetZero(),c=this.m_constant-
c-this.m_ratio*n,s=Math.max(s,-c),c=Box2D.Common.Math.b2Math.Clamp(c+Box2D.Common.b2Settings.b2_linearSlop,-Box2D.Common.b2Settings.b2_maxLinearCorrection,0),q=-this.m_pulleyMass*c,c=-q*this.m_u1.x,n=-q*this.m_u1.y,p=-this.m_ratio*q*this.m_u2.x,q=-this.m_ratio*q*this.m_u2.y,a.m_sweep.c.x+=a.m_invMass*c,a.m_sweep.c.y+=a.m_invMass*n,a.m_sweep.a+=a.m_invI*(l*n-k*c),b.m_sweep.c.x+=b.m_invMass*p,b.m_sweep.c.y+=b.m_invMass*q,b.m_sweep.a+=b.m_invI*(f*q-m*p),a.SynchronizeTransform(),b.SynchronizeTransform());
this.m_limitState1==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(c=a.m_xf.R,l=this.m_localAnchor1.x-a.m_sweep.localCenter.x,k=this.m_localAnchor1.y-a.m_sweep.localCenter.y,n=c.col1.x*l+c.col2.x*k,k=c.col1.y*l+c.col2.y*k,l=n,c=a.m_sweep.c.x+l,n=a.m_sweep.c.y+k,this.m_u1.Set(c-d,n-e),c=this.m_u1.Length(),c>Box2D.Common.b2Settings.b2_linearSlop?(this.m_u1.x*=1/c,this.m_u1.y*=1/c):this.m_u1.SetZero(),c=this.m_maxLength1-c,s=Math.max(s,-c),c=Box2D.Common.Math.b2Math.Clamp(c+Box2D.Common.b2Settings.b2_linearSlop,
-Box2D.Common.b2Settings.b2_maxLinearCorrection,0),q=-this.m_limitMass1*c,c=-q*this.m_u1.x,n=-q*this.m_u1.y,a.m_sweep.c.x+=a.m_invMass*c,a.m_sweep.c.y+=a.m_invMass*n,a.m_sweep.a+=a.m_invI*(l*n-k*c),a.SynchronizeTransform());this.m_limitState2==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(c=b.m_xf.R,f=this.m_localAnchor2.x-b.m_sweep.localCenter.x,m=this.m_localAnchor2.y-b.m_sweep.localCenter.y,n=c.col1.x*f+c.col2.x*m,m=c.col1.y*f+c.col2.y*m,f=n,p=b.m_sweep.c.x+f,q=b.m_sweep.c.y+m,this.m_u2.Set(p-
h,q-g),n=this.m_u2.Length(),n>Box2D.Common.b2Settings.b2_linearSlop?(this.m_u2.x*=1/n,this.m_u2.y*=1/n):this.m_u2.SetZero(),c=this.m_maxLength2-n,s=Math.max(s,-c),c=Box2D.Common.Math.b2Math.Clamp(c+Box2D.Common.b2Settings.b2_linearSlop,-Box2D.Common.b2Settings.b2_maxLinearCorrection,0),q=-this.m_limitMass2*c,p=-q*this.m_u2.x,q=-q*this.m_u2.y,b.m_sweep.c.x+=b.m_invMass*p,b.m_sweep.c.y+=b.m_invMass*q,b.m_sweep.a+=b.m_invI*(f*q-m*p),b.SynchronizeTransform());return s<Box2D.Common.b2Settings.b2_linearSlop};
Box2D.Dynamics.Joints.b2PulleyJoint.b2_minPulleyLength=1;Box2D.Dynamics.Joints.b2PulleyJointDef=function(){Box2D.Dynamics.Joints.b2JointDef.call(this);this.groundAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.groundAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.type=Box2D.Dynamics.Joints.b2Joint.e_pulleyJoint;this.groundAnchorA.Set(-1,1);this.groundAnchorB.Set(1,1);this.localAnchorA.Set(-1,0);this.localAnchorB.Set(1,
0);this.maxLengthB=this.lengthB=this.maxLengthA=this.lengthA=0;this.ratio=1;this.collideConnected=!0};c2inherit(Box2D.Dynamics.Joints.b2PulleyJointDef,Box2D.Dynamics.Joints.b2JointDef);Box2D.Dynamics.Joints.b2PulleyJointDef.prototype.Initialize=function(a,b,c,d,e,h,g){void 0===g&&(g=0);this.bodyA=a;this.bodyB=b;this.groundAnchorA.SetV(c);this.groundAnchorB.SetV(d);this.localAnchorA=this.bodyA.GetLocalPoint(e);this.localAnchorB=this.bodyB.GetLocalPoint(h);a=e.x-c.x;c=e.y-c.y;this.lengthA=Math.sqrt(a*
a+c*c);c=h.x-d.x;d=h.y-d.y;this.lengthB=Math.sqrt(c*c+d*d);this.ratio=g;g=this.lengthA+this.ratio*this.lengthB;this.maxLengthA=g-this.ratio*Box2D.Dynamics.Joints.b2PulleyJoint.b2_minPulleyLength;this.maxLengthB=(g-Box2D.Dynamics.Joints.b2PulleyJoint.b2_minPulleyLength)/this.ratio};Box2D.Dynamics.Joints.b2PulleyJointDef.prototype.Create=function(){return new Box2D.Dynamics.Joints.b2PulleyJoint(this)};Box2D.Dynamics.Joints.b2RevoluteJoint=function(a){Box2D.Dynamics.Joints.b2Joint.call(this,a);this.K=
new Box2D.Common.Math.b2Mat22;this.K1=new Box2D.Common.Math.b2Mat22;this.K2=new Box2D.Common.Math.b2Mat22;this.K3=new Box2D.Common.Math.b2Mat22;this.impulse3=new Box2D.Common.Math.b2Vec3(0,0,0);this.impulse2=Box2D.Common.Math.b2Vec2.Get(0,0);this.reduced=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor2=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_impulse=new Box2D.Common.Math.b2Vec3(0,0,0);this.m_mass=new Box2D.Common.Math.b2Mat33;this.m_localAnchor1.SetV(a.localAnchorA);
this.m_localAnchor2.SetV(a.localAnchorB);this.m_referenceAngle=a.referenceAngle;this.m_impulse.SetZero();this.m_motorImpulse=0;this.m_lowerAngle=a.lowerAngle;this.m_upperAngle=a.upperAngle;this.m_maxMotorTorque=a.maxMotorTorque;this.m_motorSpeed=a.motorSpeed;this.m_enableLimit=a.enableLimit;this.m_enableMotor=a.enableMotor;this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit};c2inherit(Box2D.Dynamics.Joints.b2RevoluteJoint,Box2D.Dynamics.Joints.b2Joint);Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetAnchorA=
function(){return this.m_bodyA.GetWorldPoint(this.m_localAnchor1)};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetAnchorB=function(){return this.m_bodyB.GetWorldPoint(this.m_localAnchor2)};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetReactionForce=function(a){void 0===a&&(a=0);return Box2D.Common.Math.b2Vec2.Get(a*this.m_impulse.x,a*this.m_impulse.y)};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetReactionTorque=function(a){void 0===a&&(a=0);return a*this.m_impulse.z};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetJointAngle=
function(){return this.m_bodyB.m_sweep.a-this.m_bodyA.m_sweep.a-this.m_referenceAngle};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetJointSpeed=function(){return this.m_bodyB.m_angularVelocity-this.m_bodyA.m_angularVelocity};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.IsLimitEnabled=function(){return this.m_enableLimit};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.EnableLimit=function(a){this.m_enableLimit=a};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetLowerLimit=function(){return this.m_lowerAngle};
Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetUpperLimit=function(){return this.m_upperAngle};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.SetLimits=function(a,b){void 0===a&&(a=0);void 0===b&&(b=0);this.m_lowerAngle=a;this.m_upperAngle=b};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.IsMotorEnabled=function(){this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);return this.m_enableMotor};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.EnableMotor=function(a){this.m_enableMotor=a};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.SetMotorSpeed=
function(a){void 0===a&&(a=0);this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_motorSpeed=a};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetMotorSpeed=function(){return this.m_motorSpeed};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.SetMaxMotorTorque=function(a){void 0===a&&(a=0);this.m_maxMotorTorque=a};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetMotorTorque=function(){return this.m_maxMotorTorque};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.InitVelocityConstraints=function(a){var b=
this.m_bodyA,c=this.m_bodyB,d,e=0;d=b.m_xf.R;var h=this.m_localAnchor1.x-b.m_sweep.localCenter.x,g=this.m_localAnchor1.y-b.m_sweep.localCenter.y,e=d.col1.x*h+d.col2.x*g,g=d.col1.y*h+d.col2.y*g,h=e;d=c.m_xf.R;var l=this.m_localAnchor2.x-c.m_sweep.localCenter.x,k=this.m_localAnchor2.y-c.m_sweep.localCenter.y,e=d.col1.x*l+d.col2.x*k,k=d.col1.y*l+d.col2.y*k,l=e;d=b.m_invMass;var e=c.m_invMass,f=b.m_invI,m=c.m_invI;this.m_mass.col1.x=d+e+g*g*f+k*k*m;this.m_mass.col2.x=-g*h*f-k*l*m;this.m_mass.col3.x=-g*
f-k*m;this.m_mass.col1.y=this.m_mass.col2.x;this.m_mass.col2.y=d+e+h*h*f+l*l*m;this.m_mass.col3.y=h*f+l*m;this.m_mass.col1.z=this.m_mass.col3.x;this.m_mass.col2.z=this.m_mass.col3.y;this.m_mass.col3.z=f+m;this.m_motorMass=1/(f+m);this.m_enableMotor||(this.m_motorImpulse=0);if(this.m_enableLimit){var n=c.m_sweep.a-b.m_sweep.a-this.m_referenceAngle;Math.abs(this.m_upperAngle-this.m_lowerAngle)<2*Box2D.Common.b2Settings.b2_angularSlop?this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_equalLimits:n<=
this.m_lowerAngle?(this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit&&(this.m_impulse.z=0),this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit):n>=this.m_upperAngle?(this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(this.m_impulse.z=0),this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit):(this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit,this.m_impulse.z=0)}else this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit;a.warmStarting?
(this.m_impulse.x*=a.dtRatio,this.m_impulse.y*=a.dtRatio,this.m_motorImpulse*=a.dtRatio,a=this.m_impulse.x,n=this.m_impulse.y,b.m_linearVelocity.x-=d*a,b.m_linearVelocity.y-=d*n,b.m_angularVelocity-=f*(h*n-g*a+this.m_motorImpulse+this.m_impulse.z),c.m_linearVelocity.x+=e*a,c.m_linearVelocity.y+=e*n,c.m_angularVelocity+=m*(l*n-k*a+this.m_motorImpulse+this.m_impulse.z)):(this.m_impulse.SetZero(),this.m_motorImpulse=0)};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.SolveVelocityConstraints=function(a){var b=
this.m_bodyA,c=this.m_bodyB,d=0,e=d=0,h=0,g=0,l=0,k=b.m_linearVelocity,f=b.m_angularVelocity,m=c.m_linearVelocity,n=c.m_angularVelocity,p=b.m_invMass,q=c.m_invMass,s=b.m_invI,r=c.m_invI;this.m_enableMotor&&this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_equalLimits&&(e=this.m_motorMass*-(n-f-this.m_motorSpeed),h=this.m_motorImpulse,g=a.dt*this.m_maxMotorTorque,this.m_motorImpulse=Box2D.Common.Math.b2Math.Clamp(this.m_motorImpulse+e,-g,g),e=this.m_motorImpulse-h,f-=s*e,n+=r*e);if(this.m_enableLimit&&
this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit){a=b.m_xf.R;e=this.m_localAnchor1.x-b.m_sweep.localCenter.x;h=this.m_localAnchor1.y-b.m_sweep.localCenter.y;d=a.col1.x*e+a.col2.x*h;h=a.col1.y*e+a.col2.y*h;e=d;a=c.m_xf.R;g=this.m_localAnchor2.x-c.m_sweep.localCenter.x;l=this.m_localAnchor2.y-c.m_sweep.localCenter.y;d=a.col1.x*g+a.col2.x*l;l=a.col1.y*g+a.col2.y*l;g=d;a=m.x+-n*l-k.x- -f*h;var t=m.y+n*g-k.y-f*e;this.m_mass.Solve33(this.impulse3,-a,-t,-(n-f));this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_equalLimits?
this.m_impulse.Add(this.impulse3):this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit?(d=this.m_impulse.z+this.impulse3.z,0>d&&(this.m_mass.Solve22(this.reduced,-a,-t),this.impulse3.x=this.reduced.x,this.impulse3.y=this.reduced.y,this.impulse3.z=-this.m_impulse.z,this.m_impulse.x+=this.reduced.x,this.m_impulse.y+=this.reduced.y,this.m_impulse.z=0)):this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(d=this.m_impulse.z+this.impulse3.z,0<d&&(this.m_mass.Solve22(this.reduced,
-a,-t),this.impulse3.x=this.reduced.x,this.impulse3.y=this.reduced.y,this.impulse3.z=-this.m_impulse.z,this.m_impulse.x+=this.reduced.x,this.m_impulse.y+=this.reduced.y,this.m_impulse.z=0));k.x-=p*this.impulse3.x;k.y-=p*this.impulse3.y;f-=s*(e*this.impulse3.y-h*this.impulse3.x+this.impulse3.z);m.x+=q*this.impulse3.x;m.y+=q*this.impulse3.y;n+=r*(g*this.impulse3.y-l*this.impulse3.x+this.impulse3.z)}else a=b.m_xf.R,e=this.m_localAnchor1.x-b.m_sweep.localCenter.x,h=this.m_localAnchor1.y-b.m_sweep.localCenter.y,
d=a.col1.x*e+a.col2.x*h,h=a.col1.y*e+a.col2.y*h,e=d,a=c.m_xf.R,g=this.m_localAnchor2.x-c.m_sweep.localCenter.x,l=this.m_localAnchor2.y-c.m_sweep.localCenter.y,d=a.col1.x*g+a.col2.x*l,l=a.col1.y*g+a.col2.y*l,g=d,this.m_mass.Solve22(this.impulse2,-(m.x+-n*l-k.x- -f*h),-(m.y+n*g-k.y-f*e)),this.m_impulse.x+=this.impulse2.x,this.m_impulse.y+=this.impulse2.y,k.x-=p*this.impulse2.x,k.y-=p*this.impulse2.y,f-=s*(e*this.impulse2.y-h*this.impulse2.x),m.x+=q*this.impulse2.x,m.y+=q*this.impulse2.y,n+=r*(g*this.impulse2.y-
l*this.impulse2.x);b.m_linearVelocity.SetV(k);b.m_angularVelocity=f;c.m_linearVelocity.SetV(m);c.m_angularVelocity=n};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.SolvePositionConstraints=function(a){var b=0,c;a=this.m_bodyA;var d=this.m_bodyB,e=0,h=c=0,g=0,l=0;if(this.m_enableLimit&&this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit){var b=d.m_sweep.a-a.m_sweep.a-this.m_referenceAngle,k=0;this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_equalLimits?(b=Box2D.Common.Math.b2Math.Clamp(b-
this.m_lowerAngle,-Box2D.Common.b2Settings.b2_maxAngularCorrection,Box2D.Common.b2Settings.b2_maxAngularCorrection),k=-this.m_motorMass*b,e=Math.abs(b)):this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit?(b-=this.m_lowerAngle,e=-b,b=Box2D.Common.Math.b2Math.Clamp(b+Box2D.Common.b2Settings.b2_angularSlop,-Box2D.Common.b2Settings.b2_maxAngularCorrection,0),k=-this.m_motorMass*b):this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(e=b-=this.m_upperAngle,b=Box2D.Common.Math.b2Math.Clamp(b-
Box2D.Common.b2Settings.b2_angularSlop,0,Box2D.Common.b2Settings.b2_maxAngularCorrection),k=-this.m_motorMass*b);a.m_sweep.a-=a.m_invI*k;d.m_sweep.a+=d.m_invI*k;a.SynchronizeTransform();d.SynchronizeTransform()}c=a.m_xf.R;k=this.m_localAnchor1.x-a.m_sweep.localCenter.x;b=this.m_localAnchor1.y-a.m_sweep.localCenter.y;h=c.col1.x*k+c.col2.x*b;b=c.col1.y*k+c.col2.y*b;k=h;c=d.m_xf.R;var f=this.m_localAnchor2.x-d.m_sweep.localCenter.x,m=this.m_localAnchor2.y-d.m_sweep.localCenter.y,h=c.col1.x*f+c.col2.x*
m,m=c.col1.y*f+c.col2.y*m,f=h,g=d.m_sweep.c.x+f-a.m_sweep.c.x-k,l=d.m_sweep.c.y+m-a.m_sweep.c.y-b,n=g*g+l*l;c=Math.sqrt(n);var h=a.m_invMass,p=d.m_invMass,q=a.m_invI,s=d.m_invI,r=10*Box2D.Common.b2Settings.b2_linearSlop;n>r*r&&(n=1/(h+p),g=n*-g,l=n*-l,a.m_sweep.c.x-=0.5*h*g,a.m_sweep.c.y-=0.5*h*l,d.m_sweep.c.x+=0.5*p*g,d.m_sweep.c.y+=0.5*p*l,g=d.m_sweep.c.x+f-a.m_sweep.c.x-k,l=d.m_sweep.c.y+m-a.m_sweep.c.y-b);this.K1.col1.x=h+p;this.K1.col2.x=0;this.K1.col1.y=0;this.K1.col2.y=h+p;this.K2.col1.x=q*
b*b;this.K2.col2.x=-q*k*b;this.K2.col1.y=-q*k*b;this.K2.col2.y=q*k*k;this.K3.col1.x=s*m*m;this.K3.col2.x=-s*f*m;this.K3.col1.y=-s*f*m;this.K3.col2.y=s*f*f;this.K.SetM(this.K1);this.K.AddM(this.K2);this.K.AddM(this.K3);this.K.Solve(Box2D.Dynamics.Joints.b2RevoluteJoint.tImpulse,-g,-l);g=Box2D.Dynamics.Joints.b2RevoluteJoint.tImpulse.x;l=Box2D.Dynamics.Joints.b2RevoluteJoint.tImpulse.y;a.m_sweep.c.x-=a.m_invMass*g;a.m_sweep.c.y-=a.m_invMass*l;a.m_sweep.a-=a.m_invI*(k*l-b*g);d.m_sweep.c.x+=d.m_invMass*
g;d.m_sweep.c.y+=d.m_invMass*l;d.m_sweep.a+=d.m_invI*(f*l-m*g);a.SynchronizeTransform();d.SynchronizeTransform();return c<=Box2D.Common.b2Settings.b2_linearSlop&&e<=Box2D.Common.b2Settings.b2_angularSlop};Box2D.Dynamics.Joints.b2RevoluteJoint.tImpulse=Box2D.Common.Math.b2Vec2.Get(0,0);Box2D.Dynamics.Joints.b2RevoluteJointDef=function(){Box2D.Dynamics.Joints.b2JointDef.call(this);this.localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.type=Box2D.Dynamics.Joints.b2Joint.e_revoluteJoint;
this.localAnchorA.SetZero();this.localAnchorB.SetZero();this.motorSpeed=this.maxMotorTorque=this.upperAngle=this.lowerAngle=this.referenceAngle=0;this.enableMotor=this.enableLimit=!1};c2inherit(Box2D.Dynamics.Joints.b2RevoluteJointDef,Box2D.Dynamics.Joints.b2JointDef);Box2D.Dynamics.Joints.b2RevoluteJointDef.prototype.Initialize=function(a,b,c){this.bodyA=a;this.bodyB=b;this.localAnchorA=this.bodyA.GetLocalPoint(c);this.localAnchorB=this.bodyB.GetLocalPoint(c);this.referenceAngle=this.bodyB.GetAngle()-
this.bodyA.GetAngle()};Box2D.Dynamics.Joints.b2RevoluteJointDef.prototype.Create=function(){return new Box2D.Dynamics.Joints.b2RevoluteJoint(this)};Box2D.Dynamics.Joints.b2WeldJoint=function(a){Box2D.Dynamics.Joints.b2Joint.call(this,a);this.m_localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_impulse=new Box2D.Common.Math.b2Vec3(0,0,0);this.m_mass=new Box2D.Common.Math.b2Mat33;this.m_localAnchorA.SetV(a.localAnchorA);this.m_localAnchorB.SetV(a.localAnchorB);
this.m_referenceAngle=a.referenceAngle};c2inherit(Box2D.Dynamics.Joints.b2WeldJoint,Box2D.Dynamics.Joints.b2Joint);Box2D.Dynamics.Joints.b2WeldJoint.prototype.GetAnchorA=function(){return this.m_bodyA.GetWorldPoint(this.m_localAnchorA)};Box2D.Dynamics.Joints.b2WeldJoint.prototype.GetAnchorB=function(){return this.m_bodyB.GetWorldPoint(this.m_localAnchorB)};Box2D.Dynamics.Joints.b2WeldJoint.prototype.GetReactionForce=function(a){return Box2D.Common.Math.b2Vec2.Get(a*this.m_impulse.x,a*this.m_impulse.y)};
Box2D.Dynamics.Joints.b2WeldJoint.prototype.GetReactionTorque=function(a){return a*this.m_impulse.z};Box2D.Dynamics.Joints.b2WeldJoint.prototype.InitVelocityConstraints=function(a){var b,c=0,d=this.m_bodyA,e=this.m_bodyB;b=d.m_xf.R;var h=this.m_localAnchorA.x-d.m_sweep.localCenter.x,g=this.m_localAnchorA.y-d.m_sweep.localCenter.y,c=b.col1.x*h+b.col2.x*g,g=b.col1.y*h+b.col2.y*g,h=c;b=e.m_xf.R;var l=this.m_localAnchorB.x-e.m_sweep.localCenter.x,k=this.m_localAnchorB.y-e.m_sweep.localCenter.y,c=b.col1.x*
l+b.col2.x*k,k=b.col1.y*l+b.col2.y*k,l=c;b=d.m_invMass;var c=e.m_invMass,f=d.m_invI,m=e.m_invI;this.m_mass.col1.x=b+c+g*g*f+k*k*m;this.m_mass.col2.x=-g*h*f-k*l*m;this.m_mass.col3.x=-g*f-k*m;this.m_mass.col1.y=this.m_mass.col2.x;this.m_mass.col2.y=b+c+h*h*f+l*l*m;this.m_mass.col3.y=h*f+l*m;this.m_mass.col1.z=this.m_mass.col3.x;this.m_mass.col2.z=this.m_mass.col3.y;this.m_mass.col3.z=f+m;a.warmStarting?(this.m_impulse.x*=a.dtRatio,this.m_impulse.y*=a.dtRatio,this.m_impulse.z*=a.dtRatio,d.m_linearVelocity.x-=
b*this.m_impulse.x,d.m_linearVelocity.y-=b*this.m_impulse.y,d.m_angularVelocity-=f*(h*this.m_impulse.y-g*this.m_impulse.x+this.m_impulse.z),e.m_linearVelocity.x+=c*this.m_impulse.x,e.m_linearVelocity.y+=c*this.m_impulse.y,e.m_angularVelocity+=m*(l*this.m_impulse.y-k*this.m_impulse.x+this.m_impulse.z)):this.m_impulse.SetZero()};Box2D.Dynamics.Joints.b2WeldJoint.prototype.SolveVelocityConstraints=function(a){var b,c=0;a=this.m_bodyA;var d=this.m_bodyB,e=a.m_linearVelocity,h=a.m_angularVelocity,g=d.m_linearVelocity,
l=d.m_angularVelocity,k=a.m_invMass,f=d.m_invMass,m=a.m_invI,n=d.m_invI;b=a.m_xf.R;var p=this.m_localAnchorA.x-a.m_sweep.localCenter.x,q=this.m_localAnchorA.y-a.m_sweep.localCenter.y,c=b.col1.x*p+b.col2.x*q,q=b.col1.y*p+b.col2.y*q,p=c;b=d.m_xf.R;var s=this.m_localAnchorB.x-d.m_sweep.localCenter.x,r=this.m_localAnchorB.y-d.m_sweep.localCenter.y,c=b.col1.x*s+b.col2.x*r,r=b.col1.y*s+b.col2.y*r,s=c;b=g.x-l*r-e.x+h*q;var c=g.y+l*s-e.y-h*p,t=l-h,w=new Box2D.Common.Math.b2Vec3(0,0,0);this.m_mass.Solve33(w,
-b,-c,-t);this.m_impulse.Add(w);e.x-=k*w.x;e.y-=k*w.y;h-=m*(p*w.y-q*w.x+w.z);g.x+=f*w.x;g.y+=f*w.y;l+=n*(s*w.y-r*w.x+w.z);a.m_angularVelocity=h;d.m_angularVelocity=l};Box2D.Dynamics.Joints.b2WeldJoint.prototype.SolvePositionConstraints=function(a){var b,c=0;a=this.m_bodyA;var d=this.m_bodyB;b=a.m_xf.R;var e=this.m_localAnchorA.x-a.m_sweep.localCenter.x,h=this.m_localAnchorA.y-a.m_sweep.localCenter.y,c=b.col1.x*e+b.col2.x*h,h=b.col1.y*e+b.col2.y*h,e=c;b=d.m_xf.R;var g=this.m_localAnchorB.x-d.m_sweep.localCenter.x,
l=this.m_localAnchorB.y-d.m_sweep.localCenter.y,c=b.col1.x*g+b.col2.x*l,l=b.col1.y*g+b.col2.y*l,g=c;b=a.m_invMass;var c=d.m_invMass,k=a.m_invI,f=d.m_invI,m=d.m_sweep.c.x+g-a.m_sweep.c.x-e,n=d.m_sweep.c.y+l-a.m_sweep.c.y-h,p=d.m_sweep.a-a.m_sweep.a-this.m_referenceAngle,q=10*Box2D.Common.b2Settings.b2_linearSlop,s=Math.sqrt(m*m+n*n),r=Math.abs(p);s>q&&(k*=1,f*=1);this.m_mass.col1.x=b+c+h*h*k+l*l*f;this.m_mass.col2.x=-h*e*k-l*g*f;this.m_mass.col3.x=-h*k-l*f;this.m_mass.col1.y=this.m_mass.col2.x;this.m_mass.col2.y=
b+c+e*e*k+g*g*f;this.m_mass.col3.y=e*k+g*f;this.m_mass.col1.z=this.m_mass.col3.x;this.m_mass.col2.z=this.m_mass.col3.y;this.m_mass.col3.z=k+f;q=new Box2D.Common.Math.b2Vec3(0,0,0);this.m_mass.Solve33(q,-m,-n,-p);a.m_sweep.c.x-=b*q.x;a.m_sweep.c.y-=b*q.y;a.m_sweep.a-=k*(e*q.y-h*q.x+q.z);d.m_sweep.c.x+=c*q.x;d.m_sweep.c.y+=c*q.y;d.m_sweep.a+=f*(g*q.y-l*q.x+q.z);a.SynchronizeTransform();d.SynchronizeTransform();return s<=Box2D.Common.b2Settings.b2_linearSlop&&r<=Box2D.Common.b2Settings.b2_angularSlop};
Box2D.Dynamics.Joints.b2WeldJointDef=function(){Box2D.Dynamics.Joints.b2JointDef.call(this);this.localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.type=Box2D.Dynamics.Joints.b2Joint.e_weldJoint;this.referenceAngle=0};c2inherit(Box2D.Dynamics.Joints.b2WeldJointDef,Box2D.Dynamics.Joints.b2JointDef);Box2D.Dynamics.Joints.b2WeldJointDef.prototype.Initialize=function(a,b,c){this.bodyA=a;this.bodyB=b;this.localAnchorA.SetV(this.bodyA.GetLocalPoint(c));
this.localAnchorB.SetV(this.bodyB.GetLocalPoint(c));this.referenceAngle=this.bodyB.GetAngle()-this.bodyA.GetAngle()};Box2D.Dynamics.Joints.b2WeldJointDef.prototype.Create=function(){return new Box2D.Dynamics.Joints.b2WeldJoint(this)};Box2D.Collision.b2Collision.s_incidentEdge=Box2D.Collision.b2Collision.MakeClipPointVector();Box2D.Collision.b2Collision.s_clipPoints1=Box2D.Collision.b2Collision.MakeClipPointVector();Box2D.Collision.b2Collision.s_clipPoints2=Box2D.Collision.b2Collision.MakeClipPointVector();
Box2D.Collision.b2Collision.s_localTangent=Box2D.Common.Math.b2Vec2.Get(0,0);Box2D.Collision.b2Collision.s_localNormal=Box2D.Common.Math.b2Vec2.Get(0,0);Box2D.Collision.b2Collision.s_planePoint=Box2D.Common.Math.b2Vec2.Get(0,0);Box2D.Collision.b2Collision.s_normal=Box2D.Common.Math.b2Vec2.Get(0,0);Box2D.Collision.b2Collision.s_tangent=Box2D.Common.Math.b2Vec2.Get(0,0);Box2D.Collision.b2Collision.s_tangent2=Box2D.Common.Math.b2Vec2.Get(0,0);Box2D.Collision.b2Collision.s_v11=Box2D.Common.Math.b2Vec2.Get(0,
0);Box2D.Collision.b2Collision.s_v12=Box2D.Common.Math.b2Vec2.Get(0,0);Box2D.Collision.b2TimeOfImpact.b2_toiCalls=0;Box2D.Collision.b2TimeOfImpact.b2_toiIters=0;Box2D.Collision.b2TimeOfImpact.b2_toiMaxIters=0;Box2D.Collision.b2TimeOfImpact.b2_toiRootIters=0;Box2D.Collision.b2TimeOfImpact.b2_toiMaxRootIters=0;Box2D.Collision.b2TimeOfImpact.s_cache=new Box2D.Collision.b2SimplexCache;Box2D.Collision.b2TimeOfImpact.s_distanceInput=new Box2D.Collision.b2DistanceInput;Box2D.Collision.b2TimeOfImpact.s_xfA=
new Box2D.Common.Math.b2Transform;Box2D.Collision.b2TimeOfImpact.s_xfB=new Box2D.Common.Math.b2Transform;Box2D.Collision.b2TimeOfImpact.s_fcn=new Box2D.Collision.b2SeparationFunction;Box2D.Collision.b2TimeOfImpact.s_distanceOutput=new Box2D.Collision.b2DistanceOutput;Box2D.Dynamics.b2Body.s_xf1=new Box2D.Common.Math.b2Transform;Box2D.Dynamics.b2ContactListener.b2_defaultListener=new Box2D.Dynamics.b2ContactListener;Box2D.Dynamics.b2ContactManager.s_evalCP=new Box2D.Collision.b2ContactPoint;Box2D.Dynamics.b2World.s_xf=
new Box2D.Common.Math.b2Transform;Box2D.Dynamics.b2World.s_backupA=new Box2D.Common.Math.b2Sweep;Box2D.Dynamics.b2World.s_backupB=new Box2D.Common.Math.b2Sweep;Box2D.Dynamics.Contacts.b2Contact.s_input=new Box2D.Collision.b2TOIInput;Box2D.Dynamics.Contacts.b2ContactSolver.s_worldManifold=new Box2D.Collision.b2WorldManifold;Box2D.Dynamics.Contacts.b2ContactSolver.s_psm=new Box2D.Dynamics.Contacts.b2PositionSolverManifold}cr.b2Separator=function(){};
cr.b2Separator.det=function(a,b,c,d,e,h){return a*d+c*h+e*b-b*c-d*e-h*a};cr.b2Separator.hitRay=function(a,b,c,d,e,h,g,l){var k=c-a,f=d-b,m=g-e,n=l-h,m=(m*(h-b)-n*(e-a))/(f*m-k*n),k=a+m*k,f=b+m*f;a=cr.b2Separator.isOnSegment(c,d,a,b,k,f);e=cr.b2Separator.isOnSegment(k,f,e,h,g,l);return a&&e?Box2D.Common.Math.b2Vec2.Get(k,f):null};
cr.b2Separator.isOnSegment=function(a,b,c,d,e,h){return(c+0.1>=a&&a>=e-0.1||c-0.1<=a&&a<=e+0.1)&&(d+0.1>=b&&b>=h-0.1||d-0.1<=b&&b<=h+0.1)&&cr.b2Separator.isOnLine(a,b,c,d,e,h)};cr.b2Separator.isOnLine=function(a,b,c,d,e,h){return 0.1<Math.abs(e-c)?0.1>Math.abs((h-d)/(e-c)*(a-c)+d-b):0.1>Math.abs(a-c)};cr.b2Separator.pointsMatch=function(a,b,c,d){return 0.1>Math.abs(c-a)&&0.1>Math.abs(d-b)};
cr.b2Separator.Separate=function(a,b){var c=Box2D.Common.Math.b2Vec2,d=cr.b2Separator.calcShapes(a),e=[],h,g,l,k,f,m,n,p,q;f=0;for(m=d.length;f<m;f++){g=d[f];h=[];h.length=g.length;n=q=0;for(p=g.length;n<p;n++)l=g[n],k=g[(n+1)%p],q+=l.x*k.y-l.y*k.x,h[n]=c.Get(l.x,l.y);q=Math.abs(q/2);q>=0.001*b&&e.push(h)}return e};
cr.b2Separator.calcShapes=function(a){var b=[],c=0,d=0,e=0,h=0,g=0,l=g=0,k=0,f=0,m=0,h=0,n,p,q,s=h=c=0,r=0,e=[],k=[],t=!1,w=[],A=[];for(A.push(a);A.length;){b=A[0];d=b.length;t=!0;for(c=0;c<d;c++)if(f=c,m=c<d-1?c+1:c+1-d,h=c<d-2?c+2:c+2-d,a=b[f],n=b[m],h=b[h],h=cr.b2Separator.det(a.x,a.y,n.x,n.y,h.x,h.y),0>h){t=!1;k=1E9;for(e=0;e<d;e++)e!==f&&e!==m&&(c=e,h=e<d-1?e+1:0,g=b[c],l=b[h],p=cr.b2Separator.hitRay(a.x,a.y,n.x,n.y,g.x,g.y,l.x,l.y))&&(g=n.x-p.x,l=n.y-p.y,g=g*g+l*l,g<k&&(r=c,s=h,q=p,k=g));if(1E9===
k)return[];e=[];k=[];c=r;h=s;g=b[c];l=b[h];cr.b2Separator.pointsMatch(q.x,q.y,l.x,l.y)||e.push(q);cr.b2Separator.pointsMatch(q.x,q.y,g.x,g.y)||k.push(q);r=-1;for(s=f;;){if(s!==h)e.push(b[s]);else{if(0>r||r>=d)return[];cr.b2Separator.isOnSegment(l.x,l.y,b[r].x,b[r].y,a.x,a.y)||e.push(b[s]);break}r=s;0>s-1?s=d-1:s--}e.reverse();r=-1;for(s=m;;){if(s!==c)k.push(b[s]);else{if(0>r||r>=d)return[];s!==c||cr.b2Separator.isOnSegment(g.x,g.y,b[r].x,b[r].y,n.x,n.y)||k.push(b[s]);break}r=s;s+1>d-1?s=0:s++}A.push(e,
k);A.shift();break}t&&w.push(A.shift())}return w};
cr.behaviors.Physics=function(a){for(var b=0;4E3>b;b++)Box2D.Common.Math.b2Vec2._freeCache.push(new Box2D.Common.Math.b2Vec2(0,0));this.runtime=a;this.world=new Box2D.Dynamics.b2World(Box2D.Common.Math.b2Vec2.Get(0,10),!0);this.worldG=10;this.lastUpdateTick=-1;a=new Box2D.Dynamics.b2ContactListener;a.behavior=this;a.BeginContact=function(a){var b=a.m_fixtureA.GetBody().c2userdata;a=a.m_fixtureB.GetBody().c2userdata;this.behavior.runtime.registerCollision(b.inst,a.inst)};this.world.SetContactListener(a);
a=new Box2D.Dynamics.b2ContactFilter;a.behavior=this;a.ShouldCollide=function(a,b){if(this.behavior.allCollisionsEnabled)return!0;var e=a.GetBody().c2userdata.inst.type,h=b.GetBody().c2userdata.inst.type,g=e.extra.Physics_DisabledCollisions;return g&&g.contains(h)?!1:(g=h.extra.Physics_DisabledCollisions)&&g.contains(e)?!1:!0};this.world.SetContactFilter(a);this.steppingMode=0;this.velocityIterations=8;this.positionIterations=3;this.allCollisionsEnabled=!0};
(function(){function a(){}function b(){}function c(a,b,c){c?((c=a.extra.Physics_DisabledCollisions)&&c.remove(b),(c=b.extra.Physics_DisabledCollisions)&&c.remove(a)):(a.extra.Physics_DisabledCollisions||(a.extra.Physics_DisabledCollisions=new cr.ObjectSet),a.extra.Physics_DisabledCollisions.add(b),b.extra.Physics_DisabledCollisions||(b.extra.Physics_DisabledCollisions=new cr.ObjectSet),b.extra.Physics_DisabledCollisions.add(a))}function d(){}var e=Box2D.Common.Math.b2Vec2,h=Box2D.Dynamics.b2BodyDef,
g=Box2D.Dynamics.b2FixtureDef,l=Box2D.Collision.Shapes.b2PolygonShape,k=Box2D.Collision.Shapes.b2CircleShape,f=Box2D.Dynamics.Joints.b2DistanceJointDef,m=Box2D.Dynamics.Joints.b2RevoluteJointDef,n=cr.behaviors.Physics.prototype;n.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};n.Type.prototype.onCreate=function(){};n.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime;this.world=this.behavior.world};var p=n.Instance.prototype;p.onCreate=
function(){this.immovable=0!==this.properties[0];this.collisionmask=this.properties[1];this.preventRotation=0!==this.properties[2];this.density=this.properties[3];this.friction=this.properties[4];this.restitution=this.properties[5];this.linearDamping=this.properties[6];this.angularDamping=this.properties[7];this.bullet=0!==this.properties[8];this.enabled=0!==this.properties[9];this.body=null;this.inst.update_bbox();this.lastKnownX=this.inst.x;this.lastKnownY=this.inst.y;this.lastKnownAngle=this.inst.angle;
this.lastHeight=this.lastWidth=0;this.recreateBody=this.lastTickOverride=!1;this.lastAnimation=null;this.lastAnimationFrame=-1;this.myJoints?(this.myJoints.length=0,this.myCreatedJoints.length=0,this.joiningMe.clear()):(this.myJoints=[],this.myCreatedJoints=[],this.joiningMe=new cr.ObjectSet);var a=this;this.recycled||(this.myDestroyCallback=function(b){a.onInstanceDestroyed(b)});this.runtime.addDestroyCallback(this.myDestroyCallback)};p.postCreate=function(){this.inst.update_bbox();this.createBody();
this.lastAnimation=this.inst.cur_animation;this.lastAnimationFrame=this.inst.cur_frame};p.onDestroy=function(){this.destroyMyJoints();this.myCreatedJoints.length=0;this.joiningMe.clear();this.body&&(this.world.DestroyBody(this.body),this.body=null);this.runtime.removeDestroyCallback(this.myDestroyCallback)};p.saveToJSON=function(){var a={e:this.enabled,im:this.immovable,pr:this.preventRotation,d:this.density,fr:this.friction,re:this.restitution,ld:this.linearDamping,ad:this.angularDamping,b:this.bullet,
mcj:this.myCreatedJoints};if(this.enabled){var b=e.Get(0,0);b.SetV(this.body.GetLinearVelocity());a.vx=b.x;a.vy=b.y;a.om=this.body.GetAngularVelocity()}return a};p.loadFromJSON=function(a){this.destroyMyJoints();this.myCreatedJoints.length=0;this.joiningMe.clear();this.body&&(this.world.DestroyBody(this.body),this.body=null);this.enabled=a.e;this.immovable=a.im;this.preventRotation=a.pr;this.density=a.d;this.friction=a.fr;this.restitution=a.re;this.linearDamping=a.ld;this.angularDamping=a.ad;this.bullet=
a.b;this.lastKnownX=this.inst.x;this.lastKnownY=this.inst.y;this.lastKnownAngle=this.inst.angle;this.lastWidth=this.inst.width;this.lastHeight=this.inst.height;this.enabled&&(this.createBody(),this.body.SetLinearVelocity(e.Get(a.vx,a.vy)),this.body.SetAngularVelocity(a.om),0===a.vx&&0===a.vy&&0===a.om||this.body.SetAwake(!0),this.myCreatedJoints=a.mcj)};p.afterLoad=function(){this.enabled&&this.recreateMyJoints();this.behavior.lastUpdateTick=this.runtime.tickcount-1};p.onInstanceDestroyed=function(a){var b,
c,d,e=a.uid;d=b=0;for(c=this.myCreatedJoints.length;b<c;b++)this.myCreatedJoints[d]=this.myCreatedJoints[b],d<this.myJoints.length&&(this.myJoints[d]=this.myJoints[b]),this.myCreatedJoints[b].params[1]==e?this.world.DestroyJoint(this.myJoints[b]):d++;this.myCreatedJoints.length=d;d<this.myJoints.length&&(this.myJoints.length=d);this.joiningMe.remove(a)};p.destroyMyJoints=function(){var a,b;a=0;for(b=this.myJoints.length;a<b;a++)this.world.DestroyJoint(this.myJoints[a]);this.myJoints.length=0};p.recreateMyJoints=
function(){var a,b,c;a=0;for(b=this.myCreatedJoints.length;a<b;a++)switch(c=this.myCreatedJoints[a],c.type){case 0:this.doCreateDistanceJoint(c.params[0],c.params[1],c.params[2],c.params[3],c.params[4]);break;case 1:this.doCreateRevoluteJoint(c.params[0],c.params[1]);break;case 2:this.doCreateLimitedRevoluteJoint(c.params[0],c.params[1],c.params[2],c.params[3])}};p.destroyBody=function(){this.body&&(this.destroyMyJoints(),this.world.DestroyBody(this.body),this.body=null,this.inst.extra.box2dbody=
null)};p.createBody=function(){if(this.enabled){var a=this.inst,b=!1,c=null,d=null,f,m,n,p,B,y,v,u,z,E,x,F,G;if(this.body){b=!0;c=e.Get(0,0);c.SetV(this.body.GetLinearVelocity());d=this.body.GetAngularVelocity();u=this.joiningMe.valuesRef();f=0;for(m=u.length;f<m;f++)z=u[f].extra.box2dbody.c2userdata,z.destroyMyJoints();this.destroyBody()}z=new g;z.density=this.density;z.friction=this.friction;z.restitution=this.restitution;f=new h;f.type=this.immovable?0:2;a.update_bbox();f.position.x=0.02*a.bquad.midX();
f.position.y=0.02*a.bquad.midY();f.angle=a.angle;f.fixedRotation=this.preventRotation;f.linearDamping=this.linearDamping;f.angularDamping=this.angularDamping;f.bullet=this.bullet;u=this.inst.collision_poly&&!this.inst.collision_poly.is_empty();this.body=this.world.CreateBody(f);this.body.c2userdata=this;f=this.collisionmask;u||this.inst.tilemap_exists||0!==this.collisionmask||(f=1);m=Math.max(Math.abs(a.width),1);n=Math.max(Math.abs(a.height),1);E=0>a.width;x=0>a.height;if(0===f)if(a.tilemap_exists)for(F=
a.bquad.midX()-a.x,v=a.bquad.midY()-a.y,a.maybeBuildQuadMap(),u=[],f=0,m=a.collision_rects.length;f<m;++f){E=a.collision_rects[f];x=E.rc;if(E.poly){if(!E.poly.convexpolys){B=E.poly.pts_cache;p=E.poly.pts_count;for(n=0;n<p;++n)u.push(e.Get(B[2*n],B[2*n+1]));n=E.id&3758096384;(-2147483648===n||1073741824===n||536870912===n||n&-2147483648&&n&1073741824&&n&536870912)&&u.reverse();E.poly.convexpolys=cr.b2Separator.Separate(u,(x.right-x.left)*(x.bottom-x.top));n=0;for(p=u.length;n<p;++n)e.Free(u[n]);u.length=
0}n=0;for(p=E.poly.convexpolys.length;n<p;++n){G=E.poly.convexpolys[n];B=0;for(y=G.length;B<y;++B)u.push(e.Get(0.02*(x.left+G[B].x-F),0.02*(x.top+G[B].y-v)));z.shape=new l;z.shape.SetAsArray(u,u.length);this.body.CreateFixture(z);B=0;for(y=u.length;B<y;++B)e.Free(u[B]);u.length=0}}else u.push(e.Get(0.02*(x.left-F),0.02*(x.top-v))),u.push(e.Get(0.02*(x.right-F),0.02*(x.top-v))),u.push(e.Get(0.02*(x.right-F),0.02*(x.bottom-v))),u.push(e.Get(0.02*(x.left-F),0.02*(x.bottom-v))),z.shape=new l,z.shape.SetAsArray(u,
u.length),this.body.CreateFixture(z);n=0;for(p=u.length;n<p;++n)e.Free(u[n]);u.length=0}else{f=a.angle;a.angle=0;a.set_bbox_changed();a.update_bbox();F=a.bquad.midX()-a.x;v=a.bquad.midY()-a.y;a.angle=f;a.set_bbox_changed();a.collision_poly.cache_poly(E?-m:m,x?-n:n,0);B=a.collision_poly.pts_cache;p=a.collision_poly.pts_count;u=[];u.length=p;for(f=0;f<p;f++)u[f]=e.Get(B[2*f]-F,B[2*f+1]-v);E!==x&&u.reverse();F=cr.b2Separator.Separate(u,m*n);for(f=0;f<p;f++)e.Free(u[f]);if(F.length)for(f=0,m=F.length;f<
m;f++){u=F[f];n=0;for(p=u.length;n<p;n++)v=u[n],v.x*=0.02,v.y*=0.02;z.shape=new l;z.shape.SetAsArray(u,u.length);this.body.CreateFixture(z);n=0;for(p=u.length;n<p;n++)e.Free(u[n])}else z.shape=new l,z.shape.SetAsBox(0.01*m,0.01*n),this.body.CreateFixture(z)}else 1===f?(z.shape=new l,z.shape.SetAsBox(0.01*m,0.01*n)):z.shape=new k(0.01*Math.min(m,n)),this.body.CreateFixture(z);a.extra.box2dbody=this.body;this.lastWidth=a.width;this.lastHeight=a.height;if(b)for(this.body.SetLinearVelocity(c),this.body.SetAngularVelocity(d),
e.Free(c),this.recreateMyJoints(),u=this.joiningMe.valuesRef(),f=0,m=u.length;f<m;f++)z=u[f].extra.box2dbody.c2userdata,z.recreateMyJoints()}};p.tick=function(){if(this.enabled){var a=this.inst,b;0===this.behavior.steppingMode?b=this.runtime.timescale/60:(b=this.runtime.getDt(this.inst),b>1/30&&(b=1/30));this.runtime.tickcount>this.behavior.lastUpdateTick&&0<this.runtime.timescale&&(this.world.Step(b,this.behavior.velocityIterations,this.behavior.positionIterations),this.world.ClearForces(),this.behavior.lastUpdateTick=
this.runtime.tickcount);if(this.recreateBody||a.width!==this.lastWidth||a.height!==this.lastHeight||a.cur_animation!==this.lastAnimation||a.cur_frame!==this.lastAnimationFrame||a.tilemap_exists&&a.physics_changed)this.createBody(),this.recreateBody=!1,this.lastAnimation=a.cur_animation,this.lastAnimationFrame=a.cur_frame,a.tilemap_exists&&a.physics_changed&&(a.physics_changed=!1);b=a.angle!==this.lastKnownAngle;if(a.x!==this.lastKnownX||a.y!==this.lastKnownY){a.update_bbox();var c=a.bquad.midX(),
d=a.bquad.midY(),f=c-this.lastKnownX,g=d-this.lastKnownY;this.body.SetPosition(e.Get(0.02*c,0.02*d));this.body.SetLinearVelocity(e.Get(f,g));this.lastTickOverride=!0;this.body.SetAwake(!0)}else this.lastTickOverride&&(this.lastTickOverride=!1,this.body.SetLinearVelocity(e.Get(0,0)),this.body.SetPosition(e.Get(0.02*a.bquad.midX(),0.02*a.bquad.midY())));b&&(this.body.SetAngle(a.angle),this.body.SetAwake(!0));c=this.body.GetPosition();b=c.x/0.02;c=c.y/0.02;d=this.body.GetAngle();if(b!==a.x||c!==a.y||
d!==a.angle)if(a.x=b,a.y=c,a.angle=d,a.set_bbox_changed(),a.update_bbox(),b=a.bquad.midX()-a.x,c=a.bquad.midY()-a.y,0!==b||0!==c)a.x-=b,a.y-=c,a.set_bbox_changed();this.lastKnownX=a.x;this.lastKnownY=a.y;this.lastKnownAngle=a.angle}};p.getInstImgPointX=function(a){return-1!==a&&this.inst.getImagePoint?0===a&&this.body?(this.body.GetPosition().x+this.body.GetLocalCenter().x)/0.02:this.inst.getImagePoint(a,!0):this.inst.x};p.getInstImgPointY=function(a){return-1!==a&&this.inst.getImagePoint?0===a&&
this.body?(this.body.GetPosition().y+this.body.GetLocalCenter().y)/0.02:this.inst.getImagePoint(a,!1):this.inst.y};a.prototype.IsSleeping=function(){return this.enabled?!this.body.IsAwake():!1};a.prototype.CompareVelocity=function(a,b,c){if(!this.enabled)return!1;var d=this.body.GetLinearVelocity();0===a?d=d.x/0.02:1===a?d=d.y/0.02:(a=d.x/0.02,d=d.y/0.02,d=cr.distanceTo(0,0,a,d));return cr.do_cmp(d,b,c)};a.prototype.CompareAngularVelocity=function(a,b){if(!this.enabled)return!1;var c=cr.to_degrees(this.body.GetAngularVelocity());
return cr.do_cmp(c,a,b)};a.prototype.CompareMass=function(a,b){if(!this.enabled)return!1;var c=this.body.GetMass()/0.02;return cr.do_cmp(c,a,b)};a.prototype.IsEnabled=function(){return this.enabled};n.cnds=new a;b.prototype.ApplyForce=function(a,b,c){if(this.enabled){var d=this.getInstImgPointX(c);c=this.getInstImgPointY(c);this.body.ApplyForce(e.Get(a,b),e.Get(0.02*d,0.02*c))}};b.prototype.ApplyForceToward=function(a,b,c,d){if(this.enabled){var f=this.getInstImgPointX(d);d=this.getInstImgPointY(d);
b=cr.angleTo(f,d,b,c);this.body.ApplyForce(e.Get(Math.cos(b)*a,Math.sin(b)*a),e.Get(0.02*f,0.02*d))}};b.prototype.ApplyForceAtAngle=function(a,b,c){if(this.enabled){b=cr.to_radians(b);var d=this.getInstImgPointX(c);c=this.getInstImgPointY(c);this.body.ApplyForce(e.Get(Math.cos(b)*a,Math.sin(b)*a),e.Get(0.02*d,0.02*c))}};b.prototype.ApplyImpulse=function(a,b,c){if(this.enabled){var d=this.getInstImgPointX(c);c=this.getInstImgPointY(c);this.body.ApplyImpulse(e.Get(a,b),e.Get(0.02*d,0.02*c));this.lastTickOverride=
!1;this.lastKnownX=this.inst.x;this.lastKnownY=this.inst.y}};b.prototype.ApplyImpulseToward=function(a,b,c,d){if(this.enabled){var f=this.getInstImgPointX(d);d=this.getInstImgPointY(d);b=cr.angleTo(f,d,b,c);this.body.ApplyImpulse(e.Get(Math.cos(b)*a,Math.sin(b)*a),e.Get(0.02*f,0.02*d));this.lastTickOverride=!1;this.lastKnownX=this.inst.x;this.lastKnownY=this.inst.y}};b.prototype.ApplyImpulseAtAngle=function(a,b,c){if(this.enabled){b=cr.to_radians(b);var d=this.getInstImgPointX(c);c=this.getInstImgPointY(c);
this.body.ApplyImpulse(e.Get(Math.cos(b)*a,Math.sin(b)*a),e.Get(0.02*d,0.02*c));this.lastTickOverride=!1;this.lastKnownX=this.inst.x;this.lastKnownY=this.inst.y}};b.prototype.ApplyTorque=function(a){this.enabled&&this.body.ApplyTorque(cr.to_radians(a))};b.prototype.ApplyTorqueToAngle=function(a,b){this.enabled&&(a=cr.to_radians(a),b=cr.to_radians(b),cr.angleClockwise(this.inst.angle,b)?this.body.ApplyTorque(-a):this.body.ApplyTorque(a))};b.prototype.ApplyTorqueToPosition=function(a,b,c){this.enabled&&
(a=cr.to_radians(a),b=cr.angleTo(this.inst.x,this.inst.y,b,c),cr.angleClockwise(this.inst.angle,b)?this.body.ApplyTorque(-a):this.body.ApplyTorque(a))};b.prototype.SetAngularVelocity=function(a){this.enabled&&(this.body.SetAngularVelocity(cr.to_radians(a)),this.body.SetAwake(!0))};b.prototype.CreateDistanceJoint=function(a,b,c,d,e){b&&this.enabled&&(b=b.getFirstPicked(this.inst))&&b!=this.inst&&b.extra.box2dbody&&(this.myCreatedJoints.push({type:0,params:[a,b.uid,c,d,e]}),this.doCreateDistanceJoint(a,
b.uid,c,d,e))};p.doCreateDistanceJoint=function(a,b,c,d,g){if(this.enabled&&(b=this.runtime.getObjectByUID(b))&&b!=this.inst&&b.extra.box2dbody){b.extra.box2dbody.c2userdata.joiningMe.add(this.inst);var h=this.getInstImgPointX(a);a=this.getInstImgPointY(a);var k;b.getImagePoint?(k=b.getImagePoint(c,!0),c=b.getImagePoint(c,!1)):(k=b.x,c=b.y);var l=h-k,m=a-c,n=new f;n.Initialize(this.body,b.extra.box2dbody,e.Get(0.02*h,0.02*a),e.Get(0.02*k,0.02*c));n.length=0.02*Math.sqrt(l*l+m*m);n.dampingRatio=d;
n.frequencyHz=g;this.myJoints.push(this.world.CreateJoint(n))}};b.prototype.CreateRevoluteJoint=function(a,b){if(b&&this.enabled){var c=b.getFirstPicked(this.inst);c&&c!=this.inst&&c.extra.box2dbody&&(this.myCreatedJoints.push({type:1,params:[a,c.uid]}),this.doCreateRevoluteJoint(a,c.uid))}};p.doCreateRevoluteJoint=function(a,b){if(this.enabled){var c=this.runtime.getObjectByUID(b);if(c&&c!=this.inst&&c.extra.box2dbody){c.extra.box2dbody.c2userdata.joiningMe.add(this.inst);var d=this.getInstImgPointX(a),
f=this.getInstImgPointY(a),g=new m;g.Initialize(this.body,c.extra.box2dbody,e.Get(0.02*d,0.02*f));this.myJoints.push(this.world.CreateJoint(g))}}};b.prototype.CreateLimitedRevoluteJoint=function(a,b,c,d){b&&this.enabled&&(b=b.getFirstPicked(this.inst))&&b!=this.inst&&b.extra.box2dbody&&(this.myCreatedJoints.push({type:2,params:[a,b.uid,c,d]}),this.doCreateLimitedRevoluteJoint(a,b.uid,c,d))};p.doCreateLimitedRevoluteJoint=function(a,b,c,d){if(this.enabled&&(b=this.runtime.getObjectByUID(b))&&b!=this.inst&&
b.extra.box2dbody){b.extra.box2dbody.c2userdata.joiningMe.add(this.inst);var f=this.getInstImgPointX(a);a=this.getInstImgPointY(a);var g=new m;g.Initialize(this.body,b.extra.box2dbody,e.Get(0.02*f,0.02*a));g.enableLimit=!0;g.lowerAngle=cr.to_radians(c);g.upperAngle=cr.to_radians(d);this.myJoints.push(this.world.CreateJoint(g))}};b.prototype.SetWorldGravity=function(a){if(a!==this.behavior.worldG){this.world.SetGravity(e.Get(0,a));this.behavior.worldG=a;var b,c=this.behavior.my_instances.valuesRef();
a=0;for(b=c.length;a<b;a++)c[a].extra.box2dbody&&c[a].extra.box2dbody.SetAwake(!0)}};b.prototype.SetSteppingMode=function(a){this.behavior.steppingMode=a};b.prototype.SetIterations=function(a,b){1>a&&(a=1);1>b&&(b=1);this.behavior.velocityIterations=a;this.behavior.positionIterations=b};b.prototype.SetVelocity=function(a,b){this.enabled&&(this.body.SetLinearVelocity(e.Get(0.02*a,0.02*b)),this.body.SetAwake(!0),this.lastTickOverride=!1,this.lastKnownX=this.inst.x,this.lastKnownY=this.inst.y)};b.prototype.SetDensity=
function(a){this.enabled&&this.density!==a&&(this.density=a,this.recreateBody=!0)};b.prototype.SetFriction=function(a){this.enabled&&this.friction!==a&&(this.friction=a,this.recreateBody=!0)};b.prototype.SetElasticity=function(a){this.enabled&&this.restitution!==a&&(this.restitution=a,this.recreateBody=!0)};b.prototype.SetLinearDamping=function(a){this.enabled&&this.linearDamping!==a&&(this.linearDamping=a,this.body.SetLinearDamping(a))};b.prototype.SetAngularDamping=function(a){this.enabled&&this.angularDamping!==
a&&(this.angularDamping=a,this.body.SetAngularDamping(a))};b.prototype.SetImmovable=function(a){this.enabled&&this.immovable!==(0!==a)&&(this.immovable=0!==a,this.body.SetType(this.immovable?0:2),this.body.SetAwake(!0))};b.prototype.EnableCollisions=function(a,b){if(a&&this.enabled){var d,e;if(a.is_family)for(d=0,e=a.members.length;d<e;d++)c(this.inst.type,a.members[d],0!==b);else c(this.inst.type,a,0!==b);this.behavior.allCollisionsEnabled=!1}};b.prototype.SetPreventRotate=function(a){this.enabled&&
this.preventRotation!==(0!==a)&&(this.preventRotation=0!==a,this.body.SetFixedRotation(this.preventRotation),this.body.m_torque=0,this.body.SetAngularVelocity(0),this.body.SetAwake(!0))};b.prototype.SetBullet=function(a){this.enabled&&this.bullet!==(0!==a)&&(this.bullet=0!==a,this.body.SetBullet(this.bullet),this.body.SetAwake(!0))};b.prototype.RemoveJoints=function(){this.enabled&&(this.destroyMyJoints(),this.myCreatedJoints.length=0,this.joiningMe.clear())};b.prototype.SetEnabled=function(a){this.enabled&&
0===a?(this.destroyBody(),this.enabled=!1):this.enabled||1!==a||(this.enabled=!0,this.createBody())};n.acts=new b;d.prototype.VelocityX=function(a){a.set_float(this.enabled?this.body.GetLinearVelocity().x/0.02:0)};d.prototype.VelocityY=function(a){a.set_float(this.enabled?this.body.GetLinearVelocity().y/0.02:0)};d.prototype.AngularVelocity=function(a){a.set_float(this.enabled?cr.to_degrees(this.body.GetAngularVelocity()):0)};d.prototype.Mass=function(a){a.set_float(this.enabled?this.body.GetMass()/
0.02:0)};d.prototype.CenterOfMassX=function(a){a.set_float(this.enabled?(this.body.GetPosition().x+this.body.GetLocalCenter().x)/0.02:0)};d.prototype.CenterOfMassY=function(a){a.set_float(this.enabled?(this.body.GetPosition().y+this.body.GetLocalCenter().y)/0.02:0)};d.prototype.Density=function(a){a.set_float(this.enabled?this.density:0)};d.prototype.Friction=function(a){a.set_float(this.enabled?this.friction:0)};d.prototype.Elasticity=function(a){a.set_float(this.enabled?this.restitution:0)};d.prototype.LinearDamping=
function(a){a.set_float(this.enabled?this.linearDamping:0)};d.prototype.AngularDamping=function(a){a.set_float(this.enabled?this.angularDamping:0)};n.exps=new d})();cr.behaviors.Rotate=function(a){this.runtime=a};
(function(){function a(){}function b(){}var c=cr.behaviors.Rotate.prototype;c.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};c.Type.prototype.onCreate=function(){};c.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var d=c.Instance.prototype;d.onCreate=function(){this.speed=cr.to_radians(this.properties[0]);this.acc=cr.to_radians(this.properties[1])};d.saveToJSON=function(){return{speed:this.speed,acc:this.acc}};d.loadFromJSON=
function(a){this.speed=a.speed;this.acc=a.acc};d.tick=function(){var a=this.runtime.getDt(this.inst);0!==a&&(0!==this.acc&&(this.speed+=this.acc*a),0!==this.speed&&(this.inst.angle=cr.clamp_angle(this.inst.angle+this.speed*a),this.inst.set_bbox_changed()))};c.cnds=new function(){};a.prototype.SetSpeed=function(a){this.speed=cr.to_radians(a)};a.prototype.SetAcceleration=function(a){this.acc=cr.to_radians(a)};c.acts=new a;b.prototype.Speed=function(a){a.set_float(cr.to_degrees(this.speed))};b.prototype.Acceleration=
function(a){a.set_float(cr.to_degrees(this.acc))};c.exps=new b})();cr.behaviors.Sin=function(a){this.runtime=a};
(function(){function a(){}function b(){}function c(){}var d=cr.behaviors.Sin.prototype;d.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};d.Type.prototype.onCreate=function(){};d.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime;this.i=0};var e=d.Instance.prototype,h=2*Math.PI,g=Math.PI/2,l=3*Math.PI/2;e.onCreate=function(){this.active=1===this.properties[0];this.movement=this.properties[1];this.wave=this.properties[2];this.period=
this.properties[3];this.period+=Math.random()*this.properties[4];0===this.period?this.i=0:(this.i=this.properties[5]/this.period*h,this.i+=Math.random()*this.properties[6]/this.period*h);this.mag=this.properties[7];this.mag+=Math.random()*this.properties[8];this.ratio=this.initialValue2=this.initialValue=0;this.init()};e.saveToJSON=function(){return{i:this.i,a:this.active,mv:this.movement,w:this.wave,p:this.period,mag:this.mag,iv:this.initialValue,iv2:this.initialValue2,r:this.ratio,lkv:this.lastKnownValue,
lkv2:this.lastKnownValue2}};e.loadFromJSON=function(a){this.i=a.i;this.active=a.a;this.movement=a.mv;this.wave=a.w;this.period=a.p;this.mag=a.mag;this.initialValue=a.iv;this.initialValue2=a.iv2||0;this.ratio=a.r;this.lastKnownValue=a.lkv;this.lastKnownValue2=a.lkv2||0};e.init=function(){switch(this.movement){case 0:this.initialValue=this.inst.x;break;case 1:this.initialValue=this.inst.y;break;case 2:this.initialValue=this.inst.width;this.ratio=this.inst.height/this.inst.width;break;case 3:this.initialValue=
this.inst.width;break;case 4:this.initialValue=this.inst.height;break;case 5:this.initialValue=this.inst.angle;this.mag=cr.to_radians(this.mag);break;case 6:this.initialValue=this.inst.opacity;break;case 7:this.initialValue=0;break;case 8:this.initialValue=this.inst.x,this.initialValue2=this.inst.y}this.lastKnownValue=this.initialValue;this.lastKnownValue2=this.initialValue2};e.waveFunc=function(a){a%=h;switch(this.wave){case 0:return Math.sin(a);case 1:return a<=g?a/g:a<=l?1-2*(a-g)/Math.PI:(a-l)/
g-1;case 2:return 2*a/h-1;case 3:return-2*a/h+1;case 4:return a<Math.PI?-1:1}return 0};e.tick=function(){var a=this.runtime.getDt(this.inst);if(this.active&&0!==a){0===this.period?this.i=0:(this.i+=a/this.period*h,this.i%=h);switch(this.movement){case 0:this.inst.x!==this.lastKnownValue&&(this.initialValue+=this.inst.x-this.lastKnownValue);this.inst.x=this.initialValue+this.waveFunc(this.i)*this.mag;this.lastKnownValue=this.inst.x;break;case 1:this.inst.y!==this.lastKnownValue&&(this.initialValue+=
this.inst.y-this.lastKnownValue);this.inst.y=this.initialValue+this.waveFunc(this.i)*this.mag;this.lastKnownValue=this.inst.y;break;case 2:this.inst.width=this.initialValue+this.waveFunc(this.i)*this.mag;this.inst.height=this.inst.width*this.ratio;break;case 3:this.inst.width=this.initialValue+this.waveFunc(this.i)*this.mag;break;case 4:this.inst.height=this.initialValue+this.waveFunc(this.i)*this.mag;break;case 5:this.inst.angle!==this.lastKnownValue&&(this.initialValue=cr.clamp_angle(this.initialValue+
(this.inst.angle-this.lastKnownValue)));this.inst.angle=cr.clamp_angle(this.initialValue+this.waveFunc(this.i)*this.mag);this.lastKnownValue=this.inst.angle;break;case 6:this.inst.opacity=this.initialValue+this.waveFunc(this.i)*this.mag/100;0>this.inst.opacity?this.inst.opacity=0:1<this.inst.opacity&&(this.inst.opacity=1);break;case 8:this.inst.x!==this.lastKnownValue&&(this.initialValue+=this.inst.x-this.lastKnownValue),this.inst.y!==this.lastKnownValue2&&(this.initialValue2+=this.inst.y-this.lastKnownValue2),
this.inst.x=this.initialValue+Math.cos(this.inst.angle)*this.waveFunc(this.i)*this.mag,this.inst.y=this.initialValue2+Math.sin(this.inst.angle)*this.waveFunc(this.i)*this.mag,this.lastKnownValue=this.inst.x,this.lastKnownValue2=this.inst.y}this.inst.set_bbox_changed()}};e.onSpriteFrameChanged=function(a,b){switch(this.movement){case 2:this.initialValue*=b.width/a.width;this.ratio=b.height/b.width;break;case 3:this.initialValue*=b.width/a.width;break;case 4:this.initialValue*=b.height/a.height}};a.prototype.IsActive=
function(){return this.active};a.prototype.CompareMovement=function(a){return this.movement===a};a.prototype.ComparePeriod=function(a,b){return cr.do_cmp(this.period,a,b)};a.prototype.CompareMagnitude=function(a,b){return 5===this.movement?cr.do_cmp(this.mag,a,cr.to_radians(b)):cr.do_cmp(this.mag,a,b)};a.prototype.CompareWave=function(a){return this.wave===a};d.cnds=new a;b.prototype.SetActive=function(a){this.active=1===a};b.prototype.SetPeriod=function(a){this.period=a};b.prototype.SetMagnitude=
function(a){this.mag=a;5===this.movement&&(this.mag=cr.to_radians(this.mag))};b.prototype.SetMovement=function(a){5===this.movement&&(this.mag=cr.to_degrees(this.mag));this.movement=a;this.init()};b.prototype.SetWave=function(a){this.wave=a};d.acts=new b;c.prototype.CyclePosition=function(a){a.set_float(this.i/h)};c.prototype.Period=function(a){a.set_float(this.period)};c.prototype.Magnitude=function(a){5===this.movement?a.set_float(cr.to_degrees(this.mag)):a.set_float(this.mag)};c.prototype.Value=
function(a){a.set_float(this.waveFunc(this.i)*this.mag)};d.exps=new c})();cr.behaviors.destroy=function(a){this.runtime=a};
(function(){var a=cr.behaviors.destroy.prototype;a.Type=function(a,c){this.behavior=a;this.objtype=c;this.runtime=a.runtime};a.Type.prototype.onCreate=function(){};a.Instance=function(a,c){this.type=a;this.behavior=a.behavior;this.inst=c;this.runtime=a.runtime};a=a.Instance.prototype;a.onCreate=function(){};a.tick=function(){this.inst.update_bbox();var a=this.inst.bbox,c=this.inst.layer.layout;(0>a.right||0>a.bottom||a.left>c.width||a.top>c.height)&&this.runtime.DestroyInstance(this.inst)}})();
cr.behaviors.scrollto=function(a){this.runtime=a;this.shakeMode=this.shakeEnd=this.shakeStart=this.shakeMag=0};
(function(){function a(){}var b=cr.behaviors.scrollto.prototype;b.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};b.Type.prototype.onCreate=function(){};b.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var c=b.Instance.prototype;c.onCreate=function(){this.enabled=0!==this.properties[0]};c.saveToJSON=function(){return{smg:this.behavior.shakeMag,ss:this.behavior.shakeStart,se:this.behavior.shakeEnd,smd:this.behavior.shakeMode}};
c.loadFromJSON=function(a){this.behavior.shakeMag=a.smg;this.behavior.shakeStart=a.ss;this.behavior.shakeEnd=a.se;this.behavior.shakeMode=a.smd};c.tick=function(){};c.tick2=function(){if(this.enabled){var a=this.behavior.my_instances.values(),b=0,c=0,g,l;g=0;for(l=a.length;g<l;g++)b+=a[g].x,c+=a[g].y;g=this.inst.layer.layout;var k=this.runtime.kahanTime.sum,f=l=0;k>=this.behavior.shakeStart&&k<this.behavior.shakeEnd&&(l=this.behavior.shakeMag*Math.min(this.runtime.timescale,1),0===this.behavior.shakeMode&&
(l*=1-(k-this.behavior.shakeStart)/(this.behavior.shakeEnd-this.behavior.shakeStart)),k=2*Math.random()*Math.PI,f=Math.random()*l,l=Math.cos(k)*f,f*=Math.sin(k));g.scrollToX(b/a.length+l);g.scrollToY(c/a.length+f)}};a.prototype.Shake=function(a,b,c){this.behavior.shakeMag=a;this.behavior.shakeStart=this.runtime.kahanTime.sum;this.behavior.shakeEnd=this.behavior.shakeStart+b;this.behavior.shakeMode=c};a.prototype.SetEnabled=function(a){this.enabled=0!==a};b.acts=new a})();
cr.getProjectModel=function(){return[null,"Menu",[[cr.plugins_.CJSAds,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.Browser,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.Audio,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.Sprite,!1,!0,!0,!0,!0,!0,!0,!0,!1],[cr.plugins_.Text,!1,!0,!0,!0,!0,!0,!0,!0,!1],[cr.plugins_.Touch,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.WebStorage,!0,!1,!1,!1,!1,!1,!1,!1,!1]],[["t0",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,7692572746941322,[["fondo-sheet0.png",301276,0,0,
640,360,1,0.5,0.5,[],[0.457813,-0.005555,0.332813,-0.166667,0.351562,-0.163889,0.442188,-0.047222],1]]]],[],!1,!1,0x61b3858880dfc,[],null],["t1",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x8255033f21c8c,[["catapult-sheet0.png",255,0,0,40,4,1,0,0.5,[],[0.203443,-0.430556,0.502347,-0.083333,0.762128,-0.083333,0.995305,0,0.760563,0.069444,0.502347,0.069444,0.203443,0.430556,0.00469484,0],0]]]],[],!1,!1,0x63f13f8757440,[],null],["t2",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,
1,0,!1,8099206606908238,[["fondoazul-sheet0.png",41028,0,0,639,179,1,0.500782,0.502793,[],[],0]]]],[["DestroyOutsideLayout",cr.behaviors.destroy,0x585bf795ae065]],!1,!1,0xa11af0bbaf3ef,[],null],["t3",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xf1ca4a96ac9b5,[["skip-sheet0.png",793,0,0,26,25,1,0.461538,0.52,[],[-0.461538,-0.511111,0.0259615,-0.511111,0.538462,-0.511111,0.538462,0.004444,0.538462,0.48,-0.461538,0.48],0]]]],[["DestroyOutsideLayout",cr.behaviors.destroy,6556813558773844]],
!1,!1,6150243353981714,[],null],["t4",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,6983286382604201,[["sprite-sheet0.png",452170,0,0,640,538,1,1,0,[],[0,1,-1,1,-1,0,0,0],0]]]],[],!1,!1,9931499212178684,[],null],["t5",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x6affbc425376f,[["copa-sheet0.png",29533,0,0,135,111,1,0.503704,0.504505,[],[-0.323929,-0.285326,-0.00370371,-0.470258,0.310903,-0.278477,0.383936,-0.0045045,0.434498,0.420153,-0.00370371,0.461249,-0.441906,0.420153,
-0.391344,-0.0045045],0]]]],[["DestroyOutsideLayout",cr.behaviors.destroy,0xa507baf628c20]],!1,!1,0x7745c9e458a34,[],null],["t6",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,7180372785930291,[["fondomenu-sheet0.png",299754,0,0,640,360,1,0.5,0.5,[],[],0]]]],[],!1,!0,9520504622186148,[],null],["t7",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xe573857657ec,[["facebook-sheet0.png",1020,0,0,30,30,1,0.5,0.5,[],[-0.465,-0.465,0,-0.485,0.465,-0.465,0.485,0,0.465,0.465,0,0.485,
-0.465,0.465,-0.485,0],0]]]],[["DestroyOutsideLayout",cr.behaviors.destroy,5676675754940524]],!1,!1,4892235744108046,[],null],["t8",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,5499890107022649,[["fondonegro-sheet0.png",101,0,0,80,80,1,0.5,0.5,[],[],1]]]],[["DestroyOutsideLayout",cr.behaviors.destroy,8889105149171608]],!1,!0,0xb7b7693e6481b,[],null],["t9",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,6774077189041293,[["nombre-sheet0.png",18618,0,0,138,59,1,0.5,0.576271,[],
[-0.202586,-0.485819,0.00215501,-0.485819,0.18319,-0.430542,0.4375,-0.00843215,0.140086,0.313176,-0.142241,0.328252,-0.435345,-0.00843215],0]]]],[],!1,!0,0x9401f1b4f3353,[],null],["t10",cr.plugins_.Audio,!1,[],0,0,null,null,[],!1,!1,432376389717995,[],null,[0,0,1,1,600,600,1E4,1,5E3,1]],["t11",cr.plugins_.Browser,!1,[],0,0,null,null,[],!1,!1,0x8126f96920bbe,[],null,[]],["t12",cr.plugins_.Touch,!1,[],0,0,null,null,[],!1,!1,5360238741765463,[],null,[1]],["t13",cr.plugins_.WebStorage,!1,[],0,0,null,
null,[],!1,!1,5348170403011429,[],null,[]],["t14",cr.plugins_.CJSAds,!1,[],0,0,null,null,[],!1,!1,8402394799170796,[],null,[0,1]],["t15",cr.plugins_.Sprite,!1,[],1,0,null,[["Derecha",4,!1,1,0,!1,0xc034dc8da8e7b,[["iniesta-sheet0.png",9088,50,1,34,73,1,0.5,0.479452,[],[-0.154265,-0.335548,-0.154412,-0.463836,0.117942,-0.462466,0.118382,-0.339041],0],["iniesta-sheet1.png",8806,1,1,30,65,1,0.5,0.523077,[],[-0.108167,-0.361462,-0.108333,-0.505538,0.200334,-0.504,0.200833,-0.365385],0],["iniesta-sheet1.png",
8806,32,1,29,65,1,0.62069,0.538462,[],[-0.249828,-0.376847,-0.25,-0.520923,0.0693114,-0.519385,0.0698274,-0.38077],0],["iniesta-sheet0.png",9088,85,1,35,63,1,0.571429,0.539683,[],[-0.00699961,-0.357064,-0.0071426,-0.505714,0.228858,-0.504127,0.229285,-0.361112],0],["iniesta-sheet0.png",9088,1,1,48,73,1,0.458333,0.465753,[],[-0.0467703,-0.30815,-0.0468754,-0.436438,0.146043,-0.435068,0.146354,-0.311643],0]]]],[["DestroyOutsideLayout",cr.behaviors.destroy,9756372491800036]],!1,!1,678743747071981,[],
null],["t16",cr.plugins_.Sprite,!1,[],2,0,null,[["Derecha",5,!0,1,0,!1,0xc51dbe27cb14d,[["pique-sheet0.png",14126,95,61,28,58,1,0.5,0.5,[],[-0.107143,-0.48046,0.171785,-0.479483,0.173809,-0.357758,-0.102619,-0.359885],0],["pique-sheet0.png",14126,87,1,37,59,1,0.486486,0.491525,[],[-0.243244,-0.472316,-0.00513551,-0.471356,-0.00360349,-0.351694,-0.239819,-0.353785],0],["pique-sheet0.png",14126,1,1,42,58,1,0.5,0.5,[],[-0.047619,-0.48046,0.138333,-0.479483,0.139682,-0.357758,-0.044603,-0.359885],0],
["pique-sheet0.png",14126,39,60,27,62,1,0.481481,0.5,[],[-0.148149,-0.48172,0.178147,-0.480806,0.180247,-0.350806,-0.143456,-0.352796],0],["pique-sheet0.png",14126,44,1,42,58,1,0.5,0.5,[],[-0.047619,-0.48046,0.138333,-0.479483,0.139682,-0.357758,-0.044603,-0.359885],0],["pique-sheet0.png",14126,1,60,37,59,1,0.486486,0.508475,[],[-0.216217,-0.489266,-0.00513551,-0.488305,-0.00360349,-0.368644,-0.212792,-0.370735],0],["pique-sheet1.png",3303,0,0,28,58,1,0.5,0.5,[],[-0.107143,-0.48046,0.171785,-0.479483,
0.173809,-0.357758,-0.102619,-0.359885],0],["pique-sheet0.png",14126,67,61,27,62,1,0.481481,0.5,[],[-0.148149,-0.465591,0.178147,-0.464677,0.180247,-0.334677,-0.143456,-0.336667],0]]]],[["Bullet",cr.behaviors.Bullet,0x3b5da6291dc4e],["DestroyOutsideLayout",cr.behaviors.destroy,0x80792b89154fa]],!1,!1,0xd1240486e8c51,[],null],["t17",cr.plugins_.Sprite,!1,[],0,0,null,[["Derecha",5,!1,1,0,!1,8282109649207689,[["torres-sheet1.png",7293,1,1,29,61,1,0.517241,0.491803,[],[0.394828,-0.462295,0.396552,-0.315574,
0.112069,-0.318853,0.113794,-0.459017],0],["torres-sheet0.png",12934,57,1,53,61,1,0.490566,0.491803,[],[0.0158419,-0.454098,0.01285,-0.315574,0.17648,-0.318853,0.173488,-0.454919],0],["torres-sheet0.png",12934,57,63,50,58,1,0.5,0.5,[],[-0.287931,-0.470492,-0.291207,-0.345323,-0.11069,-0.339981,-0.108965,-0.471524],0],["torres-sheet0.png",12934,1,1,55,64,1,0.490909,0.5,[],[0.0393419,-0.466585,0.0410659,-0.339396,-0.116145,-0.342675,-0.11442,-0.467214],0],["torres-sheet0.png",12934,1,66,45,61,1,0.488889,
0.491803,[],[0.134291,-0.363934,0.136015,-0.217213,-0.0818009,-0.220492,-0.0745209,-0.360656],0],["torres-sheet1.png",7293,60,1,24,55,1,0.5,0.490909,[],[0.120402,-0.45231,0.122126,-0.31468,-0.24569,-0.317959,-0.254382,-0.453577],0],["torres-sheet1.png",7293,31,1,28,62,1,0.5,0.5,[],[0.233498,-0.470492,0.235222,-0.323771,-0.12069,-0.32705,-0.118965,-0.471246],0]]]],[],!1,!1,6741832530939406,[],null],["t18",cr.plugins_.Sprite,!1,[],2,0,null,[["Derecha",5,!0,1,0,!1,6651895143931144,[["villa-sheet1.png",
16109,1,58,27,60,1,0.481481,0.5,[],[-0.0587665,-0.329556,-0.0587655,-0.481111,0.256296,-0.47975,0.256298,-0.329555],0],["villa-sheet1.png",16109,1,1,33,56,1,0.484848,0.5,[],[-0.151112,-0.335239,-0.151112,-0.497618,0.115555,-0.49616,0.115556,-0.335238],0],["villa-sheet0.png",21917,1,1,41,60,1,0.487805,0.5,[],[0.12065,-0.337112,0.12065,-0.478888,0.342438,-0.478888,0.342439,-0.342],0],["villa-sheet1.png",16109,66,1,28,63,1,0.5,0.492063,[],[0.033808,-0.343493,0.03381,-0.478518,0.295714,-0.478518,0.295715,
-0.343491],0],["villa-sheet1.png",16109,35,1,30,61,1,0.5,0.491803,[],[-0.119112,-0.331585,-0.119111,-0.480655,0.125333,-0.480655,0.125334,-0.331584],0],["villa-sheet0.png",21917,84,1,40,56,1,0.5,0.5,[],[-0.214001,-0.322381,-0.214,-0.474285,-0.030667,-0.474285,-0.030666,-0.322381],0],["villa-sheet0.png",21917,84,58,32,63,1,0.5,0.492063,[],[-0.188751,-0.354074,-0.18875,-0.479788,0.035833,-0.479788,0.040418,-0.354073],0],["villa-sheet0.png",21917,33,63,30,62,1,0.5,0.5,[],[-0.16089,-0.346667,-0.165778,
-0.476774,0.098222,-0.476774,0.103112,-0.349032],0],["villa-sheet0.png",21917,1,62,31,65,1,0.483871,0.492308,[],[-0.060216,-0.339693,-0.064946,-0.470564,0.185806,-0.468307,0.181076,-0.339693],0],["villa-sheet0.png",21917,43,1,40,61,1,0.5,0.491803,[],[-0.224334,-0.32918,-0.228,-0.468633,-0.033667,-0.471038,-0.029999,-0.331584],0],["villa-sheet1.png",16109,95,1,28,59,1,0.5,0.508475,[],[-0.150477,-0.354803,-0.145238,-0.486553,0.127142,-0.489039,0.121906,-0.352317],0]]]],[["Bullet",cr.behaviors.Bullet,
9006066521025749],["DestroyOutsideLayout",cr.behaviors.destroy,0x636c9c65b8165]],!1,!1,8701122463864948,[],null],["t19",cr.plugins_.Sprite,!1,[],1,0,null,[["Derecha",4,!1,1,0,!1,5772715265617685,[["xavi-sheet0.png",13820,43,1,39,63,1,0.538462,0.47619,[],[-0.147436,-0.45381,0.0661534,-0.453651,0.0641024,-0.31746,-0.148206,-0.313968],0],["xavi-sheet0.png",13820,1,1,41,66,1,0.512195,0.484848,[],[-0.0914631,-0.463485,0.111707,-0.463333,0.109756,-0.333333,-0.0921951,-0.33],0],["xavi-sheet0.png",13820,
83,1,30,65,1,0.366667,0.492308,[],[-0.0583337,-0.470615,0.211,-0.470461,0.208333,-0.35,-0.0593337,-0.350462],0],["xavi-sheet0.png",13820,43,65,29,59,1,0.344828,0.491525,[],[0.00862041,-0.467627,0.295862,-0.467458,0.293103,-0.322033,0.00758642,-0.318305],0]]]],[["DestroyOutsideLayout",cr.behaviors.destroy,0xae67ce56ee98d]],!1,!1,5172759910568868,[],null],["t20",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",5,!0,1,0,!1,5573578064017994,[["alves-sheet0.png",18716,87,1,30,63,1,0.5,0.492063,[],[-0.179762,
-0.454127,0.119667,-0.45381,0.112619,-0.305555,-0.176429,-0.305555],0],["alves-sheet0.png",18716,1,1,42,62,1,0.5,0.5,[],[-0.246429,-0.462063,-0.047,-0.461746,-0.054047,-0.313492,-0.243095,-0.313492],0],["alves-sheet0.png",18716,63,65,29,62,1,0.482759,0.5,[],[-0.160222,-0.478193,0.177138,-0.477875,0.17009,-0.329621,-0.156889,-0.329621],0],["alves-sheet0.png",18716,1,64,30,63,1,0.5,0.492063,[],[-0.179762,-0.454127,0.119667,-0.45381,0.112619,-0.305555,-0.176429,-0.305555],0],["alves-sheet0.png",18716,
32,64,30,63,1,0.5,0.492063,[],[-0.113095,-0.454127,0.186334,-0.45381,0.179286,-0.305555,-0.109762,-0.305555],0],["alves-sheet0.png",18716,93,65,29,62,1,0.482759,0.5,[],[-0.125739,-0.478193,0.21162,-0.477875,0.204573,-0.329621,-0.122406,-0.329621],0],["alves-sheet0.png",18716,44,1,42,62,1,0.5,0.5,[],[0.039286,-0.462063,0.262524,-0.461746,0.255477,-0.313492,0.042619,-0.313492],0],["alves-sheet1.png",3904,0,0,30,63,1,0.5,0.492063,[],[-0.104762,-0.454127,0.186334,-0.45381,0.179286,-0.305555,-0.109762,
-0.305555],0]]]],[["Bullet",cr.behaviors.Bullet,9890902679644608],["DestroyOutsideLayout",cr.behaviors.destroy,5638273177650696]],!1,!1,817379514469696,[],null],["t21",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!0,1,0,!1,0x5b08d688d7357,[["neymar-sheet0.png",45530,1,66,85,64,1,0.941176,0.90625,[],[-0.689803,-0.873177,-0.566078,-0.875,-0.567842,-0.711198,-0.692745,-0.714844],0],["neymar-sheet0.png",45530,89,1,86,64,1,0.930233,0.90625,[],[-0.620721,-0.873177,-0.496995,-0.875,-0.49876,-0.711198,
-0.623662,-0.714844],0],["neymar-sheet0.png",45530,176,1,67,61,1,0.910448,0.901639,[],[-0.64415,-0.872665,-0.490574,-0.870389,-0.492338,-0.706587,-0.647091,-0.706134],0],["neymar-sheet0.png",45530,1,131,65,61,1,0.907692,0.918033,[],[-0.440935,-0.88496,-0.28644,-0.886783,-0.288205,-0.722981,-0.443876,-0.726627],0],["neymar-sheet0.png",45530,179,190,44,58,1,0.795455,0.896552,[],[-0.612264,-0.863479,-0.374902,-0.865302,-0.376667,-0.7015,-0.615205,-0.700835],0],["neymar-sheet0.png",45530,1,193,38,62,
1,0.815789,0.903226,[],[-0.75,-0.821766,-0.493323,-0.819556,-0.495087,-0.679948,-0.751569,-0.679562],0],["neymar-sheet1.png",11259,40,1,35,61,1,0.8,0.934426,[],[-0.520056,-0.901353,-0.232045,-0.899078,-0.226666,-0.755767,-0.522997,-0.755315],0],["neymar-sheet0.png",45530,87,130,83,59,1,0.915663,0.881356,[],[-0.326941,-0.865232,-0.227312,-0.867055,-0.229077,-0.686304,-0.329882,-0.68995],0],["neymar-sheet0.png",45530,87,66,86,63,1,0.930233,0.920635,[],[-0.306767,-0.887562,-0.183042,-0.885417,-0.184806,
-0.729551,-0.309708,-0.729229],0],["neymar-sheet0.png",45530,1,1,87,64,1,0.931035,0.90625,[],[-0.369318,-0.873177,-0.234097,-0.875,-0.235861,-0.711198,-0.372258,-0.714844],0],["neymar-sheet0.png",45530,176,63,67,61,1,1.19403,0.95082,[],[-0.632956,-0.921845,-0.460723,-0.91957,-0.462488,-0.755768,-0.635897,-0.755315],0],["neymar-sheet0.png",45530,67,190,65,61,1,1.23077,0.95082,[],[-0.85632,-0.917747,-0.68644,-0.91957,-0.688205,-0.755768,-0.859261,-0.759414],0],["neymar-sheet0.png",45530,133,190,45,
58,1,1.77778,0.896552,[],[-1.19307,-0.863479,-0.963791,-0.865302,-0.96,-0.70581,-1.19601,-0.705146],0],["neymar-sheet1.png",11259,1,1,38,62,1,2.10526,0.919355,[],[-1.43284,-0.854024,-1.17753,-0.851815,-1.1793,-0.692045,-1.43578,-0.691658],0],["neymar-sheet1.png",11259,76,1,35,61,1,2.28571,0.918033,[],[-2.03434,-0.88496,-1.91062,-0.886783,-1.91238,-0.722981,-2.03728,-0.726627],0],["neymar-sheet0.png",45530,171,130,83,59,1,0.963855,0.898305,[],[-0.712482,-0.865232,-0.588757,-0.867055,-0.590521,-0.703253,
-0.715424,-0.706899],0]]]],[],!1,!1,5448815451505631,[],null],["t22",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,366602736923582,[["david-sheet1.png",5163,30,1,26,61,1,0.5,0.47541,[],[0.067308,-0.45082,0.417308,-0.448361,0.424615,-0.290984,0.066154,-0.291475],0],["david-sheet0.png",17703,47,59,38,63,1,0.631579,0.492063,[],[0.0673081,-0.4516,0.285729,-0.449141,0.293036,-0.307638,0.0661541,-0.308128],0],["david-sheet0.png",17703,52,1,45,57,1,0.511111,0.508772,[],[-0.0549151,-0.466638,
0.161752,-0.468565,0.157949,-0.324346,-0.0560691,-0.324837],0],["david-sheet0.png",17703,1,57,45,54,1,0.444444,0.462963,[],[-0.188248,-0.419854,0.0284185,-0.417395,0.0246156,-0.278537,-0.189402,-0.279028],0],["david-sheet0.png",17703,1,1,50,55,1,0.38,0.454545,[],[-0.172692,-0.429955,0.017308,-0.427496,0.019616,-0.270119,-0.173847,-0.27061],0],["david-sheet0.png",17703,86,59,31,59,1,0.419355,0.491525,[],[-0.368176,-0.394901,-0.0181758,-0.39668,-0.0189328,-0.239302,-0.36933,-0.239794],0],["david-sheet1.png",
5163,1,1,28,60,1,0.5,0.55,[],[-0.334478,-0.458743,0.060165,-0.456284,0.067473,-0.315574,-0.326704,-0.316065],0]]]],[],!1,!1,9238279215525364,[],null],["t23",cr.plugins_.Sprite,!1,[],1,0,null,[["Arriba",5,!1,1,0,!1,6617027640411097,[["ronaldinho-sheet1.png",20539,101,1,26,69,1,0.538462,0.478261,[],[-0.144231,-0.456522,0.182692,-0.460145,0.182692,-0.315217,-0.144231,-0.311594],0],["ronaldinho-sheet2.png",11965,1,1,28,66,1,0.785714,0.484848,[],[-0.419642,-0.462121,-0.116071,-0.465909,-0.116071,-0.329545,
-0.419642,-0.325758],0],["ronaldinho-sheet1.png",20539,70,1,30,66,1,0.4,0.515152,[],[-0.125,-0.492424,0.158333,-0.496212,0.158333,-0.359848,-0.125,-0.356061],0],["ronaldinho-sheet0.png",21542,39,68,33,58,1,0.424242,0.482759,[],[0.0681816,-0.456897,0.325758,-0.461207,0.325758,-0.323276,0.0681816,-0.318966],0],["ronaldinho-sheet1.png",20539,36,1,33,61,1,0.272727,0.459016,[],[0.219697,-0.434426,0.477273,-0.438524,0.477273,-0.290983,0.219697,-0.286885],0],["ronaldinho-sheet0.png",21542,1,1,44,58,1,0.431818,
0.517241,[],[0.0965908,-0.491379,0.289773,-0.49569,0.289773,-0.340517,0.0965908,-0.336206],0],["ronaldinho-sheet0.png",21542,46,1,38,66,1,0.526316,0.560606,[],[-0.0986838,-0.55303,0.125,-0.556818,0.125,-0.405303,-0.0986838,-0.401515],0],["ronaldinho-sheet0.png",21542,85,58,32,66,1,0.5,0.515152,[],[-0.117187,-0.507576,0.148438,-0.511364,0.148438,-0.359848,-0.117187,-0.356061],0]]],["Abajo",5,!1,1,0,!1,7604281855481997,[["ronaldinho-sheet2.png",11965,58,1,25,62,1,0.56,0.532258,[],[-0.19,-0.508065,0.11,
-0.512097,0.11,-0.366935,-0.19,-0.362903],0],["ronaldinho-sheet2.png",11965,84,1,22,65,1,0.454545,0.507692,[],[-0.170454,-0.484615,0.170455,-0.488461,0.170455,-0.35,-0.170454,-0.346153],0],["ronaldinho-sheet1.png",20539,34,63,28,62,1,0.535714,0.532258,[],[-0.205357,-0.491935,0.0982147,-0.495968,0.0982147,-0.350806,-0.205357,-0.346774],0],["ronaldinho-sheet1.png",20539,1,62,32,57,1,0.40625,0.508772,[],[-0.117187,-0.464912,0.117188,-0.469298,0.117188,-0.307017,-0.117187,-0.307018],0],["ronaldinho-sheet0.png",
21542,1,60,37,57,1,0.378378,0.491228,[],[-0.155405,-0.464912,0.0743246,-0.469298,0.0743246,-0.311403,-0.155405,-0.307017],0],["ronaldinho-sheet0.png",21542,85,1,42,56,1,0.380952,0.482143,[],[-0.136904,-0.473214,0.0416666,-0.477678,0.0416666,-0.294643,-0.136904,-0.294643],0],["ronaldinho-sheet1.png",20539,1,1,34,60,1,0.529412,0.466667,[],[-0.198529,-0.441667,0.0514712,-0.445833,0.0514702,-0.2625,-0.198529,-0.258334],0],["ronaldinho-sheet2.png",11965,30,1,27,64,1,0.518519,0.46875,[],[-0.231482,-0.429688,
0.0648155,-0.433594,0.0648145,-0.277344,-0.231482,-0.273437],0]]]],[["Bullet",cr.behaviors.Bullet,7486624604740094]],!1,!1,0x3e94f4f139612,[],null],["t24",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",10,!0,1,0,!1,5708573785480487,[["hulk-sheet0.png",65332,105,179,43,59,1,1,0.491525,[],[-0.526046,-0.48339,-0.266512,-0.478136,-0.266512,-0.283728,-0.526046,-0.288983],0],["hulk-sheet0.png",65332,1,123,51,60,1,1,0.5,[],[-0.434118,-0.475333,-0.233529,-0.470167,-0.233529,-0.279,-0.434118,-0.284167],0],
["hulk-sheet0.png",65332,119,1,56,58,1,1,0.5,[],[-0.415714,-0.491724,-0.2275,-0.486379,-0.2275,-0.288621,-0.415714,-0.293966],0],["hulk-sheet0.png",65332,176,1,56,58,1,1,0.482759,[],[-0.364643,-0.482759,-0.170893,-0.482759,-0.170893,-0.283276,-0.364643,-0.288621],0],["hulk-sheet0.png",65332,213,119,41,59,1,1,0.508475,[],[-0.290244,-0.48339,-0.02561,-0.478136,-0.02561,-0.294238,-0.290244,-0.299492],0],["hulk-sheet1.png",11679,81,1,35,61,1,1,0.508197,[],[-0.368571,-0.487869,-0.040857,-0.492951,-0.040857,
-0.299836,-0.368571,-0.304918],0],["hulk-sheet1.png",11679,1,1,39,58,1,1,0.482759,[],[-0.352821,-0.482759,-0.066667,-0.482759,-0.066667,-0.288621,-0.352821,-0.293966],0],["hulk-sheet0.png",65332,1,61,52,61,1,1,0.508197,[],[-0.39,-0.487869,-0.175385,-0.487869,-0.175385,-0.299836,-0.39,-0.294754],0],["hulk-sheet0.png",65332,1,1,58,59,1,1,0.508475,[],[-0.353276,-0.499153,-0.166207,-0.493898,-0.166207,-0.299492,-0.353276,-0.304746],0],["hulk-sheet0.png",65332,107,119,52,59,1,1,0.508475,[],[-0.335,-0.499153,
-0.120385,-0.493898,-0.120385,-0.304746,-0.335,-0.299492],0],["hulk-sheet0.png",65332,1,184,40,60,1,1,0.516667,[],[-0.36125,-0.496,-0.06675,-0.496,-0.06675,-0.299667,-0.36125,-0.304834],0],["hulk-sheet0.png",65332,149,179,43,59,1,0.860465,0.491525,[],[-0.617209,-0.48339,-0.364884,-0.478136,-0.364884,-0.283728,-0.617209,-0.288983],0],["hulk-sheet0.png",65332,53,123,51,60,1,0.764706,0.5,[],[-0.552745,-0.475333,-0.34,-0.475333,-0.34,-0.279,-0.552745,-0.284167],0],["hulk-sheet0.png",65332,119,60,56,58,
1,0.732143,0.5,[],[-0.535357,-0.486379,-0.330536,-0.481034,-0.330536,-0.288621,-0.535357,-0.293966],0],["hulk-sheet0.png",65332,176,60,56,58,1,0.642857,0.482759,[],[-0.478036,-0.481034,-0.289821,-0.481034,-0.289821,-0.283276,-0.478036,-0.288621],0],["hulk-sheet0.png",65332,193,179,41,59,1,0.634146,0.508475,[],[-0.62,-0.493898,-0.332683,-0.493898,-0.332683,-0.288983,-0.619999,-0.294238],0],["hulk-sheet1.png",11679,1,60,35,61,1,0.828571,0.508197,[],[-0.817143,-0.498033,-0.498285,-0.492951,-0.498285,
-0.299836,-0.817143,-0.299836],0],["hulk-sheet1.png",11679,41,1,39,58,1,0.794872,0.482759,[],[-0.735897,-0.47569,-0.47359,-0.481034,-0.47359,-0.267242,-0.735897,-0.272587],0],["hulk-sheet0.png",65332,54,61,52,61,1,0.788462,0.508197,[],[-0.625577,-0.487869,-0.416924,-0.487869,-0.416924,-0.294754,-0.625577,-0.294754],0],["hulk-sheet0.png",65332,60,1,58,59,1,0.603448,0.508475,[],[-0.453793,-0.499153,-0.261379,-0.504407,-0.261379,-0.299492,-0.453793,-0.299492],0],["hulk-sheet0.png",65332,160,119,52,59,
1,0.673077,0.508475,[],[-0.574423,-0.493898,-0.353846,-0.499153,-0.353846,-0.294238,-0.574423,-0.299492],0],["hulk-sheet0.png",65332,42,184,40,60,1,0.725,0.516667,[],[-0.6675,-0.496,-0.404,-0.501167,-0.404,-0.289334,-0.6675,-0.2945],0]]]],[["Bullet",cr.behaviors.Bullet,0x7f357ca394bdf]],!1,!1,0x7462812962340,[],null],["t25",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",10,!1,1,0,!1,0xb944a549f681,[["chicharito-sheet1.png",8917,31,1,27,57,1,0.518519,0.491228,[],[0.190371,-0.27193,-0.113333,-0.272982,
-0.111111,-0.479825,0.179259,-0.479649],0],["chicharito-sheet1.png",8917,1,1,29,63,1,0.448276,0.492063,[],[0.211724,-0.246031,-0.0710339,-0.246984,-0.0689659,-0.45,0.201379,-0.449841],0],["chicharito-sheet0.png",18585,41,55,37,59,1,0.486486,0.491525,[],[0.138919,-0.262711,-0.0827025,-0.263728,-0.0810805,-0.463559,0.130812,-0.46339],0],["chicharito-sheet0.png",18585,1,53,39,56,1,0.487179,0.517857,[],[0.131794,-0.276786,-0.0784615,-0.277857,-0.0769225,-0.488393,0.124103,-0.488214],0],["chicharito-sheet0.png",
18585,51,1,44,53,1,0.545455,0.528302,[],[0.389545,-0.292453,0.157727,-0.293585,0.15909,-0.516038,0.382727,-0.515849],0],["chicharito-sheet0.png",18585,1,1,49,51,1,0.489796,0.529412,[],[0.349796,-0.303922,0.141633,-0.305098,0.142857,-0.529412,0.343673,-0.529412],0],["chicharito-sheet0.png",18585,96,1,31,63,1,0.483871,0.507937,[],[0.488387,-0.309524,0.159355,-0.310477,0.16129,-0.492064,0.47871,-0.492064],0],["chicharito-sheet0.png",18585,79,65,29,60,1,0.517241,0.5,[],[0.453104,-0.308333,0.10138,-0.309333,
0.103449,-0.489167,0.442759,-0.489],0],["chicharito-sheet1.png",8917,59,1,20,64,1,0.75,0.5,[],[0.207,-0.320312,-0.302999,-0.32125,-0.3,-0.472656,0.192,-0.474063],0]]]],[["Bullet",cr.behaviors.Bullet,8806511009304226]],!1,!1,504755821678949,[],null],["t26",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!0,1,0,!1,7938104881483597,[["giovanni-sheet0.png",62464,221,120,33,57,1,0.393939,0.508772,[],[-0.278182,-0.305789,-0.280303,-0.473684,0.0512126,-0.472631,0.0496966,-0.302631],0],["giovanni-sheet0.png",
62464,131,120,44,55,1,0.545455,0.509091,[],[-0.429698,-0.306108,-0.431819,-0.474003,-0.168485,-0.47295,-0.124546,-0.30295],0],["giovanni-sheet0.png",62464,193,60,43,59,1,0.534884,0.491525,[],[-0.256336,-0.288542,-0.258457,-0.456438,0.0265473,-0.455385,0.0308453,-0.289622],0],["giovanni-sheet0.png",62464,60,1,57,57,1,0.561404,0.508772,[],[-0.23512,-0.305789,-0.237242,-0.473684,-0.0109885,-0.472631,-0.0125045,-0.302631],0],["giovanni-sheet0.png",62464,99,60,46,59,1,0.608696,0.491525,[],[-0.275547,-0.288542,
-0.277669,-0.456438,-0.0331096,-0.455385,-0.0346246,-0.285384],0],["giovanni-sheet0.png",62464,45,118,42,59,1,0.52381,0.491525,[],[-0.312814,-0.288542,-0.314936,-0.456438,-0.0310386,-0.455385,-0.0325546,-0.285384],0],["giovanni-sheet0.png",62464,1,59,48,58,1,0.604167,0.5,[],[-0.259243,-0.297017,-0.261364,-0.464912,0.00765133,-0.463859,0.0061363,-0.293859],0],["giovanni-sheet0.png",62464,118,1,55,58,1,0.581818,0.517241,[],[-0.211515,-0.314258,-0.213636,-0.482154,0.0269699,-0.481101,0.0254548,-0.3111],
0],["giovanni-sheet0.png",62464,176,120,44,55,1,0.522727,0.509091,[],[-0.179697,-0.306108,-0.181818,-0.474003,0.0587878,-0.47295,0.0799997,-0.30295],0],["giovanni-sheet0.png",62464,85,180,39,55,1,0.666667,0.509091,[],[-0.0124477,-0.301563,-0.0145687,-0.474003,0.265664,-0.47295,0.264149,-0.30295],0],["giovanni-sheet1.png",8422,40,1,32,55,1,0.46875,0.472727,[],[-0.040493,-0.287926,-0.042614,-0.455821,0.351402,-0.454768,0.349886,-0.284768],0],["giovanni-sheet0.png",62464,1,178,41,55,1,0.463415,0.509091,
[],[0.0181964,-0.306108,0.0160754,-0.474003,0.250029,-0.47295,0.248514,-0.30295],0],["giovanni-sheet0.png",62464,131,176,44,55,1,0.545455,0.509091,[],[0.0930305,-0.306108,0.0909084,-0.474003,0.331514,-0.47295,0.329999,-0.30295],0],["giovanni-sheet0.png",62464,221,178,33,57,1,0.424242,0.508772,[],[0.115758,-0.305789,0.113637,-0.473684,0.475455,-0.472631,0.473939,-0.302631],0],["giovanni-sheet0.png",62464,1,118,43,59,1,0.534884,0.491525,[],[-0.0702887,-0.288542,-0.0724107,-0.456438,0.189337,-0.455385,
0.187822,-0.285384],0],["giovanni-sheet0.png",62464,1,1,58,57,1,0.482759,0.508772,[],[-0.0221736,-0.305789,-0.0242946,-0.473684,0.169289,-0.472631,0.167774,-0.302631],0],["giovanni-sheet0.png",62464,146,60,46,59,1,0.369565,0.491525,[],[0.0288008,-0.305491,0.0266798,-0.456438,0.271239,-0.455385,0.269723,-0.302334],0],["giovanni-sheet0.png",62464,88,120,42,59,1,0.547619,0.491525,[],[-0.0271,-0.288542,-0.0292211,-0.456438,0.230866,-0.455385,0.229351,-0.285384],0],["giovanni-sheet0.png",62464,174,1,55,
58,1,0.581818,0.517241,[],[-0.175151,-0.314258,-0.177273,-0.482154,0.0269699,-0.481101,0.0254548,-0.3111],0],["giovanni-sheet0.png",62464,50,59,48,58,1,0.604167,0.5,[],[-0.196743,-0.297017,-0.198864,-0.464912,0.0701513,-0.463859,0.0686363,-0.293859],0],["giovanni-sheet0.png",62464,176,176,44,55,1,0.522727,0.509091,[],[-0.134242,-0.306108,-0.136364,-0.474003,0.104243,-0.47295,0.102727,-0.30295],0],["giovanni-sheet1.png",8422,1,1,38,55,1,0.657895,0.509091,[],[-0.568453,-0.287926,-0.570574,-0.474003,
-0.318007,-0.47295,-0.306364,-0.289314],0],["giovanni-sheet1.png",8422,73,1,32,55,1,0.46875,0.472727,[],[-0.290493,-0.287926,-0.292614,-0.455821,0.101402,-0.454768,0.099886,-0.284768],0],["giovanni-sheet0.png",62464,43,178,41,55,1,0.463415,0.509091,[],[-0.201316,-0.306108,-0.203437,-0.474003,0.0305174,-0.47295,0.0472954,-0.30295],0]]]],[["Bullet",cr.behaviors.Bullet,6280232582437357]],!1,!1,0xc153d3404b089,[],null],["t27",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",3,!0,1,0,!1,9281855313036692,
[["hermoso-sheet1.png",19172,81,64,22,61,1,0.454545,0.409836,[],[-0.151363,-0.181639,-0.147727,-0.402557,0.198183,-0.403443,0.211182,-0.184426],0],["hermoso-sheet0.png",12224,83,65,28,61,1,0.428571,0.409836,[],[-0.118928,-0.181639,-0.116071,-0.402557,0.155715,-0.403443,0.165929,-0.184426],0],["hermoso-sheet1.png",19172,28,1,27,62,1,0.444444,0.403226,[],[-0.123333,-0.17871,-0.12037,-0.396065,0.161482,-0.396936,0.172075,-0.181452],0],["hermoso-sheet1.png",19172,104,64,22,60,1,0.545455,0.4,[],[-0.151364,
-0.184667,-0.147728,-0.4,0.198182,-0.4,0.211182,-0.1875],0],["hermoso-sheet1.png",19172,56,1,27,61,1,0.444444,0.393443,[],[-0.123333,-0.18164,-0.12037,-0.393443,0.161482,-0.393443,0.172075,-0.184426],0],["hermoso-sheet0.png",12224,42,1,40,71,1,0.525,0.478873,[],[-0.08325,-0.156056,-0.08125,-0.345859,0.109,-0.34662,0.11615,-0.15845],0],["hermoso-sheet1.png",19172,84,1,24,62,1,0.541667,0.403226,[],[-0.180417,-0.210968,-0.177084,-0.396065,0.181667,-0.396936,0.193583,-0.21371],0],["hermoso-sheet1.png",
19172,1,1,26,65,1,0.576923,0.384615,[],[-0.166538,-0.20123,-0.163461,-0.377785,0.167693,-0.378615,0.178693,-0.203846],0],["hermoso-sheet1.png",19172,56,63,24,62,1,0.458333,0.403226,[],[-0.138749,-0.210968,-0.135416,-0.396065,0.181668,-0.396936,0.193584,-0.21371],0],["hermoso-sheet0.png",12224,83,1,29,63,1,0.448276,0.396825,[],[-0.0803449,-0.207619,-0.0775859,-0.389778,0.219311,-0.390635,0.229173,-0.210317],0],["hermoso-sheet0.png",12224,1,1,40,73,1,0.425,0.465753,[],[-0.03325,-0.179178,-0.03125,-0.336383,
0.184001,-0.337123,0.19115,-0.181506],0],["hermoso-sheet1.png",19172,28,64,24,62,1,0.541667,0.403226,[],[-0.180417,-0.210968,-0.177084,-0.396065,0.14,-0.396936,0.151916,-0.21371],0]]]],[["Bullet",cr.behaviors.Bullet,0x404034cdcac2a]],!1,!1,5177590856193557,[],null],["t28",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",3,!0,1,0,!1,5376026296267191,[["layun-sheet0.png",9295,81,61,14,59,1,0.357143,0.423729,[],[-0.226429,-0.24017,-0.232143,-0.419559,0.471428,-0.421186,0.486429,-0.241525],0],["layun-sheet0.png",
9295,107,1,19,59,1,0.315789,0.423729,[],[-0.166842,-0.24017,-0.171052,-0.419559,0.347369,-0.421186,0.358422,-0.241525],0],["layun-sheet0.png",9295,55,1,25,59,1,0.52,0.423729,[],[-0.1268,-0.24017,-0.13,-0.419559,0.264,-0.421186,0.2724,-0.241525],0],["layun-sheet0.png",9295,1,60,19,59,1,0.315789,0.423729,[],[-0.166842,-0.24017,-0.171052,-0.419559,0.347369,-0.421186,0.358422,-0.241525],0],["layun-sheet0.png",9295,1,1,26,58,1,0.5,0.431034,[],[-0.121923,-0.24431,-0.125,-0.426793,0.253846,-0.428448,0.261923,
-0.245689],0],["layun-sheet0.png",9295,21,60,19,59,1,0.315789,0.423729,[],[-0.166842,-0.24017,-0.171052,-0.419559,0.347369,-0.421186,0.358422,-0.241525],0],["layun-sheet0.png",9295,81,1,25,59,1,0.52,0.423729,[],[-0.1268,-0.24017,-0.13,-0.419559,0.264,-0.421186,0.2724,-0.241525],0],["layun-sheet0.png",9295,41,61,19,59,1,0.315789,0.423729,[],[-0.166842,-0.24017,-0.171052,-0.419559,0.347369,-0.421186,0.358422,-0.241525],0],["layun-sheet0.png",9295,28,1,26,58,1,0.5,0.431034,[],[-0.121923,-0.24431,-0.125,
-0.426793,0.253846,-0.428448,0.261923,-0.245689],0],["layun-sheet0.png",9295,61,61,19,59,1,0.315789,0.423729,[],[-0.166842,-0.24017,-0.171052,-0.419559,0.347369,-0.421186,0.358422,-0.241525],0]]]],[],!1,!1,664566718125715,[],null],["t29",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!0,1,0,!1,9318455688329228,[["marquez-sheet0.png",33944,233,58,20,58,1,0.5,0.517241,[],[0.219,-0.337284,-0.208,-0.339913,-0.208,-0.497672,0.219,-0.495043],0],["marquez-sheet0.png",33944,203,113,28,56,1,0.5,0.5,[],[0.405178,
-0.305759,0.089286,-0.308482,0.089286,-0.477321,0.405178,-0.480045],0],["marquez-sheet0.png",33944,163,1,37,56,1,0.486486,0.5,[],[0.332703,-0.322098,0.101892,-0.324821,0.101892,-0.482768,0.332703,-0.485491],0],["marquez-sheet0.png",33944,1,1,40,55,1,0.5,0.509091,[],[0.37725,-0.322409,0.156125,-0.325182,0.156125,-0.497091,0.37725,-0.499864],0],["marquez-sheet0.png",33944,77,112,31,56,1,0.483871,0.5,[],[0.327369,-0.312815,0.066216,-0.313186,0.066217,-0.475093,0.32737,-0.477445],0],["marquez-sheet0.png",
33944,77,57,38,54,1,0.5,0.518519,[],[0.348947,-0.334028,0.116184,-0.336852,0.116184,-0.500648,0.348947,-0.503472],0],["marquez-sheet0.png",33944,1,114,28,56,1,0.5,0.5,[],[0.394285,-0.311205,0.100178,-0.313929,0.100179,-0.477321,0.394286,-0.474598],0],["marquez-sheet0.png",33944,201,1,37,56,1,0.486486,0.5,[],[0.324458,-0.322098,0.0936485,-0.324821,0.0936485,-0.482768,0.324459,-0.485491],0],["marquez-sheet0.png",33944,42,1,40,55,1,0.5,0.509091,[],[0.369624,-0.322409,0.156125,-0.325182,0.156125,-0.491545,
0.369625,-0.488773],0],["marquez-sheet0.png",33944,109,112,31,56,1,0.483871,0.5,[],[0.338064,-0.311205,0.052742,-0.313929,0.052742,-0.471875,0.338064,-0.474598],0],["marquez-sheet0.png",33944,116,57,38,54,1,0.5,0.518519,[],[0.356973,-0.334028,0.116184,-0.336852,0.116184,-0.506296,0.356973,-0.503472],0],["marquez-sheet0.png",33944,232,117,20,58,1,0.5,0.517241,[],[0.201249,-0.337284,-0.22575,-0.339913,-0.22575,-0.495043,0.20125,-0.495043],0],["marquez-sheet0.png",33944,30,114,28,56,1,0.5,0.5,[],[-0.117679,
-0.311205,-0.411785,-0.313929,-0.411785,-0.471875,-0.117678,-0.474598],0],["marquez-sheet0.png",33944,1,57,37,56,1,0.513514,0.5,[],[-0.120676,-0.322098,-0.343243,-0.319375,-0.343243,-0.482768,-0.120676,-0.485491],0],["marquez-sheet0.png",33944,83,1,39,55,1,0.487179,0.509091,[],[-0.158333,-0.327955,-0.377307,-0.325182,-0.377307,-0.491545,-0.158333,-0.494318],0],["marquez-sheet0.png",33944,141,113,30,56,1,0.5,0.5,[],[-0.086167,-0.311205,-0.360667,-0.308482,-0.360666,-0.477321,-0.086167,-0.480045],0],
["marquez-sheet0.png",33944,155,58,38,54,1,0.5,0.518519,[],[-0.140658,-0.339675,-0.373421,-0.336852,-0.373421,-0.500648,-0.140658,-0.503472],0],["marquez-sheet0.png",33944,59,169,28,56,1,0.5,0.5,[],[-0.117679,-0.311205,-0.411785,-0.313929,-0.411785,-0.471875,-0.117678,-0.474598],0],["marquez-sheet0.png",33944,39,57,37,56,1,0.513514,0.5,[],[-0.120676,-0.327545,-0.343243,-0.324821,-0.343243,-0.482768,-0.120676,-0.480045],0],["marquez-sheet0.png",33944,123,1,39,55,1,0.487179,0.509091,[],[-0.158333,-0.325182,
-0.385127,-0.319636,-0.385127,-0.491545,-0.158333,-0.494318],0],["marquez-sheet0.png",33944,172,113,30,56,1,0.5,0.5,[],[-0.086167,-0.311205,-0.360667,-0.308482,-0.360666,-0.482768,-0.086167,-0.485491],0],["marquez-sheet0.png",33944,194,58,38,54,1,0.5,0.518519,[],[-0.140658,-0.339675,-0.373421,-0.336852,-0.373421,-0.500648,-0.140658,-0.497824],0]]]],[["Bullet",cr.behaviors.Bullet,0xcbcace353b001]],!1,!1,0xbf15d51b3d459,[],null],["t30",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",10,!1,1,0,!1,0x64c1c9302d5d4,
[["lahm-sheet0.png",36682,207,74,42,61,1,0.404762,0.508197,[],[-0.144524,-0.292131,-0.143095,-0.486475,0.0765471,-0.487131,0.0759521,-0.290984],0],["lahm-sheet0.png",36682,166,74,40,65,1,0.5,0.507692,[],[-0.05175,-0.320307,-0.05025,-0.487308,0.180375,-0.487923,0.17975,-0.31923],0],["lahm-sheet0.png",36682,170,1,46,72,1,0.478261,0.5,[],[0.0202171,-0.330833,0.0215221,-0.481597,0.200326,-0.482153,0.199782,-0.329861],0],["lahm-sheet0.png",36682,60,1,55,73,1,0.4,0.506849,[],[0.016909,-0.326301,0.018,-0.488699,
0.167545,-0.489247,0.167091,-0.325342],0],["lahm-sheet0.png",36682,1,1,58,71,1,0.465517,0.507042,[],[-0.0184483,-0.321408,-0.0174133,-0.48838,0.124397,-0.488944,0.123966,-0.320422],0],["lahm-sheet0.png",36682,116,1,53,68,1,0.528302,0.514706,[],[-0.0013209,-0.320882,-1.88887E-4,-0.495221,0.155,-0.495809,0.154528,-0.319853],0],["lahm-sheet0.png",36682,116,70,49,67,1,0.571429,0.507463,[],[-0.0014286,-0.325672,-2.03609E-4,-0.487687,0.147244,-0.488284,0.146734,-0.324627],0],["lahm-sheet0.png",36682,1,
73,44,70,1,0.568182,0.485714,[],[-0.0243178,-0.311714,-0.0229548,-0.466786,0.163977,-0.467357,0.163409,-0.310714],0],["lahm-sheet0.png",36682,217,1,38,70,1,0.578947,0.5,[],[-0.0281584,-0.311714,-0.0265784,-0.481071,0.216184,-0.481643,0.215526,-0.310714],0],["lahm-sheet0.png",36682,46,75,33,67,1,0.484848,0.492537,[],[-0.00212151,-0.295821,-3.02494E-4,-0.487687,0.279243,-0.488284,0.278485,-0.294776],0]]]],[],!1,!1,7641848353427969,[],null],["t31",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!0,1,
0,!1,0x61b59db05a6f,[["muller-sheet0.png",51002,106,1,49,62,1,0.55102,0.516129,[],[-0.0991834,-0.308226,-0.0969384,-0.508226,0.10898,-0.509516,0.10949,-0.306452],0],["muller-sheet0.png",51002,1,1,52,66,1,0.557692,0.515152,[],[-0.0934613,-0.289546,-0.0913463,-0.477424,0.121923,-0.478637,0.122404,-0.287879],0],["muller-sheet0.png",51002,216,133,32,63,1,0.53125,0.492063,[],[-0.120625,-0.287461,-0.117188,-0.468413,0.260625,-0.469683,0.261406,-0.285715],0],["muller-sheet0.png",51002,210,1,45,65,1,0.577778,
0.507692,[],[-0.0191108,-0.324769,-0.0166668,-0.484769,0.229778,-0.486,0.230333,-0.323077],0],["muller-sheet0.png",51002,137,124,44,59,1,0.454545,0.457627,[],[0.00318152,-0.256102,0.00568154,-0.449322,0.235001,-0.450678,0.235569,-0.254237],0],["muller-sheet0.png",51002,106,64,51,59,1,0.529412,0.457627,[],[-0.0756858,-0.239152,-0.0735298,-0.432373,0.163529,-0.433729,0.164019,-0.237288],0],["muller-sheet0.png",51002,47,68,44,60,1,0.363636,0.45,[],[-0.269546,-0.235167,-0.267046,-0.425167,-0.0150004,
-0.4265,-0.0144314,-0.233334],0],["muller-sheet0.png",51002,1,128,44,59,1,0.363636,0.542373,[],[-0.110454,-0.323898,-0.107954,-0.534068,0.121364,-0.535424,0.121932,-0.322034],0],["muller-sheet0.png",51002,156,1,49,62,1,0.55102,0.516129,[],[-0.221632,-0.308226,-0.219388,-0.492097,0.00693864,-0.493387,0.00744861,-0.306452],0],["muller-sheet0.png",51002,54,1,51,66,1,0.568627,0.515152,[],[-0.271764,-0.319849,-0.269608,-0.477424,-0.0521575,-0.478637,-0.0516665,-0.318182],0],["muller-sheet0.png",51002,
182,133,33,63,1,0.515152,0.492063,[],[-0.298788,-0.303333,-0.295455,-0.468413,0.0406065,-0.469683,0.0413635,-0.301587],0],["muller-sheet0.png",51002,210,67,45,65,1,0.577778,0.507692,[],[-0.374667,-0.324769,-0.372223,-0.484769,-0.148,-0.486,-0.147445,-0.323077],0],["muller-sheet0.png",51002,46,129,44,59,1,0.454545,0.457627,[],[-0.178636,-0.256102,-0.176136,-0.449322,0.0759095,-0.450678,0.0764776,-0.254237],0],["muller-sheet0.png",51002,158,64,51,59,1,0.529412,0.457627,[],[-0.212941,-0.239152,-0.210785,
-0.432373,0.00666618,-0.433729,0.00715721,-0.237288],0],["muller-sheet0.png",51002,92,124,44,60,1,0.363636,0.45,[],[0.27591,-0.235167,0.27841,-0.425167,0.530455,-0.4265,0.531024,-0.233334],0],["muller-sheet0.png",51002,1,68,45,59,1,0.355556,0.542373,[],[0.158667,-0.340848,0.161111,-0.534068,0.385333,-0.535424,0.385889,-0.343221],0]]]],[["Bullet",cr.behaviors.Bullet,9352308735740208]],!1,!1,9840182735111184,[],null],["t32",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!0,1,0,!1,0x421f89d84ad2f,[["ozil-sheet1.png",
23737,150,1,49,53,1,0.510204,0.566038,[],[0.137755,-0.344152,0.135918,-0.545472,0.34551,-0.542453,0.345102,-0.341321],0],["ozil-sheet1.png",23737,101,1,48,55,1,0.5,0.6,[],[0.127126,-0.378114,0.125289,-0.579434,0.334881,-0.580961,0.334473,-0.375283],0],["ozil-sheet1.png",23737,200,1,43,59,1,0.511628,0.627119,[],[0.0898201,-0.405233,0.0879831,-0.606553,0.32083,-0.603534,0.320422,-0.402402],0],["ozil-sheet0.png",42641,154,168,36,64,1,0.5,0.640625,[],[0.120181,-0.391395,0.118345,-0.557559,0.355714,-0.55454,
0.355306,-0.384658],0],["ozil-sheet0.png",42641,206,1,46,75,1,0.5,0.626667,[],[0.147959,-0.231447,0.146122,-0.379434,0.355714,-0.376415,0.360741,-0.23195],0],["ozil-sheet0.png",42641,145,1,60,88,1,0.5,0.738636,[],[-0.139541,-0.258227,-0.137211,-0.354434,0.068215,-0.354256,0.071973,-0.252556],0],["ozil-sheet0.png",42641,1,1,71,87,1,0.507042,0.747126,[],[-0.0985202,-0.341332,-0.100356,-0.462192,0.0669818,-0.462047,0.0665738,-0.341375],0],["ozil-sheet0.png",42641,62,89,65,77,1,0.492308,0.701299,[],[-0.136657,
-0.401491,-0.138493,-0.537876,0.0249453,-0.538104,0.0206903,-0.401907],0],["ozil-sheet0.png",42641,194,90,56,63,1,0.446429,0.634921,[],[-0.102041,-0.428908,-0.103878,-0.614355,0.0700004,-0.611336,0.0695914,-0.426077],0],["ozil-sheet0.png",42641,109,168,44,66,1,0.363636,0.651515,[],[-0.19295,-0.475083,-0.194786,-0.630949,0.0545786,-0.631718,0.0598516,-0.476041],0],["ozil-sheet1.png",23737,51,1,49,54,1,0.428571,0.592593,[],[-0.290816,-0.370707,-0.292652,-0.572026,-0.0830614,-0.569008,-0.0834694,-0.367876],
0],["ozil-sheet1.png",23737,1,1,49,55,1,0.44898,0.6,[],[-0.270408,-0.39175,-0.272245,-0.579434,-0.0830606,-0.580961,-0.0834696,-0.393465],0],["ozil-sheet1.png",23737,150,55,43,59,1,0.372093,0.627119,[],[-0.18925,-0.422182,-0.191087,-0.606553,0.041761,-0.603534,0.041352,-0.423589],0],["ozil-sheet1.png",23737,51,56,35,64,1,0.371429,0.640625,[],[-0.244898,-0.414832,-0.239592,-0.557559,-0.00142857,-0.558446,-0.00183657,-0.415908],0],["ozil-sheet0.png",42641,62,167,46,75,1,0.391304,0.706667,[],[-0.243345,
-0.321447,-0.245181,-0.459434,-0.0355904,-0.456415,-0.0359983,-0.32195],0],["ozil-sheet0.png",42641,1,89,60,88,1,0.45,0.75,[],[-0.022874,-0.249705,-0.020544,-0.365798,0.172381,-0.36562,0.171973,-0.252556],0],["ozil-sheet0.png",42641,73,1,71,87,1,0.507042,0.747126,[],[-0.0844352,-0.341332,-0.0862722,-0.462192,0.0810658,-0.462047,0.0806578,-0.341375],0],["ozil-sheet0.png",42641,128,90,65,77,1,0.492308,0.701299,[],[-0.0135797,-0.401491,-0.0154157,-0.537876,0.148022,-0.538104,0.147613,-0.401907],0],["ozil-sheet0.png",
42641,194,154,56,63,1,0.446429,0.634921,[],[0.0229594,-0.440812,0.0211224,-0.614355,0.212857,-0.611336,0.212448,-0.44195],0],["ozil-sheet0.png",42641,1,178,44,66,1,0.363636,0.651515,[],[0.216141,-0.459932,0.214305,-0.630949,0.469351,-0.62793,0.468943,-0.457101],0]]]],[["Bullet",cr.behaviors.Bullet,0x3baeb5ac90a21]],!1,!1,858397881581735,[],null],["t33",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",10,!1,1,0,!1,7857134011102883,[["reus-sheet1.png",15512,1,1,29,63,1,0.482759,0.507937,[],[-0.176035,
-0.342937,-0.172414,-0.485159,0.0898284,-0.485794,0.0872414,-0.343255],0],["reus-sheet1.png",15512,31,1,25,68,1,0.6,0.5,[],[-0.2442,-0.317721,-0.24,-0.478897,0.1042,-0.479485,0.1012,-0.318015],0],["reus-sheet0.png",15719,90,1,29,65,1,0.448276,0.507692,[],[-0.141552,-0.332384,-0.137931,-0.485615,0.124311,-0.486231,0.121724,-0.332692],0],["reus-sheet0.png",15719,50,1,39,66,1,0.410256,0.5,[],[0.0229486,-0.327349,0.0256416,-0.478258,0.246283,-0.478864,0.244359,-0.327652],0],["reus-sheet0.png",15719,1,
1,48,62,1,0.375,0.5,[],[0.143646,-0.31621,0.145834,-0.476855,0.325105,-0.4775,0.323542,-0.316532],0],["reus-sheet0.png",15719,1,68,57,40,1,0.438596,0.525,[],[0.208685,-0.240125,0.210527,-0.489125,0.379036,-0.490125,0.37772,-0.240625],0],["reus-sheet1.png",15512,57,1,56,29,1,0.535714,0.448276,[],[0.265983,0.151552,0.267858,-0.226379,0.457233,-0.227758,0.455893,0.150862],0],["reus-sheet0.png",15719,90,67,34,48,1,0.5,0.625,[],[-0.0325,-0.366771,-0.029411,-0.595104,0.223677,-0.595937,0.221471,-0.367188],
0],["reus-sheet1.png",15512,81,31,22,65,1,0.5,0.553846,[],[-0.050227,-0.363154,-0.045454,-0.531769,0.345683,-0.532385,0.342273,-0.363462],0],["reus-sheet1.png",15512,57,31,23,66,1,0.478261,0.530303,[],[-0.0480429,-0.327349,-0.0434779,-0.508561,0.287174,-0.509167,0.283913,-0.327652],0]]]],[["Bullet",cr.behaviors.Bullet,0x84f5a0ba4a55b]],!1,!1,7740589612611756,[],null],["t34",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!0,1,0,!1,0x825a404d3fb86,[["schweinsteiger-sheet0.png",24431,1,1,60,75,1,0.5,
0.506667,[],[-0.11125,-0.210667,-0.110417,-0.352667,0.043333,-0.353,0.04375,-0.21],0],["schweinsteiger-sheet0.png",24431,62,1,60,75,1,0.5,0.506667,[],[-0.11125,-0.210667,-0.110417,-0.352667,0.043333,-0.353,0.04375,-0.21],0],["schweinsteiger-sheet0.png",24431,123,1,60,75,1,0.5,0.506667,[],[-0.11125,-0.237334,-0.110417,-0.379334,0.043333,-0.379667,0.04375,-0.236667],0],["schweinsteiger-sheet0.png",24431,184,1,60,75,1,0.5,0.506667,[],[-0.127917,-0.237334,-0.127083,-0.379334,0.026666,-0.379667,0.027083,
-0.236667],0],["schweinsteiger-sheet0.png",24431,1,77,60,75,1,0.5,0.506667,[],[-0.127917,-0.237334,-0.127083,-0.379334,0.043333,-0.379667,0.04375,-0.236667],0],["schweinsteiger-sheet0.png",24431,62,77,60,75,1,0.5,0.506667,[],[-0.11125,-0.210667,-0.110417,-0.352667,0.043333,-0.353,0.04375,-0.21],0],["schweinsteiger-sheet0.png",24431,123,77,60,75,1,0.5,0.506667,[],[-0.11125,-0.210667,-0.110417,-0.352667,0.043333,-0.353,0.04375,-0.21],0],["schweinsteiger-sheet0.png",24431,184,77,60,75,1,0.5,0.506667,
[],[-0.11125,-0.237334,-0.110417,-0.379334,0.043333,-0.379667,0.04375,-0.236667],0],["schweinsteiger-sheet0.png",24431,1,153,60,75,1,0.5,0.506667,[],[-0.127917,-0.224,-0.127083,-0.366,0.026666,-0.366334,0.027083,-0.223333],0],["schweinsteiger-sheet0.png",24431,62,153,60,75,1,0.5,0.506667,[],[-0.127917,-0.237334,-0.127083,-0.366,0.026666,-0.366334,0.027083,-0.236667],0],["schweinsteiger-sheet0.png",24431,123,153,60,75,1,0.5,0.506667,[],[-0.127917,-0.237334,-0.127083,-0.366,0.026666,-0.366334,0.027083,
-0.236667],0],["schweinsteiger-sheet0.png",24431,184,153,60,75,1,0.5,0.506667,[],[-0.127917,-0.237334,-0.127083,-0.366,0.026666,-0.366334,0.027083,-0.236667],0],["schweinsteiger-sheet1.png",19828,1,1,60,75,1,0.5,0.506667,[],[-0.11125,-0.237334,-0.110417,-0.379334,0.043333,-0.379667,0.04375,-0.236667],0],["schweinsteiger-sheet1.png",19828,62,1,60,75,1,0.5,0.506667,[],[-0.11125,-0.210667,-0.110417,-0.352667,0.043333,-0.353,0.04375,-0.21],0],["schweinsteiger-sheet1.png",19828,123,1,60,75,1,0.5,0.506667,
[],[-0.11125,-0.210667,-0.110417,-0.352667,0.043333,-0.353,0.04375,-0.21],0],["schweinsteiger-sheet1.png",19828,184,1,60,75,1,0.5,0.506667,[],[-0.127917,-0.237334,-0.127083,-0.366,0.043333,-0.366334,0.04375,-0.236667],0],["schweinsteiger-sheet1.png",19828,1,77,60,75,1,0.5,0.506667,[],[-0.127917,-0.237334,-0.127083,-0.366,0.026666,-0.366334,0.027083,-0.236667],0],["schweinsteiger-sheet1.png",19828,62,77,60,75,1,0.5,0.506667,[],[-0.11125,-0.237334,-0.110417,-0.379334,0.043333,-0.379667,0.04375,-0.236667],
0],["schweinsteiger-sheet1.png",19828,123,77,60,75,1,0.5,0.506667,[],[-0.11125,-0.210667,-0.110417,-0.352667,0.043333,-0.353,0.04375,-0.21],0],["schweinsteiger-sheet1.png",19828,184,77,60,75,1,0.5,0.506667,[],[-0.11125,-0.210667,-0.110417,-0.352667,0.043333,-0.353,0.04375,-0.21],0]]]],[["Bullet",cr.behaviors.Bullet,9618539152719128]],!1,!1,5052621960524722,[],null],["t35",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!0,1,0,!1,7936702524537653,[["balotelli-sheet1.png",14402,116,1,26,66,1,0.538462,
0.5,[],[-0.0913456,-0.301136,-0.0865386,-0.496212,0.263461,-0.497727,0.259615,-0.30303],0],["balotelli-sheet0.png",60910,44,65,41,62,1,0.512195,0.467742,[],[0.0396339,-0.272178,0.0426829,-0.447581,0.264634,-0.449194,0.262195,-0.274194],0],["balotelli-sheet0.png",60910,86,65,38,59,1,0.5,0.474576,[],[0.016447,-0.269068,0.019737,-0.45339,0.25921,-0.455085,0.256579,-0.271186],0],["balotelli-sheet0.png",60910,1,1,51,60,1,0.490196,0.483333,[],[0.0710789,-0.297916,0.0735299,-0.479167,0.251961,-0.480833,
0.25,-0.3],0],["balotelli-sheet0.png",60910,197,66,33,66,1,0.484848,0.484848,[],[0.0492425,-0.301136,0.0530305,-0.450758,0.298485,-0.452273,0.295455,-0.30303],0],["balotelli-sheet0.png",60910,86,125,32,65,1,0.3125,0.492308,[],[-0.074219,-0.30577,-0.070312,-0.473077,0.214062,-0.474615,0.210937,-0.307693],0],["balotelli-sheet0.png",60910,193,1,42,64,1,0.47619,0.5,[],[-0.151785,-0.310547,-0.148809,-0.480469,0.0440475,-0.482031,0.0416665,-0.3125],0],["balotelli-sheet0.png",60910,1,187,28,68,1,0.464286,
0.5,[],[-0.191965,-0.321691,-0.1875,-0.481618,0.137499,-0.483088,0.133928,-0.32353],0],["balotelli-sheet1.png",14402,30,1,29,65,1,0.551724,0.523077,[],[-0.116379,-0.336539,-0.112069,-0.503846,0.167241,-0.505385,0.163793,-0.338462],0],["balotelli-sheet0.png",60910,1,62,42,64,1,0.47619,0.5,[],[-0.151785,-0.310547,-0.148809,-0.480469,0.0440475,-0.482031,0.0416665,-0.3125],0],["balotelli-sheet1.png",14402,1,1,28,68,1,0.464286,0.5,[],[-0.191965,-0.321691,-0.1875,-0.481618,0.137499,-0.483088,0.133928,-0.32353],
0],["balotelli-sheet0.png",60910,185,133,33,61,1,0.545455,0.52459,[],[-0.162879,-0.32582,-0.159091,-0.504098,0.116666,-0.505738,0.113635,-0.327869],0],["balotelli-sheet0.png",60910,1,127,35,59,1,0.542857,0.525424,[],[-0.153571,-0.319916,-0.15,-0.504237,0.11,-0.505932,0.107143,-0.322034],0],["balotelli-sheet0.png",60910,53,1,46,63,1,0.413043,0.492063,[],[-0.160326,-0.315476,-0.157608,-0.472222,0.0184775,-0.473809,0.0163035,-0.31746],0],["balotelli-sheet0.png",60910,125,66,35,64,1,0.457143,0.5,[],[-0.153572,
-0.310547,-0.15,-0.480469,0.109999,-0.482031,0.107142,-0.3125],0],["balotelli-sheet0.png",60910,161,66,35,64,1,0.457143,0.5,[],[-0.153572,-0.310547,-0.15,-0.480469,0.109999,-0.482031,0.107142,-0.3125],0],["balotelli-sheet0.png",60910,100,1,46,63,1,0.413043,0.492063,[],[-0.160326,-0.299603,-0.157608,-0.472222,0.0184775,-0.473809,0.0163035,-0.301587],0],["balotelli-sheet0.png",60910,147,1,45,64,1,0.355556,0.5,[],[-0.119445,-0.294922,-0.116667,-0.480469,0.0855554,-0.482031,0.0833334,-0.296875],0],["balotelli-sheet0.png",
60910,219,133,31,63,1,0.516129,0.492063,[],[0.020161,-0.299603,0.024194,-0.472222,0.317742,-0.473809,0.314516,-0.301587],0],["balotelli-sheet0.png",60910,37,128,32,63,1,0.59375,0.492063,[],[0.050781,-0.299603,0.054688,-0.472222,0.339063,-0.473809,0.335938,-0.301587],0],["balotelli-sheet1.png",14402,60,1,27,66,1,0.592593,0.5,[],[-0.199074,-0.301136,-0.194445,-0.481061,0.142592,-0.482576,0.138888,-0.30303],0],["balotelli-sheet0.png",60910,119,131,32,63,1,0.59375,0.492063,[],[0.050781,-0.299603,0.054688,
-0.472222,0.339063,-0.473809,0.335938,-0.301587],0],["balotelli-sheet1.png",14402,88,1,27,66,1,0.592593,0.5,[],[-0.199074,-0.301136,-0.194445,-0.481061,0.142592,-0.482576,0.138888,-0.30303],0],["balotelli-sheet0.png",60910,152,131,32,63,1,0.59375,0.492063,[],[0.050781,-0.299603,0.054688,-0.472222,0.339063,-0.473809,0.335938,-0.301587],0]]]],[["Bullet",cr.behaviors.Bullet,6972943434187614]],!1,!1,9925427050888484,[],null],["t36",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!0,1,0,!1,7805351992127505,
[["derossi-sheet2.png",4449,1,1,30,62,1,0.466667,0.483871,[],[-0.166668,-0.282258,-0.166666,-0.468548,0.158333,-0.469758,0.161667,-0.282258],0],["derossi-sheet1.png",8573,73,1,33,61,1,0.454545,0.491803,[],[-0.151516,-0.286885,-0.151513,-0.476229,0.14394,-0.477459,0.146971,-0.286885],0],["derossi-sheet0.png",8825,1,1,43,61,1,0.348837,0.491803,[],[-0.11628,-0.286885,-0.116278,-0.476229,0.110465,-0.477459,0.112791,-0.286885],0],["derossi-sheet0.png",8825,89,1,35,62,1,0.514286,0.483871,[],[-0.142858,
-0.282258,-0.142856,-0.468548,0.135714,-0.469758,0.138572,-0.282258],0],["derossi-sheet2.png",4449,32,1,30,62,1,0.466667,0.483871,[],[-0.166668,-0.282258,-0.166666,-0.468548,0.158333,-0.469758,0.161667,-0.282258],0],["derossi-sheet1.png",8573,73,63,33,61,1,0.454545,0.491803,[],[-0.151516,-0.286885,-0.151513,-0.476229,0.14394,-0.477459,0.146971,-0.286885],0],["derossi-sheet0.png",8825,45,1,43,61,1,0.348837,0.491803,[],[-0.11628,-0.286885,-0.116278,-0.476229,0.110465,-0.477459,0.112791,-0.286885],0],
["derossi-sheet0.png",8825,89,64,35,62,1,0.514286,0.483871,[],[-0.142858,-0.282258,-0.142856,-0.468548,0.135714,-0.469758,0.138572,-0.282258],0],["derossi-sheet2.png",4449,63,1,30,62,1,0.466667,0.483871,[],[-0.166668,-0.282258,-0.166666,-0.468548,0.158333,-0.469758,0.161667,-0.282258],0],["derossi-sheet1.png",8573,1,1,35,62,1,0.514286,0.483871,[],[-0.142858,-0.282258,-0.142856,-0.468548,0.135714,-0.469758,0.138572,-0.282258],0],["derossi-sheet0.png",8825,1,63,43,61,1,0.348837,0.491803,[],[-0.11628,
-0.286885,-0.116278,-0.476229,0.110465,-0.477459,0.112791,-0.286885],0],["derossi-sheet1.png",8573,1,64,33,61,1,0.454545,0.491803,[],[-0.151516,-0.286885,-0.151513,-0.476229,0.14394,-0.477459,0.146971,-0.286885],0],["derossi-sheet2.png",4449,94,1,30,62,1,0.466667,0.483871,[],[-0.166668,-0.282258,-0.166666,-0.468548,0.158333,-0.469758,0.161667,-0.282258],0],["derossi-sheet1.png",8573,37,1,35,62,1,0.514286,0.483871,[],[-0.142858,-0.282258,-0.142856,-0.468548,0.135714,-0.469758,0.138572,-0.282258],0],
["derossi-sheet0.png",8825,45,63,43,61,1,0.348837,0.491803,[],[-0.11628,-0.286885,-0.116278,-0.476229,0.110465,-0.477459,0.112791,-0.286885],0],["derossi-sheet1.png",8573,35,64,33,61,1,0.454545,0.491803,[],[-0.151516,-0.286885,-0.151513,-0.476229,0.14394,-0.477459,0.146971,-0.286885],0]]]],[["Bullet",cr.behaviors.Bullet,875939345672472]],!1,!1,0x4a22775a66d60,[],null],["t37",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!0,1,0,!1,599614295566208,[["gilardino-sheet0.png",50992,46,117,43,59,1,0.488372,
0.491525,[],[0.0505819,-0.285169,0.0494189,-0.463136,0.288954,-0.462712,0.287791,-0.283898],0],["gilardino-sheet0.png",50992,46,60,46,56,1,0.5,0.5,[],[0.090762,-0.300446,0.089674,-0.487946,0.313587,-0.4875,0.3125,-0.299107],0],["gilardino-sheet0.png",50992,1,1,48,58,1,0.5,0.5,[],[0.128646,-0.290086,0.127604,-0.471121,0.342187,-0.47069,0.341146,-0.288793],0],["gilardino-sheet0.png",50992,207,120,33,59,1,0.484848,0.491525,[],[0.0659095,-0.285169,0.0643935,-0.480085,0.346213,-0.479661,0.344697,-0.283898],
0],["gilardino-sheet0.png",50992,195,1,45,59,1,0.488889,0.491525,[],[0.0483341,-0.285169,0.0472221,-0.480085,0.253889,-0.479661,0.252778,-0.283898],0],["gilardino-sheet0.png",50992,99,1,47,58,1,0.489362,0.517241,[],[0.0888303,-0.307327,0.0877663,-0.505603,0.285638,-0.505172,0.284574,-0.306034],0],["gilardino-sheet0.png",50992,140,60,44,58,1,0.5,0.5,[],[0.185796,-0.290086,0.184659,-0.471121,0.396023,-0.47069,0.394887,-0.288793],0],["gilardino-sheet0.png",50992,134,119,37,58,1,0.486486,0.5,[],[0.0858115,
-0.290086,0.0844595,-0.471121,0.33581,-0.47069,0.334459,-0.288793],0],["gilardino-sheet0.png",50992,90,117,43,59,1,0.488372,0.491525,[],[-0.228488,-0.285169,-0.229651,-0.463136,-0.0133721,-0.462712,-0.0145341,-0.283898],0],["gilardino-sheet0.png",50992,93,60,46,56,1,0.5,0.5,[],[-0.300543,-0.300446,-0.301631,-0.487946,-0.099456,-0.4875,-0.100543,-0.299107],0],["gilardino-sheet0.png",50992,50,1,48,58,1,0.5,0.5,[],[-0.371354,-0.290086,-0.372396,-0.471121,-0.157812,-0.47069,-0.158854,-0.288793],0],["gilardino-sheet0.png",
50992,172,120,34,59,1,0.5,0.491525,[],[-0.318382,-0.285169,-0.319853,-0.480085,-0.046323,-0.479661,-0.047793,-0.283898],0],["gilardino-sheet0.png",50992,1,60,44,59,1,0.5,0.491525,[],[-0.246022,-0.285169,-0.247159,-0.480085,-0.035795,-0.479661,-0.036931,-0.283898],0],["gilardino-sheet0.png",50992,147,1,47,58,1,0.489362,0.5,[],[-0.272872,-0.290086,-0.273937,-0.488362,-0.0760637,-0.487931,-0.0771277,-0.288793],0],["gilardino-sheet0.png",50992,185,61,44,58,1,0.5,0.5,[],[-0.405113,-0.290086,-0.40625,-0.471121,
-0.172159,-0.47069,-0.173295,-0.288793],0],["gilardino-sheet0.png",50992,1,120,37,58,1,0.486486,0.5,[],[-0.319593,-0.290086,-0.320947,-0.471121,-0.0425675,-0.47069,-0.0439185,-0.288793],0]]]],[["Bullet",cr.behaviors.Bullet,0xa316f4fa41455]],!1,!1,0x6965e4e384753,[],null],["t38",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!0,1,0,!1,6428794457657725,[["montolivo-sheet1.png",6742,55,1,26,64,1,0.461538,0.453125,[],[-0.132692,-0.27461,-0.129807,-0.451172,0.179808,-0.45,0.179808,-0.273438],0],["montolivo-sheet0.png",
6798,1,1,27,63,1,0.555556,0.460317,[],[-0.201852,-0.278968,-0.199074,-0.44246,0.13611,-0.44127,0.13611,-0.277778],0],["montolivo-sheet2.png",9547,28,1,25,64,1,0.56,0.46875,[],[-0.138,-0.27461,-0.135,-0.451172,0.187,-0.45,0.187,-0.273438],0],["montolivo-sheet0.png",6798,29,1,27,63,1,0.481481,0.460317,[],[-0.201851,-0.278968,-0.199073,-0.44246,0.13611,-0.44127,0.13611,-0.277778],0],["montolivo-sheet1.png",6742,1,1,26,65,1,0.576923,0.476923,[],[-0.171153,-0.285769,-0.168269,-0.475,0.102884,-0.473846,
0.102885,-0.284616],0],["montolivo-sheet2.png",9547,80,1,25,63,1,0.44,0.47619,[],[-0.178,-0.278968,-0.175,-0.458333,0.146999,-0.457143,0.147,-0.277778],0],["montolivo-sheet1.png",6742,28,1,26,65,1,0.576923,0.476923,[],[-0.171153,-0.285769,-0.168269,-0.475,0.141346,-0.473846,0.141346,-0.284616],0],["montolivo-sheet0.png",6798,57,1,27,63,1,0.481481,0.460317,[],[-0.201851,-0.278968,-0.199073,-0.44246,0.13611,-0.44127,0.13611,-0.277778],0],["montolivo-sheet2.png",9547,54,1,25,64,1,0.56,0.46875,[],[-0.138,
-0.27461,-0.135,-0.451172,0.187,-0.45,0.187,-0.273438],0],["montolivo-sheet0.png",6798,85,1,27,63,1,0.555556,0.460317,[],[-0.201852,-0.278968,-0.199074,-0.44246,0.13611,-0.44127,0.13611,-0.277778],0],["montolivo-sheet1.png",6742,82,1,26,64,1,0.461538,0.453125,[],[-0.132692,-0.27461,-0.129807,-0.451172,0.179808,-0.45,0.179808,-0.273438],0],["montolivo-sheet2.png",9547,1,1,26,64,1,0.538462,0.46875,[],[-0.248077,-0.27461,-0.245193,-0.451172,0.0644224,-0.45,0.0644224,-0.273438],0]]]],[["Bullet",cr.behaviors.Bullet,
6450897376071644]],!1,!1,0x939e7d163be3,[],null],["t39",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x6d50bdb2cb509,[["pirlo-sheet0.png",19554,101,61,26,63,1,0.576923,0.539683,[],[-0.214422,-0.348413,-0.213942,-0.521825,0.102884,-0.519841,0.101922,-0.349207],0],["pirlo-sheet0.png",19554,54,1,48,59,1,0.395833,0.525424,[],[-0.0119793,-0.321187,-0.0117183,-0.506356,0.159896,-0.504237,0.159375,-0.322034],0],["pirlo-sheet0.png",19554,1,1,52,58,1,0.365385,0.517241,[],[-0.0110576,-0.326724,
-0.0108176,-0.497845,0.147595,-0.49569,0.147115,-0.327586],0],["pirlo-sheet0.png",19554,68,61,32,63,1,0.25,0.539683,[],[-0.017968,-0.300794,-0.017578,-0.458333,0.239843,-0.456349,0.239062,-0.301588],0],["pirlo-sheet1.png",3002,0,0,29,59,1,0.37931,0.491525,[],[-0.0887924,-0.321186,-0.0883623,-0.489407,0.195689,-0.487288,0.194827,-0.322034],0],["pirlo-sheet0.png",19554,34,61,33,62,1,0.515152,0.483871,[],[-0.138635,-0.305645,-0.138258,-0.465726,0.111363,-0.46371,0.110605,-0.306452],0],["pirlo-sheet0.png",
19554,1,60,32,64,1,0.40625,0.53125,[],[-0.205468,-0.280469,-0.205078,-0.451172,0.083593,-0.449219,0.082812,-0.28125],0]]]],[],!1,!1,7271741057383031,[],null],["t40",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!0,1,0,!1,0xb529804aebd10,[["carrick-sheet0.png",15492,1,69,27,58,1,0.407407,0.431034,[],[-1.854E-4,-0.267327,-4.17233E-7,-0.422931,0.296113,-0.423405,0.296389,-0.26724],0],["carrick-sheet0.png",15492,1,1,29,67,1,0.413793,0.492537,[],[-0.0346551,-0.246343,-0.0344831,-0.366119,0.206725,-0.36653,
0.206983,-0.246268],0],["carrick-sheet0.png",15492,29,69,27,58,1,0.407407,0.431034,[],[-0.0372224,-0.267327,-0.0370374,-0.40569,0.222039,-0.406164,0.222315,-0.26724],0],["carrick-sheet0.png",15492,61,63,29,59,1,0.482759,0.423729,[],[-0.0346556,-0.262797,-0.0344826,-0.398814,0.241208,-0.39928,0.241465,-0.262712],0],["carrick-sheet1.png",15489,59,1,27,58,1,0.407407,0.431034,[],[-1.854E-4,-0.267327,-4.17233E-7,-0.422931,0.296113,-0.423405,0.296389,-0.26724],0],["carrick-sheet0.png",15492,31,1,29,67,
1,0.413793,0.492537,[],[-0.0346551,-0.246343,-0.0344831,-0.366119,0.206725,-0.36653,0.206983,-0.246268],0],["carrick-sheet1.png",15489,87,1,27,58,1,0.407407,0.431034,[],[-0.0372224,-0.267327,-0.0370374,-0.40569,0.222039,-0.406164,0.222315,-0.26724],0],["carrick-sheet0.png",15492,91,63,29,59,1,0.482759,0.423729,[],[-0.0346556,-0.262797,-0.0344826,-0.398814,0.241208,-0.39928,0.241465,-0.262712],0],["carrick-sheet1.png",15489,59,60,27,58,1,0.518519,0.5,[],[-0.222408,-0.319051,-0.222223,-0.474655,0.0368525,
-0.475129,0.0371295,-0.318965],0],["carrick-sheet1.png",15489,1,1,28,60,1,0.5,0.5,[],[-0.214465,-0.325083,-0.214286,-0.492167,0.071251,-0.492625,0.071518,-0.325],0],["carrick-sheet1.png",15489,1,62,23,59,1,0.521739,0.491525,[],[-0.348044,-0.296694,-0.347826,-0.46661,-2.16126E-4,-0.467076,1.08898E-4,-0.296609],0],["carrick-sheet0.png",15492,61,1,29,61,1,0.551724,0.491803,[],[-0.413966,-0.270573,-0.413793,-0.467705,-0.172585,-0.468156,-0.172328,-0.270491],0],["carrick-sheet1.png",15489,87,60,27,58,
1,0.518519,0.5,[],[-0.222408,-0.319051,-0.222223,-0.474655,0.0368525,-0.475129,0.0371295,-0.318965],0],["carrick-sheet1.png",15489,30,1,28,60,1,0.5,0.5,[],[-0.214465,-0.325083,-0.214286,-0.492167,0.071251,-0.492625,0.071518,-0.325],0],["carrick-sheet1.png",15489,25,62,23,59,1,0.521739,0.508475,[],[-0.348044,-0.313644,-0.347826,-0.483559,-2.16126E-4,-0.484026,1.08898E-4,-0.313559],0],["carrick-sheet0.png",15492,91,1,29,61,1,0.551724,0.491803,[],[-0.207069,-0.270573,-0.206897,-0.418525,0.0687939,-0.418975,
0.0690519,-0.270491],0]]]],[["Bullet",cr.behaviors.Bullet,88723111525557]],!1,!1,5458744731854344,[],null],["t41",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!0,1,0,!1,0x57d216933f491,[["gerrard-sheet1.png",10126,61,62,27,59,1,0.481481,0.491525,[],[-0.299074,-0.316949,-0.300927,-0.484322,-0.0305555,-0.483898,-0.0314815,-0.317796],0],["gerrard-sheet0.png",7102,1,1,44,60,1,0.477273,0.5,[],[-0.183523,-0.311667,-0.18466,-0.47625,-0.0187497,-0.475834,-0.0193177,-0.3125],0],["gerrard-sheet0.png",7102,
91,1,29,59,1,0.482759,0.508475,[],[-0.243966,-0.31695,-0.245691,-0.484322,0.00603437,-0.483898,0.0051724,-0.317797],0],["gerrard-sheet2.png",3873,1,1,27,59,1,0.481481,0.491525,[],[-0.299074,-0.316949,-0.300927,-0.484322,-0.0305555,-0.483898,-0.0314815,-0.317796],0],["gerrard-sheet0.png",7102,46,1,44,60,1,0.477273,0.5,[],[-0.183523,-0.311667,-0.18466,-0.47625,-0.0187497,-0.475834,-0.0193177,-0.3125],0],["gerrard-sheet0.png",7102,91,61,29,59,1,0.482759,0.508475,[],[-0.243966,-0.31695,-0.24138,-0.486441,
0.00603437,-0.486017,0.0051724,-0.317797],0],["gerrard-sheet2.png",3873,29,1,27,59,1,0.481481,0.491525,[],[-0.299074,-0.316949,-0.300927,-0.484322,-0.0305555,-0.483898,-0.0314815,-0.317796],0],["gerrard-sheet0.png",7102,1,62,44,60,1,0.477273,0.5,[],[-0.183523,-0.311667,-0.18466,-0.47625,-0.0187497,-0.475834,-0.0193177,-0.3125],0],["gerrard-sheet1.png",10126,91,1,29,59,1,0.482759,0.508475,[],[-0.243966,-0.31695,-0.245691,-0.484322,0.00603437,-0.483898,0.0051724,-0.317797],0],["gerrard-sheet1.png",
10126,91,61,29,59,1,0.482759,0.508475,[],[-0.243966,-0.31695,-0.245691,-0.484322,0.00603437,-0.483898,0.0051724,-0.317797],0],["gerrard-sheet0.png",7102,46,62,44,60,1,0.477273,0.5,[],[-0.183523,-0.311667,-0.18466,-0.47625,-0.0187497,-0.475834,-0.0193177,-0.3125],0],["gerrard-sheet2.png",3873,57,1,27,59,1,0.481481,0.491525,[],[-0.299074,-0.316949,-0.300927,-0.484322,-0.0305555,-0.483898,-0.0314815,-0.317796],0],["gerrard-sheet1.png",10126,1,62,29,59,1,0.482759,0.508475,[],[-0.243966,-0.31695,-0.245691,
-0.484322,0.00603437,-0.483898,0.0051724,-0.317797],0],["gerrard-sheet1.png",10126,1,1,44,60,1,0.477273,0.5,[],[-0.183523,-0.311667,-0.18466,-0.47625,-0.0187497,-0.475834,-0.0193177,-0.3125],0],["gerrard-sheet2.png",3873,85,1,27,59,1,0.481481,0.491525,[],[-0.299074,-0.316949,-0.300927,-0.484322,-0.0305555,-0.483898,-0.0314815,-0.317796],0],["gerrard-sheet1.png",10126,31,62,29,59,1,0.482759,0.508475,[],[-0.243966,-0.31695,-0.245691,-0.484322,0.00603437,-0.483898,0.0051724,-0.317797],0],["gerrard-sheet1.png",
10126,46,1,44,60,1,0.477273,0.5,[],[-0.183523,-0.311667,-0.18466,-0.47625,-0.0187497,-0.475834,-0.0193177,-0.3125],0],["gerrard-sheet2.png",3873,1,61,27,59,1,0.481481,0.491525,[],[-0.299074,-0.316949,-0.300927,-0.484322,-0.0305555,-0.483898,-0.0314815,-0.317796],0]]]],[["Bullet",cr.behaviors.Bullet,9370326691248284]],!1,!1,0x47c76b276fc39,[],null],["t42",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!0,1,0,!1,0xe0f8917700be0,[["lampard-sheet0.png",22238,89,59,27,59,1,0.518519,0.491525,[],[-0.194446,
-0.330508,-0.195372,-0.483475,0.0824065,-0.483474,0.0833325,-0.330508],0],["lampard-sheet0.png",22238,1,1,34,56,1,0.5,0.5,[],[-0.066176,-0.294643,-0.066911,-0.455803,0.153678,-0.455803,0.154411,-0.294643],0],["lampard-sheet0.png",22238,60,59,28,57,1,0.5,0.508772,[],[-0.223215,-0.324561,-0.224107,-0.482895,0.079465,-0.482895,0.080358,-0.324561],0],["lampard-sheet0.png",22238,31,58,28,58,1,0.5,0.5,[],[-0.11607,-0.284482,-0.116963,-0.440086,0.186607,-0.440086,0.1875,-0.284482],0],["lampard-sheet0.png",
22238,69,1,31,57,1,0.483871,0.508772,[],[-0.10484,-0.307017,-0.105646,-0.465351,0.13629,-0.465351,0.137096,-0.307017],0],["lampard-sheet0.png",22238,101,1,25,57,1,0.48,0.508772,[],[-0.090001,-0.342105,-0.091001,-0.500439,0.208999,-0.500438,0.209999,-0.342105],0],["lampard-sheet0.png",22238,36,1,32,56,1,0.5,0.5,[],[-0.164063,-0.312499,-0.164844,-0.473661,0.069531,-0.47366,0.070312,-0.312499],0],["lampard-sheet0.png",22238,1,58,29,57,1,0.551724,0.508772,[],[-0.11207,-0.324561,-0.112932,-0.482895,0.145689,
-0.482895,0.146551,-0.324561],0],["lampard-sheet1.png",5873,31,1,28,52,1,0.5,0.5,[],[-0.151787,-0.336538,-0.152679,-0.490865,0.115178,-0.490865,0.116071,-0.336538],0],["lampard-sheet1.png",5873,1,1,29,53,1,0.551724,0.490566,[],[-0.11207,-0.330188,-0.112932,-0.462736,0.111207,-0.462736,0.112068,-0.330188],0]]]],[],!1,!1,0xafff923fe467e,[],null],["t43",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!0,1,0,!1,0xc71fec4c02eb8,[["rooney-sheet1.png",15034,75,58,25,57,1,0.52,0.491228,[],[0.107399,-0.281842,
0.11,-0.467018,0.429,-0.466667,0.427399,-0.282895],0],["rooney-sheet0.png",12354,1,58,38,57,1,0.5,0.491228,[],[0.149605,-0.281842,0.151316,-0.467018,0.361184,-0.466667,0.360131,-0.282895],0],["rooney-sheet1.png",15034,45,1,33,56,1,0.484848,0.5,[],[0.0510605,-0.286875,0.0530295,-0.475357,0.294698,-0.475,0.293485,-0.287946],0],["rooney-sheet0.png",12354,1,1,41,56,1,0.487805,0.5,[],[0.114268,-0.286875,0.115853,-0.475357,0.310366,-0.475,0.30939,-0.287946],0],["rooney-sheet1.png",15034,101,58,25,57,1,
0.48,0.491228,[],[0.147399,-0.281842,0.15,-0.467018,0.469,-0.466667,0.467399,-0.282895],0],["rooney-sheet1.png",15034,1,1,43,44,1,0.511628,0.5,[],[0.271744,-0.251477,0.273256,-0.468637,0.481977,-0.468182,0.481046,-0.252841],0],["rooney-sheet2.png",14577,1,1,62,26,1,0.5,0.5,[],[0.301371,-0.117883,0.302419,-0.485385,0.447178,-0.484615,0.446532,-0.120192],0],["rooney-sheet2.png",14577,1,28,53,26,1,0.490566,0.5,[],[0.314811,0.151347,0.316038,-0.177692,0.483019,-0.176923,0.482264,0.149039],0],["rooney-sheet2.png",
14577,1,55,50,25,1,0.5,0.48,[],[0.2737,-0.042599,0.275,-0.4248,0.4545,-0.424,0.4537,-0.044999],0],["rooney-sheet1.png",15034,35,58,39,45,1,0.512821,0.488889,[],[0.0688455,-0.245889,0.0705125,-0.458222,0.275,-0.457778,0.273973,-0.247222],0],["rooney-sheet2.png",14577,52,59,21,58,1,0.47619,0.5,[],[0.0326185,-0.311465,0.0357135,-0.476207,0.463096,-0.475862,0.46119,-0.3125],0],["rooney-sheet2.png",14577,90,1,24,57,1,0.5,0.491228,[],[-0.471459,-0.299386,-0.468751,-0.467018,-0.094792,-0.466667,-0.096459,
-0.300438],0],["rooney-sheet0.png",12354,40,58,38,57,1,0.5,0.491228,[],[-0.376711,-0.299386,-0.375001,-0.467018,-0.165132,-0.466667,-0.166185,-0.300438],0],["rooney-sheet1.png",15034,79,1,33,56,1,0.484848,0.5,[],[-0.25197,-0.304732,-0.250001,-0.475357,-0.0083335,-0.475,-0.00954649,-0.305804],0],["rooney-sheet0.png",12354,43,1,41,56,1,0.487805,0.5,[],[-0.300367,-0.304732,-0.298781,-0.475357,-0.0798779,-0.475,-0.0808539,-0.305804],0],["rooney-sheet2.png",14577,64,1,25,57,1,0.48,0.491228,[],[-0.452601,
-0.281842,-0.450001,-0.467018,-0.091,-0.466667,-0.092601,-0.282895],0],["rooney-sheet0.png",12354,79,58,38,57,1,0.5,0.491228,[],[-0.376711,-0.281842,-0.375001,-0.467018,-0.138816,-0.466667,-0.139869,-0.282895],0],["rooney-sheet1.png",15034,1,46,33,56,1,0.484848,0.5,[],[-0.25197,-0.286875,-0.250001,-0.475357,-0.0083335,-0.475,-0.00954649,-0.287946],0],["rooney-sheet0.png",12354,85,1,41,56,1,0.487805,0.5,[],[-0.300367,-0.286875,-0.298781,-0.475357,-0.0798779,-0.475,-0.0808539,-0.287946],0]]]],[["Bullet",
cr.behaviors.Bullet,298758084008978]],!1,!1,0xe7ccbabe6fa87,[],null],["t44",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!0,1,0,!1,0xbbb7fc1fc3ddf,[["wellbeck-sheet2.png",14144,42,1,34,60,1,0.647059,0.516667,[],[-0.109559,-0.491667,-0.109559,-0.324584,-0.3625,-0.32375,-0.361765,-0.491667],0],["wellbeck-sheet1.png",17394,1,1,42,55,1,0.642857,0.472727,[],[0.0851198,-0.447727,0.0851198,-0.280644,-0.120203,-0.27981,-0.119468,-0.447727],0],["wellbeck-sheet2.png",14144,1,56,32,55,1,0.53125,0.490909,
[],[0.19375,-0.465909,0.19375,-0.280644,-0.086535,-0.279811,-0.089706,-0.465909],0],["wellbeck-sheet1.png",17394,86,63,40,54,1,0.6,0.462963,[],[-0.0625001,-0.437963,-0.0625001,-0.252361,-0.265441,-0.251528,-0.264706,-0.437963],0],["wellbeck-sheet1.png",17394,44,56,41,54,1,0.560976,0.462963,[],[-0.0966466,-0.437963,-0.0966466,-0.252361,-0.300807,-0.251528,-0.300072,-0.437963],0],["wellbeck-sheet0.png",15874,1,1,55,59,1,0.418182,0.491525,[],[-0.0624998,-0.466525,-0.0624998,-0.299442,-0.224532,-0.300727,
-0.223797,-0.466525],0],["wellbeck-sheet1.png",17394,87,1,36,61,1,0.527778,0.52459,[],[0.0652782,-0.49959,0.0652782,-0.330457,-0.187664,-0.331673,-0.186928,-0.49959],0],["wellbeck-sheet0.png",15874,1,61,39,61,1,0.538462,0.491803,[],[-9.61602E-4,-0.466803,-9.61602E-4,-0.316113,-0.225057,-0.317329,-0.227527,-0.466803],0],["wellbeck-sheet2.png",14144,77,1,34,60,1,0.647059,0.516667,[],[0.0669122,-0.491667,0.0669122,-0.324584,-0.18603,-0.32375,-0.185294,-0.491667],0],["wellbeck-sheet0.png",15874,81,61,
43,55,1,0.627907,0.472727,[],[-0.136919,-0.447727,-0.136919,-0.280644,-0.340441,-0.27981,-0.342613,-0.447727],0],["wellbeck-sheet2.png",14144,34,62,32,55,1,0.53125,0.490909,[],[0.00624996,-0.465909,0.00624996,-0.280644,-0.246691,-0.279811,-0.249862,-0.463636],0],["wellbeck-sheet2.png",14144,1,1,40,54,1,0.6,0.462963,[],[0.0625,-0.437963,0.0625,-0.252361,-0.140441,-0.251528,-0.139706,-0.437963],0],["wellbeck-sheet1.png",17394,44,1,42,54,1,0.547619,0.462963,[],[0.204167,-0.437963,0.204167,-0.27088,-0.00115502,
-0.270046,-4.20034E-4,-0.437963],0],["wellbeck-sheet0.png",15874,57,1,46,59,1,0.5,0.491525,[],[0.27663,-0.466525,0.276631,-0.297323,0.088907,-0.298608,0.089642,-0.466525],0],["wellbeck-sheet1.png",17394,1,57,36,61,1,0.527778,0.52459,[],[0.120833,-0.49959,0.120833,-0.330457,-0.10433,-0.331673,-0.103595,-0.49959],0],["wellbeck-sheet0.png",15874,41,61,39,61,1,0.538462,0.491803,[],[0.127243,-0.466803,0.127243,-0.29972,-0.0712106,-0.300936,-0.0736806,-0.466803],0]]]],[["Bullet",cr.behaviors.Bullet,9838988769047808]],
!1,!1,7700847115117605,[],null],["t45",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!0,1,0,!1,9105562395142672,[["carvalho-sheet1.png",17684,32,1,31,59,1,0.419355,0.491525,[],[-0.104033,-0.291949,-0.104839,-0.469068,0.198387,-0.468644,0.199194,-0.292373],0],["carvalho-sheet0.png",14416,1,1,33,61,1,0.515152,0.508197,[],[-0.260435,-0.308621,-0.261241,-0.485739,0.0419845,-0.485315,0.0427915,-0.309045],0],["carvalho-sheet1.png",17684,1,63,28,63,1,0.607143,0.492063,[],[-0.291821,-0.292488,-0.292627,
-0.469606,0.0105991,-0.469182,0.0114061,-0.292911],0],["carvalho-sheet0.png",14416,35,63,30,61,1,0.6,0.508197,[],[-0.284678,-0.308621,-0.285484,-0.485739,0.017742,-0.485315,0.018549,-0.309045],0],["carvalho-sheet1.png",17684,64,1,31,59,1,0.419355,0.491525,[],[-0.0395158,-0.291949,-0.0403228,-0.469068,0.262903,-0.468644,0.26371,-0.292373],0],["carvalho-sheet0.png",14416,35,1,33,61,1,0.515152,0.508197,[],[-0.0483135,-0.308621,-0.0491205,-0.485739,0.223803,-0.485315,0.224609,-0.309045],0],["carvalho-sheet1.png",
17684,64,61,29,63,1,0.62069,0.492063,[],[-0.201919,-0.292488,-0.202726,-0.469606,0.0660183,-0.469182,0.0668244,-0.292911],0],["carvalho-sheet0.png",14416,66,63,30,61,1,0.6,0.508197,[],[-0.218011,-0.308621,-0.218817,-0.485739,0.084409,-0.485315,0.085215,-0.309045],0],["carvalho-sheet0.png",14416,97,63,30,61,1,0.6,0.508197,[],[-0.218011,-0.308621,-0.218817,-0.485739,0.084409,-0.485315,0.085215,-0.309045],0],["carvalho-sheet1.png",17684,94,61,29,63,1,0.62069,0.492063,[],[-0.236402,-0.292488,-0.237208,
-0.469606,0.0660183,-0.469182,0.0668244,-0.292911],0],["carvalho-sheet0.png",14416,69,1,33,61,1,0.515152,0.508197,[],[-0.0483135,-0.308621,-0.0491205,-0.485739,0.223803,-0.485315,0.224609,-0.309045],0],["carvalho-sheet1.png",17684,96,1,31,59,1,0.419355,0.491525,[],[-0.0395158,-0.291949,-0.0403228,-0.469068,0.262903,-0.468644,0.26371,-0.292373],0],["carvalho-sheet1.png",17684,1,1,30,61,1,0.6,0.508197,[],[-0.284678,-0.308621,-0.285484,-0.485739,0.017742,-0.485315,0.018549,-0.309045],0],["carvalho-sheet2.png",
3612,0,0,28,63,1,0.607143,0.492063,[],[-0.327535,-0.292488,-0.328341,-0.469606,0.0105991,-0.469182,0.0114061,-0.292911],0],["carvalho-sheet0.png",14416,1,63,33,61,1,0.515152,0.508197,[],[-0.260435,-0.308621,-0.261241,-0.485739,0.0419845,-0.485315,0.0427915,-0.309045],0],["carvalho-sheet1.png",17684,32,61,31,59,1,0.419355,0.491525,[],[-0.104033,-0.291949,-0.104839,-0.469068,0.198387,-0.468644,0.199194,-0.292373],0]]]],[["Bullet",cr.behaviors.Bullet,6132295517024637]],!1,!1,8293093146563255,[],null],
["t46",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!0,1,0,!1,8262829116651005,[["coentrao-sheet0.png",20036,87,61,28,60,1,0.392857,0.466667,[],[],0],["coentrao-sheet1.png",6638,30,1,28,58,1,0.392857,0.448276,[],[-0.0792861,-0.264569,-0.0803571,-0.436897,0.224822,-0.436121,0.224644,-0.265086],0],["coentrao-sheet0.png",20036,1,1,47,57,1,0.361702,0.438596,[],[-0.0685111,-0.234122,-0.0691491,-0.427017,0.11266,-0.426228,0.112554,-0.234648],0],["coentrao-sheet0.png",20036,1,59,42,49,1,0.404762,0.346939,
[],[-0.171905,-0.0886728,-0.172619,-0.313061,0.0308341,-0.312143,0.0307141,-0.0892858],0],["coentrao-sheet1.png",6638,1,1,28,60,1,0.357143,0.466667,[],[-0.0435719,-0.272417,-0.0446429,-0.439,0.296251,-0.43825,0.296072,-0.272917],0],["coentrao-sheet0.png",20036,97,1,29,59,1,0.413793,0.440678,[],[-0.0420691,-0.260085,-0.0431031,-0.429491,0.286035,-0.428729,0.285863,-0.260593],0],["coentrao-sheet0.png",20036,49,1,47,57,1,0.361702,0.438596,[],[0.144255,-0.234122,0.143617,-0.409474,0.346703,-0.408684,
0.346596,-0.234648],0],["coentrao-sheet0.png",20036,44,59,42,49,1,0.404762,0.346939,[],[0.137619,-0.109082,0.136905,-0.313061,0.340358,-0.312143,0.340239,-0.109694],0]]]],[["Bullet",cr.behaviors.Bullet,0x8f5948b196fe9]],!1,!1,0xef7d5dcd3be69,[],null],["t47",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!0,1,0,!1,7427700740225023,[["cristiano-sheet0.png",65329,223,1,32,58,1,0.5,0.5,[],[-0.189844,-0.305172,-0.189844,-0.473276,0.098437,-0.472414,0.098438,-0.303879],0],["cristiano-sheet0.png",65329,
38,64,37,56,1,0.405405,0.482143,[],[0.0249996,-0.280357,0.0250006,-0.472321,0.274324,-0.471428,0.274325,-0.279018],0],["cristiano-sheet0.png",65329,212,122,35,57,1,0.371429,0.508772,[],[-0.0878576,-0.292982,-0.0878566,-0.481579,0.175713,-0.480702,0.175714,-0.291667],0],["cristiano-sheet0.png",65329,134,63,38,59,1,0.605263,0.491525,[],[-0.107237,-0.28305,-0.107237,-0.465254,0.135526,-0.464407,0.135526,-0.281779],0],["cristiano-sheet0.png",65329,93,1,43,61,1,0.511628,0.491803,[],[0.0215121,-0.306557,
0.0215121,-0.482787,0.236046,-0.481967,0.236046,-0.305327],0],["cristiano-sheet0.png",65329,93,63,40,61,1,0.6,0.491803,[],[-0.201875,-0.32295,-0.201875,-0.482787,0.02875,-0.481967,0.02875,-0.321721],0],["cristiano-sheet0.png",65329,1,1,45,62,1,0.488889,0.5,[],[-0.112778,-0.317742,-0.112778,-0.475,0.0922221,-0.474193,0.0922221,-0.316532],0],["cristiano-sheet0.png",65329,212,63,36,58,1,0.388889,0.465517,[],[-0.140972,-0.287931,-0.140972,-0.456034,0.0875001,-0.455172,0.0875001,-0.286637],0],["cristiano-sheet0.png",
65329,134,123,31,59,1,0.419355,0.474576,[],[-0.0991938,-0.316949,-0.0991928,-0.465254,0.13387,-0.464407,0.133871,-0.315677],0],["cristiano-sheet0.png",65329,37,178,30,58,1,0.4,0.482759,[],[-0.135833,-0.305173,-0.135833,-0.473276,0.138333,-0.472414,0.138333,-0.303879],0],["cristiano-sheet0.png",65329,1,181,28,56,1,0.285714,0.446429,[],[-0.0383933,-0.244643,-0.0383923,-0.436607,0.326785,-0.435714,0.326786,-0.243304],0],["cristiano-sheet0.png",65329,75,125,31,58,1,0.516129,0.5,[],[-0.131452,-0.305172,
-0.131451,-0.473276,0.198387,-0.472414,0.198387,-0.303879],0],["cristiano-sheet0.png",65329,38,121,36,56,1,0.416667,0.482143,[],[-0.113195,-0.280357,-0.113195,-0.472321,0.170833,-0.471428,0.170833,-0.279018],0],["cristiano-sheet0.png",65329,1,123,35,57,1,0.371429,0.508772,[],[0.0550004,-0.292982,0.0550004,-0.481579,0.375713,-0.480702,0.375714,-0.291667],0],["cristiano-sheet0.png",65329,173,63,38,59,1,0.605263,0.491525,[],[-0.344079,-0.28305,-0.344079,-0.465254,-0.0750002,-0.464407,-0.0750002,-0.281779],
0],["cristiano-sheet0.png",65329,137,1,43,61,1,0.534884,0.491803,[],[-0.257559,-0.290164,-0.257558,-0.482787,-0.0197678,-0.481967,-0.0197678,-0.288934],0],["cristiano-sheet0.png",65329,181,1,41,61,1,0.609756,0.491803,[],[-0.245732,-0.32295,-0.245732,-0.482787,0.00365788,-0.481967,0.00365889,-0.321721],0],["cristiano-sheet0.png",65329,47,1,45,62,1,0.488889,0.5,[],[-0.0905559,-0.317742,-0.0905559,-0.475,0.136666,-0.474193,0.136667,-0.316532],0],["cristiano-sheet0.png",65329,1,64,36,58,1,0.416667,0.465517,
[],[0.0812503,-0.287931,0.0812503,-0.456034,0.337499,-0.455172,0.337499,-0.286637],0],["cristiano-sheet0.png",65329,166,123,31,59,1,0.419355,0.474576,[],[0.0298392,-0.316949,0.0298392,-0.465254,0.262903,-0.464407,0.262903,-0.315677],0],["cristiano-sheet0.png",65329,198,180,30,58,1,0.4,0.482759,[],[0.064167,-0.305173,0.064167,-0.473276,0.371666,-0.472414,0.371666,-0.303879],0],["cristiano-sheet0.png",65329,107,183,28,56,1,0.321429,0.446429,[],[0.0687504,-0.244643,0.0687504,-0.436607,0.398213,-0.435714,
0.398214,-0.243304],0]]]],[["Bullet",cr.behaviors.Bullet,8699308200415452]],!1,!1,882331113254573,[],null],["t48",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!0,1,0,!1,0x7eba1911c237e,[["nani-sheet0.png",13397,82,1,32,61,1,0.5,0.508197,[],[-0.104687,-0.339755,-0.105469,-0.484426,0.132812,-0.485656,0.133593,-0.338115],0],["nani-sheet0.png",13397,44,1,37,57,1,0.432432,0.473684,[],[-0.0635135,-0.275877,-0.0641894,-0.448246,0.141892,-0.449561,0.142567,-0.274123],0],["nani-sheet0.png",13397,1,1,42,
53,1,0.380952,0.45283,[],[-0.0321424,-0.258962,-0.0327384,-0.44434,0.148809,-0.445755,0.149405,-0.257076],0],["nani-sheet0.png",13397,1,55,31,56,1,0.387097,0.482143,[],[-0.0435488,-0.280804,-0.0443548,-0.45625,0.201612,-0.457589,0.202418,-0.279018],0],["nani-sheet0.png",13397,33,59,26,59,1,0.384615,0.525424,[],[-0.128846,-0.351272,-0.129808,-0.500847,0.163461,-0.502119,0.164423,-0.349577],0]]]],[],!1,!1,7359845435997077,[],null],["t49",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!0,1,0,!1,9039630595641584,
[["pepe-sheet0.png",15076,99,42,28,60,1,1,0.5,[],[-0.397322,-0.475417,-0.098214,-0.475,-0.099823,-0.320833,-0.400894,-0.31875],0],["pepe-sheet0.png",15076,66,42,32,59,1,1,0.508475,[],[-0.285157,-0.483475,-0.023438,-0.483051,-0.024845,-0.326272,-0.288282,-0.324153],0],["pepe-sheet0.png",15076,1,42,32,61,1,1,0.491803,[],[-0.410157,-0.467623,-0.148438,-0.467213,-0.149845,-0.315574,-0.413282,-0.313524],0],["pepe-sheet1.png",20687,1,1,32,59,1,1,0.508475,[],[-0.285157,-0.500424,-0.023438,-0.5,-0.024845,
-0.343221,-0.288282,-0.341102],0],["pepe-sheet2.png",13559,1,35,25,54,1,1,0.5,[],[-0.885001,-0.491204,-0.550001,-0.490741,-0.551802,-0.319445,-0.889002,-0.31713],0],["pepe-sheet0.png",15076,1,1,50,40,1,0.5,0.5,[],[-0.462501,-0.463125,-0.315001,-0.4625,-0.315901,-0.25625,-0.464501,-0.253125],0],["pepe-sheet2.png",13559,1,1,48,33,1,0.5,0.484848,[],[-0.460938,-0.440151,-0.286459,-0.439394,-0.287397,-0.189393,-0.463022,-0.185605],0],["pepe-sheet2.png",13559,27,35,36,37,1,0.5,0.486486,[],[-0.336806,-0.473648,
-0.104167,-0.472973,-0.105418,-0.195946,-0.339585,-0.192567],0],["pepe-sheet1.png",20687,30,61,31,53,1,0.709677,0.490566,[],[-0.584678,-0.462736,-0.346774,-0.462264,-0.348227,-0.287736,-0.587904,-0.285377],0],["pepe-sheet1.png",20687,100,1,24,60,1,1,0.5,[],[-0.671876,-0.475417,-0.364584,-0.475,-0.36646,-0.320833,-0.676043,-0.31875],0],["pepe-sheet1.png",20687,1,61,28,60,1,1,0.5,[],[-0.897322,-0.475417,-0.598215,-0.475,-0.599823,-0.320833,-0.900894,-0.31875],0],["pepe-sheet1.png",20687,34,1,32,59,
1,1,0.508475,[],[-0.972657,-0.483475,-0.710938,-0.483051,-0.712346,-0.326272,-0.975783,-0.324153],0],["pepe-sheet0.png",15076,34,42,31,61,1,1,0.491803,[],[-0.842743,-0.467623,-0.572581,-0.467213,-0.574034,-0.315574,-0.845969,-0.313524],0],["pepe-sheet1.png",20687,67,1,32,59,1,1,0.508475,[],[-0.941407,-0.500424,-0.710938,-0.5,-0.712346,-0.343221,-0.944533,-0.341102],0],["pepe-sheet2.png",13559,99,1,25,55,1,1,0.490909,[],[-0.445001,-0.464091,-0.11,-0.463636,-0.111801,-0.295455,-0.449001,-0.293182],
0],["pepe-sheet0.png",15076,52,1,50,40,1,1,0.5,[],[-0.1825,-0.463125,-0.015,-0.4625,-0.0159,-0.23125,-0.1845,-0.228125],0],["pepe-sheet2.png",13559,50,1,48,33,1,1,0.484848,[],[-0.210937,-0.440151,-0.036458,-0.439394,-0.037396,-0.189393,-0.213021,-0.185605],0],["pepe-sheet2.png",13559,64,57,36,37,1,1,0.486486,[],[-0.420139,-0.473648,-0.159722,-0.472973,-0.160973,-0.222972,-0.422917,-0.219595],0],["pepe-sheet1.png",20687,62,61,31,53,1,1,0.490566,[],[-0.358871,-0.462736,-0.120968,-0.462264,-0.12242,
-0.268868,-0.362098,-0.26651],0],["pepe-sheet1.png",20687,94,62,24,60,1,1,0.5,[],[-0.630209,-0.475417,-0.322917,-0.475,-0.324793,-0.304167,-0.634376,-0.302084],0]]]],[["Bullet",cr.behaviors.Bullet,0x7c5fca960957c]],!1,!1,9916867065933878,[],null],["t50",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!0,1,0,!1,7453462598422748,[["dimaria-sheet1.png",9442,1,1,43,56,1,0.465116,0.5,[],[0.0405037,-0.303721,0.0406987,-0.477232,0.21841,-0.475744,0.219379,-0.305804],0],["dimaria-sheet1.png",9442,45,1,38,
55,1,0.447368,0.509091,[],[0.0721496,-0.309243,0.0723686,-0.485909,0.29978,-0.484394,0.300876,-0.311365],0],["dimaria-sheet0.png",16047,1,53,43,59,1,0.348837,0.474576,[],[0.0405038,-0.288277,0.0406988,-0.452966,0.21841,-0.451554,0.219379,-0.290255],0],["dimaria-sheet0.png",16047,93,55,33,62,1,0.515152,0.516129,[],[-0.0570705,-0.324732,-0.0606065,-0.495565,0.193685,-0.494221,0.194949,-0.324597],0],["dimaria-sheet1.png",9442,84,1,28,54,1,0.285714,0.462963,[],[-0.259225,-0.259414,-0.258928,-0.439352,
0.0854167,-0.437809,0.0869047,-0.261575],0],["dimaria-sheet0.png",16047,1,1,56,51,1,0.464286,0.431373,[],[-0.111757,-0.196242,-0.111607,-0.406373,0.0427083,-0.404739,0.0434523,-0.19853],0],["dimaria-sheet0.png",16047,58,1,51,53,1,0.372549,0.45283,[],[-0.201144,-0.24544,-0.20098,-0.428773,-0.031537,-0.427201,-0.03072,-0.247642],0],["dimaria-sheet0.png",16047,45,55,47,52,1,0.382979,0.442308,[],[-0.218262,-0.226122,-0.218085,-0.417789,-0.0342207,-0.416187,-0.0333347,-0.228366],0]]]],[["Bullet",cr.behaviors.Bullet,
0x65991d0573e61]],!1,!1,8551686927853237,[],null],["t51",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8154554868524834,[["higuain-sheet2.png",5609,33,1,26,58,1,0.423077,0.482759,[],[-0.0934629,-0.337155,-0.0913479,-0.475,0.208653,-0.475,0.208077,-0.336207],0],["higuain-sheet0.png",3237,0,0,45,55,1,0.466667,0.490909,[],[-0.0317777,-0.319181,-0.0305557,-0.464545,0.120555,-0.464545,0.120222,-0.318182],0],["higuain-sheet1.png",5860,1,1,35,51,1,0.371429,0.490196,[],[-0.0694296,-0.305,-0.0678586,
-0.461765,0.154999,-0.461765,0.154571,-0.303921],0],["higuain-sheet2.png",5609,1,1,31,53,1,0.548387,0.471698,[],[-0.336452,-0.293491,-0.334679,-0.44434,-0.0830651,-0.44434,-0.0835481,-0.292452],0],["higuain-sheet1.png",5860,37,1,26,59,1,0.576923,0.491525,[],[-0.208847,-0.33144,-0.206732,-0.466949,0.0932679,-0.466949,0.0926929,-0.330508],0]]]],[],!1,!1,8544577695596561,[],null],["t52",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,6011134244469054,[["aguero-sheet1.png",5542,1,1,32,61,1,
0.53125,0.491803,[],[0.017188,-0.269672,0.015625,-0.470082,0.29375,-0.469672,0.292187,-0.270491],0],["aguero-sheet0.png",16222,51,61,46,58,1,0.565217,0.517241,[],[-0.0385194,-0.297265,-0.0373644,-0.49552,0.170109,-0.49511,0.171264,-0.295929],0],["aguero-sheet0.png",16222,1,65,45,58,1,0.488889,0.517241,[],[-0.0071179,-0.353299,-0.00868088,-0.49552,0.186111,-0.49511,0.187326,-0.351964],0],["aguero-sheet0.png",16222,51,1,49,59,1,0.387755,0.525424,[],[0.0280299,-0.371089,0.0290179,-0.503702,0.212755,
-0.503293,0.211193,-0.371909],0],["aguero-sheet0.png",16222,1,1,49,63,1,0.346939,0.52381,[],[-0.00258279,-0.349298,-0.00159478,-0.502088,0.171939,-0.501678,0.170376,-0.350118],0],["aguero-sheet0.png",16222,98,61,28,62,1,0.464286,0.532258,[],[-0.237277,-0.328272,-0.23884,-0.510537,0.0750003,-0.510127,0.0734373,-0.327075],0],["aguero-sheet1.png",5542,34,1,22,61,1,0.5,0.52459,[],[-0.320881,-0.318852,-0.316761,-0.502869,0.052273,-0.502459,0.05071,-0.319672],0]]]],[],!1,!1,7703452594839143,[],null],["t53",
cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!0,1,0,!1,8686799096818939,[["messi-sheet0.png",62604,118,58,35,58,1,0.514286,0.5,[],[-0.213714,-0.478103,0.0168573,-0.477845,0.0177143,-0.299569,-0.215429,-0.301724],0],["messi-sheet0.png",62604,225,61,30,59,1,0.5,0.491525,[],[-0.232762,-0.469629,0.031143,-0.46937,0.032,-0.299569,-0.234476,-0.299605],0],["messi-sheet0.png",62604,118,1,39,56,1,0.512821,0.482143,[],[-0.109685,-0.460246,0.0952455,-0.459988,0.0961025,-0.299569,-0.108195,-0.301724],0],["messi-sheet0.png",
62604,105,117,32,58,1,0.5,0.482759,[],[-0.136928,-0.454397,0.124893,-0.454138,0.12575,-0.282328,-0.138643,-0.284483],0],["messi-sheet0.png",62604,138,120,27,60,1,0.703704,0.483333,[],[-0.143873,-0.44477,0.160772,-0.444512,0.161629,-0.282902,-0.145588,-0.285057],0],["messi-sheet0.png",62604,166,121,27,56,1,0.592593,0.482143,[],[-0.143873,-0.460246,0.160772,-0.459988,0.161629,-0.281712,-0.145588,-0.283867],0],["messi-sheet0.png",62604,194,176,25,54,1,0.6,0.462963,[],[-0.019428,-0.441066,0.371143,-0.440808,
0.367,-0.264847,-0.021143,-0.264687],0],["messi-sheet0.png",62604,194,121,28,54,1,0.535714,0.462963,[],[-0.0565713,-0.441066,0.281143,-0.440808,0.282,-0.262532,-0.0582853,-0.264687],0],["messi-sheet0.png",62604,37,62,33,57,1,0.454545,0.438596,[],[-0.0327615,-0.4167,0.228113,-0.416441,0.22897,-0.238165,-0.0344765,-0.24032],0],["messi-sheet0.png",62604,158,1,36,59,1,0.444444,0.440678,[],[0.0505716,-0.418781,0.253366,-0.418523,0.254223,-0.240247,0.0488575,-0.242402],0],["messi-sheet0.png",62604,42,1,
37,60,1,0.378378,0.433333,[],[0.0573286,-0.411437,0.2879,-0.411178,0.285379,-0.251652,0.0556136,-0.251724],0],["messi-sheet0.png",62604,1,58,35,59,1,0.457143,0.491525,[],[-0.0994289,-0.469629,0.131143,-0.46937,0.132,-0.291094,-0.101143,-0.293249],0],["messi-sheet0.png",62604,154,61,35,58,1,0.485714,0.5,[],[-0.0137143,-0.478103,0.245429,-0.477845,0.246286,-0.299569,-0.0154283,-0.301724],0],["messi-sheet0.png",62604,34,120,30,59,1,0.466667,0.491525,[],[-0.0327617,-0.469629,0.264476,-0.46937,0.265333,
-0.293213,-0.0344767,-0.293249],0],["messi-sheet0.png",62604,1,1,40,56,1,0.475,0.482143,[],[-0.099428,-0.460246,0.131143,-0.459988,0.132,-0.281712,-0.101143,-0.283867],0],["messi-sheet0.png",62604,1,118,32,58,1,0.46875,0.482759,[],[-0.105678,-0.460862,0.156143,-0.460604,0.157,-0.282328,-0.107393,-0.284483],0],["messi-sheet0.png",62604,65,120,28,60,1,0.285714,0.483333,[],[-0.128,-0.44477,0.138286,-0.444512,0.139143,-0.282902,-0.129714,-0.280891],0],["messi-sheet0.png",62604,223,121,27,56,1,0.37037,
0.482143,[],[-0.143873,-0.460246,0.160773,-0.459988,0.16163,-0.281712,-0.145587,-0.283867],0],["messi-sheet0.png",62604,1,177,25,54,1,0.36,0.462963,[],[-0.339428,-0.441066,0.011143,-0.440808,0.012,-0.262532,-0.341143,-0.262372],0],["messi-sheet0.png",62604,94,176,28,54,1,0.428571,0.462963,[],[-0.270857,-0.441066,0.0668576,-0.440808,0.0677146,-0.262532,-0.272571,-0.264687],0],["messi-sheet0.png",62604,71,62,33,57,1,0.515152,0.438596,[],[-0.214579,-0.4167,0.0462945,-0.416441,0.0471515,-0.238165,-0.216294,
-0.24032],0],["messi-sheet0.png",62604,195,1,36,59,1,0.527778,0.440678,[],[-0.254984,-0.418781,-0.0244128,-0.418523,-0.0235558,-0.240247,-0.253226,-0.242402],0],["messi-sheet0.png",62604,80,1,37,60,1,0.621622,0.433333,[],[-0.266996,-0.411437,-0.0364246,-0.411178,-0.0355676,-0.249569,-0.268711,-0.251724],0],["messi-sheet0.png",62604,190,61,34,59,1,0.529412,0.491525,[],[-0.11487,-0.469629,0.119378,-0.46937,0.116559,-0.293213,-0.112908,-0.293249],0]]]],[["Bullet",cr.behaviors.Bullet,7943771565064547]],
!1,!1,9151717498977714,[],null],["t54",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!0,1,0,!1,6838506836490032,[["masherano-sheet1.png",5956,1,1,27,59,1,0.555556,0.474576,[],[0.0138884,-0.266949,0.0138884,-0.45339,0.324074,-0.451271,0.324074,-0.26483],0],["masherano-sheet0.png",6062,1,61,26,62,1,0.538462,0.467742,[],[-0.00747859,-0.276244,-0.00747859,-0.446556,0.302706,-0.446453,0.302706,-0.274125],0],["masherano-sheet1.png",5956,1,61,24,60,1,0.541667,0.5,[],[-0.0138887,-0.292373,-0.0138887,-0.478814,
0.369213,-0.478778,0.369212,-0.292338],0],["masherano-sheet0.png",6062,1,1,29,59,1,0.62069,0.508475,[],[-0.0167626,-0.300848,-0.0167626,-0.487288,0.293422,-0.48517,0.293422,-0.298729],0],["masherano-sheet1.png",5956,29,1,27,59,1,0.555556,0.474576,[],[0.0138884,-0.266949,0.0138884,-0.45339,0.324074,-0.451271,0.324074,-0.26483],0],["masherano-sheet0.png",6062,28,61,26,62,1,0.538462,0.467742,[],[-0.00747859,-0.276244,-0.00747859,-0.446556,0.302706,-0.446453,0.302706,-0.274125],0],["masherano-sheet1.png",
5956,26,61,24,60,1,0.541667,0.5,[],[-0.0138887,-0.30279,-0.0138887,-0.478814,0.379629,-0.478778,0.379629,-0.302754],0],["masherano-sheet0.png",6062,31,1,29,59,1,0.62069,0.508475,[],[-0.0167626,-0.317797,-0.0167626,-0.487288,0.293422,-0.48517,0.293422,-0.315678],0],["masherano-sheet0.png",6062,61,1,29,59,1,0.62069,0.508475,[],[-0.0167626,-0.317797,-0.0167626,-0.487288,0.293422,-0.48517,0.293422,-0.315678],0],["masherano-sheet1.png",5956,51,61,24,60,1,0.541667,0.5,[],[-0.0138887,-0.30279,-0.0138887,
-0.478814,0.337963,-0.478778,0.337963,-0.302754],0],["masherano-sheet0.png",6062,55,61,26,62,1,0.538462,0.467742,[],[-0.00747859,-0.276244,-0.00747859,-0.446556,0.293091,-0.446453,0.293091,-0.274125],0],["masherano-sheet1.png",5956,57,1,27,59,1,0.555556,0.474576,[],[0.0138884,-0.266949,0.0138884,-0.45339,0.324074,-0.451271,0.324074,-0.26483],0],["masherano-sheet0.png",6062,91,1,29,59,1,0.62069,0.508475,[],[-0.0167626,-0.317797,-0.0167626,-0.489407,0.293422,-0.487288,0.293422,-0.315678],0],["masherano-sheet1.png",
5956,76,61,24,60,1,0.541667,0.5,[],[-0.0138887,-0.292373,-0.0138887,-0.478814,0.348379,-0.478778,0.348379,-0.292338],0],["masherano-sheet0.png",6062,82,61,26,62,1,0.538462,0.467742,[],[-0.00747859,-0.276244,-0.00747859,-0.446556,0.302706,-0.446453,0.302706,-0.274125],0],["masherano-sheet1.png",5956,85,1,27,59,1,0.555556,0.474576,[],[0.0138884,-0.266949,0.0138884,-0.45339,0.324074,-0.451271,0.324074,-0.26483],0]]]],[["Bullet",cr.behaviors.Bullet,0x5ed79aa5f31fb]],!1,!1,17822286832307,[],null],["t55",
cr.plugins_.Sprite,!1,[],2,0,null,[["Animation2",5,!1,1,0,!1,8455613943593906,[["zlatan-sheet0.png",51265,213,128,21,67,1,0.571429,0.507463,[],[-0.36853,-0.133034,-0.00621158,-0.466367,0.196687,-0.0828047,-0.00621158,0.451441,-0.310559,0.0770123,-0.412009,-0.0188787],0]]],["Default",10,!1,1,0,!1,5432376421605478,[["zlatan-sheet0.png",51265,103,124,42,60,1,0.5,0.416667,[],[-0.208095,-0.0623336,0,-0.284,0.398095,-0.195334,0.063333,0.0833333,0.19,0.216333,0,0.292333,-0.316667,0.305,-0.244286,0.0833333],
0],["zlatan-sheet0.png",51265,109,1,53,59,1,0.54717,0.525424,[],[-0.236604,-0.212543,1.78814E-7,-0.386441,0.236604,-0.212543,0.179245,2.98023E-7,0.222264,0.199661,1.78814E-7,0.0901693,-0.286793,0.257627,-0.164906,2.98023E-7],0],["zlatan-sheet0.png",51265,160,62,49,61,1,0.571429,0.508197,[],[-0.175511,-0.12459,-0.0204086,-0.317705,0.181224,-0.161967,0.126938,2.98023E-7,0.212244,0.186885,-0.0204086,0.180655,-0.268572,0.199344,-0.167756,2.98023E-7],0],["zlatan-sheet0.png",51265,48,127,35,63,1,0.514286,
0.492063,[],[-0.0868568,-0.0482535,2.38419E-7,-0.253334,0.271428,-0.150793,0.293143,-5.06639E-7,0.249714,0.13873,2.38419E-7,0.470476,-0.336572,0.186985,-0.0977148,-5.06639E-7],0],["zlatan-sheet0.png",51265,54,64,48,62,1,0.4375,0.532258,[],[-0.1375,-0.122581,0.020833,-0.288064,0.282083,-0.202258,0.329583,-1.19209E-7,0.36125,0.263548,0.020833,0.226774,-0.406667,0.330968,0.020833,-1.19209E-7],0],["zlatan-sheet0.png",51265,54,1,54,62,1,0.462963,0.5,[],[-0.168889,-0.147097,2.98023E-8,-0.31871,0.204074,
-0.177742,0.19,0,0.478518,0.416774,2.98023E-8,0.220645,-0.239259,0.208387,2.98023E-8,0],0],["zlatan-sheet0.png",51265,163,1,52,60,1,0.423077,0.516667,[],[-0.211923,-0.183667,5.96046E-8,-0.475,0.153462,-0.133,0.241154,3.57628E-7,0.482308,0.418,-0.182692,0.158333,-0.0219229,3.57628E-7],0],["zlatan-sheet0.png",51265,109,61,50,62,1,0.4,0.5,[],[-0.2308,-0.202258,0.02,-0.465806,0.1568,-0.110323,0.1796,0,0.5292,0.410645,-0.1396,0.12871,-0.018,0],0],["zlatan-sheet0.png",51265,146,124,37,62,1,0.378378,0.5,
[],[-0.301622,-0.196129,0.0270266,-0.459677,0.191352,-0.098065,0.417298,0.232903,0.0270266,0.257419,-0.0243244,0.030645,-0.0756754,0],0],["zlatan-sheet0.png",51265,184,128,28,65,1,0.428571,0.507692,[],[-0.325714,-0.140307,-4.47035E-7,-0.461846,0.122143,-0.0526153,0.257858,-3.57628E-7,0.420715,0.181231,-4.47035E-7,0.116923,-0.108571,0.0467697,-0.19,-3.57628E-7],0],["zlatan-sheet0.png",51265,210,62,42,65,1,0.285714,0.507692,[],[-0.153809,-0.0993843,-2.98023E-7,-0.479385,0.253334,-0.163692,0.180953,
-3.57628E-7,0.506667,0.327385,-2.98023E-7,0.456,-0.0995243,0.0643077,-0.126666,-3.57628E-7],0],["zlatan-sheet0.png",51265,1,1,52,66,1,0.423077,0.5,[],[-0.226539,-0.178485,5.96046E-8,-0.472121,0.270385,-0.21303,0.160769,0,0.394615,0.310909,5.96046E-8,0.103636,-0.182692,0.143939,-0.153462,0],0],["zlatan-sheet0.png",51265,1,68,46,59,1,0.521739,0.559322,[],[-0.170435,-0.115932,-0.0217391,-0.528136,0.0443479,-0.0515251,0.432609,0.354237,-0.0217391,0.148136,-0.50087,0.373559,-0.186956,-5.96046E-8],0],["zlatan-sheet0.png",
51265,1,128,30,62,1,0.6,0.532258,[],[-0.228,-0.110323,0,-0.502581,0.164667,-0.0796771,0.177333,-1.19209E-7,0.329333,0.159355,0,0.226774,-0.519333,0.25129,-0.240667,-1.19209E-7],0]]]],[["Bullet",cr.behaviors.Bullet,0x5f9c33c6fd719],["DestroyOutsideLayout",cr.behaviors.destroy,8147176731599865]],!1,!1,6701417063292692,[],null],["t56",cr.plugins_.Sprite,!1,[],1,0,null,[["Espa\u00f1ol",5,!1,1,0,!1,380919311931103,[["messi1-sheet1.png",46034,0,0,471,168,1,0.369427,0.464286,[],[-0.0821857,0.372933,-0.0201198,
0.372816,-0.0201378,0.529762,-0.0821468,0.528274],0]]],["Ingles",5,!1,1,0,!1,0xa3a2b9df3aed5,[["messi1-sheet0.png",151275,1,1,472,168,1,0.370763,0.464286,[],[-0.0820117,0.372933,-0.0200767,0.372816,-0.0200957,0.529762,-0.0819727,0.528274],0]]],["Frances",5,!1,1,0,!1,6532898251152021,[["messi1-sheet0.png",151275,1,170,472,168,1,0.370763,0.464286,[],[-0.0820117,0.372933,-0.0200767,0.372816,-0.0200957,0.529762,-0.0819727,0.528274],0]]],["Sueco",5,!1,1,0,!1,9815890192233344,[["messi1-sheet0.png",151275,
1,339,472,168,1,0.370763,0.464286,[],[-0.0820117,0.372933,-0.0200767,0.372816,-0.0200957,0.529762,-0.0819727,0.528274],0]]]],[["DestroyOutsideLayout",cr.behaviors.destroy,5077038805540958]],!1,!1,0x6aea790dedfd9,[],null],["t57",cr.plugins_.Sprite,!1,[],1,0,null,[["Espa\u00f1ol",5,!1,1,0,!1,8282186501559157,[["messi2-sheet1.png",62549,0,0,465,168,1,0.655914,0.464286,[],[-0.0824419,0.373197,-0.021506,0.372321,-0.02157,0.529762,-0.082351,0.529762],0]]],["Ingles",5,!1,1,0,!1,9702130604320832,[["messi2-sheet0.png",
194881,1,1,501,168,1,0.608782,0.464286,[],[-0.0765184,0.373197,-0.0199604,0.372321,-0.0200194,0.529762,-0.0764334,0.529762],0]]],["Frances",5,!1,1,0,!1,7430657321148362,[["messi2-sheet0.png",194881,1,170,494,168,1,0.617409,0.464286,[],[-0.0776029,0.373197,-0.0202439,0.372321,-0.020303,0.529762,-0.077516,0.529762],0]]],["Sueco",5,!1,1,0,!1,6531935783276206,[["messi2-sheet0.png",194881,1,339,494,168,1,0.617409,0.464286,[],[-0.0776029,0.373197,-0.0202439,0.372321,-0.020303,0.529762,-0.077516,0.529762],
0]]]],[["DestroyOutsideLayout",cr.behaviors.destroy,0xd7b35d4b37219]],!1,!1,0x6707951db164e,[],null],["t58",cr.plugins_.Sprite,!1,[],1,0,null,[["Espa\u00f1ol",5,!1,1,0,!1,0x6a408493b27f8,[["hermoso2-sheet0.png",158802,1,170,476,168,1,0.640756,0.464286,[],[-0.0791973,0.529762,-0.0214853,0.529762,-0.0214903,0.375826,-0.0791883,0.375694],0]]],["Ingles",5,!1,1,0,!1,9881573408354032,[["hermoso2-sheet1.png",53027,0,0,472,168,1,0.646186,0.464286,[],[-0.0798684,0.529762,-0.0216674,0.529762,-0.0216724,0.375826,
-0.0798594,0.375694],0]]],["Frances",5,!1,1,0,!1,0x7ddfe3491cfb3,[["hermoso2-sheet0.png",158802,1,1,478,168,1,0.638075,0.464286,[],[-0.0788653,0.529762,-0.0213953,0.529762,-0.0214003,0.375826,-0.0788573,0.375694],0]]],["Sueco",5,!1,1,0,!1,9851436375022216,[["hermoso2-sheet0.png",158802,1,339,474,168,1,0.64346,0.464286,[],[-0.0795309,0.529762,-0.0215759,0.529762,-0.0215809,0.375826,-0.0795229,0.375694],0]]]],[["DestroyOutsideLayout",cr.behaviors.destroy,0x3b586e6d7b79d]],!1,!1,8430716719175831,[],
null],["t59",cr.plugins_.Sprite,!1,[],1,0,null,[["Espa\u00f1ol",5,!1,1,0,!1,0x38fad94313b21,[["hermoso1-sheet0.png",126198,1,339,468,168,1,0.371795,0.464286,[],[-0.0228969,0.372916,-0.0229329,0.529762,-0.0810739,0.528274,-0.0810869,0.3728],0]]],["Ingles",5,!1,1,0,!1,7725170250404137,[["hermoso1-sheet0.png",126198,1,1,469,168,1,0.373134,0.464286,[],[-0.0228483,0.372916,-0.0228833,0.529762,-0.0809013,0.528274,-0.0809143,0.3728],0]]],["Frances",5,!1,1,0,!1,5937971697810586,[["hermoso1-sheet1.png",43521,
0,0,468,168,1,0.371795,0.464286,[],[-0.0228969,0.372916,-0.0229329,0.529762,-0.0810739,0.528274,-0.0810869,0.3728],0]]],["Sueco",5,!1,1,0,!1,0xa67ca550c06b8,[["hermoso1-sheet0.png",126198,1,170,469,168,1,0.373134,0.464286,[],[-0.0228483,0.372916,-0.0228833,0.529762,-0.0809013,0.528274,-0.0809143,0.3728],0]]]],[["DestroyOutsideLayout",cr.behaviors.destroy,419316116069487]],!1,!1,0xd0ab4b617271d,[],null],["t60",cr.plugins_.Sprite,!1,[],1,0,null,[["Espa\u00f1ol",5,!1,1,0,!1,0xed188a963de19,[["tristano1-sheet0.png",
165742,1,1,465,168,1,0.376344,0.464286,[],[-0.0225801,0.529762,-0.0223281,0.369047,-0.0806161,0.370535,-0.0802261,0.528273],0]]],["Ingles",5,!1,1,0,!1,5164536776872691,[["tristano1-sheet0.png",165742,1,170,465,168,1,0.376344,0.464286,[],[-0.0225801,0.529762,-0.0223281,0.369047,-0.0806161,0.370535,-0.0802261,0.528273],0]]],["Frances",5,!1,1,0,!1,0xa502cab109175,[["tristano1-sheet0.png",165742,1,339,465,168,1,0.376344,0.464286,[],[-0.0225801,0.529762,-0.0223281,0.369047,-0.0806161,0.370535,-0.0802261,
0.528273],0]]],["Sueco",5,!1,1,0,!1,0x605775be59abb,[["tristano1-sheet1.png",53907,0,0,465,168,1,0.376344,0.464286,[],[-0.0225801,0.529762,-0.0223281,0.369047,-0.0806161,0.370535,-0.0802261,0.528273],0]]]],[["DestroyOutsideLayout",cr.behaviors.destroy,0xd492455d3db7]],!1,!1,9974056159897928,[],null],["t61",cr.plugins_.Sprite,!1,[],1,0,null,[["Espa\u00f1ol",5,!1,1,0,!1,7470871612796473,[["tristano2-sheet0.png",153652,1,170,460,168,1,0.663043,0.464286,[],[-0.0219235,0.370222,-0.0221375,0.529762,-0.0842385,
0.529762,-0.0837885,0.370536],0]]],["Ingles",5,!1,1,0,!1,5092568571540784,[["tristano2-sheet0.png",153652,1,1,502,168,1,0.60757,0.464286,[],[-0.0200897,0.370222,-0.0202857,0.529762,-0.0771907,0.529762,-0.0767787,0.370536],0]]],["Frances",5,!1,1,0,!1,0xac744a98aa3b4,[["tristano2-sheet0.png",153652,1,339,448,168,1,0.680804,0.464286,[],[-0.0225116,0.370222,-0.0227306,0.529762,-0.0864956,0.529762,-0.0860336,0.370536],0]]],["Sueco",5,!1,1,0,!1,8803840627385078,[["tristano2-sheet1.png",51131,0,0,448,168,
1,0.939732,0.422619,[],[-0.28144,0.411889,-0.281659,0.571429,-0.345424,0.571429,-0.344962,0.412203],0]]]],[["DestroyOutsideLayout",cr.behaviors.destroy,0xa69b70285e607]],!1,!1,7253715871284672,[],null],["t62",cr.plugins_.Sprite,!1,[],1,0,null,[["Espa\u00f1ol",5,!1,1,0,!1,0xbe76684c6749,[["tristano3-sheet0.png",140744,1,1,465,168,1,0.376344,0.464286,[],[-0.0207151,0.376984,-0.0208431,0.529762,-0.0822581,0.529762,-0.0818381,0.376487],0]]],["Ingles",5,!1,1,0,!1,8392129686628406,[["tristano3-sheet0.png",
140744,1,170,465,168,1,0.376344,0.464286,[],[-0.0207151,0.376984,-0.0208431,0.529762,-0.0822581,0.529762,-0.0818381,0.376487],0]]],["Frances",5,!1,1,0,!1,8307970243383198,[["tristano3-sheet0.png",140744,1,339,465,168,1,0.376344,0.464286,[],[-0.0207151,0.376984,-0.0208431,0.529762,-0.0822581,0.529762,-0.0818381,0.376487],0]]],["Sueco",5,!1,1,0,!1,0x936ceff062872,[["tristano3-sheet1.png",45137,0,0,465,168,1,0.376344,0.464286,[],[-0.0207151,0.376984,-0.0208431,0.529762,-0.0822581,0.529762,-0.0818381,
0.376487],0]]]],[["DestroyOutsideLayout",cr.behaviors.destroy,0x60d6378c5de1f]],!1,!1,0xc21bf69f401a6,[],null],["t63",cr.plugins_.Sprite,!1,[],1,0,null,[["Espa\u00f1ol",5,!1,1,0,!1,7037117548761592,[["tristano4-sheet1.png",56269,0,0,433,168,1,0.704388,0.464286,[],[-0.0850689,0.374685,-0.0230939,0.374702,-0.023672,0.529762,-0.084941,0.529762],0]]],["Ingles",5,!1,1,0,!1,6945118401997324,[["tristano4-sheet0.png",169084,1,1,494,168,1,0.617409,0.464286,[],[-0.0745649,0.374685,-0.0202419,0.374702,-0.0207489,
0.529762,-0.0744529,0.529762],0]]],["Frances",5,!1,1,0,!1,0x760d0a9454dd2,[["tristano4-sheet0.png",169084,1,339,468,168,1,0.651709,0.464286,[],[-0.0787074,0.374685,-0.0213664,0.374702,-0.0219014,0.529762,-0.0785894,0.529762],0]]],["Sueco",5,!1,1,0,!1,0xc5d9d11b605ac,[["tristano4-sheet0.png",169084,1,170,481,168,1,0.634096,0.464286,[],[-0.0765796,0.374685,-0.0207896,0.374702,-0.0213096,0.529762,-0.0764646,0.529762],0]]]],[["DestroyOutsideLayout",cr.behaviors.destroy,618805919600782]],!1,!1,7137041728721558,
[],null],["t64",cr.plugins_.Sprite,!1,[],1,0,null,[["Espa\u00f1ol",5,!1,1,0,!1,8606277779921029,[["tristano5-sheet0.png",136299,1,1,465,168,1,0.376344,0.464286,[],[-0.0191021,0.369543,-0.0192311,0.529762,-0.0811831,0.529762,-0.0807631,0.370535],0]]],["Ingles",5,!1,1,0,!1,0xb23bef2234ce0,[["tristano5-sheet1.png",46061,0,0,464,168,1,0.375,0.464286,[],[-0.019144,0.369543,-0.019273,0.529762,-0.081358,0.529762,-0.080937,0.370535],0]]],["Frances",5,!1,1,0,!1,0x82d24f616a829,[["tristano5-sheet0.png",136299,
1,170,465,168,1,0.376344,0.464286,[],[-0.0191021,0.369543,-0.0192311,0.529762,-0.0811831,0.529762,-0.0807631,0.370535],0]]],["Sueco",5,!1,1,0,!1,0x752263f77b4c,[["tristano5-sheet0.png",136299,1,339,465,168,1,0.376344,0.464286,[],[-0.0191021,0.369543,-0.0192311,0.529762,-0.0811831,0.529762,-0.0807631,0.370535],0]]]],[["DestroyOutsideLayout",cr.behaviors.destroy,0x4dde1a1c6ce1a]],!1,!1,8331904276868024,[],null],["t65",cr.plugins_.Sprite,!1,[],1,0,null,[["Espa\u00f1ol",5,!1,1,0,!1,0xabd17fe0b1659,[["tristano6-sheet0.png",
198686,1,339,466,168,1,0.654506,0.464286,[],[-0.0811914,0.373198,-0.0198504,0.372883,-0.0198494,0.528274,-0.0810724,0.529762],0]]],["Ingles",5,!1,1,0,!1,0x8fe3905e761a3,[["tristano6-sheet0.png",198686,1,170,491,168,1,0.621181,0.464286,[],[-0.0770583,0.373198,-0.0188403,0.372883,-0.0188392,0.528274,-0.0769442,0.529762],0]]],["Frances",5,!1,1,0,!1,499955871736085,[["tristano6-sheet1.png",64948,0,0,451,168,1,0.676275,0.464286,[],[-0.0838919,0.373198,-0.020511,0.372883,-0.02051,0.528274,-0.083769,0.529762],
0]]],["Sueco",5,!1,1,0,!1,0xb61d63811e6e4,[["tristano6-sheet0.png",198686,1,1,501,168,1,0.608782,0.464286,[],[-0.0755194,0.373198,-0.0184634,0.372883,-0.0184624,0.528274,-0.0754084,0.529762],0]]]],[["DestroyOutsideLayout",cr.behaviors.destroy,0xc466c6300eaf0]],!1,!1,0x55989c83e77f5,[],null],["t66",cr.plugins_.Sprite,!1,[],1,0,null,[["Espa\u00f1ol",5,!1,1,0,!1,8211681808391933,[["ronaldinho1-sheet0.png",100122,1,1,474,173,1,0.369198,0.479769,[],[-0.0822043,0.364884,-0.0822783,0.514451,-0.0205363,0.514451,
-0.0206683,0.364162],0]]],["Ingles",5,!1,1,0,!1,8818292278432012,[["ronaldinho1-sheet1.png",100532,1,175,473,173,1,0.367865,0.479769,[],[-0.0823777,0.364884,-0.0824527,0.514451,-0.0205797,0.514451,-0.0207117,0.364162],0]]],["Frances",5,!1,1,0,!1,7041011666688748,[["ronaldinho1-sheet0.png",100122,1,175,474,173,1,0.369198,0.479769,[],[-0.0822043,0.364884,-0.0822783,0.514451,-0.0205363,0.514451,-0.0206683,0.364162],0]]],["Sueco",5,!1,1,0,!1,6682689434120629,[["ronaldinho1-sheet1.png",100532,1,1,474,
173,1,0.369198,0.479769,[],[-0.0822043,0.364884,-0.0822783,0.514451,-0.0205363,0.514451,-0.0206683,0.364162],0]]]],[["DestroyOutsideLayout",cr.behaviors.destroy,5246999006263404]],!1,!1,7938133439493129,[],null],["t67",cr.plugins_.Sprite,!1,[],1,0,null,[["Espa\u00f1ol",5,!1,1,0,!1,0xd1169d45bfeb3,[["ronaldinho2-sheet1.png",58221,0,0,443,168,1,0.688488,0.464286,[],[-0.0842776,0.377661,-0.0241156,0.376487,-0.0242666,0.529762,-0.0841526,0.529762],0]]],["Ingles",5,!1,1,0,!1,0xf8605bb9c109b,[["ronaldinho2-sheet0.png",
186007,1,170,492,168,1,0.619919,0.464286,[],[-0.0766847,0.377661,-0.0205877,0.376487,-0.0207387,0.535714,-0.0765597,0.535714],0]]],["Frances",5,!1,1,0,!1,0xd6dabf9d69787,[["ronaldinho2-sheet0.png",186007,1,1,504,168,1,0.605159,0.464286,[],[-0.0743607,0.377661,-0.0201517,0.376487,-0.0203028,0.535714,-0.0742357,0.535714],0]]],["Sueco",5,!1,1,0,!1,0x3e0e4978dde90,[["ronaldinho2-sheet0.png",186007,1,339,472,168,1,0.646186,0.464286,[],[-0.0801124,0.377661,-0.0199504,0.376487,-0.0201014,0.535714,-0.0799874,
0.535714],0]]]],[["DestroyOutsideLayout",cr.behaviors.destroy,0x66fa6fd01c961]],!1,!1,9120499440993902,[],null],["t68",cr.plugins_.Sprite,!1,[],1,0,null,[["Espa\u00f1ol",5,!1,1,0,!1,0xce51d799a357,[["pique1-sheet0.png",87488,1,1,461,173,1,0.37744,0.479769,[],[-0.0214533,0.361897,-0.0215763,0.514451,-0.0824293,0.514451,-0.0819773,0.361271],0]]],["Ingles",5,!1,1,0,!1,0x39084ae7b42e5,[["pique1-sheet0.png",87488,1,175,461,173,1,0.37744,0.479769,[],[-0.0214533,0.361897,-0.0215763,0.514451,-0.0824293,0.514451,
-0.0819773,0.361271],0]]],["Frances",5,!1,1,0,!1,4671548416884296,[["pique1-sheet1.png",86408,1,1,461,173,1,0.37744,0.479769,[],[-0.0214533,0.361897,-0.0215763,0.514451,-0.0824293,0.514451,-0.0819773,0.361271],0]]],["Sueco",5,!1,1,0,!1,0x46be836547590,[["pique1-sheet1.png",86408,1,175,461,173,1,0.37744,0.479769,[],[-0.0214533,0.361897,-0.0215763,0.514451,-0.0824293,0.514451,-0.0819773,0.361271],0]]]],[["DestroyOutsideLayout",cr.behaviors.destroy,923068988158651]],!1,!1,709409310695663,[],null],["t69",
cr.plugins_.Sprite,!1,[],1,0,null,[["Espa\u00f1ol",5,!1,1,0,!1,691123708239367,[["pique2-sheet1.png",55294,0,0,433,168,1,0.704388,0.464286,[],[-0.086224,0.377661,-0.023672,0.376571,-0.024249,0.529762,-0.0860969,0.529762],0]]],["Ingles",5,!1,1,0,!1,0xe1e19f64a6b0c,[["pique2-sheet0.png",164106,1,1,491,168,1,0.621181,0.464286,[],[-0.0760382,0.377661,-0.0208762,0.376571,-0.0213842,0.529762,-0.0759262,0.529762],0]]],["Frances",5,!1,1,0,!1,9190492830297218,[["pique2-sheet0.png",164106,1,170,480,168,1,0.635417,
0.464286,[],[-0.0777817,0.377661,-0.0213547,0.376571,-0.0218747,0.529762,-0.0776667,0.529762],0]]],["Sueco",5,!1,1,0,!1,4803267758510764,[["pique2-sheet0.png",164106,1,339,452,168,1,0.674779,0.464286,[],[-0.0825998,0.377661,-0.0226768,0.376571,-0.0232298,0.529762,-0.0824777,0.529762],0]]]],[["DestroyOutsideLayout",cr.behaviors.destroy,0x5e017e2b4e201]],!1,!1,496782845782384,[],null],["t70",cr.plugins_.Sprite,!1,[],1,0,null,[["Espa\u00f1ol",5,!1,1,0,!1,0x8a75672e7ebab,[["pique3-sheet0.png",22541,1,
170,255,173,1,0.682353,0.479769,[],[-0.039215,0.514451,-0.0385749,0.365606,-0.148038,0.364258,-0.147804,0.514451],0]]],["Ingles",5,!1,1,0,!1,8312478641907515,[["pique3-sheet0.png",22541,1,1,349,168,1,0.498567,0.464286,[],[-0.0286523,0.529762,-0.0281853,0.376488,-0.108165,0.375099,-0.107994,0.529762],0]]]],[["DestroyOutsideLayout",cr.behaviors.destroy,5444738491064338]],!1,!1,6621101348669325,[],null],["t71",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,7961995334141317,[["brasil-sheet0.png",
107,0,0,50,50,1,0.5,0.5,[],[],3]]]],[],!1,!0,7348294618053126,[],null],["t72",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,5071808530058302,[["mexico-sheet0.png",4748,0,0,50,50,1,0.5,0.5,[],[-0.5,0.5,-0.5,-0.5,0.5,-0.5,0.5,0.5],0]]]],[],!1,!0,5189735349241226,[],null],["t73",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x76fc63dc48073,[["inglaterra-sheet0.png",4754,0,0,50,50,1,0.5,0.5,[],[],0]]]],[],!1,!0,5423049121433445,[],null],["t74",cr.plugins_.Sprite,!1,[],0,0,null,
[["Default",5,!1,1,0,!1,9847273945463164,[["inglaterra-sheet0.png",4754,0,0,50,50,1,0.5,0.5,[],[],0]]]],[],!1,!0,0x6cdd3c63ed08f,[],null],["t75",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x86f19b8a8dde9,[["inglaterra-sheet0.png",4754,0,0,50,50,1,0.5,0.5,[],[0.5,-0.5,0.5,0.5,-0.5,0.5,-0.5,-0.5],0]]]],[],!1,!0,5586224794746552,[],null],["t76",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xb06e554d0c344,[["inglaterra-sheet0.png",4754,0,0,50,50,1,0.5,0.5,[],[],0]]]],[],!1,
!0,8805200639080074,[],null],["t77",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xa3515f0ea2b49,[["inglaterra-sheet0.png",4754,0,0,50,50,1,0.5,0.5,[],[],0]]]],[],!1,!0,0x88ea7831b4471,[],null],["t78",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x536bc885fc2f5,[["inglaterra-sheet0.png",4754,0,0,50,50,1,0.5,0.5,[],[],0]]]],[],!1,!0,4678326592377381,[],null],["t79",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0x7e5b0f91ba6b3,[],null],["t80",cr.plugins_.Text,!1,[],0,0,null,
null,[],!1,!1,8421584064467871,[],null],["t81",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,8427231383942397,[],null],["t82",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0xed0cd3fee248c,[],null],["t83",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0xc2c600b344545,[],null],["t84",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,929620301735644,[],null],["t85",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,8414178852907249,[],null],["t86",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,7579563486187352,
[],null],["t87",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,9540614363093992,[],null],["t88",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,8548066680445138,[],null],["t89",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0x3e0a19eaddc89,[],null],["t90",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0x9946170166d74,[],null],["t91",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,7411353506745828,[],null],["t92",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0x453a1324e8b84,[],null],["t93",cr.plugins_.Text,
!1,[],0,0,null,null,[],!1,!1,0xdd12de75e1f8f,[],null],["t94",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,8264842083178683,[],null],["t95",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0x6aaf40e2fa149,[],null],["t96",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,676854313345283,[],null],["t97",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,9699589025199508,[],null],["t98",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0x898640e5f542b,[],null],["t99",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,7971231708140502,
[],null],["t100",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0xcd7064e38b629,[],null],["t101",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,68567467524647,[],null],["t102",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,6504208871418991,[],null],["t103",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0xa54db8a0f7c8,[],null],["t104",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,7880840468381531,[],null],["t105",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,396793671760344,[],null],["t106",cr.plugins_.Text,
!1,[],0,0,null,null,[],!1,!1,0x61af0140a3cb5,[],null],["t107",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,924489634681325,[],null],["t108",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0x88d46506a81fa,[],null],["t109",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,4743939498375094,[],null],["t110",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,6438845802085625,[],null],["t111",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,7476657070801002,[],null],["t112",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,
!1,0x79d100804961d,[],null],["t113",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,7340457724239956,[],null],["t114",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,9494112886714536,[],null],["t115",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0x6749ce6d61a24,[],null],["t116",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,6620290241263256,[],null],["t117",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0xa62db8e43c0e1,[],null],["t118",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0x3a47bf71df7fd,[],null],
["t119",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0xd4c5f89b88a41,[],null],["t120",cr.plugins_.Text,!1,[],1,0,null,null,[["DestroyOutsideLayout",cr.behaviors.destroy,9702449560911924]],!1,!1,6377173689450227,[],null],["t121",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!0,6162175767171887,[],null],["t122",cr.plugins_.Text,!1,[],1,0,null,null,[["DestroyOutsideLayout",cr.behaviors.destroy,0xa49a7bf2f9ee4]],!1,!1,0x724e2eb20425e,[],null],["t123",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,6113780754892822,
[],null],["t124",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!0,0x72677ce712a92,[],null],["t125",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,9133572182786694,[],null],["t126",cr.plugins_.Text,!1,[],1,0,null,null,[["DestroyOutsideLayout",cr.behaviors.destroy,0xf4dffc7804377]],!1,!0,9849713425992276,[],null],["t127",cr.plugins_.Text,!1,[],1,0,null,null,[["DestroyOutsideLayout",cr.behaviors.destroy,7945884498540714]],!1,!0,7873924915650064,[],null],["t128",cr.plugins_.Text,!1,[],1,0,null,null,[["DestroyOutsideLayout",
cr.behaviors.destroy,9314760747597936]],!1,!0,8311146458696066,[],null],["t129",cr.plugins_.Text,!1,[],1,0,null,null,[["DestroyOutsideLayout",cr.behaviors.destroy,4631018933746263]],!1,!0,537056884607183,[],null],["t130",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,6401486955305076,[["balonrayo-sheet0.png",1996,0,0,25,23,1,0.52,0.521739,[],[],0]]]],[["Sine",cr.behaviors.Sin,8317582663857243]],!1,!1,0xf800019d1e088,[],null],["t131",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,
0,!1,6069392707733568,[["sombrabalonrayo-sheet0.png",768,0,0,16,11,1,0.5625,0.636364,[],[-0.372024,-0.425838,-0.08631,-0.531101,0.247024,-0.425838,0.389881,-0.16268,0.294643,0.205741,-0.08631,0.363636,-0.372024,0.15311,-0.514881,-0.16268],0]]]],[],!1,!1,0x838c831ca4e1e,[],null],["t132",cr.plugins_.Sprite,!1,[],3,0,null,[["Default",5,!1,1,0,!1,8424501027122912,[["balone-sheet0.png",733,0,0,13,13,1,0.538462,0.538462,[],[-0.388462,-0.388462,-0.0384616,-0.538462,0.311538,-0.388462,0.461538,-0.0384616,
0.311538,0.311538,-0.0384616,0.461538,-0.388462,0.311538,-0.528462,-0.0384616],0]]]],[["Physics",cr.behaviors.Physics,765962027785803],["Rotate",cr.behaviors.Rotate,0xbbc3a3fbd462b],["DestroyOutsideLayout",cr.behaviors.destroy,8627578865082486]],!1,!1,9812128334912076,[],null],["t133",cr.plugins_.Sprite,!1,[],3,0,null,[["Default",5,!1,1,0,!1,0x67640041c66b5,[["balonp-sheet0.png",3568,38,21,18,18,1,0.5,0.5,[],[-0.435484,-0.230159,0.016129,-0.484127,0.435484,-0.198413,0.483871,-0.02381,0.451613,0.166667,
0.016129,0.484127,-0.451613,0.198413,-0.483871,-0.02381],0]]],["Tiro",5,!1,1,0,!1,0xf5fcd5a467811,[["balonp-sheet0.png",3568,38,40,18,18,1,0.5,0.5,[],[-0.460396,-0.173267,-0.064356,-0.490099,0.420792,-0.252475,0.490099,-0.044554,0.450495,0.20297,-0.064356,0.490099,-0.480198,0.113861,-0.490099,-0.044554],0]]],["BalonRasho",5,!1,1,0,!1,8107247121093024,[["balonp-sheet0.png",3568,38,1,21,19,1,0.47619,0.526316,[],[-0.255952,-0.401316,-4.76837E-7,-0.486842,0.29762,-0.394737,0.476191,-0.0526318,0.470238,
0.223684,0.220238,0.473684,-0.202381,0.473684,-0.410714,0.171052,-0.419643,-0.1875],0]]],["3Balones",5,!1,1,0,!1,8131487154758423,[["balonp-sheet0.png",3568,1,1,36,54,1,0.75,0.5,[],[0.25,0.120371,-0.375,0.5,-0.75,0.5,-0.75,-0.5,-0.381945,-0.5,0.25,-0.078703],0]]]],[["Physics",cr.behaviors.Physics,0xd6c1b3f98ad2a],["DestroyOutsideLayout",cr.behaviors.destroy,9540441154382032],["Rotate",cr.behaviors.Rotate,9677074800192948]],!1,!1,797269412778367,[],null],["t134",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",
5,!1,1,0,!1,0x8796c9e25c1a9,[["balonp-sheet0.png",3568,38,21,18,18,1,0.5,0.5,[],[-0.435484,-0.230159,0.016129,-0.484127,0.435484,-0.198413,0.483871,-0.02381,0.451613,0.166667,0.016129,0.484127,-0.451613,0.198413,-0.483871,-0.02381],0]]],["Tiro",5,!1,1,0,!1,0xfed63fd08b3ab,[["balonp-sheet0.png",3568,38,40,18,18,1,0.5,0.5,[],[-0.460396,-0.173267,-0.064356,-0.490099,0.420792,-0.252475,0.490099,-0.044554,0.450495,0.20297,-0.064356,0.490099,-0.480198,0.113861,-0.490099,-0.044554],0]]]],[],!1,!1,9208898850058312,
[],null],["t135",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8852078948679588,[["torreta-sheet0.png",107,0,0,1,359,1,1,0.501393,[],[],3]]]],[],!1,!1,0x93be708a63943,[],null],["t136",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x83d10965ceb87,[["balon3-sheet0.png",2022,0,0,30,24,1,0.466667,0.541667,[],[-0.466667,-0.541667,0.533333,-0.541667,0.533333,0.453125,-0.466667,0.458333],0]]]],[["Sine",cr.behaviors.Sin,5750505931197245]],!1,!1,5355092003660488,[],null],["t137",cr.plugins_.Sprite,
!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xa3726520311c,[["sombrabalon3-sheet0.png",856,0,0,21,11,1,0.52381,0.545455,[],[-0.390477,-0.378788,-0.0238096,-0.295455,0.342857,-0.378788,0.409523,-0.0454546,0.209523,0.121212,-0.0238096,0.412878,-0.257143,0.121212,-0.42381,-0.0454546],0]]]],[],!1,!1,0x86577d4273ef7,[],null],["t138",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xedace6d39149b,[["balontiempo-sheet0.png",2896,0,0,27,36,1,0.518519,0.5,[],[],0]]]],[["Sine",cr.behaviors.Sin,4637246527954698]],
!1,!1,5165899650360695,[],null],["t139",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x54f79f97368ff,[["sombrabalontiempo-sheet0.png",1519,0,0,22,20,1,0.545455,0.5,[],[],0]]]],[],!1,!1,8035440026136056,[],null],["t140",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,9732928374234140,[["balonrayo-sheet0.png",1996,0,0,25,23,1,0.52,0.521739,[],[],0]]]],[["Sine",cr.behaviors.Sin,9341207344929992]],!1,!1,8292150375684286,[],null],["t141",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",
5,!1,1,0,!1,8211199608364999,[["sombrabalonrayo-sheet0.png",768,0,0,16,11,1,0.5625,0.636364,[],[-0.372024,-0.425838,-0.08631,-0.531101,0.247024,-0.425838,0.389881,-0.16268,0.294643,0.205741,-0.08631,0.363636,-0.372024,0.15311,-0.514881,-0.16268],0]]]],[],!1,!1,5642698415574838,[],null],["t142",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x4200a9f0e680f,[["sprite2-sheet0.png",9780,0,0,104,56,1,0.5,0.446429,[],[0.5,-0.446429,0.5,0.553571,-0.5,0.553571,-0.5,-0.446429],0]]]],[["DestroyOutsideLayout",
cr.behaviors.destroy,8255360310872005]],!1,!1,7647115679512083,[],null],["t143",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,7820834270103179,[["sprite3-sheet0.png",9195,0,0,241,33,1,0,0.666667,[],[1,0.333333,0,0.333333,0,-0.666667,1,-0.666667],0]]]],[],!1,!1,5600469616651418,[],null],["t144",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,531755074375688,[["sprite4-sheet0.png",331,0,0,640,360,1,0.5,0.5,[],[],3]]]],[["ScrollTo",cr.behaviors.scrollto,0x975524d4abba5]],!1,!1,
0x5a75dee28fd29,[],null],["t145",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8872561212098305,[["sprite5-sheet0.png",19357,0,0,100,100,1,0.5,0.5,[],[],0]]]],[],!1,!0,6869073576219344,[],null],["t146",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,9734502164794706,[["sprite6-sheet0.png",930,0,0,52,25,1,0.5,0.52,[],[-0.225857,-0.493856,0,-0.271634,0.119938,-0.271634,0.498442,-0.02,0.119938,0.231634,0,0.231634,-0.225857,0.453856,-0.498442,-0.02],0]]]],[],!1,!0,0xf5f5cd9fe4ab1,
[],null],["t147",cr.plugins_.Sprite,!0,[],0,0,null,null,[],!1,!1,0x9769aab9b3c17,[],null],["t148",cr.plugins_.Text,!0,[],0,0,null,null,[],!1,!1,0x813aad49fc63,[],null]],[[147,52,20,35,40,45,25,46,47,22,36,50,41,37,26,27,51,24,15,30,42,28,29,54,53,38,31,48,21,32,49,16,39,33,23,43,34,17,18,44,19],[148,79,98,84,85,86,87,88,109,110,111,112,80,113,114,115,116,117,118,89,90,91,92,81,93,99,100,101,102,103,104,105,106,107,82,108,83,94,95,96,97,125]],[["Espanha",640,360,!1,"Event Espanha",0xe38cfd1e7d65c,
[["Layer 0",0,5219311130234725,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[640,0,0,640,538,0,0,1,1,0,0,0,[]],4,90,[],[],[0,"Default",0,1]],[[320,180,0,640,360,0,0,1,0.5,0.5,0,0,[]],0,5,[],[],[0,"Default",0,1]]],[]],["Layer 1",1,0xcfa63ea1546f0,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[69,185,0,21,67,0,0,1,0.571429,0.507463,0,0,[]],55,10,[],[[40,0,0,0,1,0],[]],[0,"Animation2",0,1]],[[367.765,132.762,0,29,61,0,0,1,0.517241,0.491803,0,0,[]],17,4,[],[],[0,"Derecha",0,1]],[[126,168,0,2,18,0,0,1,0.5,0.5,0,0,[]],
71,11,[],[],[0,"Default",0,1]],[[385,155,0,13,13,0,0,1,0.538462,0.538462,0,0,[]],132,12,[],[[1,2,0,2.5,0.5,0.2,0,0.01,0,1],[0,0],[]],[0,"Default",0,1]],[[340.899,50.0448,0,27,60,0,0,1,0.481481,0.5,0,0,[]],18,6,[],[[60,0,0,0,0,1],[]],[0,"Default",0,1]],[[544.055,287.734,0,28,58,0,0,1,0.5,0.5,0,0,[]],16,7,[],[[40,0,0,0,0,1],[]],[0,"Default",0,1]],[[314.906,241.98,0,34,73,0,0,1,0.5,0.479452,0,0,[]],15,14,[],[[]],[0,"Default",0,1]],[[338.662,263.064,0,39,63,0,0,1,0.538462,0.47619,0,0,[]],19,13,[],[[]],
[0,"Default",0,1]],[[120,211,0,40.1721,4.01721,0,0,1,0,0.5,0,0,[]],1,9,[],[],[1,"Default",0,1]],[[304,-160,0,461,173,0,0,1,0.37744,0.479769,0,0,[]],68,111,[],[[]],[0,"Default",0,1]],[[318,-350,0,433,168,0,0,1,0.704388,0.464286,0,0,[]],69,112,[],[[]],[0,"Default",0,1]],[[795,-349,0,255,173,0,0,1,0.682353,0.479769,0,0,[]],70,113,[],[[]],[0,"Default",0,1]],[[85,-109,0,26,25,0,0,1,0.461538,0.52,0,0,[]],3,114,[],[[]],[0,"Default",0,1]],[[11,348,0,18,18,0,0,1,0.5,0.5,0,0,[]],134,133,[],[],[0,"Default",
0,1]],[[25,339,0,200,30,0,0,1,0,0,0,0,[]],119,140,[],[],["1",0,"12pt Arial","rgb(255,255,255)",0,0,0,0,0]],[[558,324,0,99,53,0,0,0.5,0,0,0,0,[]],122,146,[],[[]],["Menu",0,"24pt Arial","rgb(255,255,255)",0,0,0,0,0]],[[364,35,0,41,30,0,0,1,0,0,0,0,[]],94,168,[],[],["Villa",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[223,2,0,200,30,0,0,1,0,0,0,0,[]],125,169,[],[],["Toca para empezar",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[386,118,0,60,30,0,0,1,0,0,0,0,[]],95,170,[],[],["Torres",0,"14pt Arial",
"rgb(255,255,153)",0,0,0,0,0]],[[332,209,0,60,30,0,0,1,0,0,0,0,[]],96,171,[],[],["Iniesta",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[363,250,0,46,30,0,0,1,0,0,0,0,[]],97,172,[],[],["Xavi",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[566,280,0,53,30,0,0,1,0,0,0,0,[]],98,173,[],[],["Pique",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[570,34,0,138,59,0,0,1,0.5,0.576271,0,0,[]],9,211,[],[],[0,"Default",0,1]],[[739,206,0,104,56,0,0,1,0.5,0.446429,0,0,[]],142,225,[],[[]],[0,"Default",0,1]],
[[469,327,0,21,11,0,0,1,0.52381,0.545455,8,0,[]],137,235,[],[],[0,"Default",0,1]],[[121,205,0,13,13,0,0,1,0.5,0.5,0,0,[]],133,8,[],[[0,2,0,2.5,0.5,0.2,0,0.01,0,1],[],[0,0]],[0,"Default",0,1]],[[467,305,0,30,24,0,0,1,0.466667,0.541667,0,0,[]],136,234,[],[[1,1,0,4,0,0,0,10,0]],[0,"Default",0,1]]],[]]],[],[]],["Brasil",641,361,!1,"Event Brasil",7354573964273585,[["Layer 0",0,5439329318600839,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[640,0,0,640,538,0,0,1,1,0,0,0,[]],4,97,[],[],[0,"Default",0,1]],[[320,180,
0,640,360,0,0,1,0.5,0.5,0,0,[]],0,15,[],[],[0,"Default",0,1]],[[320,180,0,640,360,0,0,1,0.5,0.5,0,0,[]],144,247,[],[[1]],[0,"Default",0,1]]],[]],["Layer 1",1,7136839216336943,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[69,185,0,21,67,0,0,1,0.571429,0.507463,0,0,[]],55,16,[],[[40,0,0,0,1,0],[]],[0,"Animation2",0,1]],[[120,211,0,40.1721,4.01721,0,0,1,0,0.5,0,0,[]],1,18,[],[],[1,"Default",0,1]],[[356,80,0,85,64,0,0,1,0.941176,0.90625,0,0,[]],21,19,[],[],[0,"Default",0,1]],[[323,154,0,30,63,0,0,1,0.5,0.492063,
0,0,[]],20,20,[],[[40,0,0,0,0,1],[]],[0,"Default",0,1]],[[126,168,0,2,18,0,0,1,0.5,0.5,0,0,[]],71,21,[],[],[0,"Default",0,1]],[[495,306,0,26,61,0,0,1,0.5,0.47541,0,0,[]],22,22,[],[],[0,"Default",0,1]],[[516,322,0,13,13,0,0,1,0.538462,0.538462,0,0,[]],132,23,[],[[1,2,0,2.5,0.5,0.2,0,0.01,0,1],[0,0],[]],[0,"Default",0,1]],[[246,319,0,26,69,0,0,1,0.538462,0.478261,0,0,[]],23,24,[],[[40,0,0,0,0,1]],[0,"Default",0,1]],[[91,35,0,43,59,0,0,1,1,0.491525,0,0,[]],24,25,[],[[80,0,0,0,0,1]],[0,"Default",0,1]],
[[317,-140,0,474,173,0,0,1,0.369198,0.479769,0,0,[]],66,109,[],[[]],[0,"Default",0,1]],[[313,-316,0,443,168,0,0,1,0.688488,0.464286,0,0,[]],67,110,[],[[]],[0,"Default",0,1]],[[727,211,0,241,33,0,-1.5708,1,0,0.666667,0,0,[]],143,227,[],[],[0,"Default",0,1]],[[11,348,0,18,18,0,0,1,0.5,0.5,0,0,[]],134,129,[],[],[0,"Default",0,1]],[[25,339,0,200,30,0,0,1,0,0,0,0,[]],119,136,[],[],["1",0,"12pt Arial","rgb(255,255,255)",0,0,0,0,0]],[[558,324,0,99,53,0,0,0.5,0,0,0,0,[]],122,147,[],[[]],["Menu",0,"24pt Arial",
"rgb(255,255,255)",0,0,0,0,0]],[[223,2,0,200,30,0,0,1,0,0,0,0,[]],125,162,[],[],["Toca para empezar",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[113,27,0,44,30,0,0,1,0,0,0,0,[]],79,163,[],[],["Hulk",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[314,44,0,73,30,0,0,1,0,0,0,0,[]],80,164,[],[],["Neymar",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[346,143,0,73,30,0,0,1,0,0,0,0,[]],81,165,[],[],["Alves",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[267,306,0,105,30,0,0,1,0,0,0,0,[]],82,166,
[],[],["Ronaldinho",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[513,292,0,64,30,0,0,1,0,0,0,0,[]],83,167,[],[],["D. Luiz",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[570,34,0,138,59,0,0,1,0.5,0.576271,0,0,[]],9,212,[],[],[0,"Default",0,1]],[[565.329,203.96,0,16,11,0,0,1,0.5625,0.636364,8,0,[]],131,228,[],[],[0,"Default",0,1]],[[121,205,0,13,13,0,0,1,0.5,0.5,0,0,[]],133,17,[],[[0,2,1,2.5,0.5,0.2,0,0.01,0,1],[],[0,0]],[0,"Default",0,1]],[[564.677,177.168,0,25,23,0,0,1,0.52,0.521739,0,0,[]],
130,226,[],[[1,1,0,4,0,0,0,10,0]],[0,"Default",0,1]],[[121.5,179.5,0,1,359,0,-0.2618,1,1,0.501393,0,0,[]],135,230,[],[],[0,"Default",0,1]]],[]]],[],[]],["Mexico",640,360,!1,"Event Mexico",8370239268542533,[["Layer 0",0,7126934712599836,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[640,0,0,640,538,0,0,1,1,0,0,0,[]],4,96,[],[],[0,"Default",0,1]],[[320,180,0,640,360,0,0,1,0.5,0.5,0,0,[]],0,26,[],[],[0,"Default",0,1]]],[]],["Layer 1",1,0xa483276cacad0,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[432,157,0,27,57,0,0,
1,0.518519,0.491228,0,0,[]],25,31,[],[[10,0,0,0,0,0]],[0,"Default",0,1]],[[69,185,0,21,67,0,0,1,0.571429,0.507463,0,0,[]],55,29,[],[[40,0,0,0,1,0],[]],[0,"Animation2",0,1]],[[120,211,0,40.1721,4.01721,0,0,1,0,0.5,0,0,[]],1,28,[],[],[1,"Default",0,1]],[[126,168,0,2,18,0,0,1,0.5,0.5,0,0,[]],71,30,[],[],[0,"Default",0,1]],[[442,366,0,13,13,0,0,1,0.538462,0.538462,0,0,[]],132,32,[],[[1,2,0,2.5,0.5,0.2,0,0.01,0,1],[0,0],[]],[0,"Default",0,1]],[[322,317,0,35,57,0,0,1,0.393939,0.508772,0,0,[]],26,33,[],
[[50,0,0,0,0,1]],[0,"Default",0,1]],[[528,297,0,22,61,0,0,1,0.454545,0.409836,0,0,[]],27,34,[],[[10,0,0,0,0,1]],[0,"Default",0,1]],[[116,64,0,14,59,0,0,1,0.357143,0.423729,0,0,[]],28,35,[],[],[0,"Default",0,1]],[[250,62,0,20,58,0,0,1,0.5,0.517241,0,0,[]],29,36,[],[[40,0,0,0,0,1]],[0,"Default",0,1]],[[311,-150,0,468,168,0,0,1,0.371795,0.464286,0,0,[]],59,99,[],[[]],[0,"Default",0,1]],[[-60,-158,0,476,168,0,0,1,0.640756,0.464286,0,0,[]],58,102,[],[[]],[0,"Default",0,1]],[[121,205,0,13,13,0,0,1,0.5,
0.5,0,0,[]],133,27,[],[[0,2,0,2.5,0.5,0.2,0,0.01,0,1],[],[0,0]],[0,"Default",0,1]],[[25,339,0,200,30,0,0,1,0,0,0,0,[]],119,139,[],[],["1",0,"12pt Arial","rgb(255,255,255)",0,0,0,0,0]],[[558,324,0,99,53,0,0,0.5,0,0,0,0,[]],122,148,[],[[]],["Menu",0,"24pt Arial","rgb(255,255,255)",0,0,0,0,0]],[[223,2,0,200,30,0,0,1,0,0,0,0,[]],125,174,[],[],["Toca para empezar",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[131,52,0,55,30,0,0,1,0,0,0,0,[]],84,175,[],[],["Layun",0,"14pt Arial","rgb(255,255,153)",0,
0,0,0,0]],[[260,51,0,78,30,0,0,1,0,0,0,0,[]],85,176,[],[],["Marquez",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[451,143,0,90,30,0,0,1,0,0,0,0,[]],86,177,[],[],["Chicharito",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[341,298,0,79,30,0,0,1,0,0,0,0,[]],87,178,[],[],["Giovanni",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[542,287,0,82,30,0,0,1,0,0,0,0,[]],88,179,[],[],["Hermoso",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[570,34,0,138,59,0,0,1,0.5,0.576271,0,0,[]],9,216,[],[],[0,"Default",
0,1]],[[428,65,0,21,11,0,0,1,0.52381,0.545455,8,0,[]],137,231,[],[],[0,"Default",0,1]],[[11,348,0,18,18,0,0,1,0.5,0.5,0,0,[]],134,132,[],[],[0,"Default",0,1]],[[426,41,0,30,24,0,0,1,0.466667,0.541667,0,0,[]],136,229,[],[[1,1,0,4,0,0,0,10,0]],[0,"Default",0,1]]],[]]],[],[]],["Alemania",640,360,!1,"Event Alemania",8592123515820996,[["Layer 0",0,6891270287824489,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[640,0,0,640,538,0,0,1,1,0,0,0,[]],4,95,[],[],[0,"Default",0,1]],[[320,180,0,640,360,0,0,1,0.5,0.5,0,0,
[]],0,37,[],[],[0,"Default",0,1]]],[]],["Layer 1",1,6938457755921828,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[69,185,0,21,67,0,0,1,0.571429,0.507463,0,0,[]],55,41,[],[[40,0,0,0,1,0],[]],[0,"Animation2",0,1]],[[120,211,0,40.1721,4.01721,0,0,1,0,0.5,0,0,[]],1,38,[],[],[1,"Default",0,1]],[[126,168,0,2,18,0,0,1,0.5,0.5,0,0,[]],71,40,[],[],[0,"Default",0,1]],[[317,106,0,42,61,0,0,1,0.404762,0.508197,0,0,[]],30,42,[],[],[0,"Default",0,1]],[[35,316,0,49,62,0,0,1,0.55102,0.516129,0,0,[]],31,43,[],[[60,0,0,0,
0,1]],[0,"Default",0,1]],[[247,313,0,49,53,0,0,1,0.510204,0.566038,0,0,[]],32,44,[],[[60,0,0,0,0,0]],[0,"Default",0,1]],[[327,165,0,29,63,0,0,1,0.482759,0.507937,0,0,[]],33,45,[],[[10,0,0,0,0,0]],[0,"Default",0,1]],[[322,366,0,13,13,0,0,1,0.538462,0.538462,0,0,[]],132,46,[],[[1,2,0,2.5,0.5,0.2,0,0.01,0,1],[0,0],[]],[0,"Default",0,1]],[[473,250,0,60,75,0,0,1,0.5,0.506667,0,0,[]],34,47,[],[[20,0,0,0,0,1]],[0,"Default",0,1]],[[121,205,0,13,13,0,0,1,0.5,0.5,0,0,[]],133,39,[],[[0,2,0,2.5,0.5,0.2,0,0.01,
0,1],[],[0,0]],[0,"Default",0,1]],[[11,348,0,18,18,0,0,1,0.5,0.5,0,0,[]],134,135,[],[],[0,"Default",0,1]],[[25,339,0,200,30,0,0,1,0,0,0,0,[]],119,142,[],[],["1",0,"12pt Arial","rgb(255,255,255)",0,0,0,0,0]],[[558,324,0,99,53,0,0,0.5,0,0,0,0,[]],122,149,[],[[]],["Menu",0,"24pt Arial","rgb(255,255,255)",0,0,0,0,0]],[[223,2,0,200,30,0,0,1,0,0,0,0,[]],125,180,[],[],["Toca para empezar",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[339,90,0,51,30,0,0,1,0,0,0,0,[]],109,181,[],[],["Lahm",0,"14pt Arial",
"rgb(255,255,153)",0,0,0,0,0]],[[345,148,0,84,30,0,0,1,0,0,0,0,[]],110,182,[],[],["M. Gotze",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[43,298,0,58,30,0,0,1,0,0,0,0,[]],111,183,[],[],["Muller",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[275,296,0,39,30,0,0,1,0,0,0,0,[]],112,184,[],[],["Ozil",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[490,244,0,136,30,0,0,1,0,0,0,0,[]],113,185,[],[],["Schweinsteiger",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[892,101,0,30,30,0,0,1,0.5,0.5,0,0,[]],
7,210,[],[[]],[0,"Default",0,1]],[[570,34,0,138,59,0,0,1,0.5,0.576271,0,0,[]],9,218,[],[],[0,"Default",0,1]],[[19,40,0,30,24,0,0,1,0.466667,0.541667,0,0,[]],136,240,[],[[1,1,0,4,0,0,0,10,0]],[0,"Default",0,1]],[[20,62,0,21,11,0,0,1,0.52381,0.545455,8,0,[]],137,241,[],[],[0,"Default",0,1]]],[]]],[],[]],["Italia",640,360,!1,"Event Italia",5539900333162864,[["Layer 0",0,7540993301564554,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[640,0,0,640,538,0,0,1,1,0,0,0,[]],4,91,[],[],[0,"Default",0,1]],[[320,180,0,
640,360,0,0,1,0.5,0.5,0,0,[]],0,48,[],[],[0,"Default",0,1]]],[]],["Layer 1",1,0xd3976c2298979,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[120,211,0,40.1721,4.01721,0,0,1,0,0.5,0,0,[]],1,49,[],[],[1,"Default",0,1]],[[126,168,0,2,18,0,0,1,0.5,0.5,0,0,[]],71,51,[],[],[0,"Default",0,1]],[[69,185,0,21,67,0,0,1,0.571429,0.507463,0,0,[]],55,52,[],[[40,0,0,0,1,0],[]],[0,"Animation2",0,1]],[[419,257,0,26,66,0,0,1,0.538462,0.5,0,0,[]],35,53,[],[[60,0,0,0,0,1]],[0,"Default",0,1]],[[65,53,0,30,62,0,0,1,0.466667,0.483871,
0,0,[]],36,54,[],[[40,0,0,0,0,1]],[0,"Default",0,1]],[[206,328,0,43,59,0,0,1,0.488372,0.491525,0,0,[]],37,55,[],[[60,0,0,0,0,1]],[0,"Default",0,1]],[[397,38,0,26,64,0,0,1,0.461538,0.453125,0,0,[]],38,56,[],[[20,0,0,0,0,1]],[0,"Default",0,1]],[[236,57,0,26,63,0,0,1,0.576923,0.539683,0,0,[]],39,57,[],[],[0,"Default",0,1]],[[246,80,0,13,13,0,0,1,0.538462,0.538462,0,0,[]],132,58,[],[[1,2,0,2.5,0.5,0.2,0,0.01,0,1],[0,0],[]],[0,"Default",0,1]],[[11,348,0,18,18,0,0,1,0.5,0.5,0,0,[]],134,131,[],[],[0,"Default",
0,1]],[[25,339,0,200,30,0,0,1,0,0,0,0,[]],119,138,[],[],["1",0,"12pt Arial","rgb(255,255,255)",0,0,0,0,0]],[[558,324,0,99,53,0,0,0.5,0,0,0,0,[]],122,150,[],[[]],["Menu",0,"24pt Arial","rgb(255,255,255)",0,0,0,0,0]],[[223,2,0,200,30,0,0,1,0,0,0,0,[]],125,198,[],[],["Toca para empezar",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[87,43,0,93,30,0,0,1,0,0,0,0,[]],99,199,[],[],["De Rossi",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[257,45,0,45,30,0,0,1,0,0,0,0,[]],100,200,[],[],["Pirlo",0,"14pt Arial",
"rgb(255,255,153)",0,0,0,0,0]],[[415,31,0,74,30,0,0,1,0,0,0,0,[]],101,201,[],[],["T. Motta",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[232,315,0,66,30,0,0,1,0,0,0,0,[]],102,202,[],[],["Verratti",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[441,243,0,73,30,0,0,1,0,0,0,0,[]],103,203,[],[],["Balotelli",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[570,34,0,138,59,0,0,1,0.5,0.576271,0,0,[]],9,217,[],[],[0,"Default",0,1]],[[121,205,0,13,13,0,0,1,0.5,0.5,0,0,[]],133,50,[],[[0,2,0,2.5,0.5,0.2,
0,0.01,0,1],[],[0,0]],[0,"Default",0,1]],[[600,320,0,22,20,0,0,1,0.545455,0.5,8,0,[]],139,236,[],[],[0,"Default",0,1]],[[600,290,0,27,36,0,0,1,0.518519,0.5,0,0,[]],138,237,[],[[1,1,0,4,0,0,0,10,0]],[0,"Default",0,1]]],[]]],[],[]],["Inglaterra",640,360,!1,"Event Inglaterra",707660634267315,[["Layer 0",0,0xd7b23360856e4,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[640,0,0,640,538,0,0,1,1,0,0,0,[]],4,94,[],[],[0,"Default",0,1]],[[320,180,0,640,360,0,0,1,0.5,0.5,0,0,[]],0,59,[],[],[0,"Default",0,1]]],[]],["Layer 1",
1,0xe4bf921b49f22,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[69,185,0,21,67,0,0,1,0.571429,0.507463,0,0,[]],55,63,[],[[40,0,0,0,1,0],[]],[0,"Animation2",0,1]],[[120,211,0,40.1721,4.01721,0,0,1,0,0.5,0,0,[]],1,61,[],[],[1,"Default",0,1]],[[126,168,0,2,18,0,0,1,0.5,0.5,0,0,[]],71,62,[],[],[0,"Default",0,1]],[[494,323,0,27,58,0,0,1,0.407407,0.431034,0,0,[]],40,64,[],[[40,0,0,0,0,1]],[0,"Default",0,1]],[[232,108,0,27,59,0,0,1,0.481481,0.491525,0,0,[]],41,65,[],[[30,0,0,0,0,1]],[0,"Default",0,1]],[[395,65,
0,27,59,0,0,1,0.518519,0.491525,0,0,[]],42,66,[],[],[0,"Default",0,1]],[[301,161,0,25,57,0,0,1,0.52,0.491228,0,0,[]],43,67,[],[[60,0,0,0,0,1]],[0,"Default",0,1]],[[406,366,0,13,13,0,0,1,0.538462,0.538462,0,0,[]],132,68,[],[[1,2,0,2.5,0.5,0.2,0,0.01,0,1],[0,0],[]],[0,"Default",0,1]],[[153,315,0,34,60,0,0,1,0.647059,0.516667,0,0,[]],44,69,[],[[60,0,0,0,0,0]],[0,"Default",0,1]],[[11,348,0,18,18,0,0,1,0.5,0.5,0,0,[]],134,130,[],[],[0,"Default",0,1]],[[25,339,0,200,30,0,0,1,0,0,0,0,[]],119,137,[],[],["1",
0,"12pt Arial","rgb(255,255,255)",0,0,0,0,0]],[[558,324,0,99,53,0,0,0.5,0,0,0,0,[]],122,151,[],[[]],["Menu",0,"24pt Arial","rgb(255,255,255)",0,0,0,0,0]],[[223,2,0,200,30,0,0,1,0,0,0,0,[]],125,192,[],[],["Toca para empezar",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[412,53,0,81,30,0,0,1,0,0,0,0,[]],89,193,[],[],["Lampard",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[250,97,0,69,30,0,0,1,0,0,0,0,[]],90,194,[],[],["Gerrard",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[319,153,0,76,30,0,0,
1,0,0,0,0,[]],91,195,[],[],["Rooney",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[157,301,0,84,30,0,0,1,0,0,0,0,[]],92,196,[],[],["Wellbeck",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[514,304,0,68,30,0,0,1,0,0,0,0,[]],93,197,[],[],["Carrick",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[570,34,0,138,59,0,0,1,0.5,0.576271,0,0,[]],9,215,[],[],[0,"Default",0,1]],[[565,251,0,22,20,0,0,1,0.545455,0.5,8,0,[]],139,233,[],[],[0,"Default",0,1]],[[121,205,0,13,13,0,0,1,0.5,0.5,0,0,[]],133,60,[],[[0,
2,0,2.5,0.5,0.2,0,0.01,0,1],[],[0,0]],[0,"Default",0,1]],[[565,220,0,27,36,0,0,1,0.518519,0.5,0,0,[]],138,232,[],[[1,1,0,4,0,0,0,10,0]],[0,"Default",0,1]]],[]]],[],[]],["Portugal",641,361,!1,"Event Portugal",7013353759850971,[["Layer 0",0,9519510459068844,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[640,0,0,640,538,0,0,1,1,0,0,0,[]],4,93,[],[],[0,"Default",0,1]],[[320,180,0,640,360,0,0,1,0.5,0.5,0,0,[]],0,72,[],[],[0,"Default",0,1]]],[]],["Layer 1",1,0x6a03796dfedda,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[120,
211,0,40.1721,4.01721,0,0,1,0,0.5,0,0,[]],1,71,[],[],[1,"Default",0,1]],[[126,168,0,2,18,0,0,1,0.5,0.5,0,0,[]],71,73,[],[],[0,"Default",0,1]],[[69,185,0,21,67,0,0,1,0.571429,0.507463,0,0,[]],55,74,[],[[40,0,0,0,1,0],[]],[0,"Animation2",0,1]],[[523,325,0,31,59,0,0,1,0.419355,0.491525,0,0,[]],45,75,[],[[20,0,0,0,0,1]],[0,"Default",0,1]],[[387,62,0,28,60,0,0,1,0.392857,0.466667,0,0,[]],46,76,[],[[5,0,0,0,0,1]],[0,"Default",0,1]],[[327,328,0,32,58,0,0,1,0.5,0.5,0,0,[]],47,77,[],[[40,0,0,0,0,1]],[0,"Default",
0,1]],[[518,182,0,32,61,0,0,1,0.5,0.508197,0,0,[]],48,78,[],[],[0,"Default",0,1]],[[135,54,0,28,60,0,0,1,1,0.5,0,0,[]],49,79,[],[[60,0,0,0,0,1]],[0,"Default",0,1]],[[335,-163,0,465,168,0,0,1,0.376344,0.464286,0,0,[]],60,103,[],[[]],[0,"Default",0,1]],[[326,-335,0,460,168,0,0,1,0.663043,0.464286,0,0,[]],61,104,[],[[]],[0,"Default",0,1]],[[800,-116,0,465,168,0,0,1,0.376344,0.464286,0,0,[]],62,105,[],[[]],[0,"Default",0,1]],[[820,-322,0,433,168,0,0,1,0.704388,0.464286,0,0,[]],63,106,[],[[]],[0,"Default",
0,1]],[[-160,-162,0,465,168,0,0,1,0.376344,0.464286,0,0,[]],64,107,[],[[]],[0,"Default",0,1]],[[-167,-352,0,466,168,0,0,1,0.654506,0.464286,0,0,[]],65,108,[],[[]],[0,"Default",0,1]],[[25,339,0,200,30,0,0,1,0,0,0,0,[]],119,125,[],[],["1",0,"12pt Arial","rgb(255,255,255)",0,0,0,0,0]],[[11,348,0,18,18,0,0,1,0.5,0.5,0,0,[]],134,126,[],[],[0,"Default",0,1]],[[668,422,0,303,86,0,0,1,0,0,0,0,[]],120,124,[],[[]],["Fallaste",0,"28pt Arial","rgb(255,0,0)",0,0,0,0,0]],[[558,324,0,129,66,0,0,0.5,0,0,0,0,[]],
122,127,[],[[]],["Menu",0,"24pt Arial","rgb(255,255,255)",0,0,0,0,0]],[[800,123,0,135,111,0,0,1,0.503704,0.504505,0,0,[]],5,128,[],[[]],[0,"Default",0,0]],[[223,2,0,228,51,0,0,1,0,0,0,0,[]],125,204,[],[],["Toca para empezar",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[138,44,0,52,30,0,0,1,0,0,0,0,[]],104,205,[],[],["Pepe",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[291,53,0,85,30,0,0,1,0,0,0,0,[]],105,206,[],[],["Coentrao",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[542,173,0,46,30,0,
0,1,0,0,0,0,[]],106,207,[],[],["Nani",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[339,308,0,81,30,0,0,1,0,0,0,0,[]],107,208,[],[],["Cristiano",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[546,310,0,81,30,0,0,1,0,0,0,0,[]],108,209,[],[],["Carvalho",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[570,34,0,138,59,0,0,1,0.5,0.576271,0,0,[]],9,214,[],[],[0,"Default",0,1]],[[121,204,0,1,359,0,-0.2618,1,1,0.501393,0,0,[]],135,242,[],[],[0,"Default",0,1]],[[482,79,0,16,11,0,0,1,0.5625,0.636364,8,0,
[]],131,245,[],[],[0,"Default",0,1]],[[593,248,0,16,11,0,0,1,0.5625,0.636364,8,0,[]],141,246,[],[],[0,"Default",0,1]],[[121,205,0,13,13,0,0,1,0.5,0.5,0,0,[]],133,70,[],[[0,2,0,2.5,0.5,0.2,0,0.01,0,1],[],[0,0]],[0,"Default",0,1]],[[593,223,0,25,23,0,0,1,0.52,0.521739,0,0,[]],140,243,[],[[1,1,0,4,0,0,0,10,0]],[0,"Default",0,1]],[[482,54,0,25,23,0,0,1,0.52,0.521739,0,0,[]],130,244,[],[[1,1,0,4,0,0,0,10,0]],[0,"Default",0,1]],[[320,180,0,640,360,0,0,1,0.5,0.5,0,0,[]],144,248,[],[[1]],[0,"Default",0,1]]],
[]]],[],[]],["Argentina",640,360,!1,"Event Argentina",0x7901723bf93c4,[["Layer 0",0,0xe496799496d2a,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[640,0,0,640,538,0,0,1,1,0,0,0,[]],4,92,[],[],[0,"Default",0,1]],[[320,180,0,640,360,0,0,1,0.5,0.5,0,0,[]],0,80,[],[],[0,"Default",0,1]]],[]],["Layer 1",1,9501397927521992,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[120,211,0,40.1721,4.01721,0,0,1,0,0.5,0,0,[]],1,81,[],[],[1,"Default",0,1]],[[126,168,0,2,18,0,0,1,0.5,0.5,0,0,[]],71,83,[],[],[0,"Default",0,1]],[[69,185,
0,21,67,0,0,1,0.571429,0.507463,0,0,[]],55,84,[],[[40,0,0,0,1,0],[]],[0,"Animation2",0,1]],[[287.742,47.5144,0,43,56,0,0,1,0.465116,0.5,0,0,[]],50,85,[],[[40,0,0,0,0,1]],[0,"Default",0,1]],[[183.208,287.667,0,26.8966,60,0,0,1,0.423077,0.482759,0,0,[]],51,86,[],[],[0,"Default",0,1]],[[351.298,107.592,0,32,61,0,0,1,0.53125,0.491803,0,0,[]],52,87,[],[],[0,"Default",0,1]],[[301.134,298.734,0,35,58,0,0,1,0.514286,0.5,0,0,[]],53,88,[],[[50,0,0,0,0,1]],[0,"Default",0,1]],[[469.28,228.105,0,27,59,0,0,1,0.555556,
0.474576,0,0,[]],54,89,[],[[40,0,0,0,0,1]],[0,"Default",0,1]],[[328,-123,0,471,168,0,0,1,0.369427,0.464286,0,0,[]],56,98,[],[[]],[0,"Default",0,1]],[[980,-144,0,465,168,0,0,1,0.655914,0.464286,0,0,[]],57,100,[],[[]],[0,"Default",0,1]],[[979,85,0,639,179,0,0,0.7,0.500782,0.502793,0,0,[]],2,101,[],[[]],[0,"Default",0,1]],[[11,348,0,18,18,0,0,1,0.5,0.5,0,0,[]],134,134,[],[],[0,"Default",0,1]],[[25,339,0,200,30,0,0,1,0,0,0,0,[]],119,141,[],[],["1",0,"12pt Arial","rgb(255,255,255)",0,0,0,0,0]],[[558,324,
0,99,53,0,0,0.5,0,0,0,0,[]],122,145,[],[[]],["Menu",0,"24pt Arial","rgb(255,255,255)",0,0,0,0,0]],[[223,2,0,200,30,0,0,1,0,0,0,0,[]],125,186,[],[],["Toca para empezar",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[313,36,0,79,30,0,0,1,0,0,0,0,[]],114,187,[],[],["Di Maria",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[370,98,0,66,30,0,0,1,0,0,0,0,[]],115,188,[],[],["Aguero",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[202,275,0,70,30,0,0,1,0,0,0,0,[]],116,189,[],[],["Higuain",0,"14pt Arial",
"rgb(255,255,153)",0,0,0,0,0]],[[306,290,0,55,30,0,0,1,0,0,0,0,[]],117,190,[],[],["Messi",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[486,221,0,109,30,0,0,1,0,0,0,0,[]],118,191,[],[],["Mascherano",0,"14pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[570,34,0,138,59,0,0,1,0.5,0.576271,0,0,[]],9,213,[],[],[0,"Default",0,1]],[[206,47,0,21,11,0,0,1,0.52381,0.545455,8,0,[]],137,239,[],[],[0,"Default",0,1]],[[121,205,0,13,13,0,0,1,0.5,0.5,0,0,[]],133,82,[],[[0,2,0,2.5,0.5,0.2,0,0.01,0,1],[],[0,0]],[0,"Default",
0,1]],[[205,25,0,30,24,0,0,1,0.466667,0.541667,0,0,[]],136,238,[],[[1,1,0,4,0,0,0,10,0]],[0,"Default",0,1]]],[]]],[],[]],["Menu",640,360,!1,"Event Menu",6335691548579513,[["Layer 0",0,0xa460b63d7a76b,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[320.088,179.737,0,640,360,0,0,1,0.5,0.5,0,0,[]],6,115,[],[],[0,"Default",0,1]]],[]],["Layer 1",1,0xfb1e2eb167824,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[32,246,0,50,50,0,0,1,0.5,0.5,0,0,[]],71,116,[],[],[0,"Default",0,1]],[[110,250,0,50,50,0,0,0.5,0.5,0.5,0,0,[]],72,
117,[],[],[0,"Default",0,1]],[[192,254,0,50,50,0,0,0.5,0.5,0.5,0,0,[]],73,118,[],[],[0,"Default",0,1]],[[276,253,0,50,50,0,0,0.5,0.5,0.5,0,0,[]],74,119,[],[],[0,"Default",0,1]],[[360,254,0,50,50,0,0,0.5,0.5,0.5,0,0,[]],75,120,[],[],[0,"Default",0,1]],[[447,255,0,50,50,0,0,0.5,0.5,0.5,0,0,[]],76,121,[],[],[0,"Default",0,1]],[[531,249,0,50,50,0,0,0.5,0.5,0.5,0,0,[]],77,122,[],[],[0,"Default",0,1]],[[603,244,0,50,50,0,0,0.5,0.5,0.5,0,0,[]],78,123,[],[],[0,"Default",0,1]],[[424,45,0,82,211,0,0,1,0,0,
0,0,[]],124,143,[],[],["Te invita a divertirte con este juego",0,"16pt Arial","rgb(0,51,153)",0,0,0,0,0]],[[1,331,0,219,37,0,0,1,0,0,0,0,[]],121,152,[],[],["Instrucciones",0,"20pt Arial","rgb(0,204,0)",0,0,0,0,0]],[[321,34,0,138,59,0,0,1,0.5,0.576271,0,0,[]],9,219,[],[],[0,"Default",0,1]],[[358,-349,0,640,547,0,0,1,0.5,0.5,0,0,[]],8,220,[],[[]],[0,"Default",0,1]],[[747,40,0,110,44,0,0,1,0.5,0.5,0,0,[]],126,221,[],[[]],["English",0,"24pt Arial","rgb(255,255,255)",0,0,1,0,0]],[[730,102,0,128,44,0,0,
1,0.5,0.5,0,0,[]],127,222,[],[[]],["Fran\u00e7ais",0,"24pt Arial","rgb(255,255,255)",0,0,1,0,0]],[[770,-13,0,121,44,0,0,1,0.5,0.5,0,0,[]],128,223,[],[[]],["Espa\u00f1ol",0,"24pt Arial","rgb(255,255,255)",0,0,1,0,0]],[[764,203,0,127,44,0,0,1,0.5,0.5,0,0,[]],129,224,[],[[]],["Svenska",0,"24pt Arial","rgb(255,255,255)",0,0,1,0,0]],[[600,-70,0,100,100,0,0,1,0.5,0.5,0,0,[]],145,249,[],[],[0,"Default",0,1]],[[461,177,0,52,25,0,0,1,0.5,0.52,0,0,[]],146,250,[],[],[0,"Default",0,1]]],[]]],[],[]],["Instrucciones",
640,360,!1,"Event Instrucciones",0x3cd5b4551592c,[["Layer 0",0,5322060279818657,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[640,0,0,640,538,0,0,1,1,0,0,0,[]],4,154,[],[],[0,"Default",0,1]],[[320,180,0,640,360,0,0,1,0.5,0.5,0,0,[]],0,153,[],[],[0,"Default",0,1]]],[]],["Layer 1",1,7615566662852634,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[361,247,0,30,63,0,0,1,0.5,0.492063,0,0,[]],20,155,[],[[40,0,0,0,0,1],[]],[0,"Default",0,1]],[[69,185,0,21,67,0,0,1,0.571429,0.507463,0,0,[]],55,156,[],[[40,0,0,0,1,0],[]],[0,
"Animation2",0,1]],[[121,205,0,13,13,0,0,1,0.5,0.5,0,0,[]],133,157,[],[[0,2,0,2.5,0.5,0.2,0,0.01,0,1],[],[0,0]],[0,"Default",0,1]],[[120,211,0,40.1721,4.01721,0,0,1,0,0.5,0,0,[]],1,158,[],[],[1,"Default",0,1]],[[558,324,0,99,53,0,0,0.5,0,0,0,0,[]],122,159,[],[[]],["Menu",0,"24pt Arial","rgb(255,255,255)",0,0,0,0,0]],[[103.245,2,0,427,216,0,0,1,0,0,0,0,[]],123,160,[],[],["El objetivo del juego es darle balonazos en la cara a los jugadores sin acabarte los balones (en este nivel son infinitos), para ello toca el balon, desliza tu dedo hacia atras, apunta y suelta para hacer un tiro. ",
0,"17pt Arial","rgb(255,255,153)",0,0,0,0,0]],[[126,168,0,2,18,0,0,1,0.5,0.5,0,0,[]],71,161,[],[],[0,"Default",0,1]]],[]]],[],[]]],[["Event Espanha",[[1,"Celos",0,0,!1,!1,0x51f9ac97fc526,!1],[1,"Tiro",0,0,!1,!1,6201735770935205,!1],[1,"Apuntar",0,1,!1,!1,7787189424051252,!1],[0,null,!1,null,7040196959258869,[[16,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7061403094098394,!1,[[4,133]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,0x71f40a83fe32d,!1,[[0,[1,1E-5]]]],[-1,
cr.system_object.prototype.acts.CreateObject,null,6180476960549712,!1,[[4,2],[5,[0,1]],[0,[0,320]],[0,[0,90]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0x5cb32ace9478c,!1,[[4,68],[5,[0,1]],[0,[0,319]],[0,[0,90]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0x66756ce5caed9,!1,[[4,3],[5,[0,1]],[0,[0,355]],[0,[0,165]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x5d3c1e4b743fb,!1,[[11,"Dialogo"],[7,[0,1]]]]]],[0,null,!1,null,8554065558186085,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,
null,1,!1,!1,!1,872527873184383,!1,[[4,68]]]],[[68,cr.plugins_.Sprite.prototype.acts.Destroy,null,5000982090908739,!1],[-1,cr.system_object.prototype.acts.Wait,null,0xcf745e0a046d8,!1,[[0,[1,1E-5]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0xd8aec124b4925,!1,[[4,69],[5,[0,1]],[0,[0,319]],[0,[0,90]]]]]],[0,null,!1,null,0x5fb0d5d98c02f,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,319019560933096,!1,[[4,69]]]],[[69,cr.plugins_.Sprite.prototype.acts.Destroy,null,6501243448123831,
!1],[-1,cr.system_object.prototype.acts.Wait,null,8766074361594847,!1,[[0,[1,1E-5]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0x41c70300b2f05,!1,[[4,70],[5,[0,1]],[0,[0,319]],[0,[0,90]]]]]],[0,null,!1,null,0x655daa36e8759,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,8263929575905027,!1,[[4,70]]]],[[70,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xc7ab1ec4f333d,!1],[2,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xce77781220df7,!1],[3,cr.plugins_.Sprite.prototype.acts.Destroy,
null,6379535991837671,!1],[-1,cr.system_object.prototype.acts.Wait,null,0x50949deea7554,!1,[[0,[1,1E-5]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,8997407421549982,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x7dbd53d17b0c0,!1,[[11,"Dialogo"],[7,[0,0]]]]]],[0,null,!1,null,594591894305589,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7740243465208819,!1,[[4,3]]]],[[68,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xcd7161f8d2eb5,!1],[69,cr.plugins_.Sprite.prototype.acts.Destroy,
null,0xa6f97c009ea16,!1],[70,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x96fb682363120,!1],[3,cr.plugins_.Sprite.prototype.acts.Destroy,null,7029825474427112,!1],[2,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xf390cf7b3ef7f,!1],[-1,cr.system_object.prototype.acts.Wait,null,0xc67d90960d5db,!1,[[0,[1,1E-5]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,9090144987759892,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xa7c8bd3a59293,!1,[[11,"Dialogo"],[7,[0,0]]]]]],
[0,null,!1,null,7607923165468903,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,8666895864556489,!1]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,6912213510727855,!1,[[0,[0,0]]]],[133,cr.behaviors.Physics.prototype.acts.SetIterations,"Physics",0x79628b1dbdf4f,!1,[[0,[0,12]],[0,[0,8]]]],[19,cr.plugins_.Sprite.prototype.acts.StopAnim,null,6934739606176792,!1],[10,cr.plugins_.Audio.prototype.acts.Play,null,0x4fce895ab97a9,!1,[[2,["espanha",!0]],[3,1],[0,[0,0]],[1,[2,"Espa\u00f1a"]]]],
[-1,cr.system_object.prototype.acts.SetVar,null,0xef0b49076cff8,!1,[[11,"Disparos"],[7,[0,7]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8920772514547624,!1,[[11,"Jugadores"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5487659703587073,!1,[[11,"Banner"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5278234395121128,!1,[[11,"Alineacion"],[7,[0,1]]]]]],[0,null,!1,null,5914735502218087,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xe5ced12df77eb,
!1,[[11,"Apuntar"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,935704609182474,!1,[[11,"Jugadores"],[8,2],[7,[0,5]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7169941503888133,!1,[[11,"Alineacion"],[8,0],[7,[0,0]]]]],[[133,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,32258681982564,!1,[[4,1],[7,[0,0]]]]],[[0,null,!1,null,0xc600c9e92134d,[[12,cr.plugins_.Touch.prototype.cnds.IsInTouch,null,0,!1,!1,!1,5177012598521192,!1]],[[133,cr.plugins_.Sprite.prototype.acts.SetAngle,
null,18472231849043,!1,[[0,[19,cr.system_object.prototype.exps.angle,[[20,12,cr.plugins_.Touch.prototype.exps.X,!1,null],[20,12,cr.plugins_.Touch.prototype.exps.Y,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]]]],[133,cr.plugins_.Sprite.prototype.acts.MoveAtAngle,null,0x9ca79ea71828e,!1,[[0,[4,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null],[0,180]]],[0,[19,cr.system_object.prototype.exps.min,[[7,[19,cr.system_object.prototype.exps.distance,
[[20,12,cr.plugins_.Touch.prototype.exps.X,!1,null],[20,12,cr.plugins_.Touch.prototype.exps.Y,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]],[0,3]],[0,45]]]]]],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0xbc543fa04aa08,!1,[[4,1]]],[1,cr.plugins_.Sprite.prototype.acts.SetVisible,null,7776758005253806,!1,[[3,1]]],[1,cr.plugins_.Sprite.prototype.acts.SetTowardPosition,null,6213153070160711,!1,[[0,[20,133,cr.plugins_.Sprite.prototype.exps.X,
!1,null]],[0,[20,133,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]]]],[0,null,!1,null,5834554554427737,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,8334798396329385,!1]],[[1,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0xf2d93111f6af1,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.SetVar,null,6669577601489905,!1,[[11,"Apuntar"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,6202056002410668,!1,[[11,"Tiro"],[7,[7,[19,cr.system_object.prototype.exps.distance,
[[20,133,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,133,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]],[0,15]]]]],[133,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0xe23f562508f8e,!1,[[4,1],[7,[0,0]]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",0x6082359010d28,!1,[[3,1]]],[55,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",6026328703429342,!1,[[3,1]]],[55,
cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xdbc966ddb03c5,!1,[[1,[2,"Default"]],[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,0xf69f768c249a6,!1,[[0,[0,1]]]],[133,cr.plugins_.Sprite.prototype.acts.SetAnim,null,8082458763763656,!1,[[1,[2,"Tiro"]],[3,1]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",8848327281519512,!1,[[3,0]]],[133,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",0x8744cab200f01,!1,[[0,[23,"Tiro"]],[0,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,
!1,null]],[7,[0,0]]]]]]]],[0,null,!1,null,6385187227545637,[[55,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5806452540963983,!1,[[4,71]]]],[[55,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",8982537135138043,!1,[[3,0]]]]],[0,null,!1,null,7398187201637624,[[133,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,8406708341210506,!1],[55,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0xf9ab1897695f1,!1]],[[-1,cr.system_object.prototype.acts.CreateObject,
null,6131395147453315,!1,[[4,133],[5,[0,1]],[0,[0,0]],[0,[0,0]]]],[55,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0x6a1df0596b642,!1,[[1,[2,"Animation2"]],[3,1]]],[55,cr.plugins_.Sprite.prototype.acts.SetPos,null,0xc6179880cdbd3,!1,[[0,[0,69]],[0,[0,185]]]],[-1,cr.system_object.prototype.acts.SubVar,null,912205407252426,!1,[[11,"Disparos"],[7,[0,1]]]]]],[0,null,!1,null,6137223946918368,[[133,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,0x883e99d65e1d6,!1]],[[-1,cr.system_object.prototype.acts.SetVar,
null,8134608354794716,!1,[[11,"Apuntar"],[7,[0,1]]]]]],[0,null,!1,null,5903498432783591,[[133,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5844011760838465,!1,[[4,0]]]],[[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",0x8f564f46ddd2c,!1,[[3,1]]],[133,cr.behaviors.Rotate.prototype.acts.SetSpeed,"Rotate",7653685228320693,!1,[[0,[0,720]]]],[-1,cr.system_object.prototype.acts.Wait,null,425803938466407,!1,[[0,[1,1]]]],[133,cr.plugins_.Sprite.prototype.acts.Destroy,null,
631448904563644,!1]]],[0,null,!1,null,8214946421348603,[[132,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x5aafa8527c53d,!1,[[4,0]]]],[[132,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",7111317455755969,!1,[[3,1]]],[132,cr.behaviors.Rotate.prototype.acts.SetSpeed,"Rotate",6237266762570865,!1,[[0,[0,720]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xdb83253f2e1a3,!1,[[0,[1,1]]]],[132,cr.plugins_.Sprite.prototype.acts.Destroy,null,5294521693049125,!1]]],[0,null,!1,
null,7686285499199793,[[17,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,0xc2d88b93b62d5,!1,[[8,0],[0,[0,2]]]]],[[132,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",9425229758047128,!1,[[3,0]]],[132,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",0x90ab904e3df4a,!1,[[0,[1,0.3]],[0,[19,cr.system_object.prototype.exps.choose,[[0,1],[0,350],[0,340]]]],[7,[0,0]]]]]],[0,null,!1,null,0x6aaaea8cc5d12,[[132,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,
1,!1,!1,!1,6043193602280018,!1],[17,cr.plugins_.Sprite.prototype.cnds.IsOnLayer,null,0,!1,!1,!1,626025929648192,!1,[[5,[0,1]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,5732463751807313,!1,[[4,132],[5,[0,1]],[0,[0,385]],[0,[0,155]]]],[17,cr.plugins_.Sprite.prototype.acts.StartAnim,null,719030369107901,!1,[[3,1]]]]],[0,null,!1,null,0xd94fe8730f955,[[17,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,9319837532299524,!1]],[[-1,cr.system_object.prototype.acts.Wait,null,0x51f2989d28e41,
!1,[[0,[1,0.5]]]],[132,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xd8d814ac04c01,!1]]],[0,null,!1,null,0x7ad6f8cf42006,[[18,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,6337088503259446,!1,[[8,0],[0,[0,0]]]]],[[18,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",5794225485806679,!1,[[0,[0,0]]]]]],[0,null,!1,null,5580852498525486,[[18,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,6937181050100114,!1,[[8,0],[0,[0,5]]]]],[[18,cr.behaviors.Bullet.prototype.acts.SetEnabled,
"Bullet",5132568181604759,!1,[[3,0]]]]],[0,null,!1,null,9985156543565140,[[18,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,0xa4ffb14d24ce4,!1,[[8,0],[0,[0,6]]]]],[[18,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",8316236491361753,!1,[[3,1]]],[18,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xa3fcad1310f7e,!1,[[0,[0,180]]]]]],[0,null,!1,null,7168537282110864,[[133,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8812186277832829,!1,[[4,147]]]],
[[133,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",5064015980094723,!1,[[0,[4,[23,"Tiro"],[1,0.5]]],[0,[5,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null],[0,180]]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.AddVar,null,9339978544247298,!1,[[11,"Jugadores"],[7,[0,1]]]],[147,cr.plugins_.Sprite.prototype.acts.StopAnim,null,0x53ae8bd7b0f00,!1],[147,cr.plugins_.Sprite.prototype.acts.SetAngle,null,490928459944567,!1,[[0,[0,90]]]],[147,cr.plugins_.Sprite.prototype.acts.SetCollisions,
null,7414970298817366,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,636245567316339,!1,[[0,[1,0.2]]]],[147,cr.plugins_.Sprite.prototype.acts.Destroy,null,5698637150737898,!1]],[[0,null,!1,null,0x80a7d488b2169,[[133,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,0x44b845dd65051,!1,[[1,[2,"3Balones"]]]]],[[133,cr.plugins_.Sprite.prototype.acts.Destroy,null,9863474419543908,!1]]]]],[0,null,!1,null,9108243568320280,[[16,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,
0,!1,!1,!1,0xce5a3bb132d98,!1,[[8,0],[0,[0,0]]]]],[[16,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",5314669882046663,!1,[[0,[0,0]]]]]],[0,null,!1,null,9815550775182920,[[16,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,0xf0e194621a871,!1,[[8,0],[0,[0,4]]]]],[[16,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xeaa2bb7dcabc9,!1,[[0,[0,180]]]]]],[0,null,!1,null,8100272847137233,[[15,cr.plugins_.Sprite.prototype.cnds.OnAnimFinished,null,1,!1,!1,!1,0x78787727b789f,
!1,[[1,[2,"Derecha"]]]]],[[19,cr.plugins_.Sprite.prototype.acts.StartAnim,null,5585170192821655,!1,[[3,1]]]]],[0,null,!1,null,7149792668115295,[[19,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,997524875173959,!1,[[8,0],[0,[0,2]]]]],[[15,cr.plugins_.Sprite.prototype.acts.StartAnim,null,0xc097e1624f333,!1,[[3,1]]]]],[0,null,!1,null,0x88a1cec1e9857,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6621952997884701,!1,[[11,"Disparos"],[8,0],[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.Every,
null,0,!1,!1,!1,0x3cb34c606ef3a,!1,[[0,[0,5]]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,8233983117141624,!1,[[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0x646cc38f4b7c9,!1,[[4,120],[5,[0,1]],[0,[0,257]],[0,[0,109]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5002727313619902,!1,[[11,"Banner"],[7,[0,1]]]],[14,cr.plugins_.CJSAds.prototype.acts.ShowBanner,null,5276225109955417,!1,[[3,1]]],[122,cr.plugins_.Text.prototype.acts.Destroy,null,4602565377108185,!1],
[-1,cr.system_object.prototype.acts.CreateObject,null,5856485207901556,!1,[[4,122],[5,[0,1]],[0,[0,271]],[0,[0,153]]]],[122,cr.plugins_.Text.prototype.acts.SetOpacity,null,9817300919343744,!1,[[0,[0,100]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0x4713c8dad549e,!1,[[4,7],[5,[0,1]],[0,[0,625]],[0,[0,345]]]]]],[0,null,!1,null,5895566914999565,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x3c87d85e1e807,!1,[[4,122]]]],[[147,cr.plugins_.Sprite.prototype.acts.Destroy,
null,7673674263549002,!1],[-1,cr.system_object.prototype.acts.GoToLayout,null,0x4b581027ec051,!1,[[6,"Menu"]]],[10,cr.plugins_.Audio.prototype.acts.Stop,null,389753049575251,!1,[[1,[2,"Espa\u00f1a"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9725749942401624,!1,[[11,"Banner"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x88d4940f1c77e,!1,[[11,"3Balones"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x9c092ac16b7b4,!1,[[11,"RashoLaser"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,
null,0x7fedbc018973b,!1,[[11,"Tiempo"],[7,[0,0]]]]]],[0,null,!1,null,6303218327494175,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x64a213d779050,!1,[[11,"Jugadores"],[8,0],[7,[0,5]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7756628283352809,!1,[[11,"Dialogo"],[8,0],[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0xbfd2520add089,!1,[[0,[0,5]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,4952633059709832,!1,[[4,5],[5,[0,
1]],[0,[0,305]],[0,[0,95]]]],[-1,cr.system_object.prototype.acts.SetVar,null,7240648715313114,!1,[[11,"Italia"],[7,[0,2]]]],[13,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,9431627395057054,!1,[[1,[2,"Italia"]],[7,[23,"Italia"]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0xd8641859dfb43,!1,[[0,[1,1E-5]]]],[-1,cr.system_object.prototype.acts.SetVar,null,6469123863383481,!1,[[11,"Banner"],[7,[0,1]]]],[14,cr.plugins_.CJSAds.prototype.acts.ShowBanner,null,6513735499845041,!1,[[3,
1]]],[122,cr.plugins_.Text.prototype.acts.Destroy,null,5055345317579907,!1],[-1,cr.system_object.prototype.acts.CreateObject,null,4935785317613945,!1,[[4,122],[5,[0,1]],[0,[0,271]],[0,[0,153]]]],[122,cr.plugins_.Text.prototype.acts.SetOpacity,null,9767004070739918,!1,[[0,[0,100]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,527443693995478,!1,[[4,7],[5,[0,1]],[0,[0,625]],[0,[0,345]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0xa75ae535664fc,!1,[[4,142],[5,[0,1]],[0,[0,308]],
[0,[0,247]]]]]],[0,null,!1,null,0x73229510006d3,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,5065556199663948,!1]],[[119,cr.plugins_.Text.prototype.acts.SetText,null,4686191838147483,!1,[[7,[10,[2,": "],[23,"Disparos"]]]]]]],[0,null,!1,null,0xceb188feecc03,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,868921401903211,!1,[[11,"HighScore"],[8,0],[7,[0,3]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9206111426126076,!1,[[11,"Jugadores"],[8,0],
[7,[0,5]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,6149278768897299,!1,[[11,"HighScore"],[7,[0,1]]]],[13,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,5908339929399596,!1,[[1,[2,"Selecciones"]],[7,[23,"HighScore"]]]]]],[0,null,!1,null,0xffd310fd0f269,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5046064045920312,!1,[[11,"Banner"],[8,0],[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,381638957040858,!1,[[0,[1,0.2]]]]],[[14,cr.plugins_.CJSAds.prototype.acts.HideBanner,
null,0xb50b1fd10268e,!1]]],[0,null,!1,null,9016794244794916,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8727022973947056,!1,[[11,"Alineacion"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,0x8abf7f6e0bfb0,!1,[[0,[1,1E-5]]]]]],[0,null,!1,null,7420132679730946,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,0x9cd9880240ce,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x9c67deee329fd,!1,[[11,"Alineacion"],[8,0],[7,
[0,1]]]]],[[-1,cr.system_object.prototype.acts.Wait,null,347626317626822,!1,[[0,[1,1E-5]]]],[148,cr.plugins_.Text.prototype.acts.Destroy,null,7765681377079114,!1],[-1,cr.system_object.prototype.acts.SetVar,null,0xbb6a47dd6114b,!1,[[11,"Alineacion"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0xabd2fdf4cd4b1,!1,[[0,[0,1]]]]]],[0,null,!1,null,0x9e896f2ae4617,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,9509279234464564,!1,[[4,7]]]],[[11,cr.plugins_.Browser.prototype.acts.GoToURLWindow,
null,0xdfcf26d62041f,!1,[[1,[10,[10,[10,[2,"https://www.facebook.com/sharer/sharer.php?u=http://zlatanworldcup2014.tk/default.php?score="],[23,"HighScore"]],[2,":"]],[19,cr.system_object.prototype.exps.random,[[0,1],[0,10]]]]],[1,[2,"NewWindow"]]]]]],[0,null,!1,null,9794301047390144,[[70,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,7670657186184383,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x7849a9252e36e,!1,[[11,"Celos"],[8,0],[7,[0,1]]]]],[[70,cr.plugins_.Sprite.prototype.acts.Destroy,
null,7471256209181146,!1]]],[0,null,!1,null,5221134122193731,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xce4297c475271,!1,[[4,142]]]],[[11,cr.plugins_.Browser.prototype.acts.GoToURLWindow,null,7977102889046457,!1,[[1,[2,"https://play.google.com/store/apps/details?id=com.zlatan.app"]],[1,[2,"Rate"]]]]]],[0,null,!1,null,871922320784458,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7221590219636606,!1,[[11,"Ingles"],[8,0],[7,[0,1]]]]],[[120,cr.plugins_.Text.prototype.acts.SetText,
null,4619796096043602,!1,[[7,[2,"Failed"]]]],[122,cr.plugins_.Text.prototype.acts.SetText,null,0xcbdf6e15d4976,!1,[[7,[2,"Main"]]]],[125,cr.plugins_.Text.prototype.acts.SetText,null,0x87497850de419,!1,[[7,[2,"Tap to start"]]]],[68,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0x85b5653aa1c79,!1,[[1,[2,"Ingles"]],[3,1]]],[69,cr.plugins_.Sprite.prototype.acts.SetAnim,null,7400841162817555,!1,[[1,[2,"Ingles"]],[3,1]]],[70,cr.plugins_.Sprite.prototype.acts.SetAnim,null,7044307833518499,!1,[[1,[2,"Ingles"]],
[3,1]]]]],[0,null,!1,null,479762454989376,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,438949334185963,!1,[[11,"Frances"],[8,0],[7,[0,1]]]]],[[120,cr.plugins_.Text.prototype.acts.SetText,null,0xd542a7ccbd0cd,!1,[[7,[2,"Manqu\u00e9"]]]],[122,cr.plugins_.Text.prototype.acts.SetText,null,0xf50b0fa454f44,!1,[[7,[2,"Principal"]]]],[125,cr.plugins_.Text.prototype.acts.SetText,null,6720074727487354,!1,[[7,[2,"Appuyez sur pour commencer"]]]],[68,cr.plugins_.Sprite.prototype.acts.SetAnim,
null,4936360484272867,!1,[[1,[2,"Frances"]],[3,1]]],[69,cr.plugins_.Sprite.prototype.acts.SetAnim,null,4599968214583114,!1,[[1,[2,"Frances"]],[3,1]]],[-1,cr.system_object.prototype.acts.SetVar,null,5649264999130964,!1,[[11,"Celos"],[7,[0,1]]]]]],[0,null,!1,null,0x7970ddf2d8e3e,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x59da37e0ade69,!1,[[11,"Sueco"],[8,0],[7,[0,1]]]]],[[120,cr.plugins_.Text.prototype.acts.SetText,null,0x4839b87214794,!1,[[7,[2,"Misslyckades"]]]],[122,cr.plugins_.Text.prototype.acts.SetText,
null,0x762743462b0e9,!1,[[7,[2,"Meny"]]]],[125,cr.plugins_.Text.prototype.acts.SetText,null,345692339193268,!1,[[7,[2,"Peka p\u00e5 f\u00f6r att starta"]]]],[68,cr.plugins_.Sprite.prototype.acts.SetAnim,null,9826847787138784,!1,[[1,[2,"Sueco"]],[3,1]]],[69,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6997182756605865,!1,[[1,[2,"Sueco"]],[3,1]]],[-1,cr.system_object.prototype.acts.SetVar,null,430619340243082,!1,[[11,"Celos"],[7,[0,1]]]]]],[0,null,!1,null,9480730069053546,[[136,cr.plugins_.Sprite.prototype.cnds.CompareY,
null,0,!1,!1,!1,0xbbcb4d48cef60,!1,[[8,3],[0,[0,314]]]]],[[137,cr.plugins_.Sprite.prototype.acts.SetScale,null,8051260618037332,!1,[[0,[0,1]]]]]],[0,null,!1,null,9866766053649976,[[136,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,0xa45bd03eb4f26,!1,[[8,3],[0,[0,310]]]]],[[137,cr.plugins_.Sprite.prototype.acts.SetScale,null,7405124478273296,!1,[[0,[1,1.05]]]]]],[0,null,!1,null,567022708171805,[[136,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,6744211379104287,!1,[[8,3],
[0,[0,305]]]]],[[137,cr.plugins_.Sprite.prototype.acts.SetScale,null,7930127468055323,!1,[[0,[1,1.1]]]]]],[0,null,!1,null,9963408395311932,[[136,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,8053992839162185,!1,[[8,3],[0,[0,300]]]]],[[137,cr.plugins_.Sprite.prototype.acts.SetScale,null,7458219727767599,!1,[[0,[1,1.15]]]]]],[0,null,!1,null,4600796482954846,[[136,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,0x3a92ef2be6b39,!1,[[8,3],[0,[0,294]]]]],[[137,cr.plugins_.Sprite.prototype.acts.SetScale,
null,6707951633109991,!1,[[0,[1,1.2]]]]]],[0,null,!1,null,556548537281674,[[133,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xb9705d6f16cd9,!1,[[4,136]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,6886325701521436,!1,[[11,"Apuntar"],[7,[0,1]]]],[55,cr.plugins_.Sprite.prototype.acts.SetAnim,null,7385567200658806,!1,[[1,[2,"Animation2"]],[3,1]]],[55,cr.plugins_.Sprite.prototype.acts.SetPos,null,0xd7a29a52dd860,!1,[[0,[0,69]],[0,[0,185]]]],[-1,cr.system_object.prototype.acts.SetVar,
null,0xe60be709acfd6,!1,[[11,"3Balones"],[7,[0,1]]]],[136,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x615bd9c2d398f,!1],[137,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x484c5e1832b6a,!1],[133,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6319599887751475,!1,[[1,[2,"Default"]],[3,1]]]]],[0,null,!1,null,0xbd1e9c24dd32f,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,4757667529847031,!1,[[11,"3Balones"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,
0,!1,!1,!1,0x69f6dbad131c2,!1,[[11,"Apuntar"],[8,0],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,9535219975326816,!1,[[11,"3Balones"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xcd480c29baff5,!1,[[0,[1,1.1]]]],[133,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0x5c914c0dc0b04,!1,[[1,[2,"3Balones"]],[3,1]]]]]]],["Event Brasil",[[1,"RashoLaser",0,0,!1,!1,0x3b2ad2b60cdbd,!1],[1,"Alineacion",0,0,!1,!1,0x8f4565bb46c7a,!1],[0,null,!1,null,0x81cd297b349bd,[[23,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,0x80e8db80e13d5,!1,[[4,133]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,0xc29f78d70c8a0,!1,[[0,[1,1E-5]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0xcfaf08883328c,!1,[[4,2],[5,[0,1]],[0,[0,320]],[0,[0,90]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,5801772027950068,!1,[[4,66],[5,[0,1]],[0,[0,319]],[0,[0,90]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,4830849116890836,!1,[[4,3],[5,[0,1]],[0,[0,355]],[0,[0,165]]]],[-1,cr.system_object.prototype.acts.SetVar,
null,0x6d3696523cfc3,!1,[[11,"Dialogo"],[7,[0,1]]]]]],[0,null,!1,null,5669270208471729,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7566228109103265,!1,[[4,66]]]],[[66,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xbaff9de4c0fcf,!1],[-1,cr.system_object.prototype.acts.Wait,null,369910437336543,!1,[[0,[1,1E-5]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,5308222696090216,!1,[[4,67],[5,[0,1]],[0,[0,319]],[0,[0,90]]]]]],[0,null,!1,null,441872069325946,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,
null,1,!1,!1,!1,6983971963116488,!1,[[4,67]]]],[[3,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xb48b904bcb8bc,!1],[67,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xfeedcb5d64aea,!1],[2,cr.plugins_.Sprite.prototype.acts.Destroy,null,7571833518696701,!1],[-1,cr.system_object.prototype.acts.Wait,null,0xca2c5ccc51c4a,!1,[[0,[1,1E-5]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,9893520399192776,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x956d2659d849b,!1,[[11,"Dialogo"],
[7,[0,0]]]]]],[0,null,!1,null,9415847208192676,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,9860749740968784,!1,[[4,3]]]],[[66,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x89b7b8869f0cb,!1],[67,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x4438789f196e8,!1],[3,cr.plugins_.Sprite.prototype.acts.Destroy,null,6540265412444409,!1],[2,cr.plugins_.Sprite.prototype.acts.Destroy,null,847574322431655,!1],[-1,cr.system_object.prototype.acts.Wait,null,9743020082145568,!1,[[0,[1,
1E-5]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0x9548f601b090b,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,4947633852550127,!1,[[11,"Dialogo"],[7,[0,0]]]]]],[0,null,!1,null,7538515122351437,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,7674751678637276,!1]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,0xc5ab02cfb7152,!1,[[0,[0,0]]]],[133,cr.behaviors.Physics.prototype.acts.SetIterations,"Physics",0x5c3627449d9ad,!1,[[0,[0,12]],[0,
[0,8]]]],[10,cr.plugins_.Audio.prototype.acts.Play,null,6447180069112109,!1,[[2,["brasil",!0]],[3,1],[0,[0,0]],[1,[2,"Brasil"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5647049116502452,!1,[[11,"Disparos"],[7,[0,15]]]],[-1,cr.system_object.prototype.acts.SetVar,null,6186851538902574,!1,[[11,"Jugadores"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9943873784745182,!1,[[11,"Banner"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,7176996749377759,!1,[[11,"Alineacion"],
[7,[0,1]]]]]],[0,null,!1,null,6270153232873266,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x7c86dda9de973,!1,[[11,"Alineacion"],[8,0],[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xef09755e3610b,!1,[[11,"Jugadores"],[8,2],[7,[0,5]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x60429c0a1cd44,!1,[[11,"Apuntar"],[8,0],[7,[0,1]]]]],[[133,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0x986a9752b6370,!1,[[4,1],[7,[0,0]]]]],
[[0,null,!1,null,5029709285056457,[[12,cr.plugins_.Touch.prototype.cnds.IsInTouch,null,0,!1,!1,!1,645503231613218,!1]],[[133,cr.plugins_.Sprite.prototype.acts.SetAngle,null,5312301132258706,!1,[[0,[19,cr.system_object.prototype.exps.angle,[[20,12,cr.plugins_.Touch.prototype.exps.X,!1,null],[20,12,cr.plugins_.Touch.prototype.exps.Y,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]]]],[133,cr.plugins_.Sprite.prototype.acts.MoveAtAngle,null,
0x89ba8fdf0b606,!1,[[0,[4,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null],[0,180]]],[0,[19,cr.system_object.prototype.exps.min,[[7,[19,cr.system_object.prototype.exps.distance,[[20,12,cr.plugins_.Touch.prototype.exps.X,!1,null],[20,12,cr.plugins_.Touch.prototype.exps.Y,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]],[0,3]],[0,45]]]]]],[-1,cr.system_object.prototype.acts.ScrollToObject,null,5339651474626899,!1,[[4,1]]],[1,cr.plugins_.Sprite.prototype.acts.SetVisible,
null,0xa0a610e4f8e2f,!1,[[3,1]]],[1,cr.plugins_.Sprite.prototype.acts.SetTowardPosition,null,7978904032502403,!1,[[0,[20,133,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[20,133,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]]]],[0,null,!1,null,6067968992200498,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,8823358485070638,!1]],[[1,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0xa6f1d3f5bb106,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.SetVar,null,5861561827613987,!1,
[[11,"Apuntar"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xf89f0b69467bc,!1,[[11,"Tiro"],[7,[7,[19,cr.system_object.prototype.exps.distance,[[20,133,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,133,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]],[0,15]]]]],[133,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,7145343884690335,!1,[[4,1],[7,[0,0]]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,
"Physics",824567893572631,!1,[[3,1]]],[55,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",8534532954467851,!1,[[3,1]]],[55,cr.plugins_.Sprite.prototype.acts.SetAnim,null,4670346808769132,!1,[[1,[2,"Default"]],[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,565424437378642,!1,[[0,[0,1]]]],[133,cr.plugins_.Sprite.prototype.acts.SetAnim,null,4788889416572726,!1,[[1,[2,"Tiro"]],[3,1]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",0x7c4b511e5abec,!1,[[3,0]]],[133,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,
"Physics",0x99a2f942e48d8,!1,[[0,[23,"Tiro"]],[0,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null]],[7,[0,0]]]]]]]],[0,null,!1,null,9523992898858836,[[55,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x5e8e2c66bbc1,!1,[[4,71]]]],[[55,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",520401465454957,!1,[[3,0]]]]],[0,null,!1,null,7550899896075819,[[133,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,7116464714425778,!1],[55,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
null,0,!1,!1,!1,402968329527064,!1]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0xaf30f720d8a01,!1,[[4,133],[5,[0,1]],[0,[0,0]],[0,[0,0]]]],[55,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6361164473997457,!1,[[1,[2,"Animation2"]],[3,1]]],[55,cr.plugins_.Sprite.prototype.acts.SetPos,null,7589784926503229,!1,[[0,[0,69]],[0,[0,185]]]],[-1,cr.system_object.prototype.acts.SubVar,null,9482245943091518,!1,[[11,"Disparos"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x61e4b6cb0809e,
!1,[[11,"RashoLaser"],[7,[0,0]]]]]],[0,null,!1,null,6281165709840771,[[133,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,0x491b3cc88cf37,!1]],[[-1,cr.system_object.prototype.acts.SetVar,null,9468584490919522,!1,[[11,"Apuntar"],[7,[0,1]]]]]],[0,null,!1,null,0xf718e42b8eb6d,[[133,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9197421933920028,!1,[[4,0]]]],[[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",4568371974907888,!1,[[3,1]]],[133,cr.behaviors.Rotate.prototype.acts.SetSpeed,
"Rotate",5041259132587822,!1,[[0,[0,720]]]],[-1,cr.system_object.prototype.acts.Wait,null,9662792311010364,!1,[[0,[1,1]]]],[133,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xc2926aef40cd0,!1]]],[0,null,!1,null,0xa8f98f5da032b,[[132,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6523375216195897,!1,[[4,0]]]],[[132,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",0xda39eb57bb17a,!1,[[3,1]]],[132,cr.behaviors.Rotate.prototype.acts.SetSpeed,"Rotate",5596277075453219,!1,[[0,
[0,720]]]],[-1,cr.system_object.prototype.acts.Wait,null,507306384655202,!1,[[0,[1,1]]]],[132,cr.plugins_.Sprite.prototype.acts.Destroy,null,8564947717070214,!1]]],[0,null,!1,null,0x59093cf0cc24e,[[133,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9522804818545882,!1,[[4,147]]]],[[133,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",0x58e44940ca134,!1,[[0,[4,[23,"Tiro"],[1,0.5]]],[0,[5,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null],[0,180]]],[7,[0,0]]]],
[-1,cr.system_object.prototype.acts.AddVar,null,0xdd47d6ec37eb,!1,[[11,"Jugadores"],[7,[0,1]]]],[147,cr.plugins_.Sprite.prototype.acts.StopAnim,null,307587888433202,!1],[147,cr.plugins_.Sprite.prototype.acts.SetAngle,null,0xe8b346edb64ac,!1,[[0,[0,90]]]],[147,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,7597544122980507,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,6863914828687718,!1,[[0,[1,0.2]]]],[147,cr.plugins_.Sprite.prototype.acts.Destroy,null,9110641928088508,!1]]],[0,
null,!1,null,9428890235028160,[[20,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,9744170083477028,!1,[[8,0],[0,[0,0]]]]],[[20,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",4535526563995565,!1,[[0,[0,0]]]]]],[0,null,!1,null,0xbee28bf1f11d5,[[20,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,998309667235015,!1,[[8,0],[0,[0,4]]]]],[[20,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",7293990327522395,!1,[[0,[0,180]]]]]],[0,null,!1,null,9448909211191120,
[[132,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xf75366f018730,!1,[[4,0]]]],[[132,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",7236927914956743,!1,[[3,1]]],[132,cr.behaviors.Rotate.prototype.acts.SetSpeed,"Rotate",4997366097491366,!1,[[0,[0,720]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xcbdace3a533fc,!1,[[0,[1,1]]]],[132,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x988431ce92300,!1]]],[0,null,!1,null,0x7939f6d5b5405,[[132,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,
null,1,!1,!1,!1,0x7ee92e9b918d7,!1],[22,cr.plugins_.Sprite.prototype.cnds.IsOnLayer,null,0,!1,!1,!1,9264065668034444,!1,[[5,[0,1]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,9924914830922E3,!1,[[4,132],[5,[0,1]],[0,[0,516]],[0,[0,322]]]],[22,cr.plugins_.Sprite.prototype.acts.StartAnim,null,0x67696b8ed314f,!1,[[3,1]]]]],[0,null,!1,null,6310029070461409,[[22,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,0xe0bd72013a345,!1]],[[-1,cr.system_object.prototype.acts.Wait,null,
0x4bb17a2eb31b6,!1,[[0,[1,0.5]]]],[132,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xdbf41d2b09fc2,!1]]],[0,null,!1,null,6645624478546494,[[22,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,9983519680740948,!1,[[8,0],[0,[0,3]]]]],[[132,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",0xffe95945b487f,!1,[[3,0]]],[132,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",59540698437514,!1,[[0,[1,0.3]],[0,[19,cr.system_object.prototype.exps.choose,[[0,310],[0,
290],[0,270]]]],[7,[0,0]]]]]],[0,null,!1,null,0xa2e524d902c15,[[23,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,0x8dd63b74c4c91,!1,[[1,[2,"Arriba"]]]]],[[23,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",321046759849841,!1,[[0,[0,270]]]]]],[0,null,!1,null,8177393516560843,[[23,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,0x98063f02a28a6,!1,[[1,[2,"Abajo"]]]]],[[23,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",8199664522376389,!1,[[0,
[0,90]]]]]],[0,null,!1,null,0xfa7dbebcd6a14,[[23,cr.plugins_.Sprite.prototype.cnds.OnAnimFinished,null,1,!1,!1,!1,7265398178168171,!1,[[1,[2,"Arriba"]]]]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xc05224d9c35e5,!1,[[1,[2,"Abajo"]],[3,1]]]]],[0,null,!1,null,0x5660d118a6f42,[[23,cr.plugins_.Sprite.prototype.cnds.OnAnimFinished,null,1,!1,!1,!1,4915733346665193,!1,[[1,[2,"Abajo"]]]]],[[23,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xcf21e5b84d558,!1,[[1,[2,"Arriba"]],[3,1]]]]],[0,null,
!1,null,0x77e47b1473540,[[24,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,9355908543739236,!1,[[8,0],[0,[0,11]]]]],[[24,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",9099018818457662,!1,[[0,[0,180]]]]]],[0,null,!1,null,0xdf321a269dba1,[[24,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,0x8ac6dfbf7e95d,!1,[[8,0],[0,[0,0]]]]],[[24,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",8626837040403735,!1,[[0,[0,0]]]]]],[0,null,!1,null,8229208528550951,
[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,590507012455215,!1,[[11,"Disparos"],[8,0],[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,27659669006415,!1,[[0,[0,5]]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,6292154242311685,!1,[[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,6624448748456455,!1,[[4,120],[5,[0,1]],[0,[0,257]],[0,[0,109]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8836529790681403,!1,[[11,"Banner"],[7,
[0,1]]]],[14,cr.plugins_.CJSAds.prototype.acts.ShowBanner,null,8341382844595234,!1,[[3,1]]],[122,cr.plugins_.Text.prototype.acts.Destroy,null,969934867747639,!1],[-1,cr.system_object.prototype.acts.CreateObject,null,7748981429245779,!1,[[4,122],[5,[0,1]],[0,[0,271]],[0,[0,153]]]],[122,cr.plugins_.Text.prototype.acts.SetOpacity,null,7691339778528025,!1,[[0,[0,100]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,5548767478945866,!1,[[4,7],[5,[0,1]],[0,[0,625]],[0,[0,345]]]]]],[0,null,!1,null,
0xcc7751890e432,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,5882802580544237,!1,[[4,122]]]],[[147,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x74818b196ccf0,!1],[-1,cr.system_object.prototype.acts.GoToLayout,null,4705159913156534,!1,[[6,"Menu"]]],[10,cr.plugins_.Audio.prototype.acts.Stop,null,0x942d41e125844,!1,[[1,[2,"Brasil"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9243750450724522,!1,[[11,"Banner"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,
0xbaa6e7eda351c,!1,[[11,"3Balones"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9923469370142280,!1,[[11,"RashoLaser"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8012428973427901,!1,[[11,"Tiempo"],[7,[0,0]]]]]],[0,null,!1,null,8166565322324115,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,762151702228339,!1,[[11,"Jugadores"],[8,0],[7,[0,5]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9972735687525072,!1,[[11,"Dialogo"],[8,0],
[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,9518511106871340,!1,[[0,[0,5]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,6572098867513665,!1,[[4,5],[5,[0,1]],[0,[0,305]],[0,[0,95]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x48552730b839e,!1,[[11,"Mexico"],[7,[0,2]]]],[13,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,0x9af3b6514d57c,!1,[[1,[2,"Mexico"]],[7,[23,"Mexico"]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,7828632488263252,
!1,[[0,[1,1E-5]]]],[-1,cr.system_object.prototype.acts.SetVar,null,6566665003952096,!1,[[11,"Banner"],[7,[0,1]]]],[14,cr.plugins_.CJSAds.prototype.acts.ShowBanner,null,5898985657616184,!1,[[3,1]]],[122,cr.plugins_.Text.prototype.acts.Destroy,null,388282568633591,!1],[-1,cr.system_object.prototype.acts.CreateObject,null,6193689043990546,!1,[[4,122],[5,[0,1]],[0,[0,271]],[0,[0,153]]]],[122,cr.plugins_.Text.prototype.acts.SetOpacity,null,9781756449347020,!1,[[0,[0,100]]]],[-1,cr.system_object.prototype.acts.CreateObject,
null,8933232838875951,!1,[[4,7],[5,[0,1]],[0,[0,625]],[0,[0,345]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,7961788949269516,!1,[[4,142],[5,[0,1]],[0,[0,308]],[0,[0,247]]]]]],[0,null,!1,null,0xe98143e427dd2,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,0x8c9b54b5ff521,!1]],[[119,cr.plugins_.Text.prototype.acts.SetText,null,9833803558404236,!1,[[7,[10,[2,": "],[23,"Disparos"]]]]]]],[0,null,!1,null,9620306537935400,[[-1,cr.system_object.prototype.cnds.CompareVar,null,
0,!1,!1,!1,662053935249848,!1,[[11,"HighScore"],[8,0],[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xaa3d93e962fd5,!1,[[11,"Jugadores"],[8,0],[7,[0,5]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,0x4ea8e548a0a5f,!1,[[11,"HighScore"],[7,[0,1]]]],[13,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,6251769870387708,!1,[[1,[2,"Selecciones"]],[7,[23,"HighScore"]]]]]],[0,null,!1,null,8803229758392551,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,
!1,0xd3057f254d23c,!1,[[11,"Banner"],[8,0],[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,8402461786151228,!1,[[0,[1,0.2]]]]],[[14,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,0x4e5a22aa0b04e,!1]]],[0,null,!1,null,4912071813333606,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x44e3e152f1c27,!1,[[11,"Alineacion"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,0xe658aaf4f66fb,!1,[[0,[1,1E-5]]]]]],[0,null,!1,null,6970501144919886,
[[12,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,8045376431297171,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6207561334669742,!1,[[11,"Alineacion"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.Wait,null,0xa2b67760c1b2f,!1,[[0,[1,1E-5]]]],[148,cr.plugins_.Text.prototype.acts.Destroy,null,8338887125086733,!1],[-1,cr.system_object.prototype.acts.SetVar,null,8989603746774302,!1,[[11,"Alineacion"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetTimescale,
null,6644711848481213,!1,[[0,[0,1]]]]]],[0,null,!1,null,0xd6fcff732e95f,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x91331c5946793,!1,[[4,7]]]],[[11,cr.plugins_.Browser.prototype.acts.GoToURLWindow,null,6398817108930225,!1,[[1,[10,[10,[10,[2,"https://www.facebook.com/sharer/sharer.php?u=http://zlatanworldcup2014.tk/default.php?score="],[23,"HighScore"]],[2,":"]],[19,cr.system_object.prototype.exps.random,[[0,1],[0,10]]]]],[1,[2,"NewWindow"]]]]]],[0,null,!1,null,914893427620096,
[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,5096242799282705,!1,[[4,142]]]],[[11,cr.plugins_.Browser.prototype.acts.GoToURLWindow,null,5482980826025809,!1,[[1,[2,"https://play.google.com/store/apps/details?id=com.zlatan.app"]],[1,[2,"Rate"]]]]]],[0,null,!1,null,6007592880451139,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8327462613577145,!1,[[11,"Ingles"],[8,0],[7,[0,1]]]]],[[120,cr.plugins_.Text.prototype.acts.SetText,null,0x4dc961312ff58,!1,[[7,[2,"Failed"]]]],
[122,cr.plugins_.Text.prototype.acts.SetText,null,0xa7e027fa53f21,!1,[[7,[2,"Main"]]]],[125,cr.plugins_.Text.prototype.acts.SetText,null,0xb9b150c87019,!1,[[7,[2,"Tap to start"]]]],[66,cr.plugins_.Sprite.prototype.acts.SetAnim,null,9291583676195384,!1,[[1,[2,"Ingles"]],[3,1]]],[67,cr.plugins_.Sprite.prototype.acts.SetAnim,null,4560374709395932,!1,[[1,[2,"Ingles"]],[3,1]]]]],[0,null,!1,null,0xf94a50566bfff,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8187739828231808,!1,[[11,"Frances"],
[8,0],[7,[0,1]]]]],[[120,cr.plugins_.Text.prototype.acts.SetText,null,6614540222628468,!1,[[7,[2,"Manqu\u00e9"]]]],[122,cr.plugins_.Text.prototype.acts.SetText,null,0x8d3c55c1e58f,!1,[[7,[2,"Principal"]]]],[125,cr.plugins_.Text.prototype.acts.SetText,null,6740626393001137,!1,[[7,[2,"Appuyez sur pour commencer"]]]],[66,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0x65894c0c8af6d,!1,[[1,[2,"Frances"]],[3,1]]],[67,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xaeaef08e6463c,!1,[[1,[2,"Frances"]],
[3,1]]]]],[0,null,!1,null,8885421120598333,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xe7b6e71be2072,!1,[[11,"Sueco"],[8,0],[7,[0,1]]]]],[[120,cr.plugins_.Text.prototype.acts.SetText,null,0xc5d459f971a58,!1,[[7,[2,"Misslyckades"]]]],[122,cr.plugins_.Text.prototype.acts.SetText,null,8807610672911909,!1,[[7,[2,"Meny"]]]],[125,cr.plugins_.Text.prototype.acts.SetText,null,0xceb11621b8f,!1,[[7,[2,"Peka p\u00e5 f\u00f6r att starta"]]]],[66,cr.plugins_.Sprite.prototype.acts.SetAnim,
null,7198462460671225,!1,[[1,[2,"Sueco"]],[3,1]]],[67,cr.plugins_.Sprite.prototype.acts.SetAnim,null,7531694569563139,!1,[[1,[2,"Sueco"]],[3,1]]]]],[0,null,!1,null,7270591453753852,[[130,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,6904201348209823,!1,[[8,3],[0,[0,184]]]]],[[131,cr.plugins_.Sprite.prototype.acts.SetScale,null,0x4ae463f19573a,!1,[[0,[0,1]]]]]],[0,null,!1,null,6920750366655665,[[130,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,0xbd7292ef0859e,!1,[[8,3],[0,
[0,181]]]]],[[131,cr.plugins_.Sprite.prototype.acts.SetScale,null,9037349155944416,!1,[[0,[1,1.05]]]]]],[0,null,!1,null,8525648843887908,[[130,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,0xc92d8feb3061,!1,[[8,3],[0,[0,176]]]]],[[131,cr.plugins_.Sprite.prototype.acts.SetScale,null,430993505223723,!1,[[0,[1,1.1]]]]]],[0,null,!1,null,6234660485180876,[[130,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,8543192546795832,!1,[[8,3],[0,[0,171]]]]],[[131,cr.plugins_.Sprite.prototype.acts.SetScale,
null,9089681625960336,!1,[[0,[1,1.15]]]]]],[0,null,!1,null,0xe927597724627,[[130,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,6721301565520376,!1,[[8,3],[0,[0,165]]]]],[[131,cr.plugins_.Sprite.prototype.acts.SetScale,null,9090999479086288,!1,[[0,[1,1.2]]]]]],[0,null,!1,null,7027085732982438,[[133,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6729977749766562,!1,[[4,130]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,8462624169262309,!1,[[11,"Apuntar"],[7,[0,1]]]],
[55,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xcda457ca5ad14,!1,[[1,[2,"Animation2"]],[3,1]]],[55,cr.plugins_.Sprite.prototype.acts.SetPos,null,8058359586095901,!1,[[0,[0,69]],[0,[0,185]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5139686185538261,!1,[[11,"RashoLaser"],[7,[0,1]]]],[130,cr.plugins_.Sprite.prototype.acts.Destroy,null,7710342395560335,!1],[131,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xa98770f6264db,!1]]],[0,null,!1,null,9705885635658854,[[135,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,8940159913230423,!1,[[4,20]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5632946853228617,!1,[[11,"RashoLaser"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xcc0a2c21cb064,!1,[[11,"Apuntar"],[8,0],[7,[0,0]]]]],[[10,cr.plugins_.Audio.prototype.acts.SetPaused,null,0x4cc1914dba0ec,!1,[[1,[2,"Brasil"]],[3,0]]],[10,cr.plugins_.Audio.prototype.acts.Play,null,888136453947074,!1,[[2,["rayo lluvia   efecto de sonido",!0]],[3,0],[0,[0,
0]],[1,[2,"Rayo"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9304883105187428,!1,[[11,"RashoLaser"],[7,[0,0]]]],[133,cr.plugins_.Sprite.prototype.acts.Spawn,null,9817825604593548,!1,[[4,143],[5,[0,0]],[7,[0,0]]]],[143,cr.plugins_.Sprite.prototype.acts.SetTowardPosition,null,0x5d846c834bf81,!1,[[0,[20,20,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[20,20,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],[144,cr.behaviors.scrollto.prototype.acts.Shake,"ScrollTo",0x8ec6dc3e3d4e1,!1,[[0,[0,
20]],[0,[1,0.4]],[3,0]]],[-1,cr.system_object.prototype.acts.SetObjectTimescale,null,403585299320171,!1,[[4,147],[0,[0,0]]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",0xa4063e6e21548,!1,[[3,1]]],[-1,cr.system_object.prototype.acts.SetObjectTimescale,null,9708164972403918,!1,[[4,55],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,7473408715207437,!1,[[0,[0,1]]]],[133,cr.plugins_.Sprite.prototype.acts.SetAnim,null,8939742975807968,!1,[[1,[2,"Tiro"]],[3,1]]],[-1,cr.system_object.prototype.acts.RestoreObjectTimescale,
null,4807506894435634,!1,[[4,147]]],[-1,cr.system_object.prototype.acts.RestoreObjectTimescale,null,5549046440668249,!1,[[4,55]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",4766945993209747,!1,[[3,0]]],[133,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",7086136578268962,!1,[[0,[23,"Tiro"]],[0,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null]],[7,[0,0]]]],[143,cr.plugins_.Sprite.prototype.acts.Destroy,null,6156044160782262,!1],[10,cr.plugins_.Audio.prototype.acts.SetPaused,
null,7464282936540142,!1,[[1,[2,"Brasil"]],[3,1]]]]],[0,null,!1,null,6130186019732769,[[135,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xb6aadcf515043,!1,[[4,22]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8516345095844902,!1,[[11,"RashoLaser"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8864185258514355,!1,[[11,"Apuntar"],[8,0],[7,[0,0]]]]],[[10,cr.plugins_.Audio.prototype.acts.SetPaused,null,0xcefd25f7e10f7,!1,[[1,[2,"Brasil"]],
[3,0]]],[10,cr.plugins_.Audio.prototype.acts.Play,null,0x5d0da160ba4c1,!1,[[2,["rayo lluvia   efecto de sonido",!0]],[3,0],[0,[0,0]],[1,[2,"Rayo"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x8327147044ae7,!1,[[11,"RashoLaser"],[7,[0,0]]]],[133,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xd6d64302e6bb5,!1,[[4,143],[5,[0,0]],[7,[0,0]]]],[143,cr.plugins_.Sprite.prototype.acts.SetTowardPosition,null,0xaf98a1ab8ff41,!1,[[0,[20,22,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[20,22,cr.plugins_.Sprite.prototype.exps.Y,
!1,null]]]],[144,cr.behaviors.scrollto.prototype.acts.Shake,"ScrollTo",0x652348e5c422e,!1,[[0,[0,20]],[0,[1,0.4]],[3,0]]],[-1,cr.system_object.prototype.acts.SetObjectTimescale,null,891325939745241,!1,[[4,147],[0,[0,0]]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",8355697679120038,!1,[[3,1]]],[-1,cr.system_object.prototype.acts.SetObjectTimescale,null,7316880527942811,!1,[[4,55],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x8b96aab00230e,!1,[[0,[0,1]]]],[133,cr.plugins_.Sprite.prototype.acts.SetAnim,
null,0x5bc353bcbcf41,!1,[[1,[2,"Tiro"]],[3,1]]],[-1,cr.system_object.prototype.acts.RestoreObjectTimescale,null,9535938153688632,!1,[[4,147]]],[-1,cr.system_object.prototype.acts.RestoreObjectTimescale,null,4734804968888774,!1,[[4,55]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",8308991602006382,!1,[[3,0]]],[133,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",7301155963882279,!1,[[0,[23,"Tiro"]],[0,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null]],[7,
[0,0]]]],[143,cr.plugins_.Sprite.prototype.acts.Destroy,null,5087840773768793,!1],[10,cr.plugins_.Audio.prototype.acts.SetPaused,null,0xffa607d400628,!1,[[1,[2,"Brasil"]],[3,1]]]]],[0,null,!1,null,8310847399763373,[[135,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8241338178620984,!1,[[4,24]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6526249857861915,!1,[[11,"RashoLaser"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6475218693718478,
!1,[[11,"Apuntar"],[8,0],[7,[0,0]]]]],[[10,cr.plugins_.Audio.prototype.acts.SetPaused,null,6562494472750007,!1,[[1,[2,"Brasil"]],[3,0]]],[10,cr.plugins_.Audio.prototype.acts.Play,null,8281698193030533,!1,[[2,["rayo lluvia   efecto de sonido",!0]],[3,0],[0,[0,0]],[1,[2,"Rayo"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x3ddf7a29e23cb,!1,[[11,"RashoLaser"],[7,[0,0]]]],[133,cr.plugins_.Sprite.prototype.acts.Spawn,null,8203898096378973,!1,[[4,143],[5,[0,0]],[7,[0,0]]]],[143,cr.plugins_.Sprite.prototype.acts.SetTowardPosition,
null,6232992835911505,!1,[[0,[20,24,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[20,24,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],[144,cr.behaviors.scrollto.prototype.acts.Shake,"ScrollTo",5915578180589438,!1,[[0,[0,20]],[0,[1,0.4]],[3,0]]],[-1,cr.system_object.prototype.acts.SetObjectTimescale,null,0x62fb7f3fe237c,!1,[[4,147],[0,[0,0]]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",9970494651085632,!1,[[3,1]]],[-1,cr.system_object.prototype.acts.SetObjectTimescale,null,
0xf477eabda2a86,!1,[[4,55],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,9092307236201380,!1,[[0,[0,1]]]],[133,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xd5db8527ea964,!1,[[1,[2,"Tiro"]],[3,1]]],[-1,cr.system_object.prototype.acts.RestoreObjectTimescale,null,8336691356189479,!1,[[4,147]]],[-1,cr.system_object.prototype.acts.RestoreObjectTimescale,null,5271719562350748,!1,[[4,55]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",7654159581904497,!1,[[3,0]]],[133,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,
"Physics",4840114626020836,!1,[[0,[23,"Tiro"]],[0,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null]],[7,[0,0]]]],[143,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x7032b2deb02dd,!1],[10,cr.plugins_.Audio.prototype.acts.SetPaused,null,592776333964381,!1,[[1,[2,"Brasil"]],[3,1]]]]],[0,null,!1,null,0x838a37d022631,[[135,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,620101338156465,!1,[[4,21]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5155227255836754,!1,
[[11,"RashoLaser"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x72973e9da0480,!1,[[11,"Apuntar"],[8,0],[7,[0,0]]]]],[[10,cr.plugins_.Audio.prototype.acts.SetPaused,null,0xb4fe5dc15d8be,!1,[[1,[2,"Brasil"]],[3,0]]],[10,cr.plugins_.Audio.prototype.acts.Play,null,971105907741864,!1,[[2,["rayo lluvia   efecto de sonido",!0]],[3,0],[0,[0,0]],[1,[2,"Rayo"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,7854386717802958,!1,[[11,"RashoLaser"],[7,[0,0]]]],[133,cr.plugins_.Sprite.prototype.acts.Spawn,
null,955153501550973,!1,[[4,143],[5,[0,0]],[7,[0,0]]]],[143,cr.plugins_.Sprite.prototype.acts.SetTowardPosition,null,0x3f0f0b25db89e,!1,[[0,[20,21,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[20,21,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],[144,cr.behaviors.scrollto.prototype.acts.Shake,"ScrollTo",0x921f73a5616bf,!1,[[0,[0,20]],[0,[1,0.4]],[3,0]]],[-1,cr.system_object.prototype.acts.SetObjectTimescale,null,8062100790519342,!1,[[4,147],[0,[0,0]]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,
"Physics",0xa749ba70100de,!1,[[3,1]]],[-1,cr.system_object.prototype.acts.SetObjectTimescale,null,9645947752055996,!1,[[4,55],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,5379865133656664,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestoreObjectTimescale,null,0xf62c335312a9,!1,[[4,147]]],[-1,cr.system_object.prototype.acts.RestoreObjectTimescale,null,419683847730037,!1,[[4,55]]],[133,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0x8d3e10c101c36,!1,[[1,[2,"Tiro"]],[3,1]]],[133,
cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",9775462070763004,!1,[[3,0]]],[133,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",6138794488634086,!1,[[0,[23,"Tiro"]],[0,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null]],[7,[0,0]]]],[143,cr.plugins_.Sprite.prototype.acts.Destroy,null,6933090260718993,!1],[10,cr.plugins_.Audio.prototype.acts.SetPaused,null,5821877330417642,!1,[[1,[2,"Brasil"]],[3,1]]]]],[0,null,!1,null,0xf5ffe754ac69b,[[135,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,541486662995327,!1,[[4,23]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x3f8eb82417036,!1,[[11,"RashoLaser"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5388485858803062,!1,[[11,"Apuntar"],[8,0],[7,[0,0]]]]],[[10,cr.plugins_.Audio.prototype.acts.SetPaused,null,747311728360439,!1,[[1,[2,"Brasil"]],[3,0]]],[10,cr.plugins_.Audio.prototype.acts.Play,null,9174178877974194,!1,[[2,["rayo lluvia   efecto de sonido",!0]],[3,0],[0,[0,
0]],[1,[2,"Rayo"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,7485902195980626,!1,[[11,"RashoLaser"],[7,[0,0]]]],[133,cr.plugins_.Sprite.prototype.acts.Spawn,null,0x95cd86be28bc3,!1,[[4,143],[5,[0,0]],[7,[0,0]]]],[143,cr.plugins_.Sprite.prototype.acts.SetTowardPosition,null,5030666964831069,!1,[[0,[20,23,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[20,23,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],[144,cr.behaviors.scrollto.prototype.acts.Shake,"ScrollTo",9747859840449716,!1,[[0,[0,
20]],[0,[1,0.4]],[3,0]]],[-1,cr.system_object.prototype.acts.SetObjectTimescale,null,4553006626851496,!1,[[4,147],[0,[0,0]]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",0xb9a5db7f42c08,!1,[[3,1]]],[-1,cr.system_object.prototype.acts.SetObjectTimescale,null,4783246994339561,!1,[[4,55],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,4728672164676419,!1,[[0,[0,1]]]],[133,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xb5531cf2f47fe,!1,[[1,[2,"Tiro"]],[3,1]]],[-1,cr.system_object.prototype.acts.RestoreObjectTimescale,
null,0x7a30bdf5b794e,!1,[[4,147]]],[-1,cr.system_object.prototype.acts.RestoreObjectTimescale,null,4997935202424217,!1,[[4,55]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",0xc860c4ddbbd8a,!1,[[3,0]]],[133,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",0x5a2ab6298251c,!1,[[0,[23,"Tiro"]],[0,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null]],[7,[0,0]]]],[143,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xdd6c181ea5a29,!1],[10,cr.plugins_.Audio.prototype.acts.SetPaused,
null,0x6583136ad5669,!1,[[1,[2,"Brasil"]],[3,1]]]]],[0,null,!1,null,846632206116142,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8932928990991881,!1,[[11,"RashoLaser"],[8,0],[7,[0,1]]]]],[[133,cr.plugins_.Sprite.prototype.acts.SetAnim,null,9430510322905954,!1,[[1,[2,"BalonRasho"]],[3,1]]],[135,cr.plugins_.Sprite.prototype.acts.SetX,null,0x5b44f4b31ea0f,!1,[[0,[20,133,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]],[135,cr.plugins_.Sprite.prototype.acts.SetY,null,6712578238252626,
!1,[[0,[20,133,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]]]],[0,null,!1,null,7262745559514525,[[143,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xa1fbf41ee9f05,!1,[[4,147]]]],[[147,cr.plugins_.Sprite.prototype.acts.SetEffect,null,5936712299397928,!1,[[3,1]]],[-1,cr.system_object.prototype.acts.AddVar,null,6406567870718536,!1,[[11,"Jugadores"],[7,[0,1]]]],[147,cr.plugins_.Sprite.prototype.acts.StopAnim,null,0x91f1e0ceaf114,!1],[147,cr.plugins_.Sprite.prototype.acts.SetCollisions,
null,7428517978067763,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,4882816823637833,!1,[[0,[1,0.4]]]],[147,cr.plugins_.Sprite.prototype.acts.Destroy,null,7604475563852569,!1]]]]],["Event Mexico",[[1,"3Balones",0,0,!1,!1,0xff4ec9efe61c7,!1],[0,null,!1,null,0xd8b23987b0845,[[27,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6999601409851773,!1,[[4,133]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,9350698632226100,!1,[[0,[1,1E-5]]]],[-1,cr.system_object.prototype.acts.CreateObject,
null,0xbe8464cab27f4,!1,[[4,2],[5,[0,1]],[0,[0,320]],[0,[0,90]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0xf04814f69645b,!1,[[4,59],[5,[0,1]],[0,[0,319]],[0,[0,90]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0x8ce75c6894b33,!1,[[4,3],[5,[0,1]],[0,[0,355]],[0,[0,165]]]],[-1,cr.system_object.prototype.acts.SetVar,null,591097377543381,!1,[[11,"Dialogo"],[7,[0,1]]]]]],[0,null,!1,null,0x9b533e5526292,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,9380518657823812,
!1,[[4,59]]]],[[59,cr.plugins_.Sprite.prototype.acts.Destroy,null,9928742136645876,!1],[-1,cr.system_object.prototype.acts.Wait,null,7087426614857533,!1,[[0,[1,1E-5]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0xb14a842d80491,!1,[[4,58],[5,[0,1]],[0,[0,319]],[0,[0,90]]]]]],[0,null,!1,null,0x6b4d5a4d970b5,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,8177849695500803,!1,[[4,58]]]],[[58,cr.plugins_.Sprite.prototype.acts.Destroy,null,8348726497854288,!1],[2,cr.plugins_.Sprite.prototype.acts.Destroy,
null,0x90b845951363a,!1],[3,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xa6579b412516a,!1],[-1,cr.system_object.prototype.acts.Wait,null,0x6b94bd3379687,!1,[[0,[1,1E-5]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,9637114834671884,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xfe184a82eb9c8,!1,[[11,"Dialogo"],[7,[0,0]]]]]],[0,null,!1,null,0xbe1486f315c27,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7123936066322284,!1,[[4,3]]]],[[59,cr.plugins_.Sprite.prototype.acts.Destroy,
null,710915825778098,!1],[58,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xba97e73a616d5,!1],[3,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x775a73497e1fb,!1],[2,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x8d94ae4986b3c,!1],[-1,cr.system_object.prototype.acts.Wait,null,0xc9bf040fdb25e,!1,[[0,[1,1E-5]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,5739903342709535,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x9bc66ac31ddf7,!1,[[11,"Dialogo"],[7,[0,0]]]]]],
[0,null,!1,null,0x836a93639cf08,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,8082431281253799,!1]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,0xc86d4d72cb338,!1,[[0,[0,0]]]],[133,cr.behaviors.Physics.prototype.acts.SetIterations,"Physics",0xa070e36a2d152,!1,[[0,[0,12]],[0,[0,8]]]],[25,cr.plugins_.Sprite.prototype.acts.StopAnim,null,9917948012741344,!1],[10,cr.plugins_.Audio.prototype.acts.Play,null,511191095084104,!1,[[2,["mexico",!0]],[3,1],[0,[0,0]],[1,[2,"Mexico"]]]],
[-1,cr.system_object.prototype.acts.SetVar,null,9683894265116454,!1,[[11,"Disparos"],[7,[0,10]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xfe56d961cd8c1,!1,[[11,"Jugadores"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xb035a6ac54eec,!1,[[11,"Banner"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5563301712484235,!1,[[11,"Alineacion"],[7,[0,1]]]]]],[0,null,!1,null,0x5d92993a65193,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7924160929998051,
!1,[[11,"Apuntar"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8408313510908105,!1,[[11,"Jugadores"],[8,2],[7,[0,5]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6235543491569405,!1,[[11,"Alineacion"],[8,0],[7,[0,0]]]]],[[133,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0x5e1ee54aafee8,!1,[[4,1],[7,[0,0]]]]],[[0,null,!1,null,6924444777644302,[[12,cr.plugins_.Touch.prototype.cnds.IsInTouch,null,0,!1,!1,!1,306082804375374,!1]],[[133,
cr.plugins_.Sprite.prototype.acts.SetAngle,null,8435152304033439,!1,[[0,[19,cr.system_object.prototype.exps.angle,[[20,12,cr.plugins_.Touch.prototype.exps.X,!1,null],[20,12,cr.plugins_.Touch.prototype.exps.Y,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]]]],[133,cr.plugins_.Sprite.prototype.acts.MoveAtAngle,null,542058246241627,!1,[[0,[4,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null],[0,180]]],[0,[19,cr.system_object.prototype.exps.min,
[[7,[19,cr.system_object.prototype.exps.distance,[[20,12,cr.plugins_.Touch.prototype.exps.X,!1,null],[20,12,cr.plugins_.Touch.prototype.exps.Y,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]],[0,3]],[0,45]]]]]],[-1,cr.system_object.prototype.acts.ScrollToObject,null,5591445489339823,!1,[[4,1]]],[1,cr.plugins_.Sprite.prototype.acts.SetVisible,null,7242832540102222,!1,[[3,1]]],[1,cr.plugins_.Sprite.prototype.acts.SetTowardPosition,null,
0x470701ceb3f73,!1,[[0,[20,133,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[20,133,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]]]],[0,null,!1,null,0x77a069cf3d86,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,5348371745487741,!1]],[[1,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x56490ab104676,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xc30d8fcc9804,!1,[[11,"Apuntar"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xd6efde59adeee,!1,[[11,
"Tiro"],[7,[7,[19,cr.system_object.prototype.exps.distance,[[20,133,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,133,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]],[0,15]]]]],[133,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,9506361554123164,!1,[[4,1],[7,[0,0]]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",0x89d6af866f5ad,!1,[[3,1]]],[55,cr.behaviors.Bullet.prototype.acts.SetEnabled,
"Bullet",5988569843463973,!1,[[3,1]]],[55,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6837369502185313,!1,[[1,[2,"Default"]],[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,0xcdc63146bf707,!1,[[0,[0,1]]]],[133,cr.plugins_.Sprite.prototype.acts.SetAnim,null,7941883885904082,!1,[[1,[2,"Tiro"]],[3,1]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",6008149518091653,!1,[[3,0]]],[133,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",0xe04f1cbe91825,!1,[[0,[23,
"Tiro"]],[0,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null]],[7,[0,0]]]]]]]],[0,null,!1,null,0x816ae2d50ad1d,[[55,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7792271520273805,!1,[[4,71]]]],[[55,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",0x8ff224c36be1b,!1,[[3,0]]]]],[0,null,!1,null,7867942083791365,[[133,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,0x5b64809e000b8,!1],[55,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,7181644233708077,
!1]],[[-1,cr.system_object.prototype.acts.CreateObject,null,9906260892176852,!1,[[4,133],[5,[0,1]],[0,[0,0]],[0,[0,0]]]],[55,cr.plugins_.Sprite.prototype.acts.SetAnim,null,825001514706837,!1,[[1,[2,"Animation2"]],[3,1]]],[55,cr.plugins_.Sprite.prototype.acts.SetPos,null,8012014591952806,!1,[[0,[0,69]],[0,[0,185]]]],[-1,cr.system_object.prototype.acts.SubVar,null,5967424802928191,!1,[[11,"Disparos"],[7,[0,1]]]]]],[0,null,!1,null,0x6bf43cf11b4be,[[133,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,
1,!1,!1,!1,42377671454984,!1]],[[-1,cr.system_object.prototype.acts.SetVar,null,6111776420723901,!1,[[11,"Apuntar"],[7,[0,1]]]]]],[0,null,!1,null,9357015742892868,[[133,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6233318672836984,!1,[[4,0]]]],[[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",0xe5d8c30615c80,!1,[[3,1]]],[133,cr.behaviors.Rotate.prototype.acts.SetSpeed,"Rotate",7902557733679432,!1,[[0,[0,720]]]],[-1,cr.system_object.prototype.acts.Wait,null,9421543296309412,
!1,[[0,[1,1]]]],[133,cr.plugins_.Sprite.prototype.acts.Destroy,null,5200269810706913,!1]]],[0,null,!1,null,9611750337875844,[[133,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5534214808887277,!1,[[4,147]]]],[[133,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",7306261432909359,!1,[[0,[4,[23,"Tiro"],[1,0.5]]],[0,[5,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null],[0,180]]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.AddVar,null,0x3a4cf0f61dce9,!1,[[11,
"Jugadores"],[7,[0,1]]]],[147,cr.plugins_.Sprite.prototype.acts.StopAnim,null,6191611279431638,!1],[147,cr.plugins_.Sprite.prototype.acts.SetAngle,null,0xd224c74bc0f42,!1,[[0,[0,90]]]],[147,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,501880544004147,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,0xfe2f39f2dbf5,!1,[[0,[1,0.2]]]],[147,cr.plugins_.Sprite.prototype.acts.Destroy,null,7467942441762143,!1]],[[0,null,!1,null,0xa5cdbb81a3f27,[[133,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
null,0,!1,!1,!1,7232888543660718,!1,[[1,[2,"3Balones"]]]]],[[133,cr.plugins_.Sprite.prototype.acts.Destroy,null,44234409776915,!1]]]]],[0,null,!1,null,0x6b21ca9898c1c,[[25,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,4712630344390564,!1,[[4,132]]]],[[25,cr.plugins_.Sprite.prototype.acts.StartAnim,null,0x47ce36778d408,!1,[[3,1]]],[25,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",7419640277474972,!1,[[3,1]]],[25,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",
5126477031730065,!1,[[0,[0,270]]]]]],[0,null,!1,null,5731817646529521,[[25,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,5690318488157691,!1,[[8,0],[0,[0,4]]]]],[[25,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xb3835b3f6feb4,!1,[[0,[0,90]]]]]],[0,null,!1,null,4564445647272991,[[25,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,5212059692305895,!1,[[8,0],[0,[0,3]]]]],[[132,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",9211401234424174,
!1,[[0,[1,0.5]],[0,[20,132,cr.plugins_.Sprite.prototype.exps.Angle,!1,null]],[7,[0,0]]]]]],[0,null,!1,null,488723199867029,[[25,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,4573144214715084,!1,[[8,0],[0,[0,8]]]]],[[25,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",0xc5428c7a86645,!1,[[3,0]]]]],[0,null,!1,null,8296590900311444,[[132,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,0x7ef7477d26011,!1]],[[132,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",
7544267461872377,!1,[[3,0]]],[132,cr.behaviors.Physics.prototype.acts.SetBullet,"Physics",9022807532733656,!1,[[3,1]]],[132,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",5921170514378158,!1,[[0,[1,1.3]],[0,[4,[20,132,cr.plugins_.Sprite.prototype.exps.Angle,!1,null],[0,270]]],[7,[0,0]]]]]],[0,null,!1,null,0x505b9cbdab0b9,[[132,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,0xe424052e7f8d6,!1],[25,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,798787930922696,
!1]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x6f136756575ce,!1,[[4,132],[5,[0,1]],[0,[0,437]],[0,[0,366]]]]]],[0,null,!1,null,0x7ccd799c4ebe,[[132,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8161132624503644,!1,[[4,0]]]],[[132,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",6921733192748133,!1,[[3,1]]],[132,cr.behaviors.Rotate.prototype.acts.SetSpeed,"Rotate",9042965342936946,!1,[[0,[0,720]]]],[-1,cr.system_object.prototype.acts.Wait,null,6886977362859186,
!1,[[0,[1,1]]]],[132,cr.plugins_.Sprite.prototype.acts.Destroy,null,7738322207937301,!1]]],[0,null,!1,null,601646730094508,[[25,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,0x654a0319ff8f6,!1]],[[-1,cr.system_object.prototype.acts.Wait,null,9563341907370686,!1,[[0,[1,0.5]]]],[132,cr.plugins_.Sprite.prototype.acts.Destroy,null,7961534826908678,!1]]],[0,null,!1,null,6758474907910957,[[26,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,613660868815807,!1,[[8,0],[0,[0,
0]]]]],[[26,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",5821177658922315,!1,[[0,[0,180]]]],[26,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",7015013006398551,!1,[[3,1]]]]],[0,null,!1,null,0x98f28f1a59d1f,[[26,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,326491067827668,!1,[[8,0],[0,[0,8]]]]],[[26,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",0x4827140894c0e,!1,[[3,0]]]]],[0,null,!1,null,9858082743212300,[[26,cr.plugins_.Sprite.prototype.cnds.CompareFrame,
null,0,!1,!1,!1,428156423757682,!1,[[8,0],[0,[0,12]]]]],[[26,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",4776582566462967,!1,[[0,[0,0]]]],[26,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",0x9252e061153cd,!1,[[3,1]]]]],[0,null,!1,null,8470886691846896,[[26,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,6840530719582112,!1,[[8,0],[0,[0,20]]]]],[[26,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",7309238136355427,!1,[[3,0]]]]],[0,null,!1,null,7446524387620398,
[[27,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,0xd16338c4b71c9,!1,[[8,0],[0,[0,0]]]]],[[27,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x91585ef9a19bc,!1,[[0,[0,90]]]]]],[0,null,!1,null,5031800477170264,[[27,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,7626808298911127,!1,[[8,0],[0,[0,6]]]]],[[27,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x5b5d1e4005819,!1,[[0,[0,270]]]]]],[0,null,!1,null,9676606480986388,[[29,cr.plugins_.Sprite.prototype.cnds.CompareFrame,
null,0,!1,!1,!1,0xcb4b90f8097c5,!1,[[8,0],[0,[0,0]]]]],[[29,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xb2e6c86d5b0b3,!1,[[0,[0,0]]]]]],[0,null,!1,null,6359308991786641,[[29,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,6131316988636571,!1,[[8,0],[0,[0,11]]]]],[[29,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",6740230845548593,!1,[[0,[0,180]]]]]],[0,null,!1,null,0xd51ed44b6311,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6322823367912294,
!1,[[11,"Disparos"],[8,0],[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0x9d44489256d77,!1,[[0,[0,5]]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,9391943177467306,!1,[[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,855098164282735,!1,[[4,120],[5,[0,1]],[0,[0,257]],[0,[0,109]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xffe5725aa8c9,!1,[[11,"Banner"],[7,[0,1]]]],[14,cr.plugins_.CJSAds.prototype.acts.ShowBanner,null,9401919385890566,!1,
[[3,1]]],[122,cr.plugins_.Text.prototype.acts.Destroy,null,634633112651557,!1],[-1,cr.system_object.prototype.acts.CreateObject,null,0x675fec9fee43,!1,[[4,122],[5,[0,1]],[0,[0,271]],[0,[0,153]]]],[122,cr.plugins_.Text.prototype.acts.SetOpacity,null,0x41fed85ab42e7,!1,[[0,[0,100]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0x4e29dc768c6df,!1,[[4,7],[5,[0,1]],[0,[0,625]],[0,[0,345]]]]]],[0,null,!1,null,0x92712601c7e33,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,
5498271049808706,!1,[[4,122]]]],[[147,cr.plugins_.Sprite.prototype.acts.Destroy,null,849098471610154,!1],[-1,cr.system_object.prototype.acts.GoToLayout,null,5477449135809233,!1,[[6,"Menu"]]],[10,cr.plugins_.Audio.prototype.acts.Stop,null,9779820811198728,!1,[[1,[2,"Mexico"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9050370595083864,!1,[[11,"Banner"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,6721375999222596,!1,[[11,"3Balones"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,
null,0x4b4a1b8b17242,!1,[[11,"RashoLaser"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x9cdf0d9eb9533,!1,[[11,"Tiempo"],[7,[0,0]]]]]],[0,null,!1,null,0xcba875af81f7,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7136929340088182,!1,[[11,"Jugadores"],[8,0],[7,[0,5]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8147897039353848,!1,[[11,"Dialogo"],[8,0],[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0xfdce36881d63c,!1,[[0,[0,
5]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,867306733075378,!1,[[4,5],[5,[0,1]],[0,[0,305]],[0,[0,95]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xb9c9817eaf62e,!1,[[11,"Inglaterra"],[7,[0,2]]]],[13,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,0x60ac5a83c0053,!1,[[1,[2,"Inglaterra"]],[7,[23,"Inglaterra"]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,4755170211724201,!1,[[0,[1,1E-5]]]],[-1,cr.system_object.prototype.acts.SetVar,null,812287062921125,!1,
[[11,"Banner"],[7,[0,1]]]],[14,cr.plugins_.CJSAds.prototype.acts.ShowBanner,null,0xc5bcdc254a6a1,!1,[[3,1]]],[122,cr.plugins_.Text.prototype.acts.Destroy,null,771936610833264,!1],[-1,cr.system_object.prototype.acts.CreateObject,null,8227099476195491,!1,[[4,122],[5,[0,1]],[0,[0,271]],[0,[0,153]]]],[122,cr.plugins_.Text.prototype.acts.SetOpacity,null,6499245788630972,!1,[[0,[0,100]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,7879012805720236,!1,[[4,7],[5,[0,1]],[0,[0,625]],[0,[0,345]]]],
[-1,cr.system_object.prototype.acts.CreateObject,null,7671388317668149,!1,[[4,142],[5,[0,1]],[0,[0,308]],[0,[0,247]]]]]],[0,null,!1,null,0x9289bbe90e853,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,9977870791481828,!1]],[[119,cr.plugins_.Text.prototype.acts.SetText,null,6002300998396058,!1,[[7,[10,[2,": "],[23,"Disparos"]]]]]]],[0,null,!1,null,4736019075077584,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x6c523b66809d,!1,[[11,"HighScore"],[8,0],[7,[0,1]]]],[-1,
cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5595505864905026,!1,[[11,"Jugadores"],[8,0],[7,[0,5]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,0x6b752cd0e341e,!1,[[11,"HighScore"],[7,[0,1]]]],[13,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,5186227250609581,!1,[[1,[2,"Selecciones"]],[7,[23,"HighScore"]]]]]],[0,null,!1,null,0x688a810e0ce96,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xd33c392f82eb1,!1,[[11,"Banner"],[8,0],[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.Every,
null,0,!1,!1,!1,5767565036079658,!1,[[0,[1,0.2]]]]],[[14,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,0xceb2156c4f32b,!1]]],[0,null,!1,null,0x454d52cd80ce3,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8854814300474129,!1,[[11,"Alineacion"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,0xb39a551040ef1,!1,[[0,[1,1E-5]]]]]],[0,null,!1,null,5886721785884894,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,9807909732140828,!1],[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,0xfed81049fb66c,!1,[[11,"Alineacion"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.Wait,null,0x7dae6dab2066b,!1,[[0,[1,1E-5]]]],[148,cr.plugins_.Text.prototype.acts.Destroy,null,9379728991577060,!1],[-1,cr.system_object.prototype.acts.SetVar,null,4782682580847464,!1,[[11,"Alineacion"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0xe7723895464bd,!1,[[0,[0,1]]]]]],[0,null,!1,null,8555573314867482,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,
1,!1,!1,!1,0x9ef3fdbba4eb1,!1,[[4,7]]]],[[11,cr.plugins_.Browser.prototype.acts.GoToURLWindow,null,0xf53ab094a1486,!1,[[1,[10,[10,[10,[2,"https://www.facebook.com/sharer/sharer.php?u=http://zlatanworldcup2014.tk/default.php?score="],[23,"HighScore"]],[2,":"]],[19,cr.system_object.prototype.exps.random,[[0,1],[0,10]]]]],[1,[2,"NewWindow"]]]]]],[0,null,!1,null,7029559224025941,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,5417643600789035,!1,[[4,142]]]],[[11,cr.plugins_.Browser.prototype.acts.GoToURLWindow,
null,5804622530156563,!1,[[1,[2,"https://play.google.com/store/apps/details?id=com.zlatan.app"]],[1,[2,"Rate"]]]]]],[0,null,!1,null,4668418994657203,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9554705786378300,!1,[[11,"Ingles"],[8,0],[7,[0,1]]]]],[[120,cr.plugins_.Text.prototype.acts.SetText,null,0x65a50a806fb7b,!1,[[7,[2,"Failed"]]]],[122,cr.plugins_.Text.prototype.acts.SetText,null,6538714333169877,!1,[[7,[2,"Main"]]]],[125,cr.plugins_.Text.prototype.acts.SetText,null,9032905917961528,
!1,[[7,[2,"Tap to start"]]]],[59,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6688017588855557,!1,[[1,[2,"Ingles"]],[3,1]]],[58,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xdf60c5c16debd,!1,[[1,[2,"Ingles"]],[3,1]]]]],[0,null,!1,null,0x59295fd287b9e,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,640881937100983,!1,[[11,"Frances"],[8,0],[7,[0,1]]]]],[[120,cr.plugins_.Text.prototype.acts.SetText,null,0xa36bf270ed3cd,!1,[[7,[2,"Manqu\u00e9"]]]],[122,cr.plugins_.Text.prototype.acts.SetText,
null,8729159931058107,!1,[[7,[2,"Principal"]]]],[125,cr.plugins_.Text.prototype.acts.SetText,null,5284672862516174,!1,[[7,[2,"Appuyez sur pour commencer"]]]],[59,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0x85ea928d18b75,!1,[[1,[2,"Frances"]],[3,1]]],[58,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0x5b10ebbf6c936,!1,[[1,[2,"Frances"]],[3,1]]]]],[0,null,!1,null,0x418b3493d261f,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6564064242990547,!1,[[11,"Sueco"],[8,0],[7,[0,1]]]]],
[[120,cr.plugins_.Text.prototype.acts.SetText,null,9675700108800308,!1,[[7,[2,"Misslyckades"]]]],[122,cr.plugins_.Text.prototype.acts.SetText,null,0x7a08e4ab97143,!1,[[7,[2,"Meny"]]]],[125,cr.plugins_.Text.prototype.acts.SetText,null,0x7785315642dce,!1,[[7,[2,"Peka p\u00e5 f\u00f6r att starta"]]]],[59,cr.plugins_.Sprite.prototype.acts.SetAnim,null,7536839751797921,!1,[[1,[2,"Sueco"]],[3,1]]],[58,cr.plugins_.Sprite.prototype.acts.SetAnim,null,7933258165653239,!1,[[1,[2,"Sueco"]],[3,1]]]]],[0,null,
!1,null,0x8bc485bb665f1,[[136,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,6451022169481255,!1,[[8,3],[0,[0,49]]]]],[[137,cr.plugins_.Sprite.prototype.acts.SetScale,null,7606327812912471,!1,[[0,[0,1]]]]]],[0,null,!1,null,6153900121247809,[[136,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,8651607385882369,!1,[[8,3],[0,[0,46]]]]],[[137,cr.plugins_.Sprite.prototype.acts.SetScale,null,7685670212787572,!1,[[0,[1,1.05]]]]]],[0,null,!1,null,551524878095843,[[136,cr.plugins_.Sprite.prototype.cnds.CompareY,
null,0,!1,!1,!1,0xed7f865042cf1,!1,[[8,3],[0,[0,41]]]]],[[137,cr.plugins_.Sprite.prototype.acts.SetScale,null,0xada3e4c4dde4b,!1,[[0,[1,1.1]]]]]],[0,null,!1,null,6102118556004189,[[136,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,50238084559166,!1,[[8,3],[0,[0,36]]]]],[[137,cr.plugins_.Sprite.prototype.acts.SetScale,null,0xb8e2dee9469fa,!1,[[0,[1,1.15]]]]]],[0,null,!1,null,6547519838659715,[[136,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,0xe38e8cc3b829,!1,[[8,3],[0,[0,
31]]]]],[[137,cr.plugins_.Sprite.prototype.acts.SetScale,null,5211048980372767,!1,[[0,[1,1.2]]]]]],[0,null,!1,null,378261522399698,[[133,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xd5e4ca0768807,!1,[[4,136]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xf47583c1835,!1,[[11,"Apuntar"],[7,[0,1]]]],[55,cr.plugins_.Sprite.prototype.acts.SetAnim,null,7409972861007505,!1,[[1,[2,"Animation2"]],[3,1]]],[55,cr.plugins_.Sprite.prototype.acts.SetPos,null,5088765652288123,!1,[[0,[0,
69]],[0,[0,185]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8803696311653841,!1,[[11,"3Balones"],[7,[0,1]]]],[136,cr.plugins_.Sprite.prototype.acts.Destroy,null,86139992556342,!1],[137,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x6cc54a73b0ea8,!1],[133,cr.plugins_.Sprite.prototype.acts.SetAnim,null,8340350561037674,!1,[[1,[2,"Default"]],[3,1]]]]],[0,null,!1,null,0xcf9595ad8dd1a,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xb498e450829e8,!1,[[11,"3Balones"],[8,0],[7,
[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x5b7dbb293b3dd,!1,[[11,"Apuntar"],[8,0],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,6479598876458365,!1,[[11,"3Balones"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,523340366189175,!1,[[0,[1,1.1]]]],[133,cr.plugins_.Sprite.prototype.acts.SetAnim,null,865086503898319,!1,[[1,[2,"3Balones"]],[3,1]]]]]]],["Event Alemania",[[0,null,!1,null,0x5d40f71bcfb77,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,
null,1,!1,!1,!1,8913905652257412,!1]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,7549126163442391,!1,[[0,[0,0]]]],[133,cr.behaviors.Physics.prototype.acts.SetIterations,"Physics",7391165586214051,!1,[[0,[0,12]],[0,[0,8]]]],[33,cr.plugins_.Sprite.prototype.acts.StopAnim,null,8653705057632861,!1],[30,cr.plugins_.Sprite.prototype.acts.StopAnim,null,8477974050266344,!1],[10,cr.plugins_.Audio.prototype.acts.Play,null,6184052540518145,!1,[[2,["alemania",!0]],[3,1],[0,[0,0]],[1,[2,"Alemania"]]]],
[-1,cr.system_object.prototype.acts.SetVar,null,0xbd86093f686f4,!1,[[11,"Disparos"],[7,[0,4]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9567434448272812,!1,[[11,"Jugadores"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,7622989973273725,!1,[[11,"Banner"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9113718630777944,!1,[[11,"Alineacion"],[7,[0,1]]]]]],[0,null,!1,null,0xbf8c457adc729,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x8d9be06a97494,
!1,[[11,"Apuntar"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8322995232201082,!1,[[11,"Jugadores"],[8,2],[7,[0,5]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xa8a0ada8402e0,!1,[[11,"Alineacion"],[8,0],[7,[0,0]]]]],[[133,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0xb12fbdeffe4b3,!1,[[4,1],[7,[0,0]]]]],[[0,null,!1,null,0x91aac6025beca,[[12,cr.plugins_.Touch.prototype.cnds.IsInTouch,null,0,!1,!1,!1,7674728489248149,!1]],[[133,cr.plugins_.Sprite.prototype.acts.SetAngle,
null,0x6bd62648a9684,!1,[[0,[19,cr.system_object.prototype.exps.angle,[[20,12,cr.plugins_.Touch.prototype.exps.X,!1,null],[20,12,cr.plugins_.Touch.prototype.exps.Y,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]]]],[133,cr.plugins_.Sprite.prototype.acts.MoveAtAngle,null,0xf005254a0a179,!1,[[0,[4,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null],[0,180]]],[0,[19,cr.system_object.prototype.exps.min,[[7,[19,cr.system_object.prototype.exps.distance,
[[20,12,cr.plugins_.Touch.prototype.exps.X,!1,null],[20,12,cr.plugins_.Touch.prototype.exps.Y,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]],[0,3]],[0,45]]]]]],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0xc9409b3b0b56,!1,[[4,1]]],[1,cr.plugins_.Sprite.prototype.acts.SetVisible,null,8870445140333921,!1,[[3,1]]],[1,cr.plugins_.Sprite.prototype.acts.SetTowardPosition,null,5224424637612808,!1,[[0,[20,133,cr.plugins_.Sprite.prototype.exps.X,
!1,null]],[0,[20,133,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]]]],[0,null,!1,null,6294818125077558,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,0xb105f5f435ca6,!1]],[[1,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0xca57bbd8aa889,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.SetVar,null,7720950392437397,!1,[[11,"Apuntar"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x6bf0fabeea07b,!1,[[11,"Tiro"],[7,[7,[19,cr.system_object.prototype.exps.distance,[[20,
133,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,133,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]],[0,15]]]]],[133,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,9185095436465192,!1,[[4,1],[7,[0,0]]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",590559249764328,!1,[[3,1]]],[55,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",9250761843530136,!1,[[3,1]]],[55,cr.plugins_.Sprite.prototype.acts.SetAnim,
null,0x9b85e4d818951,!1,[[1,[2,"Default"]],[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,7383725371550558,!1,[[0,[0,1]]]],[133,cr.plugins_.Sprite.prototype.acts.SetAnim,null,9440166566563044,!1,[[1,[2,"Tiro"]],[3,1]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",0xbc604f0a7a41e,!1,[[3,0]]],[133,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",0x715f0caf3b481,!1,[[0,[23,"Tiro"]],[0,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null]],[7,[0,0]]]]]]]],
[0,null,!1,null,0xdeb94717a9d5,[[55,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xbc4b488b0f69,!1,[[4,71]]]],[[55,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",8734605634775112,!1,[[3,0]]]]],[0,null,!1,null,0x6cdd72e959bda,[[133,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,0xfab1eb6e38382,!1],[55,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,9875985372786036,!1]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0x57a182da8f779,!1,[[4,
133],[5,[0,1]],[0,[0,0]],[0,[0,0]]]],[55,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6513490398452182,!1,[[1,[2,"Animation2"]],[3,1]]],[55,cr.plugins_.Sprite.prototype.acts.SetPos,null,0xff1ee071f5dc9,!1,[[0,[0,69]],[0,[0,185]]]],[-1,cr.system_object.prototype.acts.SubVar,null,7897882465321457,!1,[[11,"Disparos"],[7,[0,1]]]]]],[0,null,!1,null,0xb9a45e1c9092a,[[133,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,6383152299603898,!1]],[[-1,cr.system_object.prototype.acts.SetVar,null,
7045201853980698,!1,[[11,"Apuntar"],[7,[0,1]]]]]],[0,null,!1,null,0xb21355bdd3c85,[[133,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6140953112756585,!1,[[4,0]]]],[[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",7673731539027042,!1,[[3,1]]],[133,cr.behaviors.Rotate.prototype.acts.SetSpeed,"Rotate",0x9438117b9cc2,!1,[[0,[0,720]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x843e29a3bf8e3,!1,[[0,[1,1]]]],[133,cr.plugins_.Sprite.prototype.acts.Destroy,null,7560223805571066,
!1]]],[0,null,!1,null,7640367906024482,[[133,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5488198377685083,!1,[[4,147]]]],[[133,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",0xdff14ac14def5,!1,[[0,[4,[23,"Tiro"],[1,0.5]]],[0,[5,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null],[0,180]]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.AddVar,null,8618321238493975,!1,[[11,"Jugadores"],[7,[0,1]]]],[147,cr.plugins_.Sprite.prototype.acts.StopAnim,null,8701353521096005,
!1],[147,cr.plugins_.Sprite.prototype.acts.SetAngle,null,8930692060048372,!1,[[0,[0,90]]]],[147,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,9123624249023164,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,0xd42ee375e0963,!1,[[0,[1,0.2]]]],[147,cr.plugins_.Sprite.prototype.acts.Destroy,null,9896716217375792,!1]]],[0,null,!1,null,6423608959898837,[[31,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,8916636254287402,!1,[[8,0],[0,[0,0]]]]],[[31,cr.behaviors.Bullet.prototype.acts.SetEnabled,
"Bullet",6742590360624026,!1,[[3,1]]],[31,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",9999928919617536,!1,[[0,[0,0]]]]]],[0,null,!1,null,0xa270e8b350ef2,[[31,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,9356924037041796,!1,[[8,0],[0,[0,6]]]]],[[31,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",5795021420463182,!1,[[3,0]]]]],[0,null,!1,null,382584274444682,[[31,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,9473096856668896,!1,[[8,0],[0,[0,
8]]]]],[[31,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",0x3ea94cad33794,!1,[[3,1]]],[31,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xbcf766aae1f36,!1,[[0,[0,180]]]]]],[0,null,!1,null,6105605947807725,[[31,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,0xa40bfa4e14613,!1,[[8,0],[0,[0,14]]]]],[[31,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",8070199599214498,!1,[[3,0]]]]],[0,null,!1,null,0xa29caf5e93ab6,[[32,cr.plugins_.Sprite.prototype.cnds.CompareFrame,
null,0,!1,!1,!1,7694489168321047,!1,[[8,0],[0,[0,0]]]]],[[32,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",6948270973096208,!1,[[3,0]]]]],[0,null,!1,null,0xa66c43f20d84a,[[32,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,9802944171378034,!1,[[8,0],[0,[0,5]]]]],[[32,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",8019821750387859,!1,[[3,1]]],[32,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xa5c2eea7d80f1,!1,[[0,[0,0]]]]]],[0,null,!1,null,0xb7adaa081d1cd,
[[32,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,373299308495154,!1,[[8,0],[0,[0,10]]]]],[[32,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",8151690160478712,!1,[[3,0]]]]],[0,null,!1,null,0x514a7f70e3980,[[32,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,795665172629181,!1,[[8,0],[0,[0,15]]]]],[[32,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",0x4e5dd0a7c37a1,!1,[[3,1]]],[32,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",4680451366454015,
!1,[[0,[0,180]]]]]],[0,null,!1,null,0xa203edac31a31,[[33,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,0x659eb0c968c54,!1,[[8,0],[0,[0,1]]]]],[[33,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",0xf7f1855549f71,!1,[[3,1]]],[33,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",9067399257293772,!1,[[0,[0,270]]]]]],[0,null,!1,null,9315610807096156,[[33,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,9602793820867322,!1,[[8,0],[0,[0,4]]]]],[[33,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
"Bullet",4984061597489699,!1,[[0,[0,90]]]]]],[0,null,!1,null,0xae01b64e9303c,[[33,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,0xb4c6806967c7a,!1,[[8,0],[0,[0,7]]]]],[[33,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",6138588114823013,!1,[[3,0]]]]],[0,null,!1,null,0x694288ca368ff,[[132,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,6312621505648894,!1]],[[132,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",0x85c36d51f68b5,!1,[[3,0]]],[132,cr.behaviors.Physics.prototype.acts.SetBullet,
"Physics",5274131442550547,!1,[[3,1]]],[132,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",0xff602ad033b6b,!1,[[0,[1,1.35]],[0,[4,[20,132,cr.plugins_.Sprite.prototype.exps.Angle,!1,null],[0,270]]],[7,[0,0]]]]]],[0,null,!1,null,8501566230818616,[[132,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,4773400387162121,!1,[[4,33]]]],[[33,cr.plugins_.Sprite.prototype.acts.StartAnim,null,7132711560949716,!1,[[3,1]]],[30,cr.plugins_.Sprite.prototype.acts.StartAnim,null,0x55b5b4b2f9d4e,
!1,[[3,1]]],[132,cr.plugins_.Sprite.prototype.acts.ZMoveToObject,null,6522662444440614,!1,[[3,0],[4,30]]]]],[0,null,!1,null,0x95acdba40a7d4,[[132,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xa3033ea83ef53,!1,[[4,0]]]],[[132,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",0xa946201c18fdf,!1,[[3,1]]],[132,cr.behaviors.Rotate.prototype.acts.SetSpeed,"Rotate",8367814565687005,!1,[[0,[0,720]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x86a34b15d61b2,!1,[[0,[1,1]]]],
[132,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x55f5a8c6dec67,!1]]],[0,null,!1,null,0xcd64b0ef4327,[[30,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,7303218061066115,!1,[[8,0],[0,[0,5]]]]],[[132,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",0xf8bb9a678f469,!1,[[0,[1,0.5]],[0,[20,132,cr.plugins_.Sprite.prototype.exps.Angle,!1,null]],[7,[0,0]]]]]],[0,null,!1,null,7841593655897468,[[132,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,9902029443368560,
!1],[30,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,8891233961185729,!1],[33,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,5793972051038266,!1]],[[-1,cr.system_object.prototype.acts.CreateObject,null,9495251422646068,!1,[[4,132],[5,[0,1]],[0,[0,322]],[0,[0,366]]]]]],[0,null,!1,null,0x9324ca7c5676e,[[34,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,0xa22bfb0ca404a,!1,[[8,0],[0,[0,0]]]]],[[34,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",
0x548a08741c444,!1,[[0,[0,90]]]]]],[0,null,!1,null,5871948127155025,[[34,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,0xfaa53a906ab57,!1,[[8,0],[0,[0,10]]]]],[[34,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x7b07dc0679f3d,!1,[[0,[0,270]]]]]],[0,null,!1,null,0xfd8fe1616a6fc,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9909735080440812,!1,[[11,"Disparos"],[8,0],[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0x86e4bfd764105,
!1,[[0,[0,5]]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,9292352616800236,!1,[[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,963450118145093,!1,[[4,120],[5,[0,1]],[0,[0,257]],[0,[0,109]]]],[-1,cr.system_object.prototype.acts.SetVar,null,7014111789017083,!1,[[11,"Banner"],[7,[0,1]]]],[14,cr.plugins_.CJSAds.prototype.acts.ShowBanner,null,6318496140404093,!1,[[3,1]]],[122,cr.plugins_.Text.prototype.acts.Destroy,null,4958103618102834,!1],[-1,cr.system_object.prototype.acts.CreateObject,
null,4603351629979711,!1,[[4,122],[5,[0,1]],[0,[0,271]],[0,[0,153]]]],[122,cr.plugins_.Text.prototype.acts.SetOpacity,null,0xedbacd89d963f,!1,[[0,[0,100]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0xa7f6c4421bd5c,!1,[[4,7],[5,[0,1]],[0,[0,625]],[0,[0,345]]]]]],[0,null,!1,null,0xf7a6c1e195fa1,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,5888712496735721,!1,[[4,122]]]],[[147,cr.plugins_.Sprite.prototype.acts.Destroy,null,6110483156246185,!1],[-1,cr.system_object.prototype.acts.GoToLayout,
null,5943188742204501,!1,[[6,"Menu"]]],[10,cr.plugins_.Audio.prototype.acts.Stop,null,9328525431778124,!1,[[1,[2,"Alemania"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xd3eb7cbf6a763,!1,[[11,"Banner"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xc00b92a4eb1f8,!1,[[11,"3Balones"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x64b7705d7f0bf,!1,[[11,"RashoLaser"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,6411482188808707,!1,[[11,"Tiempo"],[7,
[0,0]]]]]],[0,null,!1,null,0x4c191e5e1a5fb,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5560063518271031,!1,[[11,"Jugadores"],[8,0],[7,[0,5]]]],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,9022585584528116,!1,[[0,[0,5]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0xaeb6b941394f6,!1,[[4,5],[5,[0,1]],[0,[0,305]],[0,[0,95]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xb990617bf89bb,!1,[[11,"Portugal"],[7,[0,2]]]],[13,cr.plugins_.WebStorage.prototype.acts.StoreLocal,
null,7030978173457205,!1,[[1,[2,"Portugal"]],[7,[23,"Portugal"]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,5255889535346967,!1,[[0,[1,1E-5]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5479689540545272,!1,[[11,"Banner"],[7,[0,1]]]],[14,cr.plugins_.CJSAds.prototype.acts.ShowBanner,null,6955291732655706,!1,[[3,1]]],[122,cr.plugins_.Text.prototype.acts.Destroy,null,0x7aafcf99b3b22,!1],[-1,cr.system_object.prototype.acts.CreateObject,null,8198164549368219,!1,[[4,122],[5,[0,1]],[0,
[0,271]],[0,[0,153]]]],[122,cr.plugins_.Text.prototype.acts.SetOpacity,null,9824741362515156,!1,[[0,[0,100]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,5866448097403248,!1,[[4,7],[5,[0,1]],[0,[0,625]],[0,[0,345]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,6524021720050329,!1,[[4,142],[5,[0,1]],[0,[0,308]],[0,[0,247]]]]]],[0,null,!1,null,7578084840780071,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,0xa3b6f85aafb8e,!1]],[[119,cr.plugins_.Text.prototype.acts.SetText,
null,0x993c40b90d27c,!1,[[7,[10,[2,": "],[23,"Disparos"]]]]]]],[0,null,!1,null,0xffd7627f49c22,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xa05a1aaa0d064,!1,[[11,"HighScore"],[8,0],[7,[0,6]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xce10cd4b5dcb0,!1,[[11,"Jugadores"],[8,0],[7,[0,5]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,4513968595841908,!1,[[11,"HighScore"],[7,[0,1]]]],[13,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,8218525733164273,
!1,[[1,[2,"Selecciones"]],[7,[23,"HighScore"]]]]]],[0,null,!1,null,5745388204914884,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9218979951143374,!1,[[11,"Banner"],[8,0],[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0xfab1956e5c8d2,!1,[[0,[1,0.2]]]]],[[14,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,7802263056030011,!1]]],[0,null,!1,null,801674864737671,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9035752369055780,!1,[[11,"Alineacion"],
[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,621411118583406,!1,[[0,[1,1E-5]]]]]],[0,null,!1,null,7691744328649079,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,8956381773381198,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9082007983137844,!1,[[11,"Alineacion"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.Wait,null,9749393534448332,!1,[[0,[1,1E-5]]]],[148,cr.plugins_.Text.prototype.acts.Destroy,null,0xfb7c714be2558,!1],
[-1,cr.system_object.prototype.acts.SetVar,null,6029689822724865,!1,[[11,"Alineacion"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0xfcb3778c58b8c,!1,[[0,[0,1]]]]]],[0,null,!1,null,0xd5b2c922aa8fd,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7985969363482096,!1,[[4,7]]]],[[11,cr.plugins_.Browser.prototype.acts.GoToURLWindow,null,0x891529714336d,!1,[[1,[10,[10,[10,[2,"https://www.facebook.com/sharer/sharer.php?u=http://zlatanworldcup2014.tk/default.php?score="],
[23,"HighScore"]],[2,":"]],[19,cr.system_object.prototype.exps.random,[[0,1],[0,10]]]]],[1,[2,"NewWindow"]]]]]],[0,null,!1,null,0x75b35e1b5d67a,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xfc2f07941aa1d,!1,[[4,142]]]],[[11,cr.plugins_.Browser.prototype.acts.GoToURLWindow,null,9318993587015284,!1,[[1,[2,"https://play.google.com/store/apps/details?id=com.zlatan.app"]],[1,[2,"Rate"]]]]]],[0,null,!1,null,5777415806417646,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,
!1,!1,!1,4836458884322163,!1,[[11,"Ingles"],[8,0],[7,[0,1]]]]],[[120,cr.plugins_.Text.prototype.acts.SetText,null,5554480390982751,!1,[[7,[2,"Failed"]]]],[122,cr.plugins_.Text.prototype.acts.SetText,null,7629836558634951,!1,[[7,[2,"Main"]]]],[125,cr.plugins_.Text.prototype.acts.SetText,null,0x70ab09ca9e20d,!1,[[7,[2,"Tap to start"]]]]]],[0,null,!1,null,6876023994441646,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,375489608514272,!1,[[11,"Frances"],[8,0],[7,[0,1]]]]],[[120,cr.plugins_.Text.prototype.acts.SetText,
null,0x56edbb2edbeed,!1,[[7,[2,"Manqu\u00e9"]]]],[122,cr.plugins_.Text.prototype.acts.SetText,null,6839202265472596,!1,[[7,[2,"Principal"]]]],[125,cr.plugins_.Text.prototype.acts.SetText,null,0x75f8f78d6cd9b,!1,[[7,[2,"Appuyez sur pour commencer"]]]]]],[0,null,!1,null,9841962443202712,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x4de92ee40ef50,!1,[[11,"Sueco"],[8,0],[7,[0,1]]]]],[[120,cr.plugins_.Text.prototype.acts.SetText,null,5062318794932988,!1,[[7,[2,"Misslyckades"]]]],[122,
cr.plugins_.Text.prototype.acts.SetText,null,0x914a4f82c1fe5,!1,[[7,[2,"Meny"]]]],[125,cr.plugins_.Text.prototype.acts.SetText,null,9506115026616336,!1,[[7,[2,"Peka p\u00e5 f\u00f6r att starta"]]]]]],[0,null,!1,null,0xc66c996d2d664,[[136,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,0xc706cfb516fb2,!1,[[8,3],[0,[0,49]]]]],[[137,cr.plugins_.Sprite.prototype.acts.SetScale,null,7338676590708728,!1,[[0,[0,1]]]]]],[0,null,!1,null,429646520487443,[[136,cr.plugins_.Sprite.prototype.cnds.CompareY,
null,0,!1,!1,!1,0x4dc58d6ad30c2,!1,[[8,3],[0,[0,45]]]]],[[137,cr.plugins_.Sprite.prototype.acts.SetScale,null,7951633899394109,!1,[[0,[1,1.05]]]]]],[0,null,!1,null,5194443432313634,[[136,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,9218610925185140,!1,[[8,3],[0,[0,40]]]]],[[137,cr.plugins_.Sprite.prototype.acts.SetScale,null,7192393056572359,!1,[[0,[1,1.1]]]]]],[0,null,!1,null,0x82c613544597b,[[136,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,5799124077307934,!1,[[8,3],
[0,[0,35]]]]],[[137,cr.plugins_.Sprite.prototype.acts.SetScale,null,8999933138018979,!1,[[0,[1,1.15]]]]]],[0,null,!1,null,8425646679794351,[[136,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,5953168825976161,!1,[[8,3],[0,[0,31]]]]],[[137,cr.plugins_.Sprite.prototype.acts.SetScale,null,0xb8e7e5c3464f8,!1,[[0,[1,1.2]]]]]],[0,null,!1,null,0xb8d6783230ded,[[133,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7413806132434341,!1,[[4,136]]]],[[-1,cr.system_object.prototype.acts.SetVar,
null,6642438667779025,!1,[[11,"Apuntar"],[7,[0,1]]]],[55,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0x6fb8a6da2f7ad,!1,[[1,[2,"Animation2"]],[3,1]]],[55,cr.plugins_.Sprite.prototype.acts.SetPos,null,0xa365f84a7ee9f,!1,[[0,[0,69]],[0,[0,185]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5198412863863696,!1,[[11,"3Balones"],[7,[0,1]]]],[136,cr.plugins_.Sprite.prototype.acts.Destroy,null,7873541654457201,!1],[137,cr.plugins_.Sprite.prototype.acts.Destroy,null,904385954576186,!1],[133,cr.plugins_.Sprite.prototype.acts.SetAnim,
null,6329637371299762,!1,[[1,[2,"Default"]],[3,1]]]]],[0,null,!1,null,7482116994436739,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x3adadd02baf31,!1,[[11,"3Balones"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xb49923deee4d9,!1,[[11,"Apuntar"],[8,0],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xed58c62a2979e,!1,[[11,"3Balones"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,6553432802414127,!1,[[0,[1,1.1]]]],[133,
cr.plugins_.Sprite.prototype.acts.SetAnim,null,7021089636674417,!1,[[1,[2,"3Balones"]],[3,1]]]]]]],["Event Italia",[[1,"Tiempo",0,0,!1,!1,0x4c56a60791e83,!1],[0,null,!1,null,0x5823c815dc2a6,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,6644632711409149,!1]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,0x8184f589cc942,!1,[[0,[0,0]]]],[133,cr.behaviors.Physics.prototype.acts.SetIterations,"Physics",6237130336733806,!1,[[0,[0,12]],[0,[0,8]]]],[10,cr.plugins_.Audio.prototype.acts.Play,
null,0xf16f426e24ebf,!1,[[2,["italia",!0]],[3,1],[0,[0,0]],[1,[2,"Italia"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xb37dde772ced8,!1,[[11,"Disparos"],[7,[0,6]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5182613230983166,!1,[[11,"Jugadores"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,6904197617379309,!1,[[11,"Banner"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xca6f50d46c312,!1,[[11,"Alineacion"],[7,[0,1]]]]]],[0,null,!1,null,5267928714373915,[[-1,
cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6793096932021494,!1,[[11,"Apuntar"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x3c495499cde75,!1,[[11,"Jugadores"],[8,2],[7,[0,5]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,359158395679793,!1,[[11,"Alineacion"],[8,0],[7,[0,0]]]]],[[133,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,7501848328980323,!1,[[4,1],[7,[0,0]]]]],[[0,null,!1,null,8988193041066144,[[12,cr.plugins_.Touch.prototype.cnds.IsInTouch,
null,0,!1,!1,!1,6379956048852584,!1]],[[133,cr.plugins_.Sprite.prototype.acts.SetAngle,null,0xc162367b06d15,!1,[[0,[19,cr.system_object.prototype.exps.angle,[[20,12,cr.plugins_.Touch.prototype.exps.X,!1,null],[20,12,cr.plugins_.Touch.prototype.exps.Y,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]]]],[133,cr.plugins_.Sprite.prototype.acts.MoveAtAngle,null,9882575430731246,!1,[[0,[4,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,
null],[0,180]]],[0,[19,cr.system_object.prototype.exps.min,[[7,[19,cr.system_object.prototype.exps.distance,[[20,12,cr.plugins_.Touch.prototype.exps.X,!1,null],[20,12,cr.plugins_.Touch.prototype.exps.Y,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]],[0,3]],[0,45]]]]]],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0x79aa365e611f3,!1,[[4,1]]],[1,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0xbb752d736d6f9,!1,[[3,1]]],[1,
cr.plugins_.Sprite.prototype.acts.SetTowardPosition,null,6924020925142069,!1,[[0,[20,133,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[20,133,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]]]],[0,null,!1,null,9343490565293336,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,0xaf1f3418351eb,!1]],[[1,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x5634d6202b46a,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x73573664b6e79,!1,[[11,"Apuntar"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,
null,4746034771020315,!1,[[11,"Tiro"],[7,[7,[19,cr.system_object.prototype.exps.distance,[[20,133,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,133,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]],[0,15]]]]],[133,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,6852455327320838,!1,[[4,1],[7,[0,0]]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",0xe10b3d527d4bc,!1,[[3,1]]],
[55,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",8566192200494181,!1,[[3,1]]],[55,cr.plugins_.Sprite.prototype.acts.SetAnim,null,9474840481077312,!1,[[1,[2,"Default"]],[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,0xeabcc67507d38,!1,[[0,[0,1]]]],[133,cr.plugins_.Sprite.prototype.acts.SetAnim,null,5044302903252972,!1,[[1,[2,"Tiro"]],[3,1]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",8465306219136606,!1,[[3,0]]],[133,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,
"Physics",0xe8f22279c7ff1,!1,[[0,[23,"Tiro"]],[0,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null]],[7,[0,0]]]]]]]],[0,null,!1,null,6234983818277513,[[55,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xe8583a94d6c0d,!1,[[4,71]]]],[[55,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",6839865119311911,!1,[[3,0]]]]],[0,null,!1,null,0x66defb4e3eb09,[[133,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,0x7102dc0404927,!1],[55,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
null,0,!1,!1,!1,5341655541620791,!1]],[[-1,cr.system_object.prototype.acts.CreateObject,null,4813068741724871,!1,[[4,133],[5,[0,1]],[0,[0,0]],[0,[0,0]]]],[55,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xf31ed7dd74fef,!1,[[1,[2,"Animation2"]],[3,1]]],[55,cr.plugins_.Sprite.prototype.acts.SetPos,null,8786537323041587,!1,[[0,[0,69]],[0,[0,185]]]],[-1,cr.system_object.prototype.acts.SubVar,null,9113567222348564,!1,[[11,"Disparos"],[7,[0,1]]]]]],[0,null,!1,null,7476226107800916,[[133,cr.plugins_.Sprite.prototype.cnds.OnCreated,
null,1,!1,!1,!1,5515771050957973,!1]],[[-1,cr.system_object.prototype.acts.SetVar,null,8891410802188034,!1,[[11,"Apuntar"],[7,[0,1]]]]]],[0,null,!1,null,0x878d2ba6ea021,[[133,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,4597972163098608,!1,[[4,0]]]],[[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",7877620860450989,!1,[[3,1]]],[133,cr.behaviors.Rotate.prototype.acts.SetSpeed,"Rotate",6283461170435128,!1,[[0,[0,720]]]],[-1,cr.system_object.prototype.acts.Wait,null,9455626525065096,
!1,[[0,[1,1]]]],[133,cr.plugins_.Sprite.prototype.acts.Destroy,null,9686944723319376,!1]]],[0,null,!1,null,8208508734679561,[[133,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6062051536770422,!1,[[4,147]]]],[[133,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",4639355716650347,!1,[[0,[4,[23,"Tiro"],[1,0.5]]],[0,[5,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null],[0,180]]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.AddVar,null,0x3e9fff4ee4be0,!1,[[11,
"Jugadores"],[7,[0,1]]]],[147,cr.plugins_.Sprite.prototype.acts.StopAnim,null,7722651311359711,!1],[147,cr.plugins_.Sprite.prototype.acts.SetAngle,null,9425636541403074,!1,[[0,[0,90]]]],[147,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,8661735479652784,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,472868301856743,!1,[[0,[1,0.2]]]],[147,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xa6d04f61f1302,!1]]],[0,null,!1,null,8420176213870787,[[35,cr.plugins_.Sprite.prototype.cnds.CompareFrame,
null,0,!1,!1,!1,6841326272361387,!1,[[8,0],[0,[0,0]]]]],[[35,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",9709392352517688,!1,[[0,[0,0]]]]]],[0,null,!1,null,7705975859583597,[[35,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,292069827248852,!1,[[8,0],[0,[0,6]]]]],[[35,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",9355363758302552,!1,[[0,[0,270]]]]]],[0,null,!1,null,0x9b09cae96266d,[[35,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,0x55df310611b4d,
!1,[[8,0],[0,[0,12]]]]],[[35,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",7714038887777498,!1,[[0,[0,180]]]]]],[0,null,!1,null,0x4356f52ce9dd9,[[35,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,0x46473ff25243f,!1,[[8,0],[0,[0,18]]]]],[[35,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",6187849219745451,!1,[[0,[0,90]]]]]],[0,null,!1,null,0x7adbbf32346f,[[36,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,6600161501491437,!1,[[8,0],[0,[0,
0]]]]],[[36,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",4740171373168702,!1,[[0,[0,0]]]]]],[0,null,!1,null,5206829126035184,[[36,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,9759960022959964,!1,[[8,0],[0,[0,8]]]]],[[36,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",9487764261323340,!1,[[0,[0,180]]]]]],[0,null,!1,null,318870298506374,[[37,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,0xed9af794acef1,!1,[[8,0],[0,[0,0]]]]],[[37,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
"Bullet",574119603837794,!1,[[0,[0,0]]]]]],[0,null,!1,null,0x930a61e31be6a,[[37,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,0xd1634c13bfa4a,!1,[[8,0],[0,[0,8]]]]],[[37,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",9504094961019162,!1,[[0,[0,180]]]]]],[0,null,!1,null,634393861172875,[[38,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,4650926120302792,!1,[[8,0],[0,[0,0]]]]],[[38,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",5171693572000368,
!1,[[0,[0,90]]]]]],[0,null,!1,null,0x84b070ed4368f,[[38,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,8477654300432158,!1,[[8,0],[0,[0,6]]]]],[[38,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",93093778312019,!1,[[0,[0,270]]]]]],[0,null,!1,null,8593286806939142,[[132,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9073132329936786,!1,[[4,0]]]],[[132,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",0x3f29780c7fc86,!1,[[3,1]]],[132,cr.behaviors.Rotate.prototype.acts.SetSpeed,
"Rotate",0x904663247c168,!1,[[0,[0,720]]]],[-1,cr.system_object.prototype.acts.Wait,null,7518636876121957,!1,[[0,[1,1]]]],[132,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x695945c121511,!1]]],[0,null,!1,null,0xb87e541617441,[[132,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,4711830506988053,!1],[39,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0xc9c162bb3460c,!1]],[[-1,cr.system_object.prototype.acts.CreateObject,null,8160929027411318,!1,[[4,132],[5,[0,1]],[0,[0,
246]],[0,[0,80]]]]]],[0,null,!1,null,0xf2b9cca5cea7b,[[132,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,9358864459226688,!1]],[[39,cr.plugins_.Sprite.prototype.acts.StartAnim,null,9694405896183206,!1,[[3,1]]]]],[0,null,!1,null,4662895938121477,[[39,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,6660714320817991,!1]],[[-1,cr.system_object.prototype.acts.Wait,null,6938884505667746,!1,[[0,[1,0.5]]]],[132,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xf5c42af58e21,!1]]],
[0,null,!1,null,4760353990306276,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x775038b403449,!1,[[11,"Disparos"],[8,0],[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,7800181992458317,!1,[[0,[0,5]]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,4597325765190347,!1,[[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,7492917617630333,!1,[[4,120],[5,[0,1]],[0,[0,257]],[0,[0,109]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9360214814124708,
!1,[[11,"Banner"],[7,[0,1]]]],[14,cr.plugins_.CJSAds.prototype.acts.ShowBanner,null,7019934501237406,!1,[[3,1]]],[122,cr.plugins_.Text.prototype.acts.Destroy,null,8938354064260319,!1],[-1,cr.system_object.prototype.acts.CreateObject,null,0x98261d35b67d,!1,[[4,122],[5,[0,1]],[0,[0,271]],[0,[0,153]]]],[122,cr.plugins_.Text.prototype.acts.SetOpacity,null,9009130612606608,!1,[[0,[0,100]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0x72fb79eb4454a,!1,[[4,7],[5,[0,1]],[0,[0,625]],[0,[0,345]]]]]],
[0,null,!1,null,5357362862250088,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,4936947681983827,!1,[[4,122]]]],[[147,cr.plugins_.Sprite.prototype.acts.Destroy,null,8026984591690981,!1],[-1,cr.system_object.prototype.acts.GoToLayout,null,8111500908464483,!1,[[6,"Menu"]]],[10,cr.plugins_.Audio.prototype.acts.Stop,null,4990732330907533,!1,[[1,[2,"Italia"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x58608adb86869,!1,[[11,"Banner"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.SetVar,
null,952722222766936,!1,[[11,"3Balones"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x71d639cbed3f2,!1,[[11,"RashoLaser"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xd01fb5d641e8c,!1,[[11,"Tiempo"],[7,[0,0]]]]]],[0,null,!1,null,6157305081665073,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x9b32646354281,!1,[[11,"Jugadores"],[8,0],[7,[0,5]]]],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,9696181778807448,!1,[[0,[0,5]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,
null,308718469447782,!1,[[4,5],[5,[0,1]],[0,[0,305]],[0,[0,95]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8134757424690882,!1,[[11,"Argentina"],[7,[0,2]]]],[13,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,4686079971230519,!1,[[1,[2,"Argentina"]],[7,[23,"Argentina"]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0x3d274c1e4d592,!1,[[0,[1,1E-5]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5475654618702352,!1,[[11,"Banner"],[7,[0,1]]]],[14,cr.plugins_.CJSAds.prototype.acts.ShowBanner,
null,0xa0323cd14b7f2,!1,[[3,1]]],[122,cr.plugins_.Text.prototype.acts.Destroy,null,7829369641210538,!1],[-1,cr.system_object.prototype.acts.CreateObject,null,623610821633987,!1,[[4,122],[5,[0,1]],[0,[0,271]],[0,[0,153]]]],[122,cr.plugins_.Text.prototype.acts.SetOpacity,null,6376705601331958,!1,[[0,[0,100]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0x518eb240e4309,!1,[[4,7],[5,[0,1]],[0,[0,625]],[0,[0,345]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,6256755116353434,!1,[[4,
142],[5,[0,1]],[0,[0,308]],[0,[0,247]]]]]],[0,null,!1,null,4609085864919893,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,0xc34cff5daf835,!1]],[[119,cr.plugins_.Text.prototype.acts.SetText,null,5878163766964905,!1,[[7,[10,[2,": "],[23,"Disparos"]]]]]]],[0,null,!1,null,7716360889703836,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8270095575313955,!1,[[11,"HighScore"],[8,0],[7,[0,4]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x4bfc02f228599,
!1,[[11,"Jugadores"],[8,0],[7,[0,5]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,0xf3958f44f389d,!1,[[11,"HighScore"],[7,[0,1]]]],[13,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,0xa045085391b9c,!1,[[1,[2,"Selecciones"]],[7,[23,"HighScore"]]]]]],[0,null,!1,null,0x8c1497daba01a,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9391535302774668,!1,[[11,"Banner"],[8,0],[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,7110839250800599,!1,[[0,[1,0.2]]]]],
[[14,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,5861156960393553,!1]]],[0,null,!1,null,8571240825255006,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8928984755552039,!1,[[11,"Alineacion"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,0x69afc9e49f703,!1,[[0,[1,1E-5]]]]]],[0,null,!1,null,0xb4848e89f4b49,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,6484987699892834,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,
!1,9377165503576628,!1,[[11,"Alineacion"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.Wait,null,0x6b4b8b9cafd74,!1,[[0,[1,1E-5]]]],[148,cr.plugins_.Text.prototype.acts.Destroy,null,0x413e3fbc337c1,!1],[-1,cr.system_object.prototype.acts.SetVar,null,8853411495717887,!1,[[11,"Alineacion"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,6845496445259773,!1,[[0,[0,1]]]]]],[0,null,!1,null,7974645348207123,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,
7710409481875932,!1,[[4,7]]]],[[11,cr.plugins_.Browser.prototype.acts.GoToURLWindow,null,5120123566539093,!1,[[1,[10,[10,[10,[2,"https://www.facebook.com/sharer/sharer.php?u=http://zlatanworldcup2014.tk/default.php?score="],[23,"HighScore"]],[2,":"]],[19,cr.system_object.prototype.exps.random,[[0,1],[0,10]]]]],[1,[2,"NewWindow"]]]]]],[0,null,!1,null,23033460634113,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x502b7cc28a618,!1,[[4,142]]]],[[11,cr.plugins_.Browser.prototype.acts.GoToURLWindow,
null,7359655014535065,!1,[[1,[2,"https://play.google.com/store/apps/details?id=com.zlatan.app"]],[1,[2,"Rate"]]]]]],[0,null,!1,null,7007094375064099,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9883991474905484,!1,[[11,"Ingles"],[8,0],[7,[0,1]]]]],[[120,cr.plugins_.Text.prototype.acts.SetText,null,0xd8eabafbcf865,!1,[[7,[2,"Failed"]]]],[122,cr.plugins_.Text.prototype.acts.SetText,null,9140430583817680,!1,[[7,[2,"Main"]]]],[125,cr.plugins_.Text.prototype.acts.SetText,null,8354855177420832,
!1,[[7,[2,"Tap to start"]]]]]],[0,null,!1,null,7846202386657643,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,443781415852337,!1,[[11,"Frances"],[8,0],[7,[0,1]]]]],[[120,cr.plugins_.Text.prototype.acts.SetText,null,5474092982093954,!1,[[7,[2,"Manqu\u00e9"]]]],[122,cr.plugins_.Text.prototype.acts.SetText,null,6510904064163246,!1,[[7,[2,"Principal"]]]],[125,cr.plugins_.Text.prototype.acts.SetText,null,6791857682307558,!1,[[7,[2,"Appuyez sur pour commencer"]]]]]],[0,null,!1,null,991586380172072,
[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,341995741041797,!1,[[11,"Sueco"],[8,0],[7,[0,1]]]]],[[120,cr.plugins_.Text.prototype.acts.SetText,null,6652111604618329,!1,[[7,[2,"Misslyckades"]]]],[122,cr.plugins_.Text.prototype.acts.SetText,null,0x66de836d653b7,!1,[[7,[2,"Meny"]]]],[125,cr.plugins_.Text.prototype.acts.SetText,null,0xd19afe44ed36f,!1,[[7,[2,"Peka p\u00e5 f\u00f6r att starta"]]]]]],[0,null,!1,null,0xa925b3d9c9d14,[[138,cr.plugins_.Sprite.prototype.cnds.CompareY,null,
0,!1,!1,!1,0x92aadb01516bf,!1,[[8,3],[0,[0,299]]]]],[[139,cr.plugins_.Sprite.prototype.acts.SetScale,null,8493351862550217,!1,[[0,[0,1]]]]]],[0,null,!1,null,968033645766035,[[138,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,0xf34ae7a6de642,!1,[[8,3],[0,[0,295]]]]],[[139,cr.plugins_.Sprite.prototype.acts.SetScale,null,8754920955327001,!1,[[0,[1,1.05]]]]]],[0,null,!1,null,781997711839132,[[138,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,860949884476779,!1,[[8,3],[0,[0,290]]]]],
[[139,cr.plugins_.Sprite.prototype.acts.SetScale,null,6295957624762701,!1,[[0,[1,1.1]]]]]],[0,null,!1,null,939972978782382,[[138,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,5500367069535384,!1,[[8,3],[0,[0,285]]]]],[[139,cr.plugins_.Sprite.prototype.acts.SetScale,null,7237682165615504,!1,[[0,[1,1.15]]]]]],[0,null,!1,null,7714599309076331,[[138,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,956229160698883,!1,[[8,3],[0,[0,281]]]]],[[139,cr.plugins_.Sprite.prototype.acts.SetScale,
null,0x4da2ab33289da,!1,[[0,[1,1.2]]]]]],[0,null,!1,null,7621015720148729,[[39,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,6169584804200841,!1,[[8,0],[0,[0,3]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x55ba6679c9591,!1,[[11,"Tiempo"],[8,0],[7,[0,0]]]]],[[132,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",0xbd690553b7e20,!1,[[3,0]]],[132,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",6990193452209264,!1,[[0,[1,0.115]],[0,[4,
[20,132,cr.plugins_.Sprite.prototype.exps.Angle,!1,null],[0,350]]],[7,[0,0]]]]]],[0,null,!1,null,5569088184018375,[[133,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x809e9dc9547ea,!1,[[4,138]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,47629888915631,!1,[[11,"Apuntar"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x5f70f3d39a126,!1,[[11,"Tiempo"],[7,[0,1]]]],[55,cr.plugins_.Sprite.prototype.acts.SetAnim,null,9615615230813592,!1,[[1,[2,"Animation2"]],[3,1]]],
[55,cr.plugins_.Sprite.prototype.acts.SetPos,null,0x55e80086ef2f5,!1,[[0,[0,69]],[0,[0,185]]]],[138,cr.plugins_.Sprite.prototype.acts.Destroy,null,4620279841087653,!1],[139,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xa8342e75406e9,!1],[133,cr.plugins_.Sprite.prototype.acts.SetAnim,null,5742142663493137,!1,[[1,[2,"Default"]],[3,1]]],[132,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",5359860810658893,!1,[[3,1]]],[-1,cr.system_object.prototype.acts.SetObjectTimescale,null,9894132968196584,
!1,[[4,147],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,375890671655036,!1,[[0,[0,10]]]],[-1,cr.system_object.prototype.acts.RestoreObjectTimescale,null,6029719082751442,!1,[[4,147]]],[132,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",9882467647467968,!1,[[3,0]]],[132,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",5393425295179613,!1,[[0,[1,0.7]],[0,[20,132,cr.plugins_.Sprite.prototype.exps.Angle,!1,null]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,
null,4755925316664435,!1,[[11,"Tiempo"],[7,[0,0]]]]]]]],["Event Inglaterra",[[0,null,!1,null,310823648153373,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,9157545666046824,!1]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,0x71db7cd09f6b4,!1,[[0,[0,0]]]],[133,cr.behaviors.Physics.prototype.acts.SetIterations,"Physics",8026831998828563,!1,[[0,[0,12]],[0,[0,8]]]],[10,cr.plugins_.Audio.prototype.acts.Play,null,5034899610252625,!1,[[2,["inglaterra",!0]],[3,1],[0,[0,0]],[1,
[2,"Inglaterra"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,700680418491255,!1,[[11,"Disparos"],[7,[0,8]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x8fbe6908a9ea,!1,[[11,"Jugadores"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x5bfc64990d9a4,!1,[[11,"Banner"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8892166694534968,!1,[[11,"Alineacion"],[7,[0,1]]]]]],[0,null,!1,null,8165783067505365,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,
!1,0x465efef685489,!1,[[11,"Apuntar"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x621c74162a574,!1,[[11,"Jugadores"],[8,2],[7,[0,5]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6056092105210934,!1,[[11,"Alineacion"],[8,0],[7,[0,0]]]]],[[133,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0xfa2c85451d2bf,!1,[[4,1],[7,[0,0]]]]],[[0,null,!1,null,6528291560864133,[[12,cr.plugins_.Touch.prototype.cnds.IsInTouch,null,0,!1,!1,!1,5767539707924885,
!1]],[[133,cr.plugins_.Sprite.prototype.acts.SetAngle,null,9023837165916628,!1,[[0,[19,cr.system_object.prototype.exps.angle,[[20,12,cr.plugins_.Touch.prototype.exps.X,!1,null],[20,12,cr.plugins_.Touch.prototype.exps.Y,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]]]],[133,cr.plugins_.Sprite.prototype.acts.MoveAtAngle,null,6533530523618522,!1,[[0,[4,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null],[0,180]]],[0,[19,cr.system_object.prototype.exps.min,
[[7,[19,cr.system_object.prototype.exps.distance,[[20,12,cr.plugins_.Touch.prototype.exps.X,!1,null],[20,12,cr.plugins_.Touch.prototype.exps.Y,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]],[0,3]],[0,45]]]]]],[-1,cr.system_object.prototype.acts.ScrollToObject,null,9969754611062956,!1,[[4,1]]],[1,cr.plugins_.Sprite.prototype.acts.SetVisible,null,405453737504329,!1,[[3,1]]],[1,cr.plugins_.Sprite.prototype.acts.SetTowardPosition,null,
0xd329a6b63cc9a,!1,[[0,[20,133,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[20,133,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]]]],[0,null,!1,null,0xb1d8be4502c70,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,5180540431136955,!1]],[[1,cr.plugins_.Sprite.prototype.acts.SetVisible,null,6186020524932794,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.SetVar,null,9250140816791012,!1,[[11,"Apuntar"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8513078725405633,
!1,[[11,"Tiro"],[7,[7,[19,cr.system_object.prototype.exps.distance,[[20,133,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,133,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]],[0,15]]]]],[133,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,6602950891183424,!1,[[4,1],[7,[0,0]]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",9800360345202604,!1,[[3,1]]],[55,cr.behaviors.Bullet.prototype.acts.SetEnabled,
"Bullet",0xb063c356e017e,!1,[[3,1]]],[55,cr.plugins_.Sprite.prototype.acts.SetAnim,null,5989541780124499,!1,[[1,[2,"Default"]],[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,5864640907076687,!1,[[0,[0,1]]]],[133,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0x48ec8dbbd1b33,!1,[[1,[2,"Tiro"]],[3,1]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",8872293105652707,!1,[[3,0]]],[133,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",0xf9addee4cd8fc,!1,[[0,[23,"Tiro"]],
[0,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null]],[7,[0,0]]]]]]]],[0,null,!1,null,796495408951522,[[55,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5701013793714568,!1,[[4,71]]]],[[55,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",7875798641790059,!1,[[3,0]]]]],[0,null,!1,null,9228994671018082,[[133,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,5034452474520128,!1],[55,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0x66c11eccac7ed,
!1]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0xcf79d979e05f6,!1,[[4,133],[5,[0,1]],[0,[0,0]],[0,[0,0]]]],[55,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6363590332498089,!1,[[1,[2,"Animation2"]],[3,1]]],[55,cr.plugins_.Sprite.prototype.acts.SetPos,null,7918286829919274,!1,[[0,[0,69]],[0,[0,185]]]],[-1,cr.system_object.prototype.acts.SubVar,null,7257849892175794,!1,[[11,"Disparos"],[7,[0,1]]]]]],[0,null,!1,null,0x439d97ab75a93,[[133,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,
1,!1,!1,!1,0x96d7daeb27b4e,!1]],[[-1,cr.system_object.prototype.acts.SetVar,null,8933175297849793,!1,[[11,"Apuntar"],[7,[0,1]]]]]],[0,null,!1,null,0xf88c6fa3eb10e,[[133,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,4675024196665377,!1,[[4,0]]]],[[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",8888822096398472,!1,[[3,1]]],[133,cr.behaviors.Rotate.prototype.acts.SetSpeed,"Rotate",9314400607143342,!1,[[0,[0,720]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x45e02d6e9dc95,
!1,[[0,[1,1]]]],[133,cr.plugins_.Sprite.prototype.acts.Destroy,null,8567622743242149,!1]]],[0,null,!1,null,9821016825499824,[[133,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x94a9806b2e50a,!1,[[4,147]]]],[[133,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",0x62cbcc39daecd,!1,[[0,[4,[23,"Tiro"],[1,0.5]]],[0,[5,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null],[0,180]]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.AddVar,null,0x38f309e5b28a8,!1,[[11,"Jugadores"],
[7,[0,1]]]],[147,cr.plugins_.Sprite.prototype.acts.StopAnim,null,5607736816404225,!1],[147,cr.plugins_.Sprite.prototype.acts.SetAngle,null,0x48f8e32218700,!1,[[0,[0,90]]]],[147,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,0xd911e8d2c2fb0,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,6376241086351784,!1,[[0,[1,0.2]]]],[147,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xad31a6799da00,!1]]],[0,null,!1,null,639686908951479,[[40,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,
0,!1,!1,!1,0x5576d3f6d97c3,!1,[[8,0],[0,[0,0]]]]],[[40,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x701fc5d88f473,!1,[[0,[0,315]]]]]],[0,null,!1,null,8359233340133466,[[40,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,9106164514982032,!1,[[8,0],[0,[0,8]]]]],[[40,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",91712195332733,!1,[[0,[0,135]]]]]],[0,null,!1,null,0xcd037ab4fb994,[[41,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,7247292754665761,
!1,[[8,0],[0,[0,0]]]]],[[41,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",8183238463537337,!1,[[0,[0,315]]]]]],[0,null,!1,null,8519788609083142,[[41,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,0xe3b8ec912e6ed,!1,[[8,0],[0,[0,9]]]]],[[41,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xaf6e32419f276,!1,[[0,[0,135]]]]]],[0,null,!1,null,7324748962540256,[[43,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,0xd0dd731afcd42,!1,[[8,0],[0,[0,
0]]]]],[[43,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x521816e345b9d,!1,[[0,[0,0]]]]]],[0,null,!1,null,9185334962985636,[[43,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,5595287751617304,!1,[[8,0],[0,[0,8]]]]],[[43,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",0xf5ac9f43508ec,!1,[[3,0]]]]],[0,null,!1,null,0x8d630e0cfdca2,[[43,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,7802320919517198,!1,[[8,0],[0,[0,11]]]]],[[43,cr.behaviors.Bullet.prototype.acts.SetEnabled,
"Bullet",7949322953909996,!1,[[3,1]]],[43,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",8354081475862001,!1,[[0,[0,180]]]]]],[0,null,!1,null,4902642020172387,[[132,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,7247266088346844,!1],[43,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,6578177079608242,!1]],[[-1,cr.system_object.prototype.acts.CreateObject,null,4588871405791745,!1,[[4,132],[5,[0,1]],[0,[0,406]],[0,[0,366]]]]]],[0,null,!1,null,0x49a619b2ff019,
[[132,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5419919068152843,!1,[[4,0]]]],[[132,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",422771889227517,!1,[[3,1]]],[132,cr.behaviors.Rotate.prototype.acts.SetSpeed,"Rotate",0x65e17ec6e84f9,!1,[[0,[0,720]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xb80d2e8d5f1fb,!1,[[0,[1,1]]]],[132,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x9a309bc02bc1d,!1]]],[0,null,!1,null,0xadb04c24fe256,[[43,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,
null,1,!1,!1,!1,7381909655443579,!1]],[[-1,cr.system_object.prototype.acts.Wait,null,9102261536870204,!1,[[0,[1,0.5]]]],[132,cr.plugins_.Sprite.prototype.acts.Destroy,null,538636587692689,!1]]],[0,null,!1,null,7565960554503189,[[44,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,6233253708791658,!1,[[8,0],[0,[0,3]]]]],[[44,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",7481391434498875,!1,[[3,1]]],[44,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xeda7a10272e87,
!1,[[0,[0,180]]]]]],[0,null,!1,null,9883147002614444,[[44,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,9839262359878506,!1,[[8,0],[0,[0,8]]]]],[[44,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",6646789200755149,!1,[[3,0]]]]],[0,null,!1,null,389740957683338,[[44,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,9251775411408340,!1,[[8,0],[0,[0,11]]]]],[[44,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",0x4d4be26bc85f1,!1,[[3,1]]],[44,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
"Bullet",8078452800481981,!1,[[0,[0,0]]]]]],[0,null,!1,null,337081423681237,[[44,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,7674541821167149,!1,[[8,0],[0,[0,0]]]]],[[44,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",9396106086198912,!1,[[3,0]]]]],[0,null,!1,null,808506929101389,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7701338699981316,!1,[[11,"Disparos"],[8,0],[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,677146959097935,!1,
[[0,[0,5]]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,0xaa550fc13c8d1,!1,[[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0x8a28d0727ac58,!1,[[4,120],[5,[0,1]],[0,[0,257]],[0,[0,109]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8320498045956037,!1,[[11,"Banner"],[7,[0,1]]]],[14,cr.plugins_.CJSAds.prototype.acts.ShowBanner,null,4564060941421195,!1,[[3,1]]],[122,cr.plugins_.Text.prototype.acts.Destroy,null,7381017934505873,!1],[-1,cr.system_object.prototype.acts.CreateObject,
null,0xbfcea0fb8617d,!1,[[4,122],[5,[0,1]],[0,[0,271]],[0,[0,153]]]],[122,cr.plugins_.Text.prototype.acts.SetOpacity,null,0x6d99efa54a408,!1,[[0,[0,100]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,6763272850663668,!1,[[4,7],[5,[0,1]],[0,[0,625]],[0,[0,345]]]]]],[0,null,!1,null,5681308022737526,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,9744199344694580,!1,[[4,122]]]],[[147,cr.plugins_.Sprite.prototype.acts.Destroy,null,7608940324553848,!1],[-1,cr.system_object.prototype.acts.GoToLayout,
null,5891308280583321,!1,[[6,"Menu"]]],[10,cr.plugins_.Audio.prototype.acts.Stop,null,0xf370b3fd26918,!1,[[1,[2,"Inglaterra"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xcc5ad736bf1a8,!1,[[11,"Banner"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,6844586142332746,!1,[[11,"3Balones"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x3e2689fbd6d56,!1,[[11,"RashoLaser"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xd6829c16f9065,!1,[[11,"Tiempo"],[7,
[0,0]]]]]],[0,null,!1,null,0x46ee9b3a570ef,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5474130998020838,!1,[[11,"Jugadores"],[8,0],[7,[0,5]]]],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,4906086465369664,!1,[[0,[0,5]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0xe253982d753dc,!1,[[4,5],[5,[0,1]],[0,[0,305]],[0,[0,95]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8034019749227298,!1,[[11,"Espa\u00f1a"],[7,[0,2]]]],[13,cr.plugins_.WebStorage.prototype.acts.StoreLocal,
null,0x65b2bb68d8b24,!1,[[1,[2,"Espa\u00f1a"]],[7,[23,"Espa\u00f1a"]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,7203225376172111,!1,[[0,[1,1E-5]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xe392a4bd70786,!1,[[11,"Banner"],[7,[0,1]]]],[14,cr.plugins_.CJSAds.prototype.acts.ShowBanner,null,0x6df2b1736f3b7,!1,[[3,1]]],[122,cr.plugins_.Text.prototype.acts.Destroy,null,7755873258813686,!1],[-1,cr.system_object.prototype.acts.CreateObject,null,0x61373752aea4e,!1,[[4,122],[5,[0,1]],
[0,[0,271]],[0,[0,153]]]],[122,cr.plugins_.Text.prototype.acts.SetOpacity,null,4883628949300594,!1,[[0,[0,100]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,9697725783084160,!1,[[4,7],[5,[0,1]],[0,[0,625]],[0,[0,345]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,5979210530459125,!1,[[4,142],[5,[0,1]],[0,[0,308]],[0,[0,247]]]]]],[0,null,!1,null,8880438538915754,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,6873550436385548,!1]],[[119,cr.plugins_.Text.prototype.acts.SetText,
null,0x909c3b6a31feb,!1,[[7,[10,[2,": "],[23,"Disparos"]]]]]]],[0,null,!1,null,7828150286758241,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9568613605836,!1,[[11,"HighScore"],[8,0],[7,[0,2]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8175306152287055,!1,[[11,"Jugadores"],[8,0],[7,[0,5]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,6498155227871003,!1,[[11,"HighScore"],[7,[0,1]]]],[13,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,6176279072933621,
!1,[[1,[2,"Selecciones"]],[7,[23,"HighScore"]]]]]],[0,null,!1,null,8722321044003283,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6000232227501997,!1,[[11,"Banner"],[8,0],[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0xcb14d29f36219,!1,[[0,[1,0.2]]]]],[[14,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,8338340168833656,!1]]],[0,null,!1,null,0xb57bad9d3981f,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x63fe3a4ec298e,!1,[[11,"Alineacion"],
[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,8136386053309301,!1,[[0,[1,1E-5]]]]]],[0,null,!1,null,0x74cc9a6355c34,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,6939087844591449,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8163307414986319,!1,[[11,"Alineacion"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.Wait,null,0x3940731db1ff4,!1,[[0,[1,1E-5]]]],[148,cr.plugins_.Text.prototype.acts.Destroy,null,0x441ef50eccc4f,!1],
[-1,cr.system_object.prototype.acts.SetVar,null,7724733031615217,!1,[[11,"Alineacion"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0xeb53683e2337b,!1,[[0,[0,1]]]]]],[0,null,!1,null,0x4d5aba76e10a8,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,5244923268093746,!1,[[4,7]]]],[[11,cr.plugins_.Browser.prototype.acts.GoToURLWindow,null,4937549271572653,!1,[[1,[10,[10,[10,[2,"https://www.facebook.com/sharer/sharer.php?u=http://zlatanworldcup2014.tk/default.php?score="],
[23,"HighScore"]],[2,":"]],[19,cr.system_object.prototype.exps.random,[[0,1],[0,10]]]]],[1,[2,"NewWindow"]]]]]],[0,null,!1,null,5499659184625604,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6951207448297808,!1,[[4,142]]]],[[11,cr.plugins_.Browser.prototype.acts.GoToURLWindow,null,6610397050806834,!1,[[1,[2,"https://play.google.com/store/apps/details?id=com.zlatan.app"]],[1,[2,"Rate"]]]]]],[0,null,!1,null,6652410999909519,[[-1,cr.system_object.prototype.cnds.CompareVar,null,
0,!1,!1,!1,5028653492283974,!1,[[11,"Ingles"],[8,0],[7,[0,1]]]]],[[120,cr.plugins_.Text.prototype.acts.SetText,null,5664235112726663,!1,[[7,[2,"Failed"]]]],[122,cr.plugins_.Text.prototype.acts.SetText,null,0x797d776944f5e,!1,[[7,[2,"Main"]]]],[125,cr.plugins_.Text.prototype.acts.SetText,null,0x77f2fa110adb4,!1,[[7,[2,"Tap to start"]]]]]],[0,null,!1,null,0xf24d404c70e91,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6199419004984683,!1,[[11,"Frances"],[8,0],[7,[0,1]]]]],[[120,cr.plugins_.Text.prototype.acts.SetText,
null,4949044193655352,!1,[[7,[2,"Manqu\u00e9"]]]],[122,cr.plugins_.Text.prototype.acts.SetText,null,9966324271350788,!1,[[7,[2,"Principal"]]]],[125,cr.plugins_.Text.prototype.acts.SetText,null,4942533429713657,!1,[[7,[2,"Appuyez sur pour commencer"]]]]]],[0,null,!1,null,822292465709079,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xb9845ac003f06,!1,[[11,"Sueco"],[8,0],[7,[0,1]]]]],[[120,cr.plugins_.Text.prototype.acts.SetText,null,9360499597314856,!1,[[7,[2,"Misslyckades"]]]],[122,
cr.plugins_.Text.prototype.acts.SetText,null,0x53916d321ac49,!1,[[7,[2,"Meny"]]]],[125,cr.plugins_.Text.prototype.acts.SetText,null,6998762041747254,!1,[[7,[2,"Peka p\u00e5 f\u00f6r att starta"]]]]]],[0,null,!1,null,5938405331075937,[[138,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,8285682191738898,!1,[[8,3],[0,[0,229]]]]],[[139,cr.plugins_.Sprite.prototype.acts.SetScale,null,17601341633774,!1,[[0,[0,1]]]]]],[0,null,!1,null,0xb118b0b7437f7,[[138,cr.plugins_.Sprite.prototype.cnds.CompareY,
null,0,!1,!1,!1,49261742959392,!1,[[8,3],[0,[0,225]]]]],[[139,cr.plugins_.Sprite.prototype.acts.SetScale,null,7525936246561899,!1,[[0,[1,1.05]]]]]],[0,null,!1,null,455415723241686,[[138,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,515260211865074,!1,[[8,3],[0,[0,220]]]]],[[139,cr.plugins_.Sprite.prototype.acts.SetScale,null,6210109750962019,!1,[[0,[1,1.1]]]]]],[0,null,!1,null,8799416278457157,[[138,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,8966648460303663,!1,[[8,3],
[0,[0,215]]]]],[[139,cr.plugins_.Sprite.prototype.acts.SetScale,null,6223921023930684,!1,[[0,[1,1.15]]]]]],[0,null,!1,null,7043993340512466,[[138,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,9580761163713564,!1,[[8,3],[0,[0,211]]]]],[[139,cr.plugins_.Sprite.prototype.acts.SetScale,null,7222102649648571,!1,[[0,[1,1.2]]]]]],[0,null,!1,null,7222075666468575,[[133,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x6832cec11c4f,!1,[[4,138]]]],[[-1,cr.system_object.prototype.acts.SetVar,
null,9207426331500348,!1,[[11,"Apuntar"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x97108643b4e1b,!1,[[11,"Tiempo"],[7,[0,1]]]],[55,cr.plugins_.Sprite.prototype.acts.SetAnim,null,5227880740269153,!1,[[1,[2,"Animation2"]],[3,1]]],[55,cr.plugins_.Sprite.prototype.acts.SetPos,null,6288833526331419,!1,[[0,[0,69]],[0,[0,185]]]],[138,cr.plugins_.Sprite.prototype.acts.Destroy,null,8166387364471042,!1],[139,cr.plugins_.Sprite.prototype.acts.Destroy,null,5073732041957986,!1],[132,cr.behaviors.Physics.prototype.acts.SetImmovable,
"Physics",5689033149156927,!1,[[3,1]]],[133,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xd29f1d44b4f0f,!1,[[1,[2,"Default"]],[3,1]]],[-1,cr.system_object.prototype.acts.SetObjectTimescale,null,0x477c0bce9eb16,!1,[[4,147],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x4acb780e54684,!1,[[0,[0,10]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x903cf42218076,!1,[[11,"Tiempo"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.RestoreObjectTimescale,null,0x43e2e5a2eb528,!1,[[4,147]]],
[132,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",0x9e531274794ca,!1,[[3,0]]]]],[0,null,!1,null,5086105419565563,[[43,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,0xa6754bbb458ba,!1,[[8,0],[0,[0,3]]]],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0x4b84c7f45aec1,!1,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x7d7e907d33d7b,!1,[[11,"Tiempo"],[8,0],[7,[0,0]]]]],[[132,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",
9244482305899214,!1,[[3,0]]],[132,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",6268108353537729,!1,[[0,[1,1.3]],[0,[4,[20,132,cr.plugins_.Sprite.prototype.exps.Angle,!1,null],[0,270]]],[7,[0,0]]]]]],[0,null,!1,null,6657224027530554,[[43,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,0xc4a24fd293dc2,!1,[[8,0],[0,[0,6]]]],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,9795035220877096,!1,[[0,[1,0.5]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,
0,!1,!1,!1,7349941390552473,!1,[[11,"Tiempo"],[8,0],[7,[0,0]]]]],[[132,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",8389966200600321,!1,[[0,[0,1]],[0,[20,132,cr.plugins_.Sprite.prototype.exps.Angle,!1,null]],[7,[0,0]]]]]]]],["Event Portugal",[[1,"Jugadores",0,0,!1,!1,9647874220887032,!1],[1,"Disparos",0,0,!1,!1,0xaf10b28ba1e36,!1],[0,null,!1,null,0xa1cd55496c4f9,[[47,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8965688513377021,!1,[[4,133]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,
null,5603563867941769,!1,[[0,[1,1E-5]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,5635839296803583,!1,[[4,2],[5,[0,1]],[0,[0,320]],[0,[0,90]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,5476519790710294,!1,[[4,60],[5,[0,1]],[0,[0,319]],[0,[0,90]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,4507402316854214,!1,[[4,3],[5,[0,1]],[0,[0,355]],[0,[0,165]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8158731028392096,!1,[[11,"Dialogo"],[7,[0,1]]]]]],[0,null,!1,null,
7392287924426228,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6561665558035573,!1,[[4,60]]]],[[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,7073718191207796,!1],[-1,cr.system_object.prototype.acts.Wait,null,5223332250122184,!1,[[0,[1,1E-5]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,6359661004036916,!1,[[4,61],[5,[0,1]],[0,[0,319]],[0,[0,90]]]]]],[0,null,!1,null,787803023056861,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7443420292954064,
!1,[[4,61]]]],[[61,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xb9188ee664d6b,!1],[-1,cr.system_object.prototype.acts.Wait,null,0x718516e087d88,!1,[[0,[1,1E-5]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0x8306b8fe4f913,!1,[[4,62],[5,[0,1]],[0,[0,319]],[0,[0,90]]]]]],[0,null,!1,null,829112664022897,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xc930ff57499e1,!1,[[4,62]]]],[[62,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xab3d3993621bb,!1],[-1,cr.system_object.prototype.acts.Wait,
null,0x692d3fff1526d,!1,[[0,[1,1E-5]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,395971923619685,!1,[[4,63],[5,[0,1]],[0,[0,319]],[0,[0,90]]]]]],[0,null,!1,null,4752280437950701,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,9310838215109844,!1,[[4,63]]]],[[63,cr.plugins_.Sprite.prototype.acts.Destroy,null,8587105749067518,!1],[-1,cr.system_object.prototype.acts.Wait,null,4701370478159369,!1,[[0,[1,1E-5]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,8190773577756348,
!1,[[4,64],[5,[0,1]],[0,[0,319]],[0,[0,90]]]]]],[0,null,!1,null,8145480188138126,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x45808c78ccd6b,!1,[[4,64]]]],[[64,cr.plugins_.Sprite.prototype.acts.Destroy,null,5729522973820245,!1],[-1,cr.system_object.prototype.acts.Wait,null,6226695912467326,!1,[[0,[1,1E-5]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,4640632917943576,!1,[[4,65],[5,[0,1]],[0,[0,319]],[0,[0,90]]]]]],[0,null,!1,null,0xb688e4ace2239,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,
null,1,!1,!1,!1,6404345748775492,!1,[[4,65]]]],[[65,cr.plugins_.Sprite.prototype.acts.Destroy,null,9359080583940414,!1],[2,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x5360f04cf8039,!1],[3,cr.plugins_.Sprite.prototype.acts.Destroy,null,8152327920933969,!1],[-1,cr.system_object.prototype.acts.Wait,null,0x8d2b8a4b93f2,!1,[[0,[1,1E-5]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,6203908066348995,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9856297316783656,!1,[[11,
"Dialogo"],[7,[0,0]]]]]],[0,null,!1,null,8493143614274296,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,8544223695382783,!1,[[4,3]]]],[[60,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xfc547747761a1,!1],[61,cr.plugins_.Sprite.prototype.acts.Destroy,null,6702743297981533,!1],[62,cr.plugins_.Sprite.prototype.acts.Destroy,null,8518417104173872,!1],[63,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xd59a2d984025d,!1],[64,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x78531efad8585,
!1],[65,cr.plugins_.Sprite.prototype.acts.Destroy,null,6088366772267314,!1],[3,cr.plugins_.Sprite.prototype.acts.Destroy,null,4853959657646682,!1],[2,cr.plugins_.Sprite.prototype.acts.Destroy,null,4528072723207475,!1],[-1,cr.system_object.prototype.acts.Wait,null,8125368802863554,!1,[[0,[1,1E-5]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0x46d31176da4bc,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,696052219299943,!1,[[11,"Dialogo"],[7,[0,0]]]]]],[0,null,!1,null,907485571891648,
[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,651147525450536,!1]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,8472704076463526,!1,[[0,[0,0]]]],[133,cr.behaviors.Physics.prototype.acts.SetIterations,"Physics",984449777963734,!1,[[0,[0,12]],[0,[0,8]]]],[10,cr.plugins_.Audio.prototype.acts.Play,null,9060288016229780,!1,[[2,["portugal",!0]],[3,1],[0,[0,0]],[1,[2,"Portugal"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9728158396842540,!1,[[11,"Disparos"],[7,[0,3]]]],
[-1,cr.system_object.prototype.acts.SetVar,null,6470920036612263,!1,[[11,"Jugadores"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,7601698089114533,!1,[[11,"Banner"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xb2745b597e905,!1,[[11,"Alineacion"],[7,[0,1]]]]]],[0,null,!1,null,9240418440897426,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8340883511758646,!1,[[11,"Apuntar"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,
!1,!1,9969635702968852,!1,[[11,"Jugadores"],[8,2],[7,[0,5]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,810908741641688,!1,[[11,"Alineacion"],[8,0],[7,[0,0]]]]],[[133,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0xca3e30e09c218,!1,[[4,1],[7,[0,0]]]]],[[0,null,!1,null,0xe0613bced6fc3,[[12,cr.plugins_.Touch.prototype.cnds.IsInTouch,null,0,!1,!1,!1,337743240439983,!1]],[[133,cr.plugins_.Sprite.prototype.acts.SetAngle,null,8865800949166864,!1,[[0,[19,cr.system_object.prototype.exps.angle,
[[20,12,cr.plugins_.Touch.prototype.exps.X,!1,null],[20,12,cr.plugins_.Touch.prototype.exps.Y,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]]]],[133,cr.plugins_.Sprite.prototype.acts.MoveAtAngle,null,0x8da0c138dfde9,!1,[[0,[4,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null],[0,180]]],[0,[19,cr.system_object.prototype.exps.min,[[7,[19,cr.system_object.prototype.exps.distance,[[20,12,cr.plugins_.Touch.prototype.exps.X,!1,null],
[20,12,cr.plugins_.Touch.prototype.exps.Y,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]],[0,3]],[0,45]]]]]],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0xdd3c5e588a1f1,!1,[[4,1]]],[1,cr.plugins_.Sprite.prototype.acts.SetVisible,null,6024949638418317,!1,[[3,1]]],[1,cr.plugins_.Sprite.prototype.acts.SetTowardPosition,null,7887501084961191,!1,[[0,[20,133,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[20,133,cr.plugins_.Sprite.prototype.exps.Y,
!1,null]]]]]],[0,null,!1,null,0xde7369f238846,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,8381950703010161,!1]],[[1,cr.plugins_.Sprite.prototype.acts.SetVisible,null,8293784332482447,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.SetVar,null,4884207112067717,!1,[[11,"Apuntar"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,7910420806949483,!1,[[11,"Tiro"],[7,[7,[19,cr.system_object.prototype.exps.distance,[[20,133,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,
133,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]],[0,15]]]]],[133,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,9829490461935116,!1,[[4,1],[7,[0,0]]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",9257478157062964,!1,[[3,1]]],[55,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",6773017927049602,!1,[[3,1]]],[55,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xf3ac0d28e6c25,
!1,[[1,[2,"Default"]],[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,0xd38ae04ba0b16,!1,[[0,[0,1]]]],[133,cr.plugins_.Sprite.prototype.acts.SetAnim,null,7600766479774848,!1,[[1,[2,"Tiro"]],[3,1]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",795128604604023,!1,[[3,0]]],[133,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",5441804724331134,!1,[[0,[23,"Tiro"]],[0,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null]],[7,[0,0]]]]]]]],[0,null,!1,null,8254029243909803,
[[55,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x8f1a6e828be5,!1,[[4,71]]]],[[55,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",6126237692886458,!1,[[3,0]]]]],[0,null,!1,null,6690485013026516,[[133,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,881566522397793,!1],[55,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,9096702212286684,!1]],[[-1,cr.system_object.prototype.acts.CreateObject,null,437843876279005,!1,[[4,133],[5,[0,1]],[0,[0,0]],[0,
[0,0]]]],[55,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xbdb4eb9832057,!1,[[1,[2,"Animation2"]],[3,1]]],[55,cr.plugins_.Sprite.prototype.acts.SetPos,null,0xdacd80257208c,!1,[[0,[0,69]],[0,[0,185]]]],[-1,cr.system_object.prototype.acts.SubVar,null,5250158254210007,!1,[[11,"Disparos"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5928333686775459,!1,[[11,"RashoLaser"],[7,[0,0]]]]]],[0,null,!1,null,7887480491570687,[[133,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,
856956487558231,!1]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xc5d44f1722c4f,!1,[[11,"Apuntar"],[7,[0,1]]]]]],[0,null,!1,null,6214479538132684,[[133,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xab141cbcc916c,!1,[[4,0]]]],[[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",7885340232046052,!1,[[3,1]]],[133,cr.behaviors.Rotate.prototype.acts.SetSpeed,"Rotate",9009170472610328,!1,[[0,[0,720]]]],[-1,cr.system_object.prototype.acts.Wait,null,333975889487656,!1,
[[0,[1,1]]]],[133,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xb4c9dbb9ee3fc,!1]]],[0,null,!1,null,5639322840096721,[[133,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xd62f32e9624e4,!1,[[4,147]]]],[[133,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",8092409857728849,!1,[[0,[4,[23,"Tiro"],[1,0.5]]],[0,[5,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null],[0,180]]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.AddVar,null,0x3bd5a7d0dfd1d,!1,[[11,"Jugadores"],
[7,[0,1]]]],[147,cr.plugins_.Sprite.prototype.acts.StopAnim,null,0xa5833f07e6651,!1],[147,cr.plugins_.Sprite.prototype.acts.SetAngle,null,901061273624883,!1,[[0,[0,90]]]],[147,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,7026373207494628,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,0x8612fb1cf0b6f,!1,[[0,[1,0.2]]]],[147,cr.plugins_.Sprite.prototype.acts.Destroy,null,5518769041698141,!1]]],[0,null,!1,null,824485210043919,[[45,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,
0,!1,!1,!1,8696987609449684,!1,[[8,0],[0,[0,0]]]]],[[45,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",5284370898419169,!1,[[0,[0,225]]]]]],[0,null,!1,null,7394154456497226,[[45,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,0xf50b238fe7ff3,!1,[[8,0],[0,[0,4]]]]],[[45,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x9c65a4efd1d82,!1,[[0,[0,315]]]]]],[0,null,!1,null,0x4ca77e16e898e,[[45,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,7318727178038113,
!1,[[8,0],[0,[0,8]]]]],[[45,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",8694373224347759,!1,[[0,[0,135]]]]]],[0,null,!1,null,5636450763783156,[[45,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,5495196966673385,!1,[[8,0],[0,[0,12]]]]],[[45,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",5362109691833595,!1,[[0,[0,45]]]]]],[0,null,!1,null,7515024050305101,[[46,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,8067141063658158,!1,[[8,0],[0,
[0,0]]]]],[[46,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",7996395395988013,!1,[[0,[0,180]]]]]],[0,null,!1,null,7698851203669658,[[46,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,6252973774398176,!1,[[8,0],[0,[0,4]]]]],[[46,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xa2bf6972601d3,!1,[[0,[0,0]]]]]],[0,null,!1,null,7643801244547275,[[47,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,5261074834606167,!1,[[8,0],[0,[0,0]]]]],[[47,cr.behaviors.Bullet.prototype.acts.SetEnabled,
"Bullet",5506706946833826,!1,[[3,1]]],[47,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x8063faae560ff,!1,[[0,[0,0]]]]]],[0,null,!1,null,7957760880944246,[[47,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,6267269761790474,!1,[[8,0],[0,[0,7]]]]],[[47,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",5526620703098653,!1,[[3,0]]]]],[0,null,!1,null,8838252035599734,[[47,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,0xa35dceb6b72cd,!1,[[8,0],[0,[0,
11]]]]],[[47,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",754707437417326,!1,[[3,1]]],[47,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",8361502640895168,!1,[[0,[0,180]]]]]],[0,null,!1,null,7441127443097255,[[47,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,0x86284f7e5e0d0,!1,[[8,0],[0,[0,18]]]]],[[47,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",6287196636868161,!1,[[3,0]]]]],[0,null,!1,null,0x69917ba075c3c,[[49,cr.plugins_.Sprite.prototype.cnds.CompareFrame,
null,0,!1,!1,!1,875919072805637,!1,[[8,0],[0,[0,0]]]]],[[49,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",0x9dbf3996ccf0e,!1,[[3,1]]],[49,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0xeba9dc6ed0dcc,!1,[[0,[0,0]]]]]],[0,null,!1,null,6427397574840046,[[49,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,0xdefe1422647be,!1,[[8,0],[0,[0,7]]]]],[[49,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",281619314722584,!1,[[3,0]]]]],[0,null,!1,null,7515819551612208,
[[49,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,7951989828596447,!1,[[8,0],[0,[0,10]]]]],[[49,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",7919577096743564,!1,[[3,1]]],[49,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",9068707414244628,!1,[[0,[0,180]]]]]],[0,null,!1,null,0x9be7f1a35b2a4,[[49,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,5823143960506123,!1,[[8,0],[0,[0,17]]]]],[[49,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",
7161401721478528,!1,[[3,0]]]]],[0,null,!1,null,0x8f08463c575ed,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,412297074070835,!1,[[11,"Disparos"],[8,0],[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,8472851387752841,!1,[[0,[0,5]]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,6611628181464154,!1,[[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,6559451821810754,!1,[[4,120],[5,[0,1]],[0,[0,257]],[0,[0,109]]]],[-1,cr.system_object.prototype.acts.SetVar,
null,7346924950762138,!1,[[11,"Banner"],[7,[0,1]]]],[14,cr.plugins_.CJSAds.prototype.acts.ShowBanner,null,9692022908967676,!1,[[3,1]]],[122,cr.plugins_.Text.prototype.acts.Destroy,null,7796919898837432,!1],[-1,cr.system_object.prototype.acts.CreateObject,null,596466800989004,!1,[[4,122],[5,[0,1]],[0,[0,271]],[0,[0,153]]]],[122,cr.plugins_.Text.prototype.acts.SetOpacity,null,6850941323346846,!1,[[0,[0,100]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0xe869fb52adecd,!1,[[4,7],[5,[0,1]],
[0,[0,625]],[0,[0,345]]]]]],[0,null,!1,null,9875669002919196,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xe73ede68dbcf2,!1,[[4,122]]]],[[147,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xa49460d67630a,!1],[-1,cr.system_object.prototype.acts.GoToLayout,null,0x8660be40ed524,!1,[[6,"Menu"]]],[10,cr.plugins_.Audio.prototype.acts.Stop,null,780690509503023,!1,[[1,[2,"Portugal"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x560672c14be3b,!1,[[11,"Banner"],[7,[0,1]]]],[-1,
cr.system_object.prototype.acts.SetVar,null,705398182405152,!1,[[11,"3Balones"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8533244184268334,!1,[[11,"RashoLaser"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,636770313401082,!1,[[11,"Tiempo"],[7,[0,0]]]]]],[0,null,!1,null,0xb18f0fbfbff35,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6880344813493486,!1,[[11,"Jugadores"],[8,0],[7,[0,5]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,
0xdf75ca88520c6,!1,[[11,"Dialogo"],[8,0],[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,542923549447727,!1,[[0,[0,5]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,8545046016807262,!1,[[4,5],[5,[0,1]],[0,[0,305]],[0,[0,95]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,7432175544173577,!1,[[0,[1,1E-5]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x85e3d9fcf0059,!1,[[11,"Banner"],[7,[0,1]]]],[14,cr.plugins_.CJSAds.prototype.acts.ShowBanner,null,5843946213358881,
!1,[[3,1]]],[122,cr.plugins_.Text.prototype.acts.Destroy,null,0xde9775216696d,!1],[-1,cr.system_object.prototype.acts.CreateObject,null,0xefbecdf205377,!1,[[4,122],[5,[0,1]],[0,[0,271]],[0,[0,153]]]],[122,cr.plugins_.Text.prototype.acts.SetOpacity,null,7489940122819761,!1,[[0,[0,100]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0xdc9bdc10e255e,!1,[[4,7],[5,[0,1]],[0,[0,625]],[0,[0,345]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0x6fcd6c105280f,!1,[[4,142],[5,[0,1]],[0,[0,
308]],[0,[0,247]]]]]],[0,null,!1,null,0x7221b8b66fead,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,8879170106200016,!1]],[[119,cr.plugins_.Text.prototype.acts.SetText,null,5847052778620888,!1,[[7,[10,[2,": "],[23,"Disparos"]]]]]]],[0,null,!1,null,5791736648336725,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xa213c2a70e6d2,!1,[[11,"HighScore"],[8,0],[7,[0,7]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,691925624673838,!1,[[11,"Jugadores"],
[8,0],[7,[0,5]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,5953472777105155,!1,[[11,"HighScore"],[7,[0,1]]]],[13,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,372269467960117,!1,[[1,[2,"Selecciones"]],[7,[23,"HighScore"]]]]]],[0,null,!1,null,7974001386435775,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6522630900498414,!1,[[11,"Banner"],[8,0],[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0xae6e0cf5000c6,!1,[[0,[1,0.2]]]]],[[14,cr.plugins_.CJSAds.prototype.acts.HideBanner,
null,340673603052302,!1]]],[0,null,!1,null,0x77d85db4ae64,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xd89ad9783f8b,!1,[[11,"Alineacion"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,419782145092756,!1,[[0,[1,1E-5]]]]]],[0,null,!1,null,4688667793117376,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,8541578026338951,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9794018582971892,!1,[[11,"Alineacion"],[8,0],[7,[0,
1]]]]],[[-1,cr.system_object.prototype.acts.Wait,null,5427013500873032,!1,[[0,[1,1E-5]]]],[148,cr.plugins_.Text.prototype.acts.Destroy,null,0xbd68fa6a29a73,!1],[-1,cr.system_object.prototype.acts.SetVar,null,7913612077675439,!1,[[11,"Alineacion"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,5344864173256441,!1,[[0,[0,1]]]]]],[0,null,!1,null,6900349096641817,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,9739450708934900,!1,[[4,7]]]],[[11,cr.plugins_.Browser.prototype.acts.GoToURLWindow,
null,6492012550556493,!1,[[1,[10,[10,[10,[2,"https://www.facebook.com/sharer/sharer.php?u=http://zlatanworldcup2014.tk/default.php?score="],[23,"HighScore"]],[2,":"]],[19,cr.system_object.prototype.exps.random,[[0,1],[0,10]]]]],[1,[2,"NewWindow"]]]]]],[0,null,!1,null,9268011078063664,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,595972957958177,!1,[[4,142]]]],[[11,cr.plugins_.Browser.prototype.acts.GoToURLWindow,null,7775769389981796,!1,[[1,[2,"https://play.google.com/store/apps/details?id=com.zlatan.app"]],
[1,[2,"Rate"]]]]]],[0,null,!1,null,6485322174482413,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7513209588736952,!1,[[11,"Ingles"],[8,0],[7,[0,1]]]]],[[120,cr.plugins_.Text.prototype.acts.SetText,null,0xa7728eae60df,!1,[[7,[2,"Failed"]]]],[122,cr.plugins_.Text.prototype.acts.SetText,null,5490961818605293,!1,[[7,[2,"Main"]]]],[125,cr.plugins_.Text.prototype.acts.SetText,null,851028287373652,!1,[[7,[2,"Tap to start"]]]],[60,cr.plugins_.Sprite.prototype.acts.SetAnim,null,669561314164438,
!1,[[1,[2,"Ingles"]],[3,1]]],[61,cr.plugins_.Sprite.prototype.acts.SetAnim,null,9884201114675148,!1,[[1,[2,"Ingles"]],[3,1]]],[62,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xcde8018333237,!1,[[1,[2,"Ingles"]],[3,1]]],[63,cr.plugins_.Sprite.prototype.acts.SetAnim,null,7389110645768832,!1,[[1,[2,"Ingles"]],[3,1]]],[64,cr.plugins_.Sprite.prototype.acts.SetAnim,null,7148435793230285,!1,[[1,[2,"Ingles"]],[3,1]]],[65,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xc90ab6e3b3871,!1,[[1,[2,"Ingles"]],
[3,1]]]]],[0,null,!1,null,0x999ed4db5f146,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,923122474891437,!1,[[11,"Frances"],[8,0],[7,[0,1]]]]],[[120,cr.plugins_.Text.prototype.acts.SetText,null,0xbfa613ebbe9cc,!1,[[7,[2,"Manqu\u00e9"]]]],[122,cr.plugins_.Text.prototype.acts.SetText,null,0xd612c1924b98a,!1,[[7,[2,"Principal"]]]],[125,cr.plugins_.Text.prototype.acts.SetText,null,721699778494882,!1,[[7,[2,"Appuyez sur pour commencer"]]]],[60,cr.plugins_.Sprite.prototype.acts.SetAnim,
null,0x6212bffdd8a41,!1,[[1,[2,"Frances"]],[3,1]]],[61,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xc202cc16199a2,!1,[[1,[2,"Frances"]],[3,1]]],[62,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xac584b35e3194,!1,[[1,[2,"Frances"]],[3,1]]],[63,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6765104570351923,!1,[[1,[2,"Frances"]],[3,1]]],[64,cr.plugins_.Sprite.prototype.acts.SetAnim,null,9073396242818508,!1,[[1,[2,"Frances"]],[3,1]]],[65,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0x6df39fb62b80f,
!1,[[1,[2,"Frances"]],[3,1]]]]],[0,null,!1,null,0x81c294d352d43,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5279403454156356,!1,[[11,"Sueco"],[8,0],[7,[0,1]]]]],[[120,cr.plugins_.Text.prototype.acts.SetText,null,7077224369278307,!1,[[7,[2,"Misslyckades"]]]],[122,cr.plugins_.Text.prototype.acts.SetText,null,9992056780877460,!1,[[7,[2,"Meny"]]]],[125,cr.plugins_.Text.prototype.acts.SetText,null,9550539878732,!1,[[7,[2,"Peka p\u00e5 f\u00f6r att starta"]]]],[60,cr.plugins_.Sprite.prototype.acts.SetAnim,
null,5030239907189738,!1,[[1,[2,"Sueco"]],[3,1]]],[61,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0x7798d0c3514ef,!1,[[1,[2,"Sueco"]],[3,1]]],[62,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xbfe8dd96e0e7e,!1,[[1,[2,"Sueco"]],[3,1]]],[63,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xc202f719e7636,!1,[[1,[2,"Sueco"]],[3,1]]],[64,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xafd81ff25d40c,!1,[[1,[2,"Sueco"]],[3,1]]],[65,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0x9648a192c04a5,!1,[[1,
[2,"Sueco"]],[3,1]]]]],[0,null,!1,null,9325769772605514,[[130,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,6274958707513822,!1,[[8,3],[0,[0,63]]]]],[[131,cr.plugins_.Sprite.prototype.acts.SetScale,null,0xfd8937a72de0d,!1,[[0,[0,1]]]]]],[0,null,!1,null,8234575525017624,[[130,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,8659294401007143,!1,[[8,3],[0,[0,59]]]]],[[131,cr.plugins_.Sprite.prototype.acts.SetScale,null,5847238702274027,!1,[[0,[1,1.05]]]]]],[0,null,!1,null,0x62902a6d53453,
[[130,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,0xf1adb4d6188d,!1,[[8,3],[0,[0,54]]]]],[[131,cr.plugins_.Sprite.prototype.acts.SetScale,null,0x92c9fb6e515e8,!1,[[0,[1,1.1]]]]]],[0,null,!1,null,0x9ec2d422b3e91,[[130,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,5421552726124721,!1,[[8,3],[0,[0,49]]]]],[[131,cr.plugins_.Sprite.prototype.acts.SetScale,null,0xf697ec1bb62d7,!1,[[0,[1,1.15]]]]]],[0,null,!1,null,0x5cbf5e64636e1,[[130,cr.plugins_.Sprite.prototype.cnds.CompareY,
null,0,!1,!1,!1,530345130740535,!1,[[8,3],[0,[0,45]]]]],[[131,cr.plugins_.Sprite.prototype.acts.SetScale,null,4605763035591985,!1,[[0,[1,1.2]]]]]],[0,null,!1,null,0x46489f8c9ea44,[[133,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5502377633567129,!1,[[4,130]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xeec9b51877fdd,!1,[[11,"Apuntar"],[7,[0,1]]]],[55,cr.plugins_.Sprite.prototype.acts.SetAnim,null,5132803743494932,!1,[[1,[2,"Animation2"]],[3,1]]],[55,cr.plugins_.Sprite.prototype.acts.SetPos,
null,6679283491593854,!1,[[0,[0,69]],[0,[0,185]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xa028c0e117339,!1,[[11,"RashoLaser"],[7,[0,1]]]],[130,cr.plugins_.Sprite.prototype.acts.Destroy,null,4569785309224249,!1],[131,cr.plugins_.Sprite.prototype.acts.Destroy,null,5436563627471698,!1]]],[0,null,!1,null,7336673428752468,[[135,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xbf7d881a977cd,!1,[[4,45]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7669630716147972,
!1,[[11,"RashoLaser"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9972924281774160,!1,[[11,"Apuntar"],[8,0],[7,[0,0]]]]],[[10,cr.plugins_.Audio.prototype.acts.SetPaused,null,5706673883396628,!1,[[1,[2,"Portugal"]],[3,0]]],[10,cr.plugins_.Audio.prototype.acts.Play,null,457942213373736,!1,[[2,["rayo lluvia   efecto de sonido",!0]],[3,0],[0,[0,0]],[1,[2,"Rayo"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,6080776734255954,!1,[[11,"RashoLaser"],[7,[0,0]]]],[133,
cr.plugins_.Sprite.prototype.acts.Spawn,null,4582622198675447,!1,[[4,143],[5,[0,0]],[7,[0,0]]]],[143,cr.plugins_.Sprite.prototype.acts.SetTowardPosition,null,8512582317384627,!1,[[0,[20,45,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[20,45,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],[144,cr.behaviors.scrollto.prototype.acts.Shake,"ScrollTo",6001024434016778,!1,[[0,[0,20]],[0,[1,0.4]],[3,0]]],[-1,cr.system_object.prototype.acts.SetObjectTimescale,null,812068621401672,!1,[[4,147],[0,[0,0]]]],
[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",0x7affa5a45bae7,!1,[[3,1]]],[-1,cr.system_object.prototype.acts.SetObjectTimescale,null,7872921265108411,!1,[[4,55],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x77f53bb491fc3,!1,[[0,[0,1]]]],[133,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xdbc793175a59d,!1,[[1,[2,"Tiro"]],[3,1]]],[-1,cr.system_object.prototype.acts.RestoreObjectTimescale,null,9266559541160156,!1,[[4,147]]],[-1,cr.system_object.prototype.acts.RestoreObjectTimescale,
null,911479515435454,!1,[[4,55]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",0x751affaab625a,!1,[[3,0]]],[133,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",0xfb4dbe191a4bf,!1,[[0,[23,"Tiro"]],[0,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null]],[7,[0,0]]]],[143,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xad06b220fd268,!1],[10,cr.plugins_.Audio.prototype.acts.SetPaused,null,0xcf40aade43237,!1,[[1,[2,"Portugal"]],[3,1]]]]],[0,null,!1,null,61095546187952,
[[135,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xcf8095b84f34f,!1,[[4,46]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8154758170789846,!1,[[11,"RashoLaser"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x71318537e08b1,!1,[[11,"Apuntar"],[8,0],[7,[0,0]]]]],[[10,cr.plugins_.Audio.prototype.acts.SetPaused,null,5364935839419133,!1,[[1,[2,"Portugal"]],[3,0]]],[10,cr.plugins_.Audio.prototype.acts.Play,null,9773313410352916,!1,
[[2,["rayo lluvia   efecto de sonido",!0]],[3,0],[0,[0,0]],[1,[2,"Rayo"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5603621866114929,!1,[[11,"RashoLaser"],[7,[0,0]]]],[133,cr.plugins_.Sprite.prototype.acts.Spawn,null,482386654344287,!1,[[4,143],[5,[0,0]],[7,[0,0]]]],[143,cr.plugins_.Sprite.prototype.acts.SetTowardPosition,null,9289027130780700,!1,[[0,[20,46,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[20,46,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],[144,cr.behaviors.scrollto.prototype.acts.Shake,
"ScrollTo",404208679840818,!1,[[0,[0,20]],[0,[1,0.4]],[3,0]]],[-1,cr.system_object.prototype.acts.SetObjectTimescale,null,0x66524b02a0593,!1,[[4,147],[0,[0,0]]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",0x5cbc19fe6f505,!1,[[3,1]]],[-1,cr.system_object.prototype.acts.SetObjectTimescale,null,9261725842817092,!1,[[4,55],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,9786882845256054,!1,[[0,[0,1]]]],[133,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xc3e6f73a2897c,
!1,[[1,[2,"Tiro"]],[3,1]]],[-1,cr.system_object.prototype.acts.RestoreObjectTimescale,null,0xa902ff176bbb1,!1,[[4,147]]],[-1,cr.system_object.prototype.acts.RestoreObjectTimescale,null,6192686189650107,!1,[[4,55]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",8380321378119127,!1,[[3,0]]],[133,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",6609190156005849,!1,[[0,[23,"Tiro"]],[0,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null]],[7,[0,0]]]],[143,cr.plugins_.Sprite.prototype.acts.Destroy,
null,0xba44159505b6f,!1],[10,cr.plugins_.Audio.prototype.acts.SetPaused,null,0xa8dfecc774de9,!1,[[1,[2,"Portugal"]],[3,1]]]]],[0,null,!1,null,8443330767711671,[[135,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6025178130810788,!1,[[4,47]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xf38e1a88aa887,!1,[[11,"RashoLaser"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,4792977766500569,!1,[[11,"Apuntar"],[8,0],[7,[0,0]]]]],[[10,cr.plugins_.Audio.prototype.acts.SetPaused,
null,7455319041348906,!1,[[1,[2,"Portugal"]],[3,0]]],[10,cr.plugins_.Audio.prototype.acts.Play,null,5413555409014825,!1,[[2,["rayo lluvia   efecto de sonido",!0]],[3,0],[0,[0,0]],[1,[2,"Rayo"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,82665171268434,!1,[[11,"RashoLaser"],[7,[0,0]]]],[133,cr.plugins_.Sprite.prototype.acts.Spawn,null,0xa0496bbe3f561,!1,[[4,143],[5,[0,0]],[7,[0,0]]]],[143,cr.plugins_.Sprite.prototype.acts.SetTowardPosition,null,8844773518976761,!1,[[0,[20,47,cr.plugins_.Sprite.prototype.exps.X,
!1,null]],[0,[20,47,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],[144,cr.behaviors.scrollto.prototype.acts.Shake,"ScrollTo",0x7ab214007cf7d,!1,[[0,[0,20]],[0,[1,0.4]],[3,0]]],[-1,cr.system_object.prototype.acts.SetObjectTimescale,null,6010785465553479,!1,[[4,147],[0,[0,0]]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",0x8850bbfe2903b,!1,[[3,1]]],[-1,cr.system_object.prototype.acts.SetObjectTimescale,null,0x7129fa6e40574,!1,[[4,55],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,
null,5573813213893568,!1,[[0,[0,1]]]],[133,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xd9ebde29f8870,!1,[[1,[2,"Tiro"]],[3,1]]],[-1,cr.system_object.prototype.acts.RestoreObjectTimescale,null,9428033813173568,!1,[[4,147]]],[-1,cr.system_object.prototype.acts.RestoreObjectTimescale,null,878102869274289,!1,[[4,55]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",925384697747326,!1,[[3,0]]],[133,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",7712978997550639,
!1,[[0,[23,"Tiro"]],[0,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null]],[7,[0,0]]]],[143,cr.plugins_.Sprite.prototype.acts.Destroy,null,9131858634932316,!1],[10,cr.plugins_.Audio.prototype.acts.SetPaused,null,8635727452260719,!1,[[1,[2,"Portugal"]],[3,1]]]]],[0,null,!1,null,6094053373937532,[[135,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xaf3b764ccce1f,!1,[[4,48]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6129854652975045,!1,[[11,"RashoLaser"],[8,
0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8999625905583393,!1,[[11,"Apuntar"],[8,0],[7,[0,0]]]]],[[10,cr.plugins_.Audio.prototype.acts.SetPaused,null,646618014674287,!1,[[1,[2,"Portugal"]],[3,0]]],[10,cr.plugins_.Audio.prototype.acts.Play,null,9325805992169844,!1,[[2,["rayo lluvia   efecto de sonido",!0]],[3,0],[0,[0,0]],[1,[2,"Rayo"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5138825860915521,!1,[[11,"RashoLaser"],[7,[0,0]]]],[133,cr.plugins_.Sprite.prototype.acts.Spawn,
null,8818159686149547,!1,[[4,143],[5,[0,0]],[7,[0,0]]]],[143,cr.plugins_.Sprite.prototype.acts.SetTowardPosition,null,8713968339387143,!1,[[0,[20,48,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[20,48,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],[144,cr.behaviors.scrollto.prototype.acts.Shake,"ScrollTo",0xc9a2355525243,!1,[[0,[0,20]],[0,[1,0.4]],[3,0]]],[-1,cr.system_object.prototype.acts.SetObjectTimescale,null,6417576947510079,!1,[[4,147],[0,[0,0]]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,
"Physics",49259337644982,!1,[[3,1]]],[-1,cr.system_object.prototype.acts.SetObjectTimescale,null,0x71baa5d928a4d,!1,[[4,55],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,528726810526178,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestoreObjectTimescale,null,4783004553190765,!1,[[4,147]]],[-1,cr.system_object.prototype.acts.RestoreObjectTimescale,null,4865840928607189,!1,[[4,55]]],[133,cr.plugins_.Sprite.prototype.acts.SetAnim,null,30608785126678,!1,[[1,[2,"Tiro"]],[3,1]]],[133,
cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",9583528935918476,!1,[[3,0]]],[133,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",0x9d19099c9dcbd,!1,[[0,[23,"Tiro"]],[0,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null]],[7,[0,0]]]],[143,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xc0143ae7e5a4,!1],[10,cr.plugins_.Audio.prototype.acts.SetPaused,null,952743071793745,!1,[[1,[2,"Portugal"]],[3,1]]]]],[0,null,!1,null,4558501961173147,[[135,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,5916984596436215,!1,[[4,49]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x5c641849d8c13,!1,[[11,"RashoLaser"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8859702860295375,!1,[[11,"Apuntar"],[8,0],[7,[0,0]]]]],[[10,cr.plugins_.Audio.prototype.acts.SetPaused,null,6536746306088108,!1,[[1,[2,"Portugal"]],[3,0]]],[10,cr.plugins_.Audio.prototype.acts.Play,null,7357740633269421,!1,[[2,["rayo lluvia   efecto de sonido",!0]],[3,0],[0,
[0,0]],[1,[2,"Rayo"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5424084950893661,!1,[[11,"RashoLaser"],[7,[0,0]]]],[133,cr.plugins_.Sprite.prototype.acts.Spawn,null,6895867497784518,!1,[[4,143],[5,[0,0]],[7,[0,0]]]],[143,cr.plugins_.Sprite.prototype.acts.SetTowardPosition,null,59973741435023,!1,[[0,[20,49,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[20,49,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]],[144,cr.behaviors.scrollto.prototype.acts.Shake,"ScrollTo",993914631994163,!1,[[0,
[0,20]],[0,[1,0.4]],[3,0]]],[-1,cr.system_object.prototype.acts.SetObjectTimescale,null,0x53f33cf177531,!1,[[4,147],[0,[0,0]]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",8060556349101158,!1,[[3,1]]],[-1,cr.system_object.prototype.acts.SetObjectTimescale,null,6158482788425223,!1,[[4,55],[0,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,9491870304759096,!1,[[0,[0,1]]]],[133,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0x5fd3a4422173a,!1,[[1,[2,"Tiro"]],[3,1]]],[-1,cr.system_object.prototype.acts.RestoreObjectTimescale,
null,5306092149092446,!1,[[4,147]]],[-1,cr.system_object.prototype.acts.RestoreObjectTimescale,null,0x61da27e463cd1,!1,[[4,55]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",0x77645025462f6,!1,[[3,0]]],[133,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",5000554989665349,!1,[[0,[23,"Tiro"]],[0,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null]],[7,[0,0]]]],[143,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x5c4044cc57b7f,!1],[10,cr.plugins_.Audio.prototype.acts.SetPaused,
null,8381021810470146,!1,[[1,[2,"Portugal"]],[3,1]]]]],[0,null,!1,null,0x5984dbd8dbfb3,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9532219643594988,!1,[[11,"RashoLaser"],[8,0],[7,[0,1]]]]],[[133,cr.plugins_.Sprite.prototype.acts.SetAnim,null,7462821095160216,!1,[[1,[2,"BalonRasho"]],[3,1]]],[135,cr.plugins_.Sprite.prototype.acts.SetX,null,0x89c0bb8858279,!1,[[0,[20,133,cr.plugins_.Sprite.prototype.exps.X,!1,null]]]],[135,cr.plugins_.Sprite.prototype.acts.SetY,null,0x661266e6adc81,
!1,[[0,[20,133,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]]]],[0,null,!1,null,0x575b73e657317,[[143,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7871881140722732,!1,[[4,147]]]],[[147,cr.plugins_.Sprite.prototype.acts.SetEffect,null,9605485625676114,!1,[[3,1]]],[-1,cr.system_object.prototype.acts.AddVar,null,8105504734932952,!1,[[11,"Jugadores"],[7,[0,1]]]],[147,cr.plugins_.Sprite.prototype.acts.StopAnim,null,5518681549280985,!1],[147,cr.plugins_.Sprite.prototype.acts.SetCollisions,
null,0xbc6e792a2342d,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,6177223856339068,!1,[[0,[1,0.4]]]],[147,cr.plugins_.Sprite.prototype.acts.Destroy,null,9093095152643522,!1]]],[0,null,!1,null,860740924002352,[[140,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,0x8ae17fd28c3c5,!1,[[8,3],[0,[0,232]]]]],[[141,cr.plugins_.Sprite.prototype.acts.SetScale,null,7630632087235108,!1,[[0,[0,1]]]]]],[0,null,!1,null,6613415616130421,[[140,cr.plugins_.Sprite.prototype.cnds.CompareY,null,
0,!1,!1,!1,0x738f6396d8a7b,!1,[[8,3],[0,[0,228]]]]],[[141,cr.plugins_.Sprite.prototype.acts.SetScale,null,5390915215277295,!1,[[0,[1,1.05]]]]]],[0,null,!1,null,0xc76bb0db8f033,[[140,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,0xbf995bb280832,!1,[[8,3],[0,[0,223]]]]],[[141,cr.plugins_.Sprite.prototype.acts.SetScale,null,8965067078690202,!1,[[0,[1,1.1]]]]]],[0,null,!1,null,9462757876034956,[[140,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,5724050945386191,!1,[[8,3],[0,
[0,218]]]]],[[141,cr.plugins_.Sprite.prototype.acts.SetScale,null,0xd4e17b8a96a4b,!1,[[0,[1,1.15]]]]]],[0,null,!1,null,0xff067e2755280,[[140,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,8604437282271431,!1,[[8,3],[0,[0,214]]]]],[[141,cr.plugins_.Sprite.prototype.acts.SetScale,null,5047479713147646,!1,[[0,[1,1.2]]]]]],[0,null,!1,null,5237799703046826,[[133,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9275107542278612,!1,[[4,140]]]],[[-1,cr.system_object.prototype.acts.SetVar,
null,7922174167168056,!1,[[11,"Apuntar"],[7,[0,1]]]],[55,cr.plugins_.Sprite.prototype.acts.Destroy,null,6023487477665664,!1],[-1,cr.system_object.prototype.acts.CreateObject,null,4532989436884093,!1,[[4,55],[5,[0,0]],[0,[0,69]],[0,[0,185]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xb37aaf7bd368d,!1,[[11,"RashoLaser"],[7,[0,1]]]],[140,cr.plugins_.Sprite.prototype.acts.Destroy,null,8773658366225424,!1],[141,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xd8887b849221a,!1]]]]],["Event Argentina",
[[0,null,!1,null,4644857698350628,[[53,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,4518961456531401,!1,[[4,133]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,9715688505065166,!1,[[0,[1,1E-5]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,5733564329938451,!1,[[4,2],[5,[0,1]],[0,[0,320]],[0,[0,90]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0xe60d62fc64795,!1,[[4,56],[5,[0,1]],[0,[0,319]],[0,[0,90]]]],[-1,cr.system_object.prototype.acts.CreateObject,
null,599269232024027,!1,[[4,3],[5,[0,1]],[0,[0,355]],[0,[0,165]]]],[-1,cr.system_object.prototype.acts.SetVar,null,7100411502292325,!1,[[11,"Dialogo"],[7,[0,1]]]]]],[0,null,!1,null,0x9cac6a35a0d48,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6983866160248579,!1,[[4,56]]]],[[56,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x54786fef18ad1,!1],[-1,cr.system_object.prototype.acts.Wait,null,8848072862421924,!1,[[0,[1,1E-5]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,
8492813213261212,!1,[[4,57],[5,[0,1]],[0,[0,319]],[0,[0,90]]]]]],[0,null,!1,null,0x6aa6dd00b6d05,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,8037100315060502,!1,[[4,57]]]],[[57,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x5da3c50dea2e7,!1],[2,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xec862d20aefb9,!1],[3,cr.plugins_.Sprite.prototype.acts.Destroy,null,90299921317712,!1],[-1,cr.system_object.prototype.acts.Wait,null,0xd450645d93130,!1,[[0,[1,1E-5]]]],[-1,cr.system_object.prototype.acts.SetTimescale,
null,6346245436406792,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,6272128524744202,!1,[[11,"Dialogo"],[7,[0,0]]]]]],[0,null,!1,null,5288636633371731,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,8594978931549606,!1,[[4,3]]]],[[56,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xc377665be2383,!1],[57,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xe23889a284634,!1],[3,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x6a8b54e676048,!1],[2,cr.plugins_.Sprite.prototype.acts.Destroy,
null,0x7667da42a698f,!1],[-1,cr.system_object.prototype.acts.Wait,null,6355704724632805,!1,[[0,[1,1E-5]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0xe9b99016edbce,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5915101696152056,!1,[[11,"Dialogo"],[7,[0,0]]]]]],[0,null,!1,null,0xca76d4a018ae7,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0xa1e4123ae50c8,!1]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,0xe4340c9ac7771,!1,[[0,[0,0]]]],[133,
cr.behaviors.Physics.prototype.acts.SetIterations,"Physics",7753345653935222,!1,[[0,[0,12]],[0,[0,8]]]],[51,cr.plugins_.Sprite.prototype.acts.StopAnim,null,8089617151836052,!1],[52,cr.plugins_.Sprite.prototype.acts.StopAnim,null,9610618301664778,!1],[-1,cr.system_object.prototype.acts.CreateObject,null,7417243612403916,!1,[[4,132],[5,[0,0]],[0,[0,184]],[0,[0,304]]]],[10,cr.plugins_.Audio.prototype.acts.Play,null,8918046916241159,!1,[[2,["argentina",!0]],[3,1],[0,[0,0]],[1,[2,"Argentina"]]]],[-1,cr.system_object.prototype.acts.SetVar,
null,0xf705c8ca9af08,!1,[[11,"Disparos"],[7,[0,5]]]],[-1,cr.system_object.prototype.acts.SetVar,null,4646074471540119,!1,[[11,"Jugadores"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5117900628310011,!1,[[11,"Banner"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xd25962efafed,!1,[[11,"Alineacion"],[7,[0,1]]]]]],[0,null,!1,null,9502107956423114,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x5c7fe1e38d451,!1,[[11,"Apuntar"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,0x6a4a4695835e2,!1,[[11,"Jugadores"],[8,2],[7,[0,5]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9425399540783052,!1,[[11,"Alineacion"],[8,0],[7,[0,0]]]]],[[133,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,9569672181448952,!1,[[4,1],[7,[0,0]]]]],[[0,null,!1,null,39681963010045,[[12,cr.plugins_.Touch.prototype.cnds.IsInTouch,null,0,!1,!1,!1,8501924006418725,!1]],[[133,cr.plugins_.Sprite.prototype.acts.SetAngle,null,5060946947141168,!1,[[0,[19,cr.system_object.prototype.exps.angle,
[[20,12,cr.plugins_.Touch.prototype.exps.X,!1,null],[20,12,cr.plugins_.Touch.prototype.exps.Y,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]]]],[133,cr.plugins_.Sprite.prototype.acts.MoveAtAngle,null,9845869376864048,!1,[[0,[4,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null],[0,180]]],[0,[19,cr.system_object.prototype.exps.min,[[7,[19,cr.system_object.prototype.exps.distance,[[20,12,cr.plugins_.Touch.prototype.exps.X,!1,null],
[20,12,cr.plugins_.Touch.prototype.exps.Y,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]],[0,3]],[0,45]]]]]],[-1,cr.system_object.prototype.acts.ScrollToObject,null,6734429679384982,!1,[[4,1]]],[1,cr.plugins_.Sprite.prototype.acts.SetVisible,null,5302503083172502,!1,[[3,1]]],[1,cr.plugins_.Sprite.prototype.acts.SetTowardPosition,null,7866927313531521,!1,[[0,[20,133,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[20,133,cr.plugins_.Sprite.prototype.exps.Y,
!1,null]]]]]],[0,null,!1,null,0x50f8898913cee,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,532841458811613,!1]],[[1,cr.plugins_.Sprite.prototype.acts.SetVisible,null,4532544793230147,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.SetVar,null,7466717012584977,!1,[[11,"Apuntar"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9311425030501460,!1,[[11,"Tiro"],[7,[7,[19,cr.system_object.prototype.exps.distance,[[20,133,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,
133,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]],[0,15]]]]],[133,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,8576778064725148,!1,[[4,1],[7,[0,0]]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",9318100412639338,!1,[[3,1]]],[55,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",0x831bcc702a429,!1,[[3,1]]],[55,cr.plugins_.Sprite.prototype.acts.SetAnim,null,7957076467870496,
!1,[[1,[2,"Default"]],[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,6386502601478406,!1,[[0,[0,1]]]],[133,cr.plugins_.Sprite.prototype.acts.SetAnim,null,5864971459300558,!1,[[1,[2,"Tiro"]],[3,1]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",0xc7c62dfcad26c,!1,[[3,0]]],[133,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",7551553601313665,!1,[[0,[23,"Tiro"]],[0,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null]],[7,[0,0]]]]]]]],[0,null,!1,null,0xf2852e238a195,
[[55,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7788568725227203,!1,[[4,71]]]],[[55,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",9513127931647072,!1,[[3,0]]]]],[0,null,!1,null,6604932911178671,[[133,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,8411691882851993,!1],[55,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,8221763322879985,!1]],[[-1,cr.system_object.prototype.acts.CreateObject,null,6027584636004271,!1,[[4,133],[5,[0,1]],[0,[0,0]],
[0,[0,0]]]],[55,cr.plugins_.Sprite.prototype.acts.SetAnim,null,8669470051962483,!1,[[1,[2,"Animation2"]],[3,1]]],[55,cr.plugins_.Sprite.prototype.acts.SetPos,null,6034142719170031,!1,[[0,[0,69]],[0,[0,185]]]],[-1,cr.system_object.prototype.acts.SubVar,null,283449070540724,!1,[[11,"Disparos"],[7,[0,1]]]]]],[0,null,!1,null,9342694411873454,[[133,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,9223944713921020,!1]],[[-1,cr.system_object.prototype.acts.SetVar,null,0xc6fc2970c068c,!1,[[11,
"Apuntar"],[7,[0,1]]]]]],[0,null,!1,null,0x6e50b604f319b,[[133,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xf7b54d7ca1c9b,!1,[[4,0]]]],[[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",0x8a20366d865f,!1,[[3,1]]],[133,cr.behaviors.Rotate.prototype.acts.SetSpeed,"Rotate",7896405755308922,!1,[[0,[0,720]]]],[-1,cr.system_object.prototype.acts.Wait,null,8570129055947976,!1,[[0,[1,1]]]],[133,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xbe74986084118,!1]]],[0,null,!1,
null,0x3fbacf945af29,[[133,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x4a2d4223061d4,!1,[[4,147]]]],[[133,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",0xd85eddf82aa9f,!1,[[0,[4,[23,"Tiro"],[1,0.5]]],[0,[5,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null],[0,180]]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.AddVar,null,7715145347944242,!1,[[11,"Jugadores"],[7,[0,1]]]],[147,cr.plugins_.Sprite.prototype.acts.StopAnim,null,728213058674785,!1],[147,
cr.plugins_.Sprite.prototype.acts.SetAngle,null,6278616367628377,!1,[[0,[0,90]]]],[147,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,9023676631443782,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.Wait,null,6396507304410442,!1,[[0,[1,0.2]]]],[147,cr.plugins_.Sprite.prototype.acts.Destroy,null,5522836154450327,!1]],[[0,null,!1,null,6726507064241053,[[133,cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,null,0,!1,!1,!1,0xeb51971f08ed6,!1,[[1,[2,"3Balones"]]]]],[[133,cr.plugins_.Sprite.prototype.acts.Destroy,
null,648504368341062,!1]]]]],[0,null,!1,null,0xca18dbcacd326,[[50,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,0xca1a677e87447,!1,[[8,0],[0,[0,0]]]]],[[50,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x51e86f563c22c,!1,[[0,[0,0]]]]]],[0,null,!1,null,5727314772816289,[[50,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,9246112587303596,!1,[[8,0],[0,[0,4]]]]],[[50,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x736714ac234a8,!1,[[0,[0,
180]]]]]],[0,null,!1,null,817777281148365,[[53,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,0x7835f6f3e56e3,!1,[[8,0],[0,[0,0]]]]],[[53,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",0x8f181d7632e8f,!1,[[0,[0,350]]]]]],[0,null,!1,null,6887830384176747,[[53,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,6955074632909514,!1,[[8,0],[0,[0,6]]]]],[[53,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",7870332071784046,!1,[[0,[0,10]]]]]],[0,null,
!1,null,5584769125036331,[[53,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,0x6d4dba7a2ec9f,!1,[[8,0],[0,[0,12]]]]],[[53,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",4739534409752286,!1,[[0,[0,190]]]]]],[0,null,!1,null,6667883205429782,[[53,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,0x98112622b806d,!1,[[8,0],[0,[0,18]]]]],[[53,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",5348428363233722,!1,[[0,[0,170]]]]]],[0,null,!1,null,0xc6abe8cac5790,
[[132,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,0x6e87768616583,!1]],[[51,cr.plugins_.Sprite.prototype.acts.StartAnim,null,8542808903811974,!1,[[3,1]]]]],[0,null,!1,null,9725730726367956,[[51,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,7480433845050023,!1,[[8,0],[0,[0,2]]]],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,7031935222300646,!1,[[0,[1,0.5]]]]],[[132,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",0x4e08c4623b988,!1,[[3,0]]],[132,
cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",0xb5aa2a9495fe3,!1,[[0,[1,1.3]],[0,[4,[20,132,cr.plugins_.Sprite.prototype.exps.Angle,!1,null],[0,295]]],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,6753349475864452,!1,[[0,[1,0.2]]]],[52,cr.plugins_.Sprite.prototype.acts.StartAnim,null,0xf6daa86af93c7,!1,[[3,1]]]]],[0,null,!1,null,8398235231593158,[[52,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,19380899608539,!1,[[8,0],[0,[0,3]]]],[-1,cr.system_object.prototype.cnds.Every,
null,0,!1,!1,!1,6248243907214836,!1,[[0,[1,0.5]]]]],[[132,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",0xe12556de6dcff,!1,[[0,[1,0.8]],[0,[20,132,cr.plugins_.Sprite.prototype.exps.Angle,!1,null]],[7,[0,0]]]]]],[0,null,!1,null,0xdef60272563b7,[[132,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xa651508fc6574,!1,[[4,0]]]],[[132,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",7370122707428759,!1,[[3,1]]],[132,cr.behaviors.Rotate.prototype.acts.SetSpeed,
"Rotate",7814181005099118,!1,[[0,[0,720]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x6f846923e6519,!1,[[0,[1,1]]]],[132,cr.plugins_.Sprite.prototype.acts.Destroy,null,5137058894468223,!1]]],[0,null,!1,null,0x548a261f40ae1,[[132,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,7047587847188135,!1],[51,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0x6092dc1a7155b,!1]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0xeb4a6656d3bf,!1,[[4,132],[5,[0,0]],[0,[0,
184]],[0,[0,304]]]]]],[0,null,!1,null,7804488824630376,[[51,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,5481973180733531,!1]],[[-1,cr.system_object.prototype.acts.Wait,null,0xd57904df80a3c,!1,[[0,[1,0.5]]]],[132,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xfcaa6dc1cc7bd,!1]]],[0,null,!1,null,0x6154a3efe871,[[54,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,7008821029996889,!1,[[8,0],[0,[0,0]]]]],[[54,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",
0x923e6b0384a5f,!1,[[0,[0,45]]]]]],[0,null,!1,null,5795107579864873,[[54,cr.plugins_.Sprite.prototype.cnds.CompareFrame,null,0,!1,!1,!1,6994299722954965,!1,[[8,0],[0,[0,8]]]]],[[54,cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,"Bullet",64012579925708,!1,[[0,[0,225]]]]]],[0,null,!1,null,7249950236463708,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x9bb526ee6b3c7,!1,[[11,"Disparos"],[8,0],[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,9173290213412576,
!1,[[0,[0,5]]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,0x48ad9b045bced,!1,[[0,[0,0]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0xb5d4982fdbff7,!1,[[4,120],[5,[0,1]],[0,[0,257]],[0,[0,109]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x6ca6bc04bc850,!1,[[11,"Banner"],[7,[0,1]]]],[14,cr.plugins_.CJSAds.prototype.acts.ShowBanner,null,0xaadcfb908a28e,!1,[[3,1]]],[122,cr.plugins_.Text.prototype.acts.Destroy,null,0xdfde2a5a24894,!1],[-1,cr.system_object.prototype.acts.CreateObject,
null,6862699464729133,!1,[[4,122],[5,[0,1]],[0,[0,271]],[0,[0,153]]]],[122,cr.plugins_.Text.prototype.acts.SetOpacity,null,0x6dfc9923acb18,!1,[[0,[0,100]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,464938105199278,!1,[[4,7],[5,[0,1]],[0,[0,625]],[0,[0,345]]]]]],[0,null,!1,null,0x8ec4062c8422d,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,17969302663893,!1,[[4,122]]]],[[147,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xf684cf45046a0,!1],[-1,cr.system_object.prototype.acts.GoToLayout,
null,0xd3c8450f499df,!1,[[6,"Menu"]]],[10,cr.plugins_.Audio.prototype.acts.Stop,null,0xda86f20febabf,!1,[[1,[2,"Argentina"]]]],[-1,cr.system_object.prototype.acts.SetVar,null,4668505854902095,!1,[[11,"Banner"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,63910392042859,!1,[[11,"3Balones"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,672328983538805,!1,[[11,"RashoLaser"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8283758113998453,!1,[[11,"Tiempo"],[7,
[0,0]]]]]],[0,null,!1,null,6750266427690634,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6538935692746857,!1,[[11,"Jugadores"],[8,0],[7,[0,5]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6646646160533419,!1,[[11,"Dialogo"],[8,0],[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,8896660016248919,!1,[[0,[0,5]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,0xc769a147d354b,!1,[[4,5],[5,[0,1]],[0,[0,305]],[0,[0,95]]]],[-1,cr.system_object.prototype.acts.SetVar,
null,0x5d0d5fd68b0c9,!1,[[11,"Alemania"],[7,[0,2]]]],[13,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,345463928561537,!1,[[1,[2,"Alemania"]],[7,[23,"Alemania"]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0xb87196ea66267,!1,[[0,[1,1E-5]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5353254047217665,!1,[[11,"Banner"],[7,[0,1]]]],[14,cr.plugins_.CJSAds.prototype.acts.ShowBanner,null,8949742128129498,!1,[[3,1]]],[122,cr.plugins_.Text.prototype.acts.Destroy,null,0x5436de5dded76,
!1],[-1,cr.system_object.prototype.acts.CreateObject,null,0x8790e365728aa,!1,[[4,122],[5,[0,1]],[0,[0,271]],[0,[0,153]]]],[122,cr.plugins_.Text.prototype.acts.SetOpacity,null,0xfb5409ef9b79c,!1,[[0,[0,100]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0x3caa51a56792e,!1,[[4,7],[5,[0,1]],[0,[0,625]],[0,[0,345]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,6300951557853596,!1,[[4,142],[5,[0,1]],[0,[0,308]],[0,[0,247]]]]]],[0,null,!1,null,0xc10b94fbeb1a4,[[-1,cr.system_object.prototype.cnds.EveryTick,
null,0,!1,!1,!1,7479399104266618,!1]],[[119,cr.plugins_.Text.prototype.acts.SetText,null,9070599394742542,!1,[[7,[10,[2,": "],[23,"Disparos"]]]]]]],[0,null,!1,null,0xbbb7f2c861938,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6745512663247257,!1,[[11,"HighScore"],[8,0],[7,[0,5]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5455872374928328,!1,[[11,"Jugadores"],[8,0],[7,[0,5]]]]],[[-1,cr.system_object.prototype.acts.AddVar,null,8975232014840971,!1,[[11,"HighScore"],
[7,[0,1]]]],[13,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,6085116269884861,!1,[[1,[2,"Selecciones"]],[7,[23,"HighScore"]]]]]],[0,null,!1,null,0x6c3f01d4bf453,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9799589292059544,!1,[[11,"Banner"],[8,0],[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,6372207764518027,!1,[[0,[1,0.2]]]]],[[14,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,4703523522516243,!1]]],[0,null,!1,null,8358341119568835,[[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,8669670002048814,!1,[[11,"Alineacion"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,0xa441e34058b0f,!1,[[0,[1,1E-5]]]]]],[0,null,!1,null,4709585149710775,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,40821601186052,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6177174848577258,!1,[[11,"Alineacion"],[8,0],[7,[0,1]]]]],[[-1,cr.system_object.prototype.acts.Wait,null,0x3e322528aaf08,!1,[[0,[1,1E-5]]]],[148,cr.plugins_.Text.prototype.acts.Destroy,
null,9090518429048676,!1],[-1,cr.system_object.prototype.acts.SetVar,null,9921940695110164,!1,[[11,"Alineacion"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0x85af0002edc22,!1,[[0,[0,1]]]]]],[0,null,!1,null,0xaf02bdf1299d3,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6208014883414909,!1,[[4,7]]]],[[11,cr.plugins_.Browser.prototype.acts.GoToURLWindow,null,6561362452108567,!1,[[1,[10,[10,[10,[2,"https://www.facebook.com/sharer/sharer.php?u=http://zlatanworldcup2014.tk/default.php?score="],
[23,"HighScore"]],[2,":"]],[19,cr.system_object.prototype.exps.random,[[0,1],[0,10]]]]],[1,[2,"NewWindow"]]]]]],[0,null,!1,null,0x813802d99a150,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x8d74318a2f36d,!1,[[4,142]]]],[[11,cr.plugins_.Browser.prototype.acts.GoToURLWindow,null,0xdd25b2e6371d6,!1,[[1,[2,"https://play.google.com/store/apps/details?id=com.zlatan.app"]],[1,[2,"Rate"]]]]]],[0,null,!1,null,9072069278786518,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,
!1,!1,0xa566f59e24f3b,!1,[[11,"Ingles"],[8,0],[7,[0,1]]]]],[[120,cr.plugins_.Text.prototype.acts.SetText,null,0x5c4e8c4c8647d,!1,[[7,[2,"Failed"]]]],[122,cr.plugins_.Text.prototype.acts.SetText,null,9226083947463996,!1,[[7,[2,"Main"]]]],[125,cr.plugins_.Text.prototype.acts.SetText,null,5921703939713615,!1,[[7,[2,"Tap to start"]]]],[56,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6852897824303093,!1,[[1,[2,"Ingles"]],[3,1]]],[57,cr.plugins_.Sprite.prototype.acts.SetAnim,null,5202313859686205,!1,
[[1,[2,"Ingles"]],[3,1]]]]],[0,null,!1,null,8873129328594209,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,969504929730707,!1,[[11,"Frances"],[8,0],[7,[0,1]]]]],[[120,cr.plugins_.Text.prototype.acts.SetText,null,0xc6cf49b3b9d09,!1,[[7,[2,"Manqu\u00e9"]]]],[122,cr.plugins_.Text.prototype.acts.SetText,null,7519774597669038,!1,[[7,[2,"Principal"]]]],[125,cr.plugins_.Text.prototype.acts.SetText,null,4894054438186828,!1,[[7,[2,"Appuyez sur pour commencer"]]]],[56,cr.plugins_.Sprite.prototype.acts.SetAnim,
null,7137744480217848,!1,[[1,[2,"Frances"]],[3,1]]],[57,cr.plugins_.Sprite.prototype.acts.SetAnim,null,835062965762206,!1,[[1,[2,"Frances"]],[3,1]]]]],[0,null,!1,null,5346679472493111,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,482121869096169,!1,[[11,"Sueco"],[8,0],[7,[0,1]]]]],[[120,cr.plugins_.Text.prototype.acts.SetText,null,6918189491888258,!1,[[7,[2,"Misslyckades"]]]],[122,cr.plugins_.Text.prototype.acts.SetText,null,5509589598538612,!1,[[7,[2,"Meny"]]]],[125,cr.plugins_.Text.prototype.acts.SetText,
null,0xf6b00d3491f00,!1,[[7,[2,"Peka p\u00e5 f\u00f6r att starta"]]]],[56,cr.plugins_.Sprite.prototype.acts.SetAnim,null,7245943687104164,!1,[[1,[2,"Sueco"]],[3,1]]],[57,cr.plugins_.Sprite.prototype.acts.SetAnim,null,8228803497549094,!1,[[1,[2,"Sueco"]],[3,1]]]]],[0,null,!1,null,9789756934838564,[[136,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,4746994127053349,!1,[[8,3],[0,[0,34]]]]],[[137,cr.plugins_.Sprite.prototype.acts.SetScale,null,5875608199767047,!1,[[0,[0,1]]]]]],[0,null,!1,
null,5570272815366307,[[136,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,7873484296994336,!1,[[8,3],[0,[0,30]]]]],[[137,cr.plugins_.Sprite.prototype.acts.SetScale,null,591638537713824,!1,[[0,[1,1.05]]]]]],[0,null,!1,null,0x394defe230d9c,[[136,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,0x8224dc27bcf0b,!1,[[8,3],[0,[0,25]]]]],[[137,cr.plugins_.Sprite.prototype.acts.SetScale,null,0xc790d6f04189d,!1,[[0,[1,1.1]]]]]],[0,null,!1,null,0xbe98ca580f8a2,[[136,cr.plugins_.Sprite.prototype.cnds.CompareY,
null,0,!1,!1,!1,0x93eb73b9f506e,!1,[[8,3],[0,[0,20]]]]],[[137,cr.plugins_.Sprite.prototype.acts.SetScale,null,0xca8d55ad45e33,!1,[[0,[1,1.15]]]]]],[0,null,!1,null,7602769262839386,[[136,cr.plugins_.Sprite.prototype.cnds.CompareY,null,0,!1,!1,!1,0x9e778a3078a3b,!1,[[8,3],[0,[0,16]]]]],[[137,cr.plugins_.Sprite.prototype.acts.SetScale,null,0x4bcac181cee2d,!1,[[0,[1,1.2]]]]]],[0,null,!1,null,0xfbacc7e40e1a9,[[133,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xf8514df94bc63,!1,[[4,136]]]],
[[-1,cr.system_object.prototype.acts.SetVar,null,5584745980974984,!1,[[11,"Apuntar"],[7,[0,1]]]],[55,cr.plugins_.Sprite.prototype.acts.SetAnim,null,9715507395979224,!1,[[1,[2,"Animation2"]],[3,1]]],[55,cr.plugins_.Sprite.prototype.acts.SetPos,null,5828599788634345,!1,[[0,[0,69]],[0,[0,185]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8561104282258412,!1,[[11,"3Balones"],[7,[0,1]]]],[136,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x58989137b9dd5,!1],[137,cr.plugins_.Sprite.prototype.acts.Destroy,
null,5781703656304396,!1],[133,cr.plugins_.Sprite.prototype.acts.SetAnim,null,6462132683433883,!1,[[1,[2,"Default"]],[3,1]]]]],[0,null,!1,null,5072239562299025,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9920254319711400,!1,[[11,"3Balones"],[8,0],[7,[0,1]]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xb9c9091211e58,!1,[[11,"Apuntar"],[8,0],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.SetVar,null,5135566764939765,!1,[[11,"3Balones"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,
null,6954872730041897,!1,[[0,[1,1.1]]]],[133,cr.plugins_.Sprite.prototype.acts.SetAnim,null,0xeb8e256bf1cd,!1,[[1,[2,"3Balones"]],[3,1]]]]]]],["Event Menu",[[1,"Sueco",0,0,!1,!1,9146630833488548,!1],[1,"Frances",0,0,!1,!1,0x926b36735226d,!1],[1,"Ingles",0,0,!1,!1,0xc85a0f1732e68,!1],[1,"Empezar",0,0,!1,!1,0x48233796d5e32,!1],[1,"Banner",0,0,!1,!1,310862771843542,!1],[1,"Dialogo",0,0,!1,!1,0x9887f7cdbcfcc,!1],[1,"HighScore",0,0,!1,!1,5771209751289045,!1],[1,"Portugal",0,1,!1,!1,6758640363241856,!1],
[1,"Mexico",0,1,!1,!1,0x7d0754e2344b4,!1],[1,"Italia",0,1,!1,!1,6322491804313885,!1],[1,"Inglaterra",0,1,!1,!1,7527420317155079,!1],[1,"Espa\u00f1a",0,1,!1,!1,8397386723911868,!1],[1,"Argentina",0,1,!1,!1,7402718939690627,!1],[1,"Alemania",0,1,!1,!1,0x467fd0deb222e,!1],[0,null,!1,null,0x683c1dcaac06a,[[13,cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,null,0,!1,!0,!1,7020043410442457,!1,[[1,[2,"Mexico"]]]]],[[13,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,4883666908656668,!1,[[1,
[2,"Argentina"]],[7,[23,"Argentina"]]]],[13,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,8693118907600928,!1,[[1,[2,"Portugal"]],[7,[23,"Portugal"]]]],[13,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,7995021895058841,!1,[[1,[2,"Alemania"]],[7,[23,"Alemania"]]]],[13,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,0x884b6d114e25e,!1,[[1,[2,"Italia"]],[7,[23,"Italia"]]]],[13,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,5631164156539463,!1,[[1,[2,"Mexico"]],[7,[23,"Mexico"]]]],
[13,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,8397832664711572,!1,[[1,[2,"Inglaterra"]],[7,[23,"Inglaterra"]]]],[13,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,7463157371297454,!1,[[1,[2,"Espa\u00f1a"]],[7,[23,"Espa\u00f1a"]]]],[13,cr.plugins_.WebStorage.prototype.acts.StoreLocal,null,6331715616886042,!1,[[1,[2,"Selecciones"]],[7,[23,"HighScore"]]]]]],[0,null,!1,null,693152388851834,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,4604471804498694,!1,[[11,"Empezar"],
[8,0],[7,[0,0]]]]],[[-1,cr.system_object.prototype.acts.CreateObject,null,6302399907858978,!1,[[4,8],[5,[0,1]],[0,[0,320]],[0,[0,180]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0xc05ad6bf8cfef,!1,[[4,128],[5,[0,1]],[0,[0,320]],[0,[0,72]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,0xf0f9cca215e13,!1,[[4,126],[5,[0,1]],[0,[0,320]],[0,[0,144]]]],[-1,cr.system_object.prototype.acts.CreateObject,null,9970664740137556,!1,[[4,127],[5,[0,1]],[0,[0,320]],[0,[0,216]]]],[-1,cr.system_object.prototype.acts.CreateObject,
null,0x3a7601b769935,!1,[[4,129],[5,[0,1]],[0,[0,320]],[0,[0,288]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xdf8a61dbd811b,!1,[[11,"Empezar"],[7,[0,1]]]]]],[0,null,!1,null,5150264960725601,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7186940488787198,!1,[[4,77]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,288748892532052,!1,[[11,"Alemania"],[8,0],[7,[0,2]]]]],[[-1,cr.system_object.prototype.acts.Wait,null,6778327607986176,!1,[[0,[1,1]]]],[-1,cr.system_object.prototype.acts.GoToLayoutByName,
null,7502572981930023,!1,[[1,[2,"Alemania"]]]],[10,cr.plugins_.Audio.prototype.acts.Stop,null,0xdbe852cadf300,!1,[[1,[2,"Menu"]]]]]],[0,null,!1,null,4720871422235809,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,411278792874091,!1,[[4,76]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xb1e99ce6d2a2d,!1,[[11,"Argentina"],[8,0],[7,[0,2]]]]],[[-1,cr.system_object.prototype.acts.Wait,null,9479863183745176,!1,[[0,[1,1]]]],[-1,cr.system_object.prototype.acts.GoToLayoutByName,
null,9780376838092666,!1,[[1,[2,"Argentina"]]]],[10,cr.plugins_.Audio.prototype.acts.Stop,null,84688664756048,!1,[[1,[2,"Menu"]]]]]],[0,null,!1,null,0xbc93e95a1556c,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7403608119564079,!1,[[4,71]]]],[[-1,cr.system_object.prototype.acts.Wait,null,6132987834642905,!1,[[0,[1,1]]]],[-1,cr.system_object.prototype.acts.GoToLayoutByName,null,0xe917a3b13d5de,!1,[[1,[2,"Brasil"]]]],[10,cr.plugins_.Audio.prototype.acts.Stop,null,0xb53e5f6b6fe3d,
!1,[[1,[2,"Menu"]]]]]],[0,null,!1,null,360949054195381,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,8166374389931765,!1,[[4,74]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,610798106177852,!1,[[11,"Espa\u00f1a"],[8,0],[7,[0,2]]]]],[[-1,cr.system_object.prototype.acts.Wait,null,7657326232295627,!1,[[0,[1,1]]]],[-1,cr.system_object.prototype.acts.GoToLayoutByName,null,5902273911093482,!1,[[1,[2,"Espanha"]]]],[10,cr.plugins_.Audio.prototype.acts.Stop,null,0x7f287feaa67f6,
!1,[[1,[2,"Menu"]]]]]],[0,null,!1,null,5431045227963498,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x7ab2a5d2d0af4,!1,[[4,73]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xfba2fbd32be87,!1,[[11,"Inglaterra"],[8,0],[7,[0,2]]]]],[[-1,cr.system_object.prototype.acts.Wait,null,7360228436167136,!1,[[0,[1,1]]]],[-1,cr.system_object.prototype.acts.GoToLayoutByName,null,0x3bea6dd70155e,!1,[[1,[2,"Inglaterra"]]]],[10,cr.plugins_.Audio.prototype.acts.Stop,null,
0x4fff6129de455,!1,[[1,[2,"Menu"]]]]]],[0,null,!1,null,0xc2c3610c135c2,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6534532276731203,!1,[[4,75]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9783458933518892,!1,[[11,"Italia"],[8,0],[7,[0,2]]]]],[[-1,cr.system_object.prototype.acts.Wait,null,9818530077356024,!1,[[0,[1,1]]]],[-1,cr.system_object.prototype.acts.GoToLayoutByName,null,6768579409923275,!1,[[1,[2,"Italia"]]]],[10,cr.plugins_.Audio.prototype.acts.Stop,
null,9010612019425652,!1,[[1,[2,"Menu"]]]]]],[0,null,!1,null,0xe0920b2522e0c,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,5274478651383574,!1,[[4,72]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7269517939644087,!1,[[11,"Mexico"],[8,0],[7,[0,2]]]]],[[-1,cr.system_object.prototype.acts.Wait,null,4571194131140783,!1,[[0,[1,1]]]],[-1,cr.system_object.prototype.acts.GoToLayoutByName,null,0xb04030c9e44ca,!1,[[1,[2,"Mexico"]]]],[10,cr.plugins_.Audio.prototype.acts.Stop,
null,0x7f1737aba063c,!1,[[1,[2,"Menu"]]]]]],[0,null,!1,null,6570972317834442,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xffe6349075a62,!1,[[4,78]]],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9713294770177528,!1,[[11,"Portugal"],[8,0],[7,[0,2]]]]],[[-1,cr.system_object.prototype.acts.Wait,null,8529051753982605,!1,[[0,[1,1]]]],[-1,cr.system_object.prototype.acts.GoToLayoutByName,null,5447271672436705,!1,[[1,[2,"Portugal"]]]],[10,cr.plugins_.Audio.prototype.acts.Stop,
null,6266037044600018,!1,[[1,[2,"Menu"]]]]]],[0,null,!1,null,0x98d3059098f7d,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xdc47272037655,!1,[[11,"Alemania"],[8,0],[7,[0,2]]]]],[[77,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x5704ae2f8ff3b,!1,[[3,0]]]]],[0,null,!1,null,0x9d563b2084043,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xabffb4d1561d7,!1,[[11,"Argentina"],[8,0],[7,[0,2]]]]],[[76,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x8f9591eea283b,
!1,[[3,0]]]]],[0,null,!1,null,0x605db6fd568c3,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,941997726954217,!1,[[11,"Espa\u00f1a"],[8,0],[7,[0,2]]]]],[[74,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0x8bc6f017f3fed,!1,[[3,0]]]]],[0,null,!1,null,8983995392507788,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,8588133589872419,!1,[[11,"Inglaterra"],[8,0],[7,[0,2]]]]],[[73,cr.plugins_.Sprite.prototype.acts.SetVisible,null,7984112198657617,!1,[[3,0]]]]],[0,null,
!1,null,5270823419665751,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x6aea847d13164,!1,[[11,"Italia"],[8,0],[7,[0,2]]]]],[[75,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0xe9e6369ad276e,!1,[[3,0]]]]],[0,null,!1,null,8916327844870689,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9882048339478306,!1,[[11,"Mexico"],[8,0],[7,[0,2]]]]],[[72,cr.plugins_.Sprite.prototype.acts.SetVisible,null,0xd5663f44edb45,!1,[[3,0]]]]],[0,null,!1,null,5512834636309446,[[-1,
cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6761656845423685,!1,[[11,"Portugal"],[8,0],[7,[0,2]]]]],[[78,cr.plugins_.Sprite.prototype.acts.SetVisible,null,4532415046221457,!1,[[3,0]]]]],[0,null,!1,null,5183962892077188,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,8860945804944883,!1]],[[133,cr.plugins_.Sprite.prototype.acts.Destroy,null,8884901122984615,!1],[14,cr.plugins_.CJSAds.prototype.acts.ShowBanner,null,7610253630601947,!1,[[3,1]]],[10,cr.plugins_.Audio.prototype.acts.Play,
null,7031983949538228,!1,[[2,["menu",!0]],[3,1],[0,[0,0]],[1,[2,"Menu"]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,9112015544971642,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.Wait,null,8771563574258206,!1,[[0,[1,0.1]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9027327238441608,!1,[[11,"Alemania"],[7,[20,13,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"Alemania"]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,8040238582675431,!1,[[11,"Argentina"],
[7,[20,13,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"Argentina"]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,7680289014881338,!1,[[11,"Espa\u00f1a"],[7,[20,13,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"Espa\u00f1a"]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,6236422474909449,!1,[[11,"Italia"],[7,[20,13,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"Italia"]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,6332770735225248,
!1,[[11,"Inglaterra"],[7,[20,13,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"Inglaterra"]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,6645339165800384,!1,[[11,"Mexico"],[7,[20,13,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"Mexico"]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xf4cfaa662e84c,!1,[[11,"Portugal"],[7,[20,13,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"Portugal"]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,
0x674573ae64fe3,!1,[[11,"HighScore"],[7,[20,13,cr.plugins_.WebStorage.prototype.exps.LocalValue,!0,null,[[2,"Selecciones"]]]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5035386616655556,!1,[[11,"Alineacion"],[7,[0,0]]]]]],[0,null,!1,null,0x803b06776a332,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,8135453931367169,!1],[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xbf94b109851eb,!1,[[11,"Empezar"],[8,0],[7,[0,1]]]]],[[145,cr.plugins_.Sprite.prototype.acts.SetPos,
null,0xff8a6b794e374,!1,[[0,[0,370]],[0,[0,138]]]]]],[0,null,!1,null,5780529789139132,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7272799711707654,!1,[[11,"Banner"],[8,0],[7,[0,0]]]],[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,0x8050af7c77fe4,!1,[[0,[1,0.2]]]]],[[14,cr.plugins_.CJSAds.prototype.acts.HideBanner,null,7561609253290543,!1]]],[0,null,!1,null,6307793525041313,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xc74a7f583d86f,!1,[[4,121]]]],
[[-1,cr.system_object.prototype.acts.Wait,null,8386739370351281,!1,[[0,[1,1]]]],[-1,cr.system_object.prototype.acts.GoToLayout,null,6479838782496107,!1,[[6,"Instrucciones"]]],[10,cr.plugins_.Audio.prototype.acts.Stop,null,4630324927448368,!1,[[1,[2,"Menu"]]]]]],[0,[!0,"Idiomas"],!1,null,6411336700973351,[[-1,cr.system_object.prototype.cnds.IsGroupActive,null,0,!1,!1,!1,6411336700973351,!1,[[1,[2,"Idiomas"]]]]],[],[[0,null,!1,null,0xa4aec2e0a13e2,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,
null,1,!1,!1,!1,8081321936834294,!1,[[4,128]]]],[[8,cr.plugins_.Sprite.prototype.acts.Destroy,null,819492301609985,!1],[126,cr.plugins_.Text.prototype.acts.Destroy,null,5793073555086328,!1],[127,cr.plugins_.Text.prototype.acts.Destroy,null,9176482765810662,!1],[129,cr.plugins_.Text.prototype.acts.Destroy,null,9346038831494724,!1],[128,cr.plugins_.Text.prototype.acts.Destroy,null,0xe05d278be1c05,!1],[-1,cr.system_object.prototype.acts.Wait,null,4843290300370177,!1,[[0,[0,1]]]],[145,cr.plugins_.Sprite.prototype.acts.SetPos,
null,0x80874da6f8576,!1,[[0,[0,370]],[0,[0,138]]]]]],[0,null,!1,null,5658611681162514,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x8c09a046b45d1,!1,[[4,126]]]],[[8,cr.plugins_.Sprite.prototype.acts.Destroy,null,7627003215072164,!1],[126,cr.plugins_.Text.prototype.acts.Destroy,null,936214885328831,!1],[127,cr.plugins_.Text.prototype.acts.Destroy,null,0x60f1a7799979,!1],[129,cr.plugins_.Text.prototype.acts.Destroy,null,0x3aa08b2b59688,!1],[128,cr.plugins_.Text.prototype.acts.Destroy,
null,6365966861038554,!1],[-1,cr.system_object.prototype.acts.SetVar,null,0x660d1b710fb1,!1,[[11,"Ingles"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.Wait,null,9869756283240748,!1,[[0,[0,1]]]],[145,cr.plugins_.Sprite.prototype.acts.SetPos,null,9148410162247280,!1,[[0,[0,370]],[0,[0,138]]]]]],[0,null,!1,null,0xc190026d7473,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x4f486a9b6744d,!1,[[4,127]]]],[[8,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x529b84e57c7dd,!1],[126,
cr.plugins_.Text.prototype.acts.Destroy,null,7426084379072455,!1],[127,cr.plugins_.Text.prototype.acts.Destroy,null,9630453265892796,!1],[129,cr.plugins_.Text.prototype.acts.Destroy,null,9381567044308196,!1],[128,cr.plugins_.Text.prototype.acts.Destroy,null,0x93572137bb6d,!1],[-1,cr.system_object.prototype.acts.SetVar,null,0x651a17c8625b0,!1,[[11,"Frances"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x8a61970278d99,!1,[[0,[0,1]]]],[145,cr.plugins_.Sprite.prototype.acts.SetPos,null,
9700794936747632,!1,[[0,[0,370]],[0,[0,138]]]]]],[0,null,!1,null,0xa76f8e3488109,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,5346676793311093,!1,[[4,129]]]],[[8,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x427ed56e98d72,!1],[126,cr.plugins_.Text.prototype.acts.Destroy,null,0x6db5ba7a1b619,!1],[127,cr.plugins_.Text.prototype.acts.Destroy,null,9594005545743808,!1],[129,cr.plugins_.Text.prototype.acts.Destroy,null,7737695641369354,!1],[128,cr.plugins_.Text.prototype.acts.Destroy,
null,0x7ba6477c92371,!1],[-1,cr.system_object.prototype.acts.SetVar,null,0xdbb4dd33f0987,!1,[[11,"Sueco"],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.Wait,null,8324375080535101,!1,[[0,[0,1]]]],[145,cr.plugins_.Sprite.prototype.acts.SetPos,null,0x5c1cc49824050,!1,[[0,[0,370]],[0,[0,138]]]]]]]],[0,null,!1,null,5664381235731074,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6876018362134459,!1,[[11,"Ingles"],[8,0],[7,[0,1]]]]],[[121,cr.plugins_.Text.prototype.acts.SetText,null,0x887fbe6c9aeac,
!1,[[7,[2,"Instructions"]]]],[124,cr.plugins_.Text.prototype.acts.SetText,null,0xb8c3e179d619e,!1,[[7,[2,"You are invited to have fun with this game"]]]]]],[0,null,!1,null,8983133590277743,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9067818215229616,!1,[[11,"Frances"],[8,0],[7,[0,1]]]]],[[121,cr.plugins_.Text.prototype.acts.SetText,null,0x5117dbb932786,!1,[[7,[2,"Lesson"]]]],[124,cr.plugins_.Text.prototype.acts.SetText,null,0xa862526d73221,!1,[[7,[2,"Vous \u00eates invit\u00e9s \u00e0 avoir du plaisir avec ce jeu"]]]]]],
[0,null,!1,null,5245739653564089,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5258876220723071,!1,[[11,"Sueco"],[8,0],[7,[0,1]]]]],[[121,cr.plugins_.Text.prototype.acts.SetText,null,8815339295596561,!1,[[7,[2,"instruktioner"]]]],[124,cr.plugins_.Text.prototype.acts.SetText,null,0xc1e4f666a8d42,!1,[[7,[2,"Du \u00e4r inbjuden att ha kul med detta spel"]]]]]],[0,null,!1,null,6613203503608542,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x3b76d985d3ba0,!1,[[4,
145]]]],[[11,cr.plugins_.Browser.prototype.acts.GoToURLWindow,null,9458107467273604,!1,[[1,[2,"https://play.google.com/store/apps/details?id=com.maniacbirds.app"]],[1,[2,"NewWindow"]]]]]],[0,null,!1,null,0xbc355772bfeb4,[[-1,cr.system_object.prototype.cnds.Every,null,0,!1,!1,!1,7539390832244231,!1,[[0,[0,3]]]]],[[145,cr.plugins_.Sprite.prototype.acts.SetAngle,null,4909841997106976,!1,[[0,[0,355]]]],[-1,cr.system_object.prototype.acts.Wait,null,6032845626659285,!1,[[0,[1,0.1]]]],[145,cr.plugins_.Sprite.prototype.acts.SetAngle,
null,0xff37f0b9d83eb,!1,[[0,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x58043eabcd48d,!1,[[0,[1,0.1]]]],[145,cr.plugins_.Sprite.prototype.acts.SetAngle,null,0x95d1dfb1e381f,!1,[[0,[0,5]]]],[-1,cr.system_object.prototype.acts.Wait,null,9917845708581116,!1,[[0,[1,0.1]]]],[145,cr.plugins_.Sprite.prototype.acts.SetAngle,null,0xb728fab0a9f2e,!1,[[0,[0,0]]]]]]]],["Event Instrucciones",[[0,null,!1,null,0x4e5a7e5774a67,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,9815254757545172,
!1]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,0x4a54e0118be51,!1,[[0,[1,1]]]],[133,cr.behaviors.Physics.prototype.acts.SetIterations,"Physics",0xf179f5568861b,!1,[[0,[0,12]],[0,[0,8]]]],[20,cr.plugins_.Sprite.prototype.acts.StopAnim,null,9835429653014368,!1],[20,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",0xc3efe675f3e4,!1,[[3,0]]]]],[0,null,!1,null,8103182779856647,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xab38a7c0f891e,!1,[[11,"Apuntar"],[8,0],[7,
[0,1]]]]],[[133,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0xab920e6cd6293,!1,[[4,1],[7,[0,0]]]]],[[0,null,!1,null,0x6317729c548cc,[[12,cr.plugins_.Touch.prototype.cnds.IsInTouch,null,0,!1,!1,!1,5504600216618498,!1]],[[133,cr.plugins_.Sprite.prototype.acts.SetAngle,null,322338305690922,!1,[[0,[19,cr.system_object.prototype.exps.angle,[[20,12,cr.plugins_.Touch.prototype.exps.X,!1,null],[20,12,cr.plugins_.Touch.prototype.exps.Y,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.X,!1,null],
[20,1,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]]]],[133,cr.plugins_.Sprite.prototype.acts.MoveAtAngle,null,339898458458572,!1,[[0,[4,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null],[0,180]]],[0,[19,cr.system_object.prototype.exps.min,[[7,[19,cr.system_object.prototype.exps.distance,[[20,12,cr.plugins_.Touch.prototype.exps.X,!1,null],[20,12,cr.plugins_.Touch.prototype.exps.Y,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]],
[0,3]],[0,45]]]]]],[-1,cr.system_object.prototype.acts.ScrollToObject,null,5108469823100685,!1,[[4,1]]],[1,cr.plugins_.Sprite.prototype.acts.SetVisible,null,5198725935843609,!1,[[3,1]]],[1,cr.plugins_.Sprite.prototype.acts.SetTowardPosition,null,9845683343332428,!1,[[0,[20,133,cr.plugins_.Sprite.prototype.exps.X,!1,null]],[0,[20,133,cr.plugins_.Sprite.prototype.exps.Y,!1,null]]]]]],[0,null,!1,null,0x832b617df3b95,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,6589900250949028,!1]],
[[1,cr.plugins_.Sprite.prototype.acts.SetVisible,null,7278578556317031,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xc23fba01584cb,!1,[[11,"Apuntar"],[7,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xf2b7ad492ce43,!1,[[11,"Tiro"],[7,[7,[19,cr.system_object.prototype.exps.distance,[[20,133,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,133,cr.plugins_.Sprite.prototype.exps.Y,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.X,!1,null],[20,1,cr.plugins_.Sprite.prototype.exps.Y,
!1,null]]],[0,15]]]]],[133,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0xca871953a7702,!1,[[4,1],[7,[0,0]]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",0x98ff25dc99477,!1,[[3,1]]],[55,cr.behaviors.Bullet.prototype.acts.SetEnabled,"Bullet",6519167032892183,!1,[[3,1]]],[55,cr.plugins_.Sprite.prototype.acts.SetAnim,null,8257760960948611,!1,[[1,[2,"Default"]],[3,1]]],[-1,cr.system_object.prototype.acts.Wait,null,8038121409660313,!1,[[0,[0,1]]]],[133,cr.plugins_.Sprite.prototype.acts.SetAnim,
null,8777501212396981,!1,[[1,[2,"Tiro"]],[3,1]]],[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",8526375782309672,!1,[[3,0]]],[133,cr.behaviors.Physics.prototype.acts.ApplyImpulseAtAngle,"Physics",7630590371139072,!1,[[0,[23,"Tiro"]],[0,[20,133,cr.plugins_.Sprite.prototype.exps.Angle,!1,null]],[7,[0,0]]]]]]]],[0,null,!1,null,612382454432469,[[55,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xf9e0e79a85475,!1,[[4,71]]]],[[55,cr.behaviors.Bullet.prototype.acts.SetEnabled,
"Bullet",4821112837769944,!1,[[3,0]]]]],[0,null,!1,null,0x6bc65ce556946,[[133,cr.plugins_.Sprite.prototype.cnds.OnDestroyed,null,1,!1,!1,!1,0x8fea389869b53,!1],[55,cr.plugins_.Sprite.prototype.cnds.IsOnScreen,null,0,!1,!1,!1,0x5d67803b7d06b,!1]],[[-1,cr.system_object.prototype.acts.CreateObject,null,8497827040587164,!1,[[4,133],[5,[0,1]],[0,[0,0]],[0,[0,0]]]],[55,cr.plugins_.Sprite.prototype.acts.Destroy,null,9489871028916324,!1],[-1,cr.system_object.prototype.acts.CreateObject,null,9164342970711716,
!1,[[4,55],[5,[0,0]],[0,[0,69]],[0,[0,185]]]]]],[0,null,!1,null,9149597128145672,[[133,cr.plugins_.Sprite.prototype.cnds.OnCreated,null,1,!1,!1,!1,715792673022603,!1]],[[-1,cr.system_object.prototype.acts.SetVar,null,5803756098502519,!1,[[11,"Apuntar"],[7,[0,1]]]]]],[0,null,!1,null,0x9a85bcf513e95,[[133,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,4550220400398997,!1,[[4,0]]]],[[133,cr.behaviors.Physics.prototype.acts.SetImmovable,"Physics",9742930512653556,!1,[[3,1]]],[133,cr.behaviors.Rotate.prototype.acts.SetSpeed,
"Rotate",0x89d4f9b725b91,!1,[[0,[0,720]]]],[-1,cr.system_object.prototype.acts.Wait,null,6604866249462916,!1,[[0,[1,1]]]],[133,cr.plugins_.Sprite.prototype.acts.Destroy,null,4641111665697969,!1]]],[0,null,!1,null,8016198953493708,[[133,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,694330764377413,!1,[[4,147]]]],[[147,cr.plugins_.Sprite.prototype.acts.SetAngle,null,9622064810816582,!1,[[0,[0,90]]]],[147,cr.plugins_.Sprite.prototype.acts.SetCollisions,null,0x69d0e6ea44bb2,!1,[[3,0]]],
[-1,cr.system_object.prototype.acts.Wait,null,5479302992554822,!1,[[0,[1,0.2]]]],[147,cr.plugins_.Sprite.prototype.acts.Destroy,null,9981519917454684,!1]]],[0,null,!1,null,8893305330357858,[[12,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,8866783115476477,!1,[[4,122]]]],[[147,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x53cb90099b3f5,!1],[55,cr.plugins_.Sprite.prototype.acts.Destroy,null,830782509570198,!1],[-1,cr.system_object.prototype.acts.GoToLayout,null,6282187519079478,
!1,[[6,"Menu"]]]]],[0,null,!1,null,8972982298164336,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,488317375984709,!1,[[11,"Ingles"],[8,0],[7,[0,1]]]]],[[123,cr.plugins_.Text.prototype.acts.SetText,null,0x8fb1ba1348db9,!1,[[7,[2,"The object is to give shots to the face to finish you off players without the ball (at this level are infinite), to do this touches the ball, slide your finger back, aim and release to make a shot. "]]]],[122,cr.plugins_.Text.prototype.acts.SetText,null,
5350244579121157,!1,[[7,[2,"Main"]]]]]],[0,null,!1,null,0xb0e9b314cbc47,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7256254580698275,!1,[[11,"Frances"],[8,0],[7,[0,1]]]]],[[123,cr.plugins_.Text.prototype.acts.SetText,null,420174502958755,!1,[[7,[2,"l'objectif est de donner des coups sur le visage pour vous finissez joueurs sans le ballon (\u00e0 ce niveau sont infinies), car il touche la balle, faites glisser votre doigt en arri\u00e8re, viser et rel\u00e2cher pour faire un coup. "]]]],
[122,cr.plugins_.Text.prototype.acts.SetText,null,0x63bd17bdd34ea,!1,[[7,[2,"Principal"]]]]]],[0,null,!1,null,4893047362400029,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,6864474595026973,!1,[[11,"Sueco"],[8,0],[7,[0,1]]]]],[[123,cr.plugins_.Text.prototype.acts.SetText,null,440026900053902,!1,[[7,[2,"Syftet \u00e4r att ge skott i ansiktet f\u00f6r att avsluta du spelare utan boll (p\u00e5 denna niv\u00e5 \u00e4r o\u00e4ndliga), f\u00f6r den vidr\u00f6r bollen, dra fingret tillbaka, sikta och sl\u00e4pp f\u00f6r att g\u00f6ra ett skott. "]]]],
[122,cr.plugins_.Text.prototype.acts.SetText,null,0xcee3a2f68eca4,!1,[[7,[2,"Meny"]]]]]]]]],"",!1,640,360,5,!1,!0,!1,"1.3",!0,!0,0,2,251,!1,!0,[]]};

createCocoonJSRuntime();

})();
